-- #########################################################
-- #########################################################
-- ConfigEnv.sql
-- #########################################################
-- #########################################################

SPOOL spool.txt
WHENEVER SQLERROR EXIT FAILURE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

-- #########################################################
-- #########################################################
-- VersionCheck.sql
-- #########################################################
-- #########################################################

declare
  Major$ NUMBER(10);
  Minor$ NUMBER(10);
begin
  select max(Major) into Major$ from DatabaseVersion;
  select max(Minor) into Minor$ from DatabaseVersion where Major = Major$;
  if (Major$ <> 1220) or (Minor$ <> 00) then
    raise_application_error(-20000, '  [' || TO_CHAR(Major$) || '.' || TO_CHAR(Minor$, 'FM00') || ']    [1220.00]');
  end if;
end;
/

-- #########################################################
-- #########################################################
-- Delete_From_StoredAttrCpt_213.sql
-- #########################################################
-- #########################################################

/*       02.13,
          DFU 13.00,    
*/
Delete from StoredAttributesCaption where docref=213
/
commit work 
/

-- #########################################################
-- #########################################################
-- alter_TR_TRANSFERTCLS_BI.sql
-- #########################################################
-- #########################################################

/*   TR_TRANSFERTCLS_BI -  ID,     */
-- ALTER TRIGGER TR_TRANSFERTCLS_BI
CREATE OR REPLACE TRIGGER TR_TRANSFERTCLS_II
  INSTEAD OF INSERT
  ON TRANSFERTCLS
  FOR EACH ROW
DECLARE
  new$ID TRANSFERTCLS.ID%TYPE := :NEW.ID;
  new$REGIONCLS TRANSFERTCLS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$CREATERUSER TRANSFERTCLS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TRANSFERTCLS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER TRANSFERTCLS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE TRANSFERTCLS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$CODE TRANSFERTCLS.CODE%TYPE := :NEW.CODE;
  new$RECEIVEKVSR TRANSFERTCLS.RECEIVEKVSR%TYPE := :NEW.RECEIVEKVSR;
  new$RECEIVEKFSR TRANSFERTCLS.RECEIVEKFSR%TYPE := :NEW.RECEIVEKFSR;
  new$RECEIVEKVR TRANSFERTCLS.RECEIVEKVR%TYPE := :NEW.RECEIVEKVR;
  new$RECEIVEKESR TRANSFERTCLS.RECEIVEKESR%TYPE := :NEW.RECEIVEKESR;
  new$RECEIVEKD TRANSFERTCLS.RECEIVEKD%TYPE := :NEW.RECEIVEKD;
  new$TRANSFERKVSR TRANSFERTCLS.TRANSFERKVSR%TYPE := :NEW.TRANSFERKVSR;
  new$TRANSFERKFSR TRANSFERTCLS.TRANSFERKFSR%TYPE := :NEW.TRANSFERKFSR;
  new$TRANSFERKCSR TRANSFERTCLS.TRANSFERKCSR%TYPE := :NEW.TRANSFERKCSR;
  new$TRANSFERKVR TRANSFERTCLS.TRANSFERKVR%TYPE := :NEW.TRANSFERKVR;
  new$TRANSFERKESR TRANSFERTCLS.TRANSFERKESR%TYPE := :NEW.TRANSFERKESR;
  new$TRANSFERKDVALUE TRANSFERTCLS.TRANSFERKDVALUE%TYPE := :NEW.TRANSFERKDVALUE;
  new$TARGETMEANSSIGN TRANSFERTCLS.TARGETMEANSSIGN%TYPE := :NEW.TARGETMEANSSIGN;
  new$TARGETCLS TRANSFERTCLS.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STARTDATE TRANSFERTCLS.STARTDATE%TYPE := :NEW.STARTDATE;
  new$DELETEDATE TRANSFERTCLS.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NOTE TRANSFERTCLS.NOTE%TYPE := :NEW.NOTE;
  new$NAME TRANSFERTCLS.NAME%TYPE := :NEW.NAME;
  new$BUDGETREF TRANSFERTCLS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$RECEIVEKCSR TRANSFERTCLS.RECEIVEKCSR%TYPE := :NEW.RECEIVEKCSR;
  new$SOURCELEVEL TRANSFERTCLS.SOURCELEVEL%TYPE := :NEW.SOURCELEVEL;
  new$DESTLEVEL TRANSFERTCLS.DESTLEVEL%TYPE := :NEW.DESTLEVEL;
  new$TRANSFERTKIND TRANSFERTCLS.TRANSFERTKIND%TYPE := :NEW.TRANSFERTKIND;
  new$GRANTKIND TRANSFERTCLS.GRANTKIND%TYPE := :NEW.GRANTKIND;
  new$TRANSFERTYEAR TRANSFERTCLS.TRANSFERTYEAR%TYPE := :NEW.TRANSFERTYEAR;
  new$EXTID TRANSFERTCLS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER TRANSFERTCLS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE TRANSFERTCLS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$FACT TRANSFERTCLS.FACT%TYPE := :NEW.FACT;
  new$EXTROOTID TRANSFERTCLS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION TRANSFERTCLS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE TRANSFERTCLS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
--
  CNT$1 NUMBER(10);
  CurrentDate1$ NUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TRANSFERTCLS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$ID from dual;
  END IF;
   
  if (new$BUDGETREF is null) then 
    new$BUDGETREF := 0;
  END IF;
  if (new$RECEIVEKVSR is null) then 
    new$RECEIVEKVSR := 0;
  END IF;
  if (new$RECEIVEKCSR is null) then 
    new$RECEIVEKCSR := 0;
  END IF;
  if (new$RECEIVEKFSR is null) then 
    new$RECEIVEKFSR := 0;
  END IF;
  if (new$RECEIVEKESR is null) then 
    new$RECEIVEKESR := 0;
  END IF;
  if (new$RECEIVEKD is null) then 
    new$RECEIVEKD := 0;
  END IF;
  if ((new$RECEIVEKVR is null) or (new$RECEIVEKVR  is null)) then 
    new$RECEIVEKVR := '000';
  END IF;
  if (new$TRANSFERKVSR is null) then 
    new$TRANSFERKVSR := 0;
  END IF;
  if (new$TRANSFERKCSR is null) then 
    new$TRANSFERKCSR := 0;
  END IF;
  if (new$TRANSFERKFSR is null) then 
    new$TRANSFERKFSR := 0;
  END IF;
  if (new$TRANSFERKVR is null) then 
    new$TRANSFERKVR := 0;
  END IF;
  if (new$TRANSFERKESR is null) then 
    new$TRANSFERKESR := 0;
  END IF;
  if ((new$TRANSFERKDVALUE is null) or (new$TRANSFERKDVALUE  is null)) then 
    new$TRANSFERKDVALUE := '00000000000000000000';
  END IF;
  if (new$TARGETMEANSSIGN is null) then 
    new$TARGETMEANSSIGN := 1;
  END IF;
  if (new$REGIONCLS is null) then 
    new$REGIONCLS := 0;
  END IF;
  if (new$FACT is null) then 
    new$FACT := 0;
  END IF;
  if (new$SourceLevel is null) then 
    new$SourceLevel := 0;
  END IF;
  if (new$GrantKind is null) then 
    new$GrantKind := 0;
  END IF;
  if (new$GrantKind = 2) then /*   "" */
    new$DestLevel := 1; /*    */
     
  else
    /*   ""  " "   */
    if ((new$GrantKind = 1) or (new$DestLevel is null)) then
      new$DestLevel := 0; /*   */
    END IF;
  END IF;
  if (new$TransfertKind is null) then 
    new$TransfertKind  := 0; 
  END IF;
  if (new$TransfertYear is null) then
    CurDateToDouble(CurrentDate1$);
    new$TransfertYear := CurrentDate1$ / 10000;
     
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_TRANSFERTCLS_BI_200)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(*) INTO CNT$1
  from TransfertCls t where
  (        (t.ID <> new$ID) and
  (t.CODE=new$CODE) and
  (t.RECEIVEKVSR=new$RECEIVEKVSR) and
  (t.RECEIVEKFSR=new$RECEIVEKFSR) and
  (t.RECEIVEKCSR=new$RECEIVEKCSR) and
  (t.RECEIVEKVR=new$RECEIVEKVR) and
  (t.RECEIVEKESR=new$RECEIVEKESR) and
  (t.RECEIVEKD=new$RECEIVEKD) and
  (t.TRANSFERKVSR=new$TRANSFERKVSR) and
  (t.TRANSFERKFSR=new$TRANSFERKFSR) and
  (t.TRANSFERKCSR=new$TRANSFERKCSR) and
  (t.TRANSFERKVR=new$TRANSFERKVR) and
  (t.TRANSFERKESR=new$TRANSFERKESR) and
  (t.TRANSFERKDVALUE=new$TRANSFERKDVALUE) and
  (t.TARGETMEANSSIGN=new$TARGETMEANSSIGN) and
  (t.REGIONCLS=new$REGIONCLS) and
  (t.DESTLEVEL=new$DESTLEVEL) and
  (t.BUDGETREF=new$BUDGETREF) and
  ((t.EXTID is null and new$EXTID is null) or (t.EXTID = new$EXTID)) and
  (t.FACT=new$FACT)) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    RaiseException('EX_DUPLICATE_TRANSFERT');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TRANSFERTCLS_BI_500)
-- Create 24.09.2007
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TRANSFERTCLS (
    ID,
    REGIONCLS,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    CODE,
    RECEIVEKVSR,
    RECEIVEKFSR,
    RECEIVEKVR,
    RECEIVEKESR,
    RECEIVEKD,
    TRANSFERKVSR,
    TRANSFERKFSR,
    TRANSFERKCSR,
    TRANSFERKVR,
    TRANSFERKESR,
    TRANSFERKDVALUE,
    TARGETMEANSSIGN,
    TARGETCLS,
    STARTDATE,
    DELETEDATE,
    NOTE,
    NAME,
    BUDGETREF,
    RECEIVEKCSR,
    SOURCELEVEL,
    DESTLEVEL,
    TRANSFERTKIND,
    GRANTKIND,
    TRANSFERTYEAR,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    FACT,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE
  ) VALUES (
    new$ID,
    new$REGIONCLS,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$CODE,
    new$RECEIVEKVSR,
    new$RECEIVEKFSR,
    new$RECEIVEKVR,
    new$RECEIVEKESR,
    new$RECEIVEKD,
    new$TRANSFERKVSR,
    new$TRANSFERKFSR,
    new$TRANSFERKCSR,
    new$TRANSFERKVR,
    new$TRANSFERKESR,
    new$TRANSFERKDVALUE,
    new$TARGETMEANSSIGN,
    new$TARGETCLS,
    new$STARTDATE,
    new$DELETEDATE,
    new$NOTE,
    new$NAME,
    new$BUDGETREF,
    new$RECEIVEKCSR,
    new$SOURCELEVEL,
    new$DESTLEVEL,
    new$TRANSFERTKIND,
    new$GRANTKIND,
    new$TRANSFERTYEAR,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$FACT,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE);

-- - - - - - - - - - - - -
-- AI_500 (TR_TRANSFERTCLS_AI_500)
-- Create 04.10.2007
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 203) and (RecordId = new$ID);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_TR_WritExecCpt_BI_BU.sql
-- #########################################################
-- #########################################################

/*        555  556 */
-- ALTER TRIGGER tr_writexecutioncaption_bi
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONCAPTION_BI
  BEFORE INSERT
  ON WRITEXECUTIONCAPTION
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_WritExecutionCaption_bi)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.FacialAcc_Cls is null) then 
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.Progindex is null) then 
    :new.Progindex := 556;
  END IF;
  if (:new.WritType is null) then 
    :new.WritType := 0;
  END IF;
  if (:new.WritPeriod is null) then 
    :new.WritPeriod := 0;
  END IF;
  if ((:new.BudgetRef is null) or (:new.BudgetRef = 0)) then 
    GetIntConst(-1, 3,:new.BudgetRef);
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_WRITEXECUTIONCAPTION_BI_500)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER tr_writexecutioncaption_bu
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONCAPTION_BU
  BEFORE UPDATE
  ON WRITEXECUTIONCAPTION
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_WritExecutionCaption_bu)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.FacialAcc_Cls is null) then 
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.Progindex is null) then 
    :new.Progindex := 556;
  END IF;
  if (:new.WritType is null) then 
    :new.WritType := 0;
  END IF;
  if (:new.WritPeriod is null) then 
    :new.WritPeriod := 0;
  END IF;
  if ((:new.BudgetRef is null) or (:new.BudgetRef = 0)) then 
    GetIntConst(-1, 3,:new.BudgetRef);
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (WRITEXECUTIONCAPTION_BU200)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  --     
  IF (:old.DOCSTATEREF <> :new.DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (:new.ID, :old.DOCSTATEREF, :new.DOCSTATEREF);         
  end if; 

-- - - - - - - - - - - - -
-- BU_700 (TR_WRITEXECUTIONCAPTION_BU_700)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion + 1;
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Insert_into_RemoteDocument_556.sql
-- #########################################################
-- #########################################################

/*    *//*        555  556 */
CREATE OR REPLACE PROCEDURE ImportRemoteDoc(   ID_$               NUMBER,   NAME_$             VARCHAR2)
AS
  IDExists$ NUMBER(10);
BEGIN
  SELECT COUNT (ID)
  INTO IDExists$      FROM RemoteDocument
  WHERE (ID = ID_$)
  ;
  IF (IDExists$  = 0) THEN
    INSERT INTO RemoteDocument
    (ID, NAME)
    VALUES (ID_$, NAME_$);
  END IF;
END;
/
CALL ImportRemoteDoc(556, ' ')
/
Update remoteclientaccount set remotedocument=556 where remoteDocument=555
/
Update remoteinputright set remotedocument=556 where remoteDocument=555
/
Delete from remotedocument where id=555
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_LayerData_TargetCls.sql
-- #########################################################
-- #########################################################


/* <TRANS_COMMAND>
ALTER TABLE LAYERDATA
  ADD TARGETCLS VARCHAR2(20)
/  

CREATE INDEX IDX_LAYERDATA_TARGETCLS ON LAYERDATA (TARGETCLS)
/

COMMIT WORK
/
*/
-- <TRANS_IGNORE>
DECLARE 
  v_exists integer;
BEGIN
  SELECT count(*) 
    INTO v_exists
    FROM USER_TAB_COLUMNS 
    WHERE TABLE_NAME='LAYERDATA' AND COLUMN_NAME='TARGETCLS';
  IF (v_exists=0) THEN
    EXECUTE IMMEDIATE 'ALTER TABLE LAYERDATA
      ADD TARGETCLS VARCHAR2(20)';

    EXECUTE IMMEDIATE 'CREATE INDEX IDX_LAYERDATA_TARGETCLS ON LAYERDATA (TARGETCLS)';
    EXECUTE IMMEDIATE 'COMMIT WORK';
  END IF;
END;
/


-- #########################################################
-- #########################################################
-- Alter_Add_Advance_OOS_Contract.sql
-- #########################################################
-- #########################################################


/*    AdvancePriceValue (    ), AdvanceSumInPercents (   )  notificationNumber (-  )
   oos_contract */
alter table oos_contract
 add (AdvancePriceValue NUMBER(15,2) DEFAULT 0, AdvanceSumInPercents NUMBER(15,2) DEFAULT 0, notificationNumber VARCHAR2(20))
/

COMMIT WORK
/



-- #########################################################
-- #########################################################
-- CREATE _OOS_ATTACHMENTS.sql
-- #########################################################
-- #########################################################

/* *****************************************************************************//* **                                 Tables                                 ***//* *****************************************************************************/
CREATE TABLE OOS_ATTACHMENTS (
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  RECORDINDEX NUMBER(10),
    CHECK((RECORDINDEX<=2147483647)AND(RECORDINDEX>-2147483648)),
  PROGINDEX NUMBER(10),
    CHECK((PROGINDEX<=2147483647)AND(PROGINDEX>-2147483648)),
  DOCTYPE VARCHAR2(150),
  FILENAME VARCHAR2(1024),
  URL VARCHAR2(1024),
  DESCRIPTION VARCHAR2(1024),
  CREATERUSER VARCHAR2(30) NOT NULL,
  CREATEDATE DATE NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  UPDATEDATE DATE NOT NULL
)
/
/* *****************************************************************************//* **                              Primary Keys                              ***//* *****************************************************************************/
ALTER TABLE OOS_ATTACHMENTS ADD (
  constraint PK_OOS_ATTACHMENTS_ID PRIMARY KEY (ID)
)
/
/* *****************************************************************************//* **                              Foreign Keys                              ***//* *****************************************************************************/
ALTER TABLE OOS_ATTACHMENTS ADD (
  constraint FK_OOS_ATTACHMENTS_RI FOREIGN KEY (RECORDINDEX) REFERENCES OOS_CONTRACT (ID)
)
/
CREATE INDEX FK_OOS_ATTACHMENTS_RI ON OOS_ATTACHMENTS(RECORDINDEX)
/
-- CREATE TRIGGER OOS_A_P_BI0
CREATE OR REPLACE TRIGGER TR_OOS_ATTACHMENTS_BI
  BEFORE INSERT
  ON OOS_ATTACHMENTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (OOS_A_P_BI0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
-- CREATE TRIGGER TR_OOS_A_P_BI_500
CREATE OR REPLACE TRIGGER TR_OOS_ATTACHMENTS_BI
  BEFORE INSERT
  ON OOS_ATTACHMENTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (OOS_A_P_BI0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_OOS_A_P_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_OOS_A_P_BU_500
CREATE OR REPLACE TRIGGER TR_OOS_A_P_BU_500
  BEFORE UPDATE
  ON OOS_ATTACHMENTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_OOS_A_P_BU_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.UpdaterUser := user;
  :new.UpdateDate := SYSDATE;

END;
/
-- CREATE TRIGGER OOS_CONTRACT_BD0
CREATE OR REPLACE TRIGGER TR_OOS_CONTRACT_BD
  BEFORE DELETE
  ON OOS_CONTRACT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (OOS_CONTRACT_BD0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  delete from oos_contract_products where oos_contract_products.RECORDINDEX = :old.ID;
  delete from oos_contract_finances where oos_contract_finances.RECORDINDEX = :old.ID;
  delete from oos_contractprocedure where oos_contractprocedure.RegNum = :old.RegNum;
  delete from oos_attachments where oos_attachments.recordindex = :old.Id;

END;
/

/* *****************************************************************************/
/* **                               Privileges                               ***/
/* *****************************************************************************/


/* Privileges of users */
GRANT SELECT, INSERT, UPDATE, DELETE ON OOS_CONTRACTPROCEDURE TO BUDGET_USERS
/
commit work
/


-- #########################################################
-- #########################################################
-- ChangeBuhAccDomen.sql
-- #########################################################
-- #########################################################

/*    BuhAcc   BuhAccPlan  INTVALUE  NOTE50 */
ALTER TABLE BuhAccPlan ADD (
  TempBuhAcc VARCHAR2(50)
)
/
ALTER TRIGGER TR_BUHACCPLAN_BU_500 DISABLE
/
commit work 
/
/*      */
CREATE OR REPLACE procedure ConvertBuhAcc
AS
  StrBuhAcc$ VARCHAR2(50);
BEGIN
  FOR REC$1 IN (select ID AS ID, BuhAcc  AS BuhAcc from BuhAccPlan )
  LOOP
    FormatClsStr(REC$1.BuhAcc, 7,StrBuhAcc$);
    update BuhAccPlan set
    TempBuhAcc = StrBuhAcc$

    where
    Id = REC$1.id;
      
  END LOOP;
END;
/
commit work 
/
CALL ConvertBuhAcc() 
/
commit work 
/
drop procedure ConvertBuhAcc 
/
commit work 
/
ALTER TABLE BuhAccPlan DROP (BuhAcc)
/
commit work 
/
ALTER TABLE BuhAccPlan ADD (
  BuhAcc VARCHAR2(50)
)
/
update BuhAccPlan set
  BuhAcc = TempBuhAcc
/
ALTER TABLE BuhAccPlan DROP (TempBuhAcc)
/
ALTER TRIGGER TR_BUHACCPLAN_BU_500 ENABLE
/
commit work 
/
ALTER TABLE BuhAccPlan MODIFY(BuhAcc NOT NULL)
/

-- #########################################################
-- #########################################################
-- SetAgreementType_NotNull.sql
-- #########################################################
-- #########################################################


alter table tb_agreements modify (agreementtype NUMBER(10,0) not null)
/

commit work
/


-- #########################################################
-- #########################################################
-- fix_Check_Unique_Organizations.sql
-- #########################################################
-- #########################################################

/*   CHECK_UNIQUE_ORGANIZATION
  " -"    " -  ", 
          */
/*   -       */
CREATE OR REPLACE procedure CHECK_UNIQUE_ORGANIZATION(    ID$ NUMBER,    INN$ NUMBER,
        INN20$ VARCHAR2)
AS
  C$ NUMBER(10);
  CHECKKIND$ NUMBER(10);
  CHECKCLOSED$ NUMBER(10);
BEGIN
  GetIntConst(32, 15,CHECKKIND$);
  GetIntConst(32, 44,CHECKCLOSED$);
  if (CHECKKIND$ is null) then
    CHECKKIND$ := 0;
  END IF;
  if (CHECKCLOSED$ is null) then
    CHECKCLOSED$ := 0;
  END IF;
  /*     -   */
  if ((INN$  is null) and ((INN20$   is null) or (INN20$  is Null))) then 
    C$ := -1;
    /*  -      */
  else 
    if (CHECKKIND$ = 0) then 
      if ((INN20$   is null) or (INN20$  is Null)) then 
        C$ := -1;
              
      else 
        /*    */
        if(CHECKCLOSED$ = 0) then
          select count(id)            into C$ from Organizations where (INN = INN$) and (INN20=INN20$) and (DateClose is null)
          ;
        else
          /*     */
          if(CHECKCLOSED$ = 1) then
            select count(id)            into C$ from Organizations where (INN = INN$) and (INN20=INN20$)
            ;
          END IF;      
        END IF;    
      END IF;
    else 
      if (CHECKKIND$ = 1) then 
        /*      -*/
        if ((INN20$   is null) or (INN20$  is Null)) then 
          if (CHECKCLOSED$ = 0) then
            select count(id)             into C$ from Organizations where (INN = INN$) and ((INN20 is Null) or (INN20  is null)) and (DateClose is null)
            ;
          END IF;
          if (CHECKCLOSED$ = 1) then
            select count(id)             into C$ from Organizations where (INN = INN$) and ((INN20 is Null) or (INN20  is null))
            ;
                
          END IF;
        else 
          if (CHECKCLOSED$ = 0) then
            select count(id)             into C$ from Organizations where (INN = INN$) and (INN20=INN20$) and (DateClose is null)
            ;
          END IF;
          if (CHECKCLOSED$ = 1) then
            select count(id)             into C$ from Organizations where (INN = INN$) and (INN20=INN20$)
            ;
                
          END IF;    
        END IF;
      else 
        /*     */      
        C$ := -1;
            
      END IF;
    END IF;
  END IF;
  if (C$ >= 0) then 
    if (C$ > 0) then 
      RaiseException('ex_DublicateINN');
    END IF;

    /*    ,       ,
                ,  -    DateClose */
    insert into inn_kpp (id, inn, inn20)
    values (ID$, INN$, INN20$);
        
  END IF;
END;
/
commit work
/

-- #########################################################
-- #########################################################
-- ClsNames2000.sql
-- #########################################################
-- #########################################################

/*        2000
*/
ALTER TABLE KCSR MODIFY (Name VARCHAR2(2000))
/
commit work 
/
ALTER TABLE KesrSubCode MODIFY (Name VARCHAR2(2000))
/
commit work 
/

-- #########################################################
-- #########################################################
-- ALTER_TR_CORRECTIONDETAIL_BI.sql
-- #########################################################
-- #########################################################

/*   TR_CORRECTIONDETAIL_BI -       */
-- ALTER TRIGGER TR_CORRECTIONDETAIL_BI
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  BPInnerNum$ NUMBER(10);
  PromiseMode$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  ConstCheck$ NUMBER(10);
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  vOperationTypeS1$ NUMBER(10);
  vOperationTypeD1$ NUMBER(10);
  vOperationType1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KESR IS NULL) THEN 
    new$KESR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS1$, vOperationTypeD1$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType1$ := vOperationTypeS1$;
          
    ELSE 
      vOperationType1$ := vOperationTypeD1$;
    END IF;
    new$OperationType := vOperationType1$;
      
  END IF;
  BEGIN

    /*  ,    */
    select
    CorCap.BudgetRef
    into new$BudgetRef   from
    correctioncaption CorCap
    where
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls); 

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode$);
  getintconst(30, 35,ConstCheck$);
  /* ( )      ,    */
  if ((PromiseMode$ <> 1) and (ConstCheck$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /* ( )      ,    */
  /*         */
  if (PromiseMode$ = 1) then
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select
      max(InnerPromiseNum)
      into BPInnerNum$       from
      PaymentSchedule
      where
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$BudgetPromise := BPInnerNum$;

      else
        RaiseException('EX_BP_NotExist');
      END IF;
    END IF;
    /*    ,   ,   */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select
        ANumber
        into BPInnerNum$       from
        PaymentSchedule
        where
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;

      new$Promise := BPInnerNum$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_PayPromiseCls_NSI.sql
-- #########################################################
-- #########################################################

/*          PayPromiseCls */
ALTER TABLE Paypromisecls DROP CONSTRAINT Uk_Paypromisecls_Ver_Key DROP INDEX
/
ALTER TABLE Paypromisecls ADD (
  Extid VARCHAR2(50),/*        */
  Extrootid VARCHAR2(50),/*   */
  constraint Uk_Paypromisecls_Ver_Key unique (Code, Budgetref, Extid)
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- AddIndexInSignLog.sql
-- #########################################################
-- #########################################################


/* В ХМАО несколько миллионов записей. Стало тормозить без индекса - выслано*/

/* <TRANS_COMMAND>

CREATE INDEX IDX_SIGNLOG_DOCID ON SIGNLOG (DOCID)
/
COMMIT WORK
/

*/
-- <TRANS_IGNORE>

DECLARE
  v_exists INTEGER;
BEGIN
  SELECT count(*)
  INTO v_exists
  FROM user_indexes
  WHERE INDEX_NAME = 'IDX_SIGNLOG_DOCID';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE 'CREATE INDEX IDX_SIGNLOG_DOCID ON SIGNLOG (DOCID)';
    EXECUTE IMMEDIATE 'COMMIT WORK';
  END IF;
END;
/



-- #########################################################
-- #########################################################
-- alter_tr_IFS_100.sql
-- #########################################################
-- #########################################################

-- CREATE TRIGGER tr_innerfinsource_au_100
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_IU
  INSTEAD OF UPDATE
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  tmp_Double$ NUMBER;
  sKVSR$ VARCHAR2(3);
  sDescrCode1$ VARCHAR2(7);
  sDescrCode2$ VARCHAR2(7);
  CNT$1 NUMBER(10);
  sAnalyticalGroupIFS$ VARCHAR2(3);
  KVSRCode$ NUMBER(10);
  DescrCode1$ NUMBER(10);
  DescrCode2$ NUMBER(10);
  sIFSLevel$ NUMBER(10);
  sDirection$ NUMBER(10);
  AGIFS$ NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_INNERFINSOURCE_BU_0)
-- Version 11.20.00.2
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction)
    into sIFSLevel$, sDirection$     from innerfinsource
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))
    ;
  END IF;
  if (sIFSLevel$ is not null) then
    new$IFS_Level := sIFSLevel$;
  END IF;
  if (sDirection$ is not null) then
    new$Direction := sDirection$;
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((new$AnalyticalGroupIFS between 300 and 399) or
    (new$AnalyticalGroupIFS between 500 and 599) or
    (new$AnalyticalGroupIFS between 800 and 899)) then
      new$Direction := -1;

    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS$);
    if (new$AnalyticalGroupIFS = AGIFS$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS$);
    if (new$AnalyticalGroupIFS = AGIFS$) then
      new$Direction := -1;

    END IF;
  END IF;
  BEGIN


    /*      */
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR$ := '000';

  else
    if (KVSRCode$ < 10) then
      sKVSR$ := '00' || KVSRCode$;

    else
      if (KVSRCode$ < 100) then
        sKVSR$ := '0' || KVSRCode$;

      else
        sKVSR$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */

  tmp$ := new$DescriptionCode;
  tmp_Double$ := tmp$ / 1000000;
  DescrCode1$ := tmp_Double$;
  /*      ,
          ,    1 */
  if (DescrCode1$  > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode1$; /*    */
  /*       */
  tmp_Double$ := DescrCode1$;
  tmp_Double$ := tmp$ - tmp_Double$ * 1000000;
  DescrCode2$ := tmp_Double$;
  tmp_Double$ := DescrCode2$ / 10000;
  DescrCode1$ := tmp_Double$;
  /*      */
  if (DescrCode1$ > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  new$ItemCode := DescrCode1$; /* */
  tmp_Double$ := DescrCode2$ - DescrCode1$ * 10000;
  new$ProgramCode := tmp_Double$; /* */
  /*       */

  tmp_Double$ := tmp$ / 10000000;
  DescrCode1$ := tmp_Double$;
  if (DescrCode1$ > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  tmp_Double$ := DescrCode1$;
  tmp_Double$ := tmp$ - tmp_Double$ * 10000000;
  DescrCode2$ := tmp_Double$;
  if (DescrCode1$ = 0) then
    sDescrCode1$ := '0000000';

  else
    if (DescrCode1$ < 10) then
      sDescrCode1$ := '000000' || DescrCode1$;

    else
      if (DescrCode1$ < 100) then
        sDescrCode1$ := '00000' || DescrCode1$;

      else
        if (DescrCode1$ < 1000) then
          sDescrCode1$ := '0000' || DescrCode1$;

        else
          if (DescrCode1$ < 10000) then
            sDescrCode1$ := '000' || DescrCode1$;

          else
            if (DescrCode1$ < 100000) then
              sDescrCode1$ := '00' || DescrCode1$;

            else
              if (DescrCode1$ < 1000000) then
                sDescrCode1$ := '0' || DescrCode1$;

              else
                sDescrCode1$ := DescrCode1$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode2$ = 0) then
    sDescrCode2$ := '0000000';

  else
    if (DescrCode2$ < 10) then
      sDescrCode2$ := '000000' || DescrCode2$;

    else
      if (DescrCode2$ < 100) then
        sDescrCode2$ := '00000' || DescrCode2$;

      else
        if (DescrCode2$ < 1000) then
          sDescrCode2$ := '0000' || DescrCode2$;

        else
          if (DescrCode2$ < 10000) then
            sDescrCode2$ := '000' || DescrCode2$;

          else
            if (DescrCode2$ < 100000) then
              sDescrCode2$ := '00' || DescrCode2$;

            else
              if (DescrCode2$ < 1000000) then
                sDescrCode2$ := '0' || DescrCode2$;

              else
                sDescrCode2$ := DescrCode2$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    new$KESR := sAnalyticalGroupIFS$;
  END IF;
  /*      */

  new$FinSourceValue := sKVSR$ || sDescrCode1$ || sDescrCode2$ || sAnalyticalGroupIFS$;

  if ((new$ID = 0) and (new$FinSourceValue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_INNERFINSOURCE SET
    ID = new$ID,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    DIRECTION = new$DIRECTION,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    FINSOURCEVALUE = new$FINSOURCEVALUE,
    UNIONFLAG = new$UNIONFLAG,
    REMOTEFLAG = new$REMOTEFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CLSASPECT = new$CLSASPECT,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    IFS_LEVEL = new$IFS_LEVEL,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_INNERFINSOURCE_AU_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);
      
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_INNERFINSOURCE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (145, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=145) and (RecordId=new$ID);
  end if;

END;
/
-- CREATE TRIGGER tr_innerfinsource_ai_100
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_II
  INSTEAD OF INSERT
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  tmp_Double$ NUMBER;
  sKVSR$ VARCHAR2(3);
  sDescrCode1$ VARCHAR2(7);
  sDescrCode2$ VARCHAR2(7);
  sAnalyticalGroupIFS$ VARCHAR2(3);
  CNT$1 NUMBER(10);
  DescrCode1$ NUMBER(10);
  DescrCode2$ NUMBER(10);
  KVSRCode1$ NUMBER(10);
  sIFSLevel1$ NUMBER(10);
  sDirection1$ NUMBER(10);
  AGIFS$ NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_INNERFINSOURCE_BI_0)
-- Version 11.20.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction)
    into sIFSLevel1$, sDirection1$     from innerfinsource
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))
    ;
  END IF;
  if (sIFSLevel1$ is not null) then
    new$IFS_Level := sIFSLevel1$;
  END IF;
  if (sDirection1$ is not null) then
    new$Direction := sDirection1$;
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((new$AnalyticalGroupIFS between 300 and 399) or
    (new$AnalyticalGroupIFS between 500 and 599) or
    (new$AnalyticalGroupIFS between 800 and 899)) then
      new$Direction := -1;

    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS$);
    if (new$AnalyticalGroupIFS = AGIFS$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS$);
    if (new$AnalyticalGroupIFS = AGIFS$) then
      new$Direction := -1;

    END IF;
  END IF;
  BEGIN


    /*      */
    select Code into KVSRCode1$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode1$ = 0) then
    sKVSR$ := '000';

  else
    if (KVSRCode1$ < 10) then
      sKVSR$ := '00' || KVSRCode1$;

    else
      if (KVSRCode1$ < 100) then
        sKVSR$ := '0' || KVSRCode1$;

      else
        sKVSR$ := KVSRCode1$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */

  tmp$ := new$DescriptionCode;
  tmp_Double$ := tmp$ / 1000000;
  DescrCode1$ := tmp_Double$;
  /*      ,
          ,    1 */
  if (DescrCode1$  > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode1$; /*    */
  /*       */
  tmp_Double$ := DescrCode1$;
  tmp_Double$ := tmp$ - tmp_Double$ * 1000000;
  DescrCode2$ := tmp_Double$;
  tmp_Double$ := DescrCode2$ / 10000;
  DescrCode1$ := tmp_Double$;
  /*      */
  if (DescrCode1$ > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  new$ItemCode := DescrCode1$; /* */
  tmp_Double$ := DescrCode2$ - DescrCode1$ * 10000;
  new$ProgramCode := tmp_Double$; /* */
  /*       */

  tmp_Double$ := tmp$ / 10000000;
  DescrCode1$ := tmp_Double$;
  if (DescrCode1$ > tmp_Double$) then
    DescrCode1$ := DescrCode1$ - 1;
  END IF;
  tmp_Double$ := DescrCode1$;
  tmp_Double$ := tmp$ - tmp_Double$ * 10000000;
  DescrCode2$ := tmp_Double$;
  if (DescrCode1$ = 0) then
    sDescrCode1$ := '0000000';

  else
    if (DescrCode1$ < 10) then
      sDescrCode1$ := '000000' || DescrCode1$;

    else
      if (DescrCode1$ < 100) then
        sDescrCode1$ := '00000' || DescrCode1$;

      else
        if (DescrCode1$ < 1000) then
          sDescrCode1$ := '0000' || DescrCode1$;

        else
          if (DescrCode1$ < 10000) then
            sDescrCode1$ := '000' || DescrCode1$;

          else
            if (DescrCode1$ < 100000) then
              sDescrCode1$ := '00' || DescrCode1$;

            else
              if (DescrCode1$ < 1000000) then
                sDescrCode1$ := '0' || DescrCode1$;

              else
                sDescrCode1$ := DescrCode1$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode2$ = 0) then
    sDescrCode2$ := '0000000';

  else
    if (DescrCode2$ < 10) then
      sDescrCode2$ := '000000' || DescrCode2$;

    else
      if (DescrCode2$ < 100) then
        sDescrCode2$ := '00000' || DescrCode2$;

      else
        if (DescrCode2$ < 1000) then
          sDescrCode2$ := '0000' || DescrCode2$;

        else
          if (DescrCode2$ < 10000) then
            sDescrCode2$ := '000' || DescrCode2$;

          else
            if (DescrCode2$ < 100000) then
              sDescrCode2$ := '00' || DescrCode2$;

            else
              if (DescrCode2$ < 1000000) then
                sDescrCode2$ := '0' || DescrCode2$;

              else
                sDescrCode2$ := DescrCode2$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */
    select Code into sAnalyticalGroupIFS$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    new$KESR := sAnalyticalGroupIFS$;
  END IF;
  /*      */

  new$FinSourceValue := sKVSR$ || sDescrCode1$ || sDescrCode2$ || sAnalyticalGroupIFS$;

  if ((new$ID = 0) and (new$FinSourceValue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_INNERFINSOURCE_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_INNERFINSOURCE (
    ID,
    CREATEDATE,
    UPDATEDATE,
    DIRECTION,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    FINSOURCEVALUE,
    UNIONFLAG,
    REMOTEFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    STARTDATE,
    SHORTNAME,
    CLSASPECT,
    CREATERUSER,
    UPDATERUSER,
    IFS_LEVEL,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPIFS
  ) VALUES (
    new$ID,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$DIRECTION,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$FINSOURCEVALUE,
    new$UNIONFLAG,
    new$REMOTEFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$STARTDATE,
    new$SHORTNAME,
    new$CLSASPECT,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$IFS_LEVEL,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPIFS);

-- - - - - - - - - - - - -
-- AI_100 (TR_INNERFINSOURCE_AI_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);
      
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_INNERFINSOURCE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 145) and (RecordId = new$ID);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Add_CLS_OOS_FINANCE.sql
-- #########################################################
-- #########################################################

/*    FacialAcc ( ), AddCls (. )
   oos_contract_finances */
ALTER TABLE OOS_CONTRACT_FINANCES ADD (
  FacialAcc VARCHAR2(20),
  AddCls VARCHAR2(100)
)
/
COMMIT WORK 
/




-- #########################################################
-- #########################################################
-- Alter_BufElExchTab.sql
-- #########################################################
-- #########################################################

/*     512  
   SourceName, DestName, Note  ed_outpaydoc
   PayerName, NamKor, Note  bankexch_merdoc*/
ALTER TABLE ed_outpaydoc MODIFY (SourceName VARCHAR2(512))
/
ALTER TABLE ed_outpaydoc MODIFY (DestName VARCHAR2(512))
/
ALTER TABLE ed_outpaydoc MODIFY (Note VARCHAR2(512))
/
ALTER TABLE bankexch_merdoc MODIFY (PayerName VARCHAR2(512))
/
ALTER TABLE bankexch_merdoc MODIFY (NamKor VARCHAR2(512))
/
ALTER TABLE bankexch_merdoc MODIFY (Note VARCHAR2(512))
/
COMMIT WORK
/


-- #########################################################
-- #########################################################
-- UpdateTenderObjects_ProductCLS_Ora.sql
-- #########################################################
-- #########################################################


ALTER TABLE TenderObjects DROP CONSTRAINT FK_TENDEROBJECTS_OKDP
;

ALTER TABLE TenderObjects DROP CONSTRAINT FK_TENDEROBJECTS_OKPCLS
;

ALTER TABLE TenderObjects DROP CONSTRAINT FK_TENDEROBJECTS_OKPD
;

ALTER TABLE TenderObjects DROP CONSTRAINT FK_TENDEROBJECTS_OKVED
;

alter table TenderObjects modify (OKDP null)
;

alter table TenderObjects modify (OKPD null)
;

alter table TenderObjects modify (OKPCLS null)
;

alter table TenderObjects modify (OKVED null)
;


CREATE OR REPLACE TRIGGER TR_TENDEROBJECTS_BI
  BEFORE INSERT
  ON TENDEROBJECTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDEROBJECTS_BI)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.MEASUREMENTCLS is null) then 
    :new.MEASUREMENTCLS := 0;
  END IF;
  if (:new.KESR is null) then 
    :new.KESR := 0;
  END IF;
  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;    
  END IF;
  if (:new.OKPD2 is null) then 
    :new.OKPD2 := 0;
  END IF;
  if (:new.OKVED2 is null) then 
    :new.OKVED2 := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDEROBJECTS_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then 
    :new.senderIdKey := -1;
      
  else 
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;
      
  else 
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDEROBJECTS_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tenderobjects_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (:new.realid is null) then 
    :new.realid := :new.id;
  END IF;

END;
/

CREATE OR REPLACE TRIGGER TR_TENDEROBJECTS_BU
  BEFORE UPDATE
  ON TENDEROBJECTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDEROBJECTS_BU_0)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (:new.MEASUREMENTCLS is null) then 
    :new.MEASUREMENTCLS := 0;
  END IF;
  if (:new.KESR is null) then 
    :new.KESR := 0;
  END IF;
  if (:new.FacialAccCls is null) then 
    :new.FacialAccCls := 0;
  END IF;
  if (:new.OKPD2 is null) then 
    :new.OKPD2 := 0;
  END IF;
  if (:new.OKVED2 is null) then 
    :new.OKVED2 := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDEROBJECTS_BU_200)
-- Create 01.11.2004
-- - - - - - - - - - - - -

  /*        */
  if (:new.DocStateRef <> :old.DocStateRef) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
    values(:new.id, :old.DocStateRef, :new.DocStateRef);
  end if;  

-- - - - - - - - - - - - -
-- BU_600 (tenderobjects_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (:new.realid is null) then 
    :new.realid := :new.id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDEROBJECTS_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

  if (:New.RVersion is null) then
    :New.RVersion := 1;
  elsif ((:New.RVersion = -1) and (:Old.RVersion <> -1)) then
    :New.RVersion := :Old.RVersion;
  else
    :New.RVersion := :Old.RVersion + 1;
  end if;  

END; 
/

commit work
;



-- #########################################################
-- #########################################################
-- alter_Organizations_RecordOwnerOrgRef_fix.sql
-- #########################################################
-- #########################################################

/*       RecordOwnerOrgRef   0. 
       RecordOwnerOrgRef    .
     RecordOwnerOrgRef   .
*/
ALTER TRIGGER TR_ORGANIZATIONS_BU_500 DISABLE
/
commit work
/
/*      */
update Organizations o1 set
  RecordOwnerOrgRef = 0
where
  (o1.RecordOwnerOrgRef <> 0) and
  not exists(
    select * from Organizations o2 where o1.RecordOwnerOrgRef = o2.id
  )
/
commit work
/
ALTER TRIGGER TR_ORGANIZATIONS_BU_500 ENABLE
/
commit work
/
INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_RECOWNERORGREFNOTFOUND', -20366, '    ')
/
commit work
/
-- ALTER TRIGGER TR_ORGANIZATIONS_AD_200
CREATE OR REPLACE TRIGGER TR_ORGANIZATIONS_ID
  INSTEAD OF DELETE
  ON ORGANIZATIONS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_ORGANIZATIONS_BD)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (:old.ID = 0) then
    RaiseException('ex_CantDelUnknownOrg');
  END IF;
  delete from Org_Accounts where org_ref = :old.id;
  delete from Banks where id = :old.id;
  delete from INN_KPP where id = :old.id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_ORGANIZATIONS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_200 (TR_ORGANIZATIONS_AD_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  update Organizations set
  GeneralOrg_Ref = id
  where
  GeneralOrg_Ref = :old.id;
  update Organizations set
  RecordOwnerOrgRef = 0
  where
  RecordOwnerOrgRef = :old.id;

-- - - - - - - - - - - - -
-- AD_210 (TR_ORGANIZATIONS_AD_210)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*       */
  delete
  from
  StateJumpHistory
  where
  DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_ORGANIZATIONS_AD_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID,RecordId,DeleteDate) values(27, :old.ID ,SYSDATE);

END;
/
-- ALTER TRIGGER TR_ORGANIZATIONS_BI_200
CREATE OR REPLACE TRIGGER TR_ORGANIZATIONS_II
  INSTEAD OF INSERT
  ON ORGANIZATIONS
  FOR EACH ROW
DECLARE
  new$ID ORGANIZATIONS.ID%TYPE := :NEW.ID;
  new$NAME ORGANIZATIONS.NAME%TYPE := :NEW.NAME;
  new$GOSNI ORGANIZATIONS.GOSNI%TYPE := :NEW.GOSNI;
  new$CITY ORGANIZATIONS.CITY%TYPE := :NEW.CITY;
  new$COUNTRY ORGANIZATIONS.COUNTRY%TYPE := :NEW.COUNTRY;
  new$PHONE ORGANIZATIONS.PHONE%TYPE := :NEW.PHONE;
  new$ADDRESS ORGANIZATIONS.ADDRESS%TYPE := :NEW.ADDRESS;
  new$ORG_CLS ORGANIZATIONS.ORG_CLS%TYPE := :NEW.ORG_CLS;
  new$INN20 ORGANIZATIONS.INN20%TYPE := :NEW.INN20;
  new$SUBINN ORGANIZATIONS.SUBINN%TYPE := :NEW.SUBINN;
  new$FACIALACC ORGANIZATIONS.FACIALACC%TYPE := :NEW.FACIALACC;
  new$REGIONCLS ORGANIZATIONS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$DIRNAME ORGANIZATIONS.DIRNAME%TYPE := :NEW.DIRNAME;
  new$BUGNAME ORGANIZATIONS.BUGNAME%TYPE := :NEW.BUGNAME;
  new$DIRPHONE ORGANIZATIONS.DIRPHONE%TYPE := :NEW.DIRPHONE;
  new$BUGPHONE ORGANIZATIONS.BUGPHONE%TYPE := :NEW.BUGPHONE;
  new$RCORG ORGANIZATIONS.RCORG%TYPE := :NEW.RCORG;
  new$CREATERUSER ORGANIZATIONS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORGANIZATIONS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORGANIZATIONS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORGANIZATIONS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$INN ORGANIZATIONS.INN%TYPE := :NEW.INN;
  new$OKATO ORGANIZATIONS.OKATO%TYPE := :NEW.OKATO;
  new$EMAIL ORGANIZATIONS.EMAIL%TYPE := :NEW.EMAIL;
  new$WEBSITE ORGANIZATIONS.WEBSITE%TYPE := :NEW.WEBSITE;
  new$UFKCODE ORGANIZATIONS.UFKCODE%TYPE := :NEW.UFKCODE;
  new$ADDOKATO ORGANIZATIONS.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$SHORTNAME ORGANIZATIONS.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$RVERSION ORGANIZATIONS.RVERSION%TYPE := :NEW.RVERSION;
  new$SENDERID ORGANIZATIONS.SENDERID%TYPE := :NEW.SENDERID;
  new$KVSR ORGANIZATIONS.KVSR%TYPE := :NEW.KVSR;
  new$OKFS ORGANIZATIONS.OKFS%TYPE := :NEW.OKFS;
  new$OKOPF ORGANIZATIONS.OKOPF%TYPE := :NEW.OKOPF;
  new$OPENDATE ORGANIZATIONS.OPENDATE%TYPE := :NEW.OPENDATE;
  new$CLOSEDATE ORGANIZATIONS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$CHANGEDATE ORGANIZATIONS.CHANGEDATE%TYPE := :NEW.CHANGEDATE;
  new$GENERALORG_REF ORGANIZATIONS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$FEDERALREGIONCODE ORGANIZATIONS.FEDERALREGIONCODE%TYPE := :NEW.FEDERALREGIONCODE;
  new$ORG_TYPE ORGANIZATIONS.ORG_TYPE%TYPE := :NEW.ORG_TYPE;
  new$BUDGETREF ORGANIZATIONS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUPPLIERSTATUS ORGANIZATIONS.SUPPLIERSTATUS%TYPE := :NEW.SUPPLIERSTATUS;
  new$COUNTRYCODE ORGANIZATIONS.COUNTRYCODE%TYPE := :NEW.COUNTRYCODE;
  new$DATECLOSE ORGANIZATIONS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$ORGCODE ORGANIZATIONS.ORGCODE%TYPE := :NEW.ORGCODE;
  new$COSTAUTHORITY ORGANIZATIONS.COSTAUTHORITY%TYPE := :NEW.COSTAUTHORITY;
  new$INCOMEAUTHORITY ORGANIZATIONS.INCOMEAUTHORITY%TYPE := :NEW.INCOMEAUTHORITY;
  new$DEBTAUTHORITY ORGANIZATIONS.DEBTAUTHORITY%TYPE := :NEW.DEBTAUTHORITY;
  new$SVRAUTHORITY ORGANIZATIONS.SVRAUTHORITY%TYPE := :NEW.SVRAUTHORITY;
  new$CLIENTID ORGANIZATIONS.CLIENTID%TYPE := :NEW.CLIENTID;
  new$DATEOPEN ORGANIZATIONS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$FUID ORGANIZATIONS.FUID%TYPE := :NEW.FUID;
  new$OKPO ORGANIZATIONS.OKPO%TYPE := :NEW.OKPO;
  new$OKTMO ORGANIZATIONS.OKTMO%TYPE := :NEW.OKTMO;
  new$DOCSTATEREF ORGANIZATIONS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CRYPTOSTATUS ORGANIZATIONS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$OGRN ORGANIZATIONS.OGRN%TYPE := :NEW.OGRN;
  new$REJECT_CLS ORGANIZATIONS.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$EXTID ORGANIZATIONS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORGANIZATIONS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORGANIZATIONS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$REMOTEPBSCODE ORGANIZATIONS.REMOTEPBSCODE%TYPE := :NEW.REMOTEPBSCODE;
  new$REMOTENOTPBSCODE ORGANIZATIONS.REMOTENOTPBSCODE%TYPE := :NEW.REMOTENOTPBSCODE;
  new$USECHECK_CARD ORGANIZATIONS.USECHECK_CARD%TYPE := :NEW.USECHECK_CARD;
  new$EXTROOTID ORGANIZATIONS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION ORGANIZATIONS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE ORGANIZATIONS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$RECORDOWNERORGREF ORGANIZATIONS.RECORDOWNERORGREF%TYPE := :NEW.RECORDOWNERORGREF;
  new$REJECTCAUSE ORGANIZATIONS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$BLOCKEDDATE ORGANIZATIONS.BLOCKEDDATE%TYPE := :NEW.BLOCKEDDATE;
  new$BLOCKEDCAUSE ORGANIZATIONS.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE ORGANIZATIONS.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE ORGANIZATIONS.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$ORGREESTRCODE ORGANIZATIONS.ORGREESTRCODE%TYPE := :NEW.ORGREESTRCODE;
--
  CNT$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_Organizations_bi)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FUID is null) then
    new$FUID := new$id;
  END IF;
  if (new$GOSNI is null) then
    new$GOSNI := 0;
  END IF;
  if (new$Name is null) then
    new$Name := '  ';
  END IF;
  if (new$City is null) then
    GetVarcharConst(-1,7,new$City);
  END IF;
  if (new$COUNTRY is null) then
    new$COUNTRY := '';
  END IF;
  if (new$CountryCode is null) then
    new$CountryCode := 643;
  END IF;
  if (new$ORG_CLS is NULL) then
    new$ORG_CLS:= 0;
  END IF;
  if (new$SubINN is null) then
    new$SubINN:= 0;
  END IF;
  if (new$INN20 is null) then
    new$INN20:= '';
  END IF;
  if (new$RCOrg is null) then
    new$RCOrg := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$OKATO is null) then
    new$OKATO := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$OKFS is null) then
    new$OKFS := 0;
  END IF;
  if (new$OKOPF is null) then
    new$OKOPF := 0;
  END IF;
  if (new$FederalRegionCode is null) then
    GetIntConst(-1, 27,new$FederalRegionCode);
  END IF;
  if (new$FederalRegionCode is null) then
    new$FederalRegionCode := 0;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  /*    - */
  if (new$org_type is null) then
    new$org_type := 20000;
  END IF;
  /*        */
  if ((new$generalorg_ref is null) or (new$org_type < 10000) or (new$org_type >= 20000)) then
    new$generalorg_ref := new$id;
  END IF;
  /*    10 ,      */
  if ((new$INN > 9999999999.9) and (new$INN20 <> '') and (new$INN20 is not null)) then
    RaiseException('EX_WRONGKPP');
  END IF;
  check_unique_organization(new$id, new$inn,  new$inn20);
  if (new$CostAuthority is null) then
    new$CostAuthority:= 0;
  END IF;
  if (new$IncomeAuthority is null) then
    new$IncomeAuthority := 0;
  END IF;
  if (new$DebtAuthority is null) then
    new$DebtAuthority := 0;
  END IF;
  if (new$SVRAuthority is null) then
    new$SVRAuthority := 0;
  END IF;
  /*        */
  if (new$Org_Type is not null)
  then
    if (new$Org_Type between 10100 and 10299) then
      new$CostAuthority:= 1;
    END IF;
    if (new$Org_Type between 10300 and 10399) then
      new$CostAuthority:= 2;
    END IF;
    if (new$Org_Type between 10400 and 10499) then
      new$CostAuthority:= 4;
    END IF;
    if (((new$Org_Type between 10500 and 10599) and (new$CostAuthority<>16)) or
    (((new$Org_Type between 10000 and 10099) or (new$Org_Type between 10600 and 10799))
    and (new$CostAuthority=0))) then
      new$CostAuthority:= 8;

    END IF;
  END IF;
  if (new$UseCheck_Card is null) then
    new$UseCheck_Card := 0;
  END IF;
  if (new$RecordOwnerOrgRef is null) then
    new$RecordOwnerOrgRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_ORGANIZATIONS_BI_10)
-- Last update 19.10.2006
-- - - - - - - - - - - - -

  if (new$FacialAcc is not null) then
    select count(id) into cnt$ from Organizations where (FacialAcc = new$FacialAcc) AND (ROWNUM = 1);
    if (cnt$ <> 0) then RaiseException('ex_DublicateFacialAcc'); end if;
  end if;

-- - - - - - - - - - - - -
-- BI_200 (TR_ORGANIZATIONS_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> new$GeneralOrg_Ref) then
    SELECT COUNT(o.id ) INTO CNT$1
    from Organizations o where (o.id = new$GeneralOrg_Ref) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('ex_GeneralOrgNotFound');
    END IF;
    /*      ,     */
    if (new$KVSR = 0) then
      BEGIN
        select
        o.KVSR
        into
        new$KVSR       from
        Organizations o
        where
        o.id = new$GeneralOrg_Ref
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;  
    END IF;
  END IF;
  if (new$RecordOwnerOrgRef <> 0) then
    SELECT COUNT(o.id ) INTO CNT$2
    from Organizations o where (o.id = new$RecordOwnerOrgRef) AND (ROWNUM = 1);
    if (not (CNT$2<> 0)) then
      RaiseException('ex_RecOwnerOrgRefNotFound');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_ORGANIZATIONS_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_ORGANIZATIONS (
    ID,
    NAME,
    GOSNI,
    CITY,
    COUNTRY,
    PHONE,
    ADDRESS,
    ORG_CLS,
    INN20,
    SUBINN,
    FACIALACC,
    REGIONCLS,
    DIRNAME,
    BUGNAME,
    DIRPHONE,
    BUGPHONE,
    RCORG,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    INN,
    OKATO,
    EMAIL,
    WEBSITE,
    UFKCODE,
    ADDOKATO,
    SHORTNAME,
    RVERSION,
    SENDERID,
    KVSR,
    OKFS,
    OKOPF,
    OPENDATE,
    CLOSEDATE,
    CHANGEDATE,
    GENERALORG_REF,
    FEDERALREGIONCODE,
    ORG_TYPE,
    BUDGETREF,
    SUPPLIERSTATUS,
    COUNTRYCODE,
    DATECLOSE,
    ORGCODE,
    COSTAUTHORITY,
    INCOMEAUTHORITY,
    DEBTAUTHORITY,
    SVRAUTHORITY,
    CLIENTID,
    DATEOPEN,
    FUID,
    OKPO,
    OKTMO,
    DOCSTATEREF,
    CRYPTOSTATUS,
    OGRN,
    REJECT_CLS,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    REMOTEPBSCODE,
    REMOTENOTPBSCODE,
    USECHECK_CARD,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    RECORDOWNERORGREF,
    REJECTCAUSE,
    BLOCKEDDATE,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    ORGREESTRCODE
  ) VALUES (
    new$ID,
    new$NAME,
    new$GOSNI,
    new$CITY,
    new$COUNTRY,
    new$PHONE,
    new$ADDRESS,
    new$ORG_CLS,
    new$INN20,
    new$SUBINN,
    new$FACIALACC,
    new$REGIONCLS,
    new$DIRNAME,
    new$BUGNAME,
    new$DIRPHONE,
    new$BUGPHONE,
    new$RCORG,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$INN,
    new$OKATO,
    new$EMAIL,
    new$WEBSITE,
    new$UFKCODE,
    new$ADDOKATO,
    new$SHORTNAME,
    new$RVERSION,
    new$SENDERID,
    new$KVSR,
    new$OKFS,
    new$OKOPF,
    new$OPENDATE,
    new$CLOSEDATE,
    new$CHANGEDATE,
    new$GENERALORG_REF,
    new$FEDERALREGIONCODE,
    new$ORG_TYPE,
    new$BUDGETREF,
    new$SUPPLIERSTATUS,
    new$COUNTRYCODE,
    new$DATECLOSE,
    new$ORGCODE,
    new$COSTAUTHORITY,
    new$INCOMEAUTHORITY,
    new$DEBTAUTHORITY,
    new$SVRAUTHORITY,
    new$CLIENTID,
    new$DATEOPEN,
    new$FUID,
    new$OKPO,
    new$OKTMO,
    new$DOCSTATEREF,
    new$CRYPTOSTATUS,
    new$OGRN,
    new$REJECT_CLS,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$REMOTEPBSCODE,
    new$REMOTENOTPBSCODE,
    new$USECHECK_CARD,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$RECORDOWNERORGREF,
    new$REJECTCAUSE,
    new$BLOCKEDDATE,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$ORGREESTRCODE);

-- - - - - - - - - - - - -
-- AI_500 (TR_ORGANIZATIONS_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 27) and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_ORGANIZATIONS_BU_200
CREATE OR REPLACE TRIGGER TR_ORGANIZATIONS_IU
  INSTEAD OF UPDATE
  ON ORGANIZATIONS
  FOR EACH ROW
DECLARE
  new$ID ORGANIZATIONS.ID%TYPE := :NEW.ID;
  new$NAME ORGANIZATIONS.NAME%TYPE := :NEW.NAME;
  new$GOSNI ORGANIZATIONS.GOSNI%TYPE := :NEW.GOSNI;
  new$CITY ORGANIZATIONS.CITY%TYPE := :NEW.CITY;
  new$COUNTRY ORGANIZATIONS.COUNTRY%TYPE := :NEW.COUNTRY;
  new$PHONE ORGANIZATIONS.PHONE%TYPE := :NEW.PHONE;
  new$ADDRESS ORGANIZATIONS.ADDRESS%TYPE := :NEW.ADDRESS;
  new$ORG_CLS ORGANIZATIONS.ORG_CLS%TYPE := :NEW.ORG_CLS;
  new$INN20 ORGANIZATIONS.INN20%TYPE := :NEW.INN20;
  new$SUBINN ORGANIZATIONS.SUBINN%TYPE := :NEW.SUBINN;
  new$FACIALACC ORGANIZATIONS.FACIALACC%TYPE := :NEW.FACIALACC;
  new$REGIONCLS ORGANIZATIONS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$DIRNAME ORGANIZATIONS.DIRNAME%TYPE := :NEW.DIRNAME;
  new$BUGNAME ORGANIZATIONS.BUGNAME%TYPE := :NEW.BUGNAME;
  new$DIRPHONE ORGANIZATIONS.DIRPHONE%TYPE := :NEW.DIRPHONE;
  new$BUGPHONE ORGANIZATIONS.BUGPHONE%TYPE := :NEW.BUGPHONE;
  new$RCORG ORGANIZATIONS.RCORG%TYPE := :NEW.RCORG;
  new$CREATERUSER ORGANIZATIONS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORGANIZATIONS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORGANIZATIONS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORGANIZATIONS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$INN ORGANIZATIONS.INN%TYPE := :NEW.INN;
  new$OKATO ORGANIZATIONS.OKATO%TYPE := :NEW.OKATO;
  new$EMAIL ORGANIZATIONS.EMAIL%TYPE := :NEW.EMAIL;
  new$WEBSITE ORGANIZATIONS.WEBSITE%TYPE := :NEW.WEBSITE;
  new$UFKCODE ORGANIZATIONS.UFKCODE%TYPE := :NEW.UFKCODE;
  new$ADDOKATO ORGANIZATIONS.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$SHORTNAME ORGANIZATIONS.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$RVERSION ORGANIZATIONS.RVERSION%TYPE := :NEW.RVERSION;
  new$SENDERID ORGANIZATIONS.SENDERID%TYPE := :NEW.SENDERID;
  new$KVSR ORGANIZATIONS.KVSR%TYPE := :NEW.KVSR;
  new$OKFS ORGANIZATIONS.OKFS%TYPE := :NEW.OKFS;
  new$OKOPF ORGANIZATIONS.OKOPF%TYPE := :NEW.OKOPF;
  new$OPENDATE ORGANIZATIONS.OPENDATE%TYPE := :NEW.OPENDATE;
  new$CLOSEDATE ORGANIZATIONS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$CHANGEDATE ORGANIZATIONS.CHANGEDATE%TYPE := :NEW.CHANGEDATE;
  new$GENERALORG_REF ORGANIZATIONS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$FEDERALREGIONCODE ORGANIZATIONS.FEDERALREGIONCODE%TYPE := :NEW.FEDERALREGIONCODE;
  new$ORG_TYPE ORGANIZATIONS.ORG_TYPE%TYPE := :NEW.ORG_TYPE;
  new$BUDGETREF ORGANIZATIONS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUPPLIERSTATUS ORGANIZATIONS.SUPPLIERSTATUS%TYPE := :NEW.SUPPLIERSTATUS;
  new$COUNTRYCODE ORGANIZATIONS.COUNTRYCODE%TYPE := :NEW.COUNTRYCODE;
  new$DATECLOSE ORGANIZATIONS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$ORGCODE ORGANIZATIONS.ORGCODE%TYPE := :NEW.ORGCODE;
  new$COSTAUTHORITY ORGANIZATIONS.COSTAUTHORITY%TYPE := :NEW.COSTAUTHORITY;
  new$INCOMEAUTHORITY ORGANIZATIONS.INCOMEAUTHORITY%TYPE := :NEW.INCOMEAUTHORITY;
  new$DEBTAUTHORITY ORGANIZATIONS.DEBTAUTHORITY%TYPE := :NEW.DEBTAUTHORITY;
  new$SVRAUTHORITY ORGANIZATIONS.SVRAUTHORITY%TYPE := :NEW.SVRAUTHORITY;
  new$CLIENTID ORGANIZATIONS.CLIENTID%TYPE := :NEW.CLIENTID;
  new$DATEOPEN ORGANIZATIONS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$FUID ORGANIZATIONS.FUID%TYPE := :NEW.FUID;
  new$OKPO ORGANIZATIONS.OKPO%TYPE := :NEW.OKPO;
  new$OKTMO ORGANIZATIONS.OKTMO%TYPE := :NEW.OKTMO;
  new$DOCSTATEREF ORGANIZATIONS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CRYPTOSTATUS ORGANIZATIONS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$OGRN ORGANIZATIONS.OGRN%TYPE := :NEW.OGRN;
  new$REJECT_CLS ORGANIZATIONS.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$EXTID ORGANIZATIONS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORGANIZATIONS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORGANIZATIONS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$REMOTEPBSCODE ORGANIZATIONS.REMOTEPBSCODE%TYPE := :NEW.REMOTEPBSCODE;
  new$REMOTENOTPBSCODE ORGANIZATIONS.REMOTENOTPBSCODE%TYPE := :NEW.REMOTENOTPBSCODE;
  new$USECHECK_CARD ORGANIZATIONS.USECHECK_CARD%TYPE := :NEW.USECHECK_CARD;
  new$EXTROOTID ORGANIZATIONS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION ORGANIZATIONS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE ORGANIZATIONS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$RECORDOWNERORGREF ORGANIZATIONS.RECORDOWNERORGREF%TYPE := :NEW.RECORDOWNERORGREF;
  new$REJECTCAUSE ORGANIZATIONS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$BLOCKEDDATE ORGANIZATIONS.BLOCKEDDATE%TYPE := :NEW.BLOCKEDDATE;
  new$BLOCKEDCAUSE ORGANIZATIONS.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE ORGANIZATIONS.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE ORGANIZATIONS.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$ORGREESTRCODE ORGANIZATIONS.ORGREESTRCODE%TYPE := :NEW.ORGREESTRCODE;
--
  CNT$ NUMBER(10);
  c$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORGANIZATIONS_BU)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (new$gosni is null) then
    new$gosni := 0;
  END IF;
  if (new$city is null) then
    getvarcharconst(-1,7,new$city);
  END IF;
  if (new$country is null) then
    new$country := '';
  END IF;
  if (new$countrycode is null) then
    new$countrycode := 643;
  END IF;
  if (new$org_cls is null) then
    new$org_cls:= 0;
  END IF;
  if (new$inn20 is null) then
    new$inn20:= '';
  END IF;
  if (new$rcorg is null) then
    new$rcorg := 0;
  END IF;
  if (new$regioncls is null) then
    new$regioncls := 0;
  END IF;
  if (new$okato is null) then
    new$okato := 0;
  END IF;
  if (new$kvsr is null) then
    new$kvsr := 0;
  END IF;
  if (new$okfs is null) then
    new$okfs := 0;
  END IF;
  if (new$okopf is null) then
    new$okopf := 0;
  END IF;
  if (new$federalregioncode is null) then
    getintconst(-1, 27,new$federalregioncode);
  END IF;
  if (new$federalregioncode is null) then
    new$federalregioncode := 0;
  END IF;
  if (new$budgetref is null) then
    new$budgetref := 0;
  END IF;
  /*    - */
  if (new$org_type is null) then
    new$org_type := 20000;
  END IF;
  /*        */
  if ((new$generalorg_ref is null) or (new$org_type < 10000) or (new$org_type >= 20000)) then
    new$generalorg_ref := new$id;
  END IF;

  /*    10 ,      */
  if ((new$inn <> :old.inn) or ((:old.inn is null) and (new$inn is not null))) then
    if ((new$inn > 9999999999.9) and (new$inn20 <> '')) then
      RaiseException('ex_wrongkpp');
    END IF;
  END IF;
  if ( ((new$inn <> :old.inn) or ((:old.inn is null) and (new$inn is not null)))
  or ( (new$inn20 <> :old.inn20) or ((:old.inn20 is null) and (new$inn20 is not null))) )
  then
    delete from INN_KPP where id = :old.id;
    check_unique_organization(new$id, new$inn, new$inn20);

  END IF;

  if (new$regioncls <> :old.regioncls) then
    update dfaccountsbuhtable set
    regioncls = new$regioncls
    where id = any (select id from org_accounts where org_ref = new$id);
  END IF;
  /*      */
  if (:old.id = 0) then
    RaiseException('ex_cantmodifyunknownorg');
  END IF;
  /*        */
  if ((new$org_type<>:old.org_type) or (new$costauthority<>:old.costauthority))
  then
    c$ := new$costauthority;
    if (new$org_type between 10100 and 10299) then
      new$costauthority:= 1;
    END IF;
    if (new$org_type between 10300 and 10399) then
      new$costauthority:= 2;
    END IF;
    if (new$org_type between 10400 and 10499) then
      new$costauthority:= 4;
    END IF;
    if (((new$org_type between 10500 and 10599) and (new$costauthority<>16)) or
    (((new$org_type between 10000 and 10099) or (new$org_type between 10600 and 10799))
    and (new$costauthority=0))) then
      new$costauthority:= 8;
    END IF;
    if ((new$org_type=:old.org_type) and (c$<>new$costauthority)) then
      RaiseException('ex_wrongcostauthority');
    END IF;
  END IF;
  /*    RegionCls  ,  
         */
  if (new$regioncls <> :old.regioncls) then
    update facialacc_cls fac set
    fac.regioncls = new$regioncls
    where
    new$id = fac.org_ref;

  END IF;
  if (new$UseCheck_Card is null) then
    new$UseCheck_Card := 0;
  END IF;
  if (new$RecordOwnerOrgRef is null) then
    new$RecordOwnerOrgRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_ORGANIZATIONS_BU_10)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$FacialAcc <> :old.FacialAcc) then
    select count(id) into CNT$ from Organizations
      where (FacialAcc = new$FacialAcc) and (id <> new$id) AND (ROWNUM = 1);
    if (CNT$ <> 0) then
      RaiseException('ex_DublicateFacialAcc');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORGANIZATIONS_BU_100)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  /*   */
  if ((new$DateClose is not null) and (:old.DateClose is null)) then
    /*         -    */
    delete from INN_KPP where id = :old.id;
    /*        */
    update Org_Accounts set
    DateClose = new$DateClose,
    CloseCode = CloseCode + 10
    where Org_Ref = new$Id;

  END IF;
  /*  /      */
  if (((new$DateClose is not null) and (:old.DateClose is null)) or (new$DateClose <> :old.DateClose)) then
    /*     / */
    update FacialAcc_Cls set
    DateClose = new$DateClose,
    CloseCode = CloseCode + 10
    where Org_ref = new$Id;
  END IF;
  /*   */
  if ((new$DateClose is null) and (:old.DateClose is not null)) then
    update Org_Accounts set
    CloseCode = CloseCode - 10
    where Org_Ref = new$Id;

    /*     / */
    update FacialAcc_Cls set
    DateClose = new$DateClose,
    CloseCode = CloseCode - 10
    where Org_ref = new$Id;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_ORGANIZATIONS_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> new$GeneralOrg_Ref) then
    SELECT COUNT(o.id ) INTO CNT$1
    from Organizations o where (o.id = new$GeneralOrg_Ref) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('ex_GeneralOrgNotFound');  
    END IF;
  END IF;
  if (new$GeneralOrg_Ref <> :old.GeneralOrg_Ref) then
    update FacialAcc_CLS set
    GeneralOrg_Ref = new$GeneralOrg_Ref
    where
    Org_Ref = new$id;
  END IF;
  if (new$RecordOwnerOrgRef <> 0) then
    SELECT COUNT(o.id ) INTO CNT$2
    from Organizations o where (o.id = new$RecordOwnerOrgRef) AND (ROWNUM = 1);
    if (not (CNT$2<> 0)) then
      RaiseException('ex_RecOwnerOrgRefNotFound');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_ORGANIZATIONS_BU_210)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$DOCSTATEREF <> :old.DOCSTATEREF) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
    values(new$id, :old.DOCSTATEREF, new$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORGANIZATIONS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  IF (new$RVersion IS NULL) THEN
    new$RVersion := 1;
  ELSIF ( (new$RVersion = -1) AND (:OLD.RVersion <> -1) ) THEN
    new$RVersion := :OLD.RVersion;
  ELSE
    new$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORGANIZATIONS SET
    ID = new$ID,
    NAME = new$NAME,
    GOSNI = new$GOSNI,
    CITY = new$CITY,
    COUNTRY = new$COUNTRY,
    PHONE = new$PHONE,
    ADDRESS = new$ADDRESS,
    ORG_CLS = new$ORG_CLS,
    INN20 = new$INN20,
    SUBINN = new$SUBINN,
    FACIALACC = new$FACIALACC,
    REGIONCLS = new$REGIONCLS,
    DIRNAME = new$DIRNAME,
    BUGNAME = new$BUGNAME,
    DIRPHONE = new$DIRPHONE,
    BUGPHONE = new$BUGPHONE,
    RCORG = new$RCORG,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    INN = new$INN,
    OKATO = new$OKATO,
    EMAIL = new$EMAIL,
    WEBSITE = new$WEBSITE,
    UFKCODE = new$UFKCODE,
    ADDOKATO = new$ADDOKATO,
    SHORTNAME = new$SHORTNAME,
    RVERSION = new$RVERSION,
    SENDERID = new$SENDERID,
    KVSR = new$KVSR,
    OKFS = new$OKFS,
    OKOPF = new$OKOPF,
    OPENDATE = new$OPENDATE,
    CLOSEDATE = new$CLOSEDATE,
    CHANGEDATE = new$CHANGEDATE,
    GENERALORG_REF = new$GENERALORG_REF,
    FEDERALREGIONCODE = new$FEDERALREGIONCODE,
    ORG_TYPE = new$ORG_TYPE,
    BUDGETREF = new$BUDGETREF,
    SUPPLIERSTATUS = new$SUPPLIERSTATUS,
    COUNTRYCODE = new$COUNTRYCODE,
    DATECLOSE = new$DATECLOSE,
    ORGCODE = new$ORGCODE,
    COSTAUTHORITY = new$COSTAUTHORITY,
    INCOMEAUTHORITY = new$INCOMEAUTHORITY,
    DEBTAUTHORITY = new$DEBTAUTHORITY,
    SVRAUTHORITY = new$SVRAUTHORITY,
    CLIENTID = new$CLIENTID,
    DATEOPEN = new$DATEOPEN,
    FUID = new$FUID,
    OKPO = new$OKPO,
    OKTMO = new$OKTMO,
    DOCSTATEREF = new$DOCSTATEREF,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    OGRN = new$OGRN,
    REJECT_CLS = new$REJECT_CLS,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    REMOTEPBSCODE = new$REMOTEPBSCODE,
    REMOTENOTPBSCODE = new$REMOTENOTPBSCODE,
    USECHECK_CARD = new$USECHECK_CARD,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    RECORDOWNERORGREF = new$RECORDOWNERORGREF,
    REJECTCAUSE = new$REJECTCAUSE,
    BLOCKEDDATE = new$BLOCKEDDATE,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    ORGREESTRCODE = new$ORGREESTRCODE
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_100 (TR_ORGANIZATIONS_AU_100)
-- Create 27.07.2007
-- - - - - - - - - - - - -

-- Comment   / 


  /*    */
  if ((new$DateClose is not null) and (:old.DateClose is null)) then
    update Banks set DateClose = new$DateClose where (id = new$ID) and (DateClose is null);
  end if;

  /*    */
  if ((new$DateClose is null) and (:old.DateClose is not null)) then
    update Banks set DateClose = null where (id = new$ID) and (DateClose is not null);
  end if;

-- - - - - - - - - - - - -
-- AU_200 (TR_ORGANIZATIONS_AU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef <> :old.BudgetRef) then
    update FacialAcc_CLS set
    BudgetRef = new$BudgetRef
    where
    (ORG_REF = new$id)and((BudgetRef = :old.BudgetRef)or(BudgetRef<>0));
  END IF;
  /*     ,    */
  if ((new$KVSR <> :old.KVSR)and(new$Org_Type >= 10100)and(new$Org_Type <= 10299)) then
    update KVSR set
    Org_Ref = new$id
    where
    id = new$KVSR;
  END IF;
  if (new$KVSR <> :old.KVSR) then
    update FacialAcc_CLS set
    KVSR = new$KVSR
    where
    (ORG_REF = new$id) and (KVSR = :old.KVSR);
  END IF;
  if (new$BudgetRef <> :old.BudgetRef) then
    update organizations set
    BudgetRef = new$BudgetRef
    where
    (generalorg_ref = new$id) and (id <> new$id);
  END IF;
  if (new$KVSR <> :old.KVSR) then
    update organizations set
    KVSR = new$KVSR
    where
    (generalorg_ref = new$id) and (id <> new$id);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORGANIZATIONS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (27, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=27) and (RecordId=new$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Add_StoredAttrFields.sql
-- #########################################################
-- #########################################################

/*       ,    .
    : MACROSCODES -> MacroCheckCodes; PARAMSVALUES -> MacroCheckParams
*/
ALTER TABLE StoredAttributesCaption ADD (
  IsSystem NUMBER(10),-- , ,    
    CHECK((IsSystem<=2147483647)AND(IsSystem>-2147483648)),
  StoredContent VARCHAR2(2000)--    
)
/
ALTER TABLE StoredAttributesDetail ADD (
  LinkAttrSingleListNames VARCHAR2(255),--       ( LinkFields)
  ParentColumnCaption VARCHAR2(255),--     (   ,  \)
  StoredContentDet VARCHAR2(2000),--    
  IsParent NUMBER(10),--           
    CHECK((IsParent<=2147483647)AND(IsParent>-2147483648)),
  WorkWithColumn NUMBER(10),-- ,           
    CHECK((WorkWithColumn<=2147483647)AND(WorkWithColumn>-2147483648)),
  IsSystem NUMBER(10)-- , ,    
  ,
    CHECK((IsSystem<=2147483647)AND(IsSystem>-2147483648))
)
/
--   
ALTER TABLE StoredAttributesDetail ADD (
  MacroCheckCodes VARCHAR2(50),
  MacroCheckParams VARCHAR2(255)
)
/
update
  StoredAttributesDetail 
set 
  MacroCheckCodes = MACROSCODES, 
  MacroCheckParams = PARAMSVALUES
/
--      -     
--alter table StoredAttributesDetail
-- drop MACROSCODES, 
--  drop PARAMSVALUES
--!!

update StoredAttributesCaption set IsSystem = 0 where IsSystem is null
/
update StoredAttributesDetail set IsSystem = 0 where IsSystem is null
/
update StoredAttributesDetail set IsParent = 0 where IsParent is null
/
update StoredAttributesDetail set WorkWithColumn = 0 where WorkWithColumn is null
/
-- CREATE TRIGGER tr_storedattrdet_bi_0
CREATE OR REPLACE TRIGGER TR_STOREDATTRIBUTESDETAIL_BI
  BEFORE INSERT
  ON STOREDATTRIBUTESDETAIL
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_STOREDATTRDET_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.fieldtype is null) then 
    :new.fieldtype := 1;                           /*       */
  END IF;
  if ((:new.fieldsize is null) and (:new.fieldtype=1)) then 
    :new.fieldsize := 255; /*       255*/
  END IF;
  if (:new.IsParent is null) then 
    :new.IsParent := 0;                             /*       */
  END IF;
  if (:new.WorkWithColumn is null) then 
    :new.WorkWithColumn := 0;                 /*        */
  END IF;
  if (:new.IsSystem is null) then 
    :new.IsSystem := 0;                             /*       */
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_STOREDATTRDET_BI_500)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  :new.createdate := SYSDATE;
  :new.updatedate := :new.createdate;
  :new.createruser := user;
  :new.updateruser := user;

END;
/
-- CREATE TRIGGER tr_storedattrdet_bu_0
CREATE OR REPLACE TRIGGER TR_storedattributesdetail_BU
  BEFORE UPDATE
  ON storedattributesdetail
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_storedattrdet_bu_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.fieldtype is null) then 
    :new.fieldtype := 1;                           /*       */
  END IF;
  if ((:new.fieldsize is null) and (:new.fieldtype=1)) then 
    :new.fieldsize := 255; /*       255*/
  END IF;
  if (:new.IsParent is null) then 
    :new.IsParent := 0;                             /*       */
  END IF;
  if (:new.WorkWithColumn is null) then 
    :new.WorkWithColumn := 0;                 /*        */
  END IF;
  if (:new.IsSystem is null) then 
    :new.IsSystem := 0;                             /*       */
  END IF;

END;
/
-- CREATE TRIGGER tr_storedattrcpt_bi_0
CREATE OR REPLACE TRIGGER TR_STOREDATTRIBUTESCAPTION_BI
  BEFORE INSERT
  ON STOREDATTRIBUTESCAPTION
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_STOREDATTRCPT_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.docref is null) then 
    :new.docref := 0;
  END IF;
  if (:new.isactive is null) then 
    :new.isactive := 1;
  END IF;
  if (:new.isbudget is null) then 
    :new.isbudget := 1;
  END IF;
  if (:new.IsSystem is null) then 
    :new.IsSystem := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_STOREDATTRCPT_BI_500)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  :new.createdate := SYSDATE;
  :new.updatedate := :new.createdate;
  :new.createruser := user;
  :new.updateruser := user;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- delete_interfaces1300.sql
-- #########################################################
-- #########################################################

--    
-- 28.02   
DELETE FROM interfaces
WHERE GUID = '{F25102A0-9C00-11D2-8C7A-008048FB76DB}'
/
COMMIT WORK
/

-- #########################################################
-- #########################################################
-- ADD_ControlResult_OOSContract.sql
-- #########################################################
-- #########################################################

ALTER TABLE OOS_Contract ADD (
  ControlResult NUMBER(10),
    CHECK((ControlResult<=2147483647)AND(ControlResult>-2147483648))
)
/
COMMIT WORK
/



-- #########################################################
-- #########################################################
-- RegNew1300.sql
-- #########################################################
-- #########################################################

/*   :     
*/
/*      */
CREATE OR REPLACE procedure AddItf(guidItf$ VARCHAR2,NameItf$ VARCHAR2,CodeItf$ NUMBER,
    ParamItf$ VARCHAR2)
AS
  ItfCount$ NUMBER(10);
BEGIN
  select count(id)   into ItfCount$ from interfaces
  where (GUID = guidItf$) and (((ParamItf$  is Null) and (Param is Null)) or (Param = ParamItf$))
  ;
  if (ItfCount$  = 0) then
    insert into interfaces (id, GUID, NOTE, Cls, Param)
    values (g_Shared.nextval, guidItf$, NameItf$, CodeItf$, ParamItf$);
      
  else
    update interfaces
    set GUID = guidItf$, NOTE = NameItf$, Cls = CodeItf$, Param = ParamItf$

    where (GUID = guidItf$) and (((ParamItf$  is Null) and (Param is Null)) or (Param = ParamItf$));
  END IF;
END;
/
CREATE OR REPLACE procedure PlaceItf(AGuid$ VARCHAR2,ParamItf$ VARCHAR2,WPName$ VARCHAR2)
AS
  IID$ NUMBER(10);
  WID$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
  select Min(ID)   into IID$ from interfaces where (GUID = AGuid$) and (((ParamItf$  is Null) and (Param is Null)) or (Param = ParamItf$))
  ;
  select Min(ID)   into WID$ from Workplaces where Upper(Note) = Upper(WPName$)
  ;
  if ((IID$  is not Null) and (WID$  is not Null)) then
    SELECT COUNT(ID ) INTO CNT$1
    from WORKPLACES_INTERFACE where ((workplaces_ref = WID$) and (INTERFACES_REF = IID$)) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) Then
      insert into workplaces_interface (workplaces_ref, INTERFACES_REF)
      values(WID$, IID$);
      
    END IF;
  END IF;
END;
/
commit work
/
CALL AddItf('{75F4558E-67FD-4F2E-923F-0B1B074FF054}', ' ', 0, Null) 
/
CALL PlaceItf('{75F4558E-67FD-4F2E-923F-0B1B074FF054}', Null, '') 
/
drop procedure AddItf
/
drop procedure PlaceItf
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_uTypedFormsCaption_Add_Web_Fields_ORA.sql
-- #########################################################
-- #########################################################


/*    UUID_WEB  ID_WEB     */

/* <TRANS_COMMAND>

ALTER TABLE TB_UTYPEDFORMSCAPTION ADD (
     UUID_WEB VARCHAR2(50)
    )
/
ALTER TABLE TB_UTYPEDFORMSCAPTION ADD (
     ID_WEB INTEGER
    )
/	
COMMIT WORK
/

*/
-- <TRANS_IGNORE>

DECLARE
  v_exists INTEGER;
BEGIN
  SELECT COUNT(*)
  INTO v_exists
  FROM USER_TAB_COLUMNS
  WHERE TABLE_NAME = 'TB_UTYPEDFORMSCAPTION'
  AND COLUMN_NAME = 'UUID_WEB';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE 'ALTER TABLE TB_UTYPEDFORMSCAPTION ADD (
     UUID_WEB VARCHAR2(50)
    )';
  END IF;

  SELECT COUNT(*)
  INTO v_exists
  FROM USER_TAB_COLUMNS
  WHERE TABLE_NAME = 'TB_UTYPEDFORMSCAPTION'
  AND COLUMN_NAME = 'ID_WEB';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE 'ALTER TABLE TB_UTYPEDFORMSCAPTION ADD (
     ID_WEB INTEGER
    )';
  END IF;
END;
/

COMMIT WORK
/

CREATE OR REPLACE VIEW UTYPEDFORMSCAPTION AS
SELECT
    ID,
    REGIONCLS,
    ACCEPTDATE,
    DOCNUMBER,
    NOTE,
    TYPEDFORM,
    PROGINDEX,
    FACIALACC_CLS,
    ORG_REF,
    CREATERUSER,
    UPDATERUSER,
    CREATEDATE,
    UPDATEDATE,
    EMAIL,
    STATE,
    ERROR,
    SOURCEID,
    SOURCEMAILID,
    AUTOTASKSSERVER,
    DEPARTMENTCLS,
    SENDERID,
    SENDERRECORDID,
    CRYPTOSTATUS,
    UTFRINDEX,
    REPORTDATE,
    ESTIMDATE,
    SELF,
    CLIENTSTYPE,
    SENDKIT,
    SENDSTS,
    SENDDOC,
    MANUALEXEC,
    DATAMODE,
    BUDGETREF,
    REPORTYEAR,
    REJECTCLS,
    DOCSTATEREF,
    RVERSION,
    LASTEXTRCHANGE,
    VERSIONID,
    CONSCLIENT,
    FINT1,
    FINT2,
    FINT3,
    FINT4,
    FINT5,
    FINT6,
    FINT7,
    PARAMS,
    FORMTEXTID,
    REGTEXTID,
    PERIODTEXTID,
    REPORTMONTH,
    ACTIVITYKIND,
    PERIOD,
    REJECTCAUSE,
    ID_WEB,
    UUID_WEB
  FROM TB_UTYPEDFORMSCAPTION
/

CREATE OR REPLACE TRIGGER TR_UTFC_II
  INSTEAD OF INSERT
  ON UTYPEDFORMSCAPTION
DECLARE
  new$ID UTYPEDFORMSCAPTION.ID%TYPE := :NEW.ID;
  new$REGIONCLS UTYPEDFORMSCAPTION.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$ACCEPTDATE UTYPEDFORMSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCNUMBER UTYPEDFORMSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NOTE UTYPEDFORMSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$TYPEDFORM UTYPEDFORMSCAPTION.TYPEDFORM%TYPE := :NEW.TYPEDFORM;
  new$PROGINDEX UTYPEDFORMSCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$FACIALACC_CLS UTYPEDFORMSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$ORG_REF UTYPEDFORMSCAPTION.ORG_REF%TYPE := :NEW.ORG_REF;
  new$CREATERUSER UTYPEDFORMSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER UTYPEDFORMSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CREATEDATE UTYPEDFORMSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE UTYPEDFORMSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$EMAIL UTYPEDFORMSCAPTION.EMAIL%TYPE := :NEW.EMAIL;
  new$STATE UTYPEDFORMSCAPTION.STATE%TYPE := :NEW.STATE;
  new$ERROR UTYPEDFORMSCAPTION.ERROR%TYPE := :NEW.ERROR;
  new$SOURCEID UTYPEDFORMSCAPTION.SOURCEID%TYPE := :NEW.SOURCEID;
  new$SOURCEMAILID UTYPEDFORMSCAPTION.SOURCEMAILID%TYPE := :NEW.SOURCEMAILID;
  new$AUTOTASKSSERVER UTYPEDFORMSCAPTION.AUTOTASKSSERVER%TYPE := :NEW.AUTOTASKSSERVER;
  new$DEPARTMENTCLS UTYPEDFORMSCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$SENDERID UTYPEDFORMSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID UTYPEDFORMSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$CRYPTOSTATUS UTYPEDFORMSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$UTFRINDEX UTYPEDFORMSCAPTION.UTFRINDEX%TYPE := :NEW.UTFRINDEX;
  new$REPORTDATE UTYPEDFORMSCAPTION.REPORTDATE%TYPE := :NEW.REPORTDATE;
  new$ESTIMDATE UTYPEDFORMSCAPTION.ESTIMDATE%TYPE := :NEW.ESTIMDATE;
  new$SELF UTYPEDFORMSCAPTION.SELF%TYPE := :NEW.SELF;
  new$CLIENTSTYPE UTYPEDFORMSCAPTION.CLIENTSTYPE%TYPE := :NEW.CLIENTSTYPE;
  new$SENDKIT UTYPEDFORMSCAPTION.SENDKIT%TYPE := :NEW.SENDKIT;
  new$SENDSTS UTYPEDFORMSCAPTION.SENDSTS%TYPE := :NEW.SENDSTS;
  new$SENDDOC UTYPEDFORMSCAPTION.SENDDOC%TYPE := :NEW.SENDDOC;
  new$MANUALEXEC UTYPEDFORMSCAPTION.MANUALEXEC%TYPE := :NEW.MANUALEXEC;
  new$DATAMODE UTYPEDFORMSCAPTION.DATAMODE%TYPE := :NEW.DATAMODE;
  new$BUDGETREF UTYPEDFORMSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$REPORTYEAR UTYPEDFORMSCAPTION.REPORTYEAR%TYPE := :NEW.REPORTYEAR;
  new$REJECTCLS UTYPEDFORMSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$DOCSTATEREF UTYPEDFORMSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION UTYPEDFORMSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$LASTEXTRCHANGE UTYPEDFORMSCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$VERSIONID UTYPEDFORMSCAPTION.VERSIONID%TYPE := :NEW.VERSIONID;
  new$CONSCLIENT UTYPEDFORMSCAPTION.CONSCLIENT%TYPE := :NEW.CONSCLIENT;
  new$FINT1 UTYPEDFORMSCAPTION.FINT1%TYPE := :NEW.FINT1;
  new$FINT2 UTYPEDFORMSCAPTION.FINT2%TYPE := :NEW.FINT2;
  new$FINT3 UTYPEDFORMSCAPTION.FINT3%TYPE := :NEW.FINT3;
  new$FINT4 UTYPEDFORMSCAPTION.FINT4%TYPE := :NEW.FINT4;
  new$FINT5 UTYPEDFORMSCAPTION.FINT5%TYPE := :NEW.FINT5;
  new$FINT6 UTYPEDFORMSCAPTION.FINT6%TYPE := :NEW.FINT6;
  new$FINT7 UTYPEDFORMSCAPTION.FINT7%TYPE := :NEW.FINT7;
  new$PARAMS UTYPEDFORMSCAPTION.PARAMS%TYPE := :NEW.PARAMS;
  new$FORMTEXTID UTYPEDFORMSCAPTION.FORMTEXTID%TYPE := :NEW.FORMTEXTID;
  new$REGTEXTID UTYPEDFORMSCAPTION.REGTEXTID%TYPE := :NEW.REGTEXTID;
  new$PERIODTEXTID UTYPEDFORMSCAPTION.PERIODTEXTID%TYPE := :NEW.PERIODTEXTID;
  new$REPORTMONTH UTYPEDFORMSCAPTION.REPORTMONTH%TYPE := :NEW.REPORTMONTH;
  new$ACTIVITYKIND UTYPEDFORMSCAPTION.ACTIVITYKIND%TYPE := :NEW.ACTIVITYKIND;
  new$PERIOD UTYPEDFORMSCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$REJECTCAUSE UTYPEDFORMSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$ID_WEB UTYPEDFORMSCAPTION.ID_WEB%TYPE := :NEW.ID_WEB;
  new$UUID_WEB UTYPEDFORMSCAPTION.UUID_WEB%TYPE := :NEW.UUID_WEB;
--
  Cnt$ NUMBER(10);
  NeedVersion$ NUMBER(5);
  ActiveVersion$ NUMBER(10);
  ReportPeriod$ NUMBER(10);
  AMonth$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_UTFC_BI)
-- Create 02.03.2004
-- Last update 15.12.2005
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL
        INTO new$ID
        FROM DUAL;
   END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_UTFC_BI10)
-- Version 8.00.00.2
-- - - - - - - - - - - - -

  if (new$TYPEDFORM is null) then 
    new$TYPEDFORM := 0;
  END IF;
  if (new$utfrindex is null) then 
    new$utfrindex := 0;
  END IF;
  if (new$self is null) then 
    new$self := 0;
  END IF;
  if (new$sendkit is null) then 
    new$sendkit := 0;
  END IF;
  if (new$sendsts is null) then 
    new$sendsts := 0;
  END IF;
  if (new$senddoc is null) then 
    new$senddoc := 0;
  END IF;
  if (new$manualexec is null) then 
    new$manualexec := 0;
  END IF;
  if (new$period is null) then 
    new$period := 0;
  END IF;
  if (new$clientstype is null) then 
    new$clientstype := 0;
  END IF;
  if (new$datamode is null) then 
    new$datamode := 0;
  END IF;
  if (new$departmentcls is null) then 
    new$departmentcls := 0;
  END IF;
  if (new$ActivityKind is null) then 
    new$ActivityKind := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then 
    BEGIN
      select fa.BudgetRef      into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$email is null) then 
    new$email := '';
  END IF;
  new$email := UPPER(new$email);
  if (not new$autotasksserver is null) then
    new$autotasksserver := UPPER(new$autotasksserver);
  END IF;
  if (new$ID_WEB is null) then 
    new$ID_WEB := 0;
  END IF;
  if (new$UUID_WEB is null) then 
    new$UUID_WEB := '';
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_UTFC_BI20)
-- Create 22.05.2004
-- Last update 15.12.2008
-- - - - - - - - - - - - -

    /*     ,     */
    BEGIN
      select utf.NEEDVERSION into NeedVersion$
      from UTYPEDFORMS utf
      where (utf.ID = new$TYPEDFORM);
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        NeedVersion$ := NULL;
    END;  
    
    if (NeedVersion$ = 1) then
        /*     ,    */
        if (new$VERSIONID is null) then
            /*      ,  */
            if (new$SENDERID is not null) then
                /*       ""*/
                BEGIN
                  select UTFV.ID into ActiveVersion$
                  from UTYPEDFORMSVERSION UTFV
                  where ((UTFV.TYPEDFORM = new$TYPEDFORM)
                      and (UTFV.IsCurrentForURM = 1));
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    ActiveVersion$ := NULL;
                END;                      
            else
                /*       ""*/
                BEGIN
                  select UTFV.ID into ActiveVersion$
                  from UTYPEDFORMSVERSION UTFV
                  where ((UTFV.TYPEDFORM = new$TYPEDFORM)
                      and (UTFV.ISCURRENT = 1));
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    ActiveVersion$ := NULL;
                END;                      
            end if;

            /*     */
            new$VERSIONID := ActiveVersion$;

            /*     */
            select count(ID) into CNT$ from UTYPEDFORMSVERSION where (ID = new$VERSIONID) AND (ROWNUM = 1);
            if (CNT$ = 0 ) then
              RaiseException('EX_NOT_ACTIVE_VERSION');
            end if;  
        end if;
    end if;

-- - - - - - - - - - - - -
-- BI_50 (TR_UTFC_BI50)
-- Version 8.00.00.2
-- - - - - - - - - - - - -

  BEGIN
    /*    */
    select utf.Period
    into ReportPeriod$   from utypedforms utf
    where utf.id = new$TypedForm
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  if (ReportPeriod$  = 30) then
    /*     12  */    
    new$REPORTMONTH := 12;
      
  else
    if (ReportPeriod$  = 20) then
      /*          */
      if ((new$ReportMonth is null) or (new$ReportMonth = 0)) then
        /*    ,    */        
        new$ReportMonth := 3;
              
      else
        AMonth$ := new$ReportMonth;
        if (AMonth$ between 1 and 3) then
          AMonth$ := 3;
                  
        else 
          if (AMonth$ between 4 and 6) then
            AMonth$ := 6;
                    
          else 
            if (AMonth$ between 7 and 9) then
              AMonth$ := 9;
                      
            else
              AMonth$ := 12;
            END IF;
          END IF;
        END IF;

        new$ReportMonth := AMonth$;
          
      END IF;
    else
      if ((ReportPeriod$  = 10) and (new$ReportMonth is null)) then
        new$ReportMonth := 1;
          
      END IF;
    END IF;
  END IF;
  if (new$REPORTYEAR is null) then 
    new$REPORTYEAR := 0;
  END IF;
  /*          */
  if (ReportPeriod$  > 0) then
    new$REPORTDATE := new$REPORTYEAR * 10000 + new$REPORTMONTH * 100 + 01;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_UTFC_BI500)
-- Create 2.03.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_UTYPEDFORMSCAPTION (
    ID,
    REGIONCLS,
    ACCEPTDATE,
    DOCNUMBER,
    NOTE,
    TYPEDFORM,
    PROGINDEX,
    FACIALACC_CLS,
    ORG_REF,
    CREATERUSER,
    UPDATERUSER,
    CREATEDATE,
    UPDATEDATE,
    EMAIL,
    STATE,
    ERROR,
    SOURCEID,
    SOURCEMAILID,
    AUTOTASKSSERVER,
    DEPARTMENTCLS,
    SENDERID,
    SENDERRECORDID,
    CRYPTOSTATUS,
    UTFRINDEX,
    REPORTDATE,
    ESTIMDATE,
    SELF,
    CLIENTSTYPE,
    SENDKIT,
    SENDSTS,
    SENDDOC,
    MANUALEXEC,
    DATAMODE,
    BUDGETREF,
    REPORTYEAR,
    REJECTCLS,
    DOCSTATEREF,
    RVERSION,
    LASTEXTRCHANGE,
    VERSIONID,
    CONSCLIENT,
    FINT1,
    FINT2,
    FINT3,
    FINT4,
    FINT5,
    FINT6,
    FINT7,
    PARAMS,
    FORMTEXTID,
    REGTEXTID,
    PERIODTEXTID,
    REPORTMONTH,
    ACTIVITYKIND,
    PERIOD,
    REJECTCAUSE,
    ID_WEB,
    UUID_WEB
  ) VALUES (
    new$ID,
    new$REGIONCLS,
    new$ACCEPTDATE,
    new$DOCNUMBER,
    new$NOTE,
    new$TYPEDFORM,
    new$PROGINDEX,
    new$FACIALACC_CLS,
    new$ORG_REF,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$EMAIL,
    new$STATE,
    new$ERROR,
    new$SOURCEID,
    new$SOURCEMAILID,
    new$AUTOTASKSSERVER,
    new$DEPARTMENTCLS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$CRYPTOSTATUS,
    new$UTFRINDEX,
    new$REPORTDATE,
    new$ESTIMDATE,
    new$SELF,
    new$CLIENTSTYPE,
    new$SENDKIT,
    new$SENDSTS,
    new$SENDDOC,
    new$MANUALEXEC,
    new$DATAMODE,
    new$BUDGETREF,
    new$REPORTYEAR,
    new$REJECTCLS,
    new$DOCSTATEREF,
    new$RVERSION,
    new$LASTEXTRCHANGE,
    new$VERSIONID,
    new$CONSCLIENT,
    new$FINT1,
    new$FINT2,
    new$FINT3,
    new$FINT4,
    new$FINT5,
    new$FINT6,
    new$FINT7,
    new$PARAMS,
    new$FORMTEXTID,
    new$REGTEXTID,
    new$PERIODTEXTID,
    new$REPORTMONTH,
    new$ACTIVITYKIND,
    new$PERIOD,
    new$REJECTCAUSE,
    new$ID_WEB,
    new$UUID_WEB);

-- - - - - - - - - - - - -
-- AI_500 (TR_UTFC_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 1301) AND (recordid = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_UTFC_ID
  INSTEAD OF DELETE
  ON UTYPEDFORMSCAPTION
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_UTFC_BD)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*    */
  delete from uTypedFormsDetail where RecordIndex = :old.id;
    
  /*        */
  delete from uTypedImportRegistry where RecordIndex = :old.id;

-- - - - - - - - - - - - -
-- BD_10 (TR_UTFC_BD10)
-- Create 30.11.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  /*       */
  DELETE FROM utfctree WHERE (utfcparent = :old.id) OR (utfckid = :old.id);

-- - - - - - - - - - - - -
-- BD_20 (TR_UTFC_BD20)
-- Create 15.12.2005
-- - - - - - - - - - - - -

  /*        */
  if (not :old.VERSIONID is null) then
    update UTYPEDFORMSVERSION utfv
    set REPORTNUMBER = (select count(utfc.ID) - 1
                        from utypedformscaption utfc
                        where (utfc.VERSIONID = :old.VERSIONID))
    where utfv.ID = :old.VERSIONID;
  end if;  

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_UTYPEDFORMSCAPTION
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AD_200 (TR_UTFC_AD_200)
-- Create 14.09.2005
-- - - - - - - - - - - - -

  /*       */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_UTFC_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  INSERT INTO delrecindexes(tableid, recordid, deletedate, ProgIndex)
  VALUES (1301, :old.ID, SYSDATE, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_UTFC_IU
  INSTEAD OF UPDATE
  ON UTYPEDFORMSCAPTION
DECLARE
  new$ID UTYPEDFORMSCAPTION.ID%TYPE := :NEW.ID;
  new$REGIONCLS UTYPEDFORMSCAPTION.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$ACCEPTDATE UTYPEDFORMSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$DOCNUMBER UTYPEDFORMSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NOTE UTYPEDFORMSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$TYPEDFORM UTYPEDFORMSCAPTION.TYPEDFORM%TYPE := :NEW.TYPEDFORM;
  new$PROGINDEX UTYPEDFORMSCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$FACIALACC_CLS UTYPEDFORMSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$ORG_REF UTYPEDFORMSCAPTION.ORG_REF%TYPE := :NEW.ORG_REF;
  new$CREATERUSER UTYPEDFORMSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER UTYPEDFORMSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$CREATEDATE UTYPEDFORMSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE UTYPEDFORMSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$EMAIL UTYPEDFORMSCAPTION.EMAIL%TYPE := :NEW.EMAIL;
  new$STATE UTYPEDFORMSCAPTION.STATE%TYPE := :NEW.STATE;
  new$ERROR UTYPEDFORMSCAPTION.ERROR%TYPE := :NEW.ERROR;
  new$SOURCEID UTYPEDFORMSCAPTION.SOURCEID%TYPE := :NEW.SOURCEID;
  new$SOURCEMAILID UTYPEDFORMSCAPTION.SOURCEMAILID%TYPE := :NEW.SOURCEMAILID;
  new$AUTOTASKSSERVER UTYPEDFORMSCAPTION.AUTOTASKSSERVER%TYPE := :NEW.AUTOTASKSSERVER;
  new$DEPARTMENTCLS UTYPEDFORMSCAPTION.DEPARTMENTCLS%TYPE := :NEW.DEPARTMENTCLS;
  new$SENDERID UTYPEDFORMSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID UTYPEDFORMSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$CRYPTOSTATUS UTYPEDFORMSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$UTFRINDEX UTYPEDFORMSCAPTION.UTFRINDEX%TYPE := :NEW.UTFRINDEX;
  new$REPORTDATE UTYPEDFORMSCAPTION.REPORTDATE%TYPE := :NEW.REPORTDATE;
  new$ESTIMDATE UTYPEDFORMSCAPTION.ESTIMDATE%TYPE := :NEW.ESTIMDATE;
  new$SELF UTYPEDFORMSCAPTION.SELF%TYPE := :NEW.SELF;
  new$CLIENTSTYPE UTYPEDFORMSCAPTION.CLIENTSTYPE%TYPE := :NEW.CLIENTSTYPE;
  new$SENDKIT UTYPEDFORMSCAPTION.SENDKIT%TYPE := :NEW.SENDKIT;
  new$SENDSTS UTYPEDFORMSCAPTION.SENDSTS%TYPE := :NEW.SENDSTS;
  new$SENDDOC UTYPEDFORMSCAPTION.SENDDOC%TYPE := :NEW.SENDDOC;
  new$MANUALEXEC UTYPEDFORMSCAPTION.MANUALEXEC%TYPE := :NEW.MANUALEXEC;
  new$DATAMODE UTYPEDFORMSCAPTION.DATAMODE%TYPE := :NEW.DATAMODE;
  new$BUDGETREF UTYPEDFORMSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$REPORTYEAR UTYPEDFORMSCAPTION.REPORTYEAR%TYPE := :NEW.REPORTYEAR;
  new$REJECTCLS UTYPEDFORMSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$DOCSTATEREF UTYPEDFORMSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION UTYPEDFORMSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$LASTEXTRCHANGE UTYPEDFORMSCAPTION.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$VERSIONID UTYPEDFORMSCAPTION.VERSIONID%TYPE := :NEW.VERSIONID;
  new$CONSCLIENT UTYPEDFORMSCAPTION.CONSCLIENT%TYPE := :NEW.CONSCLIENT;
  new$FINT1 UTYPEDFORMSCAPTION.FINT1%TYPE := :NEW.FINT1;
  new$FINT2 UTYPEDFORMSCAPTION.FINT2%TYPE := :NEW.FINT2;
  new$FINT3 UTYPEDFORMSCAPTION.FINT3%TYPE := :NEW.FINT3;
  new$FINT4 UTYPEDFORMSCAPTION.FINT4%TYPE := :NEW.FINT4;
  new$FINT5 UTYPEDFORMSCAPTION.FINT5%TYPE := :NEW.FINT5;
  new$FINT6 UTYPEDFORMSCAPTION.FINT6%TYPE := :NEW.FINT6;
  new$FINT7 UTYPEDFORMSCAPTION.FINT7%TYPE := :NEW.FINT7;
  new$PARAMS UTYPEDFORMSCAPTION.PARAMS%TYPE := :NEW.PARAMS;
  new$FORMTEXTID UTYPEDFORMSCAPTION.FORMTEXTID%TYPE := :NEW.FORMTEXTID;
  new$REGTEXTID UTYPEDFORMSCAPTION.REGTEXTID%TYPE := :NEW.REGTEXTID;
  new$PERIODTEXTID UTYPEDFORMSCAPTION.PERIODTEXTID%TYPE := :NEW.PERIODTEXTID;
  new$REPORTMONTH UTYPEDFORMSCAPTION.REPORTMONTH%TYPE := :NEW.REPORTMONTH;
  new$ACTIVITYKIND UTYPEDFORMSCAPTION.ACTIVITYKIND%TYPE := :NEW.ACTIVITYKIND;
  new$PERIOD UTYPEDFORMSCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$REJECTCAUSE UTYPEDFORMSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$ID_WEB UTYPEDFORMSCAPTION.ID_WEB%TYPE := :NEW.ID_WEB;
  new$UUID_WEB UTYPEDFORMSCAPTION.UUID_WEB%TYPE := :NEW.UUID_WEB;
--
  Cnt$ NUMBER(10);
  NeedVersion$ NUMBER(5);
  ActiveVersion$ NUMBER(10);
  ReportPeriod$ NUMBER(10);
  AMonth$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_UTFC_BU)
-- Create 02.03.2004
-- Last update 15.12.2005
-- - - - - - - - - - - - -

  /*      ID -   */
  IF (new$ID IS NULL) THEN SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL; END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_UTFC_BU10)
-- Version 8.00.00.2
-- - - - - - - - - - - - -

  if (new$typedform is null) then 
    new$typedform := 0;
  END IF;
  if (new$utfrindex is null) then 
    new$utfrindex := 0;
  END IF;
  if (new$self is null) then 
    new$self := 0;
  END IF;
  if (new$sendkit is null) then 
    new$sendkit := 0;
  END IF;
  if (new$sendsts is null) then 
    new$sendsts := 0;
  END IF;
  if (new$senddoc is null) then 
    new$senddoc := 0;
  END IF;
  if (new$manualexec is null) then 
    new$manualexec := 0;
  END IF;
  if (new$period is null) then 
    new$period := 0;
  END IF;
  if (new$clientstype is null) then 
    new$clientstype := 0;
  END IF;
  if (new$datamode is null) then 
    new$datamode := 0;
  END IF;
  if (new$departmentcls is null) then 
    new$departmentcls := 0;
  END IF;
  if (new$ActivityKind is null) then 
    new$ActivityKind := 0;
  END IF;
  if (new$BudgetRef is null) then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$email is null) then 
    new$email := '';
  END IF;
  new$email := UPPER(new$email);
  if (not new$autotasksserver is null) then
    new$autotasksserver := UPPER(new$autotasksserver);
  END IF;
  if (new$ID_WEB is null) then 
    new$ID_WEB := 0;
  END IF;
  if (new$UUID_WEB is null) then 
    new$UUID_WEB := '';
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_UTFC_BU20)
-- Create 22.05.2004
-- Last update 15.12.2008
-- - - - - - - - - - - - -

    /*     ,     */
    BEGIN
      select utf.NEEDVERSION into NeedVersion$
      from UTYPEDFORMS utf
      where (utf.ID = new$TYPEDFORM);
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        NeedVersion$ := NULL;
    END;  
    
    if (NeedVersion$ = 1) then
        /*     ,    */
        if (new$VERSIONID is null) then
            /*      ,  */
            if (new$SENDERID is not null) then
                /*       ""*/
                BEGIN
                  select UTFV.ID into ActiveVersion$
                  from UTYPEDFORMSVERSION UTFV
                  where ((UTFV.TYPEDFORM = new$TYPEDFORM)
                      and (UTFV.IsCurrentForURM = 1));
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    ActiveVersion$ := NULL;
                END;                      
            else
                /*       ""*/
                BEGIN
                  select UTFV.ID into ActiveVersion$
                  from UTYPEDFORMSVERSION UTFV
                  where ((UTFV.TYPEDFORM = new$TYPEDFORM)
                      and (UTFV.ISCURRENT = 1));
                EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    ActiveVersion$ := NULL;
                END;                      
            end if;

            /*     */
            new$VERSIONID := ActiveVersion$;

            /*     */
            select count(ID) into CNT$ from UTYPEDFORMSVERSION where (ID = new$VERSIONID) AND (ROWNUM = 1);
            if (CNT$ = 0 ) then
              RaiseException('EX_NOT_ACTIVE_VERSION');
            end if;  
        end if;
    end if;

-- - - - - - - - - - - - -
-- BU_50 (TR_UTFC_BU50)
-- Version 8.00.00.2
-- - - - - - - - - - - - -

  BEGIN
    /*    */
    select utf.Period
    into ReportPeriod$   from utypedforms utf
    where utf.id = new$TypedForm
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  if (ReportPeriod$  = 30) then
    /*     12  */    
    new$REPORTMONTH := 12;
      
  else
    if (ReportPeriod$  = 20) then
      /*          */
      if ((new$ReportMonth is null) or (new$ReportMonth = 0)) then
        /*    ,    */        
        new$ReportMonth := 3;
              
      else
        AMonth$ := new$ReportMonth;
        if (AMonth$ between 1 and 3) then
          AMonth$ := 3;
                  
        else 
          if (AMonth$ between 4 and 6) then
            AMonth$ := 6;
                    
          else 
            if (AMonth$ between 7 and 9) then
              AMonth$ := 9;
                      
            else
              AMonth$ := 12;
            END IF;
          END IF;
        END IF;

        new$ReportMonth := AMonth$;
          
      END IF;
    else
      if ((ReportPeriod$  = 10) and (new$ReportMonth is null)) then
        new$ReportMonth := 1;
          
      END IF;
    END IF;
  END IF;
  if (new$REPORTYEAR is null) then 
    new$REPORTYEAR := 0;
  END IF;
  /*          */
  if (ReportPeriod$  > 0) then
    new$REPORTDATE := new$REPORTYEAR * 10000 + new$REPORTMONTH * 100 + 01;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_UTFC_BU_200)
-- Create 14.09.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  /*       */
  if (new$DOCSTATEREF <> :old.DOCSTATEREF) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      values(new$id, :old.DOCSTATEREF, :new.DOCSTATEREF);
  end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_UTYPEDFORMSCAPTION SET
    ID = new$ID,
    REGIONCLS = new$REGIONCLS,
    ACCEPTDATE = new$ACCEPTDATE,
    DOCNUMBER = new$DOCNUMBER,
    NOTE = new$NOTE,
    TYPEDFORM = new$TYPEDFORM,
    PROGINDEX = new$PROGINDEX,
    FACIALACC_CLS = new$FACIALACC_CLS,
    ORG_REF = new$ORG_REF,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    EMAIL = new$EMAIL,
    STATE = new$STATE,
    ERROR = new$ERROR,
    SOURCEID = new$SOURCEID,
    SOURCEMAILID = new$SOURCEMAILID,
    AUTOTASKSSERVER = new$AUTOTASKSSERVER,
    DEPARTMENTCLS = new$DEPARTMENTCLS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    UTFRINDEX = new$UTFRINDEX,
    REPORTDATE = new$REPORTDATE,
    ESTIMDATE = new$ESTIMDATE,
    SELF = new$SELF,
    CLIENTSTYPE = new$CLIENTSTYPE,
    SENDKIT = new$SENDKIT,
    SENDSTS = new$SENDSTS,
    SENDDOC = new$SENDDOC,
    MANUALEXEC = new$MANUALEXEC,
    DATAMODE = new$DATAMODE,
    BUDGETREF = new$BUDGETREF,
    REPORTYEAR = new$REPORTYEAR,
    REJECTCLS = new$REJECTCLS,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    VERSIONID = new$VERSIONID,
    CONSCLIENT = new$CONSCLIENT,
    FINT1 = new$FINT1,
    FINT2 = new$FINT2,
    FINT3 = new$FINT3,
    FINT4 = new$FINT4,
    FINT5 = new$FINT5,
    FINT6 = new$FINT6,
    FINT7 = new$FINT7,
    PARAMS = new$PARAMS,
    FORMTEXTID = new$FORMTEXTID,
    REGTEXTID = new$REGTEXTID,
    PERIODTEXTID = new$PERIODTEXTID,
    REPORTMONTH = new$REPORTMONTH,
    ACTIVITYKIND = new$ACTIVITYKIND,
    PERIOD = new$PERIOD,
    REJECTCAUSE = new$REJECTCAUSE,
    ID_WEB = new$ID_WEB,
    UUID_WEB = new$UUID_WEB
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);
 
  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

END;
/

COMMIT WORK
/



-- #########################################################
-- #########################################################
-- Add_IdPZ_OOS_contract.sql
-- #########################################################
-- #########################################################

/*    IdPZ (  )
   oos_contract */
ALTER TABLE oos_contract ADD (
  IdPZ VARCHAR2(20)
)
/
COMMIT WORK 
/



-- #########################################################
-- #########################################################
-- Create_SysNotify.sql
-- #########################################################
-- #########################################################

/*   SysNotify, SysNotifyHit*/
/*   -       */
create table SysNotify (
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  SendList VARCHAR2(1024),/*  -  (,)   ,  -  */
  MsgSubj VARCHAR2(255),/*  (  ),    -       */
  MsgText VARCHAR2(1024) NOT NULL,/*   */
  MsgKind NUMBER(10) NOT NULL,/*      IAxUserNotify */
    CHECK((MsgKind<=2147483647)AND(MsgKind>-2147483648)),
  DeleteDate DATE,/*  ,   -     */
  CREATEDATE DATE NOT NULL,
  CREATERUSER VARCHAR2(30) NOT NULL,
  constraint PK_SysNotify_ID primary key (ID)
)
/
-- CREATE TRIGGER TR_SysNotify_BI_0
CREATE OR REPLACE TRIGGER TR_SysNotify_BI
  BEFORE INSERT
  ON SysNotify
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_SysNotify_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    :new.id := GEN_ID('g_gen',1);
  END IF;

END;
/
-- CREATE TRIGGER TR_SysNotify_BI_500
CREATE OR REPLACE TRIGGER TR_SysNotify_BI
  BEFORE INSERT
  ON SysNotify
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_SysNotify_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    :new.id := GEN_ID('g_gen',1);
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_SysNotify_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.CreaterUser := user;
  if (:new.DeleteDate is null) then
    :new.DeleteDate := :new.CreateDate + 1;
  END IF;

END;
/
/*   -      */
create table SysNotifyHit (
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  UserRef NUMBER(10) NOT NULL,/*    DbUsers */
    CHECK((UserRef<=2147483647)AND(UserRef>-2147483648)),
  NotifyRef NUMBER(10) NOT NULL,/*    SysNotify */
    CHECK((NotifyRef<=2147483647)AND(NotifyRef>-2147483648)),
  CREATEDATE DATE NOT NULL,
  constraint PK_SysNotifyHit_ID primary key (ID),
  constraint FK_SysNotifyHit_User foreign key (UserRef) references TB_DBUsers(ID),
  constraint FK_SysNotifyHit_Notify foreign key (NotifyRef) references SysNotify(ID)
)
/
CREATE INDEX FK_SysNotifyHit_User ON SysNotifyHit(UserRef)
/
CREATE INDEX FK_SysNotifyHit_Notify ON SysNotifyHit(NotifyRef)
/
-- CREATE TRIGGER TR_SysNotifyHit_BI_0
CREATE OR REPLACE TRIGGER TR_SysNotifyHit_BI
  BEFORE INSERT
  ON SysNotifyHit
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_SysNotifyHit_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    :new.id := GEN_ID('g_gen',1);
  END IF;

END;
/
-- CREATE TRIGGER TR_SysNotifyHit_BI_500
CREATE OR REPLACE TRIGGER TR_SysNotifyHit_BI
  BEFORE INSERT
  ON SysNotifyHit
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_SysNotifyHit_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    :new.id := GEN_ID('g_gen',1);
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_SysNotifyHit_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;

END;
/
commit work
/
-- ALTER TRIGGER tr_DbUsers_bd_1
CREATE OR REPLACE TRIGGER TR_DBUSERS_ID
  INSTEAD OF DELETE
  ON DBUSERS
  FOR EACH ROW
DECLARE
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_DBUSERS_BD)
-- - - - - - - - - - - - -

        --    SYSDBA
        if (:old.id = 0) then
                RaiseException('EX_CANTDELETETHIS');
        end if;

-- - - - - - - - - - - - -
-- BD_1 (TR_DBUSERS_BD_1)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  delete from User_Workplaces
  where Users_ref = :old.id;

  delete from ReportsPermissions
  where Userid = :old.id;

  delete from UsersInGroups
  where UserRef = :old.id;

  delete from UsersRights
  where UserRef = :old.id;

  delete from DualRights
  where (UserRef = :old.id) and (IsGroup = 0);

  delete from SysNotifyHit
  where UserRef = :old.id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_DBUSERS
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_10 (TR_DBUSERS_AD_10)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  /*    RemoteClients  DBUsers */
  if (:old.RemoteClientRef is not null) then
    SELECT COUNT(dbu.ID ) INTO CNT$1
    from DBUsers dbu where (dbu.RemoteClientRef = :old.RemoteClientRef) AND (ROWNUM = 1);
    /*     DBUsers     RemoteClient,   ,     */
    if (not (CNT$1<> 0)) then
      delete from RemoteClient where ID = :old.RemoteClientRef;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AD_20 (TR_DBUSERS_AD_20)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  /*         DBUsers */
  delete from LayerData
  where LayerRef in(select ID from Layers where Alias in('..','..')) and STRFIELD00 = :old.UserName;
  delete from LayerData
  where LayerRef = (select ID from Layers where Alias = '..') and STRFIELD01 = :old.UserName;
  delete from LayerData
  where LayerRef = (select ID from Layers where Alias = '..') and STRFIELD02 = :old.UserName;

-- - - - - - - - - - - - -
-- AD_30 (tr_dbusers_ad_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  update DepartmentCls set
  User_Ref = null
  where
  User_Ref = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_DBUSERS_AD_500)
-- - - - - - - - - - - - -

/*      */
  insert into DelRecIndexes(TableID,RecordId,DeleteDate)
       values(100,:old.ID, sysdate);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Add_SpPurchType_to_OOS.sql
-- #########################################################
-- #########################################################

/*    " "   OOS_CONTRACT_FINANCES
   "  " (, )   OOS_CONTRACT */
ALTER TRIGGER TR_OOS_C_F_BU_500 DISABLE
/
ALTER TABLE OOS_CONTRACT_FINANCES ADD (
  PurchaseCanceled NUMBER(5) default 0,
    CHECK (PurchaseCanceled in (0,1)),
  SpecialPurchaseTypeCode VARCHAR2(10),
  SpecialPurchaseTypeName VARCHAR2(2000)
)
/
ALTER TRIGGER TR_OOS_C_F_BU_500 ENABLE
/
COMMIT WORK 
/


ALTER TABLE OOS_CONTRACT_FINANCES MODIFY(PurchaseCanceled NOT NULL)
/

-- #########################################################
-- #########################################################
-- Insert_Interface_Browser.sql
-- #########################################################
-- #########################################################

insert into INTERFACES(GUID,NOTE,PARAM) values ('{D58C51A5-7579-4EE5-B6F7-C10647A67099}','','https://www.krista.ru/') 
/
COMMIT WORK 
/


-- #########################################################
-- #########################################################
-- Alter_tr_OOS_C_F_BI.sql
-- #########################################################
-- #########################################################

/*     BOOL   oos_contract_finances   */
-- CREATE TRIGGER OOS_C_F_BI_100
CREATE OR REPLACE TRIGGER TR_OOS_CONTRACT_FINANCES_BI
  BEFORE INSERT
  ON OOS_CONTRACT_FINANCES
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (OOS_C_F_BI0)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (OOS_C_F_BI_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.PurchaseCanceled is null) then 
    :new.PurchaseCanceled := 0;
  END IF;
  if (:new.IsBudgetary is null) then 
    :new.IsBudgetary := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_OOS_C_F_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
commit work
/



-- #########################################################
-- #########################################################
-- alter_DocBase_Expand_Num.sql
-- #########################################################
-- #########################################################

/*   " "      " "     150  */
ALTER TRIGGER TR_DOCBASE_BU_500 DISABLE
/
ALTER TABLE DocBase ADD (
  TempDocumentBaseNum VARCHAR2(150)
)
/
commit work 
/
update DocBase set
  TempDocumentBaseNum = DocumentBaseNum
/
ALTER TABLE DocBase DROP (DocumentBaseNum)
/
commit work 
/
ALTER TABLE DocBase ADD (
  DocumentBaseNum VARCHAR2(150)
)
/
commit work 
/
update DocBase set
  DocumentBaseNum = TempDocumentBaseNum
/
ALTER TABLE DocBase DROP (TempDocumentBaseNum)
/
ALTER TRIGGER TR_DOCBASE_BU_500 ENABLE
/
commit work
/
ALTER TRIGGER TR_SUBSIDYCLS_BU_500 DISABLE
/
ALTER TABLE SubsidyCls ADD (
  TempNPANumber VARCHAR2(150)
)
/
commit work 
/
update SubsidyCls set
  TempNPANumber = NPANumber
/
ALTER TABLE SubsidyCls DROP (NPANumber)
/
commit work 
/
ALTER TABLE SubsidyCls ADD (
  NPANumber VARCHAR2(150)
)
/
commit work 
/
update SubsidyCls set
  NPANumber = TempNPANumber
/
ALTER TABLE SubsidyCls DROP (TempNPANumber)
/
ALTER TRIGGER TR_SUBSIDYCLS_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_BudNotify_Extend_DocNumber.sql
-- #########################################################
-- #########################################################

/* 
     " "  150   e BUDNOTIFY

*/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 DISABLE
/
ALTER TABLE TB_BUDNOTIFY ADD (
  Doc_Number VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ANUMBER,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  DOCNUMBER,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOC_NUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    DOCNUMBER,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Create 18.09.2006
-- - - - - - - - - - - - -

  IF (NEW$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19, UseFax$);
    IF ((NEW$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      NEW$BidNumber := NEW$ANumber;
    end if;
    NEW$FaxDocCount := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    DOCNUMBER,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$DOCNUMBER,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOC_NUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ANUMBER = new$ANUMBER,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    DOCNUMBER = new$DOCNUMBER,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOC_NUMBER = new$DOC_NUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
update BUDNOTIFY set
  Doc_Number = DOCNUMBER 
/
ALTER TABLE TB_BUDNOTIFY DROP (DOCNUMBER)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ANUMBER,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOC_NUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Create 18.09.2006
-- - - - - - - - - - - - -

  IF (NEW$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19, UseFax$);
    IF ((NEW$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      NEW$BidNumber := NEW$ANumber;
    end if;
    NEW$FaxDocCount := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOC_NUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ANUMBER = new$ANUMBER,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOC_NUMBER = new$DOC_NUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
ALTER TABLE TB_BUDNOTIFY ADD (
  DOCNUMBER VARCHAR2(150)
)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ANUMBER,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOC_NUMBER,
  DOCNUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER,
    DOCNUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Create 18.09.2006
-- - - - - - - - - - - - -

  IF (NEW$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19, UseFax$);
    IF ((NEW$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      NEW$BidNumber := NEW$ANumber;
    end if;
    NEW$FaxDocCount := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOC_NUMBER,
    DOCNUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOC_NUMBER,
    new$DOCNUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOC_NUMBER BUDNOTIFY.DOC_NUMBER%TYPE := :NEW.DOC_NUMBER;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ANUMBER = new$ANUMBER,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOC_NUMBER = new$DOC_NUMBER,
    DOCNUMBER = new$DOCNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
update BUDNOTIFY set
  DOCNUMBER = Doc_Number 
/
ALTER TABLE TB_BUDNOTIFY DROP (Doc_Number)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ANUMBER,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Create 18.09.2006
-- - - - - - - - - - - - -

  IF (NEW$SenderID IS NOT NULL) THEN
    /*        */
    GetIntConst(30, 19, UseFax$);
    IF ((NEW$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      NEW$BidNumber := NEW$ANumber;
    end if;
    NEW$FaxDocCount := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ANUMBER = new$ANUMBER,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 ENABLE
/
commit work 
/


-- #########################################################
-- #########################################################
-- Alter_KESR_Add_Code.sql
-- #########################################################
-- #########################################################

/* 
1.   CODE, BUDGETREF  KESR,    . 
2.   CODE, BUDGETREF  KESRSubCode,    .
3.    KESR, SubKESR      .
4.   / - KESR   .
*/
/* KESR */
-- drop trigger TR_KESR_BI_0
CREATE OR REPLACE TRIGGER TR_KESR_BI
  BEFORE INSERT
  ON KESR
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_500 (TR_KESR_BI_500)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.CreaterUser := user;
  :new.UpdateDate := :new.CreateDate;
  :new.UpdaterUser := user;

END;
/
ALTER TRIGGER TR_KESR_BU_500 DISABLE
/
ALTER TABLE KESR ADD (
  TempCONTROLCODE VARCHAR2(20)
)
/
commit work
/
update KESR set
  TempCONTROLCODE = CONTROLCODE
/
commit work
/
ALTER TABLE KESR DROP (CONTROLCODE)
/
commit work
/
ALTER TABLE KESR ADD (
  CODE VARCHAR2(20),/*  */
  BudgetRef NUMBER(10),/*  */
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648)),
  CONTROLCODE VARCHAR2(20)/*     */
)
/
commit work
/
update KESR set
  CODE = Id,
  BudgetRef = 0,
  CONTROLCODE = TempCONTROLCODE
/
commit work
/
ALTER TABLE KESR ADD (
  CONSTRAINT FK_KESR_BUDGETREF FOREIGN KEY (BUDGETREF) REFERENCES TB_BUDGETS_S (ID),
  CONSTRAINT UQ_KESR_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/
CREATE INDEX FK_KESR_BUDGETREF ON KESR(BUDGETREF)
/
-- CREATE TRIGGER TR_KESR_BI_0
CREATE OR REPLACE TRIGGER TR_KESR_BI
  BEFORE INSERT
  ON KESR
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KESR_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.IsEKR is null) then 
    :new.IsEKR := 0;
  END IF;
  if (:new.IsEKD is null) then 
    :new.IsEKD := 0;
  END IF;
  if (:new.IsEKI is null) then 
    :new.IsEKI := 0;
  END IF;
  if (:new.controlcode is null) then 
    :new.controlcode := :new.Code;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KESR_BI_500)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.CreaterUser := user;
  :new.UpdateDate := :new.CreateDate;
  :new.UpdaterUser := user;

END;
/
-- ALTER TRIGGER TR_KESR_BU_0
CREATE OR REPLACE TRIGGER TR_KESR_BU
  BEFORE UPDATE
  ON KESR
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KESR_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.IsEKR is null) then 
    :new.IsEKR := 0;
  END IF;
  if (:new.IsEKD is null) then 
    :new.IsEKD := 0;
  END IF;
  if (:new.IsEKI is null) then 
    :new.IsEKI := 0;
  END IF;

END;
/
commit work 
/
ALTER TABLE KESR DROP (TempCONTROLCODE)
/
ALTER TABLE KESR DROP (CODE1)
/
ALTER TABLE KESR DROP (CODE2)
/
ALTER TABLE KESR DROP (CODE3)
/
drop procedure KESRUP
/
drop procedure KESRDIV
/
update KESR set
  code='00' || code
where
  code like '_'
/
update KESR set
  code='0' || code
where
  code like '__'
/
update KESR set
  CONTROLCODE='00' || CONTROLCODE
where
  CONTROLCODE like '_'
/
update KESR set
  CONTROLCODE='0' || CONTROLCODE
where
  CONTROLCODE like '__'
/
commit work 
/
ALTER TRIGGER TR_KESR_BU_500 ENABLE
/
commit work 
/
ALTER TRIGGER TR_KESRSUBCODE_BU_500 DISABLE
/
commit work
/
ALTER TABLE KESRSUBCODE ADD (
  CODE VARCHAR2(20),/*  */
  BudgetRef NUMBER(10)/*  */,
    CHECK((BudgetRef<=2147483647)AND(BudgetRef>-2147483648))
)
/
commit work
/
update KESRSUBCODE set
  CODE = Id,
  BudgetRef = 0
/
commit work
/
ALTER TABLE KESRSUBCODE ADD (
  CONSTRAINT FK_KESRSUBCODE_BUDGETREF FOREIGN KEY (BUDGETREF) REFERENCES TB_BUDGETS_S (ID),
  CONSTRAINT UQ_KESRSUBCODE_VER_KEY UNIQUE (CODE, BUDGETREF, EXTID)
)
/
CREATE INDEX FK_KESRSUBCODE_BUDGETREF ON KESRSUBCODE(BUDGETREF)
/
-- CREATE TRIGGER TR_KESRSUBCODE_BI_0
CREATE OR REPLACE TRIGGER TR_KESRSUBCODE_BI
  BEFORE INSERT
  ON KESRSUBCODE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KESRSUBCODE_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KESRSUBCODE_BI_500)
-- - - - - - - - - - - - -

  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;

END;
/
-- CREATE TRIGGER TR_KESRSUBCODE_BU_0
CREATE OR REPLACE TRIGGER TR_KESRSUBCODE_BU
  BEFORE UPDATE
  ON KESRSUBCODE
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KESRSUBCODE_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.Code is null) then
    RaiseException('ex_WrongClsEmpty');
  END IF;
  if (:new.BudgetRef is null) then 
    :new.BudgetRef := 0;
  END IF;
  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;

END;
/
commit work 
/
update KESRSUBCODE set
  code='000000' || code
where
  code like '_'
/
update KESRSUBCODE set
  code='00000' || code
where
  code like '__'
/
update KESRSUBCODE set
  code='0000' || code
where
  code like '___'
/
update KESRSUBCODE set
  code='000' || code
where
  code like '____'
/
update KESRSUBCODE set
  code='00' || code
where
  code like '_____'
/
update KESRSUBCODE set
  code='0' || code
where
  code like '______'
/
ALTER TRIGGER TR_KESRSUBCODE_BU_500 ENABLE
/
commit work 
/
/* BudStructRights */
-- drop trigger TR_BUDSTRUCTRIGHTS_BI_0
CREATE OR REPLACE TRIGGER TR_BUDSTRUCTRIGHTS_BI
  BEFORE INSERT
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCTRIGHTS_BI_500)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- drop trigger TR_BUDSTRUCTRIGHTS_BU_0
DROP TRIGGER TR_BUDSTRUCTRIGHTS_BU
/
ALTER TRIGGER TR_BUDSTRUCTRIGHTS_BU_500 DISABLE
/
ALTER TABLE BudStructRights ADD (
  TempKESR VARCHAR2(20),
  TempKESRUp VARCHAR2(20),
  TempSubKESR VARCHAR2(20),
  TempSubKESRUp VARCHAR2(20)
)
/
commit work 
/
update BudStructRights set
  TempKESR = KESR,
  TempKESRUp = KESRup,
  TempSubKESR = SubKESR,
  TempSubKESRUp = SubKESRUp
/
  
commit work 
/
ALTER TABLE BudStructRights DROP (KESR)
/
ALTER TABLE BudStructRights DROP (KESRUp)
/
ALTER TABLE BudStructRights DROP (SubKESR)
/
ALTER TABLE BudStructRights DROP (SubKESRUp)
/
commit work 
/
ALTER TABLE BudStructRights ADD (
  KESR VARCHAR2(20),
  KESRUp VARCHAR2(20),
  SubKESR VARCHAR2(20),
  SubKESRUp VARCHAR2(20)
)
/
commit work 
/
update BudStructRights set
  KESR = TempKESR,
  KESRUp = TempKESRup,
  SubKESR = TempSubKESR,
  SubKESRUp = TempSubKESRUp
/
  
commit work 
/
ALTER TABLE BudStructRights DROP (TempKESR)
/
ALTER TABLE BudStructRights DROP (TempKESRUp)
/
ALTER TABLE BudStructRights DROP (TempSubKESR)
/
ALTER TABLE BudStructRights DROP (TempSubKESRUp)
/
commit work 
/
update BudStructRights set
  KESR='00' || KESR
where
  KESR like '_'
/
update BudStructRights set
  KESR='0' || KESR
where
  KESR like '__'
/
update BudStructRights set
  KESRUp='00' || KESRUp
where
  KESRUp like '_'
/
update BudStructRights set
  KESRUp='0' || KESRUp
where
  KESRUp like '__'
/
update BudStructRights set
  KESRUp=''
where
  KESRUp='999'
/
update BudStructRights set
  SubKESR='000000' || SubKESR
where
  SubKESR like '_'
/
update BudStructRights set
  SubKESR='00000' || SubKESR
where
  SubKESR like '__'
/
update BudStructRights set
  SubKESR='0000' || SubKESR
where
  SubKESR like '___'
/
update BudStructRights set
  SubKESR='000' || SubKESR
where
  SubKESR like '____'
/
update BudStructRights set
  SubKESR='00' || SubKESR
where
  SubKESR like '_____'
/
update BudStructRights set
  SubKESR='0' || SubKESR
where
  SubKESR like '______'
/
update BudStructRights set
  SubKESRUp='000000' || SubKESRUp
where
  SubKESRUp like '_'
/
update BudStructRights set
  SubKESRUp='00000' || SubKESRUp
where
  SubKESRUp like '__'
/
update BudStructRights set
  SubKESRUp='0000' || SubKESRUp
where
  SubKESRUp like '___'
/
update BudStructRights set
  SubKESRUp='000' || SubKESRUp
where
  SubKESRUp like '____'
/
update BudStructRights set
  SubKESRUp='00' || SubKESRUp
where
  SubKESRUp like '_____'
/
update BudStructRights set
  SubKESRUp='0' || SubKESRUp
where
  SubKESRUp like '______'
/
update BudStructRights set
  SubKESRUp=''
where
  SubKESRUp='9999999'
/
commit work 
/
-- CREATE TRIGGER TR_BUDSTRUCTRIGHTS_BI_0
CREATE OR REPLACE TRIGGER TR_BUDSTRUCTRIGHTS_BI
  BEFORE INSERT
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCTRIGHTS_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID is null) then 
    select g_shared.nextval into :new.ID from dual;
  END IF;
  if (:new.RightRef is null) then 
    :new.RightRef := 4;
  END IF;
  if (:new.IsGroup is null) then 
    :new.IsGroup := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if ((:new.KCSR is null) or (:new.KCSR  is null)) then 
    :new.KCSR := '0';
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if ((:new.KVR is null) or (:new.KVR  is null)) then 
    :new.KVR := '0';
  END IF;
  if ((:new.KESR is null) or (:new.KESR  is null)) then 
    :new.KESR := '0';
  END IF;
  if ((:new.SubKESR is null) or (:new.SubKESR  is null)) then 
    :new.SubKESR := '0';
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if ((:new.DirectionCls is null) or (:new.DirectionCls  is null)) then 
    :new.DirectionCls := '0';
  END IF;
  if ((:new.Fact is null) or (:new.Fact  is null)) then 
    :new.Fact := '0';
  END IF;
  if ((:new.FinType is null) or (:new.FinType  is null)) then 
    :new.FinType := '0';
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.TransfertCls is null) then 
    :new.TransfertCls := 0;
  END IF;
  if ((:new.BudAllocationCls is null) or (:new.BudAllocationCls  is null)) then 
    :new.BudAllocationCls := '0';
  END IF;
  if ((:new.PayPromiseCls is null) or (:new.PayPromiseCls  is null)) then 
    :new.PayPromiseCls := '0';
  END IF;
  if ((:new.SubsidyCls is null) or (:new.SubsidyCls  is null)) then 
    :new.SubsidyCls := '0';
  END IF;
  if (:new.AssignmentKind is null) then 
    :new.AssignmentKind := 0;
  END IF;
  if (:new.KfsrUP is null) then 
    :new.KFSRUp := :new.KFSR;
  END IF;
  if (:new.KVSRUP is null) then 
    :new.KVSRUP := :new.KVSR;
  END IF;
  if (:new.KCSRUP is null) then 
    :new.KCSRUP := :new.KCSR;
  END IF;
  if (:new.KVRUP is null) then 
    :new.KVRUP := :new.KVR;
  END IF;
  if (:new.KesrUP is null) then 
    :new.KesrUP := :new.Kesr;
  END IF;
  if (:new.SubKESRUP is null) then 
    :new.SubKESRUP := :new.SubKESR;
  END IF;
  if (:new.RegionClsUP is null) then 
    :new.RegionClsUP := :new.RegionCls;
  END IF;
  if ((:new.DirectionClsUp is null) or (:new.DirectionClsUp  is null)) then 
    :new.DirectionClsUp := :new.DirectionCls;
  END IF;
  if ((:new.FactUP is null) or (:new.FactUP is null)) then 
    :new.FactUP := :new.Fact;
  END IF;
  if ((:new.FinTypeUP is null) or (:new.FinTypeUP is null)) then 
    :new.FinTypeUP := :new.FinType;
  END IF;
  if (:new.MeansTypeUP is null) then 
    :new.MeansTypeUP := :new.MeansType;
  END IF;
  if (:new.TransfertClsUp is null) then 
    :new.TransfertClsUp := :new.TransfertCls;
  END IF;
  if ((:new.BudAllocationClsUp is null) or (:new.BudAllocationClsUp  is null)) then 
    :new.BudAllocationClsUp := :new.BudAllocationCls;
  END IF;
  if ((:new.PayPromiseClsUp is null) or (:new.PayPromiseClsUp  is null)) then 
    :new.PayPromiseClsUp := :new.PayPromiseCls;
  END IF;
  if ((:new.SubsidyClsUp is null) or (:new.SubsidyClsUp  is null)) then 
    :new.SubsidyClsUp := :new.SubsidyCls;
  END IF;
  if (:new.AssignmentKindUP is null) then 
    :new.AssignmentKindUP := :new.AssignmentKind;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCTRIGHTS_BI_500)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_BUDSTRUCTRIGHTS_BU_0
CREATE OR REPLACE TRIGGER TR_BUDSTRUCTRIGHTS_BU
  BEFORE UPDATE
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCTRIGHTS_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RightRef is null) then 
    :new.RightRef := 4;
  END IF;
  if (:new.IsGroup is null) then 
    :new.IsGroup := 0;
  END IF;
  if (:new.KVSR is null) then 
    :new.KVSR := 0;
  END IF;
  if ((:new.KCSR is null) or (:new.KCSR  is null)) then 
    :new.KCSR := '0';
  END IF;
  if (:new.KFSR is null) then 
    :new.KFSR := 0;
  END IF;
  if ((:new.KVR is null) or (:new.KVR  is null)) then 
    :new.KVR := '0';
  END IF;
  if ((:new.KESR is null) or (:new.KESR  is null)) then 
    :new.KESR := '0';
  END IF;
  if ((:new.SubKESR is null) or (:new.SubKESR  is null)) then 
    :new.SubKESR := '0';
  END IF;
  if (:new.RegionCls is null) then 
    :new.RegionCls := 0;
  END IF;
  if ((:new.DirectionCls is null) or (:new.DirectionCls  is null)) then 
    :new.DirectionCls := '0';
  END IF;
  if ((:new.Fact is null) or (:new.Fact  is null)) then 
    :new.Fact := '0';
  END IF;
  if ((:new.FinType is null) or (:new.FinType  is null)) then 
    :new.FinType := '0';
  END IF;
  if (:new.MeansType is null) then 
    :new.MeansType := 0;
  END IF;
  if (:new.TransfertCls is null) then 
    :new.TransfertCls := 0;
  END IF;
  if ((:new.BudAllocationCls is null) or (:new.BudAllocationCls  is null)) then 
    :new.BudAllocationCls := '0';
  END IF;
  if ((:new.PayPromiseCls is null) or (:new.PayPromiseCls  is null)) then 
    :new.PayPromiseCls := '0';
  END IF;
  if ((:new.SubsidyCls is null) or (:new.SubsidyCls  is null)) then 
    :new.SubsidyCls := '0';
  END IF;
  if (:new.AssignmentKind is null) then 
    :new.AssignmentKind := 0;
  END IF;
  if (:new.KfsrUP is null) then 
    :new.KFSRUp := :new.KFSR;
  END IF;
  if (:new.KVSRUP is null) then 
    :new.KVSRUP := :new.KVSR;
  END IF;
  if (:new.KCSRUP is null) then 
    :new.KCSRUP := :new.KCSR;
  END IF;
  if (:new.KVRUP is null) then 
    :new.KVRUP := :new.KVR;
  END IF;
  if (:new.KesrUP is null) then 
    :new.KesrUP := :new.Kesr;
  END IF;
  if (:new.SubKESRUP is null) then 
    :new.SubKESRUP := :new.SubKESR;
  END IF;
  if (:new.RegionClsUP is null) then 
    :new.RegionClsUP := :new.RegionCls;
  END IF;
  if ((:new.DirectionClsUp is null) or (:new.DirectionClsUp  is null)) then 
    :new.DirectionClsUp := :new.DirectionCls;
  END IF;
  if ((:new.FactUP is null) or (:new.FactUP is null)) then 
    :new.FactUP := :new.Fact;
  END IF;
  if ((:new.FinTypeUP is null) or (:new.FinTypeUP is null)) then 
    :new.FinTypeUP := :new.FinType;
  END IF;
  if (:new.MeansTypeUP is null) then 
    :new.MeansTypeUP := :new.MeansType;
  END IF;
  if (:new.TransfertClsUp is null) then 
    :new.TransfertClsUp := :new.TransfertCls;
  END IF;
  if ((:new.BudAllocationClsUp is null) or (:new.BudAllocationClsUp  is null)) then 
    :new.BudAllocationClsUp := :new.BudAllocationCls;
  END IF;
  if ((:new.PayPromiseClsUp is null) or (:new.PayPromiseClsUp  is null)) then 
    :new.PayPromiseClsUp := :new.PayPromiseCls;
  END IF;
  if ((:new.SubsidyClsUp is null) or (:new.SubsidyClsUp  is null)) then 
    :new.SubsidyClsUp := :new.SubsidyCls;
  END IF;
  if (:new.AssignmentKindUP is null) then 
    :new.AssignmentKindUP := :new.AssignmentKind;
  END IF;

END;
/
ALTER TRIGGER TR_BUDSTRUCTRIGHTS_BU_500 ENABLE
/
commit work 
/
-- ALTER TRIGGER tr_kd_bi_0
CREATE OR REPLACE TRIGGER TR_KD_II
  INSTEAD OF INSERT
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vKDLevel$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_KD_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    BEGIN
      select id into new$KESR from KESR where (CODE = sAnalyticalGroupKD1$) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$KESR is null) then
      new$KESR := 0;
        
    END IF;
  END IF;
  /*      */    
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and (new$kdvalue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_KD_BI_500)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_KD (
    ID,
    REPCODE,
    CREATEDATE,
    UPDATEDATE,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    KDVALUE,
    REMOTEFLAG,
    UNIONFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    KD_LEVEL,
    STARTDATE,
    SHORTNAME,
    CREATERUSER,
    UPDATERUSER,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPKD
  ) VALUES (
    new$ID,
    new$REPCODE,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$KDVALUE,
    new$REMOTEFLAG,
    new$UNIONFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$KD_LEVEL,
    new$STARTDATE,
    new$SHORTNAME,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPKD);

-- - - - - - - - - - - - -
-- AI_100 (TR_KD_AI_100)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    if (not (CNT$1<> 0))
    then
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);

    END IF;
  else
    /*   = 0,         ,     */
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vKDLevel$ := new$KD_Level;
    vDeleteDate$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName$, vShortName$, vKDLevel$, vDeleteDate$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update kd kd1 set
    name = vName$,
    ShortName = vShortName$,
    kd_level = vKDLevel$,
    deletedate = vDeleteDate$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_KD_AI_500)
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 80)  and (RecordID = new$ID);

END;
/
-- ALTER TRIGGER TR_KD_BU_0
CREATE OR REPLACE TRIGGER TR_KD_IU
  INSTEAD OF UPDATE
  ON KD
  FOR EACH ROW
DECLARE
  new$ID KD.ID%TYPE := :NEW.ID;
  new$REPCODE KD.REPCODE%TYPE := :NEW.REPCODE;
  new$CREATEDATE KD.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE KD.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$KVSR KD.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE KD.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE KD.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE KD.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE KD.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR KD.KESR%TYPE := :NEW.KESR;
  new$KDVALUE KD.KDVALUE%TYPE := :NEW.KDVALUE;
  new$REMOTEFLAG KD.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$UNIONFLAG KD.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$BUDGETREF KD.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE KD.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME KD.NAME%TYPE := :NEW.NAME;
  new$KD_LEVEL KD.KD_LEVEL%TYPE := :NEW.KD_LEVEL;
  new$STARTDATE KD.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME KD.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CREATERUSER KD.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER KD.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$EXTID KD.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER KD.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE KD.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID KD.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION KD.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE KD.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPKD KD.ANALYTICALGROUPKD%TYPE := :NEW.ANALYTICALGROUPKD;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vKDLevel$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(5);
  sDescrCode21$ VARCHAR2(5);
  sProgCode1$ VARCHAR2(4);
  sAnalyticalGroupKD1$ VARCHAR2(3);
  sKDLevel1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_KD_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*     */
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupKD is null) then 
    new$AnalyticalGroupKD := 0;
  END IF;
  if (new$ProgramCode is null) then 
    new$ProgramCode := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR <> 0) then
    select max(kd_level) into sKDLevel1$ from KD where ((AnalyticalGroupKD = new$AnalyticalGroupKD) and (ProgramCode=new$ProgramCode)and (BudgetRef=new$BudgetRef)
    and (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0))  ;
  END IF;
  if (sKDLevel1$ is not null) then
    new$kd_Level := sKDLevel1$;
  END IF;
  /*          */
    
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100;
  new$MainDescriptionCode := tmp_Double1$;
  if (new$MainDescriptionCode > tmp_Double1$) then 
    new$MainDescriptionCode := new$MainDescriptionCode - 1;
  END IF;
  tmp_Double1$ := new$MainDescriptionCode;
  tmp_Double1$ := tmp_Double1$ * 100;
  new$ItemCode := tmp$ - tmp_Double1$; 
  BEGIN

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-   */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*       */    
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 100000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 100000;
  DescrCode21$ := tmp_Double1$;
      
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '00000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '0000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '00' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '0' || DescrCode11$;
                
          else
            sDescrCode11$ := DescrCode11$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '00000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '0000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '00' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '0' || DescrCode21$;
                
          else
            sDescrCode21$ := DescrCode21$;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
      
  /*      */
  if (new$programcode = 0) then
    sProgCode1$ := '0000';
        
  else
    if (new$programcode < 10) then
      sProgCode1$ := '000' || new$programcode;
          
    else
      if (new$programcode < 100) then
        sProgCode1$ := '00' || new$programcode;
            
      else
        if (new$programcode < 1000) then
          sProgCode1$ := '0' || new$programcode;
              
        else
          sProgCode1$ := new$programcode;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupKD1$ from AnalyticalGroupKD where (ID = new$AnalyticalGroupKD) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    BEGIN
      select id into new$KESR from KESR where (CODE = sAnalyticalGroupKD1$) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$KESR is null) then
      new$KESR := 0;
        
    END IF;
  END IF;
  /*      */    
      
  new$kdvalue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sProgCode1$ || sAnalyticalGroupKD1$;
      
  if ((new$ID = 0) and (new$kdvalue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroKD');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_KD SET
    ID = new$ID,
    REPCODE = new$REPCODE,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    KDVALUE = new$KDVALUE,
    REMOTEFLAG = new$REMOTEFLAG,
    UNIONFLAG = new$UNIONFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    KD_LEVEL = new$KD_LEVEL,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPKD = new$ANALYTICALGROUPKD
  WHERE id = :old.id;

-- - - - - - - - - - - - -
-- AU_100 (TR_KD_AU_100)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from kd kd1
    where ((kd1.kvsr = 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then
      insert into KD (KVSR, DescriptionCode, ProgramCode, AnalyticalGroupKD, Name, ShortName, RemoteFlag, kd_level, budgetref, extid)
      values (0, new$DescriptionCode, new$ProgramCode, new$AnalyticalGroupKD, new$Name, new$ShortName, new$RemoteFlag, new$kd_level, new$budgetref, new$extid);

    END IF;
  else
    /*   = 0,         ,     */
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vKDLevel$ := new$KD_Level;
    vDeleteDate$ := new$DeleteDate;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from kd kd1
      where ((kd1.kvsr = 0) and
      ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
      (kd1.programcode = new$programcode) and
      (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select kd2.Name, kd2.ShortName, kd2.KD_Level, kd2.DeleteDate                 into
          vName$, vShortName$, vKDLevel$, vDeleteDate$ from kd kd2
          where kd2.id = (select max(id) from kd kd1
          where (kd1.kvsr = 0) and
          ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
          (kd1.programcode = new$programcode) and
          (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and (kd1.BudgetRef = new$BudgetRef) and ((kd1.DeleteDate is null) or (kd1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
      END IF;
    END IF;
    update kd kd1 set
    name = vName$,
    ShortName = vShortName$,
    kd_level = vKDLevel$,
    deletedate = vDeleteDate$

    where
    (kd1.kvsr <> 0) and
    ((kd1.descriptioncode-new$descriptioncode>-1) and (kd1.descriptioncode-new$descriptioncode<1)) and
    (kd1.programcode = new$programcode) and
    (kd1.AnalyticalGroupKD = new$AnalyticalGroupKD) and
    (kd1.BudgetRef = new$BudgetRef);

  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_KD_AU_500)
-- Create 28.04.2005
-- Last update 14.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (80, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=80) and (RecordId=new$ID);
  end if;

END;
/
-- ALTER TRIGGER tr_innerfinsource_bi_0
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_II
  INSTEAD OF INSERT
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel$ NUMBER(10);
  sDirection$ NUMBER(10);
  AGIFS1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_INNERFINSOURCE_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction)
    into sIFSLevel$, sDirection$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel$ is not null) then
    new$IFS_Level := sIFSLevel$;
  END IF;
  if (sDirection$ is not null) then
    new$Direction := sDirection$;
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((new$AnalyticalGroupIFS between 300 and 399) or 
    (new$AnalyticalGroupIFS between 500 and 599) or 
    (new$AnalyticalGroupIFS between 800 and 899)) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (new$AnalyticalGroupIFS = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (new$AnalyticalGroupIFS = AGIFS1$) then
      new$Direction := -1;  
      
    END IF;
  END IF;
  BEGIN
      

    /*      */ 
    select Code into KVSRCode$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode$ < 10) then
      sKVSR1$ := '00' || KVSRCode$;
          
    else
      if (KVSRCode$ < 100) then
        sKVSR1$ := '0' || KVSRCode$;
            
      else
        sKVSR1$ := KVSRCode$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
          ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */    
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */
      
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
                
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                  
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                    
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
                
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                  
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                    
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    BEGIN
      select id into new$KESR from KESR where (CODE = sAnalyticalGroupIFS1$) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$KESR is null) then
      new$KESR := 0;
        
    END IF;
  END IF;
  /*      */
      
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
      
  if ((new$ID = 0) and (new$FinSourceValue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_INNERFINSOURCE_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_INNERFINSOURCE (
    ID,
    CREATEDATE,
    UPDATEDATE,
    DIRECTION,
    KVSR,
    DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE,
    ITEMCODE,
    PROGRAMCODE,
    KESR,
    FINSOURCEVALUE,
    UNIONFLAG,
    REMOTEFLAG,
    BUDGETREF,
    DELETEDATE,
    NAME,
    STARTDATE,
    SHORTNAME,
    CLSASPECT,
    CREATERUSER,
    UPDATERUSER,
    IFS_LEVEL,
    EXTID,
    EXTOWNER,
    EXTSYNCDATE,
    EXTROOTID,
    EXTVERSION,
    EXTVERSIONDATE,
    ANALYTICALGROUPIFS
  ) VALUES (
    new$ID,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$DIRECTION,
    new$KVSR,
    new$DESCRIPTIONCODE,
    new$MAINDESCRIPTIONCODE,
    new$ITEMCODE,
    new$PROGRAMCODE,
    new$KESR,
    new$FINSOURCEVALUE,
    new$UNIONFLAG,
    new$REMOTEFLAG,
    new$BUDGETREF,
    new$DELETEDATE,
    new$NAME,
    new$STARTDATE,
    new$SHORTNAME,
    new$CLSASPECT,
    new$CREATERUSER,
    new$UPDATERUSER,
    new$IFS_LEVEL,
    new$EXTID,
    new$EXTOWNER,
    new$EXTSYNCDATE,
    new$EXTROOTID,
    new$EXTVERSION,
    new$EXTVERSIONDATE,
    new$ANALYTICALGROUPIFS);

-- - - - - - - - - - - - -
-- AI_100 (TR_INNERFINSOURCE_AI_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);
      
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_INNERFINSOURCE_AI_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 145) and (RecordId = new$ID);

END;
/
-- ALTER TRIGGER tr_innerfinsource_bu_0
CREATE OR REPLACE TRIGGER TR_INNERFINSOURCE_IU
  INSTEAD OF UPDATE
  ON INNERFINSOURCE
  FOR EACH ROW
DECLARE
  new$ID INNERFINSOURCE.ID%TYPE := :NEW.ID;
  new$CREATEDATE INNERFINSOURCE.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE INNERFINSOURCE.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$DIRECTION INNERFINSOURCE.DIRECTION%TYPE := :NEW.DIRECTION;
  new$KVSR INNERFINSOURCE.KVSR%TYPE := :NEW.KVSR;
  new$DESCRIPTIONCODE INNERFINSOURCE.DESCRIPTIONCODE%TYPE := :NEW.DESCRIPTIONCODE;
  new$MAINDESCRIPTIONCODE INNERFINSOURCE.MAINDESCRIPTIONCODE%TYPE := :NEW.MAINDESCRIPTIONCODE;
  new$ITEMCODE INNERFINSOURCE.ITEMCODE%TYPE := :NEW.ITEMCODE;
  new$PROGRAMCODE INNERFINSOURCE.PROGRAMCODE%TYPE := :NEW.PROGRAMCODE;
  new$KESR INNERFINSOURCE.KESR%TYPE := :NEW.KESR;
  new$FINSOURCEVALUE INNERFINSOURCE.FINSOURCEVALUE%TYPE := :NEW.FINSOURCEVALUE;
  new$UNIONFLAG INNERFINSOURCE.UNIONFLAG%TYPE := :NEW.UNIONFLAG;
  new$REMOTEFLAG INNERFINSOURCE.REMOTEFLAG%TYPE := :NEW.REMOTEFLAG;
  new$BUDGETREF INNERFINSOURCE.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DELETEDATE INNERFINSOURCE.DELETEDATE%TYPE := :NEW.DELETEDATE;
  new$NAME INNERFINSOURCE.NAME%TYPE := :NEW.NAME;
  new$STARTDATE INNERFINSOURCE.STARTDATE%TYPE := :NEW.STARTDATE;
  new$SHORTNAME INNERFINSOURCE.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$CLSASPECT INNERFINSOURCE.CLSASPECT%TYPE := :NEW.CLSASPECT;
  new$CREATERUSER INNERFINSOURCE.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATERUSER INNERFINSOURCE.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$IFS_LEVEL INNERFINSOURCE.IFS_LEVEL%TYPE := :NEW.IFS_LEVEL;
  new$EXTID INNERFINSOURCE.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER INNERFINSOURCE.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE INNERFINSOURCE.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$EXTROOTID INNERFINSOURCE.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION INNERFINSOURCE.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE INNERFINSOURCE.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$ANALYTICALGROUPIFS INNERFINSOURCE.ANALYTICALGROUPIFS%TYPE := :NEW.ANALYTICALGROUPIFS;
--
  tmp$ NUMBER(15,0);
  CNT$1 NUMBER(10);
  vName$ VARCHAR2(1024);
  vShortName$ VARCHAR2(1024);
  vIFSLevel$ NUMBER(10);
  vDirection$ NUMBER(10);
  vDeleteDate$ DATE;
  CNT$2 NUMBER(10);
  tmp_Double1$ NUMBER;
  DescrCode11$ NUMBER(10);
  DescrCode21$ NUMBER(10);
  KVSRCode1$ NUMBER(10);
  sKVSR1$ VARCHAR2(3);
  sDescrCode11$ VARCHAR2(7);
  sDescrCode21$ VARCHAR2(7);
  sAnalyticalGroupIFS1$ VARCHAR2(3);
  sIFSLevel1$ NUMBER(10);
  sDirection1$ NUMBER(10);
  AGIFS1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_INNERFINSOURCE_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*  Id,     */
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$KVSR is null) then 
    new$KVSR := 0;
  END IF;
  if (new$AnalyticalGroupIFS is null) then 
    new$AnalyticalGroupIFS := 0;
  END IF;
  if (new$ClsAspect is null) then 
    new$ClsAspect := 0;
  END IF;
  if (new$UnionFlag is null) then 
    new$UnionFlag := 0;
  END IF;
  if (new$RemoteFlag is null) then 
    new$RemoteFlag := 0;
  END IF;
  if (new$BudgetRef is null) then 
    new$BudgetRef := 0;
  END IF;
  /*     */
  if (new$KVSR <> 0) then
    select max(IFS_Level), max(Direction) 
    into sIFSLevel1$, sDirection1$     from innerfinsource 
    where ((AnalyticalGroupIFS = new$AnalyticalGroupIFS) and (BudgetRef=new$BudgetRef) and 
    (DESCRIPTIONCODE = new$DESCRIPTIONCODE) and (KVSR = 0)) 
    ;
  END IF;
  if (sIFSLevel1$ is not null) then
    new$IFS_Level := sIFSLevel1$;
  END IF;
  if (sDirection1$ is not null) then
    new$Direction := sDirection1$;
  END IF;
  /*         
            =3,5,8 */
  if (new$Direction is null) then
    if ((new$AnalyticalGroupIFS between 300 and 399) or 
    (new$AnalyticalGroupIFS between 500 and 599) or 
    (new$AnalyticalGroupIFS between 800 and 899)) then
      new$Direction := -1;
          
    else
      new$Direction := 1;
    END IF;
    GetIntConst(60, 9,AGIFS1$);
    if (new$AnalyticalGroupIFS = AGIFS1$) then
      new$Direction := 1;
    END IF;
    GetIntConst(60, 10,AGIFS1$);
    if (new$AnalyticalGroupIFS = AGIFS1$) then
      new$Direction := -1;  
      
    END IF;
  END IF;
  BEGIN
      

    /*      */ 
    select Code into KVSRCode1$ from KVSR where (ID = new$KVSR) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*  20-    */
  /*      */
  if (KVSRCode1$ = 0) then
    sKVSR1$ := '000';
        
  else
    if (KVSRCode1$ < 10) then
      sKVSR1$ := '00' || KVSRCode1$;
          
    else
      if (KVSRCode1$ < 100) then
        sKVSR1$ := '0' || KVSRCode1$;
            
      else
        sKVSR1$ := KVSRCode1$;
      END IF;
    END IF;
  END IF;
  /*    , ,  */
      
  tmp$ := new$DescriptionCode;
  tmp_Double1$ := tmp$ / 1000000;
  DescrCode11$ := tmp_Double1$;
  /*      ,
          ,    1 */
  if (DescrCode11$  > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$MainDescriptionCode := DescrCode11$; /*    */
  /*       */    
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 1000000;
  DescrCode21$ := tmp_Double1$;
  tmp_Double1$ := DescrCode21$ / 10000;
  DescrCode11$ := tmp_Double1$;
  /*      */
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  new$ItemCode := DescrCode11$; /* */
  tmp_Double1$ := DescrCode21$ - DescrCode11$ * 10000;
  new$ProgramCode := tmp_Double1$; /* */
  /*       */
      
  tmp_Double1$ := tmp$ / 10000000;
  DescrCode11$ := tmp_Double1$;
  if (DescrCode11$ > tmp_Double1$) then 
    DescrCode11$ := DescrCode11$ - 1;
  END IF;
  tmp_Double1$ := DescrCode11$;
  tmp_Double1$ := tmp$ - tmp_Double1$ * 10000000;
  DescrCode21$ := tmp_Double1$;
  if (DescrCode11$ = 0) then
    sDescrCode11$ := '0000000';
        
  else
    if (DescrCode11$ < 10) then
      sDescrCode11$ := '000000' || DescrCode11$;
          
    else
      if (DescrCode11$ < 100) then
        sDescrCode11$ := '00000' || DescrCode11$;
            
      else
        if (DescrCode11$ < 1000) then
          sDescrCode11$ := '0000' || DescrCode11$;
              
        else
          if (DescrCode11$ < 10000) then
            sDescrCode11$ := '000' || DescrCode11$;
                
          else
            if (DescrCode11$ < 100000) then
              sDescrCode11$ := '00' || DescrCode11$;
                  
            else
              if (DescrCode11$ < 1000000) then
                sDescrCode11$ := '0' || DescrCode11$;
                    
              else
                sDescrCode11$ := DescrCode11$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  if (DescrCode21$ = 0) then
    sDescrCode21$ := '0000000';
        
  else
    if (DescrCode21$ < 10) then
      sDescrCode21$ := '000000' || DescrCode21$;
          
    else
      if (DescrCode21$ < 100) then
        sDescrCode21$ := '00000' || DescrCode21$;
            
      else
        if (DescrCode21$ < 1000) then
          sDescrCode21$ := '0000' || DescrCode21$;
              
        else
          if (DescrCode21$ < 10000) then
            sDescrCode21$ := '000' || DescrCode21$;
                
          else
            if (DescrCode21$ < 100000) then
              sDescrCode21$ := '00' || DescrCode21$;
                  
            else
              if (DescrCode21$ < 1000000) then
                sDescrCode21$ := '0' || DescrCode21$;
                    
              else
                sDescrCode21$ := DescrCode21$;
              END IF;
            END IF;
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*        */ 
    select Code into sAnalyticalGroupIFS1$ from AnalyticalGroupIFS where (ID = new$AnalyticalGroupIFS) ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (new$KESR is null) then
    BEGIN
      select id into new$KESR from KESR where (CODE = sAnalyticalGroupIFS1$) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (new$KESR is null) then
      new$KESR := 0;
        
    END IF;
  END IF;
  /*      */
      
  new$FinSourceValue := sKVSR1$ || sDescrCode11$ || sDescrCode21$ || sAnalyticalGroupIFS1$;
      
  if ((new$ID = 0) and (new$FinSourceValue <> '00000000000000000000') and (new$BudgetRef <> 0)) then
    RaiseException('ex_CantModify_ZeroIFS');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_INNERFINSOURCE SET
    ID = new$ID,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    DIRECTION = new$DIRECTION,
    KVSR = new$KVSR,
    DESCRIPTIONCODE = new$DESCRIPTIONCODE,
    MAINDESCRIPTIONCODE = new$MAINDESCRIPTIONCODE,
    ITEMCODE = new$ITEMCODE,
    PROGRAMCODE = new$PROGRAMCODE,
    KESR = new$KESR,
    FINSOURCEVALUE = new$FINSOURCEVALUE,
    UNIONFLAG = new$UNIONFLAG,
    REMOTEFLAG = new$REMOTEFLAG,
    BUDGETREF = new$BUDGETREF,
    DELETEDATE = new$DELETEDATE,
    NAME = new$NAME,
    STARTDATE = new$STARTDATE,
    SHORTNAME = new$SHORTNAME,
    CLSASPECT = new$CLSASPECT,
    CREATERUSER = new$CREATERUSER,
    UPDATERUSER = new$UPDATERUSER,
    IFS_LEVEL = new$IFS_LEVEL,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    ANALYTICALGROUPIFS = new$ANALYTICALGROUPIFS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_INNERFINSOURCE_AU_100)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$kvsr <> 0) then
    SELECT COUNT(*) INTO CNT$1
    from InnerFinSource ifs1
    where ((ifs1.kvsr = 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef)
    ) AND (ROWNUM = 1)                   ;
    /*    0,        =0 */
    if (not (CNT$1<> 0))
    then  
      insert into InnerFinSource (KVSR, DescriptionCode, AnalyticalGroupIFS, Name, ShortName, CLSAspect, RemoteFlag, IFS_Level, BudgetRef, ExtID)
      values (0, new$DescriptionCode, new$AnalyticalGroupIFS, new$Name, new$ShortName, new$CLSAspect, new$RemoteFlag, new$IFS_Level, new$BudgetRef, new$ExtID);
      
    END IF;
  else
    /*   = 0,         ,     */      
    vName$ := new$Name;
    vShortName$ := new$ShortName;
    vIFSLevel$ := new$IFS_Level;
    vDeleteDate$ := new$DeleteDate;
    vDirection$ := new$Direction;
    /* ,      .  ,        .    ,   . */
    if ((new$DeleteDate is not null) and (new$DeleteDate < current_date)) then
      SELECT COUNT(*) INTO CNT$2
      from InnerFinSource ifs1
      where ((ifs1.kvsr = 0) and
      ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
      (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
      (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date))
      ) AND (ROWNUM = 1)                    ;
      if ((CNT$2<> 0))
      then
        BEGIN
          select ifs2.Name, ifs2.ShortName, ifs2.IFS_Level, ifs2.Direction, ifs2.DeleteDate                 into
          vName$, vShortName$, vIFSLevel$, vDirection$, vDeleteDate$ from InnerFinSource ifs2
          where ifs2.id = (select max(id) from InnerFinSource ifs1
          where (ifs1.kvsr = 0) and
          ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
          (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
          (ifs1.BudgetRef = new$BudgetRef) and ((ifs1.DeleteDate is null) or (ifs1.DeleteDate > current_date)))
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;    
      END IF;
    END IF;
    update InnerFinSource ifs1 set
    name = vName$,
    ShortName = vShortName$,
    IFS_level = vIFSLevel$,
    Direction = vDirection$,
    deletedate = vDeleteDate$

    where
    (ifs1.kvsr <> 0) and
    ((ifs1.descriptioncode-new$descriptioncode>-1) and (ifs1.descriptioncode-new$descriptioncode<1)) and
    (ifs1.AnalyticalGroupIFS = new$AnalyticalGroupIFS) and
    (ifs1.BudgetRef = new$BudgetRef);
      
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_INNERFINSOURCE_AU_500)
-- Create 28.04.2005
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (145, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=145) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
ALTER TABLE KESR MODIFY(CODE NOT NULL)
/
ALTER TABLE KESR MODIFY(BudgetRef NOT NULL)
/
ALTER TABLE KESR MODIFY(CONTROLCODE NOT NULL)
/
ALTER TABLE KESRSUBCODE MODIFY(CODE NOT NULL)
/
ALTER TABLE KESRSUBCODE MODIFY(BudgetRef NOT NULL)
/
ALTER TABLE BudStructRights MODIFY(KESR NOT NULL)
/
ALTER TABLE BudStructRights MODIFY(SubKESR NOT NULL)
/

-- #########################################################
-- #########################################################
-- Alter_BudNotify_Extend_ANumber.sql
-- #########################################################
-- #########################################################

/* 
     ""  50   e BUDNOTIFY

*/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 DISABLE
/
/*     ANUMBER */
-- drop trigger TR_BUDNOTIFY_BI_430
CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/
ALTER TABLE TB_BUDNOTIFY ADD (
  Number_New VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ANUMBER,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  NUMBER_NEW)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ANUMBER,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ANUMBER,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$NUMBER_NEW);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ANUMBER = new$ANUMBER,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    NUMBER_NEW = new$NUMBER_NEW
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
update BUDNOTIFY b set
  Number_New = ANUMBER 
/
ALTER TABLE TB_BUDNOTIFY DROP (ANUMBER)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  NUMBER_NEW)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$NUMBER_NEW);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    NUMBER_NEW = new$NUMBER_NEW
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
ALTER TABLE TB_BUDNOTIFY ADD (
  ANUMBER VARCHAR2(50)
)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  NUMBER_NEW,
  ANUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW,
    ANUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    NUMBER_NEW,
    ANUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$NUMBER_NEW,
    new$ANUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$NUMBER_NEW BUDNOTIFY.NUMBER_NEW%TYPE := :NEW.NUMBER_NEW;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    NUMBER_NEW = new$NUMBER_NEW,
    ANUMBER = new$ANUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
update BUDNOTIFY set
  ANUMBER = Number_New 
/
ALTER TABLE TB_BUDNOTIFY DROP (Number_New)
/

CREATE OR REPLACE VIEW BUDNOTIFY (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  ANUMBER)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER
  FROM TB_BUDNOTIFY
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$ANUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    ANUMBER = new$ANUMBER
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
-- CREATE TRIGGER TR_BUDNOTIFY_BI_430
CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    /*        */
    GetIntConst(30, 19,UseFax$);
    IF ((new$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      new$BidNumber:= new$ANumber;
    END IF;
    new$FaxDocCount:= 0;
      
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$ANUMBER);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/
ALTER TRIGGER TR_BUDNOTIFY_BU_500 ENABLE
/
commit work 
/


-- #########################################################
-- #########################################################
-- Add_EDC_PayDate.sql
-- #########################################################
-- #########################################################

/*   " "  . */
ALTER TABLE TB_ExecutionDocumentsCaption ADD (
  PayDate NUMBER/*   */
)
/

CREATE OR REPLACE VIEW ExecutionDocumentsCaption (
  ID,
  DOCTYPE,
  DOCUMENTDATE,
  ACCEPTDATE,
  SUMMA,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  BUDGETREF,
  STEPNUMBER,
  FACIALACC_CLS,
  RECIPIENT_REF,
  REGISTRATIONTYPE,
  REESTRNUMBER,
  AGREEMENTINNERNUMBER,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  REVIEWNOTE,
  DOCSTATEREF,
  RVERSION,
  EXECDOCFINSUMMA,
  FACT,
  DOCNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  REALID,
  INNERNUMBER,
  ADJUSTMENTREF,
  ADJUSTMENTNUMBER,
  ACCEPTED,
  LASTACCEPTED,
  LASTADJUSTMENT,
  AGREEMENTREF,
  NOTE,
  SUPPLIERSTOREDPROPS,
  SUPPLIER_REF,
  SUPPLIERACC_REF,
  REJECTCAUSE,
  INFONUMBER,
  NOTIFYDATE,
  MONEYPROMISENUMBER,
  PURPORTDOC,
  STOREDCONTENT,
  PAYDATE)
AS
  SELECT
    ID,
    DOCTYPE,
    DOCUMENTDATE,
    ACCEPTDATE,
    SUMMA,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    STEPNUMBER,
    FACIALACC_CLS,
    RECIPIENT_REF,
    REGISTRATIONTYPE,
    REESTRNUMBER,
    AGREEMENTINNERNUMBER,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXECDOCFINSUMMA,
    FACT,
    DOCNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REALID,
    INNERNUMBER,
    ADJUSTMENTREF,
    ADJUSTMENTNUMBER,
    ACCEPTED,
    LASTACCEPTED,
    LASTADJUSTMENT,
    AGREEMENTREF,
    NOTE,
    SUPPLIERSTOREDPROPS,
    SUPPLIER_REF,
    SUPPLIERACC_REF,
    REJECTCAUSE,
    INFONUMBER,
    NOTIFYDATE,
    MONEYPROMISENUMBER,
    PURPORTDOC,
    STOREDCONTENT,
    PAYDATE
  FROM TB_ExecutionDocumentsCaption
/

CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_ID
  INSTEAD OF DELETE
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  quant$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_DOCEXECCAPTION_BD)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  select count(ID)   into quant$ from executiondocumentscaption
  where AdjustmentRef = :old.ID
  ;
  if (quant$  = 0) then
    delete from ExecutionDocumentsDetail where (RecordIndex = :old.ID);
    delete from paymentschedule where (ExecutionRef = :old.ID)and(ProgIndex=308);

  else
    RaiseException('ex_agr_cantdeladjustmented');
  END IF;

-- - - - - - - - - - - - -
-- BD_10 (TR_DocExecCaption_BD_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update ExecutionDocumentsCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update ExecutionDocumentsCaption set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_EXECUTIONDOCUMENTSCAPTION
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_10 (TR_ExecDocCaption_AD_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update ExecutionDocumentsCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update ExecutionDocumentsCaption set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_EXECDOCCAPTION_AD_200)
-- Create 04.10.2004
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_EXECDOCCAPTION_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, SUMMA) values (114, :old.ID, SYSDATE, :old.SUMMA);

END;
/

CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_II
  INSTEAD OF INSERT
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  new$ID EXECUTIONDOCUMENTSCAPTION.ID%TYPE := :NEW.ID;
  new$DOCTYPE EXECUTIONDOCUMENTSCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DOCUMENTDATE EXECUTIONDOCUMENTSCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE EXECUTIONDOCUMENTSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SUMMA EXECUTIONDOCUMENTSCAPTION.SUMMA%TYPE := :NEW.SUMMA;
  new$CREATERUSER EXECUTIONDOCUMENTSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE EXECUTIONDOCUMENTSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE EXECUTIONDOCUMENTSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER EXECUTIONDOCUMENTSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF EXECUTIONDOCUMENTSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$STEPNUMBER EXECUTIONDOCUMENTSCAPTION.STEPNUMBER%TYPE := :NEW.STEPNUMBER;
  new$FACIALACC_CLS EXECUTIONDOCUMENTSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$RECIPIENT_REF EXECUTIONDOCUMENTSCAPTION.RECIPIENT_REF%TYPE := :NEW.RECIPIENT_REF;
  new$REGISTRATIONTYPE EXECUTIONDOCUMENTSCAPTION.REGISTRATIONTYPE%TYPE := :NEW.REGISTRATIONTYPE;
  new$REESTRNUMBER EXECUTIONDOCUMENTSCAPTION.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$AGREEMENTINNERNUMBER EXECUTIONDOCUMENTSCAPTION.AGREEMENTINNERNUMBER%TYPE := :NEW.AGREEMENTINNERNUMBER;
  new$REJECTCLS EXECUTIONDOCUMENTSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS EXECUTIONDOCUMENTSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID EXECUTIONDOCUMENTSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID EXECUTIONDOCUMENTSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REVIEWNOTE EXECUTIONDOCUMENTSCAPTION.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF EXECUTIONDOCUMENTSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION EXECUTIONDOCUMENTSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$EXECDOCFINSUMMA EXECUTIONDOCUMENTSCAPTION.EXECDOCFINSUMMA%TYPE := :NEW.EXECDOCFINSUMMA;
  new$FACT EXECUTIONDOCUMENTSCAPTION.FACT%TYPE := :NEW.FACT;
  new$DOCNUMBER EXECUTIONDOCUMENTSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SENDERIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REALID EXECUTIONDOCUMENTSCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER EXECUTIONDOCUMENTSCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTREF EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ADJUSTMENTNUMBER EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ACCEPTED EXECUTIONDOCUMENTSCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED EXECUTIONDOCUMENTSCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$LASTADJUSTMENT EXECUTIONDOCUMENTSCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$AGREEMENTREF EXECUTIONDOCUMENTSCAPTION.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$NOTE EXECUTIONDOCUMENTSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$SUPPLIERSTOREDPROPS EXECUTIONDOCUMENTSCAPTION.SUPPLIERSTOREDPROPS%TYPE := :NEW.SUPPLIERSTOREDPROPS;
  new$SUPPLIER_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIER_REF%TYPE := :NEW.SUPPLIER_REF;
  new$SUPPLIERACC_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIERACC_REF%TYPE := :NEW.SUPPLIERACC_REF;
  new$REJECTCAUSE EXECUTIONDOCUMENTSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$INFONUMBER EXECUTIONDOCUMENTSCAPTION.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$NOTIFYDATE EXECUTIONDOCUMENTSCAPTION.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$MONEYPROMISENUMBER EXECUTIONDOCUMENTSCAPTION.MONEYPROMISENUMBER%TYPE := :NEW.MONEYPROMISENUMBER;
  new$PURPORTDOC EXECUTIONDOCUMENTSCAPTION.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$STOREDCONTENT EXECUTIONDOCUMENTSCAPTION.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PAYDATE EXECUTIONDOCUMENTSCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
--
  Tmp$ NUMBER(10);
  AdjID$ NUMBER(10);
  AdjDocNum$ VARCHAR2(50);
  agr_accepted$ NUMBER(10);
  agr_acceptdate$ NUMBER(10);
  PreviousInner$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ExecDoccaption_BI)
-- Version 11.20.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$ExecDocFinSumma is null) then
    new$ExecDocFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$RegistrationType is null) then
    new$RegistrationType := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef
      into new$BudgetRef     from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
  if (new$Supplier_Ref is null and new$SupplierAcc_Ref is not null) then
    BEGIN
      select oa.Org_Ref
      into new$Supplier_Ref   from Org_Accounts oa
      where oa.id = new$SupplierAcc_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('g_ExecDocNumber',1);

  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$     from ExecutionDocumentsCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_ExecDoc_NotFindInner');
    END IF;
    new$InnerNumber := PreviousInner$;

  END IF;
  /*      id */
  new$agreementinnernumber := null;
  if (new$agreementref is not null) then
    BEGIN
      select
      innernumber
      into new$agreementinnernumber     from agreements
      where
      id = new$agreementref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_EXECDOCCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_EXECDOCCAPTION_BI_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$     from ExecutionDocumentsCaption
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID), max(ID), max(DocNumber)
    into Tmp$, AdjID$, AdjDocNum$       from ExecutionDocumentsCaption
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp$ <> 1) then
      RaiseException('EX_ExecDoc_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$       from ExecutionDocumentsCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_ExecDoc_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$AdjustmentRef := AdjID$;

  else /*     */
    /*       (    )*/
    new$AdjustmentRef := null;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (tr_execdoccaption_bi_40)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_60 (tr_execdoccaption_bi_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$agreementinnernumber is not null) then
    BEGIN
      /*        , .. 
             ,    ,   
            ,     */
      select accepted, acceptdate     into
      agr_accepted$, agr_acceptdate$ from agreements
      where
      innernumber = new$agreementinnernumber and adjustmentnumber = 0
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*        */
    if (new$acceptdate is null and agr_accepted$ = 0 and agr_acceptdate$ is not null) then
      RaiseException('EX_Agr_Rejected');
    END IF;
    /*        */
    if (new$accepted = 1 and new$acceptdate is not null and
    (agr_accepted$ = 0 or agr_acceptdate$ is null)) then
      RaiseException('EX_Agr_NotAccepted');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_EXECDOCCAPTION_BI_500)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_EXECUTIONDOCUMENTSCAPTION (
    ID,
    DOCTYPE,
    DOCUMENTDATE,
    ACCEPTDATE,
    SUMMA,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    STEPNUMBER,
    FACIALACC_CLS,
    RECIPIENT_REF,
    REGISTRATIONTYPE,
    REESTRNUMBER,
    AGREEMENTINNERNUMBER,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXECDOCFINSUMMA,
    FACT,
    DOCNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REALID,
    INNERNUMBER,
    ADJUSTMENTREF,
    ADJUSTMENTNUMBER,
    ACCEPTED,
    LASTACCEPTED,
    LASTADJUSTMENT,
    AGREEMENTREF,
    NOTE,
    SUPPLIERSTOREDPROPS,
    SUPPLIER_REF,
    SUPPLIERACC_REF,
    REJECTCAUSE,
    INFONUMBER,
    NOTIFYDATE,
    MONEYPROMISENUMBER,
    PURPORTDOC,
    STOREDCONTENT,
    PAYDATE
  ) VALUES (
    new$ID,
    new$DOCTYPE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$SUMMA,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$STEPNUMBER,
    new$FACIALACC_CLS,
    new$RECIPIENT_REF,
    new$REGISTRATIONTYPE,
    new$REESTRNUMBER,
    new$AGREEMENTINNERNUMBER,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXECDOCFINSUMMA,
    new$FACT,
    new$DOCNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTREF,
    new$ADJUSTMENTNUMBER,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$LASTADJUSTMENT,
    new$AGREEMENTREF,
    new$NOTE,
    new$SUPPLIERSTOREDPROPS,
    new$SUPPLIER_REF,
    new$SUPPLIERACC_REF,
    new$REJECTCAUSE,
    new$INFONUMBER,
    new$NOTIFYDATE,
    new$MONEYPROMISENUMBER,
    new$PURPORTDOC,
    new$STOREDCONTENT,
    new$PAYDATE);

-- - - - - - - - - - - - -
-- AI_0 (TR_ExecDocCaption_AI)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update ExecutionDocuMENTSCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update ExecutionDocuMENTSCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_EXECDOCCAPTION_AI_500)
-- - - - - - - - - - - - -

-- 25.08.2004
  delete from DelRecIndexes where (TableID = 114) and (RecordID = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_IU
  INSTEAD OF UPDATE
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  new$ID EXECUTIONDOCUMENTSCAPTION.ID%TYPE := :NEW.ID;
  new$DOCTYPE EXECUTIONDOCUMENTSCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DOCUMENTDATE EXECUTIONDOCUMENTSCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE EXECUTIONDOCUMENTSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SUMMA EXECUTIONDOCUMENTSCAPTION.SUMMA%TYPE := :NEW.SUMMA;
  new$CREATERUSER EXECUTIONDOCUMENTSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE EXECUTIONDOCUMENTSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE EXECUTIONDOCUMENTSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER EXECUTIONDOCUMENTSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF EXECUTIONDOCUMENTSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$STEPNUMBER EXECUTIONDOCUMENTSCAPTION.STEPNUMBER%TYPE := :NEW.STEPNUMBER;
  new$FACIALACC_CLS EXECUTIONDOCUMENTSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$RECIPIENT_REF EXECUTIONDOCUMENTSCAPTION.RECIPIENT_REF%TYPE := :NEW.RECIPIENT_REF;
  new$REGISTRATIONTYPE EXECUTIONDOCUMENTSCAPTION.REGISTRATIONTYPE%TYPE := :NEW.REGISTRATIONTYPE;
  new$REESTRNUMBER EXECUTIONDOCUMENTSCAPTION.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$AGREEMENTINNERNUMBER EXECUTIONDOCUMENTSCAPTION.AGREEMENTINNERNUMBER%TYPE := :NEW.AGREEMENTINNERNUMBER;
  new$REJECTCLS EXECUTIONDOCUMENTSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS EXECUTIONDOCUMENTSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID EXECUTIONDOCUMENTSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID EXECUTIONDOCUMENTSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REVIEWNOTE EXECUTIONDOCUMENTSCAPTION.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF EXECUTIONDOCUMENTSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION EXECUTIONDOCUMENTSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$EXECDOCFINSUMMA EXECUTIONDOCUMENTSCAPTION.EXECDOCFINSUMMA%TYPE := :NEW.EXECDOCFINSUMMA;
  new$FACT EXECUTIONDOCUMENTSCAPTION.FACT%TYPE := :NEW.FACT;
  new$DOCNUMBER EXECUTIONDOCUMENTSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SENDERIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REALID EXECUTIONDOCUMENTSCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER EXECUTIONDOCUMENTSCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTREF EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ADJUSTMENTNUMBER EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ACCEPTED EXECUTIONDOCUMENTSCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED EXECUTIONDOCUMENTSCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$LASTADJUSTMENT EXECUTIONDOCUMENTSCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$AGREEMENTREF EXECUTIONDOCUMENTSCAPTION.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$NOTE EXECUTIONDOCUMENTSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$SUPPLIERSTOREDPROPS EXECUTIONDOCUMENTSCAPTION.SUPPLIERSTOREDPROPS%TYPE := :NEW.SUPPLIERSTOREDPROPS;
  new$SUPPLIER_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIER_REF%TYPE := :NEW.SUPPLIER_REF;
  new$SUPPLIERACC_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIERACC_REF%TYPE := :NEW.SUPPLIERACC_REF;
  new$REJECTCAUSE EXECUTIONDOCUMENTSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$INFONUMBER EXECUTIONDOCUMENTSCAPTION.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$NOTIFYDATE EXECUTIONDOCUMENTSCAPTION.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$MONEYPROMISENUMBER EXECUTIONDOCUMENTSCAPTION.MONEYPROMISENUMBER%TYPE := :NEW.MONEYPROMISENUMBER;
  new$PURPORTDOC EXECUTIONDOCUMENTSCAPTION.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$STOREDCONTENT EXECUTIONDOCUMENTSCAPTION.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PAYDATE EXECUTIONDOCUMENTSCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  CntAgr$ NUMBER(10);
  CntStep$ NUMBER(10);
  agr_accepted$ NUMBER(10);
  agr_acceptdate$ NUMBER(10);
  CountExecDoc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_EXECDOCCAPTION_BU)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$ExecDocFinSumma is null) then
    new$ExecDocFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$RegistrationType is null) then
    new$RegistrationType := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      SELECT COUNT(                   Id
      ) INTO CNT$1
      from ExecutionDocumentsDetail
      where
      (                   RecordIndex = :old.Id
      ) AND (ROWNUM = 1)                ;
      if ((CNT$1<> 0)         ) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      SELECT COUNT(                   Id
      ) INTO CNT$2
      from PaymentSchedule
      where
      (                   ExecutionRef = :old.Id
      ) AND (ROWNUM = 1)                ;
      if ((CNT$2<> 0)         ) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /* c,           */
  /* ,    */
  if (new$InnerNumber <> :old.InnerNumber or
  new$AdjustmentRef <> :old.AdjustmentRef or
  new$AdjustmentNumber <> :old.AdjustmentNumber) then
    RaiseException('EX_Agr_ChangeInnerNums');
  END IF;
  /*      id */
  new$agreementinnernumber := null;
  if (new$agreementref is not null) then
    BEGIN
      select
      innernumber
      into new$agreementinnernumber     from agreements
      where
      id = new$agreementref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_EXECDOCCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_EXECDOCCAPTION_BU_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*     */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    RaiseException('EX_RollbackCancel');
  END IF;

  /*   ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment = 1) then
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    else
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from ExecutionDocumentsCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and
    (CNT$1<> 0)       ) then
      RaiseException('EX_ExecDoc_PrimaryAgrHasNotify');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_40 (tr_execdoccaption_bu_40)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  if ((:old.AcceptDate is not null) and (new$AcceptDate is null)) then
    select count(ID) into CntAgr$ from Agreements where (CloseDoc = :old.ID) ;
    select count(ID) into CntStep$ from AgreementSteps where (CloseDoc = :old.ID) ;
    if ((CntAgr$ > 0) or (CntStep$ > 0)) then
      RaiseException('ex_CannotUpdateCloseDoc');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_execdoccaption_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$agreementinnernumber is not null) then
    BEGIN
      /*        , .. 
             ,    ,   
            ,     */
      select accepted, acceptdate     into
      agr_accepted$, agr_acceptdate$ from agreements
      where
      innernumber = new$agreementinnernumber and adjustmentnumber = 0
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*        */
    if (new$acceptdate is null and agr_accepted$ = 0 and agr_acceptdate$ is not null) then
      RaiseException('EX_Agr_Rejected');
    END IF;
    /*        */
    if (new$accepted = 1 and new$acceptdate is not null and
    (agr_accepted$ = 0 or agr_acceptdate$ is null)) then
      RaiseException('EX_Agr_NotAccepted');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_EXECDOCCAPTION_BU_200)
-- Create 04.10.2004
-- - - - - - - - - - - - -

  /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_EXECDOCCAPTION_BU_210)
-- Version 11.20.00.1
-- - - - - - - - - - - - -

  /*   */
  if (new$rejectcls is not null and new$accepted = 0) then
    /*         */
    select
    count(ffd.id)
    into CountExecDoc$     from
    facialfindetail ffd
    left join facialfincaption ffc on ffc.id = ffd.recordindex
    where
    (ffc.acceptdate is not null and (ffd.sourceexecdoc = new$id or ffd.destexecdoc = new$id))
    ;
    /*       */
    if (CountExecDoc$ <> 0) then
      RaiseException('ex_exedoc_useinfacialfindetail');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_EDCAPTION_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_EXECUTIONDOCUMENTSCAPTION SET
    ID = new$ID,
    DOCTYPE = new$DOCTYPE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    SUMMA = new$SUMMA,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    STEPNUMBER = new$STEPNUMBER,
    FACIALACC_CLS = new$FACIALACC_CLS,
    RECIPIENT_REF = new$RECIPIENT_REF,
    REGISTRATIONTYPE = new$REGISTRATIONTYPE,
    REESTRNUMBER = new$REESTRNUMBER,
    AGREEMENTINNERNUMBER = new$AGREEMENTINNERNUMBER,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXECDOCFINSUMMA = new$EXECDOCFINSUMMA,
    FACT = new$FACT,
    DOCNUMBER = new$DOCNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    AGREEMENTREF = new$AGREEMENTREF,
    NOTE = new$NOTE,
    SUPPLIERSTOREDPROPS = new$SUPPLIERSTOREDPROPS,
    SUPPLIER_REF = new$SUPPLIER_REF,
    SUPPLIERACC_REF = new$SUPPLIERACC_REF,
    REJECTCAUSE = new$REJECTCAUSE,
    INFONUMBER = new$INFONUMBER,
    NOTIFYDATE = new$NOTIFYDATE,
    MONEYPROMISENUMBER = new$MONEYPROMISENUMBER,
    PURPORTDOC = new$PURPORTDOC,
    STOREDCONTENT = new$STOREDCONTENT,
    PAYDATE = new$PAYDATE
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_0 (TR_ExecDocCaption_AU)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update ExecutionDocuMENTSCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update ExecutionDocuMENTSCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_EXECDOCCAPTION_AU_30)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where ExecutionRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_EXECDOCCAPTION_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (114, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=114) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/

-- #########################################################
-- #########################################################
-- create_Suppliers.sql
-- #########################################################
-- #########################################################

/*   Suppliers -    */
/*    */
create table Suppliers (
  ID NUMBER(10) NOT NULL,/*   */
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  RecordIndex NUMBER(10) NOT NULL,/*    */
    CHECK((RecordIndex<=2147483647)AND(RecordIndex>-2147483648)),
  OrgRef NUMBER(10) NOT NULL,/*  */
    CHECK((OrgRef<=2147483647)AND(OrgRef>-2147483648)),
  AccRef NUMBER(10),
    CHECK((AccRef<=2147483647)AND(AccRef>-2147483648)),
  StoredProps VARCHAR2(2000),/*    */
  INN NUMBER(12),/*   */
  INN20 VARCHAR2(20),/*   */
  Name VARCHAR2(1024) NOT NULL,/*   */
  Status NUMBER(10),/*   */
    CHECK((Status<=2147483647)AND(Status>-2147483648)),
  Country VARCHAR2(50),/*   */
  Address VARCHAR2(255),/*   */
  Phone VARCHAR2(20),/*   */
  CREATERUSER VARCHAR2(30) NOT NULL,
  CREATEDATE DATE NOT NULL,
  UPDATEDATE DATE NOT NULL,
  UPDATERUSER VARCHAR2(30) NOT NULL,
  SenderID NUMBER(10),/* id   */
    CHECK((SenderID<=2147483647)AND(SenderID>-2147483648)),
  SenderRecordID NUMBER(10),/* id      */
    CHECK((SenderRecordID<=2147483647)AND(SenderRecordID>-2147483648)),
  RVersion NUMBER(10) default 0,/*   */
    CHECK((RVersion<=2147483647)AND(RVersion>-2147483648)),
  SenderIDKey NUMBER(10) NOT NULL,
    CHECK((SenderIDKey<=2147483647)AND(SenderIDKey>-2147483648)),
  SenderRecordIDKey NUMBER(10) NOT NULL,
    CHECK((SenderRecordIDKey<=2147483647)AND(SenderRecordIDKey>-2147483648)),
  constraint pk_Suppliers_id primary key(id),
  constraint fk_Suppliers_RecordIndex foreign key(RecordIndex) references TB_Agreements(id),
  constraint fk_Suppliers_OrgID foreign key(OrgRef) references TB_Organizations(id),
  constraint fk_Suppliers_AccRef foreign key(AccRef) references TB_Org_Accounts(id),
  constraint u_Suppliers_Sender unique (senderidkey, senderrecordidkey)
)
/
CREATE INDEX fk_Suppliers_RecordIndex ON Suppliers(RecordIndex)
/
CREATE INDEX fk_Suppliers_OrgID ON Suppliers(OrgRef)
/
CREATE INDEX fk_Suppliers_AccRef ON Suppliers(AccRef)
/
-- CREATE TRIGGER TR_Suppliers_BI
CREATE OR REPLACE TRIGGER TR_Suppliers_BI
  BEFORE INSERT
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_Suppliers_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if ((:new.INN     is null) and
  (:new.INN20   is null) and
  (:new.Name    is null) and
  (:new.Status  is null) and
  (:new.Country is null) and
  (:new.Address is null) and
  (:new.Phone   is null))then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

END;
/
-- CREATE TRIGGER TR_Suppliers_BI_500
CREATE OR REPLACE TRIGGER TR_Suppliers_BI
  BEFORE INSERT
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_Suppliers_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if ((:new.INN     is null) and
  (:new.INN20   is null) and
  (:new.Name    is null) and
  (:new.Status  is null) and
  (:new.Country is null) and
  (:new.Address is null) and
  (:new.Phone   is null))then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_Suppliers_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_Suppliers_BU_500
CREATE OR REPLACE TRIGGER TR_Suppliers_BU_500
  BEFORE UPDATE
  ON SUPPLIERS
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_500 (TR_Suppliers_BU_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.Updatedate := SYSDATE;
  :new.UpdaterUser := User;

END;
/
-- CREATE TRIGGER TR_Suppliers_BU_700
CREATE OR REPLACE TRIGGER TR_Suppliers_BU
  BEFORE UPDATE
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_700 (TR_Suppliers_BU_700)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion:= 1;
     
  else
    if ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
      :new.RVersion:= :old.RVersion;
         
    else
      :new.RVersion:= :old.RVersion+1;
    END IF;
  END IF;

END;
/
-- CREATE TRIGGER tr_Suppliers_ai_500
CREATE OR REPLACE TRIGGER TR_Suppliers_AI
  AFTER INSERT
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AI_500 (tr_Suppliers_ai_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 118) and (RecordID = :new.ID);

END;
/
-- CREATE TRIGGER Tr_Suppliers_AU_500
CREATE OR REPLACE TRIGGER TR_Suppliers_AU
  AFTER UPDATE
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AU_500 (Tr_Suppliers_AU_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (118, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=118) and (RecordId=:new.ID);
      
  END IF;

END;
/
-- CREATE TRIGGER tr_Suppliers_ad_500
CREATE OR REPLACE TRIGGER TR_Suppliers_AD
  AFTER DELETE
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- AD_500 (tr_Suppliers_ad_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (118, :old.ID, SYSDATE);

END;
/
-- CREATE TRIGGER TR_Suppliers_BI_40
CREATE OR REPLACE TRIGGER TR_Suppliers_BI
  BEFORE INSERT
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_Suppliers_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if ((:new.INN     is null) and
  (:new.INN20   is null) and
  (:new.Name    is null) and
  (:new.Status  is null) and
  (:new.Country is null) and
  (:new.Address is null) and
  (:new.Phone   is null))then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_Suppliers_BI_40)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then 
    :new.senderIdKey := -1;
      
  else 
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;
      
  else 
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_Suppliers_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER tr_Suppliers_BU_400
CREATE OR REPLACE TRIGGER TR_Suppliers_BU
  BEFORE UPDATE
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_400 (tr_Suppliers_BU_400)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_Suppliers_BU_700)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion:= 1;
     
  else
    if ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
      :new.RVersion:= :old.RVersion;
         
    else
      :new.RVersion:= :old.RVersion+1;
    END IF;
  END IF;

END;
/
-- CREATE TRIGGER tr_Suppliers_BU
CREATE OR REPLACE TRIGGER TR_Suppliers_BU
  BEFORE UPDATE
  ON Suppliers
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_Suppliers_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if ((:new.OrgRef <> :old.OrgRef) and
  (((:new.INN is null) and
  (:old.INN is null)) or
  (:new.INN = :old.INN)) and
  (((:new.INN20 is null) and
  (:old.INN20 is null)) or
  (:new.INN20 = :old.INN20)) and
  (:new.Name = :old.Name) and
  (((:new.Status is null) and
  (:old.Status is null)) or
  (:new.Status = :old.Status)) and
  (((:new.Country is null) and
  (:old.Country is null)) or
  (:new.Country = :old.Country)) and
  (((:new.Address is null) and
  (:old.Address is null)) or
  (:new.Address = :old.Address)) and
  (((:new.Phone is null) and
  (:old.Phone is null)) or
  (:new.Phone = :old.Phone))) then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_Suppliers_BU_400)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_Suppliers_BU_700)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion:= 1;
     
  else
    if ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
      :new.RVersion:= :old.RVersion;
         
    else
      :new.RVersion:= :old.RVersion+1;
    END IF;
  END IF;

END;
/
-- CREATE TRIGGER tr_Suppliers_bi_300
CREATE OR REPLACE TRIGGER TR_Suppliers_BI
  BEFORE INSERT
  ON Suppliers
  FOR EACH ROW
DECLARE
  CountAcc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_Suppliers_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if ((:new.INN     is null) and
  (:new.INN20   is null) and
  (:new.Name    is null) and
  (:new.Status  is null) and
  (:new.Country is null) and
  (:new.Address is null) and
  (:new.Phone   is null))then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_Suppliers_BI_40)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.senderId is null) then 
    :new.senderIdKey := -1;
      
  else 
    :new.senderIdKey := :new.senderId;
  END IF;
  if (:new.SenderRecordID is null) then
    :new.SenderRecordIDKey := :new.ID;
      
  else 
    :new.SenderRecordIDKey := :new.SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_300 (tr_Suppliers_bi_300)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.AccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = :new.AccRef and oa.Org_ref = :new.OrgRef
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_Suppliers_BI_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER tr_Suppliers_bu_300
CREATE OR REPLACE TRIGGER TR_Suppliers_BU
  BEFORE UPDATE
  ON Suppliers
  FOR EACH ROW
DECLARE
  CountAcc$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_Suppliers_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if ((:new.OrgRef <> :old.OrgRef) and
  (((:new.INN is null) and
  (:old.INN is null)) or
  (:new.INN = :old.INN)) and
  (((:new.INN20 is null) and
  (:old.INN20 is null)) or
  (:new.INN20 = :old.INN20)) and
  (:new.Name = :old.Name) and
  (((:new.Status is null) and
  (:old.Status is null)) or
  (:new.Status = :old.Status)) and
  (((:new.Country is null) and
  (:old.Country is null)) or
  (:new.Country = :old.Country)) and
  (((:new.Address is null) and
  (:old.Address is null)) or
  (:new.Address = :old.Address)) and
  (((:new.Phone is null) and
  (:old.Phone is null)) or
  (:new.Phone = :old.Phone))) then
    BEGIN
      select
      o.INN,
      o.INN20,
      o.Name,
      o.SupplierStatus,
      o.Country,
      o.Address,
      o.Phone
      into
      :new.INN,
      :new.INN20,
      :new.Name,
      :new.Status,
      :new.Country,
      :new.Address,
      :new.Phone     from Organizations o
      where o.Id=:new.OrgRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_Suppliers_bu_300)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.AccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = :new.AccRef and oa.Org_ref = :new.OrgRef
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (tr_Suppliers_BU_400)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RecordIndex <> :old.RecordIndex) then
    RaiseException('EX_CANTCHANGECAPTIONREF');
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_Suppliers_BU_700)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion:= 1;
     
  else
    if ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
      :new.RVersion:= :old.RVersion;
         
    else
      :new.RVersion:= :old.RVersion+1;
    END IF;
  END IF;

END;
/
grant SELECT, INSERT, UPDATE, DELETE on Suppliers to BUDGET_USERS
/
-- ALTER TRIGGER TR_AGREEMENTS_BD
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;
      
  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Last update 05.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    /*   LastAdjustment     */
    if ((:old.AdjustmentNumber > 0) and (:old.LastAdjustment = 1)) then
        update Agreements set
            LastAdjustment = 1,
            RVersion = -1
        where (ID = :old.AdjustmentRef);
    end if;
    /*   LastAccepted     */
    if ((:old.AdjustmentNumber > 0) and (:old.LastAccepted = 1)) then
        update Agreements set
            LastAccepted = 1,
            RVersion = -1
        where (ID = :old.AdjustmentRef);
    end if;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_AT_ChainTriggers.sql
-- #########################################################
-- #########################################################

/*    : InnerNumber        ,   AdjustmentRef (    ) */
INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_NOTFINDINNERNUMBER', -20367, '        ')
/
INSERT INTO SqlExceptions(Name, Code, Text) VALUES ('EX_PRIMARYDOCHASADJUSTMENT', -20368, '   .    ')
/
-- CREATE TRIGGER TR_EXECDOCCAPTION_BI
CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_II
  INSTEAD OF INSERT
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  new$ID EXECUTIONDOCUMENTSCAPTION.ID%TYPE := :NEW.ID;
  new$DOCTYPE EXECUTIONDOCUMENTSCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DOCUMENTDATE EXECUTIONDOCUMENTSCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE EXECUTIONDOCUMENTSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SUMMA EXECUTIONDOCUMENTSCAPTION.SUMMA%TYPE := :NEW.SUMMA;
  new$CREATERUSER EXECUTIONDOCUMENTSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE EXECUTIONDOCUMENTSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE EXECUTIONDOCUMENTSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER EXECUTIONDOCUMENTSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF EXECUTIONDOCUMENTSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$STEPNUMBER EXECUTIONDOCUMENTSCAPTION.STEPNUMBER%TYPE := :NEW.STEPNUMBER;
  new$FACIALACC_CLS EXECUTIONDOCUMENTSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$RECIPIENT_REF EXECUTIONDOCUMENTSCAPTION.RECIPIENT_REF%TYPE := :NEW.RECIPIENT_REF;
  new$REGISTRATIONTYPE EXECUTIONDOCUMENTSCAPTION.REGISTRATIONTYPE%TYPE := :NEW.REGISTRATIONTYPE;
  new$REESTRNUMBER EXECUTIONDOCUMENTSCAPTION.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$AGREEMENTINNERNUMBER EXECUTIONDOCUMENTSCAPTION.AGREEMENTINNERNUMBER%TYPE := :NEW.AGREEMENTINNERNUMBER;
  new$REJECTCLS EXECUTIONDOCUMENTSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS EXECUTIONDOCUMENTSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID EXECUTIONDOCUMENTSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID EXECUTIONDOCUMENTSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REVIEWNOTE EXECUTIONDOCUMENTSCAPTION.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF EXECUTIONDOCUMENTSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION EXECUTIONDOCUMENTSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$EXECDOCFINSUMMA EXECUTIONDOCUMENTSCAPTION.EXECDOCFINSUMMA%TYPE := :NEW.EXECDOCFINSUMMA;
  new$FACT EXECUTIONDOCUMENTSCAPTION.FACT%TYPE := :NEW.FACT;
  new$DOCNUMBER EXECUTIONDOCUMENTSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SENDERIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REALID EXECUTIONDOCUMENTSCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER EXECUTIONDOCUMENTSCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTREF EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ADJUSTMENTNUMBER EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ACCEPTED EXECUTIONDOCUMENTSCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED EXECUTIONDOCUMENTSCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$LASTADJUSTMENT EXECUTIONDOCUMENTSCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$AGREEMENTREF EXECUTIONDOCUMENTSCAPTION.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$NOTE EXECUTIONDOCUMENTSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$SUPPLIERSTOREDPROPS EXECUTIONDOCUMENTSCAPTION.SUPPLIERSTOREDPROPS%TYPE := :NEW.SUPPLIERSTOREDPROPS;
  new$SUPPLIER_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIER_REF%TYPE := :NEW.SUPPLIER_REF;
  new$SUPPLIERACC_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIERACC_REF%TYPE := :NEW.SUPPLIERACC_REF;
  new$REJECTCAUSE EXECUTIONDOCUMENTSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$INFONUMBER EXECUTIONDOCUMENTSCAPTION.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$NOTIFYDATE EXECUTIONDOCUMENTSCAPTION.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$MONEYPROMISENUMBER EXECUTIONDOCUMENTSCAPTION.MONEYPROMISENUMBER%TYPE := :NEW.MONEYPROMISENUMBER;
  new$PURPORTDOC EXECUTIONDOCUMENTSCAPTION.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$STOREDCONTENT EXECUTIONDOCUMENTSCAPTION.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PAYDATE EXECUTIONDOCUMENTSCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
--
  Tmp$ NUMBER(10);
  AdjID$ NUMBER(10);
  AdjDocNum$ VARCHAR2(50);
  agr_accepted$ NUMBER(10);
  agr_acceptdate$ NUMBER(10);
  PreviousInner1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_ExecDoccaption_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$ExecDocFinSumma is null) then 
    new$ExecDocFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$RegistrationType is null) then 
    new$RegistrationType := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef
      into new$BudgetRef     from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then 
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
  if (new$Supplier_Ref is null and new$SupplierAcc_Ref is not null) then
    BEGIN
      select oa.Org_Ref
      into new$Supplier_Ref   from Org_Accounts oa
      where oa.id = new$SupplierAcc_Ref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('g_ExecDocNumber',1);
      
  else
    BEGIN
      /*          */
      select
      InnerNumber 
      into PreviousInner1$     from ExecutionDocumentsCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner1$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner1$;
      
  END IF;
  /*      id */  
  new$agreementinnernumber := null;
  if (new$agreementref is not null) then
    BEGIN
      select
      innernumber
      into new$agreementinnernumber     from agreements
      where
      id = new$agreementref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_EXECDOCCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_EXECDOCCAPTION_BI_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$     from ExecutionDocumentsCaption
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID), max(ID), max(DocNumber)
    into Tmp$, AdjID$, AdjDocNum$       from ExecutionDocumentsCaption
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp$ <> 1) then
      RaiseException('EX_ExecDoc_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$       from ExecutionDocumentsCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_ExecDoc_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$AdjustmentRef := AdjID$;

  else /*     */
    /*       (    )*/
    new$AdjustmentRef := null;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (tr_execdoccaption_bi_40)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_60 (tr_execdoccaption_bi_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$agreementinnernumber is not null) then
    BEGIN
      /*        , .. 
             ,    ,   
            ,     */
      select accepted, acceptdate     into
      agr_accepted$, agr_acceptdate$ from agreements
      where
      innernumber = new$agreementinnernumber and adjustmentnumber = 0
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*        */
    if (new$acceptdate is null and agr_accepted$ = 0 and agr_acceptdate$ is not null) then
      RaiseException('EX_Agr_Rejected');
    END IF;
    /*        */
    if (new$accepted = 1 and new$acceptdate is not null and
    (agr_accepted$ = 0 or agr_acceptdate$ is null)) then
      RaiseException('EX_Agr_NotAccepted');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_EXECDOCCAPTION_BI_500)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_EXECUTIONDOCUMENTSCAPTION (
    ID,
    DOCTYPE,
    DOCUMENTDATE,
    ACCEPTDATE,
    SUMMA,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    STEPNUMBER,
    FACIALACC_CLS,
    RECIPIENT_REF,
    REGISTRATIONTYPE,
    REESTRNUMBER,
    AGREEMENTINNERNUMBER,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXECDOCFINSUMMA,
    FACT,
    DOCNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REALID,
    INNERNUMBER,
    ADJUSTMENTREF,
    ADJUSTMENTNUMBER,
    ACCEPTED,
    LASTACCEPTED,
    LASTADJUSTMENT,
    AGREEMENTREF,
    NOTE,
    SUPPLIERSTOREDPROPS,
    SUPPLIER_REF,
    SUPPLIERACC_REF,
    REJECTCAUSE,
    INFONUMBER,
    NOTIFYDATE,
    MONEYPROMISENUMBER,
    PURPORTDOC,
    STOREDCONTENT,
    PAYDATE
  ) VALUES (
    new$ID,
    new$DOCTYPE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$SUMMA,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$STEPNUMBER,
    new$FACIALACC_CLS,
    new$RECIPIENT_REF,
    new$REGISTRATIONTYPE,
    new$REESTRNUMBER,
    new$AGREEMENTINNERNUMBER,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXECDOCFINSUMMA,
    new$FACT,
    new$DOCNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTREF,
    new$ADJUSTMENTNUMBER,
    new$ACCEPTED,
    new$LASTACCEPTED,
    new$LASTADJUSTMENT,
    new$AGREEMENTREF,
    new$NOTE,
    new$SUPPLIERSTOREDPROPS,
    new$SUPPLIER_REF,
    new$SUPPLIERACC_REF,
    new$REJECTCAUSE,
    new$INFONUMBER,
    new$NOTIFYDATE,
    new$MONEYPROMISENUMBER,
    new$PURPORTDOC,
    new$STOREDCONTENT,
    new$PAYDATE);

-- - - - - - - - - - - - -
-- AI_0 (TR_ExecDocCaption_AI)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update ExecutionDocuMENTSCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update ExecutionDocuMENTSCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_EXECDOCCAPTION_AI_500)
-- - - - - - - - - - - - -

-- 25.08.2004
  delete from DelRecIndexes where (TableID = 114) and (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_BI
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CurVal$ NUMBER (10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  Tmp$ NUMBER(10);
  AdjID$ NUMBER(10);
  AdjDocNum$ VARCHAR2(150);
  PreviousInner$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
    
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) 
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
    
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
      
  else
    BEGIN
      /*          */
      select
      InnerNumber 
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
      
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /*   5.0*/

  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;
  /*    */
  if (new$AdjustmentNumber > 0) then
    /*      -    */
    select count(ID), max(ID), max(DocNumber)
    into Tmp$, AdjID$, AdjDocNum$             from Agreements
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp$ <> 1) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$AdjustmentRef := AdjID$;
    new$AdjustmentDocNumber := AdjDocNum$;

  else /*     */
    /*       (    )*/
    new$AdjustmentRef := null;
    new$AdjustmentDocNumber := null;

  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_50 (TR_AGREEMENTS_BI_50)
-- Create 06.08.2010
-- - - - - - - - - - - - -

    if (new$InnerNumber is not null) then
        CurVal$ := gen_id('G_AgreementNumber', 0);
        if (CurVal$ < new$InnerNumber) then
          CurVal$ := gen_id('G_AgreementNumber', new$InnerNumber - CurVal$);
        end if;
    end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$PURPORTDOC,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Last update 05.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
        update Agreements set
            LastAdjustment = 0,
            RVersion = -1
        where (ID = new$AdjustmentRef);
        if (new$LastAccepted = 1) then
            update Agreements set
                LastAccepted = 0,
                RVersion = -1
            where (ID = new$AdjustmentRef);
        end if;
    end if;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BI
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  Tmp$ NUMBER(10);
  AdjID$ NUMBER(10);
  CurVal$ NUMBER(10);
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  PreviousInner$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.0*/

  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp$         from TenderCaption
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp$ is null) then
    new$AdjustmentNumber := 0;

  else
    new$AdjustmentNumber := Tmp$ + 1;
  END IF;

  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;

  else
    new$LastAdjustment := 1;
  END IF;

  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;

  else
    new$LastAccepted := 0;
  END IF;

  /*    */
  if (new$AdjustmentNumber > 0) then
    /*      -    */
    select count(ID), max(ID)
    into Tmp$, AdjID$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp$ <> 1) then
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp$ > 0) then
      RaiseException('EX_Ten_AdjustDuplicate');
    END IF;
    /* ,    ,    */
    new$AdjustmentRef := AdjID$;

  else /*     */
    /*       (    )*/
    new$AdjustmentRef := null;

  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_50 (TR_TENDERCAPTION_BI_50)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  if (new$InnerNumber is not null) then
    CurVal$ := GEN_ID('G_TENDERINNERNUMBER',0);
    if (CurVal$ < new$InnerNumber) then
      CurVal$ := GEN_ID('G_TENDERINNERNUMBER',new$InnerNumber - CurVal$);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.0*/
  /*      */
  if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_BI_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CurVal$ NUMBER (10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
  AdjDocNum1$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
    
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) 
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
    
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
      
  else
    BEGIN
      /*          */
      select
      InnerNumber 
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
      
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*      -    */
    select count(ID), max(DocNumber)
    into Tmp1$, AdjDocNum1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp1$ <> 1) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum1$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_50 (TR_AGREEMENTS_BI_50)
-- Create 06.08.2010
-- - - - - - - - - - - - -

    if (new$InnerNumber is not null) then
        CurVal$ := gen_id('G_AgreementNumber', 0);
        if (CurVal$ < new$InnerNumber) then
          CurVal$ := gen_id('G_AgreementNumber', new$InnerNumber - CurVal$);
        end if;
    end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$PURPORTDOC,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Last update 05.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
        update Agreements set
            LastAdjustment = 0,
            RVersion = -1
        where (ID = new$AdjustmentRef);
        if (new$LastAccepted = 1) then
            update Agreements set
                LastAccepted = 0,
                RVersion = -1
            where (ID = new$AdjustmentRef);
        end if;
    end if;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BI_10
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  CurVal$ NUMBER(10);
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;
      
  /*    */  
  select max(AdjustmentNumber)
  into Tmp1$         from TenderCaption 
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/   
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;    
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
          
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID)
    into Tmp1$             from TenderCaption 
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */    
    if (Tmp1$ <> 1) then 
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_Ten_AdjustDuplicate');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_50 (TR_TENDERCAPTION_BI_50)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  if (new$InnerNumber is not null) then
    CurVal$ := GEN_ID('G_TENDERINNERNUMBER',0);
    if (CurVal$ < new$InnerNumber) then
      CurVal$ := GEN_ID('G_TENDERINNERNUMBER',new$InnerNumber - CurVal$);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.0*/
  /*      */
  if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/
-- drop trigger TR_AGREEMENTS_BI_50
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
  AdjDocNum1$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
    
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) 
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
    
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
      
  else
    BEGIN
      /*          */
      select
      InnerNumber 
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
      
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*      -    */
    select count(ID), max(DocNumber)
    into Tmp1$, AdjDocNum1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp1$ <> 1) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum1$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$PURPORTDOC,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Last update 05.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
        update Agreements set
            LastAdjustment = 0,
            RVersion = -1
        where (ID = new$AdjustmentRef);
        if (new$LastAccepted = 1) then
            update Agreements set
                LastAccepted = 0,
                RVersion = -1
            where (ID = new$AdjustmentRef);
        end if;
    end if;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
-- FOR AGREEMENTS
--ACTIVE BEFORE INSERT POSITION 50
--as
--declare variable    CurVal  integer;
--begin
--    if (new.InnerNumber is not null) then
--    begin
--        CurVal = gen_id(G_AgreementNumber, 0);
--        if (CurVal < new.InnerNumber) then
--          CurVal = gen_id(G_AgreementNumber, new.InnerNumber - CurVal);
--    end
--END
-- drop trigger TR_TENDERCAPTION_BI_50
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;
      
  /*    */  
  select max(AdjustmentNumber)
  into Tmp1$         from TenderCaption 
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/   
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;    
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
          
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID)
    into Tmp1$             from TenderCaption 
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */    
    if (Tmp1$ <> 1) then 
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_Ten_AdjustDuplicate');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.0*/
  /*      */
  if ((new$AdjustmentNumber > 0) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/
-- FOR TENDERCAPTION
--ACTIVE BEFORE INSERT POSITION 50
--as
--declare variable    CurVal  integer;
--begin
--    if (new.InnerNumber is not null) then
--    begin
--        CurVal = gen_id(G_TENDERINNERNUMBER, 0);
--        if (CurVal < new.InnerNumber) then
--          CurVal = gen_id(G_TENDERINNERNUMBER, new.InnerNumber - CurVal);
--    end
--END
-- drop trigger TR_AGREEMENTS_BU_50
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  MaxNumber$ NUMBER (10);
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  DetCount1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*   12.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$Region is null) then
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount1$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount1$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*         -   InnerNumber*/
  if (((new$ProgIndex = 305) or (new$ProgIndex = 304) or (new$ProgIndex = 314)) and (new$InnerNumber is null)) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
  END IF;
  /*   */
  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  /*    .  */

  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */

  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_3 (TR_AGREEMENTS_BU_3)
-- Create 03.12.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*            */
   new$AdjustmentRef := :OLD.AdjustmentRef;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Last update 08.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    /* ,      ,   */
    if ((new$InnerNumber <> :old.InnerNumber) or
        (new$AdjustmentNumber <> :old.AdjustmentNumber) or
        (new$AgreementType <> :old.AgreementType)) then
        RaiseException('EX_AGR_ChangeInnerNums');
    end if;

    /*    !!!*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
        ((new$Accepted = 1) or (new$AcceptDate is null))) then
        RaiseException('EX_RollbackCancel');
    end if;

    /*   ,     LastAccepted*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
        ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 1;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*    ,     LastAccepted*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
        ((new$Accepted = 0) or (new$AcceptDate is null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*   ,     LastAdjustment*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
        ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then

        if (new$LastAdjustment = 1) then
            new$LastAdjustment := 0;
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;

        SELECT Max(AdjustmentNumber) INTO MaxNumber$ FROm AgreementS
        WHERE (InnerNumber = new$InnerNumber);
        /*    ,     */
        if ((new$adjustmentNumber=0) and (MaxNumber$<>0)) then
          RaiseException('EX_Agr_PrimaryAgrHasNotify');
        end if;
    end if;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion)) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);

  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
-- FOR AGREEMENTS
--ACTIVE BEFORE UPDATE POSITION 50
--as
--declare variable    CurVal  integer;
--begin
--    if (new.InnerNumber is not null) then
--    begin
--        CurVal = gen_id(G_AgreementNumber, 0);
--        if (CurVal < new.InnerNumber) then
--          CurVal = gen_id(G_AgreementNumber, new.InnerNumber - CurVal);
--    end
--END
-- drop trigger TR_TENDERCAPTION_BU_50
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  DetCount$ NUMBER(10);
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  countLastAdj$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then
    new$TenderOption := 0;
  END IF;
  if (new$InnerNumber is Null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
  END IF;
  if (new$RefinementCause is Null) then
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then
    new$SupportUndertaker := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_3 (TR_TENDERCAPTION_BU_3)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*             */
   new$AdjustmentRef := :OLD.AdjustmentRef;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*   12.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_CHANGEINNERNUMS');
  END IF;

  /*   !!!*/
  if (:old.AcceptDate is not null
  and :old.Accepted = 0
  and (new$Accepted = 1 or new$AcceptDate is null))
  then
    /* :  */
    if (new$AdjustmentNumber > 0) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;

    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
  ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
  ((new$Accepted = 0) or (new$AcceptDate is null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
  ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then
    if (new$LastAdjustment = 1) then
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.1*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*       LastAdjustment    */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_BU
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  MaxNumber$ NUMBER (10);
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;    
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_3 (TR_AGREEMENTS_BU_3)
-- Create 03.12.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*            */
   new$AdjustmentRef := :OLD.AdjustmentRef;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Last update 08.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    /* ,      ,   */
    if ((new$InnerNumber <> :old.InnerNumber) or
        (new$AdjustmentNumber <> :old.AdjustmentNumber) or
        (new$AgreementType <> :old.AgreementType)) then
        RaiseException('EX_AGR_ChangeInnerNums');
    end if;

    /*    !!!*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
        ((new$Accepted = 1) or (new$AcceptDate is null))) then
        RaiseException('EX_RollbackCancel');
    end if;

    /*   ,     LastAccepted*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
        ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 1;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*    ,     LastAccepted*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
        ((new$Accepted = 0) or (new$AcceptDate is null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*   ,     LastAdjustment*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
        ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then

        if (new$LastAdjustment = 1) then
            new$LastAdjustment := 0;
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;

        SELECT Max(AdjustmentNumber) INTO MaxNumber$ FROm AgreementS
        WHERE (InnerNumber = new$InnerNumber);
        /*    ,     */
        if ((new$adjustmentNumber=0) and (MaxNumber$<>0)) then
          RaiseException('EX_Agr_PrimaryAgrHasNotify');
        end if;
    end if;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion)) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);

  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BU_0
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  countLastAdj$ NUMBER(10);
  DetCount1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_3 (TR_TENDERCAPTION_BU_3)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*             */
   new$AdjustmentRef := :OLD.AdjustmentRef;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*   12.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_CHANGEINNERNUMS');
  END IF;

  /*   !!!*/
  if (:old.AcceptDate is not null
  and :old.Accepted = 0
  and (new$Accepted = 1 or new$AcceptDate is null))
  then
    /* :  */
    if (new$AdjustmentNumber > 0) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;

    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
  ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
  ((new$Accepted = 0) or (new$AcceptDate is null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
  ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then
    if (new$LastAdjustment = 1) then
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.1*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*       LastAdjustment    */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- drop trigger TR_AGREEMENTS_BU_3
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  MaxNumber$ NUMBER (10);
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;    
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Last update 08.02.2010
-- - - - - - - - - - - - -

/*   5.0*/
    /* ,      ,   */
    if ((new$InnerNumber <> :old.InnerNumber) or
        (new$AdjustmentNumber <> :old.AdjustmentNumber) or
        (new$AgreementType <> :old.AgreementType)) then
        RaiseException('EX_AGR_ChangeInnerNums');
    end if;

    /*    !!!*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 0)) and
        ((new$Accepted = 1) or (new$AcceptDate is null))) then
        RaiseException('EX_RollbackCancel');
    end if;

    /*   ,     LastAccepted*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
        ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 1;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*    ,     LastAccepted*/
    if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
        ((new$Accepted = 0) or (new$AcceptDate is null))) then
        /*  LastAccepted         */
        if (new$LastAdjustment = 1) then
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;
    end if;

    /*   ,     LastAdjustment*/
    if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
        ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then

        if (new$LastAdjustment = 1) then
            new$LastAdjustment := 0;
            new$LastAccepted := 0;
        else
            RaiseException('EX_AGR_ChangeStateAdjust');
        end if;

        SELECT Max(AdjustmentNumber) INTO MaxNumber$ FROm AgreementS
        WHERE (InnerNumber = new$InnerNumber);
        /*    ,     */
        if ((new$adjustmentNumber=0) and (MaxNumber$<>0)) then
          RaiseException('EX_Agr_PrimaryAgrHasNotify');
        end if;
    end if;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion)) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);

  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
--FOR AGREEMENTS
--ACTIVE BEFORE UPDATE POSITION 3
--as
--begin
--    /*            */
--    new.AdjustmentRef = old.AdjustmentRef;
--end
-- drop trigger TR_TENDERCAPTION_BU_3
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  countLastAdj$ NUMBER(10);
  DetCount1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*   12.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_CHANGEINNERNUMS');
  END IF;

  /*   !!!*/
  if (:old.AcceptDate is not null
  and :old.Accepted = 0
  and (new$Accepted = 1 or new$AcceptDate is null))
  then
    /* :  */
    if (new$AdjustmentNumber > 0) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;

    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 1)) or
  ((:old.Accepted = 0) and (new$Accepted = 1) and (new$AcceptDate is not null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 1;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*    ,     LastAccepted*/
  if (((:old.AcceptDate is not null) and (:old.Accepted = 1)) and
  ((new$Accepted = 0) or (new$AcceptDate is null))) then
    /*  LastAccepted         */
    if (new$LastAdjustment = 1) then
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

  /*   ,     LastAdjustment*/
  if (((:old.AcceptDate is null) and (new$AcceptDate is not null) and (new$Accepted = 0)) or
  ((:old.Accepted = 1) and (new$Accepted = 0) and (new$AcceptDate is not null))) then
    if (new$LastAdjustment = 1) then
      new$LastAdjustment := 0;
      new$LastAccepted := 0;

    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.1*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*       LastAdjustment    */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_BU_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  DetCount$ NUMBER(10);
  countLastAdj$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;    
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*    !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj$       from Agreements
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;
      
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then 
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
          
    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
          
    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
          
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from Agreements
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and 
    (CNT$1<> 0)       ) then
      RaiseException('EX_PrimaryDocHasAdjustment');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion)) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   6.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);

  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_EXECDOCCAPTION_BU_10
CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_IU
  INSTEAD OF UPDATE
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  new$ID EXECUTIONDOCUMENTSCAPTION.ID%TYPE := :NEW.ID;
  new$DOCTYPE EXECUTIONDOCUMENTSCAPTION.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$DOCUMENTDATE EXECUTIONDOCUMENTSCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE EXECUTIONDOCUMENTSCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SUMMA EXECUTIONDOCUMENTSCAPTION.SUMMA%TYPE := :NEW.SUMMA;
  new$CREATERUSER EXECUTIONDOCUMENTSCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE EXECUTIONDOCUMENTSCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE EXECUTIONDOCUMENTSCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER EXECUTIONDOCUMENTSCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF EXECUTIONDOCUMENTSCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$STEPNUMBER EXECUTIONDOCUMENTSCAPTION.STEPNUMBER%TYPE := :NEW.STEPNUMBER;
  new$FACIALACC_CLS EXECUTIONDOCUMENTSCAPTION.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$RECIPIENT_REF EXECUTIONDOCUMENTSCAPTION.RECIPIENT_REF%TYPE := :NEW.RECIPIENT_REF;
  new$REGISTRATIONTYPE EXECUTIONDOCUMENTSCAPTION.REGISTRATIONTYPE%TYPE := :NEW.REGISTRATIONTYPE;
  new$REESTRNUMBER EXECUTIONDOCUMENTSCAPTION.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$AGREEMENTINNERNUMBER EXECUTIONDOCUMENTSCAPTION.AGREEMENTINNERNUMBER%TYPE := :NEW.AGREEMENTINNERNUMBER;
  new$REJECTCLS EXECUTIONDOCUMENTSCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS EXECUTIONDOCUMENTSCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID EXECUTIONDOCUMENTSCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID EXECUTIONDOCUMENTSCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$REVIEWNOTE EXECUTIONDOCUMENTSCAPTION.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF EXECUTIONDOCUMENTSCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION EXECUTIONDOCUMENTSCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$EXECDOCFINSUMMA EXECUTIONDOCUMENTSCAPTION.EXECDOCFINSUMMA%TYPE := :NEW.EXECDOCFINSUMMA;
  new$FACT EXECUTIONDOCUMENTSCAPTION.FACT%TYPE := :NEW.FACT;
  new$DOCNUMBER EXECUTIONDOCUMENTSCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SENDERIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY EXECUTIONDOCUMENTSCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REALID EXECUTIONDOCUMENTSCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER EXECUTIONDOCUMENTSCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTREF EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ADJUSTMENTNUMBER EXECUTIONDOCUMENTSCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$ACCEPTED EXECUTIONDOCUMENTSCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$LASTACCEPTED EXECUTIONDOCUMENTSCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$LASTADJUSTMENT EXECUTIONDOCUMENTSCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$AGREEMENTREF EXECUTIONDOCUMENTSCAPTION.AGREEMENTREF%TYPE := :NEW.AGREEMENTREF;
  new$NOTE EXECUTIONDOCUMENTSCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$SUPPLIERSTOREDPROPS EXECUTIONDOCUMENTSCAPTION.SUPPLIERSTOREDPROPS%TYPE := :NEW.SUPPLIERSTOREDPROPS;
  new$SUPPLIER_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIER_REF%TYPE := :NEW.SUPPLIER_REF;
  new$SUPPLIERACC_REF EXECUTIONDOCUMENTSCAPTION.SUPPLIERACC_REF%TYPE := :NEW.SUPPLIERACC_REF;
  new$REJECTCAUSE EXECUTIONDOCUMENTSCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$INFONUMBER EXECUTIONDOCUMENTSCAPTION.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$NOTIFYDATE EXECUTIONDOCUMENTSCAPTION.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$MONEYPROMISENUMBER EXECUTIONDOCUMENTSCAPTION.MONEYPROMISENUMBER%TYPE := :NEW.MONEYPROMISENUMBER;
  new$PURPORTDOC EXECUTIONDOCUMENTSCAPTION.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$STOREDCONTENT EXECUTIONDOCUMENTSCAPTION.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$PAYDATE EXECUTIONDOCUMENTSCAPTION.PAYDATE%TYPE := :NEW.PAYDATE;
--
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  CntAgr$ NUMBER(10);
  CntStep$ NUMBER(10);
  agr_accepted$ NUMBER(10);
  agr_acceptdate$ NUMBER(10);
  CountExecDoc$ NUMBER(10);
  countLastAdj$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_EXECDOCCAPTION_BU)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$DocType is null) then
    new$DocType := 0;
  END IF;
  if (new$Summa is null) then
    new$Summa := 0;
  END IF;
  if (new$ExecDocFinSumma is null) then
    new$ExecDocFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$RegistrationType is null) then
    new$RegistrationType := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      SELECT COUNT(                   Id
      ) INTO CNT$1
      from ExecutionDocumentsDetail
      where
      (                   RecordIndex = :old.Id
      ) AND (ROWNUM = 1)                ;
      if ((CNT$1<> 0)         ) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      SELECT COUNT(                   Id
      ) INTO CNT$2
      from PaymentSchedule
      where
      (                   ExecutionRef = :old.Id
      ) AND (ROWNUM = 1)                ;
      if ((CNT$2<> 0)         ) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /* c,           */
  /* ,    */
  if (new$InnerNumber <> :old.InnerNumber or
  new$AdjustmentRef <> :old.AdjustmentRef or
  new$AdjustmentNumber <> :old.AdjustmentNumber) then
    RaiseException('EX_Agr_ChangeInnerNums');
  END IF;
  /*      id */
  new$agreementinnernumber := null;
  if (new$agreementref is not null) then
    BEGIN
      select
      innernumber
      into new$agreementinnernumber     from agreements
      where
      id = new$agreementref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_EXECDOCCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_EXECDOCCAPTION_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*     */
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
           , ,          */
    select count(ID)
    into countLastAdj$     from ExecutionDocumentsCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;
      
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then 
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
          
    else
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    END IF;
  END IF;
      
  /*    ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
          
    else
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    END IF;
  END IF;
      
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_ExecDoc_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
          
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from ExecutionDocumentsCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and 
    (CNT$1<> 0)       ) then
      RaiseException('EX_PrimaryDocHasAdjustment');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_40 (tr_execdoccaption_bu_40)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  if ((:old.AcceptDate is not null) and (new$AcceptDate is null)) then
    select count(ID) into CntAgr$ from Agreements where (CloseDoc = :old.ID) ;
    select count(ID) into CntStep$ from AgreementSteps where (CloseDoc = :old.ID) ;
    if ((CntAgr$ > 0) or (CntStep$ > 0)) then
      RaiseException('ex_CannotUpdateCloseDoc');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_execdoccaption_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$agreementinnernumber is not null) then
    BEGIN
      /*        , .. 
             ,    ,   
            ,     */
      select accepted, acceptdate     into
      agr_accepted$, agr_acceptdate$ from agreements
      where
      innernumber = new$agreementinnernumber and adjustmentnumber = 0
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /*        */
    if (new$acceptdate is null and agr_accepted$ = 0 and agr_acceptdate$ is not null) then
      RaiseException('EX_Agr_Rejected');
    END IF;
    /*        */
    if (new$accepted = 1 and new$acceptdate is not null and
    (agr_accepted$ = 0 or agr_acceptdate$ is null)) then
      RaiseException('EX_Agr_NotAccepted');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_EXECDOCCAPTION_BU_200)
-- Create 04.10.2004
-- - - - - - - - - - - - -

  /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_EXECDOCCAPTION_BU_210)
-- Version 11.20.00.1
-- - - - - - - - - - - - -

  /*   */
  if (new$rejectcls is not null and new$accepted = 0) then
    /*         */
    select
    count(ffd.id)
    into CountExecDoc$     from
    facialfindetail ffd
    left join facialfincaption ffc on ffc.id = ffd.recordindex
    where
    (ffc.acceptdate is not null and (ffd.sourceexecdoc = new$id or ffd.destexecdoc = new$id))
    ;
    /*       */
    if (CountExecDoc$ <> 0) then
      RaiseException('ex_exedoc_useinfacialfindetail');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_EDCAPTION_BU_700)
-- Create 14.10.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_EXECUTIONDOCUMENTSCAPTION SET
    ID = new$ID,
    DOCTYPE = new$DOCTYPE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    SUMMA = new$SUMMA,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    STEPNUMBER = new$STEPNUMBER,
    FACIALACC_CLS = new$FACIALACC_CLS,
    RECIPIENT_REF = new$RECIPIENT_REF,
    REGISTRATIONTYPE = new$REGISTRATIONTYPE,
    REESTRNUMBER = new$REESTRNUMBER,
    AGREEMENTINNERNUMBER = new$AGREEMENTINNERNUMBER,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXECDOCFINSUMMA = new$EXECDOCFINSUMMA,
    FACT = new$FACT,
    DOCNUMBER = new$DOCNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    ACCEPTED = new$ACCEPTED,
    LASTACCEPTED = new$LASTACCEPTED,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    AGREEMENTREF = new$AGREEMENTREF,
    NOTE = new$NOTE,
    SUPPLIERSTOREDPROPS = new$SUPPLIERSTOREDPROPS,
    SUPPLIER_REF = new$SUPPLIER_REF,
    SUPPLIERACC_REF = new$SUPPLIERACC_REF,
    REJECTCAUSE = new$REJECTCAUSE,
    INFONUMBER = new$INFONUMBER,
    NOTIFYDATE = new$NOTIFYDATE,
    MONEYPROMISENUMBER = new$MONEYPROMISENUMBER,
    PURPORTDOC = new$PURPORTDOC,
    STOREDCONTENT = new$STOREDCONTENT,
    PAYDATE = new$PAYDATE
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_0 (TR_ExecDocCaption_AU)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*       */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update ExecutionDocuMENTSCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update ExecutionDocuMENTSCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_EXECDOCCAPTION_AU_30)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where ExecutionRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_EXECDOCCAPTION_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (114, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=114) and (RecordId=new$ID);
  end if;

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BU_10
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  DetCount1$ NUMBER(10);
  countLastAdj1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*   !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj1$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj1$ = 0) then
      new$LastAdjustment := 1;
        
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_Ten_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
            
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from TenderCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and
    (CNT$1<> 0)         ) then
      RaiseException('EX_PrimaryDocHasAdjustment');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 7.00.02.1
-- - - - - - - - - - - - -

  /*   5.1*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentNumber > 0) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

  /*       LastAdjustment    */
  if ((new$AdjustmentNumber > 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_AU_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_IU
  INSTEAD OF UPDATE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CNT$1 NUMBER(10);
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  DetCount$ NUMBER(10);
  countLastAdj$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_AGREEMENTS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;    
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)       into DetCount$ from AgreementSteps where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
      select count(ID)       into DetCount$ from Estimate where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_AGREEMENTS_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_AGREEMENTS_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /* ,      ,   */
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber) or
  (new$AgreementType <> :old.AgreementType)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*    !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj$       from Agreements
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj$ = 0) then
      new$LastAdjustment := 1;
      
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then 
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
          
    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
          
    else
      RaiseException('EX_AGR_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment  LastAccepted */
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_AGR_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
          
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from Agreements
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and 
    (CNT$1<> 0)       ) then
      RaiseException('EX_PrimaryDocHasAdjustment');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_20 (TR_AGREEMENTS_BU_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,      */
  if ((new$Client_Ref <> :old.Client_Ref) and
      (((new$Client_INN is null) and
        (:old.Client_INN is null)) or
       (new$Client_INN = :old.Client_INN)) and
      (((new$Client_INN20 is null) and
        (:old.Client_INN20 is null)) or
       (new$Client_INN20 = :old.Client_INN20)) and
      (new$Client_Name = :old.Client_Name)) then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,      */
  if ((new$Executer_Ref <> :old.Executer_Ref) and
      (((new$Executer_INN is null) and
        (:old.Executer_INN is null)) or
       (new$Executer_INN = :old.Executer_INN)) and
      (((new$Executer_INN20 is null) and
        (:old.Executer_INN20 is null)) or
       (new$Executer_INN20 = :old.Executer_INN20)) and
      (new$Executer_Name = :old.Executer_Name) and
      (((new$Executer_Status is null) and
        (:old.Executer_Status is null)) or
       (new$Executer_Status = :old.Executer_Status)) and
      (((new$Executer_Country is null) and
        (:old.Executer_Country is null)) or
       (new$Executer_Country = :old.Executer_Country)) and
      (((new$Executer_Address is null) and
        (:old.Executer_Address is null)) or
       (new$Executer_Address = :old.Executer_Address)) and
      (((new$Executer_Phone is null) and
        (:old.Executer_Phone is null)) or
       (new$Executer_Phone = :old.Executer_Phone))) then
     BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BU_60 (tr_agreements_bu_60)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*        ,     */
  if (:old.accepted = 1 and new$accepted = 0 and new$acceptdate is not null and new$adjustmentnumber = 0) then
    SELECT COUNT(*) INTO CNT$1
    from executiondocumentscaption
    where
    (            agreementinnernumber = new$innernumber
    and (accepted <> 0 or acceptdate is null)) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      RaiseException('EX_Agr_CannotReject');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_AGREEMENTS_BU_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   /*       */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory
                  (DocID, BeginStateRef, EndStateRef
                  )
           VALUES (new$id, :OLD.DocStateRef, new$DocStateRef
                  );
   END IF;

-- - - - - - - - - - - - -
-- BU_300 (tr_agreements_bu_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_400 (TR_AGREEMENTS_BU_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (((new$rnClientID <> :old.rnClientID) or (new$rnYear <> :old.rnYear) or
  (new$rnNumber <> :old.rnNumber) or (new$ReestrVersion <> :old.ReestrVersion)) and
  (new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_600 (agreements_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_AGREEMENTS_BU_700)
-- Create 14.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSE
      IF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
         new$RVersion := :OLD.RVersion;
      ELSE
         new$RVersion := :OLD.RVersion + 1;
      END IF;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_AGREEMENTS SET
    ID = new$ID,
    SUMMA = new$SUMMA,
    AGREEMENTDATE = new$AGREEMENTDATE,
    AGREEMENTENDDATE = new$AGREEMENTENDDATE,
    EXECUTER_REF = new$EXECUTER_REF,
    CLIENT_REF = new$CLIENT_REF,
    FACIALACC_CLS = new$FACIALACC_CLS,
    AGREEMENTTYPE = new$AGREEMENTTYPE,
    ACCEPTED = new$ACCEPTED,
    ACCEPTDATE = new$ACCEPTDATE,
    CARDADVANCEPERCENT = new$CARDADVANCEPERCENT,
    CARDADVANCE = new$CARDADVANCE,
    CLOSEDOC = new$CLOSEDOC,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    BUDGETREF = new$BUDGETREF,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    FACT = new$FACT,
    REGION = new$REGION,
    CLOSEDATE = new$CLOSEDATE,
    DELIVERYRULES = new$DELIVERYRULES,
    AGREEMENTSUMMA = new$AGREEMENTSUMMA,
    AGREEMENTFINSUMMA = new$AGREEMENTFINSUMMA,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    REESTRNUMBER = new$REESTRNUMBER,
    PAYMENTDATE = new$PAYMENTDATE,
    AGREEMENTCARDADVANCE = new$AGREEMENTCARDADVANCE,
    FINCARDADVANCE = new$FINCARDADVANCE,
    STATEORDERREF = new$STATEORDERREF,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    AGREEMENTBEGINDATE = new$AGREEMENTBEGINDATE,
    PROTOCOLNUMBER = new$PROTOCOLNUMBER,
    PROTOCOLDATE = new$PROTOCOLDATE,
    REVIEWNOTE = new$REVIEWNOTE,
    DOCSTATEREF = new$DOCSTATEREF,
    RVERSION = new$RVERSION,
    EXPORTDATE = new$EXPORTDATE,
    FSORGAN = new$FSORGAN,
    FSBUDGETNAME = new$FSBUDGETNAME,
    FSOFFBUDGET = new$FSOFFBUDGET,
    RNYEAR = new$RNYEAR,
    RNNUMBER = new$RNNUMBER,
    RNDATE = new$RNDATE,
    PROTOCOLNOTICE = new$PROTOCOLNOTICE,
    PROTOCOLRESULTDATE = new$PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE = new$PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE = new$PROTOCOLSALETYPE,
    NOTIFYDATE = new$NOTIFYDATE,
    EXECUTERACCREF = new$EXECUTERACCREF,
    DOCBASEDATE = new$DOCBASEDATE,
    DOCBASENOTIFYDATE = new$DOCBASENOTIFYDATE,
    DOCBASETEXT = new$DOCBASETEXT,
    DOCBASETYPE = new$DOCBASETYPE,
    DOCBASESUMMA = new$DOCBASESUMMA,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PROTOCOLREASON = new$PROTOCOLREASON,
    DOCNUMBER = new$DOCNUMBER,
    ADJUSTMENTDOCNUMBER = new$ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER = new$OLDDOCNUMBER,
    LOTMAXSUM = new$LOTMAXSUM,
    CLIENT_INN = new$CLIENT_INN,
    CLIENT_INN20 = new$CLIENT_INN20,
    CLIENT_NAME = new$CLIENT_NAME,
    EXECUTER_INN = new$EXECUTER_INN,
    EXECUTER_INN20 = new$EXECUTER_INN20,
    EXECUTER_NAME = new$EXECUTER_NAME,
    EXECUTER_STATUS = new$EXECUTER_STATUS,
    EXECUTER_COUNTRY = new$EXECUTER_COUNTRY,
    EXECUTER_ADDRESS = new$EXECUTER_ADDRESS,
    EXECUTER_PHONE = new$EXECUTER_PHONE,
    REALID = new$REALID,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    INNERNUMBER = new$INNERNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    REESTRVERSION = new$REESTRVERSION,
    DOCTYPE = new$DOCTYPE,
    RNCLIENTID = new$RNCLIENTID,
    INFONUMBER = new$INFONUMBER,
    STATEORDERINNERNUMBER = new$STATEORDERINNERNUMBER,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    PURPORTDOC = new$PURPORTDOC,
    REESTRRECORDNUMBER = new$REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS = new$EXECUTERSTOREDPROPS,
    AUTOSANCTION = new$AUTOSANCTION,
    PURCHASECODE = new$PURCHASECODE,
    DOCUMENTNUMBER = new$DOCUMENTNUMBER,
    REJECTCAUSE = new$REJECTCAUSE,
    TENDERREF = new$TENDERREF,
    TENDERINNERNUMBER = new$TENDERINNERNUMBER,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_AGREEMENTS_AU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*       LastAdjustment     */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
  /*          */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 304)or(new$ProgIndex = 314)))then
    update Estimate
    set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    (RecordIndex = new$Id);
  END IF;
  /*         */
  if ((new$FacialAcc_Cls <> :old.FacialAcc_Cls) and ((new$ProgIndex = 305) or (new$ProgIndex = 314))) then
    update paymentschedule set
    FacialAcc_Cls = new$FacialAcc_Cls,
    RVersion = -1
    where
    AgreementRef = new$ID and
    ProgIndex in (317, 318);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_AGREEMENTS_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*      */
  if ((new$ProgIndex = 305) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  /*      */
  if ((new$ProgIndex = 314) and (new$AdjustmentNumber = 0) and
  (new$Accepted = 0) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  /*     */
  if ((:old.ProgIndex = 304) and (new$AdjustmentNumber = 0) and (new$Accepted = 0) and
  (:old.LastAdjustment = 1) and (new$LastAdjustment = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (TR_AGREEMENTS_AU_30)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) and /*     ,        */
  ((new$ProgIndex = 304) or (new$ProgIndex = 314)) and
  ((new$Accepted <> :old.Accepted) or
  (new$AcceptDate is not null and :old.AcceptDate is null) or
  (new$AcceptDate is null and :old.AcceptDate is not null) or
  (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))) then
    update paymentschedule set
    Accepted = new$Accepted,
    AcceptDate = new$AcceptDate
    where AgreementRef=new$ID;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_AGREEMENTS_AU_500)
-- Create 28.04.2005
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes
                  (TableID, RecordId, DeleteDate
                  )
           VALUES (110, :OLD.ID, SYSDATE
                  );

      DELETE FROM DelRecIndexes
            WHERE (TableID = 110) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_AU_10
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  DetCount1$ NUMBER(10);
  countLastAdj1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*   !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj1$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj1$ = 0) then
      new$LastAdjustment := 1;
        
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_Ten_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
            
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from TenderCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and
    (CNT$1<> 0)         ) then
      RaiseException('EX_PrimaryDocHasAdjustment');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
          
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_AD_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_ID
  INSTEAD OF DELETE
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_AGREEMENTS_BD)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  select count(id) into cnt$ from agreements where (adjustmentref = :old.id) ;
  /*  .       .*/
  if (cnt$ <> 0) then
    RaiseException('ex_agr_cantdeladjustmented');
  else
    delete from estimate where (recordindex = :old.id);
    delete from agreementsteps where (recordindex = :old.id);
    delete from paymentschedule where agreementref = :old.id;
    delete from Suppliers where recordindex = :old.id;
      
  END IF;

-- - - - - - - - - - - - -
-- BD_20 (TR_AGREEMENTS_BD_20)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*          */
  if ((:old.ProgIndex = 305)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 314)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    StateOrder = null,
    Agreement = null
    where
    StateOrder = :old.ID;
  END IF;
  if ((:old.ProgIndex = 304)and(:old.AdjustmentNumber = 0)) then
    update tenderresultcaption set
    Agreement = null
    where
    Agreement = :old.ID;
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_AGREEMENTS
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_10 (TR_AGREEMENTS_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */    
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update Agreements set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_AGREEMENTS_AD_200)
-- Create 04.10.2004
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_AGREEMENTS_AD_500)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, Summa, ProgIndex)
  values (110, :old.ID, SYSDATE, :old.AgreementSumma, :old.ProgIndex);

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_AD_10
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_ID
  INSTEAD OF DELETE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_TENDERCAPTION_BD)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   5.1 */
  select count(ID) into cnt$ from TenderCaption where (AdjustmentRef = :old.ID) ;
  /*    ,    */
  if (cnt$ = 0) then
    delete from TenderSupDocument where (RecordIndex = :old.ID);
    delete from TenderYardsticks where (RecordIndex = :old.ID);
    delete from TenderSourceOrg where (RecordIndex = :old.ID);
    delete from TenderContacts where (RecordIndex = :old.ID);
    delete from TenderSupplements where (RecordIndex = :old.ID);
    delete from TenderProduct where (RecordIndex = :old.ID);
    delete from TenderLot where (RecordIndex = :old.ID);

  else
    RaiseException('EX_Ten_CantDelAdjustmented');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_TENDERCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_0 (TR_TenderCaption_AD)
-- Last update 06.08.2010
-- - - - - - - - - - - - -

  delete from TENDERPRODUCT where (RecordIndex = :old.ID);
  delete from TenderSourceOrg where (RecordIndex = :old.ID);

-- - - - - - - - - - - - -
-- AD_10 (TR_TENDERCAPTION_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */    
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update TenderCaption set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_TENDERCAPTION_AD_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  /*         */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_TENDERCAPTION_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex) values (139, :old.ID, SYSDATE, :old.ProgIndex);

END;
/
-- CREATE TRIGGER TR_AGREEMENTS_AI_10
CREATE OR REPLACE TRIGGER TR_AGREEMENTS_II
  INSTEAD OF INSERT
  ON AGREEMENTS
  FOR EACH ROW
DECLARE
  new$ID AGREEMENTS.ID%TYPE := :NEW.ID;
  new$SUMMA AGREEMENTS.SUMMA%TYPE := :NEW.SUMMA;
  new$AGREEMENTDATE AGREEMENTS.AGREEMENTDATE%TYPE := :NEW.AGREEMENTDATE;
  new$AGREEMENTENDDATE AGREEMENTS.AGREEMENTENDDATE%TYPE := :NEW.AGREEMENTENDDATE;
  new$EXECUTER_REF AGREEMENTS.EXECUTER_REF%TYPE := :NEW.EXECUTER_REF;
  new$CLIENT_REF AGREEMENTS.CLIENT_REF%TYPE := :NEW.CLIENT_REF;
  new$FACIALACC_CLS AGREEMENTS.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$AGREEMENTTYPE AGREEMENTS.AGREEMENTTYPE%TYPE := :NEW.AGREEMENTTYPE;
  new$ACCEPTED AGREEMENTS.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$ACCEPTDATE AGREEMENTS.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$CARDADVANCEPERCENT AGREEMENTS.CARDADVANCEPERCENT%TYPE := :NEW.CARDADVANCEPERCENT;
  new$CARDADVANCE AGREEMENTS.CARDADVANCE%TYPE := :NEW.CARDADVANCE;
  new$CLOSEDOC AGREEMENTS.CLOSEDOC%TYPE := :NEW.CLOSEDOC;
  new$CREATERUSER AGREEMENTS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE AGREEMENTS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE AGREEMENTS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER AGREEMENTS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$BUDGETREF AGREEMENTS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$LASTADJUSTMENT AGREEMENTS.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED AGREEMENTS.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$FACT AGREEMENTS.FACT%TYPE := :NEW.FACT;
  new$REGION AGREEMENTS.REGION%TYPE := :NEW.REGION;
  new$CLOSEDATE AGREEMENTS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$DELIVERYRULES AGREEMENTS.DELIVERYRULES%TYPE := :NEW.DELIVERYRULES;
  new$AGREEMENTSUMMA AGREEMENTS.AGREEMENTSUMMA%TYPE := :NEW.AGREEMENTSUMMA;
  new$AGREEMENTFINSUMMA AGREEMENTS.AGREEMENTFINSUMMA%TYPE := :NEW.AGREEMENTFINSUMMA;
  new$ADJUSTMENTREF AGREEMENTS.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$REESTRNUMBER AGREEMENTS.REESTRNUMBER%TYPE := :NEW.REESTRNUMBER;
  new$PAYMENTDATE AGREEMENTS.PAYMENTDATE%TYPE := :NEW.PAYMENTDATE;
  new$AGREEMENTCARDADVANCE AGREEMENTS.AGREEMENTCARDADVANCE%TYPE := :NEW.AGREEMENTCARDADVANCE;
  new$FINCARDADVANCE AGREEMENTS.FINCARDADVANCE%TYPE := :NEW.FINCARDADVANCE;
  new$STATEORDERREF AGREEMENTS.STATEORDERREF%TYPE := :NEW.STATEORDERREF;
  new$REJECTCLS AGREEMENTS.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS AGREEMENTS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID AGREEMENTS.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID AGREEMENTS.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$AGREEMENTBEGINDATE AGREEMENTS.AGREEMENTBEGINDATE%TYPE := :NEW.AGREEMENTBEGINDATE;
  new$PROTOCOLNUMBER AGREEMENTS.PROTOCOLNUMBER%TYPE := :NEW.PROTOCOLNUMBER;
  new$PROTOCOLDATE AGREEMENTS.PROTOCOLDATE%TYPE := :NEW.PROTOCOLDATE;
  new$REVIEWNOTE AGREEMENTS.REVIEWNOTE%TYPE := :NEW.REVIEWNOTE;
  new$DOCSTATEREF AGREEMENTS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$RVERSION AGREEMENTS.RVERSION%TYPE := :NEW.RVERSION;
  new$EXPORTDATE AGREEMENTS.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$FSORGAN AGREEMENTS.FSORGAN%TYPE := :NEW.FSORGAN;
  new$FSBUDGETNAME AGREEMENTS.FSBUDGETNAME%TYPE := :NEW.FSBUDGETNAME;
  new$FSOFFBUDGET AGREEMENTS.FSOFFBUDGET%TYPE := :NEW.FSOFFBUDGET;
  new$RNYEAR AGREEMENTS.RNYEAR%TYPE := :NEW.RNYEAR;
  new$RNNUMBER AGREEMENTS.RNNUMBER%TYPE := :NEW.RNNUMBER;
  new$RNDATE AGREEMENTS.RNDATE%TYPE := :NEW.RNDATE;
  new$PROTOCOLNOTICE AGREEMENTS.PROTOCOLNOTICE%TYPE := :NEW.PROTOCOLNOTICE;
  new$PROTOCOLRESULTDATE AGREEMENTS.PROTOCOLRESULTDATE%TYPE := :NEW.PROTOCOLRESULTDATE;
  new$PROTOCOLDOCTYPE AGREEMENTS.PROTOCOLDOCTYPE%TYPE := :NEW.PROTOCOLDOCTYPE;
  new$PROTOCOLSALETYPE AGREEMENTS.PROTOCOLSALETYPE%TYPE := :NEW.PROTOCOLSALETYPE;
  new$NOTIFYDATE AGREEMENTS.NOTIFYDATE%TYPE := :NEW.NOTIFYDATE;
  new$EXECUTERACCREF AGREEMENTS.EXECUTERACCREF%TYPE := :NEW.EXECUTERACCREF;
  new$DOCBASEDATE AGREEMENTS.DOCBASEDATE%TYPE := :NEW.DOCBASEDATE;
  new$DOCBASENOTIFYDATE AGREEMENTS.DOCBASENOTIFYDATE%TYPE := :NEW.DOCBASENOTIFYDATE;
  new$DOCBASETEXT AGREEMENTS.DOCBASETEXT%TYPE := :NEW.DOCBASETEXT;
  new$DOCBASETYPE AGREEMENTS.DOCBASETYPE%TYPE := :NEW.DOCBASETYPE;
  new$DOCBASESUMMA AGREEMENTS.DOCBASESUMMA%TYPE := :NEW.DOCBASESUMMA;
  new$UNKNOWNAMOUNT AGREEMENTS.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PROTOCOLREASON AGREEMENTS.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$DOCNUMBER AGREEMENTS.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ADJUSTMENTDOCNUMBER AGREEMENTS.ADJUSTMENTDOCNUMBER%TYPE := :NEW.ADJUSTMENTDOCNUMBER;
  new$OLDDOCNUMBER AGREEMENTS.OLDDOCNUMBER%TYPE := :NEW.OLDDOCNUMBER;
  new$LOTMAXSUM AGREEMENTS.LOTMAXSUM%TYPE := :NEW.LOTMAXSUM;
  new$CLIENT_INN AGREEMENTS.CLIENT_INN%TYPE := :NEW.CLIENT_INN;
  new$CLIENT_INN20 AGREEMENTS.CLIENT_INN20%TYPE := :NEW.CLIENT_INN20;
  new$CLIENT_NAME AGREEMENTS.CLIENT_NAME%TYPE := :NEW.CLIENT_NAME;
  new$EXECUTER_INN AGREEMENTS.EXECUTER_INN%TYPE := :NEW.EXECUTER_INN;
  new$EXECUTER_INN20 AGREEMENTS.EXECUTER_INN20%TYPE := :NEW.EXECUTER_INN20;
  new$EXECUTER_NAME AGREEMENTS.EXECUTER_NAME%TYPE := :NEW.EXECUTER_NAME;
  new$EXECUTER_STATUS AGREEMENTS.EXECUTER_STATUS%TYPE := :NEW.EXECUTER_STATUS;
  new$EXECUTER_COUNTRY AGREEMENTS.EXECUTER_COUNTRY%TYPE := :NEW.EXECUTER_COUNTRY;
  new$EXECUTER_ADDRESS AGREEMENTS.EXECUTER_ADDRESS%TYPE := :NEW.EXECUTER_ADDRESS;
  new$EXECUTER_PHONE AGREEMENTS.EXECUTER_PHONE%TYPE := :NEW.EXECUTER_PHONE;
  new$REALID AGREEMENTS.REALID%TYPE := :NEW.REALID;
  new$ADJUSTMENTNUMBER AGREEMENTS.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$INNERNUMBER AGREEMENTS.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$SENDERIDKEY AGREEMENTS.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY AGREEMENTS.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$REESTRVERSION AGREEMENTS.REESTRVERSION%TYPE := :NEW.REESTRVERSION;
  new$DOCTYPE AGREEMENTS.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$RNCLIENTID AGREEMENTS.RNCLIENTID%TYPE := :NEW.RNCLIENTID;
  new$INFONUMBER AGREEMENTS.INFONUMBER%TYPE := :NEW.INFONUMBER;
  new$STATEORDERINNERNUMBER AGREEMENTS.STATEORDERINNERNUMBER%TYPE := :NEW.STATEORDERINNERNUMBER;
  new$PROGINDEX AGREEMENTS.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE AGREEMENTS.NOTE%TYPE := :NEW.NOTE;
  new$PURPORTDOC AGREEMENTS.PURPORTDOC%TYPE := :NEW.PURPORTDOC;
  new$REESTRRECORDNUMBER AGREEMENTS.REESTRRECORDNUMBER%TYPE := :NEW.REESTRRECORDNUMBER;
  new$EXECUTERSTOREDPROPS AGREEMENTS.EXECUTERSTOREDPROPS%TYPE := :NEW.EXECUTERSTOREDPROPS;
  new$AUTOSANCTION AGREEMENTS.AUTOSANCTION%TYPE := :NEW.AUTOSANCTION;
  new$PURCHASECODE AGREEMENTS.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$DOCUMENTNUMBER AGREEMENTS.DOCUMENTNUMBER%TYPE := :NEW.DOCUMENTNUMBER;
  new$REJECTCAUSE AGREEMENTS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$TENDERREF AGREEMENTS.TENDERREF%TYPE := :NEW.TENDERREF;
  new$TENDERINNERNUMBER AGREEMENTS.TENDERINNERNUMBER%TYPE := :NEW.TENDERINNERNUMBER;
  new$STOREDCONTENT AGREEMENTS.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  CountAcc$ NUMBER(10);
  rnClientID1$ VARCHAR2(15);
  rnYear1$ VARCHAR2(15);
  rnNumber1$ VARCHAR2(15);
  ReestrVersion1$ VARCHAR2(15);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
  AdjDocNum1$ VARCHAR2(150);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_AGREEMENTS_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    -*/
  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$CardAdvancePercent is null) then 
    new$CardAdvancePercent := 0;
  END IF;
  if (new$CardAdvance is null) then 
    new$CardAdvance := 0;
  END IF;
  if (new$AgreementCardAdvance is null) then 
    new$AgreementCardAdvance := 0;
  END IF;
  if (new$FinCardAdvance is null) then 
    new$FinCardAdvance := 0;
  END IF;
  if (new$Summa is null) then 
    new$Summa := 0;
  END IF;
  if (new$AgreementSumma is null) then 
    new$AgreementSumma := 0;
  END IF;
  if (new$AgreementFinSumma is null) then 
    new$AgreementFinSumma := 0;
  END IF;
  if (new$FacialAcc_Cls is null) then 
    new$FacialAcc_Cls := 0;
  END IF;
  if (new$Fact is null) then 
    new$Fact := 0;
  END IF;
  if (new$Region is null) then 
    new$Region := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$client_ref is null) then 
    new$client_ref := 0;
  END IF;
    
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef     into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAcc_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) 
  then 
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
    
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_AgreementNumber',1);
      
  else
    BEGIN
      /*          */
      select
      InnerNumber 
      into PreviousInner$     from Agreements
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
      
  END IF;
  /*   */
  if (new$DocType is null) then 
    new$DocType := 0;
  END IF;
  /*    .  */
    
  new$stateorderinnernumber := null;
  if (new$stateorderref is not null) then
    BEGIN
      select
      innernumber
      into new$stateorderinnernumber     from agreements
      where
      id = new$stateorderref
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*     30.  id */
    
  new$TenderInnerNumber := null;
  if (new$TenderRef is not null) then
    BEGIN
      select InnerNumber 
      into new$TenderInnerNumber     from TenderCaption
      where id = new$TenderRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_AGREEMENTS_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_AGREEMENTS_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_AGR_InnerNumsIsNull');
  END IF;

  /*    */
  select max(AdjustmentNumber)
  into Tmp1$         from Agreements
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;
  END IF;
  /*        */
  if (((new$AgreementType = 0) and (new$AdjustmentNumber > 0)) or
  ((new$AgreementType = 1) and (new$AdjustmentNumber = 0))) then
    RaiseException('EX_AGR_AgrTypeViolation');
  END IF;
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
  /*     */
  if (new$AdjustmentRef is null) then
    new$AdjustmentDocNumber := null;
        
  else
    /*    */
    /*      -    */
    select count(ID), max(DocNumber)
    into Tmp1$, AdjDocNum1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */
    if (Tmp1$ <> 1) then
      RaiseException('EX_AGR_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID)
    into Tmp1$             from Agreements
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then
      RaiseException('EX_AGR_AdjustDuplicate');
    END IF;
    new$AdjustmentDocNumber := AdjDocNum1$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_20 (TR_AGREEMENTS_BI_20)
-- Create 21.05.2009
-- - - - - - - - - - - - -

  /*    -,     */
  if ((new$Client_INN   is null) and
      (new$Client_INN20 is null) and
      (new$Client_Name  is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name
      into
        new$Client_INN,
        new$Client_INN20,
        new$Client_Name
      from Organizations o
      where o.Id=new$Client_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Client_INN := NULL;
        new$Client_INN20 := NULL;
        new$Client_Name := NULL;
    END;
  END IF;

  /*    -,     */
  if ((new$Executer_INN     is null) and
      (new$Executer_INN20   is null) and
      (new$Executer_Name    is null) and
      (new$Executer_Status  is null) and
      (new$Executer_Country is null) and
      (new$Executer_Address is null) and
      (new$Executer_Phone   is null))then
    BEGIN
      select
        o.INN,
        o.INN20,
        o.Name,
        o.SupplierStatus,
        o.Country,
        o.Address,
        o.Phone
      into
        new$Executer_INN,
        new$Executer_INN20,
        new$Executer_Name,
        new$Executer_Status,
        new$Executer_Country,
        new$Executer_Address,
        new$Executer_Phone
      from Organizations o
      where o.Id=new$Executer_Ref;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        new$Executer_INN := NULL;
        new$Executer_INN20 := NULL;
        new$Executer_Name := NULL;
        new$Executer_Status := NULL;
        new$Executer_Country := NULL;
        new$Executer_Address := NULL;
        new$Executer_Phone := NULL;
    END;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_AGREEMENTS_BI_40)
-- Create 06.08.2010
-- - - - - - - - - - - - -

  /*       */
  if (new$senderId is null) then
    new$senderIdKey := -1;
  else
    new$senderIdKey := new$senderId;
  end if;

  if (new$SenderRecordID is null)then
    new$SenderRecordIDKey := new$ID;
  else
    new$SenderRecordIDKey := new$SenderRecordID;
  end if;

-- - - - - - - - - - - - -
-- BI_300 (tr_agreements_bi_300)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  if (new$ExecuterAccRef is not null) then
    select count(ID)
    into CountAcc$     from org_accounts oa
    where oa.id = new$ExecuterAccRef and oa.Org_ref = new$Executer_Ref
    ;
    if (CountAcc$ = 0) then
      RaiseException('EX_AGR_ACCORGCHECK');
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_400 (TR_AGREEMENTS_BI_400)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if ((new$rnClientID is not null) and (new$rnYear is not null) and (new$rnNumber is not null)) then

    rnClientID1$ := new$rnClientID;
    rnYear1$ := new$rnYear;
    rnNumber1$ := new$rnNumber;
    ReestrVersion1$ := new$ReestrVersion;
    while (LENGTH(rnClientID1$) < 11) LOOP
      rnClientID1$ := '0' || rnClientID1$;
    END LOOP;
    while (LENGTH(rnNumber1$) < 6) LOOP
      rnNumber1$ := '0' || rnNumber1$;
    END LOOP;
    if (LENGTH(ReestrVersion1$) < 2) then
      ReestrVersion1$ := '0' || ReestrVersion1$;
    END IF;
    /*  ReestrRecordNumber*/
    if (new$ReestrVersion is null) then
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$;

    else
      new$ReestrRecordNumber := rnClientID1$ || rnYear1$ || rnNumber1$ || ReestrVersion1$;

    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_AGREEMENTS_BI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (agreements_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_AGREEMENTS (
    ID,
    SUMMA,
    AGREEMENTDATE,
    AGREEMENTENDDATE,
    EXECUTER_REF,
    CLIENT_REF,
    FACIALACC_CLS,
    AGREEMENTTYPE,
    ACCEPTED,
    ACCEPTDATE,
    CARDADVANCEPERCENT,
    CARDADVANCE,
    CLOSEDOC,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    BUDGETREF,
    LASTADJUSTMENT,
    LASTACCEPTED,
    FACT,
    REGION,
    CLOSEDATE,
    DELIVERYRULES,
    AGREEMENTSUMMA,
    AGREEMENTFINSUMMA,
    ADJUSTMENTREF,
    REESTRNUMBER,
    PAYMENTDATE,
    AGREEMENTCARDADVANCE,
    FINCARDADVANCE,
    STATEORDERREF,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    AGREEMENTBEGINDATE,
    PROTOCOLNUMBER,
    PROTOCOLDATE,
    REVIEWNOTE,
    DOCSTATEREF,
    RVERSION,
    EXPORTDATE,
    FSORGAN,
    FSBUDGETNAME,
    FSOFFBUDGET,
    RNYEAR,
    RNNUMBER,
    RNDATE,
    PROTOCOLNOTICE,
    PROTOCOLRESULTDATE,
    PROTOCOLDOCTYPE,
    PROTOCOLSALETYPE,
    NOTIFYDATE,
    EXECUTERACCREF,
    DOCBASEDATE,
    DOCBASENOTIFYDATE,
    DOCBASETEXT,
    DOCBASETYPE,
    DOCBASESUMMA,
    UNKNOWNAMOUNT,
    PROTOCOLREASON,
    DOCNUMBER,
    ADJUSTMENTDOCNUMBER,
    OLDDOCNUMBER,
    LOTMAXSUM,
    CLIENT_INN,
    CLIENT_INN20,
    CLIENT_NAME,
    EXECUTER_INN,
    EXECUTER_INN20,
    EXECUTER_NAME,
    EXECUTER_STATUS,
    EXECUTER_COUNTRY,
    EXECUTER_ADDRESS,
    EXECUTER_PHONE,
    REALID,
    ADJUSTMENTNUMBER,
    INNERNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    REESTRVERSION,
    DOCTYPE,
    RNCLIENTID,
    INFONUMBER,
    STATEORDERINNERNUMBER,
    PROGINDEX,
    NOTE,
    PURPORTDOC,
    REESTRRECORDNUMBER,
    EXECUTERSTOREDPROPS,
    AUTOSANCTION,
    PURCHASECODE,
    DOCUMENTNUMBER,
    REJECTCAUSE,
    TENDERREF,
    TENDERINNERNUMBER,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$SUMMA,
    new$AGREEMENTDATE,
    new$AGREEMENTENDDATE,
    new$EXECUTER_REF,
    new$CLIENT_REF,
    new$FACIALACC_CLS,
    new$AGREEMENTTYPE,
    new$ACCEPTED,
    new$ACCEPTDATE,
    new$CARDADVANCEPERCENT,
    new$CARDADVANCE,
    new$CLOSEDOC,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$BUDGETREF,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$FACT,
    new$REGION,
    new$CLOSEDATE,
    new$DELIVERYRULES,
    new$AGREEMENTSUMMA,
    new$AGREEMENTFINSUMMA,
    new$ADJUSTMENTREF,
    new$REESTRNUMBER,
    new$PAYMENTDATE,
    new$AGREEMENTCARDADVANCE,
    new$FINCARDADVANCE,
    new$STATEORDERREF,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$AGREEMENTBEGINDATE,
    new$PROTOCOLNUMBER,
    new$PROTOCOLDATE,
    new$REVIEWNOTE,
    new$DOCSTATEREF,
    new$RVERSION,
    new$EXPORTDATE,
    new$FSORGAN,
    new$FSBUDGETNAME,
    new$FSOFFBUDGET,
    new$RNYEAR,
    new$RNNUMBER,
    new$RNDATE,
    new$PROTOCOLNOTICE,
    new$PROTOCOLRESULTDATE,
    new$PROTOCOLDOCTYPE,
    new$PROTOCOLSALETYPE,
    new$NOTIFYDATE,
    new$EXECUTERACCREF,
    new$DOCBASEDATE,
    new$DOCBASENOTIFYDATE,
    new$DOCBASETEXT,
    new$DOCBASETYPE,
    new$DOCBASESUMMA,
    new$UNKNOWNAMOUNT,
    new$PROTOCOLREASON,
    new$DOCNUMBER,
    new$ADJUSTMENTDOCNUMBER,
    new$OLDDOCNUMBER,
    new$LOTMAXSUM,
    new$CLIENT_INN,
    new$CLIENT_INN20,
    new$CLIENT_NAME,
    new$EXECUTER_INN,
    new$EXECUTER_INN20,
    new$EXECUTER_NAME,
    new$EXECUTER_STATUS,
    new$EXECUTER_COUNTRY,
    new$EXECUTER_ADDRESS,
    new$EXECUTER_PHONE,
    new$REALID,
    new$ADJUSTMENTNUMBER,
    new$INNERNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$REESTRVERSION,
    new$DOCTYPE,
    new$RNCLIENTID,
    new$INFONUMBER,
    new$STATEORDERINNERNUMBER,
    new$PROGINDEX,
    new$NOTE,
    new$PURPORTDOC,
    new$REESTRRECORDNUMBER,
    new$EXECUTERSTOREDPROPS,
    new$AUTOSANCTION,
    new$PURCHASECODE,
    new$DOCUMENTNUMBER,
    new$REJECTCAUSE,
    new$TENDERREF,
    new$TENDERINNERNUMBER,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_10 (TR_AGREEMENTS_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update Agreements set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);        
    if (new$LastAccepted = 1) then
      update Agreements set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_AGREEMENTS_AI_500)
-- Last update 19.05.2005
-- - - - - - - - - - - - -

   DELETE FROM DelRecIndexes
         WHERE (TableID = 110) AND (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_AI_10
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;
      
  /*    */  
  select max(AdjustmentNumber)
  into Tmp1$         from TenderCaption 
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/   
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;    
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
          
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID)
    into Tmp1$             from TenderCaption 
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */    
    if (Tmp1$ <> 1) then 
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_Ten_AdjustDuplicate');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);            
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/
-- drop trigger TR_DOCEXECCAPTION_BD_10
CREATE OR REPLACE TRIGGER TR_EXECUTIONDOCUMENTSCAPTIO_ID
  INSTEAD OF DELETE
  ON EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  quant$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_DOCEXECCAPTION_BD)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  select count(ID)   into quant$ from executiondocumentscaption
  where AdjustmentRef = :old.ID
  ;
  if (quant$  = 0) then
    delete from ExecutionDocumentsDetail where (RecordIndex = :old.ID);
    delete from paymentschedule where (ExecutionRef = :old.ID)and(ProgIndex=308);

  else
    RaiseException('ex_agr_cantdeladjustmented');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_EXECUTIONDOCUMENTSCAPTION
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_10 (TR_ExecDocCaption_AD_10)
-- Version 7.00.01.1
-- - - - - - - - - - - - -

  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update ExecutionDocumentsCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update ExecutionDocumentsCaption set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_EXECDOCCAPTION_AD_200)
-- Create 04.10.2004
-- - - - - - - - - - - - -

  /*        */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_EXECDOCCAPTION_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, SUMMA) values (114, :old.ID, SYSDATE, :old.SUMMA);

END;
/
-- FOR EXECUTIONDOCUMENTSCAPTION
--ACTIVE BEFORE DELETE POSITION 10
--as
--begin
--    /*  LastAdjustment     */
--    if ((old.AdjustmentRef is not null) and (old.LastAdjustment = 1)) then
--        update ExecutionDocumentsCaption set
--            LastAdjustment = 1,
--            RVersion = -1
--        where (ID = old.AdjustmentRef);
--    /*  LastAccepted     */
--    if ((old.AdjustmentRef is not null) and (old.LastAccepted = 1)) then
--        update ExecutionDocumentsCaption set
--            LastAccepted = 1,
--            RVersion = -1
--        where (ID = old.AdjustmentRef);
--end
DELETE FROM SqlExceptions WHERE UPPER(Name) = UPPER('EX_ExecDoc_NotFindInner')
/
DELETE FROM SqlExceptions WHERE UPPER(Name) = UPPER('EX_Agr_PrimaryAgrHasNotify')
/
DELETE FROM SqlExceptions WHERE UPPER(Name) = UPPER('EX_ExecDoc_PrimaryAgrHasNotify')
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_BudNotify_Add_Start_End_Dates.sql
-- #########################################################
-- #########################################################

/*   "  "  "  " *//*   BudNotify  / 02.15   14 / */
ALTER TABLE TB_BudNotify ADD (
  StartDate NUMBER,
  EndDate NUMBER
)
/

CREATE OR REPLACE VIEW BudNotify (
  ID,
  DAT,
  DOCDAT,
  NOTIFYTYPE,
  BUDGETREF,
  DOCBASE,
  VARIANT,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  SENDERID,
  SENDERRECORDID,
  ATYPE,
  DOCUMENTSTATE,
  USERSVISA,
  DATEINPUT,
  ORGREF,
  REJECTCLS,
  PLANDOCTYPE,
  RECORDINDEX,
  STIMATEID,
  CRYPTOSTATUS,
  RVERSION,
  DOCSTATEREF,
  FACIALACCCLS,
  LASTEXTRCHANGE,
  BIDNUMBER,
  FAXDOCCOUNT,
  PLANKIND,
  ASSIGNMENTSOURCE,
  BA_LBO_FLAG,
  KPPERIOD,
  CLSTYPE,
  DATE_UTV_PP,
  PROGINDEX,
  NOTE,
  NOTE2,
  DOCCHANGEDATE,
  SIGNERS,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  EXTID,
  EXTROOTID,
  NOTE1,
  REJECTNOTE,
  STOREDCONTENT,
  DATABLOCKFLAG,
  DOCNUMBER,
  ANUMBER,
  STARTDATE,
  ENDDATE)
AS
  SELECT
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER,
    STARTDATE,
    ENDDATE
  FROM TB_BudNotify
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_ID
  INSTEAD OF DELETE
  ON BUDNOTIFY
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDNOTIFY_BD)
-- - - - - - - - - - - - -

  delete from BudgetData where (RecordIndex = :old.id);

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDNOTIFY
  WHERE id=:old.id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDNOTIFY_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(tableid, recordid, deletedate, createruser, progindex) values(28, :old.id, SYSDATE, user, :old.progindex);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_II
  INSTEAD OF INSERT
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
--
  UseFax$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDNOTIFY_BI)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType is null) or (new$PlanDocType < 100)) then
    new$PlanDocType := 200;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    new$AType := 1;
  END IF;
  if ((new$BudgetRef is null) or (new$BudgetRef = 0))
  then
    GetIntConst(-1, 3,new$BudgetRef);
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> 0)and(new$OrgRef is null)) then
    BEGIN
      /*         
             - \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*         */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_BUDNOTIFY_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_430 (TR_BUDNOTIFY_BI_430)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$SenderID IS NOT NULL) THEN 
    /*        */
    GetIntConst(30, 19,UseFax$);
    IF ((new$BidNumber IS NULL) AND (UseFax$ = 1)) THEN
      new$BidNumber:= new$ANumber;
    END IF;
    new$FaxDocCount:= 0;
      
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDNOTIFY_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$DocChangeDate := new$UpdateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDNOTIFY (
    ID,
    DAT,
    DOCDAT,
    NOTIFYTYPE,
    BUDGETREF,
    DOCBASE,
    VARIANT,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SENDERID,
    SENDERRECORDID,
    ATYPE,
    DOCUMENTSTATE,
    USERSVISA,
    DATEINPUT,
    ORGREF,
    REJECTCLS,
    PLANDOCTYPE,
    RECORDINDEX,
    STIMATEID,
    CRYPTOSTATUS,
    RVERSION,
    DOCSTATEREF,
    FACIALACCCLS,
    LASTEXTRCHANGE,
    BIDNUMBER,
    FAXDOCCOUNT,
    PLANKIND,
    ASSIGNMENTSOURCE,
    BA_LBO_FLAG,
    KPPERIOD,
    CLSTYPE,
    DATE_UTV_PP,
    PROGINDEX,
    NOTE,
    NOTE2,
    DOCCHANGEDATE,
    SIGNERS,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    EXTID,
    EXTROOTID,
    NOTE1,
    REJECTNOTE,
    STOREDCONTENT,
    DATABLOCKFLAG,
    DOCNUMBER,
    ANUMBER,
    STARTDATE,
    ENDDATE
  ) VALUES (
    new$ID,
    new$DAT,
    new$DOCDAT,
    new$NOTIFYTYPE,
    new$BUDGETREF,
    new$DOCBASE,
    new$VARIANT,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SENDERID,
    new$SENDERRECORDID,
    new$ATYPE,
    new$DOCUMENTSTATE,
    new$USERSVISA,
    new$DATEINPUT,
    new$ORGREF,
    new$REJECTCLS,
    new$PLANDOCTYPE,
    new$RECORDINDEX,
    new$STIMATEID,
    new$CRYPTOSTATUS,
    new$RVERSION,
    new$DOCSTATEREF,
    new$FACIALACCCLS,
    new$LASTEXTRCHANGE,
    new$BIDNUMBER,
    new$FAXDOCCOUNT,
    new$PLANKIND,
    new$ASSIGNMENTSOURCE,
    new$BA_LBO_FLAG,
    new$KPPERIOD,
    new$CLSTYPE,
    new$DATE_UTV_PP,
    new$PROGINDEX,
    new$NOTE,
    new$NOTE2,
    new$DOCCHANGEDATE,
    new$SIGNERS,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$EXTID,
    new$EXTROOTID,
    new$NOTE1,
    new$REJECTNOTE,
    new$STOREDCONTENT,
    new$DATABLOCKFLAG,
    new$DOCNUMBER,
    new$ANUMBER,
    new$STARTDATE,
    new$ENDDATE);

-- - - - - - - - - - - - -
-- AI_500 (TR_BUDNOTIFY_AI_500)
-- - - - - - - - - - - - -

        delete from DelRecIndexes where (TableID = 28) and (RecordID = NEW$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDNOTIFY_IU
  INSTEAD OF UPDATE
  ON BUDNOTIFY
  FOR EACH ROW
DECLARE
  new$ID BUDNOTIFY.ID%TYPE := :NEW.ID;
  new$DAT BUDNOTIFY.DAT%TYPE := :NEW.DAT;
  new$DOCDAT BUDNOTIFY.DOCDAT%TYPE := :NEW.DOCDAT;
  new$NOTIFYTYPE BUDNOTIFY.NOTIFYTYPE%TYPE := :NEW.NOTIFYTYPE;
  new$BUDGETREF BUDNOTIFY.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$DOCBASE BUDNOTIFY.DOCBASE%TYPE := :NEW.DOCBASE;
  new$VARIANT BUDNOTIFY.VARIANT%TYPE := :NEW.VARIANT;
  new$CREATERUSER BUDNOTIFY.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE BUDNOTIFY.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE BUDNOTIFY.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDNOTIFY.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SENDERID BUDNOTIFY.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID BUDNOTIFY.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$ATYPE BUDNOTIFY.ATYPE%TYPE := :NEW.ATYPE;
  new$DOCUMENTSTATE BUDNOTIFY.DOCUMENTSTATE%TYPE := :NEW.DOCUMENTSTATE;
  new$USERSVISA BUDNOTIFY.USERSVISA%TYPE := :NEW.USERSVISA;
  new$DATEINPUT BUDNOTIFY.DATEINPUT%TYPE := :NEW.DATEINPUT;
  new$ORGREF BUDNOTIFY.ORGREF%TYPE := :NEW.ORGREF;
  new$REJECTCLS BUDNOTIFY.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$PLANDOCTYPE BUDNOTIFY.PLANDOCTYPE%TYPE := :NEW.PLANDOCTYPE;
  new$RECORDINDEX BUDNOTIFY.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$STIMATEID BUDNOTIFY.STIMATEID%TYPE := :NEW.STIMATEID;
  new$CRYPTOSTATUS BUDNOTIFY.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$RVERSION BUDNOTIFY.RVERSION%TYPE := :NEW.RVERSION;
  new$DOCSTATEREF BUDNOTIFY.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$FACIALACCCLS BUDNOTIFY.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$LASTEXTRCHANGE BUDNOTIFY.LASTEXTRCHANGE%TYPE := :NEW.LASTEXTRCHANGE;
  new$BIDNUMBER BUDNOTIFY.BIDNUMBER%TYPE := :NEW.BIDNUMBER;
  new$FAXDOCCOUNT BUDNOTIFY.FAXDOCCOUNT%TYPE := :NEW.FAXDOCCOUNT;
  new$PLANKIND BUDNOTIFY.PLANKIND%TYPE := :NEW.PLANKIND;
  new$ASSIGNMENTSOURCE BUDNOTIFY.ASSIGNMENTSOURCE%TYPE := :NEW.ASSIGNMENTSOURCE;
  new$BA_LBO_FLAG BUDNOTIFY.BA_LBO_FLAG%TYPE := :NEW.BA_LBO_FLAG;
  new$KPPERIOD BUDNOTIFY.KPPERIOD%TYPE := :NEW.KPPERIOD;
  new$CLSTYPE BUDNOTIFY.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$DATE_UTV_PP BUDNOTIFY.DATE_UTV_PP%TYPE := :NEW.DATE_UTV_PP;
  new$PROGINDEX BUDNOTIFY.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$NOTE BUDNOTIFY.NOTE%TYPE := :NEW.NOTE;
  new$NOTE2 BUDNOTIFY.NOTE2%TYPE := :NEW.NOTE2;
  new$DOCCHANGEDATE BUDNOTIFY.DOCCHANGEDATE%TYPE := :NEW.DOCCHANGEDATE;
  new$SIGNERS BUDNOTIFY.SIGNERS%TYPE := :NEW.SIGNERS;
  new$SENDERIDKEY BUDNOTIFY.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY BUDNOTIFY.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$EXTID BUDNOTIFY.EXTID%TYPE := :NEW.EXTID;
  new$EXTROOTID BUDNOTIFY.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$NOTE1 BUDNOTIFY.NOTE1%TYPE := :NEW.NOTE1;
  new$REJECTNOTE BUDNOTIFY.REJECTNOTE%TYPE := :NEW.REJECTNOTE;
  new$STOREDCONTENT BUDNOTIFY.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
  new$DATABLOCKFLAG BUDNOTIFY.DATABLOCKFLAG%TYPE := :NEW.DATABLOCKFLAG;
  new$DOCNUMBER BUDNOTIFY.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$ANUMBER BUDNOTIFY.ANUMBER%TYPE := :NEW.ANUMBER;
  new$STARTDATE BUDNOTIFY.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ENDDATE BUDNOTIFY.ENDDATE%TYPE := :NEW.ENDDATE;
--
  IsReject$ NUMBER(10);
  DetCount$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDNOTIFY_BU)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$NotifyType is null) then
    new$NotifyType := 0;
  END IF;
  if (new$DocBase is null) then
    new$DocBase := 0;
  END IF;
  if (new$PlanKind is null) then
    new$PlanKind := 0;
  END IF;
  if (new$AssignmentSource is null) then
    new$AssignmentSource := 0;
  END IF;
  if ((new$PlanDocType > 99)and(new$PlanDocType < 200)) then
    new$AType := 0;

  else
    if (new$PlanDocType > 199) then
      new$AType := 1;
    END IF;
  END IF;
  if (new$PlanDocType is null) then
    if (new$AType = 1) then
      new$PlanDocType := 200;

    else
      new$PlanDocType := 100;

    END IF;
  END IF;
  /*    */
  if (new$BudgetRef <> :old.BudgetRef) then
    if ( not((new$BudgetRef is null) and (:old.BudgetRef is null)) ) then
      select count(ID)              into DetCount$ from BudgetData where RecordIndex = :old.ID
      ;
      if (DetCount$ > 0) then
        RaiseException('Ex_CantModufyBudget');
      END IF;
    END IF;
  END IF;
  if (new$FacialAccCls is null) then
    new$FacialAccCls := 0;
  END IF;
  if (new$BA_LBO_Flag is null) then
    new$BA_LBO_Flag := 0;
  END IF;
  if (new$KPPeriod is null) then
    new$KPPeriod := 0;
  END IF;
  if (new$ClsType is null) then
    new$ClsType := 3;
  END IF;
  if ((new$ProgIndex = 262)and(new$FacialAccCLS <> :old.FacialAccCLS)
  and(new$FacialAccCLS <> 0)) then
    BEGIN
      /*     -    \   
             - \  ,
           ,   \  */
      select
      fac.ORG_REF
      into new$OrgRef     from
      FacialACC_CLS fac
      where
      (fac.ID = new$FacialAccCLS)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*        */
  if ((new$Dat is not null) and (new$RejectCls is not null)) then
    RaiseException('EX_DOCNOTACCEPTREJECT');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_BUDNOTIFY_BU_200)
-- Create 08.02.2005
-- - - - - - - - - - - - -

   --     
  IF (:OLD.DOCSTATEREF <> NEW$DOCSTATEREF) THEN
    INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
      VALUES (NEW$ID, :OLD.DOCSTATEREF, NEW$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_BUDNOTIFY_BU_300)
-- Create 24.06.2010
-- - - - - - - - - - - - -

  IsReject$ := -1;
  if ((:old.RejectCLS is null)and(:new.RejectCLS is not null)) then
    IsReject$ := 1;
  elsif ((:old.RejectCLS is not null)and(:new.RejectCLS is null)) then
    IsReject$ := 0;
  end if;
  if (IsReject$ <> -1) then
    update LinkRecords set
      IsRejected = IsReject$
    where
      (ChildID = :new.ID)
      or(ChildID in (select d.id from BudgetData d where d.RecordIndex = :new.id));
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_BUDNOTIFY_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

  IF (NEW$RVersion IS NULL) THEN
    NEW$RVersion := 1;
  ELSIF ((NEW$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
    NEW$RVersion := :OLD.RVersion;
  ELSE
    NEW$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDNOTIFY SET
    ID = new$ID,
    DAT = new$DAT,
    DOCDAT = new$DOCDAT,
    NOTIFYTYPE = new$NOTIFYTYPE,
    BUDGETREF = new$BUDGETREF,
    DOCBASE = new$DOCBASE,
    VARIANT = new$VARIANT,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    ATYPE = new$ATYPE,
    DOCUMENTSTATE = new$DOCUMENTSTATE,
    USERSVISA = new$USERSVISA,
    DATEINPUT = new$DATEINPUT,
    ORGREF = new$ORGREF,
    REJECTCLS = new$REJECTCLS,
    PLANDOCTYPE = new$PLANDOCTYPE,
    RECORDINDEX = new$RECORDINDEX,
    STIMATEID = new$STIMATEID,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    RVERSION = new$RVERSION,
    DOCSTATEREF = new$DOCSTATEREF,
    FACIALACCCLS = new$FACIALACCCLS,
    LASTEXTRCHANGE = new$LASTEXTRCHANGE,
    BIDNUMBER = new$BIDNUMBER,
    FAXDOCCOUNT = new$FAXDOCCOUNT,
    PLANKIND = new$PLANKIND,
    ASSIGNMENTSOURCE = new$ASSIGNMENTSOURCE,
    BA_LBO_FLAG = new$BA_LBO_FLAG,
    KPPERIOD = new$KPPERIOD,
    CLSTYPE = new$CLSTYPE,
    DATE_UTV_PP = new$DATE_UTV_PP,
    PROGINDEX = new$PROGINDEX,
    NOTE = new$NOTE,
    NOTE2 = new$NOTE2,
    DOCCHANGEDATE = new$DOCCHANGEDATE,
    SIGNERS = new$SIGNERS,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    EXTID = new$EXTID,
    EXTROOTID = new$EXTROOTID,
    NOTE1 = new$NOTE1,
    REJECTNOTE = new$REJECTNOTE,
    STOREDCONTENT = new$STOREDCONTENT,
    DATABLOCKFLAG = new$DATABLOCKFLAG,
    DOCNUMBER = new$DOCNUMBER,
    ANUMBER = new$ANUMBER,
    STARTDATE = new$STARTDATE,
    ENDDATE = new$ENDDATE
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_300 (TR_BudNotify_AU_300)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType <> :old.ClsType)and(new$ClsType <> 3)
  and
  ((new$RVersion<>:old.RVersion)
  or
  ((:old.RVersion is null)and(new$RVersion is not null)))) then
    if (new$ClsType = 0) then
      update BudgetData set
      KD = 0,
      IFS = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 1) then
      update BudgetData set
      KD = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);
    END IF;
    if (new$ClsType = 2) then
      update BudgetData set
      IFS = 0,
      KVSR = 0,
      KFSR = 0,
      KCSR = 0,
      KVR = 0,
      ClsType = new$ClsType,
      RVersion = -1
      where
      (RecordIndex = new$id)and(ClsType=:old.ClsType);

    END IF;
  END IF;
  if ((new$ProgIndex in (252, 253))and(new$FacialAccCLS <> :old.FacialAccCLS)) then
    update BudgetData set
    facialacc_cls = new$FacialAccCLS
    where
    RecordIndex = new$id;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDNOTIFY_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (NEW$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (28, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=28) and (RecordId=NEW$ID);
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_PromiseCheck.sql
-- #########################################################
-- #########################################################

/*  ,  -  PaymentSchedule - Promise  BudgetPromise */
-- CREATE TRIGGER TR_FACIALFINDETAIL_BI_200
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_II
  INSTEAD OF INSERT
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  SourceFacialAcc_CLS$ NUMBER(10);
  DestFacialAcc_CLS$ NUMBER(10);
  CapBuhOperationCLS$ NUMBER(10);
  CapClsType$ NUMBER(10);
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  i_fintype$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_FACIALFINDETAIL_BI_0)
-- Last update 15.12.2002
-- - - - - - - - - - - - -

   IF (new$ID IS NULL) THEN
      SELECT g_Shared.NEXTVAL INTO new$ID FROM DUAL;
   END IF;

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

-- - - - - - - - - - - - -
-- BI_10 (tr_FacialFinDetail_bi_10)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$SenderID is null) then
    new$SenderIDKey := -1;

  else
    new$SenderIDKey := new$SenderID;
  END IF;

  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (TR_FACIALFINDETAIL_BI_100)
-- Last update 12.01.2009
-- - - - - - - - - - - - -

 /*  ,    */
   BEGIN

     select
       ffc.BudgetRef, ffc.BuhOperationCls, ffc.ClsType, ffc.AcceptDate,
       ffc.IsBlocked, ffc.BlockedCause, ffc.UnBlockedDate, ffc.UnBlockedCause
     into new$BudgetRef, CapBuhOperationCls$, CapClsType$, CapAcceptDate$,
       new$IsBlocked, new$BlockedCause, new$UnBlockedDate, new$UnBlockedCause
     from
       FacialFinCaption ffc
     where
       ffc.id = new$RecordIndex;

   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       new$BudgetRef := NULL;
       CapBuhOperationCls$ := NULL;
       CapClsType$ := NULL;
       CapAcceptDate$ := NULL;
   END;

   /*      */
   if (new$BuhOperationCls is null) then new$BuhOperationCls := CapBuhOperationCls$; end if;

   /*      */
   if (new$ClsType is null) then new$ClsType := CapClsType$; end if;

   if (new$DestClsType is null) then new$DestClsType := new$ClsType; end if;

   /*      */
   if (new$AcceptDate is null) then new$AcceptDate := CapAcceptDate$; end if;

   /*      */
   if ((new$SourceFacialAcc_CLS is null) or (new$DestFacialAcc_CLS is null)) then
     BEGIN
       select SourceFacialAcc_CLS, DestFacialAcc_CLS
         into SourceFacialAcc_CLS$, DestFacialAcc_CLS$
       from FacialFinCaption
       where new$RecordIndex = id;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
         SourceFacialAcc_CLS$ := NULL;
         DestFacialAcc_CLS$ := NULL;
     END;

     if (new$SourceFacialAcc_CLS is null) then new$SourceFacialAcc_CLS := SourceFacialAcc_CLS$; end if;
     if (new$DestFacialAcc_CLS is null) then new$DestFacialAcc_CLS := DestFacialAcc_CLS$; end if;
   end if;

-- - - - - - - - - - - - -
-- BI_110 (TR_FACIALFINDETAIL_BI_110)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */
  i_fintype$ := -1 ;
  IF (new$SourceFintype IS NULL OR (new$Sourcefintype=0)) THEN
    BEGIN
      SELECT constvalue INTO i_fintype$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype$  ;

  END IF;
  IF (new$DestFintype IS NULL OR (new$Destfintype=0)) THEN
    IF (i_fintype$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype$  ;

  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN
    new$SourceFacialAcc_CLS := 0;
  END IF;
  IF (new$SourceKVR IS NULL) THEN
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKESR IS NULL) THEN
    new$SourceKESR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN
    new$SourceDocType := 1000;
  END IF;
  IF (new$SourceIFS IS NULL) THEN
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN
    new$DestFacialAcc_CLS := 0;
  END IF;
  IF (new$DestKVR IS NULL) THEN
    new$DestKVR := 0;
  END IF;
  IF (new$DestKESR IS NULL) THEN
    new$DestKESR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN
    new$DestDocType := 1000;
  END IF;
  IF (new$DestIFS IS NULL) THEN
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;

  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*   Promise null,    */
  IF ((new$Promise IS NULL) AND
  ((new$SourcePromise IS NOT NULL) OR
  (new$DestPromise IS NOT NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;

    ELSE
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;

      ELSE
        IF ((new$progindex in (66, 67, 76))AND(new$DestPromise IS NOT NULL)AND
        (new$SourcePromise=new$DestPromise)) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF;
    END IF;/*    ,  ,       */
  ELSE
    IF ((new$Promise IS NOT NULL) AND
    (new$SourcePromise IS NULL) AND
    (new$DestPromise IS NULL)) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;

      ELSE
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;

        ELSE
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;

          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  BEGIN

    /*     \   */
    SELECT org.Org_Type  INTO new$SourceFAOrg_Type FROM Organizations org
    INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$SourceFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type  INTO new$DestFAOrg_Type FROM Organizations org
    INNER JOIN facialacc_cls fac  on (org.ID = fac.Org_ref)
    WHERE fac.ID = new$DestFacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*       */
  GETTARGETCLS(null, new$sourcetransfertcls, null, new$sourcemeanstype,
  new$sourcetargetcls,new$sourcetargetcls);
  GETTARGETCLS(null, new$desttransfertcls, null, new$destmeanstype,
  new$desttargetcls,new$desttargetcls);

-- - - - - - - - - - - - -
-- BI_120 (TR_FACIALFINDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if ((new$DestClsType is NULL) and
  (
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71))) or (new$ProgIndex = 60)
  )) then
    new$DestClsType := 1; /*       ClsType */

  else
    if ((new$DestClsType is NULL) and
    ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
    ) then
      new$DestClsType := 2; /*        ClsType */

    else
      if (new$DestClsType is null) then
        new$DestClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_FACIALFINDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (((new$SourcePromise is not null) or (new$DestPromise is not null)) and (PromiseMode2$ <> 1)) then
    if (new$SourcePromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
    if (new$DestPromise is not null) then
      /*         */
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$         from
      promise_detail pr
      where
      (pr.registrnumber = new$DESTPROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');      
      END IF;    
    END IF;
  END IF;
  if (PromiseMode2$ = 1) then
    /* source:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$SourcePromise is not null) and (new$SourceBudgetPromise is null)) then
      select max(InnerPromiseNum) 
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum$;
                
      else
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
    /* dest:  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$DestPromise is not null) and (new$DestBudgetPromise is null)) then
      select max(InnerPromiseNum) 
      into BPInnerNum$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        new$DestBudgetPromise := BPInnerNum$;
                
      else
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
    /* source:  BudgetPromise,   Promise,   Promise */
    if ((new$SourceBudgetPromise is not null) and (new$SourcePromise is null)) then
      BEGIN
        select ANumber 
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum$;
      new$Promise := BPInnerNum$;
            
    END IF;
    /* dest:  BudgetPromise,   Promise,   Promise */
    if ((new$DestBudgetPromise is not null) and (new$DestPromise is null)) then
      BEGIN
        select ANumber 
        into BPInnerNum$           from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum$;
      new$Promise := BPInnerNum$;
            
    END IF;
    /*     */
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');      
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$2
      from PaymentSchedule where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');      
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_FACIALFINDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (new$SourcePromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$SourceExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$DestExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_FACIALFINDETAIL_BI_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update facialfincaption set
  DocChangeDate = new$UpdateDate,
  RVersion=-1
  where id=new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_FACIALFINDETAIL (
    ID,
    SOURCEFACIALACC_CLS,
    SOURCEKVR,
    SOURCEKESR,
    DESTFACIALACC_CLS,
    DESTKVR,
    DESTKESR,
    BUDGETREF,
    CREDIT,
    PAYSYMBOLCLS,
    MEMORDERNUM,
    NOTE,
    PROGINDEX,
    RECORDINDEX,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    SOURCEKVSR,
    SOURCEKCSR,
    SOURCEKFSR,
    SOURCESUBKESR,
    SOURCEFACT,
    SOURCEMEANSTYPE,
    SOURCEFINSOURCE,
    SOURCEFINTYPE,
    DESTKVSR,
    DESTKCSR,
    DESTKFSR,
    DESTSUBKESR,
    DESTFACT,
    DESTMEANSTYPE,
    DESTFINSOURCE,
    DESTFINTYPE,
    REQUESTSINDEX,
    SENDERID,
    SENDERRECORDID,
    PROMISE,
    SOURCEDOCTYPE,
    DESTDOCTYPE,
    SOURCEPROMISE,
    DESTPROMISE,
    RECORDINDEX2,
    SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE,
    SUBPROGINDEX,
    STIMATEID,
    RVERSION,
    SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS,
    SOURCEDOCBASE,
    DESTDOCBASE,
    SOURCEEXECDOC,
    DESTEXECDOC,
    BUHOPERATIONCLS,
    SOURCEIFS,
    DESTIFS,
    CLSTYPE,
    UNIONNOTIFYREF,
    ACCEPTDATE,
    SOURCEKD,
    DESTKD,
    SOURCEREGIONCLS,
    DESTREGIONCLS,
    DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS,
    DESTCLSTYPE,
    SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE,
    DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT,
    DESTINVESTOBJECT,
    TRANSFERTORG_REF,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS,
    DESTTARGETCLS
  ) VALUES (
    new$ID,
    new$SOURCEFACIALACC_CLS,
    new$SOURCEKVR,
    new$SOURCEKESR,
    new$DESTFACIALACC_CLS,
    new$DESTKVR,
    new$DESTKESR,
    new$BUDGETREF,
    new$CREDIT,
    new$PAYSYMBOLCLS,
    new$MEMORDERNUM,
    new$NOTE,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$SOURCEKVSR,
    new$SOURCEKCSR,
    new$SOURCEKFSR,
    new$SOURCESUBKESR,
    new$SOURCEFACT,
    new$SOURCEMEANSTYPE,
    new$SOURCEFINSOURCE,
    new$SOURCEFINTYPE,
    new$DESTKVSR,
    new$DESTKCSR,
    new$DESTKFSR,
    new$DESTSUBKESR,
    new$DESTFACT,
    new$DESTMEANSTYPE,
    new$DESTFINSOURCE,
    new$DESTFINTYPE,
    new$REQUESTSINDEX,
    new$SENDERID,
    new$SENDERRECORDID,
    new$PROMISE,
    new$SOURCEDOCTYPE,
    new$DESTDOCTYPE,
    new$SOURCEPROMISE,
    new$DESTPROMISE,
    new$RECORDINDEX2,
    new$SOURCEBUDGETPROMISE,
    new$DESTBUDGETPROMISE,
    new$SUBPROGINDEX,
    new$STIMATEID,
    new$RVERSION,
    new$SOURCEDIRECTIONCLS,
    new$DESTDIRECTIONCLS,
    new$SOURCEDOCBASE,
    new$DESTDOCBASE,
    new$SOURCEEXECDOC,
    new$DESTEXECDOC,
    new$BUHOPERATIONCLS,
    new$SOURCEIFS,
    new$DESTIFS,
    new$CLSTYPE,
    new$UNIONNOTIFYREF,
    new$ACCEPTDATE,
    new$SOURCEKD,
    new$DESTKD,
    new$SOURCEREGIONCLS,
    new$DESTREGIONCLS,
    new$DESTFUNDSSOURCE,
    new$SOURCEFUNDSSOURCE,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SOURCETRANSFERTCLS,
    new$DESTTRANSFERTCLS,
    new$DESTCLSTYPE,
    new$SOURCEASSIGNMENTKIND,
    new$DESTASSIGNMENTKIND,
    new$SOURCEEXECINNERNUMBER,
    new$DESTEXECINNERNUMBER,
    new$SOURCESUBSIDYCLS,
    new$DESTSUBSIDYCLS,
    new$SOURCEFAORG_TYPE,
    new$DESTFAORG_TYPE,
    new$SOURCEBUDALLOCATIONCLS,
    new$SOURCEPAYPROMISECLS,
    new$DESTBUDALLOCATIONCLS,
    new$DESTPAYPROMISECLS,
    new$SOURCEINVESTOBJECT,
    new$DESTINVESTOBJECT,
    new$TRANSFERTORG_REF,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$STOREDPAYMENTCONTENT,
    new$SOURCECONTRACTCOSTSCLS,
    new$DESTCONTRACTCOSTSCLS,
    new$SOURCETARGETCLS,
    new$DESTTARGETCLS);

-- - - - - - - - - - - - -
-- AI_100 (TR_FACIALFINDETAIL_AI_100)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  update FacialFinCaption set
  ClsType = new$ClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(ClsType <> new$ClsType);
  update FacialFinCaption set
  DestClsType = new$DestClsType,
  RVersion = -1
  where
  (id = new$RecordIndex)and(DestClsType <> new$DestClsType);

-- - - - - - - - - - - - -
-- AI_500 (TR_FACIALFINDETAIL_AI_500)
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID =22 ) and (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_FACIALFINDETAIL_BU_200
CREATE OR REPLACE TRIGGER TR_FACIALFINDETAIL_IU
  INSTEAD OF UPDATE
  ON FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  new$ID FACIALFINDETAIL.ID%TYPE := :NEW.ID;
  new$SOURCEFACIALACC_CLS FACIALFINDETAIL.SOURCEFACIALACC_CLS%TYPE := :NEW.SOURCEFACIALACC_CLS;
  new$SOURCEKVR FACIALFINDETAIL.SOURCEKVR%TYPE := :NEW.SOURCEKVR;
  new$SOURCEKESR FACIALFINDETAIL.SOURCEKESR%TYPE := :NEW.SOURCEKESR;
  new$DESTFACIALACC_CLS FACIALFINDETAIL.DESTFACIALACC_CLS%TYPE := :NEW.DESTFACIALACC_CLS;
  new$DESTKVR FACIALFINDETAIL.DESTKVR%TYPE := :NEW.DESTKVR;
  new$DESTKESR FACIALFINDETAIL.DESTKESR%TYPE := :NEW.DESTKESR;
  new$BUDGETREF FACIALFINDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$CREDIT FACIALFINDETAIL.CREDIT%TYPE := :NEW.CREDIT;
  new$PAYSYMBOLCLS FACIALFINDETAIL.PAYSYMBOLCLS%TYPE := :NEW.PAYSYMBOLCLS;
  new$MEMORDERNUM FACIALFINDETAIL.MEMORDERNUM%TYPE := :NEW.MEMORDERNUM;
  new$NOTE FACIALFINDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$PROGINDEX FACIALFINDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX FACIALFINDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$CREATERUSER FACIALFINDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE FACIALFINDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE FACIALFINDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER FACIALFINDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$SOURCEKVSR FACIALFINDETAIL.SOURCEKVSR%TYPE := :NEW.SOURCEKVSR;
  new$SOURCEKCSR FACIALFINDETAIL.SOURCEKCSR%TYPE := :NEW.SOURCEKCSR;
  new$SOURCEKFSR FACIALFINDETAIL.SOURCEKFSR%TYPE := :NEW.SOURCEKFSR;
  new$SOURCESUBKESR FACIALFINDETAIL.SOURCESUBKESR%TYPE := :NEW.SOURCESUBKESR;
  new$SOURCEFACT FACIALFINDETAIL.SOURCEFACT%TYPE := :NEW.SOURCEFACT;
  new$SOURCEMEANSTYPE FACIALFINDETAIL.SOURCEMEANSTYPE%TYPE := :NEW.SOURCEMEANSTYPE;
  new$SOURCEFINSOURCE FACIALFINDETAIL.SOURCEFINSOURCE%TYPE := :NEW.SOURCEFINSOURCE;
  new$SOURCEFINTYPE FACIALFINDETAIL.SOURCEFINTYPE%TYPE := :NEW.SOURCEFINTYPE;
  new$DESTKVSR FACIALFINDETAIL.DESTKVSR%TYPE := :NEW.DESTKVSR;
  new$DESTKCSR FACIALFINDETAIL.DESTKCSR%TYPE := :NEW.DESTKCSR;
  new$DESTKFSR FACIALFINDETAIL.DESTKFSR%TYPE := :NEW.DESTKFSR;
  new$DESTSUBKESR FACIALFINDETAIL.DESTSUBKESR%TYPE := :NEW.DESTSUBKESR;
  new$DESTFACT FACIALFINDETAIL.DESTFACT%TYPE := :NEW.DESTFACT;
  new$DESTMEANSTYPE FACIALFINDETAIL.DESTMEANSTYPE%TYPE := :NEW.DESTMEANSTYPE;
  new$DESTFINSOURCE FACIALFINDETAIL.DESTFINSOURCE%TYPE := :NEW.DESTFINSOURCE;
  new$DESTFINTYPE FACIALFINDETAIL.DESTFINTYPE%TYPE := :NEW.DESTFINTYPE;
  new$REQUESTSINDEX FACIALFINDETAIL.REQUESTSINDEX%TYPE := :NEW.REQUESTSINDEX;
  new$SENDERID FACIALFINDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID FACIALFINDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$PROMISE FACIALFINDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$SOURCEDOCTYPE FACIALFINDETAIL.SOURCEDOCTYPE%TYPE := :NEW.SOURCEDOCTYPE;
  new$DESTDOCTYPE FACIALFINDETAIL.DESTDOCTYPE%TYPE := :NEW.DESTDOCTYPE;
  new$SOURCEPROMISE FACIALFINDETAIL.SOURCEPROMISE%TYPE := :NEW.SOURCEPROMISE;
  new$DESTPROMISE FACIALFINDETAIL.DESTPROMISE%TYPE := :NEW.DESTPROMISE;
  new$RECORDINDEX2 FACIALFINDETAIL.RECORDINDEX2%TYPE := :NEW.RECORDINDEX2;
  new$SOURCEBUDGETPROMISE FACIALFINDETAIL.SOURCEBUDGETPROMISE%TYPE := :NEW.SOURCEBUDGETPROMISE;
  new$DESTBUDGETPROMISE FACIALFINDETAIL.DESTBUDGETPROMISE%TYPE := :NEW.DESTBUDGETPROMISE;
  new$SUBPROGINDEX FACIALFINDETAIL.SUBPROGINDEX%TYPE := :NEW.SUBPROGINDEX;
  new$STIMATEID FACIALFINDETAIL.STIMATEID%TYPE := :NEW.STIMATEID;
  new$RVERSION FACIALFINDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$SOURCEDIRECTIONCLS FACIALFINDETAIL.SOURCEDIRECTIONCLS%TYPE := :NEW.SOURCEDIRECTIONCLS;
  new$DESTDIRECTIONCLS FACIALFINDETAIL.DESTDIRECTIONCLS%TYPE := :NEW.DESTDIRECTIONCLS;
  new$SOURCEDOCBASE FACIALFINDETAIL.SOURCEDOCBASE%TYPE := :NEW.SOURCEDOCBASE;
  new$DESTDOCBASE FACIALFINDETAIL.DESTDOCBASE%TYPE := :NEW.DESTDOCBASE;
  new$SOURCEEXECDOC FACIALFINDETAIL.SOURCEEXECDOC%TYPE := :NEW.SOURCEEXECDOC;
  new$DESTEXECDOC FACIALFINDETAIL.DESTEXECDOC%TYPE := :NEW.DESTEXECDOC;
  new$BUHOPERATIONCLS FACIALFINDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$SOURCEIFS FACIALFINDETAIL.SOURCEIFS%TYPE := :NEW.SOURCEIFS;
  new$DESTIFS FACIALFINDETAIL.DESTIFS%TYPE := :NEW.DESTIFS;
  new$CLSTYPE FACIALFINDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$UNIONNOTIFYREF FACIALFINDETAIL.UNIONNOTIFYREF%TYPE := :NEW.UNIONNOTIFYREF;
  new$ACCEPTDATE FACIALFINDETAIL.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$SOURCEKD FACIALFINDETAIL.SOURCEKD%TYPE := :NEW.SOURCEKD;
  new$DESTKD FACIALFINDETAIL.DESTKD%TYPE := :NEW.DESTKD;
  new$SOURCEREGIONCLS FACIALFINDETAIL.SOURCEREGIONCLS%TYPE := :NEW.SOURCEREGIONCLS;
  new$DESTREGIONCLS FACIALFINDETAIL.DESTREGIONCLS%TYPE := :NEW.DESTREGIONCLS;
  new$DESTFUNDSSOURCE FACIALFINDETAIL.DESTFUNDSSOURCE%TYPE := :NEW.DESTFUNDSSOURCE;
  new$SOURCEFUNDSSOURCE FACIALFINDETAIL.SOURCEFUNDSSOURCE%TYPE := :NEW.SOURCEFUNDSSOURCE;
  new$ISBLOCKED FACIALFINDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE FACIALFINDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE FACIALFINDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE FACIALFINDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SOURCETRANSFERTCLS FACIALFINDETAIL.SOURCETRANSFERTCLS%TYPE := :NEW.SOURCETRANSFERTCLS;
  new$DESTTRANSFERTCLS FACIALFINDETAIL.DESTTRANSFERTCLS%TYPE := :NEW.DESTTRANSFERTCLS;
  new$DESTCLSTYPE FACIALFINDETAIL.DESTCLSTYPE%TYPE := :NEW.DESTCLSTYPE;
  new$SOURCEASSIGNMENTKIND FACIALFINDETAIL.SOURCEASSIGNMENTKIND%TYPE := :NEW.SOURCEASSIGNMENTKIND;
  new$DESTASSIGNMENTKIND FACIALFINDETAIL.DESTASSIGNMENTKIND%TYPE := :NEW.DESTASSIGNMENTKIND;
  new$SOURCEEXECINNERNUMBER FACIALFINDETAIL.SOURCEEXECINNERNUMBER%TYPE := :NEW.SOURCEEXECINNERNUMBER;
  new$DESTEXECINNERNUMBER FACIALFINDETAIL.DESTEXECINNERNUMBER%TYPE := :NEW.DESTEXECINNERNUMBER;
  new$SOURCESUBSIDYCLS FACIALFINDETAIL.SOURCESUBSIDYCLS%TYPE := :NEW.SOURCESUBSIDYCLS;
  new$DESTSUBSIDYCLS FACIALFINDETAIL.DESTSUBSIDYCLS%TYPE := :NEW.DESTSUBSIDYCLS;
  new$SOURCEFAORG_TYPE FACIALFINDETAIL.SOURCEFAORG_TYPE%TYPE := :NEW.SOURCEFAORG_TYPE;
  new$DESTFAORG_TYPE FACIALFINDETAIL.DESTFAORG_TYPE%TYPE := :NEW.DESTFAORG_TYPE;
  new$SOURCEBUDALLOCATIONCLS FACIALFINDETAIL.SOURCEBUDALLOCATIONCLS%TYPE := :NEW.SOURCEBUDALLOCATIONCLS;
  new$SOURCEPAYPROMISECLS FACIALFINDETAIL.SOURCEPAYPROMISECLS%TYPE := :NEW.SOURCEPAYPROMISECLS;
  new$DESTBUDALLOCATIONCLS FACIALFINDETAIL.DESTBUDALLOCATIONCLS%TYPE := :NEW.DESTBUDALLOCATIONCLS;
  new$DESTPAYPROMISECLS FACIALFINDETAIL.DESTPAYPROMISECLS%TYPE := :NEW.DESTPAYPROMISECLS;
  new$SOURCEINVESTOBJECT FACIALFINDETAIL.SOURCEINVESTOBJECT%TYPE := :NEW.SOURCEINVESTOBJECT;
  new$DESTINVESTOBJECT FACIALFINDETAIL.DESTINVESTOBJECT%TYPE := :NEW.DESTINVESTOBJECT;
  new$TRANSFERTORG_REF FACIALFINDETAIL.TRANSFERTORG_REF%TYPE := :NEW.TRANSFERTORG_REF;
  new$SENDERIDKEY FACIALFINDETAIL.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY FACIALFINDETAIL.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$STOREDPAYMENTCONTENT FACIALFINDETAIL.STOREDPAYMENTCONTENT%TYPE := :NEW.STOREDPAYMENTCONTENT;
  new$SOURCECONTRACTCOSTSCLS FACIALFINDETAIL.SOURCECONTRACTCOSTSCLS%TYPE := :NEW.SOURCECONTRACTCOSTSCLS;
  new$DESTCONTRACTCOSTSCLS FACIALFINDETAIL.DESTCONTRACTCOSTSCLS%TYPE := :NEW.DESTCONTRACTCOSTSCLS;
  new$SOURCETARGETCLS FACIALFINDETAIL.SOURCETARGETCLS%TYPE := :NEW.SOURCETARGETCLS;
  new$DESTTARGETCLS FACIALFINDETAIL.DESTTARGETCLS%TYPE := :NEW.DESTTARGETCLS;
--
  CapAcceptDate$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  CaptionRejectCls1$ NUMBER(10);
  EDAccepted$ NUMBER(10);
  i_fintype$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  CaptionAcceptDate1$ NUMBER;
  CaptionRejectCls2$ NUMBER(10);
  PromiseAcceptDate1$ NUMBER;
  PromiseAccepted1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_FACIALFINDETAIL_BU_0)
-- Last update 08.12.2005
-- - - - - - - - - - - - -

   IF (new$Credit IS NULL) THEN new$Credit := 0; END IF;

   /*     */
   IF     (new$BudgetRef <> :OLD.BudgetRef)
      AND (NOT ((new$BudgetRef IS NULL) AND (:OLD.BudgetRef IS NULL))) THEN
      raiseException ('Ex_CantModufyBudget');
   END IF;

-- - - - - - - - - - - - -
-- BU_110 (TR_FACIALFINDETAIL_BU_110)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  /*     ,      */
  i_fintype$ := -1 ;
  IF (new$SourceFintype IS NULL) THEN
    BEGIN
      SELECT constvalue INTO i_fintype$   FROM intconst
      WHERE (progindex=30) AND (constindex=10) ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    new$SourceFintype := i_fintype$  ;

  END IF;
  IF (new$DestFintype IS NULL) THEN
    IF (i_fintype$ = -1) THEN
      BEGIN
        SELECT constvalue INTO i_fintype$   FROM intconst
        WHERE (progindex=30) AND (constindex=10) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    new$DestFintype := i_fintype$  ;

  END IF;
  IF (new$SourceFacialAcc_CLS IS NULL) THEN
    new$SourceFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$SourceKVR IS NULL) THEN
    new$SourceKVR := 0;
  END IF;
  IF (new$SourceKESR IS NULL) THEN
    new$SourceKESR := 0;
  END IF;
  IF (new$SourceKVSR IS NULL) THEN
    new$SourceKVSR := 0;
  END IF;
  IF (new$SourceKFSR IS NULL) THEN
    new$SourceKFSR := 0;
  END IF;
  IF (new$SourceKCSR IS NULL) THEN
    new$SourceKCSR := 0;
  END IF;
  IF (new$SourceSubKESR IS NULL) THEN
    new$SourceSubKESR := 0;
  END IF;
  IF (new$SourceDirectionCls IS NULL) THEN
    new$SourceDirectionCls := 0;
  END IF;
  IF (new$SourceFact IS NULL) THEN
    new$SourceFact := 0;
  END IF;
  IF (new$SourceMeansType IS NULL) THEN
    new$SourceMeansType := 0;
  END IF;
  IF (new$SourceFinSource IS NULL) THEN
    new$SourceFinSource := 0;
  END IF;
  IF (new$SourceFinType IS NULL) THEN
    new$SourceFinType := 0;
  END IF;
  IF (new$SourceDocType IS NULL) THEN
    new$SourceDocType := 0;
  END IF;
  IF (new$Sourceifs IS NULL) THEN
    new$Sourceifs := 0;
  END IF;
  IF (new$SourceKD IS NULL) THEN
    new$SourceKD := 0;
  END IF;
  IF (new$SourceFundsSource IS NULL) THEN
    new$SourceFundsSource := 0;
  END IF;
  IF (new$SourceAssignmentKind IS NULL) THEN
    new$SourceAssignmentKind := 0;
  END IF;
  IF (new$SourceRegionCLS IS NULL) THEN
    new$SourceRegionCLS := 0;
  END IF;
  IF (new$DestFacialAcc_CLS IS NULL) THEN
    new$DestFacialAcc_CLS := 0;
  END IF;
  /*   */
  IF (new$DestKVR IS NULL) THEN
    new$DestKVR := 0;
  END IF;
  IF (new$DestKESR IS NULL) THEN
    new$DestKESR := 0;
  END IF;
  IF (new$DestKVSR IS NULL) THEN
    new$DestKVSR := 0;
  END IF;
  IF (new$DestKFSR IS NULL) THEN
    new$DestKFSR := 0;
  END IF;
  IF (new$DestKCSR IS NULL) THEN
    new$DestKCSR := 0;
  END IF;
  IF (new$DestSubKESR IS NULL) THEN
    new$DestSubKESR := 0;
  END IF;
  IF (new$DestDirectionCls IS NULL) THEN
    new$DestDirectionCls := 0;
  END IF;
  IF (new$DestFact IS NULL) THEN
    new$DestFact := 0;
  END IF;
  IF (new$DestMeansType IS NULL) THEN
    new$DestMeansType := 0;
  END IF;
  IF (new$DestFinSource IS NULL) THEN
    new$DestFinSource := 0;
  END IF;
  IF (new$DestFinType IS NULL) THEN
    new$DestFinType := 0;
  END IF;
  IF (new$DestDocType IS NULL) THEN
    new$DestDocType := 0;
  END IF;
  IF (new$Destifs IS NULL) THEN
    new$Destifs := 0;
  END IF;
  IF (new$DestKD IS NULL) THEN
    new$DestKD := 0;
  END IF;
  IF (new$DestFundsSource IS NULL) THEN
    new$DestFundsSource := 0;
  END IF;
  IF (new$DestAssignmentKind IS NULL) THEN
    new$DestAssignmentKind := 0;
  END IF;
  IF (new$DestRegionCLS IS NULL) THEN
    new$DestRegionCLS := 0;
  END IF;
  /*   :       */
  if (new$progindex=76) then
    new$SourceKVR := new$DestKVR;
    new$SourceKESR := new$DestKESR;
    new$SourceKVSR := new$DestKVSR;
    new$SourceKFSR := new$DestKFSR;
    new$SourceKCSR := new$DestKCSR;
    new$SourceSubKESR := new$DestSubKESR;
    new$SourceDirectionCls := new$DestDirectionCls;
    new$SourceFact := new$DestFact;
    new$SourceMeansType := new$DestMeansType;
    new$SourceFinSource := new$DestFinSource;
    new$SourceFinType := new$DestFinType;
    new$SourceDocType := new$DestDocType;
    new$SourceIFS := new$DestIFS;
    new$SourceKD := new$DestKD;
    new$SourceRegionCls := new$DestRegionCls;
    new$SourceDocBase := new$DestDocBase;
    new$SourceAssignmentKind := new$DestAssignmentKind;
    new$SourceSubsidyCls := new$DestSubsidyCls;
    new$SourceTransfertCLS := new$DestTransfertCLS;
    new$SourceBudAllocationCls := new$DestBudAllocationCls;
    new$SourcePayPromiseCls := new$DestPayPromiseCls;

  END IF;
  IF (new$BuhOperationCLS IS NULL)
  THEN
    GetIntConst(60, 15,new$BuhOperationCLS);
  END IF;
  /*    */
  IF ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NOT NULL)
  AND (new$SourcePromise <> :old.SourcePromise)
  OR ((new$SourcePromise IS NULL) AND (:old.SourcePromise IS NOT NULL))
  OR ((new$SourcePromise IS NOT NULL) AND (:old.SourcePromise IS NULL))
  OR (new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NOT NULL)
  AND (new$DestPromise <> :old.DestPromise)
  OR ((new$DestPromise IS NULL) AND (:old.DestPromise IS NOT NULL))
  OR ((new$DestPromise IS NOT NULL) AND (:old.DestPromise IS NULL))) THEN
    IF (new$progindex IN (63, 64, 73)) THEN
      new$Promise := new$SourcePromise;

    ELSE
      IF (new$progindex IN (61, 62, 65, 75)) THEN
        new$Promise := new$DestPromise;

      ELSE
        IF ((new$progindex in (66, 67, 76))AND((new$SourcePromise=new$DestPromise)OR
        ((new$SourcePromise IS NULL)AND(new$DestPromise IS NULL)))) THEN
          new$Promise := new$DestPromise;
        END IF;
      END IF;
    END IF;/*     */
  ELSE
    IF ((new$Promise IS NOT NULL) AND (:old.Promise IS NOT NULL)
    AND (new$Promise <> :old.Promise)
    OR ((new$Promise IS NULL) AND (:old.Promise IS NOT NULL))
    OR ((new$Promise IS NOT NULL) AND (:old.Promise IS NULL))) THEN
      IF (new$progindex IN (63, 64, 73)) THEN
        new$SourcePromise := new$Promise;

      ELSE
        IF (new$progindex IN (61, 62, 65, 75)) THEN
          new$DestPromise := new$Promise;

        ELSE
          IF (new$progindex in (66, 67, 76)) THEN
            new$SourcePromise := new$Promise;
            new$DestPromise := new$Promise;

          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  /*     \   */
  IF ( (new$SourceFacialACC_Cls <> :old.SourceFacialAcc_Cls) OR (new$SourceFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$SourceFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$SourceFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  IF ( (new$DestFacialACC_Cls <> :old.DestFacialAcc_Cls) OR (new$DestFAOrg_Type is null) OR
  ((new$AcceptDate is not null) AND ((:old.AcceptDate is null) OR (new$AcceptDate <> :old.AcceptDate))) ) THEN
    BEGIN
      SELECT org.Org_Type    INTO new$DestFAOrg_Type FROM Organizations org
      INNER JOIN FacialACC_Cls fac ON (org.ID = fac.Org_Ref)
      WHERE (fac.ID = new$DestFacialAcc_Cls)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*       */
  GETTARGETCLS(:old.Sourcetransfertcls, new$Sourcetransfertcls, :old.Sourcemeanstype, new$Sourcemeanstype,
  new$Sourcetargetcls,new$Sourcetargetcls);
  GETTARGETCLS(:old.Desttransfertcls, new$Desttransfertcls, :old.Destmeanstype, new$Destmeanstype,
  new$Desttargetcls,new$Desttargetcls);

-- - - - - - - - - - - - -
-- BU_120 (TR_FACIALFINDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  /*  60 :  '   .'; source
          61 :  '      '; dest
          62 :  '   ';dest
          63 :  '    '; source
          64 :  '   '; source
          65 :  ' , ';dest
          66 :  '  ,  - '; source dest
          67 :  '   ';source
          68 :  '  \ ';dest
          69 :  '   \ '; dest
          70 :  '  \ ';source
          71 :  '   \ '; dest */

  /* ClsType*/
  if ((new$ClsType is NULL) and
  (
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70))) or
  (new$ProgIndex = 60)
  )) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$SourceKD <> 0) and
    (new$ProgIndex in (63,64,66,67,68,70))) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null) then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND
  (((new$SourceIFS <> 0) or (new$SourceKD <> 0)) and
  (new$ProgIndex in (63,64,66,67,68,70)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 1) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceKD <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$SourceKVSR <> 0) OR (new$SourceKFSR <> 0) OR
  (new$SourceKCSR <> 0) OR (new$SourceKVR <> 0) OR
  ((new$SourceIFS <> 0) and (new$ProgIndex in (63,64,66,67,68,70)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  /* DestClsType*/
  if (((new$ProgIndex <> 67)and(new$ClsType <> :old.ClsType))or(new$DestClsType is null)) then
    new$DestClsType := new$ClsType;
  END IF;
  IF ((new$DestClsType = 0) AND
  (((new$DestIFS <> 0) or (new$DestKD <> 0)) and
  (new$ProgIndex in (61,62,65,69,71)))
  ) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 1) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestKD <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$DestClsType = 2) AND (
  (new$DestKVSR <> 0) OR (new$DestKFSR <> 0) OR
  (new$DestKCSR <> 0) OR (new$DestKVR <> 0) OR
  ((new$DestIFS <> 0) and (new$ProgIndex in (61,62,65,69,71)))
  )) THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_FACIALFINDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  /*     */
  if (PromiseMode2$ <> 1) then
    /*          */
    if ((new$SourcePromise is not null) and (:old.SourcePromise <> new$SourcePromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$SOURCEPROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
    /*          */
    if ((new$DestPromise is not null) and (:old.DestPromise <> new$DestPromise )) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$          from
      promise_detail pr
      where
      (pr.registrnumber = new$DestPromise)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');      
      END IF;
        
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  /*     */
  if (PromiseMode2$ = 1) then
    /* source:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$SourcePromise is not null)and((:old.SourcePromise is null)or(:old.SourcePromise <> new$SourcePromise )) and 
    (new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is null)) then
      select max(InnerPromiseNum) 
      into BPInnerNum1$           from PaymentSchedule 
      where (ANumber = new$SourcePromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$SourceBudgetPromise := BPInnerNum1$;
                
      else
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
    /* dest:  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$DestPromise is not null)and((:old.DestPromise is null)or(new$DestPromise <> :old.DestPromise)) and
    (new$DestBudgetPromise is null) and (:old.DestBudgetPromise is null)) then
      select max(InnerPromiseNum) 
      into BPInnerNum1$           from PaymentSchedule
      where (ANumber = new$DestPromise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$DestBudgetPromise := BPInnerNum1$;
                
      else
        RaiseException('EX_BP_NotExist');      
      END IF;
    END IF;
          
    /* source:  BudgetPromise    Promise=NULL,   Promise */
    if (new$SourcePromise is null and ((new$SourceBudgetPromise is not null and :old.SourceBudgetPromise is null) or 
    (new$SourceBudgetPromise <> :old.SourceBudgetPromise))) then
      BEGIN
        select ANumber 
        into BPInnerNum1$           from PaymentSchedule
        where (InnerPromiseNum = new$SourceBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$SourcePromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;
            
    END IF;
    /* dest:  BudgetPromise    Promise=NULL,   Promise */
    if (new$DestPromise is null and ((new$DestBudgetPromise is not null and :old.DestBudgetPromise is null) or 
    (new$DestBudgetPromise <> :old.DestBudgetPromise))) then
      BEGIN
        select ANumber 
        into BPInnerNum1$            from PaymentSchedule
        where (InnerPromiseNum = new$DestBudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$DestPromise := BPInnerNum1$;
      new$Promise := BPInnerNum1$;
            
    END IF;
    /* Source:  BudgetPromise -   Promise */
    if ((new$SourceBudgetPromise is null) and (:old.SourceBudgetPromise is not null)) then
      new$SourcePromise := null;
      new$Promise := null;
            
    END IF;
    /* Source:  Promise -   BudgetPromise */
    if ((new$SourcePromise is null) and (:old.SourcePromise is not null)) then
      new$SourceBudgetPromise := null;
      new$Promise := null;
            
    END IF;
    /* Dest:  BudgetPromise -   Promise */
    if ((new$DestBudgetPromise is null) and (:old.DestBudgetPromise is not null)) then
      new$DestPromise := null;
      new$Promise := null;
            
    END IF;
    /* Dest:  Promise -   BudgetPromise */
    if ((new$DestPromise is null) and (:old.DestPromise is not null)) then
      new$DestBudgetPromise := null;
      new$Promise := null;
            
    END IF;
    if (new$SourceBudgetPromise is not null and new$SourcePromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Source */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$SourcePromise and InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');      
      END IF;
    END IF;
    if (new$DestBudgetPromise is not null and new$DestPromise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$2
      from PaymentSchedule
      where (ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$2<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls         into CaptionAcceptDate1$, CaptionRejectCls2$ from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*      Dest */
        select AcceptDate, Accepted         into PromiseAcceptDate1$, PromiseAccepted1$ from PaymentSchedule
        where ANumber = new$DestPromise and InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls2$ is null and PromiseAccepted1$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate1$ is not null and (PromiseAcceptDate1$ is null or PromiseAccepted1$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');      
      END IF;    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_FACIALFINDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$SourcePromise is not null and (
    (:old.SourcePromise is null or :old.SourcePromise <> new$SourcePromise) or
    (:old.SourceExecDoc is null or new$SourceExecDoc is null or :old.SourceExecDoc <> new$SourceExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$SourcePromise and ps.InnerPromiseNum = new$SourceBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$SourceExecDoc := ExecID$;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      else
        if (new$SourceExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$SourceExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$SourceExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$SourceExecDoc is null or :old.SourceExecDoc is null or new$SourceExecDoc <> :old.SourceExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$SourceExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$SourceExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    /*     Dest */

    /*        */
    if (new$DestPromise is not null and (
    (:old.DestPromise is null or :old.DestPromise <> new$DestPromise) or
    (:old.DestExecDoc is null or new$DestExecDoc is null or :old.DestExecDoc <> new$DestExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$DestPromise and ps.InnerPromiseNum = new$DestBudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$DestExecDoc := ExecID$;
        new$DestExecInnerNumber := ExecInnerNumber$;

      else
        if (new$DestExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$DestExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$DestExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$DestExecDoc is null or :old.DestExecDoc is null or new$DestExecDoc <> :old.DestExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$DestExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$DestExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;
    if (new$SourceExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls1$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Source */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where id = new$SourceExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls1$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;
    if (new$DestExecDoc is not null) then
      BEGIN
        /*     */
        select Reject_Cls
        into CaptionRejectCls1$       from FacialFinCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     Dest */
        select Accepted
        into EDAccepted$       from ExecutionDocumentsCaption
        where ID = new$DestExecDoc
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls1$ is null and EDAccepted$ <> 1) then
        RaiseException('Ex_ExecDoc_Rejected');
      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_300 (TR_FACIALFINDETAIL_BU_300)
-- Create 20.02.2006
-- - - - - - - - - - - - -

  /*          (  ) */
  if ((:old.AcceptDate <> new$AcceptDate)or((:old.AcceptDate is not null)and(new$AcceptDate is null))) then
    BEGIN
      select c.AcceptDate into CapAcceptDate$
      from facialfincaption c
      where c.id = new$RecordIndex;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        CapAcceptDate$ := NULL;
    END;

    if ((new$AcceptDate = CapAcceptDate$) or (CapAcceptDate$ is null)) then
      new$AcceptDate := new$AcceptDate;
    else
      RaiseException('ex_wrongacceptdate');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_700 (TR_FACIALFINDETAIL_BU_700)
-- Create 17.09.2004
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_FACIALFINDETAIL SET
    ID = new$ID,
    SOURCEFACIALACC_CLS = new$SOURCEFACIALACC_CLS,
    SOURCEKVR = new$SOURCEKVR,
    SOURCEKESR = new$SOURCEKESR,
    DESTFACIALACC_CLS = new$DESTFACIALACC_CLS,
    DESTKVR = new$DESTKVR,
    DESTKESR = new$DESTKESR,
    BUDGETREF = new$BUDGETREF,
    CREDIT = new$CREDIT,
    PAYSYMBOLCLS = new$PAYSYMBOLCLS,
    MEMORDERNUM = new$MEMORDERNUM,
    NOTE = new$NOTE,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    SOURCEKVSR = new$SOURCEKVSR,
    SOURCEKCSR = new$SOURCEKCSR,
    SOURCEKFSR = new$SOURCEKFSR,
    SOURCESUBKESR = new$SOURCESUBKESR,
    SOURCEFACT = new$SOURCEFACT,
    SOURCEMEANSTYPE = new$SOURCEMEANSTYPE,
    SOURCEFINSOURCE = new$SOURCEFINSOURCE,
    SOURCEFINTYPE = new$SOURCEFINTYPE,
    DESTKVSR = new$DESTKVSR,
    DESTKCSR = new$DESTKCSR,
    DESTKFSR = new$DESTKFSR,
    DESTSUBKESR = new$DESTSUBKESR,
    DESTFACT = new$DESTFACT,
    DESTMEANSTYPE = new$DESTMEANSTYPE,
    DESTFINSOURCE = new$DESTFINSOURCE,
    DESTFINTYPE = new$DESTFINTYPE,
    REQUESTSINDEX = new$REQUESTSINDEX,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    PROMISE = new$PROMISE,
    SOURCEDOCTYPE = new$SOURCEDOCTYPE,
    DESTDOCTYPE = new$DESTDOCTYPE,
    SOURCEPROMISE = new$SOURCEPROMISE,
    DESTPROMISE = new$DESTPROMISE,
    RECORDINDEX2 = new$RECORDINDEX2,
    SOURCEBUDGETPROMISE = new$SOURCEBUDGETPROMISE,
    DESTBUDGETPROMISE = new$DESTBUDGETPROMISE,
    SUBPROGINDEX = new$SUBPROGINDEX,
    STIMATEID = new$STIMATEID,
    RVERSION = new$RVERSION,
    SOURCEDIRECTIONCLS = new$SOURCEDIRECTIONCLS,
    DESTDIRECTIONCLS = new$DESTDIRECTIONCLS,
    SOURCEDOCBASE = new$SOURCEDOCBASE,
    DESTDOCBASE = new$DESTDOCBASE,
    SOURCEEXECDOC = new$SOURCEEXECDOC,
    DESTEXECDOC = new$DESTEXECDOC,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    SOURCEIFS = new$SOURCEIFS,
    DESTIFS = new$DESTIFS,
    CLSTYPE = new$CLSTYPE,
    UNIONNOTIFYREF = new$UNIONNOTIFYREF,
    ACCEPTDATE = new$ACCEPTDATE,
    SOURCEKD = new$SOURCEKD,
    DESTKD = new$DESTKD,
    SOURCEREGIONCLS = new$SOURCEREGIONCLS,
    DESTREGIONCLS = new$DESTREGIONCLS,
    DESTFUNDSSOURCE = new$DESTFUNDSSOURCE,
    SOURCEFUNDSSOURCE = new$SOURCEFUNDSSOURCE,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SOURCETRANSFERTCLS = new$SOURCETRANSFERTCLS,
    DESTTRANSFERTCLS = new$DESTTRANSFERTCLS,
    DESTCLSTYPE = new$DESTCLSTYPE,
    SOURCEASSIGNMENTKIND = new$SOURCEASSIGNMENTKIND,
    DESTASSIGNMENTKIND = new$DESTASSIGNMENTKIND,
    SOURCEEXECINNERNUMBER = new$SOURCEEXECINNERNUMBER,
    DESTEXECINNERNUMBER = new$DESTEXECINNERNUMBER,
    SOURCESUBSIDYCLS = new$SOURCESUBSIDYCLS,
    DESTSUBSIDYCLS = new$DESTSUBSIDYCLS,
    SOURCEFAORG_TYPE = new$SOURCEFAORG_TYPE,
    DESTFAORG_TYPE = new$DESTFAORG_TYPE,
    SOURCEBUDALLOCATIONCLS = new$SOURCEBUDALLOCATIONCLS,
    SOURCEPAYPROMISECLS = new$SOURCEPAYPROMISECLS,
    DESTBUDALLOCATIONCLS = new$DESTBUDALLOCATIONCLS,
    DESTPAYPROMISECLS = new$DESTPAYPROMISECLS,
    SOURCEINVESTOBJECT = new$SOURCEINVESTOBJECT,
    DESTINVESTOBJECT = new$DESTINVESTOBJECT,
    TRANSFERTORG_REF = new$TRANSFERTORG_REF,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    STOREDPAYMENTCONTENT = new$STOREDPAYMENTCONTENT,
    SOURCECONTRACTCOSTSCLS = new$SOURCECONTRACTCOSTSCLS,
    DESTCONTRACTCOSTSCLS = new$DESTCONTRACTCOSTSCLS,
    SOURCETARGETCLS = new$SOURCETARGETCLS,
    DESTTARGETCLS = new$DESTTARGETCLS
  WHERE ID = :OLD.ID;

-- - - - - - - - - - - - -
-- AU_100 (TR_FACIALFINDETAIL_AU_100)
-- Create 14.05.2007
-- - - - - - - - - - - - -

  if (new$ClsType <> :old.ClsType) then
    update FacialFinCaption set
      ClsType = new$ClsType,
      RVersion = -1
    where
      (id = new$RecordIndex)and(ClsType <> new$ClsType);
  end if;

-- - - - - - - - - - - - -
-- AU_500 (TR_FACIALFINDETAIL_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (22, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=22) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
-- CREATE TRIGGER TR_CORRECTIONDETAIL_BI_200
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_II
  INSTEAD OF INSERT
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  vOperationTypeS1$ NUMBER(10);
  vOperationTypeD1$ NUMBER(10);
  vOperationType1$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_CORRECTIONDETAIL_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN 
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN 
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN 
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN 
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN 
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN 
    new$KFSR := 0;
  END IF;
  IF (new$KESR IS NULL) THEN 
    new$KESR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN 
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN 
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN 
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN 
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN 
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN 
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN 
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN 
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN 
    new$DocType := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN 
    new$FundsSource := 0;  
  END IF;
  IF (new$SubKesr IS NULL) THEN 
    new$SubKesr := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN 
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN 
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN 
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS1$, vOperationTypeD1$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN 
      vOperationType1$ := vOperationTypeS1$;
          
    ELSE 
      vOperationType1$ := vOperationTypeD1$;
    END IF;
    new$OperationType := vOperationType1$;
      
  END IF;
  BEGIN

    /*  ,    */
    select
    CorCap.BudgetRef
    into new$BudgetRef   from
    correctioncaption CorCap
    where
    CorCap.id = new$RecordIndex
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  BEGIN

    SELECT org.Org_Type   INTO new$FAOrgType FROM Organizations org
    INNER JOIN FacialAcc_Cls fac  ON (org.ID = fac.Org_ref)
    WHERE fac.ID = new$FacialACC_Cls
    ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  /*    */
  GETTARGETCLS(null, new$transfertcls, null, new$meanstype,
  new$targetcls,new$targetcls); 

-- - - - - - - - - - - - -
-- BI_100 (tr_correctiondetail_bi_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if (new$progindex = 316) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BI_120 (TR_CORRECTIONDETAIL_BI_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_CORRECTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (new$Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');    
      END IF;  
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((new$Promise is not null) and (new$BudgetPromise is null)) then
      select 
      max(InnerPromiseNum) 
      into BPInnerNum1$       from 
      PaymentSchedule 
      where 
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;
              
      else
        RaiseException('EX_BP_NotExist');    
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((new$BudgetPromise is not null) and (new$Promise is null)) then
      BEGIN
        select 
        ANumber 
        into BPInnerNum1$       from 
        PaymentSchedule
        where 
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;
          
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN
        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_CORRECTIONDETAIL_BI_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*    ,   ,  */
    else
      if (new$ExecDoc is not null) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_CORRECTIONDETAIL_BI_500)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := user;
  new$UpdaterUser := user;

  Update CorrectionCaption set
  DocChangeDate = new$UpdateDate,
  RVersion = -1
  where id = new$recordindex;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_CORRECTIONDETAIL (
    ID,
    PARENTID,
    BUDGETREF,
    SUMMA,
    CLSTYPE,
    FACIALACC_CLS,
    KVSR,
    KFSR,
    KCSR,
    KVR,
    KESR,
    DIRECTIONCLS,
    MEANSTYPE,
    FACT,
    REGIONCLS,
    FINSOURCE,
    FINTYPE,
    DOCTYPE,
    SUBKESR,
    FUNDSSOURCE,
    KD,
    IFS,
    BUHOPERATIONCLS,
    CHANGEACC_REF,
    CHANGEACC,
    CHANGEORGINN,
    CHANGEORGINN20,
    PROGINDEX,
    RECORDINDEX,
    DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX,
    ISBLOCKED,
    BLOCKEDCAUSE,
    UNBLOCKEDDATE,
    UNBLOCKEDCAUSE,
    SENDERID,
    SENDERRECORDID,
    RVERSION,
    CREATERUSER,
    CREATEDATE,
    UPDATERUSER,
    UPDATEDATE,
    NOTE,
    ISCLSCHANGED,
    PROMISE,
    BUDGETPROMISE,
    EXECDOC,
    OKATO,
    ADDOKATO,
    TRANSFERTCLS,
    ORIGINALCLSSUMMA,
    NOTECLS,
    OPERATIONTYPE,
    REVERSEFLAG,
    EXECINNERNUMBER,
    CLSFIELFCHANGED,
    FAORGTYPE,
    SUBSIDYCLS,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    NOTEQUALEX,
    OKTMO,
    UINCODE,
    INVESTOBJECT,
    CHANGEORGNAME,
    CONTRACTCOSTSCLS,
    TARGETCLS,
    STOREDCONTENT
  ) VALUES (
    new$ID,
    new$PARENTID,
    new$BUDGETREF,
    new$SUMMA,
    new$CLSTYPE,
    new$FACIALACC_CLS,
    new$KVSR,
    new$KFSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$DIRECTIONCLS,
    new$MEANSTYPE,
    new$FACT,
    new$REGIONCLS,
    new$FINSOURCE,
    new$FINTYPE,
    new$DOCTYPE,
    new$SUBKESR,
    new$FUNDSSOURCE,
    new$KD,
    new$IFS,
    new$BUHOPERATIONCLS,
    new$CHANGEACC_REF,
    new$CHANGEACC,
    new$CHANGEORGINN,
    new$CHANGEORGINN20,
    new$PROGINDEX,
    new$RECORDINDEX,
    new$DOCUMENTPROGINDEX,
    new$DOCUMENTRECORDINDEX,
    new$ISBLOCKED,
    new$BLOCKEDCAUSE,
    new$UNBLOCKEDDATE,
    new$UNBLOCKEDCAUSE,
    new$SENDERID,
    new$SENDERRECORDID,
    new$RVERSION,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATERUSER,
    new$UPDATEDATE,
    new$NOTE,
    new$ISCLSCHANGED,
    new$PROMISE,
    new$BUDGETPROMISE,
    new$EXECDOC,
    new$OKATO,
    new$ADDOKATO,
    new$TRANSFERTCLS,
    new$ORIGINALCLSSUMMA,
    new$NOTECLS,
    new$OPERATIONTYPE,
    new$REVERSEFLAG,
    new$EXECINNERNUMBER,
    new$CLSFIELFCHANGED,
    new$FAORGTYPE,
    new$SUBSIDYCLS,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$NOTEQUALEX,
    new$OKTMO,
    new$UINCODE,
    new$INVESTOBJECT,
    new$CHANGEORGNAME,
    new$CONTRACTCOSTSCLS,
    new$TARGETCLS,
    new$STOREDCONTENT);

-- - - - - - - - - - - - -
-- AI_500 (TR_CORRECTIONDETAIL_AI_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

 delete from DelRecIndexes where (TableID =5504 ) and (RecordID = new$ID);

END;
/
-- CREATE TRIGGER TR_CORRECTIONDETAIL_BU_200
CREATE OR REPLACE TRIGGER TR_CORRECTIONDETAIL_IU
  INSTEAD OF UPDATE
  ON CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  new$ID CORRECTIONDETAIL.ID%TYPE := :NEW.ID;
  new$PARENTID CORRECTIONDETAIL.PARENTID%TYPE := :NEW.PARENTID;
  new$BUDGETREF CORRECTIONDETAIL.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUMMA CORRECTIONDETAIL.SUMMA%TYPE := :NEW.SUMMA;
  new$CLSTYPE CORRECTIONDETAIL.CLSTYPE%TYPE := :NEW.CLSTYPE;
  new$FACIALACC_CLS CORRECTIONDETAIL.FACIALACC_CLS%TYPE := :NEW.FACIALACC_CLS;
  new$KVSR CORRECTIONDETAIL.KVSR%TYPE := :NEW.KVSR;
  new$KFSR CORRECTIONDETAIL.KFSR%TYPE := :NEW.KFSR;
  new$KCSR CORRECTIONDETAIL.KCSR%TYPE := :NEW.KCSR;
  new$KVR CORRECTIONDETAIL.KVR%TYPE := :NEW.KVR;
  new$KESR CORRECTIONDETAIL.KESR%TYPE := :NEW.KESR;
  new$DIRECTIONCLS CORRECTIONDETAIL.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$MEANSTYPE CORRECTIONDETAIL.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$FACT CORRECTIONDETAIL.FACT%TYPE := :NEW.FACT;
  new$REGIONCLS CORRECTIONDETAIL.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FINSOURCE CORRECTIONDETAIL.FINSOURCE%TYPE := :NEW.FINSOURCE;
  new$FINTYPE CORRECTIONDETAIL.FINTYPE%TYPE := :NEW.FINTYPE;
  new$DOCTYPE CORRECTIONDETAIL.DOCTYPE%TYPE := :NEW.DOCTYPE;
  new$SUBKESR CORRECTIONDETAIL.SUBKESR%TYPE := :NEW.SUBKESR;
  new$FUNDSSOURCE CORRECTIONDETAIL.FUNDSSOURCE%TYPE := :NEW.FUNDSSOURCE;
  new$KD CORRECTIONDETAIL.KD%TYPE := :NEW.KD;
  new$IFS CORRECTIONDETAIL.IFS%TYPE := :NEW.IFS;
  new$BUHOPERATIONCLS CORRECTIONDETAIL.BUHOPERATIONCLS%TYPE := :NEW.BUHOPERATIONCLS;
  new$CHANGEACC_REF CORRECTIONDETAIL.CHANGEACC_REF%TYPE := :NEW.CHANGEACC_REF;
  new$CHANGEACC CORRECTIONDETAIL.CHANGEACC%TYPE := :NEW.CHANGEACC;
  new$CHANGEORGINN CORRECTIONDETAIL.CHANGEORGINN%TYPE := :NEW.CHANGEORGINN;
  new$CHANGEORGINN20 CORRECTIONDETAIL.CHANGEORGINN20%TYPE := :NEW.CHANGEORGINN20;
  new$PROGINDEX CORRECTIONDETAIL.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$RECORDINDEX CORRECTIONDETAIL.RECORDINDEX%TYPE := :NEW.RECORDINDEX;
  new$DOCUMENTPROGINDEX CORRECTIONDETAIL.DOCUMENTPROGINDEX%TYPE := :NEW.DOCUMENTPROGINDEX;
  new$DOCUMENTRECORDINDEX CORRECTIONDETAIL.DOCUMENTRECORDINDEX%TYPE := :NEW.DOCUMENTRECORDINDEX;
  new$ISBLOCKED CORRECTIONDETAIL.ISBLOCKED%TYPE := :NEW.ISBLOCKED;
  new$BLOCKEDCAUSE CORRECTIONDETAIL.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE CORRECTIONDETAIL.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE CORRECTIONDETAIL.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$SENDERID CORRECTIONDETAIL.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID CORRECTIONDETAIL.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$RVERSION CORRECTIONDETAIL.RVERSION%TYPE := :NEW.RVERSION;
  new$CREATERUSER CORRECTIONDETAIL.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE CORRECTIONDETAIL.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATERUSER CORRECTIONDETAIL.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$UPDATEDATE CORRECTIONDETAIL.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$NOTE CORRECTIONDETAIL.NOTE%TYPE := :NEW.NOTE;
  new$ISCLSCHANGED CORRECTIONDETAIL.ISCLSCHANGED%TYPE := :NEW.ISCLSCHANGED;
  new$PROMISE CORRECTIONDETAIL.PROMISE%TYPE := :NEW.PROMISE;
  new$BUDGETPROMISE CORRECTIONDETAIL.BUDGETPROMISE%TYPE := :NEW.BUDGETPROMISE;
  new$EXECDOC CORRECTIONDETAIL.EXECDOC%TYPE := :NEW.EXECDOC;
  new$OKATO CORRECTIONDETAIL.OKATO%TYPE := :NEW.OKATO;
  new$ADDOKATO CORRECTIONDETAIL.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$TRANSFERTCLS CORRECTIONDETAIL.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$ORIGINALCLSSUMMA CORRECTIONDETAIL.ORIGINALCLSSUMMA%TYPE := :NEW.ORIGINALCLSSUMMA;
  new$NOTECLS CORRECTIONDETAIL.NOTECLS%TYPE := :NEW.NOTECLS;
  new$OPERATIONTYPE CORRECTIONDETAIL.OPERATIONTYPE%TYPE := :NEW.OPERATIONTYPE;
  new$REVERSEFLAG CORRECTIONDETAIL.REVERSEFLAG%TYPE := :NEW.REVERSEFLAG;
  new$EXECINNERNUMBER CORRECTIONDETAIL.EXECINNERNUMBER%TYPE := :NEW.EXECINNERNUMBER;
  new$CLSFIELFCHANGED CORRECTIONDETAIL.CLSFIELFCHANGED%TYPE := :NEW.CLSFIELFCHANGED;
  new$FAORGTYPE CORRECTIONDETAIL.FAORGTYPE%TYPE := :NEW.FAORGTYPE;
  new$SUBSIDYCLS CORRECTIONDETAIL.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$BUDALLOCATIONCLS CORRECTIONDETAIL.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS CORRECTIONDETAIL.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$NOTEQUALEX CORRECTIONDETAIL.NOTEQUALEX%TYPE := :NEW.NOTEQUALEX;
  new$OKTMO CORRECTIONDETAIL.OKTMO%TYPE := :NEW.OKTMO;
  new$UINCODE CORRECTIONDETAIL.UINCODE%TYPE := :NEW.UINCODE;
  new$INVESTOBJECT CORRECTIONDETAIL.INVESTOBJECT%TYPE := :NEW.INVESTOBJECT;
  new$CHANGEORGNAME CORRECTIONDETAIL.CHANGEORGNAME%TYPE := :NEW.CHANGEORGNAME;
  new$CONTRACTCOSTSCLS CORRECTIONDETAIL.CONTRACTCOSTSCLS%TYPE := :NEW.CONTRACTCOSTSCLS;
  new$TARGETCLS CORRECTIONDETAIL.TARGETCLS%TYPE := :NEW.TARGETCLS;
  new$STOREDCONTENT CORRECTIONDETAIL.STOREDCONTENT%TYPE := :NEW.STOREDCONTENT;
--
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  ExecRegType$ NUMBER(10);
  ExecAgrInnerNum$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  vOperationTypeS1$ NUMBER(10);
  vOperationTypeD1$ NUMBER(10);
  vOperationType1$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  CaptionAcceptDate$ NUMBER;
  CaptionRejectCls$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_CORRECTIONDETAIL_BU)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  IF (new$id IS NULL) THEN
    select g_shared.nextval into new$id from dual;
  END IF;
  IF (new$KD IS NULL) THEN
    new$KD := 0;
  END IF;
  IF (new$IFS IS NULL) THEN
    new$IFS := 0;
  END IF;
  IF (new$FacialAcc_Cls IS NULL) THEN
    new$FacialAcc_Cls := 0;
  END IF;
  IF (new$KVSR IS NULL) THEN
    new$KVSR := 0;
  END IF;
  IF (new$KFSR IS NULL) THEN
    new$KFSR := 0;
  END IF;
  IF (new$KESR IS NULL) THEN
    new$KESR := 0;
  END IF;
  IF (new$KVR IS NULL) THEN
    new$KVR := 0;
  END IF;
  IF (new$KCSR IS NULL) THEN
    new$KCSR := 0;
  END IF;
  IF (new$MeansType IS NULL) THEN
    new$MeansType := 0;
  END IF;
  IF (new$Fact IS NULL) THEN
    new$Fact := 0;
  END IF;
  IF (new$DirectionCls IS NULL) THEN
    new$DirectionCls := 0;
  END IF;
  IF (new$RegionCLS IS NULL) THEN
    new$RegionCLS := 0;
  END IF;
  IF (new$Finsource IS NULL) THEN
    new$Finsource := 0;
  END IF;
  IF (new$FinType IS NULL) THEN
    new$FinType := 0;
  END IF;
  IF (new$DocType IS NULL) THEN
    new$DocType := 0;
  END IF;
  IF (new$SubKesr IS NULL) THEN
    new$SubKesr := 0;
  END IF;
  IF (new$FundsSource IS NULL) THEN
    new$FundsSource := 0;
  END IF;
  IF (new$buhoperationCls IS NULL) THEN
    new$buhoperationCls := 0;
  END IF;
  IF (new$ReverseFlag IS NULL) THEN
    new$ReverseFlag := 1;
  END IF;
  IF (new$OperationType IS NULL) THEN
    BEGIN
      SELECT CorCap.SourceType, CorCap.DestType
      INTO
      vOperationTypeS1$, vOperationTypeD1$       FROM correctioncaption CorCap
      WHERE
      (CorCap.id = new$recordindex)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    IF (new$ProgIndex = 315) THEN
      vOperationType1$ := vOperationTypeS1$;

    ELSE
      vOperationType1$ := vOperationTypeD1$;
    END IF;
    new$OperationType := vOperationType1$;

  END IF;
  /*     \*/
  IF ((new$FacialAcc_Cls <> :old.FacialAcc_CLS) OR (new$FAOrgType IS NULL)) THEN
    BEGIN
      SELECT org.Org_Type      INTO new$FAOrgType FROM Organizations org
      INNER JOIN facialacc_cls fac  ON (org.ID = fac.Org_ref)
      WHERE fac.ID = new$FacialACC_Cls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, new$transfertcls, :old.meanstype, new$meanstype,
  new$targetcls,new$targetcls);

-- - - - - - - - - - - - -
-- BU_100 (tr_correctiondetail_bu_100)
-- Version 7.01.00.1
-- - - - - - - - - - - - -

  if ((new$buhoperationcls <> :old.buhoperationcls) and (new$progindex = 316)) then
    update correctiondetail set
    buhoperationcls = new$buhoperationcls
    where ID = new$parentid;
  END IF;

-- - - - - - - - - - - - -
-- BU_120 (TR_CORRECTIONDETAIL_BU_120)
-- Version 11.00.00.1
-- - - - - - - - - - - - -

  if ((new$ClsType is NULL) and (new$IFS <> 0)) then
    new$ClsType := 1; /*       ClsType */

  else
    if ((new$ClsType is NULL) and (new$KD <> 0)) then
      new$ClsType := 2; /*        ClsType */

    else
      if (new$ClsType is null)
      then
        new$ClsType := 0; /*  -  */
      END IF;
    END IF;
  END IF;
  IF ((new$ClsType = 0) AND ((new$IFS <> 0) or (new$KD <> 0)))THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ( (new$ClsType = 1) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$KD <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((new$ClsType = 2) AND (
  (new$KVSR <> 0) OR (new$KFSR <> 0) OR
  (new$KCSR <> 0) OR (new$KVR <> 0) OR
  (new$IFS <> 0)
  ))
  THEN /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_CORRECTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = new$PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');    
      END IF;  
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((new$Promise is not null)and((:old.Promise is null)or(:old.Promise <> new$Promise )) and 
    (new$BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select 
      max(InnerPromiseNum) 
      into BPInnerNum1$       from 
      PaymentSchedule 
      where 
      (ANumber = new$Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        new$BudgetPromise := BPInnerNum1$;
              
      else
        RaiseException('EX_BP_NotExist');    
      END IF;
    END IF;
        
    /*  BudgetPromise    Promise=NULL,   Promise */
    if (new$Promise is null and ((new$BudgetPromise is not null and :old.BudgetPromise is null) or
    (new$BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select 
        ANumber 
        into BPInnerNum1$       from 
        PaymentSchedule
        where 
        (InnerPromiseNum = new$BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      new$Promise := BPInnerNum1$;
          
    END IF;
        
    /*  BudgetPromise -   Promise */
    if ((new$BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      new$Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((new$Promise is null) and (:old.Promise is not null)) then
      new$BudgetPromise := null;
    END IF;
    /*     */
    if (new$BudgetPromise is not null and new$Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*        */
        select AcceptDate, Reject_Cls       into CaptionAcceptDate$, CaptionRejectCls$ from CorrectionCaption
        where ID = new$RecordIndex
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = new$Promise and InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (CaptionRejectCls$ is null and PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');
      END IF;
      /*         */
      if (CaptionAcceptDate$ is not null and (PromiseAcceptDate$ is null or PromiseAccepted$ <> 1)) then
        RaiseException('Ex_BP_NotAccepted');    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_CORRECTIONDETAIL_BU_210)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (new$Promise is not null and (
    (:old.Promise is null or :old.Promise <> new$Promise) or
    (:old.ExecDoc is null or new$ExecDoc is null or :old.ExecDoc <> new$ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = new$Promise and ps.InnerPromiseNum = new$BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*    ,      */
      if (ProgIndex$ = 308) then
        new$ExecDoc := ExecID$;
        new$ExecInnerNumber := ExecInnerNumber$;

      else
        if (new$ExecDoc is not null) then
          BEGIN
            /*      ,         */
            /*        */
            select
            RegistrationType, AgreementInnerNumber, InnerNumber
            into ExecRegType$, ExecAgrInnerNum$, ExecInnerNumber$         from ExecutionDocumentsCaption
            where
            Id = new$ExecDoc
            ;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN NULL;
          END;
          /*    ,    */
          if (ExecRegType$ = 4) then
            RaiseException('EX_IncorrectBindingExec_BO');
          END IF;
          /*        ,     */
          if (ExecAgrInnerNum$ <> AgrInnerNumber$) then
            RaiseException('EX_DiffAgree_InBOExec');
          END IF;
          /*    ,      */
          new$ExecInnerNumber := ExecInnerNumber$;

        END IF;
      END IF;/*       ,   ,  */
    else
      if (new$ExecDoc is null or :old.ExecDoc is null or new$ExecDoc <> :old.ExecDoc) then
        BEGIN
          /*      */
          select
          InnerNumber
          into ExecInnerNumber$       from ExecutionDocumentsCaption
          where
          Id = new$ExecDoc
          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        new$ExecInnerNumber := ExecInnerNumber$;

      END IF;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_CORRECTIONDETAIL_BU_700)
-- Create 13.08.2007
-- - - - - - - - - - - - -

 if (new$RVersion is null) then
   new$RVersion:=1;
 else
   if ((new$RVersion = -1) and (:Old.RVersion <> -1)) then
     new$RVersion:=:Old.RVersion;
   else
     new$RVersion:=:Old.RVersion+1;
   end if;
 end if;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_CORRECTIONDETAIL SET
    ID = new$ID,
    PARENTID = new$PARENTID,
    BUDGETREF = new$BUDGETREF,
    SUMMA = new$SUMMA,
    CLSTYPE = new$CLSTYPE,
    FACIALACC_CLS = new$FACIALACC_CLS,
    KVSR = new$KVSR,
    KFSR = new$KFSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    DIRECTIONCLS = new$DIRECTIONCLS,
    MEANSTYPE = new$MEANSTYPE,
    FACT = new$FACT,
    REGIONCLS = new$REGIONCLS,
    FINSOURCE = new$FINSOURCE,
    FINTYPE = new$FINTYPE,
    DOCTYPE = new$DOCTYPE,
    SUBKESR = new$SUBKESR,
    FUNDSSOURCE = new$FUNDSSOURCE,
    KD = new$KD,
    IFS = new$IFS,
    BUHOPERATIONCLS = new$BUHOPERATIONCLS,
    CHANGEACC_REF = new$CHANGEACC_REF,
    CHANGEACC = new$CHANGEACC,
    CHANGEORGINN = new$CHANGEORGINN,
    CHANGEORGINN20 = new$CHANGEORGINN20,
    PROGINDEX = new$PROGINDEX,
    RECORDINDEX = new$RECORDINDEX,
    DOCUMENTPROGINDEX = new$DOCUMENTPROGINDEX,
    DOCUMENTRECORDINDEX = new$DOCUMENTRECORDINDEX,
    ISBLOCKED = new$ISBLOCKED,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    RVERSION = new$RVERSION,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    NOTE = new$NOTE,
    ISCLSCHANGED = new$ISCLSCHANGED,
    PROMISE = new$PROMISE,
    BUDGETPROMISE = new$BUDGETPROMISE,
    EXECDOC = new$EXECDOC,
    OKATO = new$OKATO,
    ADDOKATO = new$ADDOKATO,
    TRANSFERTCLS = new$TRANSFERTCLS,
    ORIGINALCLSSUMMA = new$ORIGINALCLSSUMMA,
    NOTECLS = new$NOTECLS,
    OPERATIONTYPE = new$OPERATIONTYPE,
    REVERSEFLAG = new$REVERSEFLAG,
    EXECINNERNUMBER = new$EXECINNERNUMBER,
    CLSFIELFCHANGED = new$CLSFIELFCHANGED,
    FAORGTYPE = new$FAORGTYPE,
    SUBSIDYCLS = new$SUBSIDYCLS,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    NOTEQUALEX = new$NOTEQUALEX,
    OKTMO = new$OKTMO,
    UINCODE = new$UINCODE,
    INVESTOBJECT = new$INVESTOBJECT,
    CHANGEORGNAME = new$CHANGEORGNAME,
    CONTRACTCOSTSCLS = new$CONTRACTCOSTSCLS,
    TARGETCLS = new$TARGETCLS,
    STOREDCONTENT = new$STOREDCONTENT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_CORRECTIONDETAIL_AU_500)
-- Create 29.12.2009
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (5504, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=5504) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
-- CREATE TRIGGER TR_WRITEXECUTIONDETAIL_BI_200
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONDETAIL_BI
  BEFORE INSERT
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  PromiseMode1$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  ScheduleRef$ NUMBER(10);
  BPInnerNum1$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count1$ NUMBER(10);
  ConstCheck1$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_WRITEXECUTIONDETAIL_BI)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.BudgetRef is null) then
    BEGIN
      select
      writ_c.BudgetRef
      into :new.BudgetRef     from
      WritExecutionCaption writ_c
      where
      writ_c.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;

  if (:new.Progindex is null) then
    :new.Progindex := 556;
  END IF;
  if (:new.FacialAcc_Cls is null) then
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.KVSR is null) then
    :new.KVSR := 0;
  END IF;
  if (:new.KFSR is null) then
    :new.KFSR := 0;
  END IF;
  if (:new.KESR is null) then
    :new.KESR := 0;
  END IF;
  if (:new.KVR is null) then
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then
    :new.Fact := 0;
  END IF;
  if (:new.DirectionCls is null) then
    :new.DirectionCls := 0;
  END IF;
  if (:new.RegionCLS is null) then
    :new.RegionCLS := 0;
  END IF;
  if (:new.Finsource is null) then
    :new.Finsource := 0;
  END IF;
  if (:new.FinType is null) then
    :new.FinType := 0;
  END IF;
  if (:new.DocType is null) then
    :new.DocType := 0;
  END IF;
  if (:new.SubKesr is null) then
    :new.SubKesr := 0;
  END IF;

  if (:new.Month01 IS NULL) then
    :new.Month01 := 0;
  END IF;
  if (:new.Month02 IS NULL) then
    :new.Month02 := 0;
  END IF;
  if (:new.Month03 IS NULL) then
    :new.Month03 := 0;
  END IF;
  if (:new.Month04 IS NULL) then
    :new.Month04 := 0;
  END IF;
  if (:new.Month05 IS NULL) then
    :new.Month05 := 0;
  END IF;
  if (:new.Month06 IS NULL) then
    :new.Month06 := 0;
  END IF;
  if (:new.Month07 IS NULL) then
    :new.Month07 := 0;
  END IF;
  if (:new.Month08 IS NULL) then
    :new.Month08 := 0;
  END IF;
  if (:new.Month09 IS NULL) then
    :new.Month09 := 0;
  END IF;
  if (:new.Month10 IS NULL) then
    :new.Month10 := 0;
  END IF;
  if (:new.Month11 IS NULL) then
    :new.Month11 := 0;
  END IF;
  if (:new.Month12 IS NULL) then
    :new.Month12 := 0;
  END IF;

  if (:new.Quarter1 IS NULL) then
    :new.Quarter1 := 0;
  END IF;
  if (:new.Quarter2 IS NULL) then
    :new.Quarter2 := 0;
  END IF;
  if (:new.Quarter3 IS NULL) then
    :new.Quarter3 := 0;
  END IF;
  if (:new.Quarter4 IS NULL) then
    :new.Quarter4 := 0;
  END IF;

  if (:new.WritExecutionSumma is Null) then
    :new.WritExecutionSumma := 0;
  END IF;
  if ((not :new.PROMISE is null) and (not :new.BUDGETPROMISE is null)) then
    BEGIN
      select ps.id     into ScheduleRef$ from PaymentSchedule ps
      where (ps.InnerPromiseNum = :new.BUDGETPROMISE) and
      (ps.ANumber = :new.PROMISE)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (ScheduleRef$ <> 0) then
    :new.PScheduleRef := ScheduleRef$;

  else
    :new.PScheduleRef := null;
  END IF;
  /*    */
  GETTARGETCLS(null, :new.transfertcls, null, :new.meanstype,
  :new.targetcls,:new.targetcls);

-- - - - - - - - - - - - -
-- BI_110 (TR_WritExecutionDetail_BI_110)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  if (:new.KD is NULL) then
    :new.KD := 0;
  END IF;
  if (:new.IFS is NULL) then
    :new.IFS := 0;
  END IF;

  if (:new.ClsType is NULL) then
    if (:new.KD <> 0) then
      :new.ClsType := 2; /*       ClsType */

    else
      if (:new.IFS <> 0) then
        :new.ClsType := 1;

      else
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.KD <> 0) or (:new.ifs <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 2) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BI_200 (TR_WRITEXECUTIONDETAIL_BI_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck1$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck1$ = 1)) then
    if (:new.Promise is not null) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count1$        from
      promise_detail pr
      where
      (pr.registrnumber = :new.PROMISE)
      ;
      /*    ,  */
      if (Promise_Count1$ = 0) then
        RaiseException('EX_BP_NotExist');    
      END IF;  
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise,   BudgetPromise,   BudgetPromise */
    if ((:new.Promise is not null) and (:new.BudgetPromise is null)) then
      select 
      max(InnerPromiseNum) 
      into BPInnerNum1$       from 
      PaymentSchedule 
      where 
      (ANumber = :new.Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum1$ <> 0) then
        :new.BudgetPromise := BPInnerNum1$;
              
      else
        RaiseException('EX_BP_NotExist');    
      END IF;
    END IF;
    /*  BudgetPromise,   Promise,   Promise */
    if ((:new.BudgetPromise is not null) and (:new.Promise is null)) then
      BEGIN
        select 
        ANumber 
        into BPInnerNum1$       from 
        PaymentSchedule
        where 
        (InnerPromiseNum = :new.BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum1$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      :new.Promise := BPInnerNum1$;
          
    END IF;
    /*     */
    if (:new.BudgetPromise is not null and :new.Promise is not null) then
      SELECT COUNT(ANumber ) INTO CNT$1
      from PaymentSchedule where (ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_210 (TR_WRITEXECUTIONDETAIL_BI_210)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode1$);
  if (PromiseMode1$ = 1) then
    /*        */
    if (:new.Promise is not null) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = :new.Promise and ps.InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_WRITEXECUTIONDETAIL_BI_500)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  :new.CreateDate := SYSDATE;
  :new.UpdateDate := :new.CreateDate;
  :new.CreaterUser := user;
  :new.UpdaterUser := user;

END;
/
-- CREATE TRIGGER TR_WRITEXECUTIONDETAIL_BU_200
CREATE OR REPLACE TRIGGER TR_WRITEXECUTIONDETAIL_BU
  BEFORE UPDATE
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  PromiseMode$ NUMBER(10);
  ProgIndex$ NUMBER(10);
  ExecID$ NUMBER(10);
  ExecInnerNumber$ NUMBER(10);
  AgrInnerNumber$ NUMBER(10);
  ScheduleRef$ NUMBER(10);
  BPInnerNum$ NUMBER(10);
  PromiseMode2$ NUMBER(10);
  Promise_Count$ NUMBER(10);
  ConstCheck$ NUMBER(10);
  PromiseAcceptDate$ NUMBER;
  PromiseAccepted$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_WRITEXECUTIONDETAIL_BU)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if (:new.BudgetRef is null) then
    BEGIN
      select
      writ_c.BudgetRef
      into :new.BudgetRef     from
      WritExecutionCaption writ_c
      where
      writ_c.id = :new.RecordIndex
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (:new.Progindex is null) then
    :new.Progindex := 556;
  END IF;
  if (:new.FacialAcc_Cls is null) then
    :new.FacialAcc_Cls := 0;
  END IF;
  if (:new.KVSR is null) then
    :new.KVSR := 0;
  END IF;
  if (:new.KFSR is null) then
    :new.KFSR := 0;
  END IF;
  if (:new.KESR is null) then
    :new.KESR := 0;
  END IF;
  if (:new.KVR is null) then
    :new.KVR := 0;
  END IF;
  if (:new.KCSR is null) then
    :new.KCSR := 0;
  END IF;
  if (:new.MeansType is null) then
    :new.MeansType := 0;
  END IF;
  if (:new.Fact is null) then
    :new.Fact := 0;
  END IF;
  if (:new.DirectionCls is null) then
    :new.DirectionCls := 0;
  END IF;
  if (:new.RegionCLS is null) then
    :new.RegionCLS := 0;
  END IF;
  if (:new.Finsource is null) then
    :new.Finsource := 0;
  END IF;
  if (:new.FinType is null) then
    :new.FinType := 0;
  END IF;
  if (:new.DocType is null) then
    :new.DocType := 0;
  END IF;
  if (:new.SubKesr is null) then
    :new.SubKesr := 0;
  END IF;

  if (:new.Month01 IS NULL) then
    :new.Month01 := 0;
  END IF;
  if (:new.Month02 IS NULL) then
    :new.Month02 := 0;
  END IF;
  if (:new.Month03 IS NULL) then
    :new.Month03 := 0;
  END IF;
  if (:new.Month04 IS NULL) then
    :new.Month04 := 0;
  END IF;
  if (:new.Month05 IS NULL) then
    :new.Month05 := 0;
  END IF;
  if (:new.Month06 IS NULL) then
    :new.Month06 := 0;
  END IF;
  if (:new.Month07 IS NULL) then
    :new.Month07 := 0;
  END IF;
  if (:new.Month08 IS NULL) then
    :new.Month08 := 0;
  END IF;
  if (:new.Month09 IS NULL) then
    :new.Month09 := 0;
  END IF;
  if (:new.Month10 IS NULL) then
    :new.Month10 := 0;
  END IF;
  if (:new.Month11 IS NULL) then
    :new.Month11 := 0;
  END IF;
  if (:new.Month12 IS NULL) then
    :new.Month12 := 0;
  END IF;

  if (:new.Quarter1 IS NULL) then
    :new.Quarter1 := 0;
  END IF;
  if (:new.Quarter2 IS NULL) then
    :new.Quarter2 := 0;
  END IF;
  if (:new.Quarter3 IS NULL) then
    :new.Quarter3 := 0;
  END IF;
  if (:new.Quarter4 IS NULL) then
    :new.Quarter4 := 0;
  END IF;

  if (:new.WritExecutionSumma is Null) then
    :new.WritExecutionSumma := 0;
  END IF;
  if ((not :new.PROMISE is null) and (not :new.BUDGETPROMISE is null)) then
    BEGIN
      select ps.id     into ScheduleRef$ from PaymentSchedule ps
      where (ps.InnerPromiseNum = :new.BUDGETPROMISE) and
      (ps.ANumber = :new.PROMISE)
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  if (ScheduleRef$ <> 0) then
    :new.PScheduleRef := ScheduleRef$;

  else
    :new.PScheduleRef := null;
  END IF;
  /*    */
  GETTARGETCLS(:old.transfertcls, :new.transfertcls, :old.meanstype, :new.meanstype,
  :new.targetcls,:new.targetcls);

-- - - - - - - - - - - - -
-- BU_110 (TR_WritExecutionDetail_BU_110)
-- Version 12.10.00.1
-- - - - - - - - - - - - -

  if (:new.KD is NULL) then
    :new.KD := 0;
  END IF;
  if (:new.IFS is NULL) then
    :new.IFS := 0;
  END IF;
  if (:new.ClsType is NULL) then
    if (:new.KD <> 0) then
      :new.ClsType := 2; /*       ClsType */

    else
      if (:new.IFS <> 0) then
        :new.ClsType := 1;

      else
        :new.ClsType := 0;
      END IF;
    END IF;
  END IF;
  IF ((:new.ClsType = 0) AND ((:new.KD <> 0) or (:new.ifs <> 0))) THEN  /*   */
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (
  (:new.KVSR <> 0) OR (:new.KFSR <> 0) OR
  (:new.KCSR <> 0) OR (:new.KVR <> 0)
  )) THEN
    RaiseException('EX_WRONGBUDCLS');
  END IF;
  IF ((:new.ClsType <> 0) AND (:new.ClsType <> 2) AND (:new.ClsType <> 1)) THEN /*   */
    RaiseException('EX_WRONGBUDCLSTYPE');
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_WRITEXECUTIONDETAIL_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*       */
  GetIntConst(30, 15,PromiseMode2$);
  getintconst(30, 35,ConstCheck$);
  /* ( )      ,    */
  if ((PromiseMode2$ <> 1) and (ConstCheck$ = 1)) then
    if ((:new.Promise is not null)and((:old.Promise is null)or(:old.Promise <> :new.Promise ))) then
      select
      count(pr.REGISTRNUMBER)
      into
      Promise_Count$        from
      promise_detail pr
      where
      (pr.registrnumber = :new.PROMISE)
      ;
      /*    ,  */
      if (Promise_Count$ = 0) then
        RaiseException('EX_BP_NotExist');    
      END IF;  
    END IF;/* end  PromiseMode <> 1*/
  END IF;
  if (PromiseMode2$ = 1) then
    /*  Promise    BudgetPromise=NULL,   BudgetPromise */
    if ((:new.Promise is not null)and((:old.Promise is null)or(:old.Promise <> :new.Promise )) and 
    (:new.BudgetPromise is null) and (:old.BudgetPromise is null)) then
      select 
      max(InnerPromiseNum) 
      into BPInnerNum$       from 
      PaymentSchedule 
      where 
      (ANumber = :new.Promise) and (AcceptDate is not null) and (Accepted = 1)
      ;
      if (BPInnerNum$ <> 0) then
        :new.BudgetPromise := BPInnerNum$;
              
      else
        RaiseException('EX_BP_NotExist');    
      END IF;
    END IF;
        
    /*  BudgetPromise    Promise=NULL,   Promise */
    if (:new.Promise is null and ((:new.BudgetPromise is not null and :old.BudgetPromise is null) or
    (:new.BudgetPromise <> :old.BudgetPromise))) then
      BEGIN
        select 
        ANumber 
        into BPInnerNum$       from 
        PaymentSchedule
        where 
        (InnerPromiseNum = :new.BudgetPromise) and (LastAccepted = 1)
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (BPInnerNum$ is NULL) then
        RaiseException('EX_BP_NotExist');
      END IF;
      :new.Promise := BPInnerNum$;
          
    END IF;
        
    /*  BudgetPromise -   Promise */
    if ((:new.BudgetPromise is null) and (:old.BudgetPromise is not null)) then
      :new.Promise := null;
    END IF;
    /*  Promise -   BudgetPromise */
    if ((:new.Promise is null) and (:old.Promise is not null)) then
      :new.BudgetPromise := null;
    END IF;
    /*     */
    if (:new.BudgetPromise is not null and :new.Promise is not null) then
      SELECT COUNT(ANumber
      ) INTO CNT$1
      from PaymentSchedule
      where (ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise) AND (ROWNUM = 1);
      if (not (CNT$1<> 0)) then
        RaiseException('Ex_BP_NotExist');
      END IF;
      BEGIN

        /*     */
        select AcceptDate, Accepted       into PromiseAcceptDate$, PromiseAccepted$ from PaymentSchedule
        where ANumber = :new.Promise and InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      /*        */
      if (PromiseAccepted$ <> 1) then
        RaiseException('Ex_BP_Rejected');    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_WRITEXECUTIONDETAIL_BU_210)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  /*    ?*/
  GetIntConst(30, 15,PromiseMode$);
  if (PromiseMode$ = 1) then
    /*        */
    if (:new.Promise is not null and (
    (:old.Promise is null or :old.Promise <> :new.Promise) or
    (:old.ExecDoc is null or :new.ExecDoc is null or :old.ExecDoc <> :new.ExecDoc)
    )) then
      BEGIN
        /* ,       ,    */
        select
        ps.ProgIndex, ps.ExecutionRef, edc.InnerNumber, a.InnerNumber
        into ProgIndex$, ExecID$, ExecInnerNumber$, AgrInnerNumber$       from PaymentSchedule ps
        left join ExecutionDocumentsCaption edc on edc.ID = ps.ExecutionRef
        left join Agreements a on a.Id = ps.AgreementRef
        where
        ps.ANumber = :new.Promise and ps.InnerPromiseNum = :new.BudgetPromise
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;/*   " "*/
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_WRITEXECUTIONDETAIL_BU_700)
-- Create 02.04.2010
-- Last update 02.04.2010
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion + 1;
  end if;

END;
/
commit work
/

-- #########################################################
-- #########################################################
-- Update_BudgetPromise.sql
-- #########################################################
-- #########################################################

/*   ,      ,  -  PaymentSchedule - Promise  BudgetPromise */
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 DISABLE
/
update facialfindetail set sourcebudgetpromise=null
where (sourcebudgetpromise is not null and sourcepromise is null)
/
update facialfindetail set destbudgetpromise=null
where (destbudgetpromise is not null and destpromise is null)
/
ALTER TRIGGER TR_FACIALFINDETAIL_BU_500 ENABLE
/
ALTER TRIGGER TR_CORRECTIONDETAIL_BU_500 DISABLE
/
Update CorrectionDetail set budgetpromise=null
where (budgetpromise is not null and promise is null)
/
ALTER TRIGGER TR_CORRECTIONDETAIL_BU_500 ENABLE
/
ALTER TRIGGER TR_WRITEXECUTIONDETAIL_BU_500 DISABLE
/
Update WRITEXECUTIONDETAIL set budgetpromise=null
where (budgetpromise is not null and promise is null)
/
ALTER TRIGGER TR_WRITEXECUTIONDETAIL_BU_500 ENABLE
/

commit work
/

-- #########################################################
-- #########################################################
-- Alter_TenderCaption_Add_ParentInnerNumber.sql
-- #########################################################
-- #########################################################

/*   ParentInnerNumber  TenderCaption,     "stateorderinnernumber"        */
ALTER TABLE TB_TenderCaption ADD (
  ParentInnerNumber NUMBER(10)/*   /   / */,
    CHECK((ParentInnerNumber<=2147483647)AND(ParentInnerNumber>-2147483648))
)
/

CREATE OR REPLACE VIEW TenderCaption (
  ID,
  BUDGETREF,
  FACIALACCCLS,
  MULTIPURPOSE,
  DOCUMENTDATE,
  ACCEPTDATE,
  PERIOD,
  ACCEPTSUMMA,
  SALETYPE,
  REJECTCLS,
  CRYPTOSTATUS,
  SENDERID,
  SENDERRECORDID,
  DOCSTATEREF,
  CREATERUSER,
  CREATEDATE,
  UPDATEDATE,
  UPDATERUSER,
  LASTADJUSTMENT,
  LASTACCEPTED,
  ADJUSTMENTREF,
  ACCEPTED,
  EXPORTDATE,
  YEARACCEPTSUMMA,
  TENDEROPTION,
  TENDERTARGET,
  RVERSION,
  ALLOWANCE,
  REFINEMENTCAUSE,
  PREFERENCE,
  PREFERENCESIZE,
  SECURITY,
  UNKNOWNAMOUNT,
  PERIODYEAR,
  SUPPORTUNDERTAKER,
  AYEAR,
  REWORKCAUSE,
  NOTE,
  REALID,
  INNERNUMBER,
  ADJUSTMENTNUMBER,
  SENDERIDKEY,
  SENDERRECORDIDKEY,
  PROTOCOLREASON,
  PROGINDEX,
  DOCNUMBER,
  SECURITYTSIZE,
  SECURITYASIZE,
  AVANSSIZE,
  PREFERENCECRIPPLE,
  PREFERENCERUSPRODUCT,
  PREFERENCEPRISON,
  AGREEMENTEXECUTIONDATE,
  PURCHASECODE,
  PURCHASESOCIALNKO,
  AVERSION,
  PARENTREF,
  REJECTCAUSE,
  PARENTINNERNUMBER)
AS
  SELECT
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE,
    PARENTINNERNUMBER
  FROM TB_TenderCaption
/

CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_ID
  INSTEAD OF DELETE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  cnt$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_TENDERCAPTION_BD)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   5.1 */
  select count(ID) into cnt$ from TenderCaption where (AdjustmentRef = :old.ID) ;
  /*    ,    */
  if (cnt$ = 0) then
    delete from TenderSupDocument where (RecordIndex = :old.ID);
    delete from TenderYardsticks where (RecordIndex = :old.ID);
    delete from TenderSourceOrg where (RecordIndex = :old.ID);
    delete from TenderContacts where (RecordIndex = :old.ID);
    delete from TenderSupplements where (RecordIndex = :old.ID);
    delete from TenderProduct where (RecordIndex = :old.ID);
    delete from TenderLot where (RecordIndex = :old.ID);

  else
    RaiseException('EX_Ten_CantDelAdjustmented');
  END IF;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_TENDERCAPTION
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AD_0 (TR_TenderCaption_AD)
-- Last update 06.08.2010
-- - - - - - - - - - - - -

  delete from TENDERPRODUCT where (RecordIndex = :old.ID);
  delete from TenderSourceOrg where (RecordIndex = :old.ID);

-- - - - - - - - - - - - -
-- AD_10 (TR_TENDERCAPTION_AD_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*   LastAdjustment     */
  if ((:old.AdjustmentRef is not null) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;
  /*   LastAccepted     */    
  if ((:old.AdjustmentRef is not null) and (:old.LastAccepted = 1)) then
    update TenderCaption set
    LastAccepted = 1,
    RVersion = -1
    where (ID = :old.AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AD_200 (TR_TENDERCAPTION_AD_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  /*         */
  delete from StateJumpHistory where DocID = :old.ID;

-- - - - - - - - - - - - -
-- AD_500 (TR_TENDERCAPTION_AD_500)
-- Version 9.00.00.1
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate, ProgIndex) values (139, :old.ID, SYSDATE, :old.ProgIndex);

END;
/

CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$PARENTINNERNUMBER TENDERCAPTION.PARENTINNERNUMBER%TYPE := :NEW.PARENTINNERNUMBER;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;
      
  /*    */  
  select max(AdjustmentNumber)
  into Tmp1$         from TenderCaption 
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/   
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;    
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
          
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID)
    into Tmp1$             from TenderCaption 
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */    
    if (Tmp1$ <> 1) then 
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_Ten_AdjustDuplicate');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE,
    PARENTINNERNUMBER
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE,
    new$PARENTINNERNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);            
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/

CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$PARENTINNERNUMBER TENDERCAPTION.PARENTINNERNUMBER%TYPE := :NEW.PARENTINNERNUMBER;
--
  ParentProgIndex$ NUMBER(10);
  ParentInnerNumber$ NUMBER(10);
  AdjParentRef$ NUMBER(10);
  AdjParentInnerNumber$ NUMBER(10);
  DetCount1$ NUMBER(10);
  countLastAdj1$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*   !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj1$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj1$ = 0) then
      new$LastAdjustment := 1;
        
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_Ten_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
            
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from TenderCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and
    (CNT$1<> 0)         ) then
      RaiseException('EX_PrimaryDocHasAdjustment');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex$, ParentInnerNumber$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex$ <> 240))
    then
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber$         from TenderCaption
          where ID=AdjParentRef$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber$ <> ParentInnerNumber$) then
          RaiseException('EX_IncorrectAdjTenderParentRef');
        END IF;
      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE,
    PARENTINNERNUMBER = new$PARENTINNERNUMBER
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
          
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BI_30
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_II
  INSTEAD OF INSERT
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$PARENTINNERNUMBER TENDERCAPTION.PARENTINNERNUMBER%TYPE := :NEW.PARENTINNERNUMBER;
--
  PreviousInner$ NUMBER(10);
  Tmp1$ NUMBER(10);
  ParentProgIndex1$ NUMBER(10);
  AdjParentRef1$ NUMBER(10);
  AdjParentInnerNumber1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_TENDERCAPTION_BI)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then 
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
      
  /*  .    ,     */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    BEGIN
      select fa.BudgetRef       into new$BudgetRef from FacialAcc_Cls fa
      where fa.Id = new$FacialAccCls
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /*    ,    */
  if ((new$BudgetRef is null) or (new$BudgetRef = 0)) then
    GetIntConst(-1,3,new$BudgetRef);
  END IF;
      
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  if (new$PurchaseSocialNKO is null) then 
    new$PurchaseSocialNKO := 0;
  END IF;
  /*    ,     ,      */
  if (new$AdjustmentRef is null) then
    new$InnerNumber := GEN_ID('G_TenderInnerNumber',1);
        
  else
    BEGIN
      /*          */
      select
      InnerNumber
      into PreviousInner$       from TenderCaption
      where ID = new$AdjustmentRef and LastAccepted = 1 and LastAdjustment = 1
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    if (PreviousInner$ is null) then
      RaiseException('EX_NotFindInnerNumber');
    END IF;
    new$InnerNumber := PreviousInner$;
        
  END IF;

-- - - - - - - - - - - - -
-- BI_5 (TR_TENDERCAPTION_BI_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_10 (TR_TENDERCAPTION_BI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*    .*/
  if (new$InnerNumber is null) then
    RaiseException('EX_Ten_InnerNumsIsNull');
  END IF;
      
  /*    */  
  select max(AdjustmentNumber)
  into Tmp1$         from TenderCaption 
  where (InnerNumber = new$InnerNumber)
  ;
  /*      ,   0*/   
  if (Tmp1$ is null) then
    new$AdjustmentNumber := 0;
        
  else
    new$AdjustmentNumber := Tmp1$ + 1;    
  END IF;
      
  /*        ,     */
  if ((new$Accepted = 0) and (new$AcceptDate is not null)) then
    new$LastAdjustment := 0;
        
  else
    new$LastAdjustment := 1;
  END IF;
      
  /*   ,       */
  if ((new$AcceptDate is not null) and (new$Accepted = 1)) then 
    new$LastAccepted := 1;
        
  else
    new$LastAccepted := 0;
  END IF;
          
  /*    */
  if (new$AdjustmentRef is not null) then
    /*      -    */
    select count(ID)
    into Tmp1$             from TenderCaption 
    where (InnerNumber = new$InnerNumber) and (LastAccepted = 1)
    ;
    /*   ,  */    
    if (Tmp1$ <> 1) then 
      RaiseException('EX_Ten_AdjustNotAccept');
    END IF;
    /*         ,  */
    select count(ID) 
    into Tmp1$             from TenderCaption
    where (InnerNumber = new$InnerNumber) and (AcceptDate is null)
    ;
    if (Tmp1$ > 0) then 
      RaiseException('EX_Ten_AdjustDuplicate');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_30 (TR_TENDERCAPTION_BI_30)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  new$ParentInnerNumber := null;
  if (new$ParentRef is not null) then
    BEGIN
      select ProgIndex, InnerNumber
      into ParentProgIndex1$, new$ParentInnerNumber     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex1$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex1$ <> 240))
    then 
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef1$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef1$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber1$         from TenderCaption
          where ID=AdjParentRef1$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber1$ <> new$ParentInnerNumber) then
          RaiseException('EX_IncorrectAdjTenderParentRef');      
        END IF;    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BI_40 (TR_TENDERCAPTION_BI_40)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  if (new$senderId is null) then
    new$senderIdKey := -1;

  else
    new$senderIdKey := new$senderId;
  END IF;
  if (new$SenderRecordID is null) then
    new$SenderRecordIDKey := new$ID;

  else
    new$SenderRecordIDKey := new$SenderRecordID;
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_TENDERCAPTION_BI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- BI_600 (tendercaption_realid_bi_600)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_TENDERCAPTION (
    ID,
    BUDGETREF,
    FACIALACCCLS,
    MULTIPURPOSE,
    DOCUMENTDATE,
    ACCEPTDATE,
    PERIOD,
    ACCEPTSUMMA,
    SALETYPE,
    REJECTCLS,
    CRYPTOSTATUS,
    SENDERID,
    SENDERRECORDID,
    DOCSTATEREF,
    CREATERUSER,
    CREATEDATE,
    UPDATEDATE,
    UPDATERUSER,
    LASTADJUSTMENT,
    LASTACCEPTED,
    ADJUSTMENTREF,
    ACCEPTED,
    EXPORTDATE,
    YEARACCEPTSUMMA,
    TENDEROPTION,
    TENDERTARGET,
    RVERSION,
    ALLOWANCE,
    REFINEMENTCAUSE,
    PREFERENCE,
    PREFERENCESIZE,
    SECURITY,
    UNKNOWNAMOUNT,
    PERIODYEAR,
    SUPPORTUNDERTAKER,
    AYEAR,
    REWORKCAUSE,
    NOTE,
    REALID,
    INNERNUMBER,
    ADJUSTMENTNUMBER,
    SENDERIDKEY,
    SENDERRECORDIDKEY,
    PROTOCOLREASON,
    PROGINDEX,
    DOCNUMBER,
    SECURITYTSIZE,
    SECURITYASIZE,
    AVANSSIZE,
    PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT,
    PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE,
    PURCHASECODE,
    PURCHASESOCIALNKO,
    AVERSION,
    PARENTREF,
    REJECTCAUSE,
    PARENTINNERNUMBER
  ) VALUES (
    new$ID,
    new$BUDGETREF,
    new$FACIALACCCLS,
    new$MULTIPURPOSE,
    new$DOCUMENTDATE,
    new$ACCEPTDATE,
    new$PERIOD,
    new$ACCEPTSUMMA,
    new$SALETYPE,
    new$REJECTCLS,
    new$CRYPTOSTATUS,
    new$SENDERID,
    new$SENDERRECORDID,
    new$DOCSTATEREF,
    new$CREATERUSER,
    new$CREATEDATE,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$LASTADJUSTMENT,
    new$LASTACCEPTED,
    new$ADJUSTMENTREF,
    new$ACCEPTED,
    new$EXPORTDATE,
    new$YEARACCEPTSUMMA,
    new$TENDEROPTION,
    new$TENDERTARGET,
    new$RVERSION,
    new$ALLOWANCE,
    new$REFINEMENTCAUSE,
    new$PREFERENCE,
    new$PREFERENCESIZE,
    new$SECURITY,
    new$UNKNOWNAMOUNT,
    new$PERIODYEAR,
    new$SUPPORTUNDERTAKER,
    new$AYEAR,
    new$REWORKCAUSE,
    new$NOTE,
    new$REALID,
    new$INNERNUMBER,
    new$ADJUSTMENTNUMBER,
    new$SENDERIDKEY,
    new$SENDERRECORDIDKEY,
    new$PROTOCOLREASON,
    new$PROGINDEX,
    new$DOCNUMBER,
    new$SECURITYTSIZE,
    new$SECURITYASIZE,
    new$AVANSSIZE,
    new$PREFERENCECRIPPLE,
    new$PREFERENCERUSPRODUCT,
    new$PREFERENCEPRISON,
    new$AGREEMENTEXECUTIONDATE,
    new$PURCHASECODE,
    new$PURCHASESOCIALNKO,
    new$AVERSION,
    new$PARENTREF,
    new$REJECTCAUSE,
    new$PARENTINNERNUMBER);

-- - - - - - - - - - - - -
-- AI_10 (TR_TENDERCAPTION_AI_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  if ((new$AdjustmentRef is not null) and (new$LastAdjustment = 1)) then
    update TenderCaption set
    LastAdjustment = 0,
    RVersion = -1
    where (ID = new$AdjustmentRef);            
    if (new$LastAccepted = 1) then
      update TenderCaption set
      LastAccepted = 0,
      RVersion = -1
      where (ID = new$AdjustmentRef);
        
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AI_500 (TR_TENDERCAPTION_AI_500)
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   DELETE FROM delrecindexes
         WHERE (tableid = 139) AND (recordid = new$ID);

END;
/
-- CREATE TRIGGER TR_TENDERCAPTION_BU_30
CREATE OR REPLACE TRIGGER TR_TENDERCAPTION_IU
  INSTEAD OF UPDATE
  ON TENDERCAPTION
  FOR EACH ROW
DECLARE
  new$ID TENDERCAPTION.ID%TYPE := :NEW.ID;
  new$BUDGETREF TENDERCAPTION.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$FACIALACCCLS TENDERCAPTION.FACIALACCCLS%TYPE := :NEW.FACIALACCCLS;
  new$MULTIPURPOSE TENDERCAPTION.MULTIPURPOSE%TYPE := :NEW.MULTIPURPOSE;
  new$DOCUMENTDATE TENDERCAPTION.DOCUMENTDATE%TYPE := :NEW.DOCUMENTDATE;
  new$ACCEPTDATE TENDERCAPTION.ACCEPTDATE%TYPE := :NEW.ACCEPTDATE;
  new$PERIOD TENDERCAPTION.PERIOD%TYPE := :NEW.PERIOD;
  new$ACCEPTSUMMA TENDERCAPTION.ACCEPTSUMMA%TYPE := :NEW.ACCEPTSUMMA;
  new$SALETYPE TENDERCAPTION.SALETYPE%TYPE := :NEW.SALETYPE;
  new$REJECTCLS TENDERCAPTION.REJECTCLS%TYPE := :NEW.REJECTCLS;
  new$CRYPTOSTATUS TENDERCAPTION.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$SENDERID TENDERCAPTION.SENDERID%TYPE := :NEW.SENDERID;
  new$SENDERRECORDID TENDERCAPTION.SENDERRECORDID%TYPE := :NEW.SENDERRECORDID;
  new$DOCSTATEREF TENDERCAPTION.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CREATERUSER TENDERCAPTION.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE TENDERCAPTION.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE TENDERCAPTION.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER TENDERCAPTION.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$LASTADJUSTMENT TENDERCAPTION.LASTADJUSTMENT%TYPE := :NEW.LASTADJUSTMENT;
  new$LASTACCEPTED TENDERCAPTION.LASTACCEPTED%TYPE := :NEW.LASTACCEPTED;
  new$ADJUSTMENTREF TENDERCAPTION.ADJUSTMENTREF%TYPE := :NEW.ADJUSTMENTREF;
  new$ACCEPTED TENDERCAPTION.ACCEPTED%TYPE := :NEW.ACCEPTED;
  new$EXPORTDATE TENDERCAPTION.EXPORTDATE%TYPE := :NEW.EXPORTDATE;
  new$YEARACCEPTSUMMA TENDERCAPTION.YEARACCEPTSUMMA%TYPE := :NEW.YEARACCEPTSUMMA;
  new$TENDEROPTION TENDERCAPTION.TENDEROPTION%TYPE := :NEW.TENDEROPTION;
  new$TENDERTARGET TENDERCAPTION.TENDERTARGET%TYPE := :NEW.TENDERTARGET;
  new$RVERSION TENDERCAPTION.RVERSION%TYPE := :NEW.RVERSION;
  new$ALLOWANCE TENDERCAPTION.ALLOWANCE%TYPE := :NEW.ALLOWANCE;
  new$REFINEMENTCAUSE TENDERCAPTION.REFINEMENTCAUSE%TYPE := :NEW.REFINEMENTCAUSE;
  new$PREFERENCE TENDERCAPTION.PREFERENCE%TYPE := :NEW.PREFERENCE;
  new$PREFERENCESIZE TENDERCAPTION.PREFERENCESIZE%TYPE := :NEW.PREFERENCESIZE;
  new$SECURITY TENDERCAPTION.SECURITY%TYPE := :NEW.SECURITY;
  new$UNKNOWNAMOUNT TENDERCAPTION.UNKNOWNAMOUNT%TYPE := :NEW.UNKNOWNAMOUNT;
  new$PERIODYEAR TENDERCAPTION.PERIODYEAR%TYPE := :NEW.PERIODYEAR;
  new$SUPPORTUNDERTAKER TENDERCAPTION.SUPPORTUNDERTAKER%TYPE := :NEW.SUPPORTUNDERTAKER;
  new$AYEAR TENDERCAPTION.AYEAR%TYPE := :NEW.AYEAR;
  new$REWORKCAUSE TENDERCAPTION.REWORKCAUSE%TYPE := :NEW.REWORKCAUSE;
  new$NOTE TENDERCAPTION.NOTE%TYPE := :NEW.NOTE;
  new$REALID TENDERCAPTION.REALID%TYPE := :NEW.REALID;
  new$INNERNUMBER TENDERCAPTION.INNERNUMBER%TYPE := :NEW.INNERNUMBER;
  new$ADJUSTMENTNUMBER TENDERCAPTION.ADJUSTMENTNUMBER%TYPE := :NEW.ADJUSTMENTNUMBER;
  new$SENDERIDKEY TENDERCAPTION.SENDERIDKEY%TYPE := :NEW.SENDERIDKEY;
  new$SENDERRECORDIDKEY TENDERCAPTION.SENDERRECORDIDKEY%TYPE := :NEW.SENDERRECORDIDKEY;
  new$PROTOCOLREASON TENDERCAPTION.PROTOCOLREASON%TYPE := :NEW.PROTOCOLREASON;
  new$PROGINDEX TENDERCAPTION.PROGINDEX%TYPE := :NEW.PROGINDEX;
  new$DOCNUMBER TENDERCAPTION.DOCNUMBER%TYPE := :NEW.DOCNUMBER;
  new$SECURITYTSIZE TENDERCAPTION.SECURITYTSIZE%TYPE := :NEW.SECURITYTSIZE;
  new$SECURITYASIZE TENDERCAPTION.SECURITYASIZE%TYPE := :NEW.SECURITYASIZE;
  new$AVANSSIZE TENDERCAPTION.AVANSSIZE%TYPE := :NEW.AVANSSIZE;
  new$PREFERENCECRIPPLE TENDERCAPTION.PREFERENCECRIPPLE%TYPE := :NEW.PREFERENCECRIPPLE;
  new$PREFERENCERUSPRODUCT TENDERCAPTION.PREFERENCERUSPRODUCT%TYPE := :NEW.PREFERENCERUSPRODUCT;
  new$PREFERENCEPRISON TENDERCAPTION.PREFERENCEPRISON%TYPE := :NEW.PREFERENCEPRISON;
  new$AGREEMENTEXECUTIONDATE TENDERCAPTION.AGREEMENTEXECUTIONDATE%TYPE := :NEW.AGREEMENTEXECUTIONDATE;
  new$PURCHASECODE TENDERCAPTION.PURCHASECODE%TYPE := :NEW.PURCHASECODE;
  new$PURCHASESOCIALNKO TENDERCAPTION.PURCHASESOCIALNKO%TYPE := :NEW.PURCHASESOCIALNKO;
  new$AVERSION TENDERCAPTION.AVERSION%TYPE := :NEW.AVERSION;
  new$PARENTREF TENDERCAPTION.PARENTREF%TYPE := :NEW.PARENTREF;
  new$REJECTCAUSE TENDERCAPTION.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$PARENTINNERNUMBER TENDERCAPTION.PARENTINNERNUMBER%TYPE := :NEW.PARENTINNERNUMBER;
--
  DetCount1$ NUMBER(10);
  countLastAdj1$ NUMBER(10);
  CNT$1 NUMBER(10);
  ParentProgIndex1$ NUMBER(10);
  AdjParentRef1$ NUMBER(10);
  AdjParentInnerNumber1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_TENDERCAPTION_BU_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if (new$FacialAccCls is null) then 
    new$FacialAccCls := 0;
  END IF;
  /*         ( ) */
  if (new$ProgIndex = 230 and new$Multipurpose is null) then 
    new$Multipurpose := 0;
  END IF;
  if (new$AcceptSumma is null) then 
    new$AcceptSumma := 0;
  END IF;
  if (new$YearAcceptSumma is null) then 
    new$YearAcceptSumma := 0;
  END IF;
  if (new$Allowance is null) then 
    new$Allowance := 0;
  END IF;
  if (new$Accepted is null) then 
    new$Accepted := 1;
  END IF;
  /*     */
  if (new$BudgetRef <> :old.BudgetRef) then
    if (not((new$BudgetRef is null) and (:old.BudgetRef is null))) then
      select count(ID)         into DetCount1$ from TENDERSOURCEORG where RecordIndex = :old.ID
      ;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERCONTACTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPDOCUMENT where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERSUPPLEMENTS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TENDERYARDSTICKS where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');
      else
        select count(ID)         into DetCount1$ from TenderLot where RecordIndex = :old.ID
        ;
      END IF;
      if (DetCount1$ > 0) then 
        RaiseException('Ex_CantModufyBudget');    
      END IF;
    END IF;
  END IF;
  if (new$SaleType is null) then 
    new$SaleType := 0;
  END IF;
  if (new$TenderOption is null) then 
    new$TenderOption := 0;
  END IF;
  if (new$RefinementCause is Null) then 
    new$RefinementCause := 0;
  END IF;
  if (new$Preference is Null) then 
    new$Preference := 0;
  END IF;
  if (new$UnknownAmount is null) then 
    new$UnknownAmount := 0;
  END IF;
  if (new$SupportUndertaker is null) then 
    new$SupportUndertaker := 0;
  END IF;
  /*     ,        */
  if (new$InnerNumber is null) then
    new$InnerNumber := :old.InnerNumber;
  END IF;

-- - - - - - - - - - - - -
-- BU_5 (TR_TENDERCAPTION_BU_5)
-- Version 7.02.00.1
-- - - - - - - - - - - - -

  /*     ,                */
  if (new$DocStateRef is null) then
    if (new$AcceptDate is null or new$RejectCls is null) then
      new$Accepted := 1;

    else
      new$Accepted := 0;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_TENDERCAPTION_BU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  if ((new$InnerNumber <> :old.InnerNumber) or
  (new$AdjustmentRef <> :old.AdjustmentRef) or
  (new$AdjustmentNumber <> :old.AdjustmentNumber)) then
    RaiseException('EX_AGR_ChangeInnerNums');
  END IF;
      
  /*   !!!*/
  if (:old.AcceptDate is not null and :old.Accepted = 0 and (new$Accepted = 1 or new$AcceptDate is null)) then
    /* :  */
    if (new$AdjustmentRef is not null) then
      RaiseException('EX_RollbackCancel');
    END IF;
    /*      ,
             , ,          */
    select count(ID)
    into countLastAdj1$       from TenderCaption
    where InnerNumber=new$InnerNumber and LastAdjustment = 1
    ;
    if (countLastAdj1$ = 0) then
      new$LastAdjustment := 1;
        
    END IF;
  END IF;
  /*  ,     LastAccepted*/
  if (:old.AcceptDate is null and new$AcceptDate is not null and new$Accepted = 1) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 1;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAccepted*/
  if (:old.AcceptDate is not null and :old.Accepted = 1 and new$AcceptDate is null) then
    /*  LastAccepted         */
    if (:old.LastAdjustment = 1) then
      new$LastAccepted := 0;
            
    else
      RaiseException('EX_Ten_ChangeStateAdjust');
    END IF;
  END IF;
  /*   ,     LastAdjustment*/
  if (new$AcceptDate is not null and new$Accepted = 0 and (:old.AcceptDate is null or :old.Accepted = 1)) then
    if (:old.LastAdjustment <> 1) then
      RaiseException('EX_Ten_ChangeStateAdjust');
    else
      new$LastAdjustment := 0;
      new$LastAccepted := 0;
            
    END IF;
    SELECT COUNT(                 Id
    ) INTO CNT$1
    from TenderCaption
    where
    (                 InnerNumber = new$InnerNumber and AdjustmentNumber > 0
    ) AND (ROWNUM = 1)              ;
    /*          */
    if (new$AdjustmentNumber = 0 and
    (CNT$1<> 0)         ) then
      RaiseException('EX_PrimaryDocHasAdjustment');    
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_30 (TR_TENDERCAPTION_BU_30)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  new$ParentInnerNumber := null;
  if (new$ParentRef is not null) then
    BEGIN
      select InnerNumber
      into new$ParentInnerNumber     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
  END IF;
  /* :  /    / */
  if (new$ParentRef is not null
  /*  ,   */
  and  (:old.ParentRef is null
  or (:old.ParentRef is not null and :old.ParentRef <> new$ParentRef)))
  then 
    /* :     ParentRef  */
    if (new$LastAdjustment = 0) then
      RaiseException('EX_ChangeAdjTenderParentRef');
    END IF;
    BEGIN
      select ProgIndex
      into ParentProgIndex1$     from TenderCaption
      where ID=new$ParentRef
      ;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
    END;
    /* :  /    / */
    if  ((new$ProgIndex=243 and ParentProgIndex1$ <> 242)
    or (new$ProgIndex=241 and ParentProgIndex1$ <> 240))
    then 
      RaiseException('EX_IncorrectTenderParentRef');
    END IF;
    /* :       /     ( ,    ) */
    if (new$AdjustmentRef is not null) then
      BEGIN
        select ParentRef
        into AdjParentRef1$       from TenderCaption
        where ID=new$AdjustmentRef
        ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
      if (AdjParentRef1$ is not null) then
        BEGIN
          select InnerNumber
          into AdjParentInnerNumber1$         from TenderCaption
          where ID=AdjParentRef1$

          ;
        EXCEPTION
          WHEN NO_DATA_FOUND THEN NULL;
        END;
        if (AdjParentInnerNumber1$ <> new$ParentInnerNumber) then
          RaiseException('EX_IncorrectAdjTenderParentRef');      
        END IF;    
      END IF;  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_TENDERCAPTION_BU_200)
-- Create 03.12.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   /*        */
   IF (new$DocStateRef <> :OLD.DocStateRef) THEN
      INSERT INTO StateJumpHistory(DocID, BeginStateRef, EndStateRef)
        VALUES (new$ID, :OLD.DocStateRef, new$DocStateRef);
   END IF;

-- - - - - - - - - - - - -
-- BU_600 (tendercaption_realid_bu_600)
-- Version 10.30.00.1
-- - - - - - - - - - - - -

  if (new$realid is null) then
    new$realid := new$id;
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_TENDERCAPTION_BU_700)
-- Create 14.10.2004
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$RVersion IS NULL) THEN
      new$RVersion := 1;
   ELSIF ((new$RVersion = -1) AND (:OLD.RVersion <> -1)) THEN
      new$RVersion := :OLD.RVersion;
   ELSE
      new$RVersion := :OLD.RVersion + 1;
   END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_TENDERCAPTION SET
    ID = new$ID,
    BUDGETREF = new$BUDGETREF,
    FACIALACCCLS = new$FACIALACCCLS,
    MULTIPURPOSE = new$MULTIPURPOSE,
    DOCUMENTDATE = new$DOCUMENTDATE,
    ACCEPTDATE = new$ACCEPTDATE,
    PERIOD = new$PERIOD,
    ACCEPTSUMMA = new$ACCEPTSUMMA,
    SALETYPE = new$SALETYPE,
    REJECTCLS = new$REJECTCLS,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    SENDERID = new$SENDERID,
    SENDERRECORDID = new$SENDERRECORDID,
    DOCSTATEREF = new$DOCSTATEREF,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    LASTADJUSTMENT = new$LASTADJUSTMENT,
    LASTACCEPTED = new$LASTACCEPTED,
    ADJUSTMENTREF = new$ADJUSTMENTREF,
    ACCEPTED = new$ACCEPTED,
    EXPORTDATE = new$EXPORTDATE,
    YEARACCEPTSUMMA = new$YEARACCEPTSUMMA,
    TENDEROPTION = new$TENDEROPTION,
    TENDERTARGET = new$TENDERTARGET,
    RVERSION = new$RVERSION,
    ALLOWANCE = new$ALLOWANCE,
    REFINEMENTCAUSE = new$REFINEMENTCAUSE,
    PREFERENCE = new$PREFERENCE,
    PREFERENCESIZE = new$PREFERENCESIZE,
    SECURITY = new$SECURITY,
    UNKNOWNAMOUNT = new$UNKNOWNAMOUNT,
    PERIODYEAR = new$PERIODYEAR,
    SUPPORTUNDERTAKER = new$SUPPORTUNDERTAKER,
    AYEAR = new$AYEAR,
    REWORKCAUSE = new$REWORKCAUSE,
    NOTE = new$NOTE,
    REALID = new$REALID,
    INNERNUMBER = new$INNERNUMBER,
    ADJUSTMENTNUMBER = new$ADJUSTMENTNUMBER,
    SENDERIDKEY = new$SENDERIDKEY,
    SENDERRECORDIDKEY = new$SENDERRECORDIDKEY,
    PROTOCOLREASON = new$PROTOCOLREASON,
    PROGINDEX = new$PROGINDEX,
    DOCNUMBER = new$DOCNUMBER,
    SECURITYTSIZE = new$SECURITYTSIZE,
    SECURITYASIZE = new$SECURITYASIZE,
    AVANSSIZE = new$AVANSSIZE,
    PREFERENCECRIPPLE = new$PREFERENCECRIPPLE,
    PREFERENCERUSPRODUCT = new$PREFERENCERUSPRODUCT,
    PREFERENCEPRISON = new$PREFERENCEPRISON,
    AGREEMENTEXECUTIONDATE = new$AGREEMENTEXECUTIONDATE,
    PURCHASECODE = new$PURCHASECODE,
    PURCHASESOCIALNKO = new$PURCHASESOCIALNKO,
    AVERSION = new$AVERSION,
    PARENTREF = new$PARENTREF,
    REJECTCAUSE = new$REJECTCAUSE,
    PARENTINNERNUMBER = new$PARENTINNERNUMBER
  WHERE ID = :OLD.ID
      AND (RVersion = :OLD.RVersion
           OR RVersion IS NULL AND :OLD.RVersion IS NULL
          );

   IF SQL%ROWCOUNT <> 1 THEN
      RaiseException ('EX_RECORDCHANGED');
   END IF;

-- - - - - - - - - - - - -
-- AU_10 (TR_TENDERCAPTION_AU_10)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  /*   13.0*/
  /*      */
  /*     ,       */
  if ((new$AdjustmentRef is not null) and (new$LastAccepted <> :old.LastAccepted) and (:old.LastAdjustment = 1)) then
    update TenderCaption set
    LastAccepted = :old.LastAccepted,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;
          
  /*       LastAdjustment    */
  if ((new$AdjustmentRef is not null) and (:old.LastAdjustment = 1) and (new$LastAdjustment = 0) and
  (new$AcceptDate is not null) and (new$Accepted = 0)) then
    update TenderCaption set
    LastAdjustment = 1,
    RVersion = -1
    where (ID = new$AdjustmentRef);
  END IF;

-- - - - - - - - - - - - -
-- AU_20 (TR_TENDERCAPTION_AU_20)
-- Version 8.00.00.1
-- - - - - - - - - - - - -

  /*   2.0*/
  /*       ,      */
  if (:old.FacialAccCls <> new$FacialAccCls) then
    update TenderProduct set
    RVersion = -1,
    FacialAccCls = new$FacialAccCls
    where
    (RecordIndex = new$ID) and (ProgIndex = 230);
  END IF;

-- - - - - - - - - - - - -
-- AU_30 (tr_TenderCaption_au_30)
-- Version 12.00.00.1
-- - - - - - - - - - - - -

  if ((new$DocStateRef is null) /*      */
  and ((new$ProgIndex = 240) /* */ or (new$ProgIndex = 242) /* */))
  then
    if ((new$Accepted <> :old.Accepted)
    or (new$AcceptDate is not null and :old.AcceptDate is null)
    or (new$AcceptDate is null and :old.AcceptDate is not null)
    or (new$AcceptDate is not null and :old.AcceptDate is not null and new$AcceptDate <> :old.AcceptDate))
    then
      update TenderCaption set
      RejectCls = new$RejectCls,
      AcceptDate = new$AcceptDate
      where ParentRef=new$ID;
      /*          */
      if (:old.Accepted=1 and new$Accepted=0) then
        update TenderCaption set
        RejectCause = '   : ' || new$RejectCause
        where ParentRef=new$ID;
      END IF;
      /*             */
      if (:old.Accepted=0 and new$Accepted=1) then
        update TenderCaption set
        RejectCls = null,
        RejectCause = null
        where ParentRef=new$ID;

      END IF;
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_TENDERCAPTION_AU_500)
-- Create 28.04.2005
-- Last update 25.05.2005
-- - - - - - - - - - - - -

   IF (new$ID <> :OLD.ID) THEN
      INSERT INTO DelRecIndexes(TableID, RecordId, DeleteDate)
           VALUES (139, :OLD.ID, SYSDATE);

      DELETE FROM DelRecIndexes
            WHERE (TableID = 139) AND (RecordId = new$ID);
   END IF;

END;
/
commit work
/
ALTER TRIGGER TR_TENDERCAPTION_BU_500 DISABLE
/
update TenderCaption set ParentInnerNumber=ParentInnerNumber where ParentRef is not null
/
ALTER TRIGGER TR_TENDERCAPTION_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- Add_Recipient_ref_to_DataPacket.sql
-- #########################################################
-- #########################################################

/*       - */
ALTER TABLE DataPacket ADD (
  Recipient_Ref NUMBER(10),
    CHECK((Recipient_Ref<=2147483647)AND(Recipient_Ref>-2147483648)),
  Constraint FK_DATAPACKET_RECIPIENT_REF FOREIGN KEY (Recipient_Ref) REFERENCES TB_Organizations (ID)
)
/
CREATE INDEX FK_DATAPACKET_RECIPIENT_REF ON DataPacket(Recipient_Ref)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Create_Temp_Keys.sql
-- #########################################################
-- #########################################################


-- <TRANS_IGNORE>

BEGIN
EXECUTE IMMEDIATE 'CREATE GLOBAL TEMPORARY TABLE Temp_Keys (ID Integer not null primary key) ON COMMIT PRESERVE ROWS';
END;
/

/* Privileges of users */
GRANT SELECT, INSERT, UPDATE, DELETE ON Temp_Keys TO BUDGET_USERS
/

commit work
/



-- #########################################################
-- #########################################################
-- CreateTables_EPBSExport.sql
-- #########################################################
-- #########################################################

create table EPBSExportLogCaption(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  FormDate NUMBER,/* ,     */
  ExportDate DATE,/*      */
  ExportUser VARCHAR2(30),/*   */
  CreaterUser VARCHAR2(30) NOT NULL,
  CreateDate DATE NOT NULL,
  UpdaterUser VARCHAR2(30),
  UpdateDate DATE,
  constraint pk_EPBSExportCaption_ID primary key (id)
)
/
-- CREATE TRIGGER tr_EPBSExpLogCpt_BI_0
CREATE OR REPLACE TRIGGER TR_EPBSExportLogCaption_BI
  BEFORE INSERT
  ON EPBSExportLogCaption
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_EPBSExpLogCpt_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.ExportUser is null) then 
    :new.ExportUser := user;
  END IF;
  if (:new.ExportDate is null) then 
    :new.ExportUser := SYSDATE;
  END IF;

END;
/
-- CREATE TRIGGER tr_EPBSExpLogCpt_BI_500
CREATE OR REPLACE TRIGGER TR_EPBSExportLogCaption_BI
  BEFORE INSERT
  ON EPBSExportLogCaption
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_EPBSExpLogCpt_BI_0)
-- Version 13.00.00.2
-- - - - - - - - - - - - -

  :new.createdate := SYSDATE;
  :new.updatedate := :new.createdate;
  :new.createruser := user;
  :new.updateruser := user;

END;
/
-- CREATE TRIGGER tr_EPBSExpLogCpt_BU_500
CREATE OR REPLACE TRIGGER TR_EPBSExportLogCaption_BU
  BEFORE UPDATE
  ON EPBSExportLogCaption
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_EPBSExpLogCpt_BU_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.updatedate := SYSDATE;
  :new.updateruser := user;

END;
/
create table EPBSExportLogDetail(
  ID NUMBER(10) NOT NULL,
    CHECK((ID<=2147483647)AND(ID>-2147483648)),
  RecordIndex NUMBER(10) NOT NULL,
    CHECK((RecordIndex<=2147483647)AND(RecordIndex>-2147483648)),
  PacketNumber VARCHAR2(255),/*  ,     */
  PageTab VARCHAR2(50),/*   / */
  PageID NUMBER(10),/*   / */
    CHECK((PageID<=2147483647)AND(PageID>-2147483648)),
  WasError NUMBER(10),/*    */
    CHECK((WasError<=2147483647)AND(WasError>-2147483648)),
  NoData NUMBER(10),/*    */
    CHECK((NoData<=2147483647)AND(NoData>-2147483648)),
  CreaterUser VARCHAR2(30) NOT NULL,
  CreateDate DATE NOT NULL,
  UpdaterUser VARCHAR2(30),
  UpdateDate DATE,
  constraint pk_EPBSExpLogDet_ID primary key (id),
  constraint FK_EPBSExpLogDet_RecordIndex foreign key (RecordIndex) references EPBSExportLogCaption(ID)
)
/
CREATE INDEX FK_EPBSExpLogDet_RecordIndex ON EPBSExportLogDetail(RecordIndex)
/
-- CREATE TRIGGER tr_EPBSExpLogDet_BI_0
CREATE OR REPLACE TRIGGER TR_EPBSExportLogDetail_BI
  BEFORE INSERT
  ON EPBSExportLogDetail
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_EPBSExpLogDet_BI_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (:new.id is null) then 
    select g_shared.nextval into :new.id from dual;
  END IF;
  if (:new.WasError is null) then 
    :new.WasError := 0;
  END IF;
  if (:new.NoData is null) then 
    :new.NoData := 0;
  END IF;

END;
/
-- CREATE TRIGGER tr_EPBSExpLogDet_BI_500
CREATE OR REPLACE TRIGGER TR_EPBSExportLogDetail_BI
  BEFORE INSERT
  ON EPBSExportLogDetail
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (tr_EPBSExpLogDet_BI_0)
-- Version 13.00.00.2
-- - - - - - - - - - - - -

  :new.createdate := SYSDATE;
  :new.updatedate := :new.createdate;
  :new.createruser := user;
  :new.updateruser := user;

END;
/
-- CREATE TRIGGER tr_EPBSExpLogDet_BU_500
CREATE OR REPLACE TRIGGER TR_EPBSExportLogDetail_BU
  BEFORE UPDATE
  ON EPBSExportLogDetail
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (tr_EPBSExpLogDet_BU_500)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  :new.updatedate := SYSDATE;
  :new.updateruser := user;

END;
/
-- CREATE TRIGGER tr_EPBSExpLogCpt_BD_0
CREATE OR REPLACE TRIGGER TR_EPBSExportLogCaption_BD
  BEFORE DELETE
  ON EPBSExportLogCaption
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (tr_EPBSExpLogCpt_BD_0)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  delete from EPBSExportLogDetail where (RecordIndex = :old.id);

END;
/
/*        */
/* create table EPBSExportDocList(
ExportDetailRef integer not null,

)
!! */

commit work
/

-- #########################################################
-- #########################################################
-- fix_Check_Unique_Organizations2.sql
-- #########################################################
-- #########################################################

/*    TR_ORGANIZATIONS_BU.
   / ,        INN_KPP.
        INN_KPP.
*/
-- CREATE TRIGGER tr_organizations_bu
CREATE OR REPLACE TRIGGER TR_ORGANIZATIONS_IU
  INSTEAD OF UPDATE
  ON ORGANIZATIONS
  FOR EACH ROW
DECLARE
  new$ID ORGANIZATIONS.ID%TYPE := :NEW.ID;
  new$NAME ORGANIZATIONS.NAME%TYPE := :NEW.NAME;
  new$GOSNI ORGANIZATIONS.GOSNI%TYPE := :NEW.GOSNI;
  new$CITY ORGANIZATIONS.CITY%TYPE := :NEW.CITY;
  new$COUNTRY ORGANIZATIONS.COUNTRY%TYPE := :NEW.COUNTRY;
  new$PHONE ORGANIZATIONS.PHONE%TYPE := :NEW.PHONE;
  new$ADDRESS ORGANIZATIONS.ADDRESS%TYPE := :NEW.ADDRESS;
  new$ORG_CLS ORGANIZATIONS.ORG_CLS%TYPE := :NEW.ORG_CLS;
  new$INN20 ORGANIZATIONS.INN20%TYPE := :NEW.INN20;
  new$SUBINN ORGANIZATIONS.SUBINN%TYPE := :NEW.SUBINN;
  new$FACIALACC ORGANIZATIONS.FACIALACC%TYPE := :NEW.FACIALACC;
  new$REGIONCLS ORGANIZATIONS.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$DIRNAME ORGANIZATIONS.DIRNAME%TYPE := :NEW.DIRNAME;
  new$BUGNAME ORGANIZATIONS.BUGNAME%TYPE := :NEW.BUGNAME;
  new$DIRPHONE ORGANIZATIONS.DIRPHONE%TYPE := :NEW.DIRPHONE;
  new$BUGPHONE ORGANIZATIONS.BUGPHONE%TYPE := :NEW.BUGPHONE;
  new$RCORG ORGANIZATIONS.RCORG%TYPE := :NEW.RCORG;
  new$CREATERUSER ORGANIZATIONS.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$CREATEDATE ORGANIZATIONS.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$UPDATEDATE ORGANIZATIONS.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER ORGANIZATIONS.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$INN ORGANIZATIONS.INN%TYPE := :NEW.INN;
  new$OKATO ORGANIZATIONS.OKATO%TYPE := :NEW.OKATO;
  new$EMAIL ORGANIZATIONS.EMAIL%TYPE := :NEW.EMAIL;
  new$WEBSITE ORGANIZATIONS.WEBSITE%TYPE := :NEW.WEBSITE;
  new$UFKCODE ORGANIZATIONS.UFKCODE%TYPE := :NEW.UFKCODE;
  new$ADDOKATO ORGANIZATIONS.ADDOKATO%TYPE := :NEW.ADDOKATO;
  new$SHORTNAME ORGANIZATIONS.SHORTNAME%TYPE := :NEW.SHORTNAME;
  new$RVERSION ORGANIZATIONS.RVERSION%TYPE := :NEW.RVERSION;
  new$SENDERID ORGANIZATIONS.SENDERID%TYPE := :NEW.SENDERID;
  new$KVSR ORGANIZATIONS.KVSR%TYPE := :NEW.KVSR;
  new$OKFS ORGANIZATIONS.OKFS%TYPE := :NEW.OKFS;
  new$OKOPF ORGANIZATIONS.OKOPF%TYPE := :NEW.OKOPF;
  new$OPENDATE ORGANIZATIONS.OPENDATE%TYPE := :NEW.OPENDATE;
  new$CLOSEDATE ORGANIZATIONS.CLOSEDATE%TYPE := :NEW.CLOSEDATE;
  new$CHANGEDATE ORGANIZATIONS.CHANGEDATE%TYPE := :NEW.CHANGEDATE;
  new$GENERALORG_REF ORGANIZATIONS.GENERALORG_REF%TYPE := :NEW.GENERALORG_REF;
  new$FEDERALREGIONCODE ORGANIZATIONS.FEDERALREGIONCODE%TYPE := :NEW.FEDERALREGIONCODE;
  new$ORG_TYPE ORGANIZATIONS.ORG_TYPE%TYPE := :NEW.ORG_TYPE;
  new$BUDGETREF ORGANIZATIONS.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$SUPPLIERSTATUS ORGANIZATIONS.SUPPLIERSTATUS%TYPE := :NEW.SUPPLIERSTATUS;
  new$COUNTRYCODE ORGANIZATIONS.COUNTRYCODE%TYPE := :NEW.COUNTRYCODE;
  new$DATECLOSE ORGANIZATIONS.DATECLOSE%TYPE := :NEW.DATECLOSE;
  new$ORGCODE ORGANIZATIONS.ORGCODE%TYPE := :NEW.ORGCODE;
  new$COSTAUTHORITY ORGANIZATIONS.COSTAUTHORITY%TYPE := :NEW.COSTAUTHORITY;
  new$INCOMEAUTHORITY ORGANIZATIONS.INCOMEAUTHORITY%TYPE := :NEW.INCOMEAUTHORITY;
  new$DEBTAUTHORITY ORGANIZATIONS.DEBTAUTHORITY%TYPE := :NEW.DEBTAUTHORITY;
  new$SVRAUTHORITY ORGANIZATIONS.SVRAUTHORITY%TYPE := :NEW.SVRAUTHORITY;
  new$CLIENTID ORGANIZATIONS.CLIENTID%TYPE := :NEW.CLIENTID;
  new$DATEOPEN ORGANIZATIONS.DATEOPEN%TYPE := :NEW.DATEOPEN;
  new$FUID ORGANIZATIONS.FUID%TYPE := :NEW.FUID;
  new$OKPO ORGANIZATIONS.OKPO%TYPE := :NEW.OKPO;
  new$OKTMO ORGANIZATIONS.OKTMO%TYPE := :NEW.OKTMO;
  new$DOCSTATEREF ORGANIZATIONS.DOCSTATEREF%TYPE := :NEW.DOCSTATEREF;
  new$CRYPTOSTATUS ORGANIZATIONS.CRYPTOSTATUS%TYPE := :NEW.CRYPTOSTATUS;
  new$OGRN ORGANIZATIONS.OGRN%TYPE := :NEW.OGRN;
  new$REJECT_CLS ORGANIZATIONS.REJECT_CLS%TYPE := :NEW.REJECT_CLS;
  new$EXTID ORGANIZATIONS.EXTID%TYPE := :NEW.EXTID;
  new$EXTOWNER ORGANIZATIONS.EXTOWNER%TYPE := :NEW.EXTOWNER;
  new$EXTSYNCDATE ORGANIZATIONS.EXTSYNCDATE%TYPE := :NEW.EXTSYNCDATE;
  new$REMOTEPBSCODE ORGANIZATIONS.REMOTEPBSCODE%TYPE := :NEW.REMOTEPBSCODE;
  new$REMOTENOTPBSCODE ORGANIZATIONS.REMOTENOTPBSCODE%TYPE := :NEW.REMOTENOTPBSCODE;
  new$USECHECK_CARD ORGANIZATIONS.USECHECK_CARD%TYPE := :NEW.USECHECK_CARD;
  new$EXTROOTID ORGANIZATIONS.EXTROOTID%TYPE := :NEW.EXTROOTID;
  new$EXTVERSION ORGANIZATIONS.EXTVERSION%TYPE := :NEW.EXTVERSION;
  new$EXTVERSIONDATE ORGANIZATIONS.EXTVERSIONDATE%TYPE := :NEW.EXTVERSIONDATE;
  new$RECORDOWNERORGREF ORGANIZATIONS.RECORDOWNERORGREF%TYPE := :NEW.RECORDOWNERORGREF;
  new$REJECTCAUSE ORGANIZATIONS.REJECTCAUSE%TYPE := :NEW.REJECTCAUSE;
  new$BLOCKEDDATE ORGANIZATIONS.BLOCKEDDATE%TYPE := :NEW.BLOCKEDDATE;
  new$BLOCKEDCAUSE ORGANIZATIONS.BLOCKEDCAUSE%TYPE := :NEW.BLOCKEDCAUSE;
  new$UNBLOCKEDDATE ORGANIZATIONS.UNBLOCKEDDATE%TYPE := :NEW.UNBLOCKEDDATE;
  new$UNBLOCKEDCAUSE ORGANIZATIONS.UNBLOCKEDCAUSE%TYPE := :NEW.UNBLOCKEDCAUSE;
  new$ORGREESTRCODE ORGANIZATIONS.ORGREESTRCODE%TYPE := :NEW.ORGREESTRCODE;
--
  CNT$ NUMBER(10);
  CNT$1 NUMBER(10);
  CNT$2 NUMBER(10);
  c1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_ORGANIZATIONS_BU)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$gosni is null) then 
    new$gosni := 0;
  END IF;
  if (new$city is null) then 
    getvarcharconst(-1,7,new$city);
  END IF;
  if (new$country is null) then 
    new$country := '';
  END IF;
  if (new$countrycode is null) then 
    new$countrycode := 643;
  END IF;
  if (new$org_cls is null) then 
    new$org_cls:= 0;
  END IF;
  if (new$inn20 is null) then 
    new$inn20:= '';
  END IF;
  if (new$rcorg is null) then 
    new$rcorg := 0;
  END IF;
  if (new$regioncls is null) then 
    new$regioncls := 0;
  END IF;
  if (new$okato is null) then 
    new$okato := 0;
  END IF;
  if (new$kvsr is null) then 
    new$kvsr := 0;
  END IF;
  if (new$okfs is null) then 
    new$okfs := 0;
  END IF;
  if (new$okopf is null) then 
    new$okopf := 0;
  END IF;
  if (new$federalregioncode is null) then
    getintconst(-1, 27,new$federalregioncode);
  END IF;
  if (new$federalregioncode is null) then
    new$federalregioncode := 0;
  END IF;
  if (new$budgetref is null) then 
    new$budgetref := 0;
  END IF;
  /*    - */
  if (new$org_type is null) then 
    new$org_type := 20000;
  END IF;
  /*        */
  if ((new$generalorg_ref is null) or (new$org_type < 10000) or (new$org_type >= 20000)) then
    new$generalorg_ref := new$id;
  END IF;

  /*    10 ,      */
  if ((new$inn <> :old.inn) or ((:old.inn is null) and (new$inn is not null))) then 
    if ((new$inn > 9999999999.9) and (new$inn20 <> '')) then
      RaiseException('ex_wrongkpp');  
    END IF;
  END IF;
  if ( ((new$inn <> :old.inn) or
  ((:old.inn is null) and (new$inn is not null)) or
  ((:old.inn is not null) and (new$inn is null)))
  or ((new$inn20 <> :old.inn20) or
  ((:old.inn20 is null) and (new$inn20 is not null)) or
  ((:old.inn20 is not null) and (new$inn20 is null))) )
  then 
    delete from INN_KPP where id = :old.id;
    check_unique_organization(new$id, new$inn, new$inn20);
      
  END IF;
   
  if (new$regioncls <> :old.regioncls) then
    update dfaccountsbuhtable set
    regioncls = new$regioncls
    where id = any (select id from org_accounts where org_ref = new$id);
  END IF;
  /*      */
  if (:old.id = 0) then
    RaiseException('ex_cantmodifyunknownorg');
  END IF;
  /*        */
  if ((new$org_type<>:old.org_type) or (new$costauthority<>:old.costauthority))
  then 
    c1$ := new$costauthority;
    if (new$org_type between 10100 and 10299) then
      new$costauthority:= 1;
    END IF;
    if (new$org_type between 10300 and 10399) then
      new$costauthority:= 2;
    END IF;
    if (new$org_type between 10400 and 10499) then
      new$costauthority:= 4;
    END IF;
    if (((new$org_type between 10500 and 10599) and (new$costauthority<>16)) or
    (((new$org_type between 10000 and 10099) or (new$org_type between 10600 and 10799))
    and (new$costauthority=0))) then
      new$costauthority:= 8;
    END IF;
    if ((new$org_type=:old.org_type) and (c1$<>new$costauthority)) then
      RaiseException('ex_wrongcostauthority');  
    END IF;
  END IF;
  /*    RegionCls  ,  
         */
  if (new$regioncls <> :old.regioncls) then
    update facialacc_cls fac set
    fac.regioncls = new$regioncls
    where
    new$id = fac.org_ref;
      
  END IF;
  if (new$UseCheck_Card is null) then 
    new$UseCheck_Card := 0;
  END IF;
  if (new$RecordOwnerOrgRef is null) then 
    new$RecordOwnerOrgRef := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_10 (TR_ORGANIZATIONS_BU_10)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$FacialAcc <> :old.FacialAcc) then
    select count(id) into CNT$ from Organizations
      where (FacialAcc = new$FacialAcc) and (id <> new$id) AND (ROWNUM = 1);
    if (CNT$ <> 0) then
      RaiseException('ex_DublicateFacialAcc');
    end if;
  end if;

-- - - - - - - - - - - - -
-- BU_100 (TR_ORGANIZATIONS_BU_100)
-- Version 12.20.00.1
-- - - - - - - - - - - - -

  /*   */
  if ((new$DateClose is not null) and (:old.DateClose is null)) then
    /*         -    */
    delete from INN_KPP where id = :old.id;
    /*        */
    update Org_Accounts set
    DateClose = new$DateClose,
    CloseCode = CloseCode + 10
    where Org_Ref = new$Id;

  END IF;
  /*  /      */
  if (((new$DateClose is not null) and (:old.DateClose is null)) or (new$DateClose <> :old.DateClose)) then
    /*     / */
    update FacialAcc_Cls set
    DateClose = new$DateClose,
    CloseCode = CloseCode + 10
    where Org_ref = new$Id;
  END IF;
  /*   */
  if ((new$DateClose is null) and (:old.DateClose is not null)) then
    update Org_Accounts set
    CloseCode = CloseCode - 10
    where Org_Ref = new$Id;

    /*     / */
    update FacialAcc_Cls set
    DateClose = new$DateClose,
    CloseCode = CloseCode - 10
    where Org_ref = new$Id;

  END IF;

-- - - - - - - - - - - - -
-- BU_200 (TR_ORGANIZATIONS_BU_200)
-- Version 13.00.00.1
-- - - - - - - - - - - - -

  if (new$id <> new$GeneralOrg_Ref) then
    SELECT COUNT(o.id ) INTO CNT$1
    from Organizations o where (o.id = new$GeneralOrg_Ref) AND (ROWNUM = 1);
    if (not (CNT$1<> 0)) then
      RaiseException('ex_GeneralOrgNotFound');  
    END IF;
  END IF;
  if (new$GeneralOrg_Ref <> :old.GeneralOrg_Ref) then
    update FacialAcc_CLS set
    GeneralOrg_Ref = new$GeneralOrg_Ref
    where
    Org_Ref = new$id;
  END IF;
  if (new$RecordOwnerOrgRef <> 0) then
    SELECT COUNT(o.id ) INTO CNT$2
    from Organizations o where (o.id = new$RecordOwnerOrgRef) AND (ROWNUM = 1);
    if (not (CNT$2<> 0)) then
      RaiseException('ex_RecOwnerOrgRefNotFound');  
    END IF;
  END IF;

-- - - - - - - - - - - - -
-- BU_210 (TR_ORGANIZATIONS_BU_210)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$DOCSTATEREF <> :old.DOCSTATEREF) then
    insert into StateJumpHistory(DocID, BeginStateRef, EndStateRef)
    values(new$id, :old.DOCSTATEREF, new$DOCSTATEREF);
  END IF;

-- - - - - - - - - - - - -
-- BU_700 (TR_ORGANIZATIONS_BU_700)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  IF (new$RVersion IS NULL) THEN
    new$RVersion := 1;
  ELSIF ( (new$RVersion = -1) AND (:OLD.RVersion <> -1) ) THEN
    new$RVersion := :OLD.RVersion;
  ELSE
    new$RVersion := :OLD.RVersion + 1;
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_ORGANIZATIONS SET
    ID = new$ID,
    NAME = new$NAME,
    GOSNI = new$GOSNI,
    CITY = new$CITY,
    COUNTRY = new$COUNTRY,
    PHONE = new$PHONE,
    ADDRESS = new$ADDRESS,
    ORG_CLS = new$ORG_CLS,
    INN20 = new$INN20,
    SUBINN = new$SUBINN,
    FACIALACC = new$FACIALACC,
    REGIONCLS = new$REGIONCLS,
    DIRNAME = new$DIRNAME,
    BUGNAME = new$BUGNAME,
    DIRPHONE = new$DIRPHONE,
    BUGPHONE = new$BUGPHONE,
    RCORG = new$RCORG,
    CREATERUSER = new$CREATERUSER,
    CREATEDATE = new$CREATEDATE,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    INN = new$INN,
    OKATO = new$OKATO,
    EMAIL = new$EMAIL,
    WEBSITE = new$WEBSITE,
    UFKCODE = new$UFKCODE,
    ADDOKATO = new$ADDOKATO,
    SHORTNAME = new$SHORTNAME,
    RVERSION = new$RVERSION,
    SENDERID = new$SENDERID,
    KVSR = new$KVSR,
    OKFS = new$OKFS,
    OKOPF = new$OKOPF,
    OPENDATE = new$OPENDATE,
    CLOSEDATE = new$CLOSEDATE,
    CHANGEDATE = new$CHANGEDATE,
    GENERALORG_REF = new$GENERALORG_REF,
    FEDERALREGIONCODE = new$FEDERALREGIONCODE,
    ORG_TYPE = new$ORG_TYPE,
    BUDGETREF = new$BUDGETREF,
    SUPPLIERSTATUS = new$SUPPLIERSTATUS,
    COUNTRYCODE = new$COUNTRYCODE,
    DATECLOSE = new$DATECLOSE,
    ORGCODE = new$ORGCODE,
    COSTAUTHORITY = new$COSTAUTHORITY,
    INCOMEAUTHORITY = new$INCOMEAUTHORITY,
    DEBTAUTHORITY = new$DEBTAUTHORITY,
    SVRAUTHORITY = new$SVRAUTHORITY,
    CLIENTID = new$CLIENTID,
    DATEOPEN = new$DATEOPEN,
    FUID = new$FUID,
    OKPO = new$OKPO,
    OKTMO = new$OKTMO,
    DOCSTATEREF = new$DOCSTATEREF,
    CRYPTOSTATUS = new$CRYPTOSTATUS,
    OGRN = new$OGRN,
    REJECT_CLS = new$REJECT_CLS,
    EXTID = new$EXTID,
    EXTOWNER = new$EXTOWNER,
    EXTSYNCDATE = new$EXTSYNCDATE,
    REMOTEPBSCODE = new$REMOTEPBSCODE,
    REMOTENOTPBSCODE = new$REMOTENOTPBSCODE,
    USECHECK_CARD = new$USECHECK_CARD,
    EXTROOTID = new$EXTROOTID,
    EXTVERSION = new$EXTVERSION,
    EXTVERSIONDATE = new$EXTVERSIONDATE,
    RECORDOWNERORGREF = new$RECORDOWNERORGREF,
    REJECTCAUSE = new$REJECTCAUSE,
    BLOCKEDDATE = new$BLOCKEDDATE,
    BLOCKEDCAUSE = new$BLOCKEDCAUSE,
    UNBLOCKEDDATE = new$UNBLOCKEDDATE,
    UNBLOCKEDCAUSE = new$UNBLOCKEDCAUSE,
    ORGREESTRCODE = new$ORGREESTRCODE
  WHERE ID = :OLD.ID and (RVersion = :old.RVersion or RVersion is NULL and :old.RVersion is NULL);

  if SQL%ROWCOUNT <> 1 then
    RaiseException('EX_RECORDCHANGED');
  end if;

-- - - - - - - - - - - - -
-- AU_100 (TR_ORGANIZATIONS_AU_100)
-- Create 27.07.2007
-- - - - - - - - - - - - -

-- Comment   / 


  /*    */
  if ((new$DateClose is not null) and (:old.DateClose is null)) then
    update Banks set DateClose = new$DateClose where (id = new$ID) and (DateClose is null);
  end if;

  /*    */
  if ((new$DateClose is null) and (:old.DateClose is not null)) then
    update Banks set DateClose = null where (id = new$ID) and (DateClose is not null);
  end if;

-- - - - - - - - - - - - -
-- AU_200 (TR_ORGANIZATIONS_AU_200)
-- Version 10.00.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef <> :old.BudgetRef) then
    update FacialAcc_CLS set
    BudgetRef = new$BudgetRef
    where
    (ORG_REF = new$id)and((BudgetRef = :old.BudgetRef)or(BudgetRef<>0));
  END IF;
  /*     ,    */
  if ((new$KVSR <> :old.KVSR)and(new$Org_Type >= 10100)and(new$Org_Type <= 10299)) then
    update KVSR set
    Org_Ref = new$id
    where
    id = new$KVSR;
  END IF;
  if (new$KVSR <> :old.KVSR) then
    update FacialAcc_CLS set
    KVSR = new$KVSR
    where
    (ORG_REF = new$id) and (KVSR = :old.KVSR);
  END IF;
  if (new$BudgetRef <> :old.BudgetRef) then
    update organizations set
    BudgetRef = new$BudgetRef
    where
    (generalorg_ref = new$id) and (id <> new$id);
  END IF;
  if (new$KVSR <> :old.KVSR) then
    update organizations set
    KVSR = new$KVSR
    where
    (generalorg_ref = new$id) and (id <> new$id);
  END IF;

-- - - - - - - - - - - - -
-- AU_500 (TR_ORGANIZATIONS_AU_500)
-- Last update 24.05.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (27, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=27) and (RecordId=new$ID);
  end if;

END;
/
commit work
/
delete from inn_kpp t1
where
  not exists (
    select id from organizations t2
    where
      ((t1.inn = t2.inn) or ((t1.inn is null) and (t2.inn is null))) 
      and
      ((t1.inn20 = t2.inn20) or ((t1.inn20 is null) and (t2.inn20 is null)))
  )
/
commit work
/

-- #########################################################
-- #########################################################
-- Alter_AUTOSANCTIONDATA_Add_MeansType.sql
-- #########################################################
-- #########################################################

/* 
    " "    AUTOSANCTIONDATA

*/
ALTER TABLE autosanctiondata ADD (
  MeansType NUMBER(10),
    CHECK((MeansType<=2147483647)AND(MeansType>-2147483648)),
  constraint AUTOSANCTIONDATA_FK_MeansType foreign key (MEANSTYPE) references MEANSTYPE(ID) 
)
/
CREATE INDEX AUTOSANCTIONDATA_FK_MeansType ON autosanctiondata(MEANSTYPE)
/
commit work 
/


-- #########################################################
-- #########################################################
-- Alter_ContractCostsCls_NSI.sql
-- #########################################################
-- #########################################################

/*          ContractCostsCls */
ALTER TABLE ContractCostsCls ADD (
  Extid VARCHAR2(50),/*        */
  Extrootid VARCHAR2(50)/*   */
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Alter_Purchasetype_NSI.sql
-- #########################################################
-- #########################################################

/*          purchasetype */
ALTER TABLE purchasetype ADD (
  Extid VARCHAR2(50),/*        */
  Extrootid VARCHAR2(50),/*   */
  StartDate DATE,/*   */
  DeleteDate DATE/*   */
)
/
commit work 
/

-- #########################################################
-- #########################################################
-- Add_NewVnebudgetValues.sql
-- #########################################################
-- #########################################################

/* ***************************************
       
****************************************/
CREATE OR REPLACE procedure AddEnum(EnumName$ VARCHAR2)
AS
  CNT$1 NUMBER(10);
BEGIN
  SELECT COUNT(Id ) INTO CNT$1
  from Enums where (name = EnumName$) AND (ROWNUM = 1);
  if ((CNT$1<> 0)) then
    delete from EnumValues ev where ev.enumref in (select e.id from enums e where e.Name = EnumName$);
      
  else
    insert into Enums (Name) values (EnumName$);
  END IF;
END;
/
CREATE OR REPLACE procedure AddEnumValue(EnumName$ VARCHAR2,EnumVal$ NUMBER,ValName$ VARCHAR2)
AS
  EnumID$ NUMBER(10);
  CNT$1 NUMBER(10);
BEGIN
  BEGIN
    select ID into EnumID$ from Enums where Name = EnumName$  ;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN NULL;
  END;
  if (EnumID$  is not null) then
    SELECT COUNT(Id ) INTO CNT$1
    from EnumValues where ((EnumRef = EnumID$)and(Val = EnumVal$) ) AND (ROWNUM = 1);
    if ((CNT$1<> 0)) then
      Update EnumValues ev set
      ev.Name = ValName$

      where (ev.EnumRef = EnumID$)and(ev.Val = EnumVal$);
          
    else
      insert into EnumValues(EnumRef, Val, Name) values (EnumID$, EnumVal$, ValName$);
      
    END IF;
  END IF;
END;
/
CALL AddEnumValue('', 8, '  ') 
/
CALL AddEnumValue('', 9, '  ()  ') 
/
CALL AddEnumValue('', 10, '  ,    ()  ') 
/
CALL AddEnumValue('', 17, ' ') 
/
CALL AddEnumValue('', 18, '  ') 
/
CALL AddEnumValue('', 19, '    ') 
/
CALL AddEnumValue('', 20, ' ') 
/
drop procedure AddEnum
/
drop procedure AddEnumValue
/
commit work
/

-- #########################################################
-- #########################################################
-- Create_proc_SetIdTempKeys.sql
-- #########################################################
-- #########################################################


/*             (1, 2, 3)    */

CREATE or REPLACE PROCEDURE SetIdTempKeys
   (IDsList in VARCHAR2, Delim in VARCHAR2  )
IS  
  second_pos NUMBER := 0;
  first_pos number := 1;
  new_id number;
BEGIN 
  while (second_pos <= LENGTH(IDsList) - 1) loop
    second_pos := INSTR(IDsList, Delim, first_pos);
    if (second_pos = 0) then
      second_pos := LENGTH(IDsList) + 1;       
    end if;
    new_id := TO_NUMBER((SUBSTR(IDsList, first_pos, second_pos - first_pos)));
    INSERT /* + APPEND */ into temp_keys(id) values (new_id);
    first_pos := second_pos + 1;
  end loop;    
END;
/

GRANT EXECUTE ON SetIdTempKeys TO BUDGET_USERS
/

COMMIT WORK
/



-- #########################################################
-- #########################################################
-- alter_BudStruct_add_TargetCls.sql
-- #########################################################
-- #########################################################

/*       (BudStruct)    (TargetCls) */
ALTER TABLE TB_BudStruct ADD (
  TargetCls NUMBER(10),
    CHECK((TargetCls<=2147483647)AND(TargetCls>-2147483648))
)
/

CREATE OR REPLACE VIEW BudStruct (
  ID,
  KFSR,
  KVSR,
  KCSR,
  KVR,
  KESR,
  SUBKESR,
  REGIONCLS,
  FACT,
  FINTYPE,
  MEANSTYPE,
  ACTUALDATE,
  CREATEDATE,
  CREATERUSER,
  UPDATEDATE,
  UPDATERUSER,
  DIRECTIONCLS,
  BUDGETREF,
  TRANSFERTCLS,
  STARTDATE,
  ISLIMITSPEND,
  BUDALLOCATIONCLS,
  PAYPROMISECLS,
  SUBSIDYCLS,
  ASSIGNMENTKIND,
  TARGETCLS)
AS
  SELECT
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS
  FROM TB_BudStruct
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_ID
  INSTEAD OF DELETE
  ON BUDSTRUCT
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BD_0 (TR_BUDSTRUCT_BD_0)
-- - - - - - - - - - - - -

--      BudStrLink
  delete from BudStrLink
  where BudStruct = :old.Id;

-- - - - - - - - - - - - -
-- DELETE
-- - - - - - - - - - - - -
  DELETE FROM TB_BUDSTRUCT
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AD_500 (TR_BUDSTRUCT_AD_500)
-- - - - - - - - - - - - -

  insert into DelRecIndexes(TableID, RecordId, DeleteDate)
    values(141, :old.ID, SYSDATE);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_II
  INSTEAD OF INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  CNT$1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BI_0 (TR_BUDSTRUCT_BI_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$id is null) then
    select g_shared.nextval into new$id from dual;
  END IF;
  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BI_100 (tr_budstruct_bi_100)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1$
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1$<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- BI_500 (TR_BUDSTRUCT_BI_500)
-- Last update 22.02.2004
-- - - - - - - - - - - - -

  new$CreateDate := SYSDATE;
  new$UpdateDate := new$CreateDate;
  new$CreaterUser := USER;
  new$UpdaterUser := USER;

-- - - - - - - - - - - - -
-- INSERT
-- - - - - - - - - - - - -
  INSERT INTO TB_BUDSTRUCT (
    ID,
    KFSR,
    KVSR,
    KCSR,
    KVR,
    KESR,
    SUBKESR,
    REGIONCLS,
    FACT,
    FINTYPE,
    MEANSTYPE,
    ACTUALDATE,
    CREATEDATE,
    CREATERUSER,
    UPDATEDATE,
    UPDATERUSER,
    DIRECTIONCLS,
    BUDGETREF,
    TRANSFERTCLS,
    STARTDATE,
    ISLIMITSPEND,
    BUDALLOCATIONCLS,
    PAYPROMISECLS,
    SUBSIDYCLS,
    ASSIGNMENTKIND,
    TARGETCLS
  ) VALUES (
    new$ID,
    new$KFSR,
    new$KVSR,
    new$KCSR,
    new$KVR,
    new$KESR,
    new$SUBKESR,
    new$REGIONCLS,
    new$FACT,
    new$FINTYPE,
    new$MEANSTYPE,
    new$ACTUALDATE,
    new$CREATEDATE,
    new$CREATERUSER,
    new$UPDATEDATE,
    new$UPDATERUSER,
    new$DIRECTIONCLS,
    new$BUDGETREF,
    new$TRANSFERTCLS,
    new$STARTDATE,
    new$ISLIMITSPEND,
    new$BUDALLOCATIONCLS,
    new$PAYPROMISECLS,
    new$SUBSIDYCLS,
    new$ASSIGNMENTKIND,
    new$TARGETCLS);

END;
/

CREATE OR REPLACE TRIGGER TR_BUDSTRUCT_IU
  INSTEAD OF UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  new$ID BUDSTRUCT.ID%TYPE := :NEW.ID;
  new$KFSR BUDSTRUCT.KFSR%TYPE := :NEW.KFSR;
  new$KVSR BUDSTRUCT.KVSR%TYPE := :NEW.KVSR;
  new$KCSR BUDSTRUCT.KCSR%TYPE := :NEW.KCSR;
  new$KVR BUDSTRUCT.KVR%TYPE := :NEW.KVR;
  new$KESR BUDSTRUCT.KESR%TYPE := :NEW.KESR;
  new$SUBKESR BUDSTRUCT.SUBKESR%TYPE := :NEW.SUBKESR;
  new$REGIONCLS BUDSTRUCT.REGIONCLS%TYPE := :NEW.REGIONCLS;
  new$FACT BUDSTRUCT.FACT%TYPE := :NEW.FACT;
  new$FINTYPE BUDSTRUCT.FINTYPE%TYPE := :NEW.FINTYPE;
  new$MEANSTYPE BUDSTRUCT.MEANSTYPE%TYPE := :NEW.MEANSTYPE;
  new$ACTUALDATE BUDSTRUCT.ACTUALDATE%TYPE := :NEW.ACTUALDATE;
  new$CREATEDATE BUDSTRUCT.CREATEDATE%TYPE := :NEW.CREATEDATE;
  new$CREATERUSER BUDSTRUCT.CREATERUSER%TYPE := :NEW.CREATERUSER;
  new$UPDATEDATE BUDSTRUCT.UPDATEDATE%TYPE := :NEW.UPDATEDATE;
  new$UPDATERUSER BUDSTRUCT.UPDATERUSER%TYPE := :NEW.UPDATERUSER;
  new$DIRECTIONCLS BUDSTRUCT.DIRECTIONCLS%TYPE := :NEW.DIRECTIONCLS;
  new$BUDGETREF BUDSTRUCT.BUDGETREF%TYPE := :NEW.BUDGETREF;
  new$TRANSFERTCLS BUDSTRUCT.TRANSFERTCLS%TYPE := :NEW.TRANSFERTCLS;
  new$STARTDATE BUDSTRUCT.STARTDATE%TYPE := :NEW.STARTDATE;
  new$ISLIMITSPEND BUDSTRUCT.ISLIMITSPEND%TYPE := :NEW.ISLIMITSPEND;
  new$BUDALLOCATIONCLS BUDSTRUCT.BUDALLOCATIONCLS%TYPE := :NEW.BUDALLOCATIONCLS;
  new$PAYPROMISECLS BUDSTRUCT.PAYPROMISECLS%TYPE := :NEW.PAYPROMISECLS;
  new$SUBSIDYCLS BUDSTRUCT.SUBSIDYCLS%TYPE := :NEW.SUBSIDYCLS;
  new$ASSIGNMENTKIND BUDSTRUCT.ASSIGNMENTKIND%TYPE := :NEW.ASSIGNMENTKIND;
  new$TARGETCLS BUDSTRUCT.TARGETCLS%TYPE := :NEW.TARGETCLS;
--
  CNT$1$ NUMBER(10);
BEGIN
-- - - - - - - - - - - - -
-- BU_0 (TR_BUDSTRUCT_BU_0)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  if (new$BudgetRef is null) then
    new$BudgetRef := 0;
  END IF;
  if (new$KVSR is null) then
    new$KVSR := 0;
  END IF;
  if (new$KCSR is null) then
    new$KCSR := 0;
  END IF;
  if (new$KFSR is null) then
    new$KFSR := 0;
  END IF;
  if (new$KVR is null) then
    new$KVR := 0;
  END IF;
  if (new$KESR is null) then
    new$KESR := 0;
  END IF;
  if (new$SubKESR is null) then
    new$SubKESR := 0;
  END IF;
  if (new$RegionCls is null) then
    new$RegionCls := 0;
  END IF;
  if (new$DirectionCls is null) then
    new$DirectionCls := 0;
  END IF;
  if (new$Fact is null) then
    new$Fact := 0;
  END IF;
  if (new$FinType is null) then
    new$FinType := 0;
  END IF;
  if (new$MeansType is null) then
    new$MeansType := 0;
  END IF;
  if (new$AssignMentKind is null) then
    new$AssignMentKind := 0;
  END IF;
  if (new$IsLimitSpend is null) then
    new$IsLimitSpend := 0;
  END IF;

-- - - - - - - - - - - - -
-- BU_100 (tr_budstruct_bu_100)
-- Version 11.30.00.1
-- - - - - - - - - - - - -

  SELECT COUNT(id ) INTO CNT$1$
  from BudStruct
  where
  (        (BUDGETREF = new$BUDGETREF) and
  (KFSR = new$KFSR) and
  (KVSR = new$KVSR) and
  (KCSR = new$KCSR) and
  (KVR = new$KVR) and
  (KESR = new$KESR) and
  (SUBKESR = new$SUBKESR) and
  (REGIONCLS = new$REGIONCLS) and
  (FACT = new$FACT) and
  (FINTYPE = new$FINTYPE) and
  (MEANSTYPE = new$MEANSTYPE) and
  (DIRECTIONCLS = new$DIRECTIONCLS) and
  ((TRANSFERTCLS = new$TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new$TRANSFERTCLS is null))) and
  ((BUDALLOCATIONCLS = new$BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new$BUDALLOCATIONCLS is null))) and
  ((PAYPROMISECLS = new$PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new$PAYPROMISECLS is null))) and
  ((SUBSIDYCLS = new$SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new$SUBSIDYCLS is null))) and
  (ASSIGNMENTKIND = new$ASSIGNMENTKIND) and
  (id <> :old.id)
  ) AND (ROWNUM = 1)      ;
  if ((CNT$1$<> 0))
  then
    RaiseException('EX_BUDSTRUCT_UNIQUE');
  END IF;

-- - - - - - - - - - - - -
-- UPDATE
-- - - - - - - - - - - - -
  UPDATE TB_BUDSTRUCT SET
    ID = new$ID,
    KFSR = new$KFSR,
    KVSR = new$KVSR,
    KCSR = new$KCSR,
    KVR = new$KVR,
    KESR = new$KESR,
    SUBKESR = new$SUBKESR,
    REGIONCLS = new$REGIONCLS,
    FACT = new$FACT,
    FINTYPE = new$FINTYPE,
    MEANSTYPE = new$MEANSTYPE,
    ACTUALDATE = new$ACTUALDATE,
    CREATEDATE = new$CREATEDATE,
    CREATERUSER = new$CREATERUSER,
    UPDATEDATE = new$UPDATEDATE,
    UPDATERUSER = new$UPDATERUSER,
    DIRECTIONCLS = new$DIRECTIONCLS,
    BUDGETREF = new$BUDGETREF,
    TRANSFERTCLS = new$TRANSFERTCLS,
    STARTDATE = new$STARTDATE,
    ISLIMITSPEND = new$ISLIMITSPEND,
    BUDALLOCATIONCLS = new$BUDALLOCATIONCLS,
    PAYPROMISECLS = new$PAYPROMISECLS,
    SUBSIDYCLS = new$SUBSIDYCLS,
    ASSIGNMENTKIND = new$ASSIGNMENTKIND,
    TARGETCLS = new$TARGETCLS
  WHERE Id = :old.Id;

-- - - - - - - - - - - - -
-- AU_500 (TR_BUDSTRUCT_AU_500)
-- Create 28.04.2005
-- - - - - - - - - - - - -

  if (new$ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (141, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=141) and (RecordId=new$ID);
  end if;

END;
/
commit work 
/
ALTER TABLE TB_BUDSTRUCT ADD (
  CONSTRAINT FK_BUDSTRUCT_TargetCls
  FOREIGN KEY (TargetCls) REFERENCES TargetCls(ID)
)
/
CREATE INDEX FK_BUDSTRUCT_TargetCls ON TB_BUDSTRUCT(TargetCls)
/
commit work 
/

-- #########################################################
-- #########################################################
-- update_permissions_RenameCls_13.00.sql
-- #########################################################
-- #########################################################

/*     */
ALTER TRIGGER TR_PERMISSIONS_BU_500 DISABLE
/
commit work
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('    ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('     ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('   ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('    ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ' , '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ', '
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' - ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('- ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = '   ()'
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('   ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = '   '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('   ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('     ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('    ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = ''
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('   ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('  ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper('   ')
/
update Permissions set
  Name = ' '
where
  Upper(Name) = Upper('    ')
/
update Permissions set
  Name = '   '
where
  Upper(Name) = Upper('')
/
update Permissions set
  Name = '    '
where
  Upper(Name) = Upper(' ')
/
update Permissions set
  Name = '  '
where
  Upper(Name) = Upper(' ')
/
delete from Permissions 
where
  (Upper(Name) = Upper('')) or
  (Upper(Name) = Upper(' ')) or
  (Upper(Name) = Upper('  ')) or
  (Upper(Name) = Upper('   ')) or
  (Upper(Name) = Upper('  ')) or
  (Upper(Name) = Upper('   '))
/
commit work
/
ALTER TRIGGER TR_PERMISSIONS_BU_500 ENABLE
/
commit work
/

-- #########################################################
-- #########################################################
-- UpdDocFields_13.00.00_Ora.sql
-- #########################################################
-- #########################################################


--  : 121000 - 130000.     02.07.2018 15:10:46.
CREATE OR REPLACE PROCEDURE ImportDocType (
   ID_               NUMBER,
   PROGINDEX_        NUMBER,
   NAME_             VARCHAR2,
   USESTATE_         NUMBER,
   DBTABLE_          VARCHAR2,
   NEEDEDS_          NUMBER,
   LOCKMASK_         NUMBER,
   DEFAULTACTIONMACROSNAME_ VARCHAR2,
   DOCUMENTKIND_     NUMBER,
   SHORTNAME_         VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentTypes
    WHERE (ID = ID_);

  IF (IDExists$ = 0) THEN
     INSERT INTO DocumentTypes
                 (ID, PROGINDEX, NAME, USESTATE, DBTABLE, NEEDEDS, LOCKMASK, DEFAULTACTIONMACROSNAME, DOCUMENTKIND, SHORTNAME)
          VALUES (ID_, PROGINDEX_, NAME_, USESTATE_, DBTABLE_, NEEDEDS_, LOCKMASK_, DEFAULTACTIONMACROSNAME_, DOCUMENTKIND_, SHORTNAME_);
  else
      Update documenttypes set
        Name=Name_,
		    DBTABLE=DBTABLE_,
        LockMask=LockMask_,
        DEFAULTACTIONMACROSNAME=DEFAULTACTIONMACROSNAME_,
        DOCUMENTKIND=DOCUMENTKIND_,
        SHORTNAME=SHORTNAME_,
	      PROGINDEX=PROGINDEX_
      where (id=ID_)
        and (
          (Name<>Name_) or
          ((LockMask is null) and (LockMask_ is not null)) or
          ((LockMask is not null) and (LockMask_ is null)) or
          ((LockMask is not null) and (LockMask_ is not null) and (LockMask <> LockMask_)) or
          (DEFAULTACTIONMACROSNAME is null) or
          (DOCUMENTKIND<>DOCUMENTKIND_) or 
          (SHORTNAME is null) or 
          (SHORTNAME<>SHORTNAME_) or
          (PROGINDEX <> PROGINDEX_) or 
          ((DBTABLE is null) and (DBTABLE_ is not null)) or
          ((DBTABLE is not null) and (DBTABLE_ is null)) or
          ((DBTABLE is not null) and (DBTABLE_ is not null) and (DBTABLE <> DBTABLE_))
        );
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE UPDATEINTERFACES (
  CLS_   NUMBER,
  NOTE_  VARCHAR2,
  GUID_  VARCHAR2,
  PARAM_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT (ID)
   INTO IDEXISTS$
   FROM INTERFACES
  WHERE (GUID=GUID_);
  
  IF (IDExists$ = 0)  THEN
    INSERT INTO INTERFACES
      (CLS,NOTE,GUID,PARAM)
    VALUES
      (CLS_,NOTE_,GUID_,PARAM_);
  ELSE
    IF ((PARAM_ ='')OR(PARAM_ IS NULL)) THEN 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    ELSE 
      UPDATE INTERFACES SET
        CLS = CLS_
      WHERE (GUID=GUID_) AND (PARAM=PARAM_) AND ((CLS<> CLS_)OR(CLS IS NULL));
    END IF;
  END IF;
END;
/

--   
CALL ImportDocType(0, 0, ' ', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(101, 223, '   ', 0, ' ', 0,-1,'',10200,'') ;

CALL ImportDocType(200, 0, '  ()', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(201, 32, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(202, 260, ' ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(203, 261, '  ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(204, 262, ' , ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(205, 263, '', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL ImportDocType(206, 268, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'__') ;

CALL ImportDocType(207, 272, '  ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(208, 273, '   ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'__') ;

CALL ImportDocType(209, 274, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(209, ' ', '{DA309359-EF6B-4D29-AC0D-309040B5CDB6}', '') ;

CALL ImportDocType(210, 252, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(210, ' ', '{2EF0F811-E21F-4ADB-BC7E-A3A9B16059A4}', '') ;

CALL ImportDocType(211, 275, ' ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(211, ' ', '{AE8281A0-BE7F-4F3A-90BD-A7831E8D842F}', '') ;

CALL ImportDocType(212, 276, '  , ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL UpdateInterfaces(212, '  , ', '{B743C24B-6E28-4C9C-B3CA-16AC6E529D07}', '') ;

CALL ImportDocType(213, 277, '     ', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(213, '     ', '{88C29844-D7AE-41B0-A693-9785E7B791B0}', '') ;

CALL ImportDocType(214, 278, '  14 /', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'__') ;

CALL UpdateInterfaces(214, '  14 /', '{EA75FD26-4DD0-484A-A6B3-98BB52A919B9}', '') ;

CALL ImportDocType(215, 279, '  14 /', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'__') ;

CALL UpdateInterfaces(215, '  14 /', '{96F991A7-0B8F-4E69-A9B3-072C65444503}', '') ;

CALL ImportDocType(300, 0, '  ', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(301, 66, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(302, 63, '  \', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(303, 65, ' ()', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(304, 64, '  ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(305, 61, '  \', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(306, 62, '  ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(307, 0, ' ', 0, 'FacialFinReestr', 0,-1,'_',10100,'') ;

CALL ImportDocType(308, 67, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(308, ' ', '{B50F2C63-9CF4-42C3-8062-E355EABD53E4}', '') ;

CALL ImportDocType(311, 68, '   ', 0, 'FacialFinCaption', 0,-1,'_',10100,'_') ;

CALL ImportDocType(312, 69, '    ', 0, 'FacialFinCaption', 0,-1,'_',10100,'_') ;

CALL ImportDocType(314, 70, '   ', 0, 'FacialFinCaption', 0,-1,'_',10100,'_') ;

CALL ImportDocType(315, 71, '     ', 0, 'FacialFinCaption', 0,-1,'_',10200,'_') ;

CALL ImportDocType(316, 521, ' ', 0, 'ManagerBid', 0,0,'',10100,'') ;

CALL ImportDocType(322, 73, '  ', 0, 'FacialFinCaption', 0,-1,'_',10200,'') ;

CALL ImportDocType(323, 75, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(324, 76, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') ;

CALL ImportDocType(801, 57, ' ', 0, 'LimitNotifyCaption[RVERSION=RVERSION-1]', 0,34,'_',10100,'_') ;

CALL ImportDocType(900, 0, '', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(901, 0, '   ', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(902, 0, '  ()', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(903, 45, '  ', 0, ' ', 0,-1,'',10100,'_') ;

CALL ImportDocType(905, 0, '  ', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(906, 41, '  ()', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(907, 0, '  ()', 0, ' ', 0,-1,'',10200,'_') ;

CALL ImportDocType(1807, 0, '  ', 0, '', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1807, '  ', '{DCD3A201-01A8-11D5-9238-4854E826BF13}', '') ;

CALL ImportDocType(1815, 0, '    ', 0, '', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1815, '    ', '{D92C5F6D-D02D-4589-B0A8-0E5A05AFEFBF}', '') ;

CALL ImportDocType(1816, 0, '  ', 0, '', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1816, '  ', '{584B1826-AD94-47DC-A420-B5E42F2CA7D7}', '') ;

CALL ImportDocType(1818, 0, '    ', 0, 'OOS_CONTRACT', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1818, '    ', '{BA8DC899-AE20-4BDB-9B15-278A56CB01C5}', '') ;

CALL ImportDocType(1819, 0, '  -  ', 0, 'OOS_CONTRACT', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1819, '  -  ', '{95E88D33-7335-4272-AFB7-FEB8EB4FDE32}', '') ;

CALL ImportDocType(1820, 0, '     ', 0, 'OOS_CONTRACT', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(1820, '     ', '{DD1E0269-F97E-45A0-BF08-AB5696B158E5}', '') ;

CALL ImportDocType(1900, 0, '  ()', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(1901, 264, ' ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1902, 215, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1903, 265, '  ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'_') ;

CALL ImportDocType(1906, 271, '   ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'',10100,'__') ;

CALL ImportDocType(2200, 0, '  ()', 0, '', 0,0,'',30000,'') ;

CALL ImportDocType(2201, 46, '  ()', 0, 'BudNotify[RVERSION=RVERSION-1]', 0,-1,'_',10100,'_') ;

CALL ImportDocType(2502, 304, '', 0, 'Agreements', 0,-65537,'',10100,'') ;

CALL ImportDocType(2503, 308, '  ', 0, 'ExecutionDocumentsCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(2504, 314, ' ', 0, 'Agreements', 0,-65537,'',10100,'') ;

CALL ImportDocType(3006, 241, ' -', 0, 'TenderCaption', 0,-65537,'',10100,'') ;

CALL ImportDocType(3011, 243, '  ', 0, 'TenderCaption', 0,-1,'',10100,'') ;

CALL ImportDocType(4401, 251, ' ', 0, 'UnionNotifyCaption', 0,-1,'_',10100,'') ;

CALL UpdateInterfaces(4401, ' ', '{AB6937F7-A672-461D-A94C-808F4DCA4D71}', '') ;

CALL ImportDocType(5101, 0, '  ', 0, 'StoredAttributesCaption', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(5101, '  ', '{12614FA4-D546-4C45-8946-43813CED6EBF}', '') ;

CALL ImportDocType(5201, 556, ' / ', 0, 'WritExecutionCaption', 0,-1,'',10100,'') ;

CALL UpdateInterfaces(5201, ' / ', '{623EE404-09D9-4069-9115-27974DB69AD1}', '') ;

CALL ImportDocType(5401, 0, '  ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(5401, '  ', '{664FA50A-3858-47D0-BBB4-CEF206EFCA63}', '') ;

CALL ImportDocType(5402, 0, '   ', 0, 'EPBSExportLogCaption', 0,-1,'',10200,'') ;

CALL UpdateInterfaces(5402, '   ', '{FFEDC65A-7FF7-45F0-81B6-84896D6B3D15}', '') ;

CALL ImportDocType(5501, 312, '   ', 0, 'CorrectionCaption', 0,-1,'',10100,'_') ;

CALL ImportDocType(5502, 313, '   ', 0, 'CorrectionCaption', 0,-1,'',10100,'_') ;

CALL ImportDocType(9601, 0, '', 0, 'ORGANIZATIONS', 0,0,'',20100,'') ;

CALL ImportDocType(9802, 0, '', 0, 'kfsr', 0,0,'',20200,'') ;

CALL ImportDocType(9803, 0, ' ', 0, 'KVSR', 0,0,'',20100,'') ;

CALL ImportDocType(9804, 0, '', 0, 'KVR', 0,0,'',20100,'') ;

CALL ImportDocType(9805, 0, '', 0, 'KCSR', 0,0,'',20100,'') ;

CALL ImportDocType(9808, 0, '', 0, 'KESRSubCode', 0,0,'',20100,'') ;

CALL ImportDocType(9849, 0, ' ', 0, 'MEANSTYPE', 0,0,'',20200,'') ;

CALL ImportDocType(9868, 0, '    ', 0, 'KESR', 0,0,'',20100,'') ;

CALL ImportDocType(9871, 0, ' ', 0, 'BuhOperationCls', 0,0,'',20200,'') ;

CALL ImportDocType(9879, 0, ' ', 0, 'TargetCls', 0,0,'',20100,'') ;

CALL ImportDocType(9890, 0, ' ', 0, 'BudAllocationCls', 0,0,'',20100,'') ;

CALL ImportDocType(9897, 0, '', 0, 'ContractCostsCls', 0,0,'',20100,'') ;

CALL ImportDocType(9898, 0, ' ', 0, 'PURCHASETYPE ', 0,0,'',20100,'') ;

CALL ImportDocType(9903, 0, ' ', 0, 'ORGANIZATIONS', 0,-1,'',10100,'_') ;

CALL ImportDocType(9913, 0, '', 0, '', 0,0,'',10200,'') ;

CALL ImportDocType(9919, 0, ' ', 0, '', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9919, ' ', '{88FA05A2-02A0-11D2-B26C-008048E689F8}', '') ;

CALL ImportDocType(9926, 0, '   ', 0, 'WritNotifyCls ', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9926, '   ', '{89CAEE9C-9516-4EE2-8A4B-CB0BFA9165AB}', '') ;

CALL ImportDocType(9928, 0, '   ', 0, 'ClsCorrespondents', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9928, '   ', '{C1FAE5FE-7817-4D46-858B-ACFA478BA485}', '') ;

CALL ImportDocType(9931, 0, '   ', 0, 'ClsCorrespondents', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9931, '   ', '{DCD828A5-5C9F-4446-ACA2-85F6B3BE0FD6}', '') ;

CALL ImportDocType(9932, 0, '  /  ', 0, 'BudStrLink', 0,0,'',10200,'') ;

CALL UpdateInterfaces(9932, '  /  ', '{9B39F873-9C5A-4856-A0B5-FDCFE2E8115A}', '') ;

DROP PROCEDURE ImportDocType
/

DROP PROCEDURE UPDATEINTERFACES
/



CREATE OR REPLACE PROCEDURE SELECTIONS_IMPORT(
  ID_ NUMBER,
  KIND_ NUMBER,
  NAME_ VARCHAR2,
  NOTE_ VARCHAR2,
  READONLY_ NUMBER,
  USEINDOC_ NUMBER,
  TABLENAME_ VARCHAR2,
  ALIAS_ VARCHAR2,
  TABLECODE_ NUMBER,
  NEEDGROUPONDB_ NUMBER,
  NEEDDISTINCT_ NUMBER,
  MASTER_ NUMBER,
  DISCRIMVALUE_ VARCHAR2,
  AVAILABLEINDEREF_ NUMBER,
  CACHETYPE_ NUMBER,
  FULLORMODINSREFRTIME_ NUMBER,
  DELETEREFRTIME_ NUMBER,
  FINDTIMEREFRESH_ NUMBER,
  ANNOTATION_ VARCHAR2,
  DEREFNAME_ VARCHAR2,
  GroupID_ NUMBER,
  IsLogged_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONS SET
      KIND = KIND_,
      NAME = NAME_,
      NOTE = NOTE_,
      READONLY = READONLY_,
      USEINDOC = USEINDOC_,
      TABLENAME = TABLENAME_,
      ALIAS = ALIAS_,
      TABLECODE = TABLECODE_,    
      NEEDGROUPONDB = NEEDGROUPONDB_,
      NEEDDISTINCT = NEEDDISTINCT_,
      MASTER = MASTER_,
      DISCRIMVALUE = DISCRIMVALUE_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,         
      CACHETYPE = CACHETYPE_,   
      FULLORMODINSREFRTIME = FULLORMODINSREFRTIME_,   
      DELETEREFRTIME = DELETEREFRTIME_,   
      FINDTIMEREFRESH = FINDTIMEREFRESH_,   
      ANNOTATION = ANNOTATION_,   
      DEREFNAME = DEREFNAME_,     
      GroupID = GroupID_, 
      IsLogged = IsLogged_  
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONS
      (ID, KIND, NAME, NOTE, READONLY, USEINDOC, TABLENAME, ALIAS, TABLECODE, NEEDGROUPONDB, NEEDDISTINCT, MASTER, DISCRIMVALUE,
      AVAILABLEINDEREF, CACHETYPE, FULLORMODINSREFRTIME, DELETEREFRTIME, FINDTIMEREFRESH, ANNOTATION, DEREFNAME, GroupID, IsLogged)
    VALUES
      (ID_, KIND_, NAME_, NOTE_, READONLY_, USEINDOC_, TABLENAME_, ALIAS_, TABLECODE_, NEEDGROUPONDB_, NEEDDISTINCT_, MASTER_, DISCRIMVALUE_,
      AVAILABLEINDEREF_, CACHETYPE_, FULLORMODINSREFRTIME_, DELETEREFRTIME_, FINDTIMEREFRESH_, ANNOTATION_, DEREFNAME_, GroupID_, IsLogged_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  ALIAS_ VARCHAR2,
  JOINORDER_ NUMBER,
  JOINTYPE_ NUMBER,
  RELATIONTYPE_ NUMBER,
  JOINCONDITION_ VARCHAR2,
  DONTUSETABLELIMITS_ NUMBER,
  LIMITNAMESLIST_ VARCHAR2,
  QueryGroup_ NUMBER  
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONSDETAIL
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONSDETAIL SET
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      ALIAS = ALIAS_,
      JOINORDER = JOINORDER_,
      JOINTYPE = JOINTYPE_,
      RELATIONTYPE = RELATIONTYPE_,
      JOINCONDITION = JOINCONDITION_,
      DONTUSETABLELIMITS = DONTUSETABLELIMITS_,
      LIMITNAMESLIST = LIMITNAMESLIST_,
      QueryGroup = QueryGroup_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONSDETAIL
      (ID, SELECTIONREF, TABLEREF, ALIAS, JOINORDER, JOINTYPE, RELATIONTYPE, JOINCONDITION, DONTUSETABLELIMITS, LIMITNAMESLIST, QueryGroup)
    VALUES
      (ID_, SELECTIONREF_, TABLEREF_, ALIAS_, JOINORDER_, JOINTYPE_, RELATIONTYPE_, JOINCONDITION_, DONTUSETABLELIMITS_, LIMITNAMESLIST_, QueryGroup_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_IMPORT(
  ID_ NUMBER,
  FIELDKIND_ NUMBER,
  DESCRIPTIONLEVEL_ NUMBER,
  ANCESTORREF_ NUMBER,
  SELECTIONREF_ NUMBER,
  TABLEREF_ NUMBER,
  FIELDNAME_ VARCHAR2,
  DATATYPE_ NUMBER,
  SUBDATATYPE_ NUMBER,
  FIELDSIZE_ NUMBER,
  DISPLAYLABEL_ VARCHAR2,
  NOTE_ VARCHAR2,
  DEFAULTWIDTH_ NUMBER,
  EDITMASK_ VARCHAR2,
  DISPLAYFORMAT_ VARCHAR2,
  EDITFORMAT_ VARCHAR2,
  CANTEDIT_ NUMBER,
  NOVISUALIZE_ NUMBER,
  ENUMSREF_ NUMBER,
  REQUIRED_ NUMBER,
  FOREIGNKEY_ NUMBER,
  ONDELACTION_ NUMBER,
  PRIMARYKEY_ NUMBER,
  ISRVERSION_ NUMBER,
  LIMITPARAMNAMES_ VARCHAR2,
  FOLLOWORDER_ NUMBER,
  SORTDIRECTION_ NUMBER,
  SORTORDER_ NUMBER,
  AGRFUNCTION_ NUMBER,
  FLAGFIELDNAME_ NUMBER,
  FLAGDISPLAYLABEL_ NUMBER,
  FLAGNOTE_ NUMBER,
  FLAGDEFAULTWIDTH_ NUMBER,
  FLAGCANTEDIT_ NUMBER,
  FLAGNOVISUALIZE_ NUMBER,
  FLAGREQUIRED_ NUMBER,
  FLAGLIMITPARAMNAMES_ NUMBER,
  FLAGAGRFUNCTION_ NUMBER,
  ISTIMESTAMPFIELD_ NUMBER,
  ISBUDGET_ NUMBER,
  AVAILABLEINDEREF_ NUMBER,
  ANNOTATION_ VARCHAR2,
  ALIAS_ VARCHAR2,
  DEREFNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM FIELDSINFO
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE FIELDSINFO SET
      FIELDKIND = FIELDKIND_,
      DESCRIPTIONLEVEL = DESCRIPTIONLEVEL_,
      ANCESTORREF = ANCESTORREF_,
      SELECTIONREF = SELECTIONREF_,
      TABLEREF = TABLEREF_,
      FIELDNAME = FIELDNAME_,
      DATATYPE = DATATYPE_,
      SUBDATATYPE = SUBDATATYPE_,
      FIELDSIZE = FIELDSIZE_,
      DISPLAYLABEL = DISPLAYLABEL_,
      NOTE = NOTE_,
      DEFAULTWIDTH = DEFAULTWIDTH_,
      EDITMASK = EDITMASK_,
      DISPLAYFORMAT = DISPLAYFORMAT_,
      EDITFORMAT = EDITFORMAT_,
      CANTEDIT = CANTEDIT_,
      NOVISUALIZE = NOVISUALIZE_,
      ENUMSREF = ENUMSREF_,
      REQUIRED = REQUIRED_,
      FOREIGNKEY = FOREIGNKEY_,
      ONDELACTION = ONDELACTION_,
      PRIMARYKEY = PRIMARYKEY_,
      ISRVERSION = ISRVERSION_,
      LIMITPARAMNAMES = LIMITPARAMNAMES_,
      FOLLOWORDER = FOLLOWORDER_,
      SORTDIRECTION = SORTDIRECTION_,
      SORTORDER = SORTORDER_,
      AGRFUNCTION = AGRFUNCTION_,
      FLAGFIELDNAME = FLAGFIELDNAME_,
      FLAGDISPLAYLABEL = FLAGDISPLAYLABEL_,
      FLAGNOTE = FLAGNOTE_,
      FLAGDEFAULTWIDTH = FLAGDEFAULTWIDTH_,
      FLAGCANTEDIT = FLAGCANTEDIT_,
      FLAGNOVISUALIZE = FLAGNOVISUALIZE_,
      FLAGREQUIRED = FLAGREQUIRED_,
      FLAGLIMITPARAMNAMES = FLAGLIMITPARAMNAMES_,
      FLAGAGRFUNCTION = FLAGAGRFUNCTION_,
      ISTIMESTAMPFIELD = ISTIMESTAMPFIELD_,
      ISBUDGET = ISBUDGET_,
      AVAILABLEINDEREF = AVAILABLEINDEREF_,
      ANNOTATION = ANNOTATION_,
      ALIAS = ALIAS_,
      DEREFNAME = DEREFNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO FIELDSINFO
      (ID, FIELDKIND, DESCRIPTIONLEVEL, ANCESTORREF, SELECTIONREF, TABLEREF, FIELDNAME, DATATYPE, SUBDATATYPE,
       FIELDSIZE, DISPLAYLABEL, NOTE, DEFAULTWIDTH, EDITMASK, DISPLAYFORMAT, EDITFORMAT, CANTEDIT, NOVISUALIZE,
       ENUMSREF, REQUIRED, FOREIGNKEY, ONDELACTION, PRIMARYKEY, ISRVERSION, LIMITPARAMNAMES,
       FOLLOWORDER, SORTDIRECTION, SORTORDER, AGRFUNCTION, FLAGFIELDNAME, FLAGDISPLAYLABEL, FLAGNOTE,
       FLAGDEFAULTWIDTH, FLAGCANTEDIT, FLAGNOVISUALIZE, FLAGREQUIRED, FLAGLIMITPARAMNAMES, FLAGAGRFUNCTION,
       ISTIMESTAMPFIELD, ISBUDGET, AVAILABLEINDEREF, ANNOTATION, ALIAS, DEREFNAME)
    VALUES
      (ID_, FIELDKIND_, DESCRIPTIONLEVEL_, ANCESTORREF_, SELECTIONREF_, TABLEREF_, FIELDNAME_, DATATYPE_, SUBDATATYPE_,
       FIELDSIZE_, DISPLAYLABEL_, NOTE_, DEFAULTWIDTH_, EDITMASK_, DISPLAYFORMAT_, EDITFORMAT_, CANTEDIT_, NOVISUALIZE_,
       ENUMSREF_, REQUIRED_, FOREIGNKEY_, ONDELACTION_, PRIMARYKEY_, ISRVERSION_, LIMITPARAMNAMES_,
       FOLLOWORDER_, SORTDIRECTION_, SORTORDER_, AGRFUNCTION_, FLAGFIELDNAME_, FLAGDISPLAYLABEL_, FLAGNOTE_,
       FLAGDEFAULTWIDTH_, FLAGCANTEDIT_, FLAGNOVISUALIZE_, FLAGREQUIRED_, FLAGLIMITPARAMNAMES_, FLAGAGRFUNCTION_,
       ISTIMESTAMPFIELD_, ISBUDGET_, AVAILABLEINDEREF_, ANNOTATION_, ALIAS_, DEREFNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_IMPORT(
  ID_ NUMBER,
  SELECTIONREF_ NUMBER,
  EVENTCODE_ NUMBER,
  SCRIPTNAME_ VARCHAR2
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM SELECTIONEVENTS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE SELECTIONEVENTS SET
      SELECTIONREF = SELECTIONREF_,
      EVENTCODE = EVENTCODE_,
      SCRIPTNAME = SCRIPTNAME_
    WHERE ID = ID_;
  ELSE
    INSERT INTO SELECTIONEVENTS
      (ID, SELECTIONREF, EVENTCODE, SCRIPTNAME)
    VALUES
      (ID_, SELECTIONREF_, EVENTCODE_, SCRIPTNAME_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FIELDSINFO_DELETE(
  ID_ NUMBER
) IS
BEGIN
  UPDATE DOCUMENTFIELDS SET
    FIELDINFOREF = NULL
  WHERE FIELDINFOREF = ID_;
  DELETE FROM FIELDSINFO FI
  WHERE FI.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONSDETAIL_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONSDETAIL SLD
  WHERE SLD.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE SELECTIONEVENTS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM SELECTIONEVENTS SE
  WHERE SE.ID = ID_;
END;
/

-- 
CALL FIELDSINFO_DELETE(16873) ;

CALL FIELDSINFO_DELETE(16874) ;

CALL FIELDSINFO_DELETE(16875) ;

CALL SELECTIONS_IMPORT(40457, 1, 'CONTRACTCOSTSCLS', '', 0, 0, 'CONTRACTCOSTSCLS', 'CCC', 0, 0, 0, 2, '', 1, 0, 1800, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(40480, 1, 'PURCHASETYPE', ' ', 0, 0, 'PURCHASETYPE', 'PURCHASETYPE', 0, 0, 0, 2, '', 1, 0, 1800, null, 5, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(40596, 1, 'DOCBASETYPE', ' ', 0, 0, 'DOCBASETYPE', 'DocBaseType', 247, 0, 0, 1, '', 1, 0, 3, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(43265, 1, 'ORGATTRS', '', 0, 0, 'ORGATTRS', 'ORGATTRS', 1425, 0, 0, 2, '', 1, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(43723, 1, 'SUPPLIERS', '  ', 0, 0, 'SUPPLIERS', 'sup', 118, 0, 0, 2, '', 0, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(44230, 1, 'EPBSEXPORTLOGCAPTION', '    ', 0, 0, 'EPBSEXPORTLOGCAPTION', 'EPBSExportLogCaption', 0, 0, 0, 1, '', 0, 0, -1, null, null, '', '', null, 0) ;

CALL SELECTIONS_IMPORT(44232, 1, 'EPBSEXPORTLOGDETAIL', '    ', 0, 0, 'EPBSEXPORTLOGDETAIL', 'EPBSExportLogDetail', 0, 0, 0, 1, '', 0, 0, -1, null, null, '', '', null, 0) ;

-- KD
CALL FIELDSINFO_IMPORT(16836, 0, 1, null, 16824, null, 'KDVALUE', 1, 0, 20, ' ', '  ', 31, '999.9.99.99.999.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KESR
CALL FIELDSINFO_IMPORT(16872, 0, 1, null, 16871, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16877, 0, 1, null, 16871, null, 'CONTROLCODE', 1, 0, 20, ' ', '', 11, '9.9.99.9.9', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43607, 0, 1, null, 16871, null, 'CODE', 1, 0, 20, '', '', 6, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43608, 0, 1, null, 16871, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- KESRSUBCODE
CALL FIELDSINFO_IMPORT(16916, 0, 1, null, 16915, null, 'ID', 3, 0, 0, '', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43610, 0, 1, null, 16915, null, 'CODE', 1, 0, 20, '', '', 6, '>aaa.aa.aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43611, 0, 1, null, 16915, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- DOCBASE
CALL FIELDSINFO_IMPORT(16978, 0, 1, null, 16973, null, 'NAME', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16979, 0, 1, null, 16973, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16980, 0, 1, null, 16973, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16981, 0, 1, null, 16973, null, 'DOCUMENTBASEDATE', 6, 0, 0, ' ', ' ', 11, '99/99/9999', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(16982, 0, 1, null, 16973, null, 'DOCUMENTBASENUM', 1, 0, 100, ' ', ' ', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(36865, 0, 1, null, 16973, null, 'CODE', 1, 0, 20, '', '', 20, '>aa.aa.aaa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(36866, 0, 1, null, 16973, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(36867, 0, 1, null, 16973, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(36868, 0, 1, null, 16973, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40622, 0, 1, null, 16973, null, 'DOCBASETYPEREF', 3, 0, 0, '   ', '   ', 11, '', '', '', 0, 0, null, 1, 40596, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40613, 0, 1, null, 16973, null, 'KVSR', 3, 0, 0, '', '', 11, '', '', '', 0, 0, null, 1, 16851, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40614, 0, 1, null, 16973, null, 'EXTID', 1, 0, 50, '', '', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40615, 0, 1, null, 16973, null, 'EXTOWNER', 1, 0, 50, '  ', '  ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40616, 0, 1, null, 16973, null, 'EXTSYNCDATE', 11, 0, 0, ',  ,  ', ',  ,  ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40617, 0, 1, null, 16973, null, 'EXTROOTID', 1, 0, 50, ' ', ' ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40618, 0, 1, null, 16973, null, 'EXTVERSION', 3, 0, 0, '   ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40619, 0, 1, null, 16973, null, 'EXTVERSIONDATE', 11, 0, 0, '   ', '   ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40623, 0, 1, null, 16973, null, 'FULLNAME', 1, 0, 1024, ' ', ' ', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40624, 0, 1, null, 16973, null, 'ACOMMENT', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- INNERFINSOURCE
CALL FIELDSINFO_IMPORT(17055, 0, 1, null, 17043, null, 'FINSOURCEVALUE', 1, 0, 20, ' .  .  ', '       ', 31, '999.99.99.99.99.99.9999.aaa;0;_', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- MEANSTYPE
CALL FIELDSINFO_IMPORT(17319, 0, 1, null, 17311, null, 'ACTIVITYKIND', 1, 0, 1, '  ', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(29925, 0, 1, null, 17311, null, 'ACTIVITYTYPE', 1, 0, 1, '', '', 11, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDGETDATA
CALL FIELDSINFO_IMPORT(40783, 0, 1, null, 17408, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDNOTIFY
CALL FIELDSINFO_IMPORT(17467, 0, 1, null, 17463, null, 'DOCNUMBER', 1, 0, 100, ' -', ' -', 40, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(17499, 0, 1, null, 17463, null, 'ANUMBER', 1, 0, 50, ' ', ' ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- INCOMES32
CALL FIELDSINFO_IMPORT(40886, 0, 1, null, 17668, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 78, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- LIMITFINDETAIL
CALL FIELDSINFO_IMPORT(40891, 0, 1, null, 18627, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 49, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- FACIALFINDETAIL
CALL FIELDSINFO_IMPORT(40642, 0, 1, null, 18864, null, 'SOURCETARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 94, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40643, 0, 1, null, 18864, null, 'DESTTARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 95, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- EXECUTIONDOCUMENTSCAPTION
CALL FIELDSINFO_IMPORT(43489, 0, 1, null, 19736, null, 'AUTOPAYTYPE', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 56, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- AGREEMENTS
CALL FIELDSINFO_IMPORT(43484, 0, 1, null, 19795, null, 'EXECUTERSTOREDPROPS', 1, 0, 2000, ' ', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 104, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43490, 0, 1, null, 19795, null, 'AUTOPAYTYPE', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43491, 0, 1, null, 19795, null, 'AUTOPAYMONTH', 3, 0, 0, '    ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 106, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43492, 0, 1, null, 19795, null, 'AUTOPAYDAY', 3, 0, 0, '   / ', '', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 107, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- PAYMENTSCHEDULE
CALL FIELDSINFO_IMPORT(40887, 0, 1, null, 20221, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 98, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TENDERPRODUCT
CALL FIELDSINFO_IMPORT(40892, 0, 1, null, 21028, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 85, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- BUDSTRUCTRIGHTS
CALL FIELDSINFO_IMPORT(21485, 0, 1, null, 21480, null, 'KFSR', 3, 0, 0, '', '', 11, '99.99', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21489, 0, 1, null, 21480, null, 'KESR', 1, 0, 20, '', '', 11, '9.9.9', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21490, 0, 1, null, 21480, null, 'SUBKESR', 1, 0, 20, ' ', '', 11, '999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21502, 0, 1, null, 21480, null, 'KESRUP', 1, 0, 20, '', '', 11, '9.9.9', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(21503, 0, 1, null, 21480, null, 'SUBKESRUP', 1, 0, 20, '. ', '', 11, '999.99.99', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- TARGETCLS
CALL FIELDSINFO_IMPORT(44257, 0, 1, null, 22385, null, 'TRANSFERKVSR', 3, 0, 0, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44258, 0, 1, null, 22385, null, 'TRANSFERKFSR', 3, 0, 0, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44259, 0, 1, null, 22385, null, 'TRANSFERKCSR', 1, 0, 0, '  ', '', 10, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(44260, 0, 1, null, 22385, null, 'TRANSFERKVR', 1, 0, 0, '  ', '', 10, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- TRANSFERTCLS
CALL FIELDSINFO_IMPORT(43561, 0, 1, null, 22773, null, 'FACT', 3, 0, 0, '', '', 9, '', '', '', 0, 0, null, 1, 16964, 0, 0, 0, '', 38, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- CORRECTIONDETAIL
CALL FIELDSINFO_IMPORT(40890, 0, 1, null, 22908, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 67, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- WRITEXECUTIONDETAIL
CALL FIELDSINFO_IMPORT(40888, 0, 1, null, 23401, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- REPLACEMENTCLSDETAILINFO
CALL FIELDSINFO_IMPORT(40889, 0, 1, null, 26795, null, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 37, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- BUDALLOCATIONCLS
CALL FIELDSINFO_IMPORT(43451, 0, 1, null, 27814, null, 'ASSIGNMENTKIND', 3, 0, 10, ' ', '', 10, '', '', '', 0, 0, null, 1, 22976, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- ANALYTICALGROUPKD
CALL FIELDSINFO_IMPORT(38908, 0, 1, null, 38906, null, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- ANALYTICALGROUPIFS
CALL FIELDSINFO_IMPORT(38919, 0, 1, null, 38917, null, 'CODE', 1, 0, 20, '', '', 0, '>a.a.a', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CONTRACTCOSTSCLS
CALL FIELDSINFO_IMPORT(40458, 0, 1, null, 40457, null, 'ID', 3, 0, 0, ' ', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40459, 0, 1, null, 40457, null, 'CODE', 1, 0, 20, '', '', 0, '999', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40460, 0, 1, null, 40457, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40461, 0, 1, null, 40457, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40462, 0, 1, null, 40457, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40463, 0, 1, null, 40457, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40464, 0, 1, null, 40457, null, 'NAME', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40465, 0, 1, null, 40457, null, 'DELETEDATE', 11, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40466, 0, 1, null, 40457, null, 'STARTDATE', 11, 0, 0, '   ', '', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40467, 0, 1, null, 40457, null, 'NOTE', 1, 0, 255, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40468, 0, 1, null, 40457, null, 'BUDGETREF', 3, 0, 0, ' ', '', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40471, 0, 1, null, 40457, null, 'PURCHASETYPE ', 3, 0, 0, ' ', '', 20, '', '', '', 0, 0, null, 0, 40480, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- PURCHASETYPE
CALL FIELDSINFO_IMPORT(40481, 0, 1, null, 40480, null, 'ID', 3, 0, 0, ' ', '', 11, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40482, 0, 1, null, 40480, null, 'CREATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40483, 0, 1, null, 40480, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40484, 0, 1, null, 40480, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40485, 0, 1, null, 40480, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40486, 0, 1, null, 40480, null, 'NAME', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- DOCBASETYPE
CALL FIELDSINFO_IMPORT(40597, 0, 1, null, 40596, null, 'ID', 3, 0, 0, '', '', 0, '', '', '', 2, 0, null, 1, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40598, 0, 1, null, 40596, null, 'CODE', 1, 0, 20, '', '', 20, '>aa.aa', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40599, 0, 1, null, 40596, null, 'NAME', 1, 0, 1024, '', '', 60, '', '', '', 0, 0, null, 1, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40600, 0, 1, null, 40596, null, 'BUDGETREF', 3, 0, 0, ' ', ' ', 11, '', '', '', 0, 0, null, 1, 16803, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40601, 0, 1, null, 40596, null, 'CREATEDATE', 11, 0, 0, ' ', ' ', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40602, 0, 1, null, 40596, null, 'CREATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40603, 0, 1, null, 40596, null, 'UPDATEDATE', 11, 0, 0, ' ', ' ', 20, '99/99/9999', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40604, 0, 1, null, 40596, null, 'UPDATERUSER', 1, 0, 30, '', '', 30, '', '', '', 1, 0, null, 1, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40605, 0, 1, null, 40596, null, 'STARTDATE', 11, 0, 0, '   ', '   ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40606, 0, 1, null, 40596, null, 'DELETEDATE', 11, 0, 0, ' ', ' ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40607, 0, 1, null, 40596, null, 'EXTID', 1, 0, 50, '', '', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40608, 0, 1, null, 40596, null, 'EXTOWNER', 1, 0, 50, '  ', '  ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40609, 0, 1, null, 40596, null, 'EXTSYNCDATE', 11, 0, 0, ',  ,  ', ',  ,  ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40610, 0, 1, null, 40596, null, 'EXTROOTID', 1, 0, 50, ' ', ' ', 50, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40611, 0, 1, null, 40596, null, 'EXTVERSION', 3, 0, 0, '   ', '   ', 11, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(40612, 0, 1, null, 40596, null, 'EXTVERSIONDATE', 11, 0, 0, '   ', '   ', 20, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', '', '') ;

-- ORGATTRS
CALL FIELDSINFO_IMPORT(43266, 0, 1, null, 43265, null, 'ID', 3, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 1, 0, '', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43274, 0, 1, null, 43265, null, 'OGRN', 1, 0, 20, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43275, 0, 1, null, 43265, null, 'INN', 1, 0, 20, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43276, 0, 1, null, 43265, null, 'INN20', 1, 0, 20, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43277, 0, 1, null, 43265, null, 'NAME', 1, 0, 2000, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43278, 0, 1, null, 43265, null, 'ACC', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43279, 0, 1, null, 43265, null, 'BANKNAME', 1, 0, 2000, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43280, 0, 1, null, 43265, null, 'BANKCOR', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43281, 0, 1, null, 43265, null, 'BANKMFO', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43282, 0, 1, null, 43265, null, 'BANKINN', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43283, 0, 1, null, 43265, null, 'BANKINN20', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43284, 0, 1, null, 43265, null, 'ATTRIBUTESKR', 1, 0, 20, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43285, 0, 1, null, 43265, null, 'PAYERATTRSID', 1, 0, 50, '  ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43286, 0, 1, null, 43265, null, 'PAYERATTRSUPDATEDATE', 11, 0, 0, '   ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43287, 0, 1, null, 43265, null, 'PROGINDEX', 3, 0, 0, 'ProgIndex', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43288, 0, 1, null, 43265, null, 'RVERSION', 3, 0, 0, 'RVersion', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 1, '', 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43289, 0, 1, null, 43265, null, 'CREATERUSER', 1, 0, 30, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43290, 0, 1, null, 43265, null, 'CREATEDATE', 11, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43291, 0, 1, null, 43265, null, 'UPDATEDATE', 11, 0, 0, ' ', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, '', '', '') ;

CALL FIELDSINFO_IMPORT(43292, 0, 1, null, 43265, null, 'UPDATERUSER', 1, 0, 30, '', '', 0, '', '', '', 0, 0, null, 0, null, 0, 0, 0, '', 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', '', '') ;

-- CLS_302
CALL FIELDSINFO_IMPORT(40905, 0, 2, 40642, 32867, 32869, 'SOURCETARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_304
CALL FIELDSINFO_IMPORT(40907, 0, 2, 40642, 34400, 34402, 'SOURCETARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_305
CALL FIELDSINFO_IMPORT(40908, 0, 2, 40643, 34424, 34427, 'DESTTARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_303
CALL FIELDSINFO_IMPORT(40906, 0, 2, 40643, 34448, 34451, 'DESTTARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_322
CALL FIELDSINFO_IMPORT(40910, 0, 2, 40642, 34588, 34591, 'SOURCETARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_323
CALL FIELDSINFO_IMPORT(40911, 0, 2, 40643, 34610, 34613, 'DESTTARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_201
CALL FIELDSINFO_IMPORT(40893, 0, 2, 40783, 34631, 34633, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_202
CALL FIELDSINFO_IMPORT(40894, 0, 2, 40783, 34650, 34653, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_203
CALL FIELDSINFO_IMPORT(40895, 0, 2, 40783, 34718, 34721, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_204
CALL FIELDSINFO_IMPORT(40896, 0, 2, 40783, 34738, 34741, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_205
CALL FIELDSINFO_IMPORT(40897, 0, 2, 40783, 34759, 34762, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 29, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_206
CALL FIELDSINFO_IMPORT(40898, 0, 2, 40783, 34779, 34782, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_207
CALL FIELDSINFO_IMPORT(40899, 0, 2, 40783, 34799, 34802, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_208
CALL FIELDSINFO_IMPORT(40900, 0, 2, 40783, 34820, 34823, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_903
CALL FIELDSINFO_IMPORT(38956, 0, 2, 17712, 35019, 35024, 'KESR', 3, 0, 0, '', ' ', 6, '9.9.9', '', '', 0, 0, null, 1, 16871, 0, 0, 0, '', 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'KESR', '') ;

CALL FIELDSINFO_IMPORT(40913, 0, 2, 40886, 35019, 35024, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_210
CALL FIELDSINFO_IMPORT(40902, 0, 2, 40783, 37748, 37752, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 27, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, '', 'TARGETCLS', '') ;

-- CLS_324
CALL FIELDSINFO_IMPORT(40912, 0, 2, 40643, 38766, 38768, 'DESTTARGETCLS', 3, 0, 0, '   ()', '    ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TARGETCLS', '') ;

-- CLS_209
CALL FIELDSINFO_IMPORT(40901, 0, 2, 40783, 38791, 38794, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TARGETCLS', '') ;

-- CLS_212
CALL FIELDSINFO_IMPORT(40904, 0, 2, 40783, 38818, 38822, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TARGETCLS', '') ;

-- CLS_211
CALL FIELDSINFO_IMPORT(40903, 0, 2, 40783, 38846, 38848, 'TARGETCLS', 3, 0, 0, '  ()', '   ', 12, '', '', '', 0, 0, null, 0, 22385, 0, 0, 0, '', 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, '', 'TARGETCLS', '') ;

--  
DROP PROCEDURE SELECTIONS_IMPORT
/

DROP PROCEDURE SELECTIONSDETAIL_IMPORT
/

DROP PROCEDURE FIELDSINFO_IMPORT
/

DROP PROCEDURE SELECTIONEVENTS_IMPORT
/

DROP PROCEDURE FIELDSINFO_DELETE
/

DROP PROCEDURE SELECTIONSDETAIL_DELETE
/

DROP PROCEDURE SELECTIONS_DELETE
/

DROP PROCEDURE SELECTIONEVENTS_DELETE
/

CREATE OR REPLACE PROCEDURE ImportDocCLS (
   ID_                 NUMBER,
   DOCTYPE_            NUMBER,
   DOCTYPENOTE_        VARCHAR2,
   TABLENAME_          VARCHAR2,
   TABLENAMEURM_       VARCHAR2,
   PRIMARYKEYNAME_     VARCHAR2,
   PRIMARYKEYNAMEURM_  VARCHAR2,
   LINKFIELDNAME_      VARCHAR2,
   LINKFIELDNAMEURM_   VARCHAR2,
   CLSTYPE_            NUMBER,
   SELECTIONREFBUDGET_ NUMBER,
   SELECTIONREFURM_    NUMBER,
   PROGINDEX_          NUMBER
) IS IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
   INTO IDExists$
   FROM DOCUMENTCLS
   WHERE (ID = ID_);

   IF (IDExists$ = 0) THEN
   INSERT INTO DOCUMENTCLS
   (ID, DOCTYPE, DOCTYPENOTE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM, LINKFIELDNAME, LINKFIELDNAMEURM, CLSTYPE, 
     SELECTIONREFBUDGET, SELECTIONREFURM, PROGINDEX)
   VALUES (ID_, DOCTYPE_, DOCTYPENOTE_, TABLENAME_, TABLENAMEURM_, PRIMARYKEYNAME_, PRIMARYKEYNAMEURM_, LINKFIELDNAME_, LINKFIELDNAMEURM_, CLSTYPE_, 
     SELECTIONREFBUDGET_, SELECTIONREFURM_, PROGINDEX_);
   ELSE
   UPDATE DOCUMENTCLS 
   SET
     DOCTYPENOTE = DOCTYPENOTE_,
     TABLENAME = TABLENAME_,
     TABLENAMEURM = TABLENAMEURM_,
     PRIMARYKEYNAME = PRIMARYKEYNAME_,
     PRIMARYKEYNAMEURM = PRIMARYKEYNAMEURM_,
     LINKFIELDNAME = LINKFIELDNAME_,
     LINKFIELDNAMEURM = LINKFIELDNAMEURM_,
     CLSTYPE = CLSTYPE_,
     SELECTIONREFBUDGET = SELECTIONREFBUDGET_,
     SELECTIONREFURM = SELECTIONREFURM_,
     PROGINDEX = PROGINDEX_
   WHERE  
    (ID = ID_)
    AND NOT (
            (
                    ((DOCTYPENOTE IS NOT NULL AND DOCTYPENOTE_ IS NOT NULL) AND
                       (UPPER (DOCTYPENOTE) = UPPER (DOCTYPENOTE_))
                    )
                    OR (DOCTYPENOTE IS NULL AND DOCTYPENOTE_ IS NULL)
                )    
        AND (UPPER (TABLENAME) = UPPER (TABLENAME_))    
        AND (
                    ((TABLENAMEURM IS NOT NULL AND TABLENAMEURM_ IS NOT NULL) AND
                       (UPPER (TABLENAMEURM) = UPPER (TABLENAMEURM_))
                    )
                    OR (TABLENAMEURM IS NULL AND TABLENAMEURM_ IS NULL)
                )    
        AND (UPPER (PRIMARYKEYNAME) = UPPER (PRIMARYKEYNAME_))
        AND (
                    ((PRIMARYKEYNAMEURM IS NOT NULL AND PRIMARYKEYNAMEURM_ IS NOT NULL) AND
                       (UPPER (PRIMARYKEYNAMEURM) = UPPER (PRIMARYKEYNAMEURM_))
                    )
                    OR (PRIMARYKEYNAMEURM IS NULL AND PRIMARYKEYNAMEURM_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAME IS NOT NULL AND LINKFIELDNAME_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAME) = UPPER (LINKFIELDNAME_))
                    )
                    OR (LINKFIELDNAME IS NULL AND LINKFIELDNAME_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAMEURM IS NOT NULL AND LINKFIELDNAMEURM_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAMEURM) = UPPER (LINKFIELDNAMEURM_))
                    )
                    OR (LINKFIELDNAMEURM IS NULL AND LINKFIELDNAMEURM_ IS NULL)
                )    
        AND (
                    ((CLSTYPE IS NOT NULL AND CLSTYPE_ IS NOT NULL) AND
                       (UPPER (CLSTYPE) = UPPER (CLSTYPE_))
                    )
                    OR (CLSTYPE IS NULL AND CLSTYPE_ IS NULL)
                ) 
        AND (
                    ((PROGINDEX IS NOT NULL AND PROGINDEX_ IS NOT NULL) AND
                       (PROGINDEX = PROGINDEX_)
                    )
                    OR (PROGINDEX IS NULL AND PROGINDEX_ IS NULL)
                )   
            );
   
   END IF;
END;
/

--   
CALL ImportDocCLS(10100, 101, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10101, 101, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, 223) ;

CALL ImportDocCLS(10102, 101, ' ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10103, 101, ' ', 'DEBT', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10104, 101, ' %  ', 'FINDOCDETAIL', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(10105, 101, ' ', 'INCOMES32', ' ', 'ID', ' ', 'TOTALREF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20100, 201, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(20101, 201, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 32) ;

CALL ImportDocCLS(30100, 301, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30101, 301, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 66) ;

CALL ImportDocCLS(30200, 302, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30201, 302, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 63) ;

CALL ImportDocCLS(30300, 303, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30301, 303, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 65) ;

CALL ImportDocCLS(30400, 304, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30401, 304, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 64) ;

CALL ImportDocCLS(30500, 305, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30501, 305, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 61) ;

CALL ImportDocCLS(30600, 306, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30601, 306, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 62) ;

CALL ImportDocCLS(30700, 307, '', 'FACIALFINREESTR', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(31100, 311, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31101, 311, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 68) ;

CALL ImportDocCLS(31200, 312, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31201, 312, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 69) ;

CALL ImportDocCLS(31400, 314, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31401, 314, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 70) ;

CALL ImportDocCLS(31500, 315, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(31501, 315, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 71) ;

CALL ImportDocCLS(992500, 9925, '', 'Cards', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992501, 9925, ' ', 'CARDSDETAIL_FACC', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(490300, 4903, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 527) ;

CALL ImportDocCLS(32200, 322, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32201, 322, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 73) ;

CALL ImportDocCLS(32300, 323, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32301, 323, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 75) ;

CALL ImportDocCLS(32400, 324, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(32401, 324, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 76) ;

CALL ImportDocCLS(40100, 401, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 130) ;

CALL ImportDocCLS(40101, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 131) ;

CALL ImportDocCLS(40102, 401, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 137) ;

CALL ImportDocCLS(40103, 401, '', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 132) ;

CALL ImportDocCLS(40104, 401, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 134) ;

CALL ImportDocCLS(40105, 401, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 138) ;

CALL ImportDocCLS(40106, 401, ' %', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 133) ;

CALL ImportDocCLS(40107, 401, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40108, 401, '. ', 'DEBT', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(40109, 401, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 340) ;

CALL ImportDocCLS(40110, 401, '.', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 341) ;

CALL ImportDocCLS(40111, 401, '', 'LOANCREDITCONTRACTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 342) ;

CALL ImportDocCLS(50100, 501, '', 'LOANCREDIT', ' ', 'ID', ' ', '', ' ', 0, null, null, 120) ;

CALL ImportDocCLS(50101, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 121) ;

CALL ImportDocCLS(50102, 501, ' ', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 127) ;

CALL ImportDocCLS(50103, 501, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 122) ;

CALL ImportDocCLS(50104, 501, ' %', 'LOANCREDITPERCENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 124) ;

CALL ImportDocCLS(50105, 501, '  %', 'LOANCREDITPLAN', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 128) ;

CALL ImportDocCLS(50106, 501, ' %', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 123) ;

CALL ImportDocCLS(50107, 501, ' %', 'PERCENTJOURNAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(50108, 501, '', 'COLLATERAL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 321) ;

CALL ImportDocCLS(70100, 701, '', 'FINDOCCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70101, 701, '', 'FINDOCDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 23) ;

CALL ImportDocCLS(70200, 702, '', 'PAYDOC32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70201, 702, '', 'PAYDOC32', ' ', 'ID', ' ', 'PARENTINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(70300, 703, '', 'FINDOCDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, 36) ;

CALL ImportDocCLS(80100, 801, '', 'LIMITNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80101, 801, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 57) ;

CALL ImportDocCLS(80200, 802, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80300, 803, '', 'REQUESTFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80301, 803, '', 'LIMITFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(80400, 804, '', 'LIMITFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90100, 901, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 145) ;

CALL ImportDocCLS(90101, 901, '', 'INCOMES32', ' ', 'ID', ' ', 'RecordIndex', ' ', 0, null, null, 0) ;

CALL ImportDocCLS(90300, 903, '', 'QUOTESTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90301, 903, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 45) ;

CALL ImportDocCLS(90500, 905, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 44) ;

CALL ImportDocCLS(90600, 906, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 41) ;

CALL ImportDocCLS(90601, 906, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 42) ;

CALL ImportDocCLS(120100, 1201, '', 'BUH_JOURNAL', ' ', 'ID', ' ', '', ' ', 0, null, null, 309) ;

CALL ImportDocCLS(150100, 1501, '', 'ORGOPERAT', ' ', 'ID', ' ', '', ' ', 0, null, null, 35) ;

CALL ImportDocCLS(160100, 1601, '', 'PROMISE_CAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(160101, 1601, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', 'TITLE_REF', ' ', 0, null, null, 345) ;

CALL ImportDocCLS(160200, 1602, '', 'PROMISE_DETAIL', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(170100, 1701, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 222) ;

CALL ImportDocCLS(170200, 1702, '', 'REQUESTS', ' ', 'ID', ' ', '', ' ', 0, null, null, 221) ;

CALL ImportDocCLS(170201, 1702, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(190100, 1901, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(190101, 1901, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 264) ;

CALL ImportDocCLS(220100, 2201, '', 'BUDNOTIFY', 'BUDNOTIFY', 'ID', ' ', '', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(220101, 2201, '', 'BUDGETDATA', 'BUDGETDATA', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 46) ;

CALL ImportDocCLS(280100, 2801, '', 'ACCSOPERTITLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(280101, 2801, '', 'PAYDOC32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 16) ;

CALL ImportDocCLS(280200, 2802, '', 'DFACCOUNTOPERATION', ' ', 'ID', ' ', '', ' ', 0, null, null, 50) ;

CALL ImportDocCLS(440100, 4401, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(440101, 4401, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 251) ;

CALL ImportDocCLS(0, 0, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991304, 9913, ' ', 'STATICLINKS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(440300, 4403, '', 'UNIONNOTIFYCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(440301, 4403, '', 'UNIONNOTIFYDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 254) ;

CALL ImportDocCLS(989500, 9895, ' ', 'OKTMO', 'OKTMO', 'id', 'id', '', '', 95, null, null, null) ;

CALL ImportDocCLS(990300, 9903, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990301, 9903, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990302, 9903, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'ORG_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(990500, 9905, '', 'ORGANIZATIONS', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(90200, 902, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 38) ;

CALL ImportDocCLS(20701, 207, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(90700, 907, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181200, 1812, '', 'ED_CorrectionCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181000, 1810, '', 'ED_OUTPAYDOC', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20700, 207, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 272) ;

CALL ImportDocCLS(181001, 1810, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992700, 9927, '', 'REMOTECLIENT', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550100, 5501, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(20801, 208, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(30701, 307, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', 'REESTR_REF', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21100, 211, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 275) ;

CALL ImportDocCLS(490100, 4901, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 525) ;

CALL ImportDocCLS(992701, 9927, '  ', 'REMOTEREADRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(550101, 5501, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 312) ;

CALL ImportDocCLS(490301, 4903, '', 'ARCHIVEOPLOG', ' ', 'ID', ' ', 'DATAPACKETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(390100, 3901, '', 'DELOIN', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21101, 211, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(992300, 9923, '', 'SIGNSCHEMECAPTION', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181201, 1812, '', 'ED_CorrectionDetail', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(550200, 5502, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(20800, 208, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 273) ;

CALL ImportDocCLS(550201, 5502, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 313) ;

CALL ImportDocCLS(90000, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992301, 9923, '', 'SIGNSCHEMEDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991600, 9916, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992200, 9922, '', 'ARCHIVEDOCTYPE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(90001, 900, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(390101, 3901, '', 'DELOEXEC', ' ', 'ID', ' ', 'DOCID', ' ', 0, null, null, null) ;

CALL ImportDocCLS(180700, 1807, '', 'PayDocExchange', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21102, 211, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 275) ;

CALL ImportDocCLS(991700, 9917, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991200, 9912, '', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(181600, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30800, 308, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250100, 2501, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 305) ;

CALL ImportDocCLS(21200, 212, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 276) ;

CALL ImportDocCLS(250101, 2501, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(30801, 308, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 67) ;

CALL ImportDocCLS(250200, 2502, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', ' ', 0, null, null, 304) ;

CALL ImportDocCLS(250201, 2502, ' ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(988900, 9889, ' ', 'SubsidyCls', ' ', 'id', ' ', '', '', 89, null, null, null) ;

CALL ImportDocCLS(250202, 2502, '  ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(988700, 9887, ' ', 'VariantCls', ' ', 'ID', ' ', '', '', 87, null, null, null) ;

CALL ImportDocCLS(520100, 5201, '', 'WritExecutionCaption', 'WritExecutionCaption', 'id', 'id', '', '', 0, null, null, 555) ;

CALL ImportDocCLS(990800, 9908, '', 'DocumentTypes', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(250300, 2503, '', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', '', ' ', 0, null, null, null) ;

CALL ImportDocCLS(21201, 212, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(250301, 2503, '', 'EXECUTIONDOCUMENTSDETAIL', 'EXECUTIONDOCUMENTSDETAIL', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(180500, 1805, '', 'BANKEXCH_MERDOC', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20201, 202, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20301, 203, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20401, 204, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20501, 205, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20601, 206, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190201, 1902, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190301, 1903, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(20000, 200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190601, 1906, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(20200, 202, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 260) ;

CALL ImportDocCLS(20300, 203, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 261) ;

CALL ImportDocCLS(20400, 204, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 262) ;

CALL ImportDocCLS(20500, 205, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 263) ;

CALL ImportDocCLS(20600, 206, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 268) ;

CALL ImportDocCLS(190200, 1902, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 215) ;

CALL ImportDocCLS(190300, 1903, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 265) ;

CALL ImportDocCLS(180501, 1805, '', 'ED_DETAIL', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(190600, 1906, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', ' ', 0, null, null, 271) ;

CALL ImportDocCLS(988400, 9884, ' ', 'TransfertCLS', ' ', 'ID', ' ', '', '', 84, null, null, null) ;

CALL ImportDocCLS(988800, 9888, ' ', 'OKP', ' ', 'ID', ' ', '', '', 88, null, null, null) ;

CALL ImportDocCLS(989900, 9899, ' ', 'DBUsers', ' ', 'ID', ' ', '', '', 201, null, null, null) ;

CALL ImportDocCLS(990801, 9908, ' ', 'DOCUMENTFIELDS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(361000, 3610, '', 'UTYPEDFORMSCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 550) ;

CALL ImportDocCLS(987200, 9872, ' ', 'BalanceCls', ' ', 'ID', ' ', '', '', 72, null, null, null) ;

CALL ImportDocCLS(984600, 9846, ' ', 'BUHPAYMENTCLS', ' ', 'ID', ' ', '', '', 46, null, null, null) ;

CALL ImportDocCLS(981800, 9818, ' ', 'CURRENCYCLS', ' ', 'ID', ' ', '', '', 18, null, null, null) ;

CALL ImportDocCLS(988500, 9885, ' ', 'AssignmentKind', ' ', 'ID', ' ', '', '', 85, null, null, null) ;

CALL ImportDocCLS(983500, 9835, ' ', 'BUDGETTYPE', ' ', 'ID', ' ', '', '', 35, null, null, null) ;

CALL ImportDocCLS(985800, 9858, ' ', 'DEBTTYPE', ' ', 'ID', ' ', '', '', 58, null, null, null) ;

CALL ImportDocCLS(988600, 9886, ' ', 'AssignmentSource', ' ', 'ID', ' ', ' ', ' ', 86, null, null, null) ;

CALL ImportDocCLS(988300, 9883, ' ', 'Org_Type', ' ', 'ID', ' ', '', '', 83, null, null, null) ;

CALL ImportDocCLS(986400, 9864, ' ', 'PlanDocType', ' ', 'ID', ' ', '', '', 64, null, null, null) ;

CALL ImportDocCLS(985700, 9857, ' ', 'LOANTYPE', ' ', 'ID', ' ', '', '', 57, null, null, null) ;

CALL ImportDocCLS(984300, 9843, ' ', 'PAYTYPECLS', ' ', 'ID', ' ', '', '', 43, null, null, null) ;

CALL ImportDocCLS(982300, 9823, ' ', 'GOSNI', ' ', 'ID', ' ', '', '', 23, null, null, null) ;

CALL ImportDocCLS(982200, 9822, ' ', 'GroupInf_CLS', ' ', 'ID', ' ', '', '', 22, null, null, null) ;

CALL ImportDocCLS(982900, 9829, ' ', 'DocBase', ' ', 'ID', ' ', '', '', 29, null, null, null) ;

CALL ImportDocCLS(981100, 9811, ' ', 'DocTypes', ' ', 'ID', ' ', '', '', 11, null, null, null) ;

CALL ImportDocCLS(986000, 9860, ' ', 'MEASUREMENTCLS', ' ', 'ID', ' ', '', '', 60, null, null, null) ;

CALL ImportDocCLS(988000, 9880, ' ', 'FundsSource', ' ', 'ID', ' ', '', '', 80, null, null, null) ;

CALL ImportDocCLS(985200, 9852, ' ', 'InnerFinSource', ' ', 'ID', ' ', '', '', 52, null, null, null) ;

CALL ImportDocCLS(981300, 9813, ' ', 'NOTIFYTYPES', ' ', 'ID', ' ', '', '', 13, null, null, null) ;

CALL ImportDocCLS(984500, 9845, ' ', 'PAYSYMBOLCLS', ' ', 'ID', ' ', '', '', 45, null, null, null) ;

CALL ImportDocCLS(980400, 9804, ' ', 'KVR', ' ', 'ID', ' ', '', '', 4, null, null, null) ;

CALL ImportDocCLS(980300, 9803, ' ', 'KVSR', ' ', 'ID', ' ', '', '', 3, null, null, null) ;

CALL ImportDocCLS(980900, 9809, ' ', 'KD', ' ', 'ID', ' ', '', '', 9, null, null, null) ;

CALL ImportDocCLS(984700, 9847, ' ', 'TYPEOPERATIONCLS', ' ', 'ID', ' ', '', '', 47, null, null, null) ;

CALL ImportDocCLS(986800, 9868, ' ', 'KESR', ' ', 'ID', ' ', '', '', 68, null, null, null) ;

CALL ImportDocCLS(987900, 9879, ' ', 'TargetCls', ' ', 'ID', ' ', '', '', 79, null, null, null) ;

CALL ImportDocCLS(985100, 9851, ' ', 'Error', ' ', 'ID', ' ', '', '', 51, null, null, null) ;

CALL ImportDocCLS(982100, 9821, ' ', 'ACC_CLS', ' ', 'ID', ' ', '', '', 21, null, null, null) ;

CALL ImportDocCLS(981400, 9814, ' ', 'KSHK', ' ', 'ID', ' ', '', '', 14, null, null, null) ;

CALL ImportDocCLS(980200, 9802, ' ', 'kfsr', ' ', 'ID', ' ', '', '', 2, null, null, null) ;

CALL ImportDocCLS(980500, 9805, ' ', 'KCSR', ' ', 'ID', ' ', '', '', 5, null, null, null) ;

CALL ImportDocCLS(984100, 9841, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', '', '', 41, null, null, null) ;

CALL ImportDocCLS(981500, 9815, ' ', 'VALUECLS', ' ', 'ID', ' ', '', '', 15, null, null, null) ;

CALL ImportDocCLS(982800, 9828, ' ', 'FACT', ' ', 'ID', ' ', '', '', 28, null, null, null) ;

CALL ImportDocCLS(984800, 9848, ' ', 'PAYDESTINATIONCLS', ' ', 'ID', ' ', '', '', 48, null, null, null) ;

CALL ImportDocCLS(986900, 9869, ' ', 'DirectionCLS', ' ', 'ID', ' ', '', '', 69, null, null, null) ;

CALL ImportDocCLS(986200, 9862, ' ', 'OKATO', ' ', 'ID', ' ', '', '', 62, null, null, null) ;

CALL ImportDocCLS(988200, 9882, ' ', 'OKOPF', ' ', 'ID', ' ', '', '', 82, null, null, null) ;

CALL ImportDocCLS(988100, 9881, ' ', 'OKFS', ' ', 'ID', ' ', '', '', 81, null, null, null) ;

CALL ImportDocCLS(981600, 9816, ' ', 'MeansCLS', ' ', 'ID', ' ', '', '', 16, null, null, null) ;

CALL ImportDocCLS(985900, 9859, ' ', 'DepartmentCLS', ' ', 'ID', ' ', '', '', 59, null, null, null) ;

CALL ImportDocCLS(986500, 9865, ' ', 'BuhAccPlan', ' ', 'ID', ' ', '', '', 65, null, null, null) ;

CALL ImportDocCLS(986100, 9861, ' ', 'TenderObjects', ' ', 'ID', ' ', '', '', 61, null, null, null) ;

CALL ImportDocCLS(985000, 9850, ' ', 'RejectCLS', ' ', 'ID', ' ', '', '', 50, null, null, null) ;

CALL ImportDocCLS(987000, 9870, ' ', 'ProgramCode', ' ', 'ID', ' ', '', '', 70, null, null, null) ;

CALL ImportDocCLS(981200, 9812, ' ', 'RegionCLS', ' ', 'ID', ' ', '', '', 12, null, null, null) ;

CALL ImportDocCLS(982600, 9826, ' ', 'BUDGETACCOUNTS', ' ', 'ID', ' ', '', '', 26, null, null, null) ;

CALL ImportDocCLS(981700, 9817, ' ', 'REFCLS', ' ', 'ID', ' ', '', '', 17, null, null, null) ;

CALL ImportDocCLS(981000, 9810, ' ', 'SubKD', ' ', 'ID', ' ', '', '', 10, null, null, null) ;

CALL ImportDocCLS(980600, 9806, ' ', 'SUBKCSR', ' ', 'ID', ' ', '', '', 6, null, null, null) ;

CALL ImportDocCLS(980800, 9808, ' ', 'KESRSubCode', ' ', 'ID', ' ', '', '', 8, null, null, null) ;

CALL ImportDocCLS(986300, 9863, ' ', 'COLLATERALTYPE', ' ', 'ID', ' ', '', '', 63, null, null, null) ;

CALL ImportDocCLS(982000, 9820, ' ', 'ORG_CLS', ' ', 'ID', ' ', '', '', 20, null, null, null) ;

CALL ImportDocCLS(983400, 9834, ' ', 'ReportType', ' ', 'ID', ' ', '', '', 34, null, null, null) ;

CALL ImportDocCLS(985300, 9853, ' ', 'REESTRTYPE', ' ', 'ID', ' ', '', '', 53, null, null, null) ;

CALL ImportDocCLS(984900, 9849, ' ', 'MEANSTYPE', ' ', 'ID', ' ', '', '', 49, null, null, null) ;

CALL ImportDocCLS(982700, 9827, ' ', 'FinType', ' ', 'ID', ' ', '', '', 27, null, null, null) ;

CALL ImportDocCLS(984400, 9844, ' ', 'Org_AccDefaults', ' ', 'ID', ' ', '', '', 44, null, null, null) ;

CALL ImportDocCLS(960100, 9601, ' ', 'ORGANIZATIONS', ' ', 'ID', ' ', '', '', 1000, null, null, null) ;

CALL ImportDocCLS(960200, 9602, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 1001, null, null, null) ;

CALL ImportDocCLS(960400, 9604, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', '', '', 1003, null, null, null) ;

CALL ImportDocCLS(960300, 9603, ' ', 'BANKS', ' ', 'ID', ' ', '', '', 1002, null, null, null) ;

CALL ImportDocCLS(987100, 9871, ' ', 'BuhOperationCls', ' ', 'Id', ' ', '', '', 71, null, null, null) ;

CALL ImportDocCLS(987800, 9878, ' ', 'budgets_s', ' ', 'id', ' ', '', '', 78, null, null, null) ;

CALL ImportDocCLS(991400, 9914, '', 'DATAPACKETTYPES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991401, 9914, '', 'DATAPACKETCONTENT', ' ', 'ID', ' ', 'DATAPACKETTYPE', '', 0, null, null, null) ;

CALL ImportDocCLS(991500, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991501, 9915, '', 'UNLOCKDATES', ' ', 'ID', ' ', 'ID', '', 0, null, null, null) ;

CALL ImportDocCLS(20001, 200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(30000, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(30001, 300, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190000, 1900, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(190001, 1900, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(220000, 2200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(220001, 2200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(991300, 9913, '', 'INTERFACES', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991301, 9913, '', 'Permissions', ' ', 'ID', ' ', 'INTERFACEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(991302, 9913, '', 'LinkType', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991303, 9913, ' ', ' ', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(490200, 4902, '', 'DATAPACKET', ' ', 'ID', ' ', '', ' ', 0, null, null, 526) ;

CALL ImportDocCLS(250400, 2504, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', '', 0, null, null, 314) ;

CALL ImportDocCLS(300100, 3001, '', 'TenderCaption', ' ', 'ID', ' ', '', '', 0, null, null, 230) ;

CALL ImportDocCLS(250401, 2504, '  ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(250402, 2504, '   ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 304) ;

CALL ImportDocCLS(250403, 2504, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) ;

CALL ImportDocCLS(300600, 3006, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 241) ;

CALL ImportDocCLS(250102, 2501, '  . ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 305) ;

CALL ImportDocCLS(70202, 702, '', 'PAYDOCEXCHANGE', ' ', 'ID', ' ', 'PAYDOCREF', '', 0, null, null, null) ;

CALL ImportDocCLS(170101, 1701, '', 'REQUESTSPAYMENTS', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(20900, 209, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 274) ;

CALL ImportDocCLS(300601, 3006, '  ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 241) ;

CALL ImportDocCLS(300602, 3006, '   ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300300, 3003, '', 'TenderResultCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(300101, 3001, ' ', 'TenderProduct', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 230) ;

CALL ImportDocCLS(300102, 3001, ' ', 'TenderLot', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300103, 3001, '   ', 'TENDERSOURCEORG', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300104, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300105, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300106, 3001, ' ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300107, 3001, '   ', 'TENDERSUPPLEMENTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(300108, 3001, ',  ', 'TENDERSUPDOCUMENT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(370100, 3701, '', 'TenderObjects', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(520101, 5201, '', 'WritExecutionDetail', 'WritExecutionDetail', 'id', 'id', 'RecordIndex', '', 0, null, null, 556) ;

CALL ImportDocCLS(20901, 209, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(21000, 210, '', 'BUDNOTIFY', ' ', 'ID', ' ', '', '', 0, null, null, 252) ;

CALL ImportDocCLS(21001, 210, ', ', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 252) ;

CALL ImportDocCLS(21002, 210, '', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 253) ;

CALL ImportDocCLS(991800, 9918, '', 'USERGENERATOR', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(991801, 9918, '', 'USERGENERATORFIELDS', ' ', 'ID', ' ', 'GENREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992702, 9927, '   ', 'REMOTEINPUTRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(21202, 212, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 276) ;

CALL ImportDocCLS(990802, 9908, ' ', 'STATE_DOCSTATES', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990803, 9908, '', 'STATE_JUMPS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(990804, 9908, '', 'STATE_ACTIONS', ' ', 'ID', ' ', 'DOCTYPEREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992703, 9927, '   ', 'REMOTECLIENTACCOUNT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992000, 9920, '', 'BUHOPERATIONCLS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992001, 9920, '', 'BUHACCCORR', ' ', 'ID', ' ', 'BUHOPERATIONCLS', '', 0, null, null, null) ;

CALL ImportDocCLS(992100, 9921, '', 'BUDGETS_S', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992101, 9921, ' ', 'FACIALACC_CLS', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(992102, 9921, ' ', 'DFACCOUNTSBUHTABLE', ' ', 'ID', ' ', 'BUDGETREF', '', 0, null, null, null) ;

CALL ImportDocCLS(989000, 9890, ' ', 'BudAllocationCls', ' ', 'id', ' ', '', '', 90, null, null, null) ;

CALL ImportDocCLS(989100, 9891, ' ', 'PayPromiseCls', ' ', 'id', ' ', '', '', 91, null, null, null) ;

CALL ImportDocCLS(550300, 5503, '', 'ReplacementClsCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(550301, 5503, '   ', 'ReplacementClsDetail', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(550302, 5503, ' ', 'ReplacementClsDetailInfo', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(250302, 2503, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'EXECUTIONREF', '', 0, null, null, 308) ;

CALL ImportDocCLS(181400, 1814, '', 'BANKEXCH_LS_KB', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(180900, 1809, '', 'BANKEXCH_SUBSTITUTION', 'BANKEXCH_SUBSTITUTION', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181500, 1815, '', 'BANKEXCH_KO_SALDO', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992900, 9929, '', 'BudStruct', 'BudStruct', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992201, 9922, '', 'ARCHIVEDOCPARAMS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) ;

CALL ImportDocCLS(992400, 9924, '', 'SIGNS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(480101, 4801, '', 'GeneralDocsDetail', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992502, 9925, '', 'CARDSDETAIL_KESR', ' ', 'ID', ' ', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(250203, 2502, ' ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, 304) ;

CALL ImportDocCLS(250404, 2504, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', '', 0, null, null, 318) ;

CALL ImportDocCLS(520102, 5201, '2', 'WritExecutionNotify', 'WritExecutionNotify', 'id', 'id', 'RecordIndex', '', 0, null, null, null) ;

CALL ImportDocCLS(989200, 9892, ' ', 'ArchiveDocType', ' ', 'id', ' ', '', '', 92, null, null, null) ;

CALL ImportDocCLS(480100, 4801, '', 'GeneralDocuments', ' ', 'ID', ' ', '', '', 0, null, null, 528) ;

CALL ImportDocCLS(992600, 9926, '', 'WritNotifyCls', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992601, 9926, '', 'WRITNOTIFYCLSDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) ;

CALL ImportDocCLS(992602, 9926, ' ', 'WritNotifyClsPart', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(31600, 316, '', 'ManagerBid', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(20902, 209, '2', 'BUDGETDATA', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 274) ;

CALL ImportDocCLS(992704, 9927, '  + /', 'DUALRIGHTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992705, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(992706, 9927, ' ', 'REMOTEEDSRIGHT', ' ', 'ID', ' ', 'REMOTECLIENT', '', 0, null, null, null) ;

CALL ImportDocCLS(990400, 9904, '', 'CONTACTPERSONS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181601, 1816, '', 'FacialFinCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992707, 9927, '', 'SIGNCERTIFICATE', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(992708, 9927, '  ', 'SIGNDOCUMENTSGROUP', ' ', 'ID', ' ', 'CLIENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(510100, 5101, '', 'StoredAttributesCaption', 'StoredAttributesCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(510101, 5101, '', 'StoredAttributesDetail', 'StoredAttributesDetail', 'id', 'id', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250405, 2504, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(993000, 9930, '', 'AUTOSANCTIONDATA', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301000, 3010, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 242) ;

CALL ImportDocCLS(970200, 9702, ' ', 'AnalyticalGroupIFS', 'AnalyticalGroupIFS', 'ID', 'ID', '', '', 102, null, null, null) ;

CALL ImportDocCLS(970100, 9701, ' ', 'AnalyticalGroupKD', 'AnalyticalGroupKD', 'ID', 'ID', '', '', 101, null, null, null) ;

CALL ImportDocCLS(181800, 1818, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(301100, 3011, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 243) ;

CALL ImportDocCLS(301101, 3011, ' ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 243) ;

CALL ImportDocCLS(300500, 3005, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 240) ;

CALL ImportDocCLS(181801, 1818, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181802, 1818, '', 'OOS_CONTRACT_PRODUCTS', 'OOS_CONTRACT_PRODUCTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181803, 1818, '', 'OOS_CONTRACTPROCEDURE', 'OOS_CONTRACTPROCEDURE', 'ID', 'ID', 'RegNum', 'RegNum', 0, null, null, null) ;

CALL ImportDocCLS(989700, 9897, ' ', 'ContractCostsCls', 'ContractCostsCls', 'id', 'id', '', '', 97, null, null, null) ;

CALL ImportDocCLS(960101, 9601, ' ', 'ORG_ACCOUNTS', ' ', 'ID', ' ', '', '', 0, null, null, null) ;

CALL ImportDocCLS(989800, 9898, ' ', 'PURCHASETYPE ', 'PURCHASETYPE ', 'id', 'id', '', '', 98, null, null, null) ;

CALL ImportDocCLS(21300, 213, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 277) ;

CALL ImportDocCLS(21301, 213, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 277) ;

CALL ImportDocCLS(21400, 214, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 278) ;

CALL ImportDocCLS(21401, 214, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 278) ;

CALL ImportDocCLS(993200, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(993201, 9932, '', 'BudStrLink', 'BudStrLink', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(21500, 215, '', 'BudNotify', 'BudNotify', 'ID', 'ID', '', '', 0, null, null, 279) ;

CALL ImportDocCLS(21501, 215, '', 'BudgetData', 'BudgetData', 'ID', 'ID', 'RecordIndex', '', 0, null, null, 279) ;

CALL ImportDocCLS(250204, 2502, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', 'AGREEMENTREF', '', 0, null, null, null) ;

CALL ImportDocCLS(181900, 1819, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(181901, 1819, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(182000, 1820, '', 'OOS_CONTRACT', 'OOS_CONTRACT', 'ID', 'ID', '', '', 0, null, null, null) ;

CALL ImportDocCLS(182001, 1820, '', 'OOS_CONTRACT_FINANCES', 'OOS_CONTRACT_FINANCES', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(181804, 1818, '', 'OOS_ATTACHMENTS', 'OOS_ATTACHMENTS', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(250406, 2504, '', 'Suppliers', 'Suppliers', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

CALL ImportDocCLS(540200, 5402, '', 'EPBSExportLogCaption', 'EPBSExportLogCaption', 'id', 'id', '', '', 0, null, null, null) ;

CALL ImportDocCLS(540201, 5402, '', 'EPBSExportLogDetail', 'EPBSExportLogDetail', 'ID', 'ID', 'RecordIndex', 'RecordIndex', 0, null, null, null) ;

DROP PROCEDURE ImportDocCLS
/

COMMIT WORK
/


CREATE OR REPLACE PROCEDURE ImportField (
   ID_                NUMBER,
   NAME_              VARCHAR2,
   ITFFIELDNAME_      VARCHAR2,
   NOTE_              VARCHAR2,
   TEMPLATEFIELD_     VARCHAR2,
   ISBUDGET_          NUMBER,
   DOCTYPEREF_        NUMBER,
   DETAILNUMBER_      NUMBER,
   ONLYREAD_          NUMBER,
   ReportFieldName_   VARCHAR2,
   KIND_	      NUMBER,
   FIELDINFOREF_      NUMBER,
   CONTAINERREF_      NUMBER, 
   ATTRFIELDKIND_     NUMBER,
   ATTRIBUTENAME_     VARCHAR2
) IS
   IDExists$   NUMBER (10);
BEGIN
   SELECT COUNT (ID)
     INTO IDExists$
     FROM DocumentFields
    WHERE (ID = ID_);

   IF (IDExists$ <> 0) THEN
      UPDATE DocumentFields
         SET NAME = NAME_,
             ITFFIELDNAME = ITFFIELDNAME_,
             NOTE = NOTE_,
             TEMPLATEFIELD = TEMPLATEFIELD_,
             ISBUDGET = ISBUDGET_,
             DOCTYPEREF = DOCTYPEREF_,
             DETAILNUMBER = DETAILNUMBER_,
             ONLYREAD = ONLYREAD_,
             ReportFieldName = ReportFieldName_,
			       FIELDINFOREF = FIELDINFOREF_, 
             CONTAINERREF = CONTAINERREF_, 
             ATTRFIELDKIND = ATTRFIELDKIND_,
             ATTRIBUTENAME = ATTRIBUTENAME_
       WHERE (ID = ID_)
         AND NOT (
                      (
                          (
                           (NAME IS NOT NULL AND NAME_ IS NOT NULL) AND
                           (UPPER (NAME) = UPPER (NAME_))
                          )
                       OR (NAME IS NULL AND NAME_ IS NULL)
                      )

                  AND (
                          (
                           (ITFFIELDNAME_ IS NOT NULL AND ITFFIELDNAME IS NOT NULL) AND
                           (UPPER (ITFFIELDNAME_) = UPPER (ITFFIELDNAME))
                          )
                       OR (ITFFIELDNAME_ IS NULL AND ITFFIELDNAME IS NULL)
                      )
                      
                  AND (
                          (
                           (NOTE IS NOT NULL AND NOTE_ IS NOT NULL) AND
                           (UPPER (NOTE) = UPPER (NOTE_))
                          )
                       OR (NOTE IS NULL AND NOTE_ IS NULL)
                      )
                  AND (UPPER (TEMPLATEFIELD) = UPPER (TEMPLATEFIELD_))
                  AND (
                          (
                           (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                           (ISBUDGET = ISBUDGET_)
                          )
                       OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                      )
                  AND (
                          (
                           (FIELDINFOREF IS NOT NULL AND FIELDINFOREF_ IS NOT NULL) AND
                           (FIELDINFOREF = FIELDINFOREF_)
                          )
                       OR (FIELDINFOREF IS NULL AND FIELDINFOREF_ IS NULL)
                      )
                  AND (
                          (
                           (CONTAINERREF IS NOT NULL AND CONTAINERREF_ IS NOT NULL) AND
                           (CONTAINERREF = CONTAINERREF_)
                          )
                       OR (CONTAINERREF IS NULL AND CONTAINERREF_ IS NULL)
                      )   
                  AND (
                          (
                           (ATTRFIELDKIND IS NOT NULL AND ATTRFIELDKIND_ IS NOT NULL) AND
                           (ATTRFIELDKIND = ATTRFIELDKIND_)
                          )
                       OR (ATTRFIELDKIND IS NULL AND ATTRFIELDKIND_ IS NULL)
                      )
                  AND (
                          (
                           (ATTRIBUTENAME_ IS NOT NULL AND ATTRIBUTENAME IS NOT NULL) AND
                           (UPPER (ATTRIBUTENAME_) = UPPER (ATTRIBUTENAME))
                          )
                       OR (ATTRIBUTENAME_ IS NULL AND ATTRIBUTENAME IS NULL)
                      )
                  AND (DOCTYPEREF = DOCTYPEREF_)
                  AND (DETAILNUMBER = DETAILNUMBER_)
                  AND (ONLYREAD = ONLYREAD_)
                  AND (
                          (
                           (ReportFieldName IS NOT NULL AND ReportFieldName_ IS NOT NULL) AND
                           (UPPER (ReportFieldName) = UPPER (ReportFieldName_))
                          )
                       OR (ReportFieldName IS NULL AND ReportFieldName_ IS NULL)
                      )
                 );
   ELSE
      INSERT INTO DocumentFields
                  (ID, NAME, ITFFIELDNAME, NOTE, TEMPLATEFIELD,
                   ISBUDGET, DOCTYPEREF, DETAILNUMBER, ONLYREAD, ReportFieldName, FIELDINFOREF, CONTAINERREF, ATTRFIELDKIND, ATTRIBUTENAME
                  )
           VALUES (ID_, NAME_, ITFFIELDNAME_, NOTE_, TEMPLATEFIELD_,
                   ISBUDGET_, DOCTYPEREF_, DETAILNUMBER_, ONLYREAD_, ReportFieldName_, FIELDINFOREF_, CONTAINERREF_, ATTRFIELDKIND_, ATTRIBUTENAME_
                  );
   END IF;

   FOR tab_rec IN (
                   SELECT ID
                     FROM DocumentFields
                    WHERE (ID <> ID_)
                      AND (DOCTYPEREF = DOCTYPEREF_)
                      AND (
                              (
                               (ISBUDGET IS NOT NULL AND ISBUDGET_ IS NOT NULL) AND
                               (ISBUDGET = ISBUDGET_)
                              )
                           OR (ISBUDGET IS NULL AND ISBUDGET_ IS NULL)
                          )
                      AND (DETAILNUMBER = DETAILNUMBER_)
              AND ( /*      ,       ,       */
                            (
                             ((ITFFIELDNAME_ IS NULL)or(ITFFIELDNAME_=' '))
                 and not((TEMPLATEFIELD_ IS NULL)or(TEMPLATEFIELD_=' '))
                 and(TEMPLATEFIELD is NOT null) and (UPPER(TEMPLATEFIELD)=UPPER(TEMPLATEFIELD_))
                            )
                    or (
                        not ((ITFFIELDNAME_ IS NULL) or (ITFFIELDNAME_=' '))
                                and (ITFFIELDNAME IS NOT NULL) and (UPPER(ITFFIELDNAME)=UPPER(ITFFIELDNAME_)))
                            )
                       )
   LOOP
      UPDATE State_OpenFields
         SET DOCFIELDREF = ID_
       WHERE (DOCFIELDREF = tab_rec.ID);

      UPDATE DOCLOCKFIELDS
         SET FIELDREF = ID_
       WHERE (FIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET PARENTFIELDREF = ID_
      WHERE (PARENTFIELDREF = tab_rec.ID);

      UPDATE staticlinks
         SET CHILDFIELDREF = ID_
      WHERE (CHILDFIELDREF = tab_rec.ID);

      DELETE FROM DocumentFields
            WHERE (ID = tab_rec.ID);
   END LOOP;
END;
/

CREATE OR REPLACE PROCEDURE DeleteFields (ID$ NUMBER) IS
BEGIN
  DELETE FROM State_OpenFields
  WHERE (docfieldref = ID$);
  DELETE FROM DOCLOCKFIELDS
  WHERE (fieldref = ID$);

  DELETE FROM STATE_JUMPCONTROL
  WHERE STATICLINKREF IN(SELECT ID FROM staticlinks
                           WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$));
  DELETE FROM staticlinks
  WHERE (PARENTFIELDREF=ID$)OR(CHILDFIELDREF=ID$);
  
  DELETE FROM DOCUMENTTEMPLATEFIELDS
  WHERE (FIELDS=ID$);

  DELETE FROM DocumentFields
  WHERE (id = ID$);
END;
/

CREATE OR REPLACE PROCEDURE INSERTCONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER,
  NOTE_          VARCHAR2,
  VARCHARVALUE_  VARCHAR2,
  DOUBLEVALUE_   NUMBER,
  INTVALUE_      INTEGER,
  EDITDOCCODE_   INTEGER
) IS
  IDEXISTS$ NUMBER;
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM IntConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO INTCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,INTVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE INTCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 8) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM VarcharConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO VARCHARCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,VARCHARVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE VARCHARCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;    
  END IF;

  IF (CONSTTYPE_ = 5) THEN
    SELECT COUNT (PROGINDEX)
    INTO IDExists$
    FROM RealConst
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);

    IF (IDExists$ = 0) THEN
      INSERT INTO REALCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (PROGINDEX_,CONSTINDEX_,DOUBLEVALUE_,NOTE_,EDITDOCCODE_);
    ELSE 
      UPDATE REALCONST SET
        NOTE = NOTE_,
        EDITDOCCODE = EDITDOCCODE_
      WHERE (PROGINDEX=PROGINDEX_) AND (CONSTINDEX=CONSTINDEX_);
    END IF;   
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DELETECONST (
  PROGINDEX_     NUMBER,
  CONSTINDEX_    NUMBER,
  CONSTTYPE_     NUMBER
) IS
BEGIN
  IF (CONSTTYPE_ = 3) THEN
    UPDATE IntConst
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
  IF (CONSTTYPE_ = 8) THEN
    UPDATE VARCHARCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_); 
  END IF;
  IF (CONSTTYPE_ = 5) THEN
    UPDATE REALCONST
      SET CloseDate = systimestamp
    WHERE (PROGINDEX = PROGINDEX_) AND (CONSTINDEX = CONSTINDEX_);
  END IF;
END;
/

--       
ALTER TRIGGER TR_INTCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 DISABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 DISABLE
/

--     
CALL DeleteFields(20901017) ;

CALL DeleteFields(20901027) ;

CALL DeleteFields(21101014) ;

CALL DeleteFields(21111019) ;

CALL DeleteFields(21211019) ;

CALL DeleteFields(21201014) ;

CALL DeleteFields(21300031) ;

CALL DeleteFields(21301008) ;

CALL DeleteFields(30201154) ;

CALL DeleteFields(30200210) ;

CALL DeleteFields(30201178) ;

CALL DeleteFields(250310070) ;

CALL DeleteFields(250415001) ;

CALL DeleteFields(250415002) ;

CALL DeleteFields(250415003) ;

CALL DeleteFields(250415004) ;

CALL DeleteFields(250415005) ;

CALL DeleteFields(250415006) ;

CALL DeleteFields(250415007) ;

CALL DeleteFields(250415008) ;

CALL DeleteFields(250415009) ;

CALL DeleteFields(250415011) ;

CALL DeleteFields(250415012) ;

CALL DeleteFields(250415013) ;

CALL DeleteFields(250415014) ;

CALL DeleteFields(250415015) ;

CALL DeleteFields(250410117) ;

CALL DeleteFields(250410118) ;

CALL DeleteFields(250410119) ;

CALL DeleteFields(250415157) ;

CALL DeleteFields(370110006) ;

CALL DeleteFields(370110007) ;

CALL DeleteFields(370110012) ;

CALL DeleteFields(370110020) ;

CALL DeleteFields(370110023) ;

CALL DeleteFields(370110021) ;

CALL DeleteFields(370110026) ;

CALL DeleteFields(520110035) ;

CALL DeleteFields(520110037) ;

CALL DeleteFields(520110038) ;

CALL DeleteFields(520110063) ;

CALL DeleteFields(960111005) ;

CALL DeleteFields(990510026) ;

CALL DeleteFields(990510027) ;

CALL DeleteFields(990510028) ;

CALL DeleteFields(990510029) ;

CALL DeleteFields(990510030) ;

--    , (1)
CALL ImportField(10111008, '', 'KVSR', '', ' ', 1, 101, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10111009, '()', 'KFSR', '', ' ', 1, 101, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10111010, '', 'KCSR', '', ' ', 1, 101, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10111011, '', 'KVR', '', ' ', 1, 101, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10111012, '', 'KESR', '', ' ', 1, 101, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10111019, '', 'SUBKESR', '', ' ', 1, 101, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10111044, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10111181, '()', 'KCSRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10111182, '()', 'KVRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10111183, '()', 'KVSRCode', '()', ' ', 1, 101, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10111223, '()', 'KESRCODE', '()', ' ', 1, 101, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10111226, '()', 'SUBKESRCode', '()', ' ', 1, 101, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10112049, '', 'KESR', '', ' ', 1, 101, 2, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10112050, '()', 'KFSR', '', ' ', 1, 101, 2, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10112051, '', 'KCSR', '', ' ', 1, 101, 2, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10112052, '', 'KVSR', '', ' ', 1, 101, 2, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10112053, '', 'KVR', '', ' ', 1, 101, 2, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10112054, '', 'SUBKESR', '', ' ', 1, 101, 2, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10112078, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 2, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10112214, '()', 'KCSRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10112215, '()', 'KVRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10112216, '()', 'KVSRCode', '()', ' ', 1, 101, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10112224, '()', 'KESRCODE', '()', ' ', 1, 101, 2, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10112227, '()', 'SUBKESRCode', '()', ' ', 1, 101, 2, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10113107, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 3, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(10114111, '', 'KESR', '', ' ', 1, 101, 4, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(10114112, '', 'KFSR', '', ' ', 1, 101, 4, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(10114113, '', 'KCSR', '', ' ', 1, 101, 4, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(10114114, '', 'KVSR', '', ' ', 1, 101, 4, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(10114115, '', 'KVR', '', ' ', 1, 101, 4, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(10114116, '', 'SUBKESR', '', ' ', 1, 101, 4, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(10114136, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 4, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(10114216, '', 'KCSRCode', '', ' ', 1, 101, 4, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(10114217, '', 'KVRCode', '', ' ', 1, 101, 4, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(10114218, '', 'KVSRCode', '', ' ', 1, 101, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(10114225, '()', 'KESRCODE', '()', ' ', 1, 101, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(10114228, '()', 'SUBKESRCode', '()', ' ', 1, 101, 4, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(10115156, ' ', 'BuhOperationCLS', ' ', ' ', 1, 101, 5, 0, '', 0, 17720, 0, 0, '') ;

--   (), (1)
CALL ImportField(20010005, '()', '{("")}', ' ', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010015, '', 'AUTO_AUTORIZATION', '', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010016, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010017, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010018, '  ()', 'CREATEDATE', '  ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20010019, '  ()', 'ProgIndex', '  ()', ' ', 1, 200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011016, ' ', '{("")}', ' ', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011018, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011019, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011020, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011021, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011022, '', '{("")}', ' ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011023, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011024, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011025, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011042, ' ', '{("")}', ' ', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011043, ' ', '{("")}', '  ()', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20011044, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 200, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20011045, '', 'AUTO_AUTORIZATION', '', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011046, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011047, '  ()', 'CREATEDATE', '  ()', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011048, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20011050, '', '{("")}', '', ' ', 1, 200, 1, 0, '', 0, null, 0, 0, '') ;

--    (), (1)
CALL ImportField(20110001, ' ', 'Dat', ' ', 'Dat', 1, 201, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20110002, ' ', 'Id', ' ', 'Id', 1, 201, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20110003, ' ', 'DocDat', ' ', 'DocDat', 1, 201, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20110004, '()', 'Note', '', 'Note', 1, 201, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20110007, '', 'NotifyType', ' ', 'NotifyType', 1, 201, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20110008, '', 'BudgetRef', '', 'BudgetRef', 1, 201, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20110009, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 201, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20110010, '', 'Variant', '', 'Variant', 1, 201, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20110011, '', 'Number', '', 'Number', 1, 201, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20110012, ' ', 'DocNumber', ' ', 'DocNumber', 1, 201, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20110014, ' ', 'DateInput', ' ', 'DateInput', 1, 201, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20110015, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 1, 201, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20110016, '  ', 'RejectCls', ' ', 'RejectCls', 1, 201, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20110017, '  ()', 'RejectCause', ' ()', 'RejectCause', 1, 201, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20110018, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 201, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20110019, ' ', ' ', ' ', 'StimateId', 1, 201, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(20110021, '', 'DocStateRef', ' ', 'DocStateRef', 1, 201, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20110022, ' ', 'OrgName', ' ', 'DestOrgName', 1, 201, 0, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20110026, '  ', 'SenderId', '  ', 'SenderId', 1, 201, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20110027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 1, 201, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20110029, '  ', ' ', '  ', 'SoftRejectCls', 1, 201, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(20110030, '  ()', ' ', '  ()', 'SoftRejectCause', 1, 201, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(20110058, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 1, 201, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(20110069, ' ', 'AssignmentSource', '  ', 'ASSIGNMENTSOURCE', 1, 201, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20110076, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 1, 201, 0, 0, '_', 0, 17502, 0, 1, '_') ;

CALL ImportField(20110081, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 201, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20110082, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 201, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20110083, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20110084, '', 'AUTO_AUTORIZATION', '', ' ', 1, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20110085, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20110086, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20110087, '  ()', 'CREATEDATE', '  ()', ' ', 1, 201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111001, ' ', 'Id', ' ', 'Id', 1, 201, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20111004, '', 'Kvsr', '', 'DestKvsrKey', 1, 201, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20111005, '', 'Kvr', '', 'DestKvrKey', 1, 201, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20111006, '()', 'Kfsr', '', 'DestKfsr', 1, 201, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20111007, '', 'Kesr', '', 'DestKesrKey', 1, 201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20111008, '', 'KCSR', '', 'DestKcsrKey', 1, 201, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20111009, '', 'SubKesr', '', 'DestSubKesrKey', 1, 201, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20111011, '', 'FactCode', '', 'DestFactCls', 1, 201, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20111012, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 1, 201, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20111014, ' ', '', ' ', 'DestFacialAccClsName', 1, 201, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(20111015, '/ ', 'FacialCode', '  ', 'DestFacialAccClsFacialCode', 1, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20111019, ' ()', 'Org_Ref', '  . .', 'Org_Ref_Det', 1, 201, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20111020, ' ', 'RecordIndex', '  ', 'RecordIndex', 1, 201, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20111022, '  ', 'SenderId', '  ', 'SenderId', 1, 201, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20111023, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 1, 201, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(20111024, '', 'Month01', '', 'Month01', 1, 201, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20111025, '', 'Month02', '', 'Month02', 1, 201, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20111026, '', 'Month03', '', 'Month03', 1, 201, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20111027, '', 'Month04', '', 'Month04', 1, 201, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20111028, '', 'Month05', '', 'Month05', 1, 201, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20111029, '', 'Month06', '', 'Month06', 1, 201, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20111030, '', 'Month07', '', 'Month07', 1, 201, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20111031, '', 'Month08', '', 'Month08', 1, 201, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20111032, '', 'Month09', '', 'Month09', 1, 201, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20111033, '', 'Month10', '', 'Month10', 1, 201, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20111034, '', 'Month11', '', 'Month11', 1, 201, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20111035, '', 'Month12', '', 'Month12', 1, 201, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20111036, ' 1', 'Quarter1', '1', 'Quarter1', 1, 201, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20111037, ' 2', 'Quarter2', '2', 'Quarter2', 1, 201, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20111038, ' 3', 'Quarter3', '3', 'Quarter3', 1, 201, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20111039, ' 4', 'Quarter4', '4', 'Quarter4', 1, 201, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20111048, '()', 'NAME', '', ' ', 1, 201, 1, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(20111049, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 201, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20111050, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 201, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20111051, '', 'OrgNameAndAcc', '', ' ', 1, 201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20111055, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 201, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20111064, ' () ', 'KVRCORR', ' () ', 'KVRCORRKey', 1, 201, 1, 1, '', 0, 17461, 0, 1, '') ;

CALL ImportField(20111068, ' ', 'AssignmentKind', '  ', 'ASSIGNMENTKIND', 1, 201, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20111075, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 201, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20111080, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 201, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20111082, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 201, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20111083, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 201, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20111084, '', 'KCSRCode', '()', 'DestKcsr', 1, 201, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20111085, '()', 'KVRCode', '()', 'DestKvr', 1, 201, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20111086, '()', 'KVSRCode', '()', 'DestKvsr', 1, 201, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20111088, ' ', 'ClsType', ' ', 'ClsType', 1, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20111089, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 201, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20111090, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 201, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20111092, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 201, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20111093, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 201, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20111094, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 201, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20111095, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 201, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20111096, ' ()', 'TransfertOrg_Name', ' ()', 'TransfertOrgName', 1, 201, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20111097, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 1, 201, 1, 1, '', 0, 29463, 0, 1, '') ;

CALL ImportField(20111181, ' ()', 'TransfertOrg_INN', ' ()', 'TransfertOrgINN', 1, 201, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(20111182, ' ()', 'TransfertOrg_INN20', ' ()', 'TransfertOrgKPP', 1, 201, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(20111183, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 1, 201, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20111184, ' ()', 'Fact', '', 'DestFactClsKey', 1, 201, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20111185, ' .  ()', 'FINTYPE', '  ', 'DestFinTypeClsKey', 1, 201, 1, 1, ',', 0, 17425, 0, 1, '') ;

CALL ImportField(20111186, '', 'InvestObject', '', 'InvestObjectKey', 1, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20111187, '', 'InvestObjectCode', '', 'InvestObject', 1, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20111193, ' ()', 'KVRCORRCode', ' ()', 'KVRCORR', 1, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20111194, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20111195, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20111198, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 201, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20111199, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 201, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20111200, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 201, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20111201, '', 'AUTO_AUTORIZATION', '', ' ', 1, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111202, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111203, '  ()', 'CREATEDATE', '  ()', ' ', 1, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111204, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20111205, '()', 'KESRCODE', '()', 'DestKesr', 1, 201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20111207, '()', 'SubKesrCode', '()', 'DestSubKesr', 1, 201, 1, 0, '', 0, 43610, 0, 1, '') ;

--  (), (1)
CALL ImportField(20210001, '', 'NUMBER', '', 'Number', 1, 202, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20210010, '', 'Variant', '', 'Variant', 1, 202, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20210012, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 202, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20210013, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 202, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20210014, ' ', 'DOCDAT', ' ', 'DocDat', 1, 202, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20210015, ' ', 'DateInput', ' ', 'DateInput', 1, 202, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20210016, ' ', 'DAT', ' ', 'Dat', 1, 202, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20210020, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 202, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20210023, '', 'BUDGETREF', '', 'BudgetRef', 1, 202, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20210025, ' ', 'ID', ' ', 'Id', 1, 202, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20210034, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 202, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20210037, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 202, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20210039, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 1, 202, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20210040, '()', 'NOTE', '()', 'Note', 1, 202, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20210044, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 202, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20210045, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 202, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20210066, '', 'DocStateRef', '', 'DocStateRef', 1, 202, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20210069, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 202, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20210082, '  ', 'SenderID', '  ', 'SenderId', 1, 202, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20210084, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 1, 202, 0, 0, '_', 0, 17502, 0, 1, '_') ;

CALL ImportField(20210089, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 202, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20210090, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 202, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20210091, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 202, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20210092, '', 'AUTO_AUTORIZATION', '', ' ', 1, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20210093, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20210094, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20210095, '  ()', 'CREATEDATE', '  ()', ' ', 1, 202, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20211004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20211009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 202, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20211011, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 202, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20211018, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 202, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20211021, '', 'KVR', '()', 'DestKvrKey', 1, 202, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20211022, '', 'KVSR', '()', 'DestKvsrKey', 1, 202, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20211026, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 202, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20211027, ' ', 'ID', ' ', 'Id', 1, 202, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20211030, '()', 'KFSR', '()', 'DestKfsr', 1, 202, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20211031, '', 'KCSR', '()', 'DestKcsrKey', 1, 202, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20211032, '', 'KESR', '', 'DestKesrKey', 1, 202, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20211033, '  ', 'FACIALACC_CLS', '  ', 'DestFacialAccCls', 1, 202, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20211035, '', 'FACTCODE', '()', 'DestFactCls', 1, 202, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20211036, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 202, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20211038, '  ()', 'Org_Ref', '', 'Org_Ref_Det', 1, 202, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20211047, '', 'Month08', '', 'Month08', 1, 202, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20211048, '', 'Month04', '', 'Month04', 1, 202, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20211049, '', 'Month12', '', 'Month12', 1, 202, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20211050, '', 'Month07', '', 'Month07', 1, 202, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20211051, '', 'Month06', '', 'Month06', 1, 202, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20211052, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 202, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20211053, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 202, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20211054, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 202, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20211055, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 202, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20211056, '', 'Month05', '', 'Month05', 1, 202, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20211057, '', 'Month03', '', 'Month03', 1, 202, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20211058, '', 'Month11', '', 'Month11', 1, 202, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20211059, '', 'Month10', '', 'Month10', 1, 202, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20211060, '', 'Month09', '', 'Month09', 1, 202, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20211061, '', 'Month02', '', 'Month02', 1, 202, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20211062, '', 'Month01', '', 'Month01', 1, 202, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20211067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 202, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20211070, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 202, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20211083, '  ', 'SenderID', '  ', 'SenderId', 1, 202, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20211088, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 202, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20211090, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 202, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20211091, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 202, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20211092, '()', 'KCSRCode', '()', 'DestKcsr', 1, 202, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20211093, '()', 'KVRCode', '()', 'DestKvr', 1, 202, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20211094, '()', 'KVSRCode', '()', 'DestKvsr', 1, 202, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20211096, ' ', 'ClsType', '', 'ClsType', 1, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20211097, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 202, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20211098, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 202, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20211100, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 202, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20211101, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 202, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20211102, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 202, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20211103, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 202, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20211105, '()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 202, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20211106, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 202, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20211108, '', 'InvestObjectCode', '', 'InvestObject', 1, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20211109, '', 'InvestObject', '', 'InvestObjectKey', 1, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20211111, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 202, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20211112, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 202, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20211115, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 202, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20211116, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 202, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20211117, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 202, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20211118, '', 'AUTO_AUTORIZATION', '', ' ', 1, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20211119, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20211120, '  ()', 'CREATEDATE', '  ()', ' ', 1, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20211121, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 202, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20211143, ' ()', 'TransfertOrg_INN', ' ()', 'TransfertOrgINN', 1, 202, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(20211144, ' ()', 'TransfertOrg_INN20', ' ()', 'TransfertOrgKPP', 1, 202, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(20211145, ' ()', 'TransfertOrg_Name', ' ()', 'TransfertOrgName', 1, 202, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20211146, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 1, 202, 1, 1, '', 0, 29463, 0, 1, '') ;

CALL ImportField(20211149, ' ()', 'TransfertOrg_CalcName', ' () ( )', ' ', 1, 202, 1, 0, '', 1, null, 0, 0, '') ;

CALL ImportField(20211150, '()', 'KESRCODE', '()', 'DestKesr', 1, 202, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20211152, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 202, 1, 0, '', 0, 43610, 0, 1, '') ;

--   (), (1)
CALL ImportField(20310001, '', 'NUMBER', '', 'Number', 1, 203, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20310010, '', 'Variant', '', 'Variant', 1, 203, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20310012, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 203, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20310013, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 203, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20310014, ' ', 'DOCDAT', ' ', 'DocDat', 1, 203, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20310015, ' ', 'DateInput', ' ', 'DateInput', 1, 203, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20310016, ' ', 'DAT', ' ', 'Dat', 1, 203, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20310020, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 203, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20310023, '', 'BUDGETREF', '', 'BudgetRef', 1, 203, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20310025, ' ', 'ID', ' ', 'Id', 1, 203, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20310034, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 203, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20310037, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 203, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20310039, '  ()', 'OrgRef', ' ', 'DestOrgRef', 1, 203, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20310040, '()', 'NOTE', '()', 'Note', 1, 203, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20310044, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 203, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20310045, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 203, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20310066, '', 'DocStateRef', '', 'DocStateRef', 1, 203, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20310069, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 203, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20310073, '  ', 'SenderID', '  ', 'SenderId', 1, 203, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20310074, '', 'KPPERIOD', '', 'KPPeriod', 1, 203, 0, 1, '', 0, 24700, 0, 1, '') ;

CALL ImportField(20310080, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 203, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20310081, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 203, 0, 1, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20310082, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 203, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20310083, '', 'AUTO_AUTORIZATION', '', ' ', 1, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20310084, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20310085, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20310086, '  ()', 'CREATEDATE', '  ()', ' ', 1, 203, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20311004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20311009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 203, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20311011, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 203, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20311018, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 203, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20311021, '', 'KVR', '()', 'DestKvrKey', 1, 203, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20311022, '', 'KVSR', '()', 'DestKvsrKey', 1, 203, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20311026, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 203, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20311027, ' ', 'ID', ' ', 'Id', 1, 203, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20311030, '()', 'KFSR', '()', 'DestKfsr', 1, 203, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20311031, '', 'KCSR', '()', 'DestKcsrKey', 1, 203, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20311032, '', 'KESR', '', 'DestKesrKey', 1, 203, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20311033, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 203, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20311035, '', 'FACTCODE', '()', 'DestFactCls', 1, 203, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20311036, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 203, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20311038, '', 'Org_Ref', '', 'Org_Ref_Det', 1, 203, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20311047, '', 'Month08', '', 'Month08', 1, 203, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20311048, '', 'Month04', '', 'Month04', 1, 203, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20311049, '', 'Month12', '', 'Month12', 1, 203, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20311050, '', 'Month07', '', 'Month07', 1, 203, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20311051, '', 'Month06', '', 'Month06', 1, 203, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20311052, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 203, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20311053, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 203, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20311054, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 203, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20311055, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 203, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20311056, '', 'Month05', '', 'Month05', 1, 203, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20311057, '', 'Month03', '', 'Month03', 1, 203, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20311061, '', 'Month11', '', 'Month11', 1, 203, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20311062, '', 'Month10', '', 'Month10', 1, 203, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20311063, '', 'Month09', '', 'Month09', 1, 203, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20311064, '', 'Month02', '', 'Month02', 1, 203, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20311065, '', 'Month01', '', 'Month01', 1, 203, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20311067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 203, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20311070, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 203, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20311074, '  ', 'SenderID', '  ', 'SenderId', 1, 203, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20311079, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 203, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20311081, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 203, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20311082, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 203, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20311083, '()', 'KCSRCode', '()', 'DestKcsr', 1, 203, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20311084, '()', 'KVRCode', '()', 'DestKvr', 1, 203, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20311085, '()', 'KVSRCode', '()', 'DestKvsr', 1, 203, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20311087, ' ', 'ClsType', ' ', 'ClsType', 1, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20311089, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 203, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20311090, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 203, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20311091, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 203, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20311092, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 203, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20311093, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 203, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20311094, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 203, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20311095, '()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 203, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20311096, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 203, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20311098, '', 'InvestObjectCode', '', 'InvestObject', 1, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20311099, '', 'InvestObject', '', 'InvestObjectKey', 1, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20311101, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 203, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20311102, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 203, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20311103, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 203, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20311104, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 203, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20311105, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 203, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20311106, '', 'AUTO_AUTORIZATION', '', ' ', 1, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20311107, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20311108, '  ()', 'CREATEDATE', '  ()', ' ', 1, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20311109, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 203, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20311159, '()', 'KESRCODE', '()', 'DestKesr', 1, 203, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20311161, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 203, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , , (1)
CALL ImportField(20410001, '', 'NUMBER', '', 'Number', 1, 204, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20410010, '', 'Variant', '', 'Variant', 1, 204, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20410012, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 204, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20410013, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 204, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20410014, ' ', 'DOCDAT', ' ', 'DocDat', 1, 204, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20410015, ' ', 'DateInput', ' ', 'DateInput', 1, 204, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20410016, ' ', 'DAT', ' ', 'Dat', 1, 204, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20410020, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 204, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20410023, '', 'BUDGETREF', '', 'BudgetRef', 1, 204, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20410025, ' ', 'ID', ' ', 'Id', 1, 204, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20410034, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 204, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20410037, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 204, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20410039, ' ()', 'OrgRef', ' ', 'DestOrgRef', 1, 204, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20410040, '()', 'NOTE', '()', 'Note', 1, 204, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20410044, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 204, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20410045, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 204, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20410066, '', 'DocStateRef', '', 'DocStateRef', 1, 204, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20410069, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 204, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20410081, '  ', 'SenderID', '  ', 'SenderId', 1, 204, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20410084, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 204, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20410086, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 204, 0, 1, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20410087, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 204, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20410088, '', 'AUTO_AUTORIZATION', '', ' ', 1, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20410089, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20410090, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20410091, '  ()', 'CREATEDATE', '  ()', ' ', 1, 204, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20411004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20411009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 204, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20411011, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 204, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20411018, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 204, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20411019, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 1, 204, 1, 0, '', 0, 17456, 0, 1, '') ;

CALL ImportField(20411021, '', 'KVR', '()', 'DestKvrKey', 1, 204, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20411022, '', 'KVSR', '()', 'DestKvsrKey', 1, 204, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20411026, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 204, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20411027, ' ', 'ID', ' ', 'Id', 1, 204, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20411030, '()', 'KFSR', '()', 'DestKfsr', 1, 204, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20411031, '', 'KCSR', '()', 'DestKcsrKey', 1, 204, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20411032, '', 'KESR', '', 'DestKesrKey', 1, 204, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20411033, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 204, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20411035, '', 'FACTCODE', '()', 'DestFactCls', 1, 204, 1, 0, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20411036, '', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 1, 204, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20411038, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 1, 204, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20411047, '', 'Month08', '', 'Month08', 1, 204, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20411048, '', 'Month04', '', 'Month04', 1, 204, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20411049, '', 'Month12', '', 'Month12', 1, 204, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20411050, '', 'Month07', '', 'Month07', 1, 204, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20411051, '', 'Month06', '', 'Month06', 1, 204, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20411052, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 204, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20411053, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 204, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20411054, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 204, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20411055, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 204, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20411056, '', 'Month05', '', 'Month05', 1, 204, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20411057, '', 'Month03', '', 'Month03', 1, 204, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20411061, '', 'Month11', '', 'Month11', 1, 204, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20411062, '', 'Month10', '', 'Month10', 1, 204, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20411063, '', 'Month09', '', 'Month09', 1, 204, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20411064, '', 'Month02', '', 'Month02', 1, 204, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20411065, '', 'Month01', '', 'Month01', 1, 204, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20411067, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 204, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20411070, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 204, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20411082, '  ', 'SenderID', '  ', 'SenderId', 1, 204, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20411083, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 204, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20411085, '  ()', 'TransfertCls', '   ()', 'TransfertCls', 1, 204, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20411086, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 204, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20411087, ' ', 'ClsType', ' ', 'ClsType', 1, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20411090, ' ()', 'DescriptionCode', ' ()', 'DescriptionCode', 1, 204, 1, 0, '', 0, 16831, 0, 1, '') ;

CALL ImportField(20411091, ' ', 'IFS', ' ', 'IFS', 1, 204, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(20411092, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 204, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(20411093, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 204, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(20411094, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 204, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20411095, '()', 'KCSRCode', '()', 'DestKcsr', 1, 204, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20411096, '', 'KD', '', 'KD', 1, 204, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(20411097, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 204, 1, 0, '', 0, 38908, 0, 1, '') ;

CALL ImportField(20411098, ' ()', 'KDKVSRCode', ' ()', 'KDKVSRCode', 1, 204, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20411099, '()', 'KVRCode', '()', 'DestKvr', 1, 204, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20411100, '()', 'KVSRCode', '()', 'DestKvsr', 1, 204, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20411101, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 204, 1, 0, '', 0, 16834, 0, 1, '') ;

CALL ImportField(20411104, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 204, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20411105, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 204, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20411106, ' ', 'KDValue', ' ', 'KDValue', 1, 204, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(20411108, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 204, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20411109, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 204, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20411110, '  ', 'SubsidyClsOldCode', '', 'SubsidyClsOldCode', 1, 204, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20411111, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 204, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20411112, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 204, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20411113, '  ', 'SubsidyClsOld', '', 'SubsidyClsOld', 1, 204, 1, 1, '', 0, 27836, 0, 1, '') ;

CALL ImportField(20411114, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 204, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20411115, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 204, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20411117, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 204, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(20411118, '', 'InvestObjectCode', '', 'InvestObject', 1, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20411119, '', 'InvestObject', '', 'InvestObjectKey', 1, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20411120, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 204, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20411121, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 204, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20411124, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 204, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20411125, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 204, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20411126, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 204, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20411127, '', 'AUTO_AUTORIZATION', '', ' ', 1, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20411128, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20411129, '  ()', 'CREATEDATE', '  ()', ' ', 1, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20411130, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 204, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20411151, '()', 'KESRCODE', '()', 'DestKesr', 1, 204, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20411152, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 204, 1, 0, '', 0, 43610, 0, 1, '') ;

-- , (1)
CALL ImportField(20510001, '', 'NUMBER', '', 'Number', 1, 205, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20510011, '', 'Variant', '', 'Variant', 1, 205, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20510013, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 205, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20510014, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 205, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20510015, ' ', 'DOCDAT', ' ', 'DocDat', 1, 205, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20510016, ' ', 'DateInput', ' ', 'DateInput', 1, 205, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20510017, ' ', 'DAT', ' ', 'Dat', 1, 205, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20510021, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 205, 0, 1, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20510024, '', 'BUDGETREF', '', 'BudgetRef', 1, 205, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20510026, ' ', 'ID', ' ', 'Id', 1, 205, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20510035, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 205, 0, 1, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20510038, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 205, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20510040, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 205, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20510041, '()', 'NOTE', '()', 'Note', 1, 205, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20510045, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 205, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20510046, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 205, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20510064, '', 'DocStateRef', '', 'DocStateRef', 1, 205, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20510067, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 205, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20510071, '  ', 'SenderID', '  ', 'SenderId', 1, 205, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20510085, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 205, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20510089, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 205, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20510090, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 205, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20510091, '', 'AUTO_AUTORIZATION', '', ' ', 1, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20510092, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20510093, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20510094, '  ()', 'CREATEDATE', '  ()', ' ', 1, 205, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20511007, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 205, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20511012, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 205, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20511019, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 205, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20511022, '', 'KVR', '()', 'DestKvrKey', 1, 205, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20511023, '', 'KVSR', '()', 'DestKvsrKey', 1, 205, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20511027, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 205, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20511028, ' ', 'ID', ' ', 'Id', 1, 205, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20511031, '()', 'KFSR', '()', 'DestKfsr', 1, 205, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20511032, '', 'KCSR', '()', 'DestKcsrKey', 1, 205, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20511033, '', 'KESR', '', 'DestKesrKey', 1, 205, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20511034, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 205, 1, 1, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20511036, '', 'FACTCODE', '', 'DestFactCls', 1, 205, 1, 0, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20511037, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 205, 1, 0, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20511039, '', 'Org_ref', '', 'Org_Ref_Det', 1, 205, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20511048, '', 'Month08', '', 'Month08', 1, 205, 1, 1, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20511049, '', 'Month04', '', 'Month04', 1, 205, 1, 1, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20511050, '', 'Month12', '', 'Month12', 1, 205, 1, 1, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20511051, '', 'Month07', '', 'Month07', 1, 205, 1, 1, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20511052, '', 'Month06', '', 'Month06', 1, 205, 1, 1, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20511053, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 205, 1, 1, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20511054, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 205, 1, 1, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20511055, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 205, 1, 1, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20511056, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 205, 1, 1, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20511057, '', 'Month05', '', 'Month05', 1, 205, 1, 1, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20511058, '', 'Month03', '', 'Month03', 1, 205, 1, 1, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20511059, '', 'Month11', '', 'Month11', 1, 205, 1, 1, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20511060, '', 'Month10', '', 'Month10', 1, 205, 1, 1, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20511061, '', 'Month09', '', 'Month09', 1, 205, 1, 1, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20511062, '', 'Month02', '', 'Month02', 1, 205, 1, 1, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20511063, '', 'Month01', '', 'Month01', 1, 205, 1, 1, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20511065, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 205, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20511068, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 205, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20511069, ' . ', 'FINTYPECode', '  ', 'DestFINTYPECls', 1, 205, 1, 0, ',', 0, 36853, 0, 0, '') ;

CALL ImportField(20511072, '  ', 'SenderID', '  ', 'SenderId', 1, 205, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20511073, ' ()', 'DescriptionCode', ' ()', 'DescriptionCode', 1, 205, 1, 0, '', 0, 16831, 0, 1, '') ;

CALL ImportField(20511074, ' ', 'IFS', ' ', 'IFS', 1, 205, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(20511075, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 205, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(20511076, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 205, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(20511077, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 205, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20511078, '', 'KD', '', 'KD', 1, 205, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(20511079, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 205, 1, 0, '', 0, 38908, 0, 1, '') ;

CALL ImportField(20511080, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 205, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20511081, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 205, 1, 0, '', 0, 16834, 0, 1, '') ;

CALL ImportField(20511082, '.  ', 'SubKD', '.  ', 'SubKD', 1, 205, 1, 0, '', 0, 25271, 0, 1, '') ;

CALL ImportField(20511084, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 205, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20511086, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 205, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20511087, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 205, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20511090, '()', 'KCSRCode', '()', 'DestKcsr', 1, 205, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20511092, '()', 'KVRCode', '()', 'DestKvr', 1, 205, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20511093, '()', 'KVSRCode', '()', 'DestKvsr', 1, 205, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20511094, ' ', 'ClsType', ' ', 'ClsType', 1, 205, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20511095, ' ', 'KDValue', ' ', 'KDValue', 1, 205, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(20511096, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 205, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20511097, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 205, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20511098, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 205, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20511099, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 205, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20511101, ' .  ()', 'FINTYPE', '  ', 'DestFINTYPEClsKey', 1, 205, 1, 1, ',', 0, 17425, 0, 0, '') ;

CALL ImportField(20511102, ' ()', 'DirectionCLS', ' ()', 'DestDirectionCLSKey', 1, 205, 1, 1, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20511103, ' ()', 'FACT', '', 'DestFactClsKey', 1, 205, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20511104, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 205, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(20511105, '', 'InvestObjectCode', '', 'InvestObject', 1, 205, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20511106, '', 'InvestObject', '', 'InvestObjectKey', 1, 205, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20511107, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 205, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20511108, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 205, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20511111, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 205, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20511112, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 205, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20511113, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 205, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20511114, '', 'AUTO_AUTORIZATION', '', ' ', 1, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20511115, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20511116, '  ()', 'CREATEDATE', '  ()', ' ', 1, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20511117, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 205, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20511118, '()', 'KESRCODE', '()', 'DestKesr', 1, 205, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20511119, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 205, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), (1)
CALL ImportField(20610001, '', 'NUMBER', '', 'Number', 1, 206, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20610011, '', 'Variant', '', 'Variant', 1, 206, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20610013, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 206, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20610014, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 206, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20610015, ' ', 'DOCDAT', ' ', 'DocDat', 1, 206, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20610016, ' ', 'DateInput', ' ', 'DateInput', 1, 206, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20610017, ' ', 'DAT', ' ', 'Dat', 1, 206, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20610021, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 206, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20610024, '', 'BUDGETREF', '', 'BudgetRef', 1, 206, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20610026, ' ', 'ID', ' ', 'Id', 1, 206, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20610035, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 206, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20610038, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 206, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20610040, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 206, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20610041, '()', 'NOTE', '()', 'Note', 1, 206, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20610045, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 206, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20610046, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 206, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20610067, '', 'DocStateRef', '', 'DocStateRef', 1, 206, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20610070, ' ', 'DocBaseCODE', ' ', 'DocBase', 1, 206, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20610081, '  ', 'SenderID', '  ', 'SenderId', 1, 206, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20610082, '', 'KPPERIOD', '', 'KPPeriod', 1, 206, 0, 0, '', 0, 24700, 0, 1, '') ;

CALL ImportField(20610088, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 206, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20610089, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 206, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20610090, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 206, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20610091, '', 'AUTO_AUTORIZATION', '', ' ', 1, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20610092, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20610093, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20610094, '  ()', 'CREATEDATE', '  ()', ' ', 1, 206, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20611004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20611010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 206, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20611012, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 206, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20611019, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 206, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20611022, '', 'KVR', '()', 'DestKvrKey', 1, 206, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20611023, '', 'KVSR', '()', 'DestKvsrKey', 1, 206, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20611027, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 206, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20611028, ' ', 'ID', ' ', 'Id', 1, 206, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20611031, '()', 'KFSR', '()', 'DestKfsr', 1, 206, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20611032, '', 'KCSR', '()', 'DestKcsrKey', 1, 206, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20611033, '', 'KESR', '', 'DestKesrKey', 1, 206, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20611034, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 206, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20611036, '', 'FACTCODE', '()', 'DestFactCls', 1, 206, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20611037, '', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 1, 206, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20611039, '', 'Org_Ref', '', 'Org_Ref_Det', 1, 206, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20611048, '', 'Month08', '', 'Month08', 1, 206, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20611049, '', 'Month04', '', 'Month04', 1, 206, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20611050, '', 'Month12', '', 'Month12', 1, 206, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20611051, '', 'Month07', '', 'Month07', 1, 206, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20611052, '', 'Month06', '', 'Month06', 1, 206, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20611053, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 206, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(20611054, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 206, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(20611055, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 206, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(20611056, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 206, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(20611057, '', 'Month05', '', 'Month05', 1, 206, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20611058, '', 'Month03', '', 'Month03', 1, 206, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20611062, '', 'Month11', '', 'Month11', 1, 206, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20611063, '', 'Month10', '', 'Month10', 1, 206, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20611064, '', 'Month09', '', 'Month09', 1, 206, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20611065, '', 'Month02', '', 'Month02', 1, 206, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20611066, '', 'Month01', '', 'Month01', 1, 206, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20611068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 206, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20611071, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 206, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20611082, '  ', 'SenderID', '  ', 'SenderId', 1, 206, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20611087, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 206, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20611089, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 206, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20611090, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 206, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20611091, '()', 'KCSRCode', '()', 'DestKcsr', 1, 206, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20611092, '()', 'KVRCode', '()', 'DestKvr', 1, 206, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20611093, '()', 'KVSRCode', '()', 'DestKvsr', 1, 206, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20611095, ' ', 'ClsType', ' ', 'ClsType', 1, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20611096, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 206, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20611097, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 206, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20611099, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 206, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20611100, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 206, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20611101, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 206, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20611102, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 206, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20611103, ' ()', 'TransfertOrg_Name', '', 'TransfertOrgName', 1, 206, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20611104, ' ()', 'TransfertOrg_Ref', '', 'TransfertOrg_Ref', 1, 206, 1, 1, '', 0, 29463, 0, 1, '') ;

CALL ImportField(20611181, ' ()', 'TransfertOrg_INN', ' ()', 'TransfertOrgINN', 1, 206, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(20611182, ' ()', 'TransfertOrg_INN20', ' ()', 'TransfertOrgKPP', 1, 206, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(20611183, '', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 206, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20611184, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 206, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20611186, '', 'InvestObjectCode', '', 'InvestObject', 1, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20611187, '', 'InvestObject', '', 'InvestObjectKey', 1, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20611188, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 206, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20611189, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 206, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20611190, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 206, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20611191, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 206, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20611192, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 206, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20611193, '', 'AUTO_AUTORIZATION', '', ' ', 1, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20611194, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20611195, '  ()', 'CREATEDATE', '  ()', ' ', 1, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20611196, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 206, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20611199, '()', 'KESRCODE', '()', 'DestKesr', 1, 206, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20611201, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 206, 1, 0, '', 0, 43610, 0, 1, '') ;

--   , (1)
CALL ImportField(20710001, '', 'NUMBER', '', 'Number', 1, 207, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20710011, '', 'Variant', '', 'Variant', 1, 207, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20710013, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 207, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20710014, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 207, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20710015, ' ', 'DOCDAT', ' ', 'DocDat', 1, 207, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20710016, ' ', 'DateInput', ' ', 'DateInput', 1, 207, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20710017, ' ', 'DAT', ' ', 'Dat', 1, 207, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20710021, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 207, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20710024, '', 'BUDGETREF', '', 'BudgetRef', 1, 207, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20710026, ' ', 'ID', ' ', 'Id', 1, 207, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20710035, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 207, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20710038, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 207, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20710040, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 207, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20710041, '()', 'NOTE', '()', 'Note', 1, 207, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20710045, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 207, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20710046, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 207, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20710067, '', 'DocStateRef', '', 'DocStateRef', 1, 207, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20710070, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 207, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20710075, '  ', 'SenderID', '  ', 'SenderId', 1, 207, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20710158, ' ', 'ClsType', ' ', 'ClsType', 1, 207, 0, 0, '', 0, 24698, 0, 1, '') ;

CALL ImportField(20710159, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 207, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20710160, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 207, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20710161, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 207, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20710162, '', 'AUTO_AUTORIZATION', '', ' ', 1, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20710163, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20710164, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20710165, '  ()', 'CREATEDATE', '  ()', ' ', 1, 207, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20711004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20711010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 207, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20711012, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 207, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20711019, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 207, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20711020, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 1, 207, 1, 1, '', 0, 17456, 0, 1, '') ;

CALL ImportField(20711022, '', 'KVR', '()', 'DestKvrKey', 1, 207, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20711023, '', 'KVSR', '()', 'DestKvsrKey', 1, 207, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20711027, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 207, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20711028, ' ', 'ID', ' ', 'Id', 1, 207, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20711031, '()', 'KFSR', '()', 'DestKfsr', 1, 207, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20711032, '', 'KCSR', '()', 'DestKcsrKey', 1, 207, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20711033, '', 'KESR', '', 'DestKesrKey', 1, 207, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20711034, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 207, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20711036, '', 'FACTCODE', '()', 'DestFactCls', 1, 207, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20711037, '', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 1, 207, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20711039, '', 'Org_Ref', '', 'Org_Ref_Det', 1, 207, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20711048, '', 'Month08', '', 'Month08', 1, 207, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20711049, '', 'Month04', '', 'Month04', 1, 207, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20711050, '', 'Month12', '', 'Month12', 1, 207, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20711051, '', 'Month07', '', 'Month07', 1, 207, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20711052, '', 'Month06', '', 'Month06', 1, 207, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20711057, '', 'Month05', '', 'Month05', 1, 207, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20711058, '', 'Month03', '', 'Month03', 1, 207, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20711062, '', 'Month11', '', 'Month11', 1, 207, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20711063, '', 'Month10', '', 'Month10', 1, 207, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20711064, '', 'Month09', '', 'Month09', 1, 207, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20711065, '', 'Month02', '', 'Month02', 1, 207, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20711066, '', 'Month01', '', 'Month01', 1, 207, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20711068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 207, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20711071, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 207, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20711076, '  ', 'SenderID', '  ', 'SenderId', 1, 207, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20711077, ' ', 'ClsType', ' ', 'ClsType', 1, 207, 1, 1, '', 0, 17453, 0, 1, '') ;

CALL ImportField(20711078, ' ', 'IFS', ' ', 'IFS', 1, 207, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(20711079, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 207, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(20711080, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 207, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(20711081, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 207, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20711083, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 207, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20711160, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 207, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20711161, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 207, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20711163, '()', 'KCSRCode', '()', 'DestKcsr', 1, 207, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20711164, '()', 'KVRCode', '()', 'DestKvr', 1, 207, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20711165, '()', 'KVSRCode', '()', 'DestKvsr', 1, 207, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20711167, ' ()', 'DescriptionCode', ' ()', 'DescriptionCode', 1, 207, 1, 0, '', 0, 16831, 0, 1, '') ;

CALL ImportField(20711168, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 207, 1, 0, '', 0, 38908, 0, 1, '') ;

CALL ImportField(20711169, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 207, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20711170, ' ()', 'ProgramCode', ' ()', 'ProgramCode', 1, 207, 1, 0, '', 0, 16834, 0, 1, '') ;

CALL ImportField(20711171, '', 'KD', '', 'KD', 1, 207, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(20711173, ' ', 'StimateId', '', 'StimateId', 1, 207, 1, 1, '', 0, 17448, 0, 1, '') ;

CALL ImportField(20711174, ' ', 'KDValue', ' ', 'KDValue', 1, 207, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(20711176, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 207, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20711177, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 207, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20711178, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 207, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20711179, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 207, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20711180, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 207, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20711181, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 207, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20711182, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 207, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20711183, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 207, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20711185, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 207, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(20711186, '', 'InvestObjectCode', '', 'InvestObject', 1, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20711187, '', 'InvestObject', '', 'InvestObjectKey', 1, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20711188, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 207, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20711189, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 207, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20711190, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 207, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20711191, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 207, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20711192, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 207, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20711193, '', 'AUTO_AUTORIZATION', '', ' ', 1, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20711194, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20711195, '  ()', 'CREATEDATE', '  ()', ' ', 1, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20711196, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 207, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20711220, '()', 'KESRCODE', '()', 'DestKesr', 1, 207, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20711222, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 207, 1, 0, '', 0, 43610, 0, 1, '') ;

--    , (1)
CALL ImportField(20810001, '', 'NUMBER', '', 'Number', 1, 208, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(20810011, '', 'Variant', '', 'Variant', 1, 208, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(20810013, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 208, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(20810014, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 208, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(20810015, ' ', 'DOCDAT', ' ', 'DocDat', 1, 208, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(20810016, ' ', 'DateInput', ' ', 'DateInput', 1, 208, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(20810017, ' ', 'DAT', ' ', 'Dat', 1, 208, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(20810021, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 208, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(20810024, '', 'BUDGETREF', '', 'BudgetRef', 1, 208, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(20810026, ' ', 'ID', ' ', 'Id', 1, 208, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(20810035, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 208, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(20810038, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 208, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(20810040, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 208, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(20810041, '()', 'NOTE', '()', 'Note', 1, 208, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(20810045, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 208, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(20810046, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 208, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(20810067, '', 'DocStateRef', '', 'DocStateRef', 1, 208, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(20810070, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 208, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20810075, '  ', 'SenderID', '  ', 'SenderId', 1, 208, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(20810159, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 208, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20810160, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 208, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(20810161, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 208, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20810162, '', 'AUTO_AUTORIZATION', '', ' ', 1, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20810163, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20810164, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20810165, '  ()', 'CREATEDATE', '  ()', ' ', 1, 208, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20811004, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20811010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 208, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(20811012, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 208, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(20811019, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 208, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(20811020, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 1, 208, 1, 1, '', 0, 17456, 0, 1, '') ;

CALL ImportField(20811022, '', 'KVR', '()', 'DestKvrKey', 1, 208, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20811023, '', 'KVSR', '()', 'DestKvsrKey', 1, 208, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20811027, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 208, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20811028, ' ', 'ID', ' ', 'Id', 1, 208, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20811031, '()', 'KFSR', '()', 'DestKfsr', 1, 208, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20811032, '', 'KCSR', '()', 'DestKcsrKey', 1, 208, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20811033, '', 'KESR', '', 'DestKesrKey', 1, 208, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20811034, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 208, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20811036, '', 'FACTCODE', '()', 'DestFactCls', 1, 208, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20811037, '', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 208, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20811039, '', 'Org_Ref', '', 'Org_Ref_Det', 1, 208, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(20811048, '', 'Month08', '', 'Month08', 1, 208, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(20811049, '', 'Month04', '', 'Month04', 1, 208, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(20811050, '', 'Month12', '', 'Month12', 1, 208, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(20811051, '', 'Month07', '', 'Month07', 1, 208, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(20811052, '', 'Month06', '', 'Month06', 1, 208, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(20811057, '', 'Month05', '', 'Month05', 1, 208, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(20811058, '', 'Month03', '', 'Month03', 1, 208, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(20811062, '', 'Month11', '', 'Month11', 1, 208, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(20811063, '', 'Month10', '', 'Month10', 1, 208, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(20811064, '', 'Month09', '', 'Month09', 1, 208, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(20811065, '', 'Month02', '', 'Month02', 1, 208, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(20811066, '', 'Month01', '', 'Month01', 1, 208, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(20811068, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 208, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20811071, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 208, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20811076, '  ', 'SenderID', '  ', 'SenderId', 1, 208, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(20811077, ' ', 'ClsType', ' ', 'ClsType', 1, 208, 1, 1, '', 0, 17453, 0, 1, '') ;

CALL ImportField(20811078, ' ', 'IFS', ' ', 'IFS', 1, 208, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(20811079, ' ()', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20811080, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 208, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(20811081, '()', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 208, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20811082, '', 'KD', '', 'KD', 1, 208, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(20811162, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 208, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(20811163, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 208, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(20811164, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 208, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(20811166, '()', 'KCSRCode', '()', 'DestKcsr', 1, 208, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(20811167, '()', 'KVRCode', '()', 'DestKvr', 1, 208, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(20811168, '()', 'KVSRCode', '()', 'DestKvsr', 1, 208, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(20811170, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 208, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(20811171, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 208, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(20811172, '  ', 'KDValue', ' ', 'KDValue', 1, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20811174, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 208, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20811175, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 208, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20811176, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 208, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20811177, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 208, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20811178, ' ()', 'TransfertOrg_Ref', ' ()', 'TransfertOrg_Ref', 1, 208, 1, 1, '', 0, 29463, 0, 1, '') ;

CALL ImportField(20811179, ' ()', 'TransfertOrg_Name', ' ()', 'TransfertOrgName', 1, 208, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(20811181, ' ()', 'TransfertOrg_INN', ' ()', 'TransfertOrgINN', 1, 208, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(20811182, ' ()', 'TransfertOrg_INN20', ' ()', 'TransfertOrgKPP', 1, 208, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(20811184, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 208, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20811185, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 208, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20811186, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 208, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(20811187, '', 'InvestObjectCode', '', 'InvestObject', 1, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20811188, '', 'InvestObject', '', 'InvestObjectKey', 1, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20811189, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 208, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20811190, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 208, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20811191, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 208, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20811192, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 208, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20811193, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 208, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20811194, '', 'AUTO_AUTORIZATION', '', ' ', 1, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20811195, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20811196, '  ()', 'CREATEDATE', '  ()', ' ', 1, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20811197, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 208, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20811222, '()', 'KESRCODE', '()', 'DestKesr', 1, 208, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20811224, '()', 'SUBKESRCode', '()', 'DestSubKesr', 1, 208, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(20910001, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910002, '', 'BUDGETREF', '', 'BudgetRef', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910003, ' ', 'ClsType', ' ', 'ClsType', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910004, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20910005, ' ', 'DAT', ' ', 'Dat', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910006, ' ', 'DateInput', ' ', 'DateInput', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910007, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 209, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(20910009, ' ', 'DOCDAT', ' ', 'DocDat', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910010, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910011, '', 'DocStateRef', '', 'DocStateRef', 1, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20910012, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910014, '', 'KPPERIOD', '', 'KPPeriod', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910015, '()', 'NOTE', '()', 'note', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910018, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910019, '', 'NUMBER', '', 'Number', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910021, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20910022, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910023, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 209, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20910024, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910025, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910026, '', 'Variant', '', 'Variant', 1, 209, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20910027, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 209, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(20910028, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 209, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20910029, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 209, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(20910030, '', 'AUTO_AUTORIZATION', '', ' ', 1, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20910031, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20910032, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20910033, '  ()', 'CREATEDATE', '  ()', ' ', 1, 209, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20911001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911002, ' ()', 'CreateDate', ' ()', 'CreateDate_Det', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911003, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911004, '', 'DayPlan', '', 'DayPlan', 1, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20911005, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 1, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20911006, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 209, 1, 1, '', 0, 36861, 0, 1, '') ;

CALL ImportField(20911007, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 209, 1, 1, '', 0, 17419, 0, 1, '') ;

CALL ImportField(20911009, '', 'FACTCODE', '', 'DestFactCls', 1, 209, 1, 1, '', 0, 36863, 0, 1, '') ;

CALL ImportField(20911010, ' . ', 'FINTYPECode', '  ', 'DestFinTypeCls', 1, 209, 1, 1, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(20911012, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 209, 1, 1, '', 0, 38919, 0, 0, '') ;

CALL ImportField(20911014, '()', 'INN', '()', 'DestFacialAccClsOrgINN', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911015, '()', 'INN20', '()', 'DestFacialAccClsOrgKPP', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911016, '()', 'KCSRCode', '()', 'DestKcsr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911017, '', 'KESR', ' ()', 'DestKesrKey', 1, 209, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20911018, '()', 'KFSR', '()', 'DestKfsr', 1, 209, 1, 1, '', 0, 17411, 0, 1, '') ;

CALL ImportField(20911019, '()', 'KVRCode', '()', 'DestKvr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911020, '()', 'KVSRCode', '()', 'DestKvsr', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911021, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 209, 1, 1, '', 0, 17426, 0, 1, '') ;

CALL ImportField(20911022, '()', 'NAME', '()', 'DestFacialAccClsOrgName', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911023, '', 'NOTE', '', 'Note', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911025, ' ', 'REGIONCLS', ' ', 'RegionCLS', 1, 209, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(20911027, '', 'SUBKESR', '()', 'DestSubkesrKey', 1, 209, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(20911029, ' ()', 'UpdateDate', ' ()', 'UpdateDate_Det', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911030, '()', 'UpdaterUser', '()', 'UpdaterUser_det', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911031, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911032, ' ', 'ClsType', ' ', 'ClsType', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911041, ' ', 'ID', ' ', 'Id', 1, 209, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(20911134, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 209, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(20911135, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 209, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(20911136, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 209, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(20911138, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 209, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(20911139, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 209, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(20911140, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 1, 209, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(20911141, '   ', 'PayPromiseCls', '   ()', 'PayPromiseCls', 1, 209, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(20911142, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 209, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(20911143, ' ', 'IFS', '    ()', 'IFS', 1, 209, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(20911145, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 209, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(20911146, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20911147, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 209, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(20911148, '', 'KVR', '()', 'DestKvrKey', 1, 209, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(20911149, '', 'KVSR', '()', 'DestKvsrKey', 1, 209, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(20911150, '', 'KCSR', '()', 'DestKcsrKey', 1, 209, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(20911151, '', 'InvestObjectCode', '', 'InvestObject', 1, 209, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(20911152, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 209, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(20911153, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 209, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(20911154, '', 'AUTO_AUTORIZATION', '', ' ', 1, 209, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20911155, '()', 'KESRCODE', '()', 'DestKesr', 1, 209, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20911156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 209, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(20912016, '()', 'KCSRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912017, '', 'KESR', ' ()', 'DestKesrKey', 1, 209, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(20912018, '()', 'KFSR', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912019, '()', 'KVRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912020, '()', 'KVSRCode', '()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912027, '', 'SUBKESR', '()', 'DestSubkesrKey', 1, 209, 2, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(20912037, '', 'KCSR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912038, '', 'KVR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912039, '', 'KVSR', ' ()', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912044, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 209, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(20912045, ' ', 'BudAllocationClsCode', ' ', ' ', 1, 209, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(20912046, '  ', 'PayPromiseClsCode', '  ', ' ', 1, 209, 2, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(20912047, ' ', 'TargetCls', '  ()', ' ', 1, 209, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(20912048, ' ', 'TargetClsCode', ' ', ' ', 1, 209, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(20912155, '()', 'KESRCODE', '()', 'DestKesr', 1, 209, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(20912156, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 209, 2, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(21010001, '', 'ANUMBER', '', 'Number', 1, 210, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21010002, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 210, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(21010003, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 1, 210, 0, 0, '_', 0, 17502, 0, 1, '_') ;

CALL ImportField(21010004, '', 'BUDGETREF', '', 'BudgetRef', 1, 210, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21010006, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 210, 0, 1, '', 0, 17490, 0, 1, '') ;

CALL ImportField(21010007, ' ', 'DAT', ' ', 'Dat', 1, 210, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21010008, '   ', 'DATE_UTV_PP', '   ', 'DATE_UTV_PP', 1, 210, 0, 0, '', 0, 24699, 0, 1, '') ;

CALL ImportField(21010009, ' ', 'DateInput', ' ', 'DateInput', 1, 210, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21010010, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 210, 0, 1, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21010011, ' ', 'DOCDAT', ' ', 'DocDat', 1, 210, 0, 1, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21010012, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 210, 0, 1, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21010013, '', 'DocStateRef', '', 'DocStateRef', 1, 210, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21010014, ' ', 'FacialAccCls', ' ', 'FacialAccCls', 1, 210, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21010015, ' ', 'ID', ' ', 'Id', 1, 210, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21010016, '', 'KPPERIOD', '', 'KPPeriod', 1, 210, 0, 0, '', 0, 24700, 0, 1, '') ;

CALL ImportField(21010017, ' ', 'NOTE', ' ', 'note', 1, 210, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21010018, ' ', 'NOTE1', ' ', 'note1', 1, 210, 0, 0, '', 0, 17469, 0, 1, '') ;

CALL ImportField(21010019, ' ', 'NOTE2', ' ', 'note2', 1, 210, 0, 1, '', 0, 17470, 0, 1, '') ;

CALL ImportField(21010020, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 210, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21010022, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 210, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21010023, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 210, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21010024, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 210, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21010025, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 210, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21010026, '', 'Variant', '', 'Variant', 1, 210, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21010027, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 210, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21010028, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 210, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21010029, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 210, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21010030, '', 'AUTO_AUTORIZATION', '', ' ', 1, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21010031, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21010032, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21010033, '  ()', 'CREATEDATE', '  ()', ' ', 1, 210, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 210, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(21011003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 210, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21011004, ' ', 'ClsType', ' ', 'ClsType', 1, 210, 1, 1, '', 0, 17453, 0, 1, '') ;

CALL ImportField(21011005, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 210, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21011006, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 210, 1, 1, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21011008, '', 'FACTCODE', '', 'DestFactCls', 1, 210, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21011009, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 1, 210, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21011010, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 1, 210, 1, 1, '', 0, 17456, 0, 1, '') ;

CALL ImportField(21011011, ' ', 'ID', ' ', 'Id', 1, 210, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21011015, '', 'KCSR', '', 'DestKcsrKey', 1, 210, 1, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(21011016, '()', 'KCSRCode', '()', 'DestKcsr', 1, 210, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(21011017, '', 'KESR', '', 'DestKesrKey', 1, 210, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21011019, '()', 'KFSR', '()', 'DestKfsr', 1, 210, 1, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(21011020, '', 'KVR', '', 'DestKvrKey', 1, 210, 1, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(21011021, '()', 'KVRCode', '()', 'DestKvr', 1, 210, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(21011022, '', 'KVSR', '', 'DestKvsrKey', 1, 210, 1, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(21011023, '()', 'KVSRCode', '()', 'DestKvsr', 1, 210, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21011024, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 210, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21011025, '', 'NOTE', '', 'Note', 1, 210, 1, 0, '', 0, 17431, 0, 1, '') ;

CALL ImportField(21011026, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 210, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21011027, ' ', 'REGIONCLS', ' ', 'RegionCLS', 1, 210, 1, 0, ',,', 0, 17417, 0, 1, '') ;

CALL ImportField(21011029, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 210, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21011030, ' ', 'SUMMAYEAR1', ' ', 'SummaYear1', 1, 210, 1, 0, '', 0, 17457, 0, 1, '') ;

CALL ImportField(21011031, '  ', 'SUMMAYEAR2', '  ', 'SummaYear2', 1, 210, 1, 0, '', 0, 17458, 0, 1, '') ;

CALL ImportField(21011032, '  ', 'SUMMAYEAR3', '  ', 'SummaYear3', 1, 210, 1, 0, '', 0, 17459, 0, 1, '') ;

CALL ImportField(21011034, ' ', 'IFS', ' ', 'IFS', 1, 210, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(21011035, '  ', 'TransfertCls', '  ', 'TransfertCls', 1, 210, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21011036, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 210, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21011037, '  ', 'IFS_FinSourceValue', '', 'IFS_FinSourceValue', 1, 210, 1, 1, '', 0, 17055, 0, 1, '') ;

CALL ImportField(21011038, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 210, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(21011039, ' ', 'SubsidyCls', ' ()', 'SubsidyCls', 1, 210, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(21011040, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 210, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21011041, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 210, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21011042, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 210, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21011043, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 210, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(21011044, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 210, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21011045, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 210, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(21011049, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 210, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21011050, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21011051, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21011052, '', 'InvestObjectCode', '', 'InvestObject', 1, 210, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21011053, '', 'InvestObject', '', 'InvestObjectKey', 1, 210, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21011054, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 210, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21011055, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 210, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21011056, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 210, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(21011057, '', 'AUTO_AUTORIZATION', '', ' ', 1, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011058, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011059, '  ()', 'CREATEDATE', '  ()', ' ', 1, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011060, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 210, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21011071, '()', 'KESRCODE', '()', 'DestKesr', 1, 210, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21011072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 210, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21012001, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 210, 2, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(21012003, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 210, 2, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21012004, ' ', 'ClsType', ' ', 'ClsType', 1, 210, 2, 1, '', 0, 17453, 0, 1, '') ;

CALL ImportField(21012006, '()', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 210, 2, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21012007, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 210, 2, 1, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21012009, '', 'FACTCODE', '', 'DestFactCls', 1, 210, 2, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21012010, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 1, 210, 2, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21012011, '  ', 'FundsSource', '  ', 'FUNDSSOURCE', 1, 210, 2, 1, '', 0, 17456, 0, 1, '') ;

CALL ImportField(21012012, ' ', 'ID', ' ', 'Id', 1, 210, 2, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21012013, '', 'KCSR', '', 'DestKcsrKey', 1, 210, 2, 1, '', 0, 17413, 0, 1, '') ;

CALL ImportField(21012014, '()', 'KCSRCode', '()', 'DestKcsr', 1, 210, 2, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(21012015, '', 'KESR', '', 'DestKesrKey', 1, 210, 2, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21012017, '()', 'KFSR', '()', 'DestKfsr', 1, 210, 2, 0, '', 0, 17411, 0, 1, '') ;

CALL ImportField(21012018, '', 'KVR', '', 'DestKvrKey', 1, 210, 2, 1, '', 0, 17414, 0, 1, '') ;

CALL ImportField(21012019, '()', 'KVRCode', '()', 'DestKvr', 1, 210, 2, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(21012020, '', 'KVSR', '', 'DestKvsrKey', 1, 210, 2, 1, '', 0, 17412, 0, 1, '') ;

CALL ImportField(21012021, '()', 'KVSRCode', '()', 'DestKvsr', 1, 210, 2, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21012022, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 210, 2, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21012023, '', 'Month01', '', 'Month01', 1, 210, 2, 1, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21012024, '', 'Month02', '', 'Month02', 1, 210, 2, 1, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21012025, '', 'Month03', '', 'Month03', 1, 210, 2, 1, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21012026, '', 'Month04', '', 'Month04', 1, 210, 2, 1, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21012027, '', 'Month05', '', 'Month05', 1, 210, 2, 1, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21012028, '', 'Month06', '', 'Month06', 1, 210, 2, 1, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21012029, '', 'Month07', '', 'Month07', 1, 210, 2, 1, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21012030, '', 'Month08', '', 'Month08', 1, 210, 2, 1, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21012031, '', 'Month09', '', 'Month09', 1, 210, 2, 1, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21012032, '', 'Month10', '', 'Month10', 1, 210, 2, 1, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21012033, '', 'Month11', '', 'Month11', 1, 210, 2, 1, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21012034, '', 'Month12', '', 'Month12', 1, 210, 2, 1, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21012035, '', 'NOTE', '', 'Note', 1, 210, 2, 0, '', 0, 17431, 0, 1, '') ;

CALL ImportField(21012040, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 210, 2, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21012041, ' ', 'REGIONCLS', ' ', 'RegionCLS', 1, 210, 2, 0, ',,', 0, 17417, 0, 1, '') ;

CALL ImportField(21012043, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 210, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21012045, '  ', 'TransfertCls', '  ', 'TransfertCls', 1, 210, 2, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21012046, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 210, 2, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21012047, ' ', 'IFS', '', 'IFS', 1, 210, 2, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(21012051, '  ', 'IFS_FinSourceValue', '', 'IFS_FinSourceValue', 1, 210, 2, 1, '', 0, 17055, 0, 1, '') ;

CALL ImportField(21012052, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 210, 2, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(21012053, ' ', 'SubsidyCls', ' ()', 'SubsidyCls', 1, 210, 2, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(21012054, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 210, 2, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21012055, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 210, 2, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21012056, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 210, 2, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21012057, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 210, 2, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(21012059, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 210, 2, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21012061, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 210, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21012062, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 210, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21012063, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 210, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21012064, '', 'InvestObjectCode', '', 'InvestObject', 1, 210, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21012065, '', 'InvestObject', '', 'InvestObjectKey', 1, 210, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21012066, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 210, 2, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21012067, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 210, 2, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21012071, '()', 'KESRCODE', '()', 'DestKesr', 1, 210, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21012072, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 210, 2, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(21110001, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110002, '', 'BUDGETREF', '', 'BudgetRef', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110003, ' ', 'ClsType', ' ', 'ClsType', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110004, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21110005, ' ', 'DAT', ' ', 'Dat', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110006, ' ', 'DateInput', ' ', 'DateInput', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110007, ' ', 'DOCDAT', ' ', 'DocDat', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110008, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110009, '', 'DocStateRef', '', 'DocStateRef', 1, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21110010, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110012, '', 'KPPERIOD', '', 'KPPeriod', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110013, '()', 'NOTE', '()', 'note', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110016, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110017, '', 'NUMBER', '', 'Number', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110019, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21110020, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110021, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 211, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21110022, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110023, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110024, '', 'Variant', '', 'Variant', 1, 211, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21110025, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 211, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(21110027, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 211, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21110028, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 211, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21110029, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 211, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21110030, '', 'AUTO_AUTORIZATION', '', ' ', 1, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21110031, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21110032, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21110033, '  ()', 'CREATEDATE', '  ()', ' ', 1, 211, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21111001, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111002, ' ', 'ClsType', ' ', 'ClsType', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111003, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111004, ' ()', 'CreateDate', ' ()', 'CreateDate_Det', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111005, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111006, '', 'DayPlan', '', 'DayPlan', 1, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21111007, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 1, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21111008, '()', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 1, 211, 1, 1, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21111009, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111011, '', 'FACTCODE', '', 'DestFactCls', 1, 211, 1, 1, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21111012, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 1, 211, 1, 1, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21111014, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21111016, '()', 'INN', '()', 'DestFacialAccClsOrgINN', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111017, '()', 'INN20', '()', 'DestFacialAccClsOrgKPP', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111018, '()', 'KCSRCode', '()', 'DestKcsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111020, '()', 'KFSR', '()', 'DestKfsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111021, '()', 'KVRCode', '()', 'DestKvr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111022, '()', 'KVSRCode', '()', 'DestKvsr', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111023, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111024, '()', 'NAME', '()', 'DestFacialAccClsOrgName', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111025, '', 'NOTE', '', 'Note', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111027, ' ', 'REGIONCLS', ' ', 'RegionCLS', 1, 211, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(21111029, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 211, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21111031, ' ()', 'UpdateDate', ' ()', 'UpdateDate_Det', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111032, '()', 'UpdaterUser', '()', 'UpdaterUser_det', 1, 211, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21111033, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 211, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21111034, ' ', 'ID', ' ', 'Id', 1, 211, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21111035, '', 'KD', '', 'KD', 1, 211, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21111036, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 211, 1, 0, '', 0, 38908, 0, 0, '') ;

CALL ImportField(21111037, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 211, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21111038, ' ', 'KDValue', ' ', 'KDValue', 1, 211, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21111039, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 211, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21111040, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 211, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(21111042, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 211, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21111043, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 211, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21111044, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 1, 211, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(21111045, '   ', 'PayPromiseCls', '   ()', 'PayPromiseCls', 1, 211, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21111046, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 211, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(21111047, ' ', 'IFS', '    ()', 'IFS', 1, 211, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(21111049, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 211, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21111050, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 211, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21111051, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 211, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21111052, '', 'AUTO_AUTORIZATION', '', ' ', 1, 211, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21111059, '()', 'KESRCODE', '()', 'DestKesr', 1, 211, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21111063, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 211, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21112015, '()', 'KCSRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112016, '', 'KESR', ' ()', 'DestKesrKey', 1, 211, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21112017, '()', 'KFSR', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112018, '()', 'KVRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112019, '()', 'KVSRCode', '()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112026, '', 'SUBKESR', '', 'DestSubkesrKey', 1, 211, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21112030, '', 'KVR', ' ()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112031, '', 'KVSR', ' ()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112032, '', 'KCSR', ' ()', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112037, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 211, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21112048, '', 'ContractCostsCls', '', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112049, '', 'ContractCostsClsCode', '', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112050, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 211, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21112051, ' ', 'TargetClsCode', ' ', ' ', 1, 211, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21112052, ' ', 'TargetCls', '  ()', ' ', 1, 211, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21112058, '()', 'KESRCODE', '()', 'DestKesr', 1, 211, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21112062, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 211, 2, 0, '', 0, 43610, 0, 1, '') ;

--   , , (1)
CALL ImportField(21210001, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210002, '', 'BUDGETREF', '', 'BudgetRef', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210003, ' ', 'ClsType', ' ', 'ClsType', 1, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21210004, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21210005, ' ', 'DAT', ' ', 'Dat', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210006, ' ', 'DateInput', ' ', 'DateInput', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210007, ' ', 'DOCDAT', ' ', 'DocDat', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210008, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210009, '', 'DocStateRef', '', 'DocStateRef', 1, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21210010, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210012, '', 'KPPERIOD', '', 'KPPeriod', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210013, '()', 'NOTE', '()', 'note', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210016, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210017, '', 'NUMBER', '', 'Number', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210019, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21210020, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210021, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 212, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21210022, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210023, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210024, '', 'Variant', '', 'Variant', 1, 212, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21210025, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 212, 0, 0, ',', 0, null, 0, 1, '') ;

CALL ImportField(21210027, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 212, 0, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(21210028, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 212, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21210029, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 212, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21210030, '', 'AUTO_AUTORIZATION', '', ' ', 1, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21210031, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21210032, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21210033, '  ()', 'CREATEDATE', '  ()', ' ', 1, 212, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21211001, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211002, ' ', 'ClsType', ' ', 'ClsType', 1, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21211003, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211004, ' ()', 'CreateDate', ' ()', 'CreateDate_Det', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211005, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211006, '', 'DayPlan', '', 'DayPlan', 1, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21211007, '', 'DAYPLANSUMMA', '', 'DayPlanSumma', 1, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21211008, '()', 'DirectionCLSCODE', '()', 'DestDirectionCLS', 1, 212, 1, 1, '', 0, 36861, 0, 1, '') ;

CALL ImportField(21211009, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211011, '', 'FACTCODE', '', 'DestFactCls', 1, 212, 1, 1, '', 0, 36863, 0, 1, '') ;

CALL ImportField(21211012, ' . ', 'FINTYPECODE', '  ', 'DestFinTypeCls', 1, 212, 1, 1, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(21211014, '()', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21211016, '()', 'INN', '()', 'DestFacialAccClsOrgINN', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211017, '()', 'INN20', '()', 'DestFacialAccClsOrgKPP', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211018, '()', 'KCSRCode', '()', 'DestKcsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211020, '()', 'KFSR', '()', 'DestKfsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211021, '()', 'KVRCode', '()', 'DestKvr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211022, '()', 'KVSRCode', '()', 'DestKvsr', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211023, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211024, '()', 'NAME', '()', 'DestFacialAccClsOrgName', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211025, '', 'NOTE', '', 'Note', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211027, ' ', 'REGIONCLS', ' ', 'RegionCLS', 1, 212, 1, 1, ',,', 0, null, 0, 1, '') ;

CALL ImportField(21211029, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 1, 212, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21211031, ' ()', 'UpdateDate', ' ()', 'UpdateDate_Det', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211032, '()', 'UpdaterUser', '()', 'UpdaterUser_det', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211033, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 212, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21211034, ' ', 'ID', ' ', 'Id', 1, 212, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21211035, '', 'KD', '', 'KD', 1, 212, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21211036, '()', 'KDAGCode', '()', 'KDKESRCode', 1, 212, 1, 0, '', 0, 38908, 0, 0, '') ;

CALL ImportField(21211037, '()', 'KDKVSRCode', '()', 'KDKVSRCode', 1, 212, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(21211038, ' ', 'KDValue', ' ', 'KDValue', 1, 212, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21211039, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 212, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(21211040, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 212, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(21211042, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 1, 212, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21211043, ' ', 'BudAllocationClsCode', ' ', 'BudAllocationClsCode', 1, 212, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(21211044, '  ', 'BudAllocationCls', '  ()', 'BudAllocationCls', 1, 212, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(21211045, '  ', 'PayPromiseClsCode', '  ', 'PayPromiseClsCode', 1, 212, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(21211046, '   ', 'PayPromiseCls', '   ()', 'PayPromiseCls', 1, 212, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(21211047, '', 'IFS_FinSourceValue', '   ', 'IFS_FinSourceValue', 1, 212, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(21211048, ' ', 'IFS', '    ()', 'IFS', 1, 212, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(21211050, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 212, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21211051, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 212, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21211052, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 212, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21211053, '', 'AUTO_AUTORIZATION', '', ' ', 1, 212, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21211058, '()', 'KESRCODE', '()', 'DestKesr', 1, 212, 1, 1, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21211062, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 212, 1, 1, '', 0, 43610, 0, 1, '') ;

CALL ImportField(21212015, '()', 'KCSRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212016, '', 'KESR', ' ()', 'DestKesrKey', 1, 212, 2, 0, '', 0, 17415, 0, 1, '') ;

CALL ImportField(21212017, '()', 'KFSR', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212018, '()', 'KVRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212019, '()', 'KVSRCode', '()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212026, '', 'SUBKESR', ' ()', 'DestSubkesrKey', 1, 212, 2, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(21212030, '', 'KVR', ' ()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212031, '', 'KVSR', ' ()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212032, '', 'KCSR', ' ()', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212038, '  ()', 'BudAllocationCls', '  ()', ' ', 1, 212, 2, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(21212049, '', 'ContractCostsCls', '', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212050, '', 'ContractCostsClsCode', '', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212051, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 212, 2, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21212052, ' ', 'TargetClsCode', ' ', ' ', 1, 212, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21212053, ' ', 'TargetCls', '  ()', ' ', 1, 212, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21212057, '()', 'KESRCODE', '()', 'DestKesr', 1, 212, 2, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(21212061, '()', 'SUBKESRCode', '()', 'DestSubkesr', 1, 212, 2, 0, '', 0, 43610, 0, 1, '') ;

--      , (1)
CALL ImportField(21310001, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 213, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21310002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21310003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21310004, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21310005, '  ()', 'CREATEDATE', '  ()', ' ', 1, 213, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21310006, ' ', 'Dat', ' ', 'Dat', 1, 213, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21310007, ' ', 'Id', ' ', 'Id', 1, 213, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21310008, ' ', 'DocDat', ' ', 'DocDat', 1, 213, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21310009, '()', 'Note', '', 'Note', 1, 213, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21310010, ' ', 'Note1', ' ', 'Note1', 1, 213, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21310011, ' ()', 'Note2', ' ', 'Note2', 1, 213, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21310012, '', 'NotifyType', ' ', 'NotifyType', 1, 213, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21310013, '', 'BudgetRef', '', 'BudgetRef', 1, 213, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21310014, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 213, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21310015, '', 'Variant', '', 'Variant', 1, 213, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21310016, '', 'Number', '', 'Number', 1, 213, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21310017, ' ', 'DocNumber', ' ', 'DocNumber', 1, 213, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21310018, ' ', 'DateInput', ' ', 'DateInput', 1, 213, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21310019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 1, 213, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21310020, '  ', 'RejectCls', ' ', 'RejectCls', 1, 213, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21310021, '  ()', 'RejectCause', ' ()', 'RejectCause', 1, 213, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21310022, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 213, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21310023, ' ', 'CryptoStatus', '', 'CryptoStatus', 1, 213, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21310024, '', 'DocStateRef', ' ', 'DocStateRef', 1, 213, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21310025, ' ()', 'DocBaseParent', ' ()', ' ', 1, 213, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21310026, '  ', 'SenderId', '  ', 'SenderId', 1, 213, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21310027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 1, 213, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21310028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 1, 213, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21310029, ' ', 'ProgIndex', 'ProgIndex', ' ', 1, 213, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21310030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 213, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21310032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 1, 213, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 213, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(21311002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21311003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21311004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21311005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 213, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21311006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 213, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21311007, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 213, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21311009, ' ', 'ClsType', ' ', 'ClsType', 1, 213, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21311010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 213, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21311011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 213, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21311012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 1, 213, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21311013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 213, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21311014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 213, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21311015, '', 'TreeOwner0', ' ()', ' ', 1, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311016, ' 4', 'Quarter4', '4', 'Quarter4', 1, 213, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21311017, ' 3', 'Quarter3', '3', 'Quarter3', 1, 213, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21311018, ' 2', 'Quarter2', '2', 'Quarter2', 1, 213, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21311019, ' 1', 'Quarter1', '1', 'Quarter1', 1, 213, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21311020, '', 'Month12', '', 'Month12', 1, 213, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21311021, '', 'Month11', '', 'Month11', 1, 213, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21311022, '', 'Month10', '', 'Month10', 1, 213, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21311023, '', 'Month09', '', 'Month09', 1, 213, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21311024, '', 'Month08', '', 'Month08', 1, 213, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21311025, '', 'Month07', '', 'Month07', 1, 213, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21311026, '', 'Month06', '', 'Month06', 1, 213, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21311027, '', 'Month05', '', 'Month05', 1, 213, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21311028, '', 'Month04', '', 'Month04', 1, 213, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21311029, '', 'Month03', '', 'Month03', 1, 213, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21311030, '', 'Month02', '', 'Month02', 1, 213, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21311031, '', 'Month01', '', 'Month01', 1, 213, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21311032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 1, 213, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21311033, '  ', 'SenderId', '  ', 'SenderId', 1, 213, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21311034, ' ', 'RecordIndex', '  ', 'RecordIndex', 1, 213, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21311035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 1, 213, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21311036, ' ', 'RegionCls', '', 'RegionCls', 1, 213, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21311037, '', 'BudgetRef', '', 'BUDGETREF', 1, 213, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21311038, '    ', ' ', '*    ', 'FUId', 1, 213, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21311039, ' ', 'Id', ' ', 'Id', 1, 213, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21311040, ' ', 'KDValue', ' ', 'KDValue', 1, 213, 1, 0, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21311041, '  ()', 'KD', '  ()', 'KD', 1, 213, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21311042, ' ', 'SubsidySumma', ' ', ' ', 1, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311043, '   ', 'TotalSumma', '   ', ' ', 1, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311044, '  ', 'HigherBudCls', '  ', ' ', 1, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 1, 213, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21311046, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 213, 1, 1, '', 0, null, 0, 1, '') ;

--      , +(2)
CALL ImportField(21310031, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 213, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21310048, '    ()', 'TotalSumma', '    ()', 'TotalSummaCpt', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21310049, '  ()', 'SubsidySumma', '  ()', 'SubsidySummaCpt', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21310050, ' ', 'AgreementLevel', ' ', 'AgreementLevel', 2, 213, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21311008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 213, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21311047, ' ', 'Percent', ' ', 'Percent', 2, 213, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(21311051, ' ()', 'Org_Ref', ' ()', 'Org_Ref_Det', 2, 213, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(21311052, '()', 'INN', '()', 'DestOrgInn', 2, 213, 1, 0, '', 0, 16645, 0, 0, '') ;

CALL ImportField(21311053, '()', 'INN20', '()', 'DestOrgKpp', 2, 213, 1, 0, '', 0, 16653, 0, 0, '') ;

CALL ImportField(21311054, '()', 'NAME', '()', 'DestOrgNAME', 2, 213, 1, 0, '', 0, 16646, 0, 0, '') ;

CALL ImportField(21311055, '', 'OrgNameAndAcc', '', ' ', 2, 213, 1, 0, '', 0, null, 0, 0, '') ;

--   14 /, (1)
CALL ImportField(21410001, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 214, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21410002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21410003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21410004, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21410005, '  ()', 'CREATEDATE', '  ()', ' ', 1, 214, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21410006, ' ', 'Dat', ' ', 'Dat', 1, 214, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21410007, ' ', 'Id', ' ', 'Id', 1, 214, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21410008, ' ', 'DocDat', ' ', 'DocDat', 1, 214, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21410009, '()', 'Note', '', 'Note', 1, 214, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21410010, ' ', 'Note1', ' ', 'Note1', 1, 214, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21410011, ' ()', 'Note2', ' ', 'Note2', 1, 214, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21410012, '', 'NotifyType', ' ', 'NotifyType', 1, 214, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21410013, '', 'BudgetRef', '', 'BudgetRef', 1, 214, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21410014, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 214, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21410015, '', 'Variant', '', 'Variant', 1, 214, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21410016, '', 'Number', '', 'Number', 1, 214, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21410017, ' ', 'DocNumber', ' ', 'DocNumber', 1, 214, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21410018, ' ', 'DateInput', ' ', 'DateInput', 1, 214, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21410019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 1, 214, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21410020, '  ', 'RejectCls', ' ', 'RejectCls', 1, 214, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21410021, '  ()', 'RejectCause', ' ()', 'RejectCause', 1, 214, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21410022, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 214, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21410023, ' ', 'CryptoStatus', '', 'CryptoStatus', 1, 214, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21410024, '', 'DocStateRef', ' ', 'DocStateRef', 1, 214, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21410025, ' ()', 'DocBaseParent', ' ()', ' ', 1, 214, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21410026, '  ', 'SenderId', '  ', 'SenderId', 1, 214, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21410027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 1, 214, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21410028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 1, 214, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21410029, ' ', 'ProgIndex', 'ProgIndex', ' ', 1, 214, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21410030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 214, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21410031, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 214, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21410032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 1, 214, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21411001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 214, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(21411002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21411003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21411004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21411005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 214, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21411006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 214, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21411007, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 214, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21411008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 214, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21411009, ' ', 'ClsType', ' ', 'ClsType', 1, 214, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21411010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 214, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21411011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 214, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21411012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 1, 214, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21411013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 214, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21411014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 214, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21411015, '', 'TreeOwner0', ' ()', ' ', 1, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21411016, ' 4', 'Quarter4', '4', 'Quarter4', 1, 214, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21411017, ' 3', 'Quarter3', '3', 'Quarter3', 1, 214, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21411018, ' 2', 'Quarter2', '2', 'Quarter2', 1, 214, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21411019, ' 1', 'Quarter1', '1', 'Quarter1', 1, 214, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21411020, '', 'Month12', '', 'Month12', 1, 214, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21411021, '', 'Month11', '', 'Month11', 1, 214, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21411022, '', 'Month10', '', 'Month10', 1, 214, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21411023, '', 'Month09', '', 'Month09', 1, 214, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21411024, '', 'Month08', '', 'Month08', 1, 214, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21411025, '', 'Month07', '', 'Month07', 1, 214, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21411026, '', 'Month06', '', 'Month06', 1, 214, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21411027, '', 'Month05', '', 'Month05', 1, 214, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21411028, '', 'Month04', '', 'Month04', 1, 214, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21411029, '', 'Month03', '', 'Month03', 1, 214, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21411030, '', 'Month02', '', 'Month02', 1, 214, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21411031, '', 'Month01', '', 'Month01', 1, 214, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21411032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 1, 214, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21411033, '  ', 'SenderId', '  ', 'SenderId', 1, 214, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21411034, ' ', 'RecordIndex', '  ', 'RecordIndex', 1, 214, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21411035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 1, 214, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21411036, ' ', 'RegionCls', '', 'RegionCls', 1, 214, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21411037, '', 'BudgetRef', '', 'BUDGETREF', 1, 214, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21411038, '    ', ' ', '*    ', 'FUId', 1, 214, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21411039, ' ', 'Id', ' ', 'Id', 1, 214, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21411040, ' ', 'KDValue', ' ', 'KDValue', 1, 214, 1, 0, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21411041, '  ()', 'KD', '  ()', 'KD', 1, 214, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21411042, ' ', 'SubsidySumma', ' ', ' ', 1, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21411043, '   ', 'TotalSumma', '   ', ' ', 1, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21411044, '  ', 'HigherBudCls', '  ', ' ', 1, 214, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21411045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 1, 214, 1, 0, '', 0, null, 0, 0, '') ;

--   14 /, +(2)
CALL ImportField(21411046, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 214, 1, 1, '', 0, null, 0, 1, '') ;

--   14 /, (1)
CALL ImportField(21510001, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 215, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(21510002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21510003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21510004, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21510005, '  ()', 'CREATEDATE', '  ()', ' ', 1, 215, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21510006, ' ', 'Dat', ' ', 'Dat', 1, 215, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(21510007, ' ', 'Id', ' ', 'Id', 1, 215, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(21510008, ' ', 'DocDat', ' ', 'DocDat', 1, 215, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(21510009, '()', 'Note', '', 'Note', 1, 215, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(21510010, ' ', 'Note1', ' ', 'Note1', 1, 215, 0, 0, '', 0, 17469, 0, 0, '') ;

CALL ImportField(21510011, ' ()', 'Note2', ' ', 'Note2', 1, 215, 0, 0, '', 0, 17470, 0, 0, '') ;

CALL ImportField(21510012, '', 'NotifyType', ' ', 'NotifyType', 1, 215, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(21510013, '', 'BudgetRef', '', 'BudgetRef', 1, 215, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(21510014, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 215, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(21510015, '', 'Variant', '', 'Variant', 1, 215, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(21510016, '', 'Number', '', 'Number', 1, 215, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(21510017, ' ', 'DocNumber', ' ', 'DocNumber', 1, 215, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(21510018, ' ', 'DateInput', ' ', 'DateInput', 1, 215, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(21510019, '  ()', 'OrgRef', ' ()', 'DestOrgRef', 1, 215, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(21510020, '  ', 'RejectCls', ' ', 'RejectCls', 1, 215, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(21510021, '  ()', 'RejectCause', ' ()', 'RejectCause', 1, 215, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(21510022, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 215, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(21510023, ' ', 'CryptoStatus', '', 'CryptoStatus', 1, 215, 0, 1, '', 0, 17490, 0, 0, '') ;

CALL ImportField(21510024, '', 'DocStateRef', ' ', 'DocStateRef', 1, 215, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(21510025, ' ()', 'DocBaseParent', ' ()', ' ', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21510026, '  ', 'SenderId', '  ', 'SenderId', 1, 215, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(21510027, '\  ', 'FacialAccCls', ' ', 'FacialAccCls', 1, 215, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(21510028, '  ', 'SenderRecordID', 'SenderRecordID', 'SenderRecordId', 1, 215, 0, 1, '', 0, 17476, 0, 1, '') ;

CALL ImportField(21510029, ' ', 'ProgIndex', 'ProgIndex', ' ', 1, 215, 0, 1, '', 0, 17493, 0, 0, '') ;

CALL ImportField(21510030, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 215, 0, 0, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(21510031, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 215, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21510032, ' ', 'DataBlockFlag', ' ', 'DataBlockFlag', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21510046, '   ', 'StartDate', '   ', ' ', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21510047, '  ', 'EndDate', '  ', ' ', 1, 215, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21511001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 215, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(21511002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21511003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21511004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21511005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 215, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(21511006, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 215, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(21511007, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 215, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(21511008, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 215, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(21511009, ' ', 'ClsType', ' ', 'ClsType', 1, 215, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(21511010, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 215, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(21511011, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 215, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(21511012, ' ', 'SUMMAYEAR1', '  ', 'SUMMAYEAR1', 1, 215, 1, 0, '', 0, 17457, 0, 0, '') ;

CALL ImportField(21511013, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 215, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(21511014, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 215, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(21511015, '', 'TreeOwner0', ' ()', ' ', 1, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21511016, ' 4', 'Quarter4', '4', 'Quarter4', 1, 215, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(21511017, ' 3', 'Quarter3', '3', 'Quarter3', 1, 215, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(21511018, ' 2', 'Quarter2', '2', 'Quarter2', 1, 215, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(21511019, ' 1', 'Quarter1', '1', 'Quarter1', 1, 215, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(21511020, '', 'Month12', '', 'Month12', 1, 215, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(21511021, '', 'Month11', '', 'Month11', 1, 215, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(21511022, '', 'Month10', '', 'Month10', 1, 215, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(21511023, '', 'Month09', '', 'Month09', 1, 215, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(21511024, '', 'Month08', '', 'Month08', 1, 215, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(21511025, '', 'Month07', '', 'Month07', 1, 215, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(21511026, '', 'Month06', '', 'Month06', 1, 215, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(21511027, '', 'Month05', '', 'Month05', 1, 215, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(21511028, '', 'Month04', '', 'Month04', 1, 215, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(21511029, '', 'Month03', '', 'Month03', 1, 215, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(21511030, '', 'Month02', '', 'Month02', 1, 215, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(21511031, '', 'Month01', '', 'Month01', 1, 215, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(21511032, '  ', 'SenderRecordId', '   ', 'SenderRecordId', 1, 215, 1, 1, '', 0, 17435, 0, 1, '') ;

CALL ImportField(21511033, '  ', 'SenderId', '  ', 'SenderId', 1, 215, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(21511034, ' ', 'RecordIndex', '  ', 'RecordIndex', 1, 215, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(21511035, ' ', 'FacialAcc_Cls', ' ', 'DestFacialAccCls', 1, 215, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(21511036, ' ', 'RegionCls', '', 'RegionCls', 1, 215, 1, 0, ',,', 0, 17417, 0, 0, '') ;

CALL ImportField(21511037, '', 'BudgetRef', '', 'BUDGETREF', 1, 215, 1, 1, '', 0, 17410, 0, 0, '') ;

CALL ImportField(21511038, '    ', ' ', '*    ', 'FUId', 1, 215, 1, 1, '', 1, null, 0, 0, '') ;

CALL ImportField(21511039, ' ', 'Id', ' ', 'Id', 1, 215, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(21511040, ' ', 'KDValue', ' ', 'KDValue', 1, 215, 1, 0, '', 0, 16836, 0, 1, '') ;

CALL ImportField(21511041, '  ()', 'KD', '  ()', 'KD', 1, 215, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(21511042, ' ', 'SubsidySumma', ' ', ' ', 1, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21511043, '   ', 'TotalSumma', '   ', ' ', 1, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21511044, '  ', 'HigherBudCls', '  ', ' ', 1, 215, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(21511045, ' /  ', 'FacialCodeHigherGRBS', ' /  ', ' ', 1, 215, 1, 0, '', 0, null, 0, 0, '') ;

--   14 /, +(2)
CALL ImportField(21511048, ' ', 'ProgIndex', ' ', 'ProgIndex', 2, 215, 1, 1, '', 0, null, 0, 1, '') ;

--   , (1)
CALL ImportField(30010023, '', 'AUTO_AUTORIZATION', '', ' ', 1, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30010024, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30010025, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30010026, '  ()', 'CREATEDATE', '  ()', ' ', 1, 300, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011024, ' ', '{("")}', ' ', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011026, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011027, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011028, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011029, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011030, '', '{("")}', ' ()', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011031, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011032, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011033, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011046, ' ', '{("")}', ' ', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30011047, ' ', '{("")}', '  ()', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011048, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 300, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30011049, '', 'AUTO_AUTORIZATION', '', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011050, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011051, '  ()', 'CREATEDATE', '  ()', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011052, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 300, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30011053, '', '{("")}', '', ' ', 1, 300, 1, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(30110136, '  ', '', '  ', 'ExecutionDate', 1, 301, 0, 0, '', 0, null, 30210163, 1, '') ;

CALL ImportField(30110137, ' ', 'DestClsType', '', ' ', 1, 301, 0, 1, '', 0, 38187, 0, 0, '') ;

CALL ImportField(30110138, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 301, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30110139, '', 'AUTO_AUTORIZATION', '', ' ', 1, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110140, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110141, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30110142, '  ()', 'CREATEDATE', '  ()', ' ', 1, 301, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111004, ' .', 'SourceKVR', ' ', 'SourceKVRKey', 1, 301, 1, 1, 'SourceKVR,', 0, 18867, 0, 0, '') ;

CALL ImportField(30111005, ' .', 'SourceKESR', ' ', 'SourceKESRKey', 1, 301, 1, 1, 'SourceKESR,', 0, 18868, 0, 0, '') ;

CALL ImportField(30111006, ' .( .)', 'SourceKFSR', ' ', 'SourceKFSR', 1, 301, 1, 0, ',', 0, 18888, 0, 0, '') ;

CALL ImportField(30111007, ' .', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 301, 1, 1, 'SourceKCSR,', 0, 18887, 0, 0, '') ;

CALL ImportField(30111008, ' .', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 301, 1, 1, 'SourceKVSR,', 0, 18886, 0, 0, '') ;

CALL ImportField(30111009, ' .', 'SourceSubKESR', ' ', 'SourceSubKESRKey', 1, 301, 1, 1, ',SourceSubKESR', 0, 18889, 0, 0, '') ;

CALL ImportField(30111016, ' -', 'DestKVR', ' ', 'DestKVRKey', 1, 301, 1, 1, 'DestKVR,', 0, 18870, 0, 0, '') ;

CALL ImportField(30111017, ' -', 'DestKESR', ' ', 'DestKESRKey', 1, 301, 1, 1, 'DestKESR,', 0, 18871, 0, 0, '') ;

CALL ImportField(30111018, ' -( -)', 'DestKFSR', ' ', 'DestKFSR', 1, 301, 1, 0, 'DestKFSR,', 0, 18897, 0, 0, '') ;

CALL ImportField(30111019, ' -', 'DestKCSR', ' ', 'DestKCSRKey', 1, 301, 1, 1, 'DestKCSR,', 0, 18896, 0, 0, '') ;

CALL ImportField(30111020, ' -', 'DestKVSR', ' ', 'DestKVSRKey', 1, 301, 1, 1, 'DestKVSR,', 0, 18895, 0, 0, '') ;

CALL ImportField(30111021, ' -', 'DestSubKESR', ' ', 'DestSubKESRKey', 1, 301, 1, 1, 'DestSubKESR,', 0, 18898, 0, 0, '') ;

CALL ImportField(30111050, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 301, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30111128, 'DestIFS_FullID( )', 'DestIFS_FullID', 'DestIFS_FullID( )', 'DestIFS_DescriptionCode', 1, 301, 1, 1, 'DestIFS_FullID,', 0, 17055, 0, 0, '') ;

CALL ImportField(30111132, '  -', 'DestFundsSource', '  -', 'DestFundsSource', 1, 301, 1, 0, '', 0, 18929, 0, 0, '') ;

CALL ImportField(30111133, '  .', 'SourceFundsSource', '  .', 'SourceFundsSource', 1, 301, 1, 0, ',', 0, 18930, 0, 0, '') ;

CALL ImportField(30111140, ' -( -)', 'DestKCSRCode', ' -( -)', 'DestKCSR', 1, 301, 1, 0, ',DestKCSRCode', 0, 25462, 0, 0, '') ;

CALL ImportField(30111142, ' -( -)', 'DESTKVRCode', ' -( -)', 'DestKVR', 1, 301, 1, 0, ',DESTKVRCode', 0, 25467, 0, 0, '') ;

CALL ImportField(30111143, ' -( -)', 'DestKVSRCode', ' -( -)', 'DestKVSR', 1, 301, 1, 0, ',DestKVSRCode', 0, 25472, 0, 0, '') ;

CALL ImportField(30111145, ' .( .)', 'SourceKCSRCode', ' .( .)', 'SourceKCSR', 1, 301, 1, 0, ',,SourceKCSRCode', 0, 25462, 0, 0, '') ;

CALL ImportField(30111147, ' .( .)', 'SOURCEKVRCode', ' .( .)', 'SourceKVR', 1, 301, 1, 0, ',,SOURCEKVRCode', 0, 25467, 0, 0, '') ;

CALL ImportField(30111148, ' .( .)', 'SourceKVSRCode', ' .( .)', 'SourceKVSR', 1, 301, 1, 0, ',,SourceKVSRCode', 0, 25472, 0, 0, '') ;

CALL ImportField(30111154, '  -', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 301, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30111155, '   -', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 301, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(30111156, '  .', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 301, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30111158, '  -', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 301, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(30111160, '  .', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 301, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(30111171, '  ()', 'SourceInvestObject', ' ', 'SourceInvestObjectKey', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111172, '  ()', 'DestInvestObject', ' ', 'DestInvestObjectKey', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111173, ' ', 'SourceInvestObjectCode', ' ', 'SourceInvestObject', 1, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111174, ' ', 'DestInvestObjectCode', ' ', 'DestInvestObject', 1, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111175, ' -', 'DestContractCostsClsCode', ' ', 'DestContractCostsCls', 1, 301, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30111176, ' -', 'DestContractCostsCls', ' ', 'DestContractCostsClsKey', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111177, ' .', 'SourceContractCostsCls', ' ', 'SourceContractCostsClsKey', 1, 301, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30111178, ' .', 'SourceContractCostsClsCode', ' ', 'SourceContractCostsCls', 1, 301, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30111179, '(.  )', 'SourceExecDocDate', '  ', 'SourceExecDocDate', 1, 301, 1, 1, ',', 0, 19740, 0, 0, '') ;

CALL ImportField(30111180, '(.  )', 'SourceExecDocNote', '  ', 'SourceExecDocNote', 1, 301, 1, 1, '', 0, 19762, 0, 0, '') ;

CALL ImportField(30111181, ' (.  )', 'SourceExecDocReestr', '   ', 'SourceExecDocReestr', 1, 301, 1, 1, '', 0, 19756, 0, 0, '') ;

CALL ImportField(30111182, '(.  )', 'SourceExecDocSumma', '   ', 'SourceExecDocSumma', 1, 301, 1, 1, '', 0, 19744, 0, 0, '') ;

CALL ImportField(30111183, '(.  )', 'SourceExecDocType', '  ', 'SourceExecDocType', 1, 301, 1, 1, '', 0, 19738, 0, 0, '') ;

CALL ImportField(30111184, '(.  )', 'DestExecDocDate', '', 'DestExecDocDate', 1, 301, 1, 1, '', 0, 19740, 0, 0, '') ;

CALL ImportField(30111185, '(.  )', 'DestExecDocNote', '', 'DestExecDocNote', 1, 301, 1, 1, '', 0, 19762, 0, 0, '') ;

CALL ImportField(30111186, ' (.  )', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 1, 301, 1, 1, '', 0, 19756, 0, 0, '') ;

CALL ImportField(30111187, '(.  )', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 1, 301, 1, 1, '', 0, 19744, 0, 0, '') ;

CALL ImportField(30111188, '(.  )', 'DestExecDocType', '  ', 'DestExecDocType', 1, 301, 1, 1, '', 0, 19738, 0, 0, '') ;

CALL ImportField(30111189, '  ', 'DestClsType', '  -', 'DestClsType', 1, 301, 1, 1, '', 0, 25179, 0, 0, '') ;

CALL ImportField(30111190, '  .', 'SourceTargetClsCode', '  ', 'SourceTargetCls', 1, 301, 1, 0, ',', 0, 22390, 0, 0, '') ;

CALL ImportField(30111191, '  .', 'SourceTargetCls', '   ()', 'SourceTargetClsKey', 1, 301, 1, 1, ',', 0, 40642, 0, 0, '') ;

CALL ImportField(30111192, '  -', 'DestTargetClsCode', '  ', 'DestTargetCls', 1, 301, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30111193, '  -', 'DestTargetCls', '   ()', 'DestTargetClsKey', 1, 301, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30111194, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 301, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30111195, '', 'AUTO_AUTORIZATION', '', ' ', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111196, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111197, '  ()', 'CREATEDATE', '  ()', ' ', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111198, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 301, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30111213, ' -( -)', 'DestKESRCode', ' -( -)', 'DestKESR', 1, 301, 1, 0, ',DestKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30111215, ' -( -)', 'DestSubKESRCode', ' ( -)', 'DestSubKESR', 1, 301, 1, 0, 'DestSubKESR,', 0, 43610, 0, 0, '') ;

CALL ImportField(30111217, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 301, 1, 0, ',,SourceKESRCode', 0, 43607, 0, 0, '') ;

CALL ImportField(30111219, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSubKESR', 1, 301, 1, 0, ',,SourceSubKESRCode', 0, 43610, 0, 0, '') ;

--   \, (1)
CALL ImportField(30210014, ' (  )', 'NOTE', ' ', 'NOTE', 1, 302, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(30210024, '()', 'SUMMA', '', 'SUMMA', 1, 302, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(30210032, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 1, 302, 0, 0, ',', 0, 18957, 0, 1, '') ;

CALL ImportField(30210105, '', 'BUDGETREF', '', 'BudgetRef', 1, 302, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(30210122, '  ', 'SENDERID', '  ', 'SenderID', 1, 302, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(30210123, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 302, 0, 1, '', 0, 18970, 0, 1, '') ;

CALL ImportField(30210136, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 302, 0, 1, '', 0, 18960, 0, 1, '') ;

CALL ImportField(30210193, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 302, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30210194, '', 'AUTO_AUTORIZATION', '', ' ', 1, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210195, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210196, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30210197, '  ()', 'CREATEDATE', '  ()', ' ', 1, 302, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211001, '', 'SOURCESUBKESR', '', 'SOURCESUBKESRKey', 1, 302, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(30211003, '', 'SOURCEKVR', '', 'SourceKVRKey', 1, 302, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(30211004, '', 'SOURCEKESR', '', 'SourceKESRKey', 1, 302, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(30211005, '()', 'SOURCEKFSR', '', 'SourceKFSR', 1, 302, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(30211006, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 1, 302, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(30211007, '', 'SOURCEKVSR', ' ', 'SourceKVSRKey', 1, 302, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(30211013, ' ()', 'SUMMA', '', 'SUMMA', 1, 302, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(30211037, '', 'NOTE', ' ()', 'NOTE', 1, 302, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(30211040, '\ ', ' ', '\ ', 'SourceFacialAccCls', 1, 302, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30211043, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 302, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30211131, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 302, 1, 1, '', 0, 18877, 0, 1, '') ;

CALL ImportField(30211140, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 302, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(30211142, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 302, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(30211143, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 302, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(30211147, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 302, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30211149, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 302, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(30211156, '', 'SourceInvestObject', '', 'SourceInvestObjectKey', 1, 302, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30211157, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 1, 302, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30211184, ' ', 'SourceTargetCls', '  ()', 'SourceTargetCLSKey', 1, 302, 1, 1, '', 0, 40642, 30211158, 1, '') ;

CALL ImportField(30211194, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 1, 302, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30211195, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 1, 302, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30211196, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 1, 302, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30211197, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 302, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30211198, '', 'AUTO_AUTORIZATION', '', ' ', 1, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211199, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211200, '  ()', 'CREATEDATE', '  ()', ' ', 1, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211201, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 302, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30211220, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 302, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(30211222, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 1, 302, 1, 0, '', 0, 43610, 0, 0, '') ;

--   \, +(2)
CALL ImportField(30210003, ' / ', 'ACC', ' / ', 'DestAccountName', 2, 302, 0, 0, '', 0, 17112, 30210153, 1, '') ;

CALL ImportField(30210013, '/ ', 'DESTACCOUNT', '/ ', 'DESTACCOUNT', 2, 302, 0, 1, '', 0, 18958, 0, 0, '') ;

CALL ImportField(30210030, '/  ()', 'SOURCEACCOUNTNAME', '/  ()', 'SourceAccountName', 2, 302, 0, 0, '', 0, 17112, 30210154, 1, '') ;

CALL ImportField(30210043, '   ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 2, 302, 0, 1, ',', 0, 18956, 0, 0, '') ;

CALL ImportField(30210064, ' ', ' ', ' ', 'SourceFKFacialCode', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210072, '  ', ' ', '  ', 'SourceBankName', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210073, '  ', ' ', '  ', 'SourceBankBIK', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210074, '.  ', ' ', '.  ', 'SourceBankCor', 2, 302, 0, 1, '', 1, null, 30210154, 1, '') ;

CALL ImportField(30210091, '  ', ' ', '  ', 'DestBankName', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210092, '  ', ' ', '  ', 'DestBankBIK', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210093, '.  ', ' ', '.  ', 'DestBankCor', 2, 302, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(30210153, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 2, 302, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30210154, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 2, 302, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30210163, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 2, 302, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30210166, ' ', '', ' ', 'SourceINN', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210167, ' ', '', ' ', 'SourceKPP', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210168, ' ', '', ' ', 'SourceName', 2, 302, 0, 0, '', 0, null, 30210154, 1, '') ;

CALL ImportField(30210175, ' ', '', ' ', 'DestName', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210176, '  ', '', '  ', 'DestINN', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210177, ' ', '', ' ', 'DetKPP', 2, 302, 0, 0, '', 0, null, 30210153, 1, '') ;

CALL ImportField(30210198, ' ', '', ' ', 'SourceLSFK', 2, 302, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30210199, ' ', '', ' ', 'DestLSFK', 2, 302, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30211158, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 2, 302, 1, 0, '', 0, null, 0, 2, '') ;

--  (), (1)
CALL ImportField(30310035, '  ', 'FEDERALFUNDSName', '  ', 'FEDERALFUNDSREESTR', 1, 303, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30310067, 'CRYPTOSTATUS', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310083, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 303, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30310084, '', 'AUTO_AUTORIZATION', '', ' ', 1, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310085, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310086, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30310087, '  ()', 'CREATEDATE', '  ()', ' ', 1, 303, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311014, '()', 'DestKFSR', '', 'DestKFSR', 1, 303, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(30311015, '', 'DestKCSR', '', 'DestKCSRKey', 1, 303, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(30311016, ' ', 'DESTKVR', ' ', 'DESTKVRKey', 1, 303, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(30311017, '', 'DESTKESR', '', 'DESTKESRKey', 1, 303, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(30311022, '', 'DestSubKESR', '', 'DestSubKESRKey', 1, 303, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(30311032, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 303, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(30311036, '', 'DestKVSR', '', 'DestKVSRKey', 1, 303, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(30311074, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 303, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(30311075, ' ()', 'DESTKVRCode', ' ()', 'DESTKVR', 1, 303, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(30311076, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 303, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(30311080, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 303, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(30311087, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 303, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(30311095, '', 'DestInvestObject', '', 'DestInvestObjectKey', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311096, '', 'DestInvestObjectCode', '', 'DestInvestObject', 1, 303, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30311097, '', 'DestContractCostsCLSCode', '', 'DestContractCostsCls', 1, 303, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30311098, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311099, '  ', 'DestBudgetPromiseAgrDate', '  ', 'DestBudgetPromiseAgrDate', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311100, '  ', 'DestBudgetPromiseAgrNote', '  ', 'DestBudgetPromiseAgrNote', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311101, '  ', 'DestBudgetPromiseAgrNum', '  ', 'DestBudgetPromiseAgrNum', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311102, '   ', 'DestBudgetPromiseAgrRNum', '   ', 'DestBudgetPromiseAgrReestrNum', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311103, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 1, 303, 1, 1, '', 0, 20242, 0, 0, '') ;

CALL ImportField(30311104, '  ', 'DestBudgetPromiseAgrSumma', '  ', 'DestBudgetPromiseAgrSumma', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311105, '(.  )', 'DestExecDocDate', '', 'DestExecDocDate', 1, 303, 1, 1, '', 0, 19740, 0, 0, '') ;

CALL ImportField(30311106, '(.  )', 'DestExecDocNote', '', 'DestExecDocNote', 1, 303, 1, 1, '', 0, 19762, 0, 0, '') ;

CALL ImportField(30311107, ' (.  )', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 1, 303, 1, 1, '', 0, 19756, 0, 0, '') ;

CALL ImportField(30311108, '(.  )', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 1, 303, 1, 1, '', 0, 19744, 0, 0, '') ;

CALL ImportField(30311109, '(.  )', 'DestExecDocType', '  ', 'DestExecDocType', 1, 303, 1, 1, '', 0, 19738, 0, 0, '') ;

CALL ImportField(30311110, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 1, 303, 1, 0, '', 0, 18906, 0, 0, '') ;

CALL ImportField(30311111, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 1, 303, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30311112, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 1, 303, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30311113, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 303, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30311114, '', 'AUTO_AUTORIZATION', '', ' ', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311115, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311116, '  ()', 'CREATEDATE', '  ()', ' ', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311117, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 303, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30311118, '()', 'DESTKESRCode', '()', 'DESTKESR', 1, 303, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(30311119, '()', 'DestSubKESRCode', '()', 'DestSubKESR', 1, 303, 1, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(30410001, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 304, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(30410002, '', 'ARHIVEDOC', ' ', 'ARHIVEDOC', 1, 304, 0, 0, ',', 0, 18961, 0, 1, '') ;

CALL ImportField(30410004, '', 'PERIOD', '', 'Period', 1, 304, 0, 0, '', 0, 18965, 0, 1, '') ;

CALL ImportField(30410005, '  ()', 'BUHPAYMENTCLS', ' ', 'BUHPAYMENTCLS', 1, 304, 0, 0, '', 0, 18968, 0, 1, '') ;

CALL ImportField(30410006, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 304, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(30410007, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 1, 304, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(30410008, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 1, 304, 0, 0, '', 0, 18972, 0, 1, '') ;

CALL ImportField(30410009, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 1, 304, 0, 1, '', 0, 19091, 0, 1, '') ;

CALL ImportField(30410010, '()', 'SUMMA', '', 'SUMMA', 1, 304, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(30410011, ' ', 'TRUSTNUMBER', ' ', 'TrustNumber', 1, 304, 0, 0, '', 0, 18976, 0, 1, '') ;

CALL ImportField(30410012, ' ()', 'ACC', ' ', 'DestAccountName', 1, 304, 0, 0, '', 0, 17112, 0, 1, '') ;

CALL ImportField(30410013, '()', 'NAME', '', 'SourceBankFUID', 1, 304, 0, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(30410014, ' ()', 'INN20', ' ', 'DestOrgKPP', 1, 304, 0, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(30410015, ' ()', 'INN', ' ', 'DestOrgINN', 1, 304, 0, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(30410016, '/  ()', 'SOURCEACCOUNTNAME', '/  ()', 'SourceAccountName', 1, 304, 0, 0, '', 0, 17112, 0, 1, '') ;

CALL ImportField(30410017, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 1, 304, 0, 0, '', 0, 18957, 0, 1, '') ;

CALL ImportField(30410018, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 304, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(30410019, ' ', 'DOCNUMBER', ' ', 'DocumentNumber', 1, 304, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(30410020, ' ', 'NOTE', ' ', 'NOTE', 1, 304, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(30410021, '', 'DEPARTMENTCLS', '', 'DEPARTMENTCLS', 1, 304, 0, 1, '', 0, 18989, 0, 1, '') ;

CALL ImportField(30410022, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 1, 304, 0, 0, '', 0, 19090, 0, 1, '') ;

CALL ImportField(30410024, '/ () ', 'DESTFACIALACC_CLS', '/  ()', 'DestFacialAccCls', 1, 304, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(30410028, ' ', 'PayDate', ' ', 'PayDate', 1, 304, 0, 1, '', 0, 18951, 0, 1, '') ;

CALL ImportField(30410030, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 1, 304, 0, 1, '', 0, 18963, 0, 1, '') ;

CALL ImportField(30410031, '', 'PayPriority', '', 'PayPriority', 1, 304, 0, 1, '', 0, 18966, 0, 1, '') ;

CALL ImportField(30410033, '  ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 1, 304, 0, 1, ',', 0, 18956, 0, 1, '') ;

CALL ImportField(30410034, '', 'DocStateRef', ' ', 'DocStateRef', 1, 304, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(30410035, '  ', ' ', '  ', 'IsInBudget', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410036, ' ', ' ', ' ', 'DocSuspended', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410037, ' ', ' ', ' ', 'IsVised', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410038, '   ', 'ManagerBid', ' ', 'ManagerBid', 1, 304, 0, 1, '', 0, 18992, 0, 1, '') ;

CALL ImportField(30410039, '  ', ' ', '  ', 'LASTEXTRCHANGE', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410040, ' ', 'StimateID', ' ', 'StimateID', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410043, '  ', ' ', '  ', 'ManBidFuid', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410044, ' ', 'Reestr_Ref', ' ', 'Reestr_Ref', 1, 304, 0, 1, '', 0, 18971, 0, 1, '') ;

CALL ImportField(30410045, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 1, 304, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(30410046, '  ', ' ', '  ', 'SoftRejectCls', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410047, '   ', ' ', '   ', 'SoftRejectCause', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410049, '  ', ' ', '  ', 'RequestNumber', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410050, '  ', ' ', '  ', 'RequestDate', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410051, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410052, ' ', ' ', ' ', 'SourceFKFacialCode', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410053, '   ', ' ', '   ', 'SourceOrgId', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410054, '    ', ' ', '    ', 'SourceOrgFUID', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410055, ' -', ' ', ' -', 'SourceOrgINN', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410056, ' -', ' ', ' -', 'SourceOrgKPP', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410057, ' -', ' ', ' -', 'SourceOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410058, ' -', ' ', ' -', 'SourceOrgCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410059, '  ', ' ', '  ', 'SourceBankName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410060, '  ', ' ', '  ', 'SourceBankBIK', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410061, '.  ', ' ', '.  ', 'SourceBankCor', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410062, '   ', ' ', '   ', 'SourceBankCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410063, '\ ', ' ', '\ ', 'SourceFacialAccClsName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410064, ' \ ', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 1, 304, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30410065, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410066, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410067, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410068, '   ', ' ', '   ', 'SourceFKOrgINN', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410069, '   ', ' ', '   ', 'SourceFKOrgKPP', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410070, '  ', ' ', '  ', 'SourceFKOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410071, '   ', ' ', '   ', 'SourceFKOrgCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410073, ' ', ' ', ' ', 'DestBankDepartmentNumber', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410074, ' ', ' ', ' ', 'DestFKFacialCode', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410075, '   ', ' ', '   ', 'DestOrgId', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410076, '    ', ' ', '    ', 'DestOrgFUID', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410079, ' -', ' ', ' -', 'DestOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410080, ' -', ' ', ' -', 'DestOrgCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410081, ' ', ' ', ' ', 'DestBankFUID', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410082, '  ', ' ', '  ', 'DestBankName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410083, '  ', ' ', '  ', 'DestBankBIK', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410084, '.  ', ' ', '.  ', 'DestBankCor', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410085, '   ', ' ', '   ', 'DestBankCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410086, '\  ()', ' ', '\ ', 'DestFacialAccClsName', 1, 304, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30410087, ' \  ()', ' ', ' \ ', 'DestFacialAccClsFacialCode', 1, 304, 0, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30410088, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410089, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410090, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410091, '   ', ' ', '   ', 'DestFKOrgINN', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410092, '   ', ' ', '   ', 'DestFKOrgKPP', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410093, '  ', ' ', '  ', 'DestFKOrgName', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410094, '   ', ' ', '   ', 'DestFKOrgCity', 1, 304, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30410095, '', 'BUDGETREF', '', 'BudgetRef', 1, 304, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(30410096, ' ', 'OperationDirection', ' ', 'OperationDirection', 1, 304, 0, 0, '', 0, 19009, 0, 1, '') ;

CALL ImportField(30410104, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 1, 304, 0, 0, '', 0, 19008, 0, 1, '') ;

CALL ImportField(30410105, ' ', 'ID', ' ', 'ID', 1, 304, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(30410107, ' ', 'DestAccount', ' ', 'DESTACCOUNT', 1, 304, 0, 1, '', 0, 18958, 0, 1, '') ;

CALL ImportField(30410115, '  ', 'SENDERID', '  ', 'SenderID', 1, 304, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(30410116, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 304, 0, 1, '', 0, 18970, 0, 1, '') ;

CALL ImportField(30410122, ' ', 'CashierPersonalInfo', ' ', 'CashierPersonalInfo', 1, 304, 0, 0, '', 0, 24731, 0, 1, '') ;

CALL ImportField(30410128, '  ', 'RegionBudgetEst', '  ', 'RegionBudgetEst', 1, 304, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30410129, ' ', 'CardNumber', '   ()', 'CARDNUMBER', 1, 304, 0, 0, '', 0, 18985, 0, 1, '') ;

CALL ImportField(30410141, ' ()', 'CardRef', '  ', 'CardRef', 1, 304, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30410142, ' ', 'CardRefName', '  ', 'CardRefName', 1, 304, 0, 0, '', 0, 18939, 0, 1, '') ;

CALL ImportField(30410146, '', 'Signers', '', 'Signers', 1, 304, 0, 0, '', 0, 38174, 0, 1, '') ;

CALL ImportField(30410147, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 304, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30410148, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 304, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30410149, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 1, 304, 0, 0, '', 0, 31659, 0, 2, '') ;

CALL ImportField(30410150, '  ', 'StoredPaymentProps', '', ' ', 1, 304, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30410151, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 304, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30410152, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 304, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30410153, '', 'AUTO_AUTORIZATION', '', ' ', 1, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30410154, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30410155, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30410156, '  ()', 'CREATEDATE', '  ()', ' ', 1, 304, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411001, '', 'SOURCEFACTCODE', '', 'SOURCEFACTCLS', 1, 304, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(30411002, ' ', 'NOTE', ' ', 'NOTE', 1, 304, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(30411004, ' O ', 'SOURCEPROMISE', '  ', 'SOURCEPROMISE', 1, 304, 1, 0, '', 0, 18905, 0, 1, '') ;

CALL ImportField(30411005, ' ', 'PAYSYMBOLCLS', ' ', 'PaySymbolCls', 1, 304, 1, 0, '', 0, 18874, 0, 1, '') ;

CALL ImportField(30411006, '()', 'SUMMA', '', 'SUMMA', 1, 304, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(30411007, ' ', 'SOURCEDOCTYPE', ' ', 'SOURCEDOCTYPECLS', 1, 304, 1, 0, '', 0, 18894, 0, 1, '') ;

CALL ImportField(30411008, ' . ', 'SOURCEFINTYPECODE', '  ', 'SOURCEFINTYPECLS', 1, 304, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(30411009, ' ', 'SOURCEFINSOURCE', ' ', 'SOURCEFINSOURCECLS', 1, 304, 1, 0, '', 0, 18892, 0, 1, '') ;

CALL ImportField(30411010, '', 'SourceDirectionClsCode', '', 'SourceDirectionCLS', 1, 304, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(30411011, '', 'SOURCEKVSR', ' ', 'SourceKVSRKey', 1, 304, 1, 1, '', 0, 18886, 0, 1, '') ;

CALL ImportField(30411012, '', 'SOURCEKCSR', '', 'SourceKCSRKey', 1, 304, 1, 1, '', 0, 18887, 0, 1, '') ;

CALL ImportField(30411013, '()', 'SOURCEKFSR', '', 'SourceKFSR', 1, 304, 1, 0, '', 0, 18888, 0, 1, '') ;

CALL ImportField(30411014, '', 'SOURCEKESR', '', 'SourceKESRKey', 1, 304, 1, 1, '', 0, 18868, 0, 1, '') ;

CALL ImportField(30411015, '', 'SOURCEKVR', '', 'SourceKVRKey', 1, 304, 1, 1, '', 0, 18867, 0, 1, '') ;

CALL ImportField(30411016, '', 'SOURCESUBKESR', '', 'SOURCESUBKESRKey', 1, 304, 1, 1, '', 0, 18889, 0, 1, '') ;

CALL ImportField(30411017, ' ', 'SOURCEMEANSTYPE', ' ', 'SOURCEMEANSTYPECLS', 1, 304, 1, 0, '', 0, 18891, 0, 1, '') ;

CALL ImportField(30411018, '', 'SourceDocBaseCode', '', 'SourceDocBase', 1, 304, 1, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(30411020, '.   ', 'SourceBudgetPromise', '     ', 'SOURCEBUDGETPROMISE', 1, 304, 1, 1, ',', 0, 18908, 0, 1, '') ;

CALL ImportField(30411022, ' ..  ', 'SourceExecDoc', '    ', 'SourceExecDoc', 1, 304, 1, 1, '', 0, 18917, 0, 1, '') ;

CALL ImportField(30411023, '(.  )', 'SourceExecDocNum', '   ', 'SourceExecDocNum', 1, 304, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(30411024, ' (.  )', 'SourceExecDocReestr', '   ', 'SourceExecDocReestr', 1, 304, 1, 1, '', 0, 19756, 0, 1, '') ;

CALL ImportField(30411025, '(.  )', 'SourceExecDocDate', '  ', 'SourceExecDocDate', 1, 304, 1, 1, '', 0, 19740, 0, 1, '') ;

CALL ImportField(30411026, '(.  )', 'SourceExecDocType', '  ', 'SourceExecDocType', 1, 304, 1, 1, '', 0, 19738, 0, 1, '') ;

CALL ImportField(30411027, '(.  )', 'SourceExecDocSumma', '   ', 'SourceExecDocSumma', 1, 304, 1, 1, '', 0, 19744, 0, 1, '') ;

CALL ImportField(30411028, '(.  )', 'SourceExecDocNote', '  ', 'SourceExecDocNote', 1, 304, 1, 1, '', 0, 19762, 0, 1, '') ;

CALL ImportField(30411042, '\ ', ' ', '\ ', 'SourceFacialAccCls', 1, 304, 1, 0, '', 1, null, 0, 1, '') ;

CALL ImportField(30411043, ' ', 'SourceRegionCLS', '', 'SourceRegionCls', 1, 304, 1, 1, ',', 0, 18927, 0, 1, '') ;

CALL ImportField(30411044, ' ', ' ', ' ', 'StimateId', 1, 304, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30411045, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 304, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30411046, ' ', 'ClsType', ' (, , )', 'ClsType', 1, 304, 1, 1, '', 0, 18922, 0, 1, '') ;

CALL ImportField(30411049, ' ( . - )', 'SourceBudgetPromiseSumma', ' ', 'SourceBudgetPromiseSumma', 1, 304, 1, 1, '', 0, 20242, 0, 1, '') ;

CALL ImportField(30411050, ' ', 'SourceBudgetPromiseAgrNum', ' ', 'SourceBudgetPromiseAgrNum', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411051, ' ', 'SourceBudgetPromiseAgrDate', ' ', 'SourceBudgetPromiseAgrDate', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411052, ' ', 'SourceBudgetPromiseAgrSumma', ' ', 'SourceBudgetPromiseAgrSumma', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411053, '  .', 'SourceBudgetPromiseAgrRNum', '  .', 'SourceBudgetPromiseAgrReestrNum', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411054, '. ', 'SourceBudgetPromiseAgrNote', '. ', 'SourceBudgetPromiseAgrNote', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411055, ' . ', 'SourceBudgetPromiseSONum', ' . ', 'SourceBudgetPromiseAgrNum', 1, 304, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(30411056, ' . ', 'SourceBudgetPromiseSODate', ' . ', 'SourceBudgetPromiseAgrDate', 1, 304, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(30411058, '  . ', 'SourceBudgetPromiseSORNum', '  . ', 'SourceBudgetPromiseAgrReestrNum', 1, 304, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(30411059, '. . ', 'SourceBudgetPromiseSONote', '. . ', 'SourceBudgetPromiseAgrNote', 1, 304, 1, 1, '', 0, 19821, 0, 1, '') ;

CALL ImportField(30411078, ' ()', 'SourceIFS_DescriptionCode', '  ( )', 'SourceIFS_DescriptionCode', 1, 304, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(30411103, ' ', 'SourceFundsSource', ' ', 'SourceFundsSource', 1, 304, 1, 0, '', 0, 18930, 0, 1, '') ;

CALL ImportField(30411110, ' ', 'SourceIFS', ' ', 'SourceIFS', 1, 304, 1, 1, ',', 0, 18920, 0, 1, '') ;

CALL ImportField(30411111, ' ', 'SourceKD', ' ', 'SourceKD', 1, 304, 1, 1, '', 0, 18925, 0, 1, '') ;

CALL ImportField(30411113, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 304, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(30411114, ' ', 'ID', ' ', 'Id', 1, 304, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(30411123, ' ', 'SourceKD_Value', ' ', 'SourceKDValue', 1, 304, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(30411127, '  ', 'SourceTransfertCls', '   ()', 'SourceTransfertCls', 1, 304, 1, 1, '', 0, 18935, 0, 1, '') ;

CALL ImportField(30411128, '  ', 'SourceTransfertClsCode', '  ', 'SourceTransfertClsValue', 1, 304, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(30411130, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 304, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30411132, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 304, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30411133, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 304, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30411134, ' ', 'SourceSubsidyCls', '  ()', 'SourceSubsidyCls', 1, 304, 1, 1, '', 0, 26626, 0, 1, '') ;

CALL ImportField(30411135, ' ', 'SourceSubsidyClsCode', ' ', 'SourceSubsidyClsCode', 1, 304, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(30411137, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 304, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30411138, '  ', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 1, 304, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(30411139, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 304, 1, 1, '', 0, 27844, 0, 1, '') ;

CALL ImportField(30411140, '  ', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 1, 304, 1, 1, '', 0, 27845, 0, 1, '') ;

CALL ImportField(30411141, '()', 'SourceFact', '', 'SourceFACTCLSKey', 1, 304, 1, 1, '', 0, 18890, 0, 1, '') ;

CALL ImportField(30411143, ' .  ()', 'SOURCEFINTYPE', '  ', 'SourceFINTYPECLSKey', 1, 304, 1, 1, ',', 0, 18893, 0, 1, '') ;

CALL ImportField(30411145, '', 'SourceInvestObject', '', 'SourceInvestObjectKey', 1, 304, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30411146, '', 'SourceInvestObjectCode', '', 'SourceInvestObject', 1, 304, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30411147, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 1, 304, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30411148, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 1, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411149, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 304, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30411150, ' ', 'SourceTargetCls', '  ()', 'SourceTargetClsKey', 1, 304, 1, 1, '', 0, 40642, 0, 0, '') ;

CALL ImportField(30411151, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 1, 304, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30411152, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 304, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30411153, '', 'AUTO_AUTORIZATION', '', ' ', 1, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411154, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411155, '  ()', 'CREATEDATE', '  ()', ' ', 1, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411156, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 304, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30411176, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 304, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30411178, '()', 'SourceSubKESRCode', '()', 'SOURCESUBKESR', 1, 304, 1, 0, '', 0, 43610, 0, 0, '') ;

--   \, (1)
CALL ImportField(30510001, ' ', 'ID', ' ', 'ID', 1, 305, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(30510002, ' /', 'DOCNUMBER', ' ', 'DocumentNumber', 1, 305, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(30510003, '  ', ' ', '  ', 'FUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510004, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 305, 0, 1, '', 0, 18970, 0, 1, '') ;

CALL ImportField(30510005, '  ', 'SENDERID', '  ', 'SenderID', 1, 305, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(30510006, ' /', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 305, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(30510007, ' ', 'PAYDATE', ' ', 'PayDate', 1, 305, 0, 0, '', 0, 18951, 0, 1, '') ;

CALL ImportField(30510008, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 305, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(30510009, '()', 'SUMMA', '', 'SUMMA', 1, 305, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(30510011, ' ', 'PAYTYPECLS', ' ', 'PAYTYPECLS', 1, 305, 0, 0, '', 0, 18963, 0, 1, '') ;

CALL ImportField(30510012, ' ', 'NOTE', ' ', 'NOTE', 1, 305, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(30510013, '', 'PAYPRIORITY', ' ', 'PayPriority', 1, 305, 0, 0, '', 0, 18966, 0, 1, '') ;

CALL ImportField(30510014, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 305, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(30510015, '  ()', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 1, 305, 0, 0, '', 0, 18968, 0, 1, '') ;

CALL ImportField(30510016, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 1, 305, 0, 0, '', 0, 18972, 0, 1, '') ;

CALL ImportField(30510017, '  ()', 'REJECTCAUSE', '  ', 'RejectCause', 1, 305, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(30510018, '  ', 'SOURCEACCOUNT', '  ', 'SOURCEACCOUNT', 1, 305, 0, 1, '', 0, 18956, 0, 1, '') ;

CALL ImportField(30510019, '/ ', 'SOURCEFACIALACC_CLS', '\ ', 'SourceFacialAccCls', 1, 305, 0, 0, '', 0, 18957, 0, 1, '') ;

CALL ImportField(30510020, '   ', 'DESTACCOUNT', '   ', 'DESTACCOUNT', 1, 305, 0, 1, ',', 0, 18958, 0, 1, '') ;

CALL ImportField(30510021, '/ ', 'DESTFACIALACC_CLS', '\ ', 'DestFacialAccCls', 1, 305, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(30510022, '', 'DocStateRef', ' ', 'DocStateRef', 1, 305, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(30510023, '  ', ' ', '  ', 'BeginDocStateRef', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510024, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 1, 305, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(30510025, '/ ', 'SourceAccountName', '/ ', 'SourceAccountName', 1, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30510026, ' ', 'SourceFACIALCODE', ' ', 'SourceFKFacialCode', 1, 305, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30510027, ' ', 'DestAccountName', ' ', 'DestAccountName', 1, 305, 0, 0, '', 0, 17112, 0, 1, '') ;

CALL ImportField(30510028, '/   ', 'DestFACIALCODE', ' ', 'DestFKFacialCode', 1, 305, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30510030, '()', 'INN', ' -', 'DestOrgINN', 1, 305, 0, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(30510032, '()', 'INN20', ' -', 'DestOrgKPP', 1, 305, 0, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(30510034, '()', 'NAME', ' -', 'SourceOrgName', 1, 305, 0, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(30510035, '  ', ' ', '  ', 'IsInBudget', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510036, ' ', ' ', ' ', 'DocSuspended', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510037, ' ', ' ', ' ', 'IsVised', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510039, ' ', ' ', ' ', 'ManagerBid', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510040, '  ', ' ', '  ', 'LASTEXTRCHANGE', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510043, '  ', ' ', '  ', 'ManBidFuid', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510045, '  ', ' ', '  ', 'SoftRejectCls', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510046, '   ', ' ', '   ', 'SoftRejectCause', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510047, '  /c  ', ' ', '  /c  ', 'SourceAccountFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510048, ' ', ' ', ' ', 'SourceBankDepartmentNumber', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510049, '   ', ' ', '   ', 'SourceOrgId', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510050, '   ( )', ' ', '   ( )', 'SourceOrgFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510051, ' -', ' ', ' -', 'SourceOrgINN', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510052, ' -', ' ', ' -', 'SourceOrgKPP', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510053, ' -', ' ', ' -', 'SourceOrgCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510054, ' ', ' ', ' ', 'SourceBankFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510055, '  ', ' ', '  ', 'SourceBankName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510056, '  ', ' ', '  ', 'SourceBankBIK', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510057, '.  ', ' ', '.  ', 'SourceBankCor', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510058, '   ', ' ', '   ', 'SourceBankCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510059, ' \  ()', ' ', ' \  ()', 'SourceFacialAccClsName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510060, ' \  ()', ' ', ' \ ', 'SourceFacialAccClsFacialCode', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510061, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgINN', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510062, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgKPP', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510063, ' - \ ', ' ', ' - \ ', 'SourceFacialAccClsOrgName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510064, '  ()', ' ', '  ()', 'SourceFKOrgId', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510065, '   ', ' ', '   ', 'SourceFKOrgFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510066, '   ', ' ', '   ', 'SourceFKOrgINN', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510067, '   ', ' ', '   ', 'SourceFKOrgKPP', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510068, '  ', ' ', '  ', 'SourceFKOrgName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510069, '   ', ' ', '   ', 'SourceFKOrgCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510070, '    ', ' ', '    ', 'DestAccountFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510071, ' ', ' ', ' ', 'DestBankDepartmentNumber', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510072, '   ', ' ', '   ', 'DestOrgId', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510073, '    ', ' ', '    ', 'DestOrgFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510074, ' -', ' ', ' -', 'DestOrgName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510075, ' -', ' ', ' -', 'DestOrgCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510076, ' ', ' ', ' ', 'DestBankFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510077, '  ', ' ', '  ', 'DestBankName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510078, '  ', ' ', '  ', 'DestBankBIK', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510079, '.  ', ' ', '.  ', 'DestBankCor', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510080, '   ', ' ', '   ', 'DestBankCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510081, ' \ ', ' ', ' \ ', 'DestFacialAccClsName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510082, ' \ ', ' ', ' \ ', 'DestFacialAccClsFacialCode', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510083, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgINN', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510084, ' - \ ', ' ', ' - \ ', 'DestFacialAccClsOrgKPP', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510085, '   \ ', ' ', '   \ ', 'DestFacialAccClsOrgName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510086, '  ()', ' ', '  ()', 'DestFKOrgId', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510087, '   ', ' ', '   ', 'DestFKOrgFUID', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510088, '   ', ' ', '   ', 'DestFKOrgINN', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510089, '   ', ' ', '   ', 'DestFKOrgKPP', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510090, '  ', ' ', '  ', 'DestFKOrgName', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510091, '   ', ' ', '   ', 'DestFKOrgCity', 1, 305, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30510096, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 305, 0, 0, '', 0, 18961, 0, 1, '') ;

CALL ImportField(30510099, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 1, 305, 0, 0, '', 0, 19009, 0, 1, '') ;

CALL ImportField(30510100, '', 'BUDGETREF', '', 'BudgetRef', 1, 305, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(30510108, '   ', 'TaxNote', '   ', 'TaxNote', 1, 305, 0, 0, '', 0, 18991, 0, 1, '') ;

CALL ImportField(30510114, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 1, 305, 0, 0, '', 0, 19008, 0, 1, '') ;

CALL ImportField(30510165, ' ()', 'CardRef', '  ', 'CardRef', 1, 305, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30510166, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 305, 0, 0, '', 0, 31657, 0, 1, '') ;

CALL ImportField(30510167, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 305, 0, 0, '', 0, 31658, 0, 1, '') ;

CALL ImportField(30510169, '  ', 'CardRefName', '  ', 'CardRefName', 1, 305, 0, 0, '', 0, 18939, 0, 1, '') ;

CALL ImportField(30510170, '', 'UINCode', '  ', 'UINCode', 1, 305, 0, 0, '', 0, 35367, 0, 1, '') ;

CALL ImportField(30510173, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 305, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30510174, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 305, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30510175, '', 'AUTO_AUTORIZATION', '', ' ', 1, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30510176, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30510177, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30510178, '  ()', 'CREATEDATE', '  ()', ' ', 1, 305, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511001, ' ', 'ID', ' ', 'Id', 1, 305, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(30511002, '  ', ' ', '  ', 'FUID', 1, 305, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30511003, '  ', ' ', '  ', 'SenderRecordID', 1, 305, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30511004, '  ', ' ', '  ', 'SenderID', 1, 305, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30511005, '()', 'SUMMA', '', 'SUMMA', 1, 305, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(30511006, ' ', 'NOTE', ' ', 'NOTE', 1, 305, 1, 1, '', 0, 18876, 0, 1, '') ;

CALL ImportField(30511008, ' ', 'RECORDINDEX', '  ', 'RecordIndex', 1, 305, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(30511009, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 1, 305, 1, 0, '', 0, 18906, 0, 1, '') ;

CALL ImportField(30511010, ' ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DestBudgetPROMISENum', 1, 305, 1, 0, ',', 0, 20223, 0, 1, '') ;

CALL ImportField(30511011, '.   ', 'DESTBUDGETPROMISE', '  ', 'DestBUDGETPROMISE', 1, 305, 1, 1, ',', 0, 18909, 0, 1, '') ;

CALL ImportField(30511012, ' ', 'DestFacialAcc_Cls', '\ ', 'DestFacialAccCls', 1, 305, 1, 1, '', 0, 18869, 0, 1, '') ;

CALL ImportField(30511013, '', 'DESTKVR', ' ', 'DestKVRKey', 1, 305, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30511014, '', 'DESTKESR', '', 'DestKESRKey', 1, 305, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30511015, '', 'DestKVSR', ' ', 'DestKVSRKey', 1, 305, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30511016, '', 'DestKCSR', ' ', 'DestKCSRKey', 1, 305, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30511017, '()', 'DestKFSR', ' ', 'DestKFSR', 1, 305, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30511018, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 305, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30511019, '', 'DestFactCode', ' ', 'DestFACTCLS', 1, 305, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(30511020, ' ', 'DestMeansType', '  ', 'DestMEANSTYPECLS', 1, 305, 1, 0, '', 0, 18900, 0, 1, '') ;

CALL ImportField(30511021, ' ', 'DestFinSource', '  ', 'DestFINSOURCECLS', 1, 305, 1, 0, '', 0, 18901, 0, 1, '') ;

CALL ImportField(30511022, ' . ', 'DestFinTypeCode', '  ', 'DestFINTYPECLS', 1, 305, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(30511023, ' ', 'DestDocType', '  ', 'DestDOCTYPECLS', 1, 305, 1, 0, '', 0, 18903, 0, 1, '') ;

CALL ImportField(30511024, '', 'DestDirectionCLSCode', ' ', 'DestDirectionCLS', 1, 305, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(30511025, ' ', ' ', ' ', 'StimateID', 1, 305, 1, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(30511027, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 1, 305, 1, 1, '', 0, 18918, 0, 1, '') ;

CALL ImportField(30511028, '(.  )', 'DestExecDocNum', '', 'DestExecDocNum', 1, 305, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(30511029, ' (.  )', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 1, 305, 1, 1, '', 0, 19756, 0, 1, '') ;

CALL ImportField(30511030, '(.  )', 'DestExecDocDate', '', 'DestExecDocDate', 1, 305, 1, 1, '', 0, 19740, 0, 1, '') ;

CALL ImportField(30511031, '(.  )', 'DestExecDocType', '  ', 'DestExecDocType', 1, 305, 1, 1, '', 0, 19738, 0, 1, '') ;

CALL ImportField(30511032, '(.  )', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 1, 305, 1, 1, '', 0, 19744, 0, 1, '') ;

CALL ImportField(30511033, '(.  )', 'DestExecDocNote', '', 'DestExecDocNote', 1, 305, 1, 1, '', 0, 19762, 0, 1, '') ;

CALL ImportField(30511035, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 305, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30511036, ' ', 'ClsType', ' (, , )', 'ClsType', 1, 305, 1, 1, ',', 0, 18922, 0, 1, '') ;

CALL ImportField(30511037, '  ', 'DestBudgetPromiseAgrNote', '  ', 'DestBudgetPromiseAgrNote', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511038, '   ', 'DestBudgetPromiseAgrRNum', '   ', 'DestBudgetPromiseAgrReestrNum', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511039, '  ', 'DestBudgetPromiseAgrSumma', '  ', 'DestBudgetPromiseAgrSumma', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511040, '  ', 'DestBudgetPromiseAgrDate', '  ', 'DestBudgetPromiseAgrDate', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511041, '  ', 'DestBudgetPromiseAgrNum', '  ', 'DestBudgetPromiseAgrNum', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511042, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 1, 305, 1, 1, '', 0, 20242, 0, 1, '') ;

CALL ImportField(30511045, ' ', 'DestIFS', '   .  . -', 'DestIFS', 1, 305, 1, 1, ',', 0, 18921, 0, 1, '') ;

CALL ImportField(30511046, ' ()', 'DestIFS_DescriptionCode', ' ( )', 'DestIFS_DescriptionCode', 1, 305, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(30511103, '', 'DestDocBaseCode', '', 'DestDocBase', 1, 305, 1, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(30511104, ' ', 'DestRegionCls', '', 'DestRegionCls', 1, 305, 1, 0, ',', 0, 18928, 0, 1, '') ;

CALL ImportField(30511116, ' ', 'DestKD', ' ', 'DestKD', 1, 305, 1, 1, '', 0, 18926, 0, 1, '') ;

CALL ImportField(30511123, ' ', 'DestIFS_FullID', 'DestIFS_FullID( )', 'DestIFS_DescriptionCode', 1, 305, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30511124, ' ', 'DestKD_Value', ' ', 'DestKDValue', 1, 305, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(30511127, '  ', 'DestTransfertCls', '   ()', 'DestTransfertCls', 1, 305, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(30511128, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 1, 305, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(30511130, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 305, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30511132, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 305, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30511133, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 305, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30511134, ' ', 'DestFundsSource', ' ', 'DestFundsSource', 1, 305, 1, 0, '', 0, 18929, 0, 1, '') ;

CALL ImportField(30511136, ' ', 'DestSubsidyClsCode', ' ', 'DestSubsidyClsCode', 1, 305, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(30511138, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 305, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30511139, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 305, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(30511140, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 305, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30511141, '  ', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 1, 305, 1, 1, '', 0, 27843, 0, 1, '') ;

CALL ImportField(30511142, ' ()', 'DestFact', '', 'DestFACTCLSKey', 1, 305, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30511144, ' .  - ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 1, 305, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30511146, '', 'DestInvestObject', '', 'DestInvestObjectKey', 1, 305, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30511147, '', 'DestInvestObjectCode', '', 'DestInvestObject', 1, 305, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30511148, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 305, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30511149, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511150, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 305, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30511151, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 1, 305, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30511152, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 1, 305, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30511153, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 305, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30511154, '', 'AUTO_AUTORIZATION', '', ' ', 1, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511155, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511156, '  ()', 'CREATEDATE', '  ()', ' ', 1, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511157, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 305, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30511188, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 305, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30511190, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 305, 1, 0, '', 0, 43610, 0, 1, '') ;

--   , (1)
CALL ImportField(30610001, '', 'BUDGETREF', '', 'BudgetRef', 1, 306, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(30610002, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 1, 306, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(30610008, '()', 'SUMMA', '()', 'SUMMA', 1, 306, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(30610009, ' ', 'NOTE', ' ', 'NOTE', 1, 306, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(30610010, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 306, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(30610011, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 1, 306, 0, 0, '', 0, 19009, 0, 1, '') ;

CALL ImportField(30610012, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 306, 0, 0, '', 0, 18961, 0, 1, '') ;

CALL ImportField(30610013, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 306, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(30610014, ' ', 'DOCNUMBER', ' ', 'DocumentNumber', 1, 306, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(30610043, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 1, 306, 0, 0, '', 0, 18972, 0, 1, '') ;

CALL ImportField(30610044, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 1, 306, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(30610045, '  ()', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 1, 306, 0, 0, '', 0, 18968, 0, 1, '') ;

CALL ImportField(30610046, '/ ()', 'SOURCEFACIALACC_CLS', '/ ()', 'SourceFacialAccCls', 1, 306, 0, 0, '', 0, 18957, 0, 1, '') ;

CALL ImportField(30610048, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 306, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(30610101, '( )', 'IsBlocked', '', 'IsBlocked', 1, 306, 0, 0, '', 0, 19012, 0, 1, '') ;

CALL ImportField(30610102, ' ( )', 'BlockedCause', ' ', 'BLOCKEDCAUSE', 1, 306, 0, 0, '', 0, 19013, 0, 1, '') ;

CALL ImportField(30610103, ' ( )', 'UnBlockedDate', ' ', 'UnBlockedDate', 1, 306, 0, 0, '', 0, 19014, 0, 1, '') ;

CALL ImportField(30610104, ' ( )', 'UnBlockedCause', ' ', 'UnblockedCause', 1, 306, 0, 0, '', 0, 19015, 0, 1, '') ;

CALL ImportField(30610105, ' ', 'ClsType', ' (, , )', 'CLSTYPE', 1, 306, 0, 0, '', 0, 19008, 0, 1, '') ;

CALL ImportField(30610107, ' ', 'ID', ' ', 'ID', 1, 306, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(30610108, '. c ', 'DESTACCOUNT', '. c ', 'DESTACCOUNT', 1, 306, 0, 1, ',', 0, 18958, 0, 1, '') ;

CALL ImportField(30610109, '', 'DocStateRef', '', 'DocStateRef', 1, 306, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(30610119, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 1, 306, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(30610120, '  ', 'SENDERID', '  ', 'SenderID', 1, 306, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(30610121, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 306, 0, 1, '', 0, 18970, 0, 1, '') ;

CALL ImportField(30610125, '.  ', 'SOURCEACCOUNT', '.  ', 'SOURCEACCOUNT', 1, 306, 0, 1, '', 0, 18956, 0, 1, '') ;

CALL ImportField(30610126, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 306, 0, 1, '', 0, 18960, 0, 1, '') ;

CALL ImportField(30610127, ' ', 'CashierPersonalInfo', ' ', 'CashierPersonalInfo', 1, 306, 0, 0, '', 0, 24731, 0, 1, '') ;

CALL ImportField(30610128, '', 'DepartmentCLS', '', 'DEPARTMENTCLS', 1, 306, 0, 1, '', 0, 18989, 0, 1, '') ;

CALL ImportField(30610130, ' ', 'CARDNUMBER', '   ()', 'CARDNUMBER', 1, 306, 0, 0, '', 0, 18985, 0, 1, '') ;

CALL ImportField(30610144, ' ()', 'CardRef', '  ', 'CardRef', 1, 306, 0, 1, '', 0, 31656, 0, 1, '') ;

CALL ImportField(30610146, '(  )', 'UINCode', '  ', 'UINCode', 1, 306, 0, 0, '', 0, 35367, 0, 1, '') ;

CALL ImportField(30610153, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 306, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30610154, '', 'AUTO_AUTORIZATION', '', ' ', 1, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30610155, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30610156, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30610157, '  ()', 'CREATEDATE', '  ()', ' ', 1, 306, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611015, ' ', 'PAYSYMBOLCLS', ' ', 'PaySymbolCls', 1, 306, 1, 0, '', 0, 18874, 0, 1, '') ;

CALL ImportField(30611016, ' ', 'NOTE', ' ', 'NOTE', 1, 306, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(30611018, '', 'DestKVSR', '', 'DestKVSRKey', 1, 306, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30611019, '()', 'DestKFSR', '', 'DestKFSR', 1, 306, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30611020, '', 'DestKCSR', '', 'DestKCSRKey', 1, 306, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30611021, '', 'DESTKVR', '', 'DestKVRKey', 1, 306, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30611022, '', 'DESTKESR', '', 'DestKESRKey', 1, 306, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30611023, '', 'DestFactCode', '', 'DestFACTCLS', 1, 306, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(30611024, '', 'DestDirectionCLSCode', '', 'DestDirectionCLS', 1, 306, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(30611032, ' . ', 'DestFinTypeCode', '  ', 'DestFINTYPECLS', 1, 306, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(30611033, ' ', 'DestDocType', ' ', 'DestDOCTYPECLS', 1, 306, 1, 0, '', 0, 18903, 0, 1, '') ;

CALL ImportField(30611034, '()', 'SUMMA', '()', 'SUMMA', 1, 306, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(30611035, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 1, 306, 1, 0, '', 0, 18906, 0, 1, '') ;

CALL ImportField(30611036, ' ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DestBudgetPROMISENum', 1, 306, 1, 0, ',', 0, 20223, 0, 1, '') ;

CALL ImportField(30611037, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 306, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30611038, ' ', 'ClsType', ' (, , )', 'ClsType', 1, 306, 1, 1, ',', 0, 18922, 0, 1, '') ;

CALL ImportField(30611039, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 306, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30611040, ' ', 'DestMeansType', ' ', 'DestMEANSTYPECLS', 1, 306, 1, 0, '', 0, 18900, 0, 1, '') ;

CALL ImportField(30611041, ' ', 'DestFinSource', ' ', 'DestFINSOURCECLS', 1, 306, 1, 0, '', 0, 18901, 0, 1, '') ;

CALL ImportField(30611049, '', 'DestDocBaseCode', '', 'DESTDOCBASE', 1, 306, 1, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(30611050, ' ', 'DestRegionCls', '', 'DESTREGIONCLS', 1, 306, 1, 1, ',', 0, 18928, 0, 1, '') ;

CALL ImportField(30611100, '(.  )', 'DestExecDocNum', '', 'DestExecDocNum', 1, 306, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(30611106, ' ', 'DestFundsSource', ' ', 'DestFundsSource', 1, 306, 1, 0, '', 0, 18929, 0, 1, '') ;

CALL ImportField(30611112, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 1, 306, 1, 1, ',', 0, 18909, 0, 1, '') ;

CALL ImportField(30611113, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 1, 306, 1, 1, '', 0, 18918, 0, 1, '') ;

CALL ImportField(30611114, ' ', 'DestIFS', ' ', 'DestIFS', 1, 306, 1, 1, ',', 0, 18921, 0, 1, '') ;

CALL ImportField(30611115, ' ', 'DestKD', ' ', 'DESTKD', 1, 306, 1, 1, '', 0, 18926, 0, 1, '') ;

CALL ImportField(30611117, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 306, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(30611118, ' ', 'ID', ' ', 'Id', 1, 306, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(30611127, ' ', 'DestIFS_FullID', 'DestIFS_FullID( )', 'DestIFS_DescriptionCode', 1, 306, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30611128, ' ', 'DestKD_Value', ' ', 'DESTKDVALUE', 1, 306, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(30611129, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 306, 1, 1, '', 0, 18877, 0, 1, '') ;

CALL ImportField(30611130, '  ', 'DestTransfertCls', '   ()', 'DestTransfertCls', 1, 306, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(30611131, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 1, 306, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(30611133, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 306, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30611135, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 306, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30611136, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 306, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30611137, ' ', 'DestSubsidyCls', '  ()', 'DestSubsidyCls', 1, 306, 1, 1, '', 0, 26624, 0, 1, '') ;

CALL ImportField(30611138, ' ', 'DestSubsidyClsCode', ' ', 'DestSubsidyClsCode', 1, 306, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(30611140, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 306, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30611141, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 306, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(30611142, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 306, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30611143, '  ', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 1, 306, 1, 1, '', 0, 27843, 0, 1, '') ;

CALL ImportField(30611144, ' ()', 'DestFact', '', 'DestFACTCLSKey', 1, 306, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30611146, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 1, 306, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30611148, '', 'DestInvestObject', '', 'DestInvestObjectKey', 1, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30611149, '', 'DestInvestObjectCode', '', 'DestInvestObject', 1, 306, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(30611150, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 306, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30611151, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611152, '  ', 'DestBudgetPromiseAgrDate', '  ', 'DestBudgetPromiseAgrDate', 1, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30611153, '  ', 'DestBudgetPromiseAgrNum', '  ', 'DestBudgetPromiseAgrNum', 1, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30611154, '  ', 'DestBudgetPromiseAgrNote', '  ', 'DestBudgetPromiseAgrNote', 1, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30611155, '   ', 'DestBudgetPromiseAgrRNum', '   ', 'DestBudgetPromiseAgrReestrNum', 1, 306, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(30611156, '  ', 'DestBudgetPromiseSumma', '  ', 'DestBudgetPromiseSumma', 1, 306, 1, 1, '', 0, 20242, 0, 1, '') ;

CALL ImportField(30611157, '(.  )', 'DestExecDocDate', '', 'DestExecDocDate', 1, 306, 1, 1, '', 0, 19740, 0, 1, '') ;

CALL ImportField(30611158, '(.  )', 'DestExecDocNote', '', 'DestExecDocNote', 1, 306, 1, 1, '', 0, 19762, 0, 1, '') ;

CALL ImportField(30611159, ' (.  )', 'DestExecDocReestr', ' ', 'DestExecDocReestr', 1, 306, 1, 1, '', 0, 19756, 0, 1, '') ;

CALL ImportField(30611160, '(.  )', 'DestExecDocSumma', ' .  ', 'DestExecDocSumma', 1, 306, 1, 1, '', 0, 19744, 0, 1, '') ;

CALL ImportField(30611161, '(.  )', 'DestExecDocType', '  ', 'DestExecDocType', 1, 306, 1, 1, '', 0, 19738, 0, 1, '') ;

CALL ImportField(30611162, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 306, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30611163, '', 'AUTO_AUTORIZATION', '', ' ', 1, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611164, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611165, '  ()', 'CREATEDATE', '  ()', ' ', 1, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611166, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 306, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30611206, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 306, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30611208, '()', 'DestSubKESRCode', '()', 'DestSubKESR', 1, 306, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(30710005, '', 'Note', '', 'ReestrNote', 1, 307, 0, 0, '', 0, 19103, 0, 0, '') ;

CALL ImportField(30710014, ' ', 'CryptoStatus', '   ', 'CryptoStatus', 1, 307, 0, 1, '', 0, 19109, 0, 0, '') ;

CALL ImportField(30710017, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 307, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30710018, '', 'AUTO_AUTORIZATION', '', ' ', 1, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30710019, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30710020, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30710021, '  ()', 'CREATEDATE', '  ()', ' ', 1, 307, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30711019, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 307, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30711020, '', 'AUTO_AUTORIZATION', '', ' ', 1, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30711021, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30711022, '  ()', 'CREATEDATE', '  ()', ' ', 1, 307, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30711023, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 307, 1, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(30810001, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 308, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(30810002, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 308, 0, 0, '', 0, 18961, 0, 1, '') ;

CALL ImportField(30810003, '', 'BUDGETREF', '', 'BudgetRef', 1, 308, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(30810004, '  ()', 'BUHPAYMENTCLS', '  ()', 'BUHPAYMENTCLS', 1, 308, 0, 0, '', 0, 18968, 0, 1, '') ;

CALL ImportField(30810005, '. c', 'DESTACCOUNT', '. c', 'DESTACCOUNT', 1, 308, 0, 1, '', 0, 18958, 0, 1, '') ;

CALL ImportField(30810006, ' .', 'DOCNUMBER', ' .', 'DocumentNumber', 1, 308, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(30810007, '', 'DocStateRef', '', 'DocStateRef', 1, 308, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(30810008, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 308, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(30810010, ' c', 'FEDERALFUNDSREF', ' c', 'FEDERALFUNDSREF', 1, 308, 0, 1, '', 0, 19004, 0, 1, '') ;

CALL ImportField(30810011, ' ', 'ID', ' ', 'ID', 1, 308, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(30810012, ' (  )', 'NOTE', ' ', 'NOTE', 1, 308, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(30810013, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 1, 308, 0, 0, '', 0, 19009, 0, 1, '') ;

CALL ImportField(30810014, ' ', 'REESTR_REF', ' ', 'Reestr_Ref', 1, 308, 0, 1, '', 0, 18971, 0, 1, '') ;

CALL ImportField(30810015, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 1, 308, 0, 0, '', 0, 19090, 0, 1, '') ;

CALL ImportField(30810016, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 1, 308, 0, 0, '', 0, 18972, 0, 1, '') ;

CALL ImportField(30810017, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 1, 308, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(30810018, '. c ()', 'SOURCEACCOUNT', '. c ()', 'SOURCEACCOUNT', 1, 308, 0, 1, ',', 0, 18956, 0, 1, '') ;

CALL ImportField(30810020, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 1, 308, 0, 0, ',', 0, 18957, 0, 1, '') ;

CALL ImportField(30810022, '()', 'SUMMA', '()', 'SUMMA', 1, 308, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(30810023, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 308, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(30810024, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 1, 308, 0, 1, '', 0, 19091, 0, 1, '') ;

CALL ImportField(30810057, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 308, 0, 1, '', 0, 18960, 0, 1, '') ;

CALL ImportField(30810058, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 1, 308, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(30810059, '', 'DepartmentCLS', '', 'DEPARTMENTCLS', 1, 308, 0, 1, '', 0, 18989, 0, 1, '') ;

CALL ImportField(30810061, ' ', 'BidDate', '', 'BidDate', 1, 308, 0, 0, '', 0, 24730, 0, 1, '') ;

CALL ImportField(30810062, ' ', 'BidNumber', '', 'BidNumber', 1, 308, 0, 0, '', 0, 18993, 0, 1, '') ;

CALL ImportField(30810064, '/  ', 'DESTFACIALACC_CLS', '/ ()', 'DestFacialAccCls', 1, 308, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(30810065, '(  )', 'NDS', '', 'NDS', 1, 308, 0, 0, '', 0, 18990, 0, 1, '') ;

CALL ImportField(30810069, '(  )', 'UINCode', '  ', 'UINCode', 1, 308, 0, 0, '', 0, 35367, 0, 1, '') ;

CALL ImportField(30810071, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 308, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(30810072, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 308, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(30810073, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 1, 308, 0, 0, '', 0, 31659, 0, 2, '') ;

CALL ImportField(30810074, '  ', 'StoredPaymentProps', '', ' ', 1, 308, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30810075, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 308, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30810076, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 308, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(30810077, '', 'AUTO_AUTORIZATION', '', ' ', 1, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30810078, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30810079, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30810080, '  ()', 'CREATEDATE', '  ()', ' ', 1, 308, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30810081, '  ', 'SENDERID', '  ', 'SenderID', 1, 308, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(30811001, '', 'BUDGETREF', '', 'BudgetRef', 1, 308, 1, 1, '', 0, 18872, 0, 1, '') ;

CALL ImportField(30811002, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 308, 1, 0, '', 0, 18919, 0, 1, '') ;

CALL ImportField(30811003, '  ', 'ClsType', '  .', 'ClsType', 1, 308, 1, 1, ',', 0, 18922, 0, 1, '') ;

CALL ImportField(30811004, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 1, 308, 1, 1, '', 0, 18909, 0, 1, '') ;

CALL ImportField(30811007, '  ', 'DestClsType', '  -', 'DestClsType', 1, 308, 1, 1, '', 0, 25179, 0, 1, '') ;

CALL ImportField(30811008, ' ', 'DestDirectionCLSCode', ' -', 'DestDirectionCLS', 1, 308, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(30811009, ' ', 'DestDocBaseCode', ' ', 'DESTDOCBASE', 1, 308, 1, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(30811010, '  ', 'DestDocType', '  -', 'DestDOCTYPECLS', 1, 308, 1, 0, '', 0, 18903, 0, 1, '') ;

CALL ImportField(30811011, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 1, 308, 1, 1, '', 0, 18918, 0, 1, '') ;

CALL ImportField(30811013, '(.  )', 'DestExecDocNum', '(.  )', 'DestExecDocNum', 1, 308, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(30811014, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 1, 308, 1, 1, '', 0, 18869, 0, 1, '') ;

CALL ImportField(30811016, ' ', 'DestFactCode', ' -', 'DestFACTCLS', 1, 308, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(30811017, ' - ', 'DestFinSource', ' - -', 'DestFINSOURCECLS', 1, 308, 1, 0, '', 0, 18901, 0, 1, '') ;

CALL ImportField(30811018, ' .  ( )', 'DestFinTypeCode', '   -', 'DestFINTYPECLS', 1, 308, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(30811019, '   .', 'DestKD', '   ()', 'DESTKD', 1, 308, 1, 1, '', 0, 18926, 0, 1, '') ;

CALL ImportField(30811024, '  ', 'DestMeansType', '  -', 'DestMEANSTYPECLS', 1, 308, 1, 0, '', 0, 18900, 0, 1, '') ;

CALL ImportField(30811025, '  ', 'DESTPROMISE', '  ', 'DestPROMISE', 1, 308, 1, 0, '', 0, 18906, 0, 1, '') ;

CALL ImportField(30811026, '  ', 'DestRegionCls', ' -', 'DESTREGIONCLS', 1, 308, 1, 1, ',', 0, 18928, 0, 1, '') ;

CALL ImportField(30811027, ' ', 'DestSubKESR', ' ', 'DestSUBKESRKey', 1, 308, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(30811028, ' ', 'ID', ' ', 'Id', 1, 308, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(30811029, ' . ', 'MEMORDERNUM', ' . ', 'MemOrderNum', 1, 308, 1, 1, '', 0, 18875, 0, 1, '') ;

CALL ImportField(30811030, '', 'NOTE', ' ', 'NOTE', 1, 308, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(30811031, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 308, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(30811032, '.   ', 'SOURCEBUDGETPROMISE', '.   ', 'SourceBUDGETPROMISE', 1, 308, 1, 1, ',,', 0, 18908, 0, 1, '') ;

CALL ImportField(30811034, ' ( . - )', 'SOURCEBUDGETPROMISENUM', '  ( . - )', 'SourceBudgetPromiseNum', 1, 308, 1, 0, ',,', 0, 20223, 0, 0, '') ;

CALL ImportField(30811035, ' .( .)', 'SourceDirectionCLSCode', ' .( .)', 'SourceDirectionCLS', 1, 308, 1, 0, ',', 0, 36861, 0, 1, '') ;

CALL ImportField(30811036, ' ', 'SourceDocBaseCode', ' ', 'SOURCEDOCBASE', 1, 308, 1, 0, ',,', 0, 36865, 0, 1, '') ;

CALL ImportField(30811037, '  ', 'SourceDocType', '  .', 'SourceDOCTYPECLS', 1, 308, 1, 0, ',', 0, 18894, 0, 1, '') ;

CALL ImportField(30811038, ' ..  ', 'SourceExecDoc', ' ..  ', 'SourceExecDoc', 1, 308, 1, 1, ',', 0, 18917, 0, 1, '') ;

CALL ImportField(30811040, '(.  )', 'SourceExecDocNum', '(.  )', 'SourceExecDocNum', 1, 308, 1, 0, ',', 0, 19739, 0, 1, '') ;

CALL ImportField(30811041, ' ', 'SourceFactCode', ' .', 'SourceFACTCLS', 1, 308, 1, 0, ',', 0, 36863, 0, 1, '') ;

CALL ImportField(30811042, ' - ', 'SourceFinSource', ' - .', 'SourceFINSOURCECLS', 1, 308, 1, 0, ',', 0, 18892, 0, 1, '') ;

CALL ImportField(30811043, ' .  .', 'SourceFinTypeCode', '   .', 'SourceFINTYPECLS', 1, 308, 1, 0, ',,,', 0, 36853, 0, 1, '') ;

CALL ImportField(30811044, ' ', 'SourceKCSR', ' .', 'SourceKCSRKey', 1, 308, 1, 1, ',', 0, 18887, 0, 1, '') ;

CALL ImportField(30811045, ' .()', 'SOURCEKESR', ' .()', 'SourceKESRKey', 1, 308, 1, 1, '', 0, 18868, 0, 1, '') ;

CALL ImportField(30811046, ' ( )', 'SourceKFSR', ' .( .)', 'SourceKFSR', 1, 308, 1, 0, ',', 0, 18888, 0, 1, '') ;

CALL ImportField(30811047, ' ', 'SOURCEKVR', ' .', 'SourceKVRKey', 1, 308, 1, 1, ',', 0, 18867, 0, 1, '') ;

CALL ImportField(30811048, ' ', 'SourceKVSR', ' .', 'SourceKVSRKey', 1, 308, 1, 1, ',', 0, 18886, 0, 1, '') ;

CALL ImportField(30811049, '  ', 'SourceMeansType', '  .', 'SourceMEANSTYPECLS', 1, 308, 1, 0, ',', 0, 18891, 0, 1, '') ;

CALL ImportField(30811050, '  ', 'SOURCEPROMISE', '  ', 'SourcePROMISE', 1, 308, 1, 0, ',', 0, 18905, 0, 1, '') ;

CALL ImportField(30811051, '  ', 'SourceRegionCls', ' .', 'SOURCEREGIONCLS', 1, 308, 1, 1, ',,,', 0, 18927, 0, 1, '') ;

CALL ImportField(30811052, ' ', 'SourceSubKESR', ' .', 'SourceSUBKESRKey', 1, 308, 1, 1, '', 0, 18889, 0, 1, '') ;

CALL ImportField(30811053, '()', 'SUMMA', '()', 'SUMMA', 1, 308, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(30811056, '  ', 'DestFundsSource', '  -', 'DestFundsSource', 1, 308, 1, 0, '', 0, 18929, 0, 1, '') ;

CALL ImportField(30811057, '  ', 'SourceFundsSource', '  .', 'SourceFundsSource', 1, 308, 1, 0, ',', 0, 18930, 0, 1, '') ;

CALL ImportField(30811058, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 308, 1, 1, '', 0, 18877, 0, 1, '') ;

CALL ImportField(30811060, ' ( )', 'SourceKCSRCode', ' .( .)', 'SourceKCSR', 1, 308, 1, 0, ',', 0, 25462, 0, 1, '') ;

CALL ImportField(30811061, ' ( )', 'SOURCEKVRCode', ' .( .)', 'SourceKVR', 1, 308, 1, 0, ',', 0, 25467, 0, 1, '') ;

CALL ImportField(30811062, ' ( )', 'SourceKVSRCode', ' .( .)', 'SourceKVSR', 1, 308, 1, 0, ',', 0, 25472, 0, 1, '') ;

CALL ImportField(30811063, '   ', 'DestTransfertCls', '', 'DestTransfertCls', 1, 308, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(30811064, '   -', 'DestTransfertClsCode', '', 'DestTransfertClsValue', 1, 308, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(30811065, '   ', 'SourceTransfertCls', '', 'SourceTransfertCls', 1, 308, 1, 1, ',', 0, 18935, 0, 1, '') ;

CALL ImportField(30811066, '   ', 'SourceTransfertClsCode', '', 'SourceTransfertClsValue', 1, 308, 1, 0, ',', 0, 25326, 0, 1, '') ;

CALL ImportField(30811067, ' ', 'DestKCSR', '', 'DestKCSRKey', 1, 308, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(30811068, ' ( )', 'DestKCSRCode', '', 'DestKCSR', 1, 308, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(30811069, ' ', 'DESTKESR', ' ', 'DestKESRKey', 1, 308, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(30811070, ' ( )', 'DestKFSR', '', 'DestKFSR', 1, 308, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(30811071, ' ', 'DESTKVR', '', 'DestKVRKey', 1, 308, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(30811072, ' ( )', 'DESTKVRCode', '', 'DestKVR', 1, 308, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(30811073, ' ', 'DestKVSR', '', 'DestKVSRKey', 1, 308, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(30811074, ' ( )', 'DestKVSRCode', '', 'DestKVSR', 1, 308, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(30811075, '   .', 'SourceKD', '   ()', 'SOURCEKD', 1, 308, 1, 1, ',', 0, 18925, 0, 1, '') ;

CALL ImportField(30811081, '  ', 'DestSubsidyCls', '', 'DestSubsidyCls', 1, 308, 1, 1, '', 0, 26624, 0, 1, '') ;

CALL ImportField(30811082, '  ', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 1, 308, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(30811083, '  ', 'SourceSubsidyCls', '', 'SourceSubsidyCls', 1, 308, 1, 1, ',', 0, 26626, 0, 1, '') ;

CALL ImportField(30811084, '  ', 'SourceSubsidyClsCode', '', 'SourceSubsidyClsCode', 1, 308, 1, 0, ',', 0, 26641, 0, 1, '') ;

CALL ImportField(30811085, '  ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 308, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(30811086, '   ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 308, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(30811087, '  ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 308, 1, 0, ',', 0, 27825, 0, 1, '') ;

CALL ImportField(30811088, '   ', 'SourcePayPromiseClsCode', '', 'SourcePayPromiseClsCode', 1, 308, 1, 0, ',', 0, 27849, 0, 1, '') ;

CALL ImportField(30811089, '  ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 308, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(30811090, '   ', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 1, 308, 1, 1, '', 0, 27843, 0, 1, '') ;

CALL ImportField(30811091, '  ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 308, 1, 1, ',', 0, 27844, 0, 1, '') ;

CALL ImportField(30811092, '   ', 'SourcePayPromiseCls', '', 'SourcePayPromiseCls', 1, 308, 1, 1, ',', 0, 27845, 0, 1, '') ;

CALL ImportField(30811094, ' ( )', 'DestIFS', '', 'DestIFS', 1, 308, 1, 1, '', 0, 18921, 0, 1, '') ;

CALL ImportField(30811098, ' ( )', 'SourceIFS', '', 'SourceIFS', 1, 308, 1, 1, ',', 0, 18920, 0, 1, '') ;

CALL ImportField(30811102, '  .', 'SourceKD_Value', '  ', 'SOURCEKDVALUE', 1, 308, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(30811103, '  ()', 'SourceFact', ' ', 'SourceFACTCLSKey', 1, 308, 1, 1, ',', 0, 18890, 0, 1, '') ;

CALL ImportField(30811104, '  ()', 'DestFact', ' ', 'DestFACTCLSKey', 1, 308, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(30811107, ' .  . ()', 'SourceFinType', '   ', 'SourceFINTYPECLSKey', 1, 308, 1, 1, ',,', 0, 18893, 0, 1, '') ;

CALL ImportField(30811108, ' .  ()', 'DestFinType', '   ', 'DestFINTYPECLSKey', 1, 308, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(30811115, ' ', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 308, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(30811116, ' ', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811117, ' ', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 1, 308, 1, 1, ',', 0, null, 0, 0, '') ;

CALL ImportField(30811118, ' ', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 1, 308, 1, 0, ',', 0, null, 0, 0, '') ;

CALL ImportField(30811119, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 308, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(30811120, '  -', 'DestTargetCls', '   ()', 'DestTargetClsKey', 1, 308, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(30811121, '  -', 'DestTargetClsCode', '  ', 'DestTargetCls', 1, 308, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(30811122, '  .', 'SourceTargetCls', '   ()', 'SourceTargetClsKey', 1, 308, 1, 1, ',', 0, 40642, 0, 0, '') ;

CALL ImportField(30811123, '  .', 'SourceTargetClsCode', '  ', 'SourceTargetCls', 1, 308, 1, 0, ',', 0, 22390, 0, 0, '') ;

CALL ImportField(30811124, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 308, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(30811125, '', 'AUTO_AUTORIZATION', '', ' ', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811126, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811127, '  ()', 'CREATEDATE', '  ()', ' ', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811128, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 308, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(30811254, ' ( )', 'DestKESRCode', ' ( )', 'DestKESR', 1, 308, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(30811256, ' ( )', 'DestSubKESRCode', ' ( )', 'DestSUBKESR', 1, 308, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(30811258, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 308, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(30811261, ' ( .)', 'SourceSubKESRCode', ' ( .)', 'SourceSUBKESR', 1, 308, 1, 0, ',', 0, 43610, 0, 1, '') ;

--    , (1)
CALL ImportField(31110082, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 311, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(31110083, '', 'AUTO_AUTORIZATION', '', ' ', 1, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31110084, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31110085, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31110086, '  ()', 'CREATEDATE', '  ()', ' ', 1, 311, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111004, '', 'SOURCEKVR', '', 'SOURCEKVRKey', 1, 311, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(31111005, '', 'SOURCEKESR', '', 'SOURCEKESRKey', 1, 311, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31111006, '()', 'SourceKFSR', '', 'SourceKFSR', 1, 311, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(31111007, '', 'SourceKCSR', '', 'SourceKCSRKey', 1, 311, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(31111008, '', 'SourceKVSR', '', 'SourceKVSRKey', 1, 311, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(31111009, '', 'SourceSubKESR', '', 'SourceSubKESRKey', 1, 311, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31111017, ' ', 'DESTKVR', ' ', 'DESTKVRKey', 1, 311, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31111018, '  ()', 'DESTKESR', ' ', 'DESTKESRKey', 1, 311, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31111019, ' ', 'DestKFSR', ' ', 'DestKFSR', 1, 311, 1, 1, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31111020, ' ', 'DestKCSR', ' ', 'DestKCSRKey', 1, 311, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31111021, ' ', 'DestKVSR', ' ', 'DestKVSRKey', 1, 311, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31111022, '  ()', 'DestSubKESR', ' ', 'DestSubKESRKey', 1, 311, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31111044, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 311, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31111080, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 311, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31111082, '()', 'SOURCEKVRCode', '()', 'SOURCEKVR', 1, 311, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31111083, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 311, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31111091, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 311, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31111093, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 311, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(31111109, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 1, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111110, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 1, 311, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31111111, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 311, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(31111112, '', 'AUTO_AUTORIZATION', '', ' ', 1, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111113, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111114, '  ()', 'CREATEDATE', '  ()', ' ', 1, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111115, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 311, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31111116, ' ', 'DESTKESRCode', ' ', 'DESTKESR', 1, 311, 1, 1, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31111117, ' ', 'DestSubKESRCode', ' ', 'DestSubKESR', 1, 311, 1, 1, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31111118, '()', 'SOURCEKESRCode', '()', 'SOURCEKESR', 1, 311, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31111119, '()', 'SourceSubKESRCode', '()', 'SourceSubKESR', 1, 311, 1, 0, '', 0, 43610, 0, 0, '') ;

--     , (1)
CALL ImportField(31210127, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 312, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(31210128, '', 'AUTO_AUTORIZATION', '', ' ', 1, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31210129, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31210130, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31210131, '  ()', 'CREATEDATE', '  ()', ' ', 1, 312, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 312, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31211016, '', 'DestKVR', ' ', 'DestKVRKey', 1, 312, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31211017, '', 'DestKESR', '', 'DestKESRKey', 1, 312, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31211018, '', 'DestKVSR', ' ', 'DestKVSRKey', 1, 312, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31211019, '', 'DestKCSR', ' ', 'DestKCSRKey', 1, 312, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31211020, '()', 'DestKFSR', ' ', 'DestKFSR', 1, 312, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31211021, '', 'DestSUBKESR', '', 'DestSUBKESRKey', 1, 312, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31211034, ' ', 'SourceKVR', ' ', 'SourceKVRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211035, ' ', 'SourceKESR', ' ', 'SourceKESRKey', 1, 312, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31211036, ' ', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211037, ' ', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211038, ' ', 'SourceKFSR', ' ', 'SourceKFSR', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211039, ' ', 'SourceSUBKESR', ' ', 'SourceSUBKESRKey', 1, 312, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31211125, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 312, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31211127, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 312, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31211128, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 312, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31211132, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 312, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(31211133, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 312, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31211144, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211145, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 312, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31211146, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 312, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(31211147, '', 'AUTO_AUTORIZATION', '', ' ', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211148, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211149, '  ()', 'CREATEDATE', '  ()', ' ', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211150, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 312, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31211176, '()', 'DestKESRCode', '()', 'DestKESR', 1, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31211178, '()', 'DestSUBKESRCode', '()', 'DestSUBKESR', 1, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31211181, ' .( .)', 'SourceKESRCode', ' .( .)', 'SourceKESR', 1, 312, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31211183, ' .( .)', 'SourceSubKESRCode', ' .( .)', 'SourceSUBKESR', 1, 312, 1, 0, '', 0, 43610, 0, 0, '') ;

--    , (1)
CALL ImportField(31410127, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 314, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(31410128, '', 'AUTO_AUTORIZATION', '', ' ', 1, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31410129, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31410130, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31410131, '  ()', 'CREATEDATE', '  ()', ' ', 1, 314, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411009, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 314, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31411016, ' ', 'DestKVR', ' ', 'DestKVRKey', 1, 314, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31411017, ' ', 'DestKESR', ' ', 'DestKESRKey', 1, 314, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31411018, ' ', 'DestKVSR', ' ', 'DestKVSRKey', 1, 314, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31411019, ' ', 'DestKCSR', ' ', 'DestKCSRKey', 1, 314, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31411020, ' ', 'DestKFSR', ' ', 'DestKFSR', 1, 314, 1, 1, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31411021, ' ', 'DestSUBKESR', ' ', 'DestSUBKESRKey', 1, 314, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31411034, '', 'SourceKVR', ' ', 'SourceKVRKey', 1, 314, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(31411035, '', 'SourceKESR', ' ', 'SourceKESRKey', 1, 314, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(31411036, '', 'SourceKVSR', ' ', 'SourceKVSRKey', 1, 314, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(31411037, '', 'SourceKCSR', ' ', 'SourceKCSRKey', 1, 314, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(31411038, '()', 'SourceKFSR', ' ', 'SourceKFSR', 1, 314, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(31411039, '', 'SourceSUBKESR', ' ', 'SourceSUBKESRKey', 1, 314, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(31411125, '()', 'SourceKCSRCode', '()', 'SourceKCSR', 1, 314, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31411127, '()', 'SOURCEKVRCode', '()', 'SourceKVR', 1, 314, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31411128, '()', 'SourceKVSRCode', '()', 'SourceKVSR', 1, 314, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31411132, ' ', 'SourceBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 314, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31411134, ' ', 'SourceBudAllocationCls', '', 'SourceBudAllocationCls', 1, 314, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(31411144, '', 'SourceContractCostsClsCode', '', 'SourceContractCostsCls', 1, 314, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31411145, '', 'SourceContractCostsCls', '', 'SourceContractCostsClsKey', 1, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411146, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 314, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(31411147, '', 'AUTO_AUTORIZATION', '', ' ', 1, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411148, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411149, '  ()', 'CREATEDATE', '  ()', ' ', 1, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411150, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 314, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31411174, '()', 'SourceKESRCode', '()', 'SourceKESR', 1, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31411176, '()', 'SourceSubKESRCode', '()', 'SourceSUBKESR', 1, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(31411177, ' .( .)', 'DestKESRCode', ' .( .)', 'DestKESR', 1, 314, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31411178, ' .( .)', 'DestSUBKESRCode', ' .( .)', 'DestSUBKESR', 1, 314, 1, 0, '', 0, 43610, 0, 0, '') ;

--      , (1)
CALL ImportField(31510098, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 315, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(31510099, '', 'AUTO_AUTORIZATION', '', ' ', 1, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31510100, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31510101, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31510102, '  ()', 'CREATEDATE', '  ()', ' ', 1, 315, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511016, '', 'DestKVSR', '', 'DestKVSRKey', 1, 315, 1, 1, '', 0, 18895, 0, 0, '') ;

CALL ImportField(31511017, '()', 'DestKFSR', '', 'DestKFSR', 1, 315, 1, 0, '', 0, 18897, 0, 0, '') ;

CALL ImportField(31511018, '', 'DestKCSR', '', 'DestKCSRKey', 1, 315, 1, 1, '', 0, 18896, 0, 0, '') ;

CALL ImportField(31511019, '', 'DESTKVR', '', 'DestKVRKey', 1, 315, 1, 1, '', 0, 18870, 0, 0, '') ;

CALL ImportField(31511020, '', 'DESTKESR', '', 'DestKESRKey', 1, 315, 1, 1, '', 0, 18871, 0, 0, '') ;

CALL ImportField(31511031, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 315, 1, 1, '', 0, 18898, 0, 0, '') ;

CALL ImportField(31511037, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 315, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(31511083, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 315, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(31511085, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 315, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(31511086, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 315, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(31511090, ' ', 'DestBudAllocationClsCode', '', 'SourceBudAllocationClsCode', 1, 315, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(31511092, ' ', 'DestBudAllocationCls', '', ' ', 1, 315, 1, 1, '', 0, 27842, 0, 0, '') ;

CALL ImportField(31511100, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 315, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(31511101, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511102, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 315, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(31511103, '', 'AUTO_AUTORIZATION', '', ' ', 1, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511104, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511105, '  ()', 'CREATEDATE', '  ()', ' ', 1, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511106, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 315, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31511107, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 315, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(31511108, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 315, 1, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(31610001, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 316, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(31610002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31610003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31610004, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31610005, '  ()', 'CREATEDATE', '  ()', ' ', 1, 316, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31611001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 316, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(31611002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31611003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31611004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 316, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(31611005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 316, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(32210020, ' ', 'BuhOperationCLS', ' ', ' ', 1, 322, 0, 0, '', 0, 19007, 0, 0, '') ;

CALL ImportField(32210078, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 322, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32210079, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 322, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32210080, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 1, 322, 0, 0, '', 0, 31659, 0, 2, '') ;

CALL ImportField(32210081, '  ', 'StoredPaymentProps', '', ' ', 1, 322, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32210082, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 322, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32210083, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 322, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(32210084, '', 'AUTO_AUTORIZATION', '', ' ', 1, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32210085, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32210086, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32210087, '  ()', 'CREATEDATE', '  ()', ' ', 1, 322, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32211023, '', 'SourceKVSR', '', ' ', 1, 322, 1, 1, '', 0, 18886, 0, 0, '') ;

CALL ImportField(32211024, '()', 'SourceKFSR', '', ' ', 1, 322, 1, 0, '', 0, 18888, 0, 0, '') ;

CALL ImportField(32211025, '', 'SourceKCSR', '', ' ', 1, 322, 1, 1, '', 0, 18887, 0, 0, '') ;

CALL ImportField(32211026, '', 'SOURCEKVR', '', ' ', 1, 322, 1, 1, '', 0, 18867, 0, 0, '') ;

CALL ImportField(32211027, '', 'SOURCEKESR', '', ' ', 1, 322, 1, 1, '', 0, 18868, 0, 0, '') ;

CALL ImportField(32211039, '', 'SourceSubKESR', '', ' ', 1, 322, 1, 1, '', 0, 18889, 0, 0, '') ;

CALL ImportField(32211047, ' ', 'BuhOperationCLS', ' ', ' ', 1, 322, 1, 0, '', 0, 18919, 0, 0, '') ;

CALL ImportField(32211077, '()', 'SourceKCSRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(32211078, '()', 'SOURCEKVRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(32211079, '()', 'SourceKVSRCode', '()', ' ', 1, 322, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(32211080, ' ', 'SourceBudAllocationClsCode', '', ' ', 1, 322, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(32211082, ' ', 'SourceBudAllocationCls', '', ' ', 1, 322, 1, 1, '', 0, 27844, 0, 0, '') ;

CALL ImportField(32211094, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 322, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32211095, ' ', 'SourceTargetClsCode', ' ', 'SourceTargetCls', 1, 322, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32211096, ' ', 'SourceTargetCls', '  ()', 'SourceTargetClsKey', 1, 322, 1, 1, '', 0, 40642, 0, 0, '') ;

CALL ImportField(32211097, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 322, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(32211098, '', 'AUTO_AUTORIZATION', '', ' ', 1, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32211099, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32211100, '  ()', 'CREATEDATE', '  ()', ' ', 1, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32211101, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 322, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32211102, '()', 'SOURCEKESRCode', '()', ' ', 1, 322, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(32211103, '()', 'SourceSubKESRCode', '()', ' ', 1, 322, 1, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(32310001, ' .', 'DOCNUMBER', ' .', 'DocNumber', 1, 323, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(32310002, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 323, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(32310003, '', 'BUDGETREF', '', 'BudgetRef', 1, 323, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(32310005, '()', 'SUMMA', '()', 'SUMMA', 1, 323, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(32310006, ' ', 'NOTE', ' ', 'NOTE', 1, 323, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(32310007, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 323, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(32310008, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 1, 323, 0, 0, '', 0, 19007, 0, 1, '') ;

CALL ImportField(32310009, ' ', 'ClsType', ' ', 'CLSTYPE', 1, 323, 0, 0, ',', 0, 19008, 0, 1, '') ;

CALL ImportField(32310010, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 323, 0, 0, '', 0, 18961, 0, 1, '') ;

CALL ImportField(32310027, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 1, 323, 0, 0, '', 0, 19090, 0, 1, '') ;

CALL ImportField(32310028, '/() ', 'SOURCEFACIALACC_CLS', '/() ', 'SourceFacialAccCls', 1, 323, 0, 0, '', 0, 18957, 0, 1, '') ;

CALL ImportField(32310029, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 323, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(32310044, '  ()', 'BUHPAYMENTCLS', '. ', 'DestType', 1, 323, 0, 1, '', 0, 18968, 0, 1, '') ;

CALL ImportField(32310045, ' ', 'ID', ' ', 'ID', 1, 323, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(32310046, ' ', 'REESTR_REF', ' ', 'Reestr_Ref', 1, 323, 0, 1, '', 0, 18971, 0, 1, '') ;

CALL ImportField(32310047, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 1, 323, 0, 1, '', 0, 19009, 0, 1, '') ;

CALL ImportField(32310048, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 1, 323, 0, 0, '', 0, 18972, 0, 1, '') ;

CALL ImportField(32310049, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 1, 323, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(32310050, '. c', 'DESTACCOUNT', '. c', 'DESTACCOUNT', 1, 323, 0, 1, '', 0, 18958, 0, 1, '') ;

CALL ImportField(32310051, '', 'DocStateRef', '', 'DocStateRef', 1, 323, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(32310052, '. c()', 'SOURCEACCOUNT', '. c()', 'SourceBankCity', 1, 323, 0, 1, ',', 0, 18956, 0, 1, '') ;

CALL ImportField(32310059, '  ', 'SENDERID', '  ', 'SenderID', 1, 323, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(32310060, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 323, 0, 1, '', 0, 18970, 0, 1, '') ;

CALL ImportField(32310061, '  ', 'FEDERALFUNDSName', '  ', 'FEDERALFUNDSREESTR', 1, 323, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32310062, ' c', 'FEDERALFUNDSREF', ' c', 'FEDERALFUNDSREF', 1, 323, 0, 1, '', 0, 19004, 0, 1, '') ;

CALL ImportField(32310065, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 323, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(32310066, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 1, 323, 0, 1, '', 0, 19091, 0, 1, '') ;

CALL ImportField(32310136, ' ', 'PayDate', ' ', 'PayDate', 1, 323, 0, 1, '', 0, 18951, 0, 1, '') ;

CALL ImportField(32310137, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 323, 0, 1, '', 0, 18960, 0, 1, '') ;

CALL ImportField(32310138, '/ . (.)', 'DestFacialAcc_Cls', '/c . .', 'DestFacialAccCls', 1, 323, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(32310140, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 323, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32310141, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 323, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32310142, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 1, 323, 0, 0, '', 0, 31659, 0, 2, '') ;

CALL ImportField(32310143, '  ', 'StoredPaymentProps', '', ' ', 1, 323, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32310144, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 323, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32310145, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 323, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(32310146, '', 'AUTO_AUTORIZATION', '', ' ', 1, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32310147, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32310148, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32310149, '  ()', 'CREATEDATE', '  ()', ' ', 1, 323, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311012, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 1, 323, 1, 0, '', 0, 18869, 0, 1, '') ;

CALL ImportField(32311014, '', 'DestKVSR', '', 'DestKVSRKey', 1, 323, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(32311015, '()', 'DestKFSR', '', 'DestKFSR', 1, 323, 1, 0, '', 0, 18897, 0, 1, '') ;

CALL ImportField(32311016, '', 'DestKCSR', '', 'DestKCSRKey', 1, 323, 1, 1, '', 0, 18896, 0, 1, '') ;

CALL ImportField(32311017, ' ', 'DESTKVR', ' ', 'DestKVRKey', 1, 323, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(32311018, '', 'DESTKESR', '', 'DestKESRKey', 1, 323, 1, 1, '', 0, 18871, 0, 1, '') ;

CALL ImportField(32311019, '', 'DestFactCode', '', 'DestFACTCLS', 1, 323, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(32311020, '', 'DestDirectionCLSCode', '', 'DestDirectionCLS', 1, 323, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(32311024, ' ', 'DestMeansType', ' ', 'DestMEANSTYPECLS', 1, 323, 1, 0, '', 0, 18900, 0, 1, '') ;

CALL ImportField(32311025, '()', 'SUMMA', '()', 'SUMMA', 1, 323, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(32311026, ' ', 'NOTE', ' ', 'NOTE', 1, 323, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(32311030, ' ', 'AcceptDate', ' ', 'ACCEPTDATE', 1, 323, 1, 0, '', 0, 18924, 0, 1, '') ;

CALL ImportField(32311031, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 323, 1, 1, '', 0, 18898, 0, 1, '') ;

CALL ImportField(32311032, ' ', 'DestRegionCls', '', 'DESTREGIONCLS', 1, 323, 1, 0, ',', 0, 18928, 0, 1, '') ;

CALL ImportField(32311033, ' ', 'DestFinSource', ' ', 'DestFINSOURCECLS', 1, 323, 1, 0, '', 0, 18901, 0, 1, '') ;

CALL ImportField(32311034, ' . ', 'DestFinTypeCode', '  ', 'DestFINTYPECLS', 1, 323, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(32311035, ' ', 'DestDocType', ' ', 'DestDOCTYPECLS', 1, 323, 1, 0, '', 0, 18903, 0, 1, '') ;

CALL ImportField(32311036, '', 'DestDocBaseCode', '', 'DESTDOCBASE', 1, 323, 1, 0, ',,', 0, 36865, 0, 1, '') ;

CALL ImportField(32311037, ' . ', 'MEMORDERNUM', ' . ', 'MemOrderNum', 1, 323, 1, 0, '', 0, 18875, 0, 1, '') ;

CALL ImportField(32311038, ' . -', 'DestPromise', ' . -', 'DestPROMISE', 1, 323, 1, 0, ',', 0, 18906, 0, 1, '') ;

CALL ImportField(32311039, ' ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DESTBUDGETPROMISENUM', 1, 323, 1, 0, ',', 0, 20223, 0, 0, '') ;

CALL ImportField(32311043, '(.  )', 'DestExecDocNum', '', 'DestExecDocNum', 1, 323, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(32311053, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 1, 323, 1, 1, ',', 0, 18909, 0, 1, '') ;

CALL ImportField(32311054, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 1, 323, 1, 1, '', 0, 18918, 0, 1, '') ;

CALL ImportField(32311055, ' ', 'DestIFS', ' ', 'DestIFS', 1, 323, 1, 1, ',', 0, 18921, 0, 1, '') ;

CALL ImportField(32311057, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 323, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(32311058, ' ', 'ID', ' ', 'Id', 1, 323, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(32311068, ' ', 'DestIFS_FullID', 'DestIFS_FullID( )', 'DestIFS_DescriptionCode', 1, 323, 1, 1, ',', 0, null, 0, 1, '') ;

CALL ImportField(32311137, ' ', 'DestAssignmentKind', ' ', 'DestAssignmentKind', 1, 323, 1, 0, '', 0, 25178, 0, 1, '') ;

CALL ImportField(32311138, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 323, 1, 1, '', 0, 18877, 0, 1, '') ;

CALL ImportField(32311139, '  ', 'DestTransfertCls', '   ()', 'DestTransfertCls', 1, 323, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(32311140, '  ', 'DestTransfertClsCode', '  ', 'DestTransfertClsValue', 1, 323, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(32311142, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 323, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(32311143, ' ()', 'DESTKVRCode', ' ()', 'DestKVR', 1, 323, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(32311144, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 323, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(32311147, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 323, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(32311148, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 323, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(32311149, ' ', 'DestSubsidyCls', '', 'DestSubsidyCls', 1, 323, 1, 1, '', 0, 26624, 0, 1, '') ;

CALL ImportField(32311150, ' ', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 1, 323, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(32311151, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 323, 1, 1, '', 0, 27842, 0, 1, '') ;

CALL ImportField(32311152, '  ', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 1, 323, 1, 1, '', 0, 27843, 0, 1, '') ;

CALL ImportField(32311153, ' ()', 'DestDirectionCLS', '', 'DestDirectionCLSKey', 1, 323, 1, 1, '', 0, 18914, 0, 1, '') ;

CALL ImportField(32311154, ' ()', 'DestFact', '', 'DestFACTCLSKey', 1, 323, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(32311155, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 1, 323, 1, 1, ',', 0, 18902, 0, 1, '') ;

CALL ImportField(32311156, ' ()', 'DestDocBase', '', 'DESTDOCBASEKEY', 1, 323, 1, 1, ',,', 0, 18916, 0, 1, '') ;

CALL ImportField(32311163, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 1, 323, 1, 1, '', 0, 38150, 0, 1, '') ;

CALL ImportField(32311165, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 323, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32311166, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 323, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32311167, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 323, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32311168, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 1, 323, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32311169, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 1, 323, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(32311170, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 323, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(32311171, '', 'AUTO_AUTORIZATION', '', ' ', 1, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311172, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311173, '  ()', 'CREATEDATE', '  ()', ' ', 1, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311174, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 323, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32311221, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 323, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(32311223, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 323, 1, 0, '', 0, 43610, 0, 1, '') ;

--  , (1)
CALL ImportField(32410002, ' .', 'DOCNUMBER', ' .', 'DocNumber', 1, 324, 0, 0, '', 0, 18949, 0, 1, '') ;

CALL ImportField(32410003, ' ', 'DOCUMENTDATE', ' ', 'DocumentDate', 1, 324, 0, 0, '', 0, 18953, 0, 1, '') ;

CALL ImportField(32410004, '', 'BUDGETREF', '', 'BudgetRef', 1, 324, 0, 0, '', 0, 18983, 0, 1, '') ;

CALL ImportField(32410005, '/ ', 'SOURCEFACIALACC_CLS', '/ ', 'SourceFacialAccCls', 1, 324, 0, 0, ',', 0, 18957, 0, 1, '') ;

CALL ImportField(32410007, '()', 'SUMMA', '()', 'SUMMA', 1, 324, 0, 0, '', 0, 18955, 0, 1, '') ;

CALL ImportField(32410008, ' ', 'NOTE', ' ', 'NOTE', 1, 324, 0, 0, '', 0, 18964, 0, 1, '') ;

CALL ImportField(32410009, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 324, 0, 0, '', 0, 18952, 0, 1, '') ;

CALL ImportField(32410010, ' ', 'BuhOperationCLS', ' ', 'BUHOPERATIONCLS', 1, 324, 0, 0, '', 0, 19007, 0, 1, '') ;

CALL ImportField(32410011, ' ', 'ClsType', ' ', 'CLSTYPE', 1, 324, 0, 0, ',', 0, 19008, 0, 1, '') ;

CALL ImportField(32410012, '', 'ARHIVEDOC', '', 'ARHIVEDOC', 1, 324, 0, 0, '', 0, 18961, 0, 1, '') ;

CALL ImportField(32410031, ' ', 'REESTRNUMBER', ' ', 'ReestrNumber', 1, 324, 0, 0, '', 0, 19090, 0, 1, '') ;

CALL ImportField(32410032, ' ', 'TYPEOPERATIONCLS', ' ', 'OperationTypeCls', 1, 324, 0, 0, '', 0, 18967, 0, 1, '') ;

CALL ImportField(32410052, '  ()', 'BUHPAYMENTCLS', '. ', 'BUHPAYMENTCLS', 1, 324, 0, 1, '', 0, 18968, 0, 1, '') ;

CALL ImportField(32410053, ' ', 'ID', ' ', 'ID', 1, 324, 0, 1, '', 0, 18948, 0, 1, '') ;

CALL ImportField(32410054, ' ', 'REESTR_REF', ' ', 'Reestr_Ref', 1, 324, 0, 1, '', 0, 18971, 0, 1, '') ;

CALL ImportField(32410055, ' ', 'OperationDirection', ' ', 'OPERATIONDIRECTION', 1, 324, 0, 1, '', 0, 19009, 0, 1, '') ;

CALL ImportField(32410057, '  ()', 'REJECTCAUSE', '  ()', 'RejectCause', 1, 324, 0, 0, '', 0, 18973, 0, 1, '') ;

CALL ImportField(32410058, '', 'DocStateRef', '', 'DocStateRef', 1, 324, 0, 1, '', 0, 18996, 0, 1, '') ;

CALL ImportField(32410059, '. c ()', 'SOURCEACCOUNT', '. c ()', 'SOURCEACCOUNT', 1, 324, 0, 1, ',', 0, 18956, 0, 1, '') ;

CALL ImportField(32410060, '. c', 'DESTACCOUNT', '. c', 'DESTACCOUNT', 1, 324, 0, 1, '', 0, 18958, 0, 1, '') ;

CALL ImportField(32410071, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 324, 0, 1, '', 0, 18975, 0, 1, '') ;

CALL ImportField(32410085, ' ', 'REESTRDATE', ' ', 'REESTRDATE', 1, 324, 0, 1, '', 0, 19091, 0, 1, '') ;

CALL ImportField(32410171, ' ', 'PayDate', ' ', 'PayDate', 1, 324, 0, 1, '', 0, 18951, 0, 1, '') ;

CALL ImportField(32410172, '  ', 'SENDERID', '  ', 'SenderID', 1, 324, 0, 1, '', 0, 18969, 0, 1, '') ;

CALL ImportField(32410173, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 324, 0, 1, '', 0, 18960, 0, 1, '') ;

CALL ImportField(32410174, '/c  .', 'DestFacialAcc_Cls', '/  .', 'DestFacialAccCls', 1, 324, 0, 0, '', 0, 18959, 0, 1, '') ;

CALL ImportField(32410177, '(  )', 'DestStoredPaymentProps', '', 'DestStoredPaymentProps', 1, 324, 0, 0, '', 0, 31657, 0, 2, '') ;

CALL ImportField(32410178, '(  )', 'SourceStoredPaymentProps', '', 'SourceStoredPaymentProps', 1, 324, 0, 0, '', 0, 31658, 0, 2, '') ;

CALL ImportField(32410179, ' (  )', 'StoredPaymentNote', '', 'StoredPaymentNote', 1, 324, 0, 0, '', 0, 31659, 0, 2, '') ;

CALL ImportField(32410180, '  ', 'StoredPaymentProps', '', ' ', 1, 324, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(32410181, '.  ', 'StoredPaymentContent', '.  ', 'StoredPaymentContent', 1, 324, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32410182, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 324, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(32410183, '', 'AUTO_AUTORIZATION', '', ' ', 1, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32410184, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32410185, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32410186, '  ()', 'CREATEDATE', '  ()', ' ', 1, 324, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411020, ' .', 'SourceFact', '', 'SOURCEFACT', 1, 324, 1, 1, '', 0, 18890, 0, 1, '') ;

CALL ImportField(32411026, '/ ', 'DESTFACIALACC_CLS', '/ ', 'DestFacialAccCls', 1, 324, 1, 0, ',DestFacialACCCLS', 0, 18869, 0, 1, '') ;

CALL ImportField(32411027, '()', 'SUMMA', '()', 'SUMMA', 1, 324, 1, 0, '', 0, 18873, 0, 1, '') ;

CALL ImportField(32411028, ' ', 'NOTE', ' ', 'NOTE', 1, 324, 1, 0, '', 0, 18876, 0, 1, '') ;

CALL ImportField(32411030, ' ( . - )', 'DESTBUDGETPROMISENUM', '  ()', 'DESTBUDGETPROMISENUM', 1, 324, 1, 0, ',', 0, 20223, 0, 0, '') ;

CALL ImportField(32411033, ' ', 'AcceptDate', ' ', 'ACCEPTDATE', 1, 324, 1, 0, '', 0, 18924, 0, 1, '') ;

CALL ImportField(32411040, ' ', 'DestRegionCls', ' -', 'DESTREGIONCLS', 1, 324, 1, 0, 'DestRegionCls,,', 0, 18928, 0, 1, '') ;

CALL ImportField(32411041, ' . ', 'MEMORDERNUM', ' . ', 'MemOrderNum', 1, 324, 1, 0, '', 0, 18875, 0, 1, '') ;

CALL ImportField(32411043, ' . -', 'DESTPROMISE', '  ', 'DestPROMISE', 1, 324, 1, 0, '', 0, 18906, 0, 1, '') ;

CALL ImportField(32411051, '(.  )', 'DestExecDocNum', '   ', 'DestExecDocNum', 1, 324, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(32411062, '.   ', 'DESTBUDGETPROMISE', '.   ', 'DestBUDGETPROMISE', 1, 324, 1, 1, ',', 0, 18909, 0, 1, '') ;

CALL ImportField(32411064, ' ..  ', 'DestExecDoc', ' ..  ', 'DestExecDoc', 1, 324, 1, 1, '', 0, 18918, 0, 1, '') ;

CALL ImportField(32411067, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 324, 1, 1, '', 0, 18878, 0, 1, '') ;

CALL ImportField(32411068, ' ', 'ID', ' ', 'Id', 1, 324, 1, 1, '', 0, 18865, 0, 1, '') ;

CALL ImportField(32411072, '', 'DestFactCode', ' -', 'DestFACTCLS', 1, 324, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(32411073, ' -', 'DestFinSource', ' - -', 'DestFINSOURCECLS', 1, 324, 1, 0, '', 0, 18901, 0, 1, '') ;

CALL ImportField(32411074, ' . ', 'DestFinTypeCode', '   -', 'DestFINTYPECLS', 1, 324, 1, 0, ',,', 0, 36853, 0, 1, '') ;

CALL ImportField(32411075, '', 'DestKCSR', ' -', 'DestKCSRKey', 1, 324, 1, 1, ',', 0, 18896, 0, 1, '') ;

CALL ImportField(32411076, '', 'DESTKESR', '', 'DestKESRKey', 1, 324, 1, 1, ',', 0, 18871, 0, 1, '') ;

CALL ImportField(32411077, '()', 'DestKFSR', ' -', 'DestKFSR', 1, 324, 1, 0, ',', 0, 18897, 0, 1, '') ;

CALL ImportField(32411078, '', 'DESTKVR', ' -', 'DestKVRKey', 1, 324, 1, 1, '', 0, 18870, 0, 1, '') ;

CALL ImportField(32411079, '', 'DestKVSR', ' -', 'DestKVSRKey', 1, 324, 1, 1, '', 0, 18895, 0, 1, '') ;

CALL ImportField(32411080, ' ', 'DestMeansType', '  -', 'DestMEANSTYPECLS', 1, 324, 1, 0, ',', 0, 18900, 0, 1, '') ;

CALL ImportField(32411081, '', 'DestSubKESR', '', 'DestSUBKESRKey', 1, 324, 1, 1, ',', 0, 18898, 0, 1, '') ;

CALL ImportField(32411082, '', 'DestDocBaseCode', '', 'DESTDOCBASE', 1, 324, 1, 0, ',,', 0, 36865, 0, 1, '') ;

CALL ImportField(32411083, ' ', 'DestDocType', '  -', 'DestDOCTYPECLS', 1, 324, 1, 0, ',', 0, 18903, 0, 1, '') ;

CALL ImportField(32411084, '', 'DestDirectionCLSCode', ' -', 'DestDirectionCLS', 1, 324, 1, 0, ',', 0, 36861, 0, 1, '') ;

CALL ImportField(32411088, ' ', 'DestIFS', ' ', 'DestIFS', 1, 324, 1, 1, '', 0, 18921, 0, 1, '') ;

CALL ImportField(32411175, ' ', 'DestAssignmentKind', '  -', 'DestAssignmentKind', 1, 324, 1, 0, ',', 0, 25178, 0, 1, '') ;

CALL ImportField(32411176, ' ', 'Progindex', '  ()', 'ProgIndex', 1, 324, 1, 1, '', 0, 18877, 0, 1, '') ;

CALL ImportField(32411178, '  ', 'DestTransfertCls', '    ()', 'DestTransfertCls', 1, 324, 1, 1, '', 0, 18936, 0, 1, '') ;

CALL ImportField(32411179, '  ', 'DestTransfertClsCode', '   ', 'DestTransfertClsValue', 1, 324, 1, 0, ',', 0, 25326, 0, 1, '') ;

CALL ImportField(32411182, '()', 'DestKCSRCode', '()', 'DestKCSR', 1, 324, 1, 0, ',', 0, 25462, 0, 1, '') ;

CALL ImportField(32411183, '()', 'DESTKVRCode', '()', 'DestKVR', 1, 324, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(32411184, '()', 'DestKVSRCode', '()', 'DestKVSR', 1, 324, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(32411185, ' ', 'DestIFS_FullID', ' ', 'DestIFS_DescriptionCode', 1, 324, 1, 1, '', 0, 17055, 0, 1, '') ;

CALL ImportField(32411188, ' ', 'DestBudAllocationClsCode', '', 'DestBudAllocationClsCode', 1, 324, 1, 0, ',', 0, 27825, 0, 1, '') ;

CALL ImportField(32411189, '  ', 'DestPayPromiseClsCode', '', 'DestPayPromiseClsCode', 1, 324, 1, 0, ',', 0, 27849, 0, 1, '') ;

CALL ImportField(32411190, ' ', 'DestSubsidyCls', '', 'DestSubsidyCls', 1, 324, 1, 1, ',', 0, 26624, 0, 1, '') ;

CALL ImportField(32411191, ' ', 'DestSubsidyClsCode', '', 'DestSubsidyClsCode', 1, 324, 1, 0, ',', 0, 26641, 0, 1, '') ;

CALL ImportField(32411192, ' ', 'DestBudAllocationCls', '', 'DestBudAllocationCls', 1, 324, 1, 1, ',', 0, 27842, 0, 1, '') ;

CALL ImportField(32411193, '  ', 'DestPayPromiseCls', '', 'DestPayPromiseCls', 1, 324, 1, 1, ',', 0, 27843, 0, 1, '') ;

CALL ImportField(32411194, ' ()', 'DestFact', ' -', 'DestFACTCLSKey', 1, 324, 1, 1, '', 0, 18899, 0, 1, '') ;

CALL ImportField(32411196, ' .  ()', 'DestFinType', '  ', 'DestFINTYPECLSKey', 1, 324, 1, 1, ',,', 0, 18902, 0, 1, '') ;

CALL ImportField(32411204, ' ()', 'TransfertOrg_Ref', ' ()()', 'TransfertOrg_Ref', 1, 324, 1, 1, '', 0, 38150, 0, 1, '') ;

CALL ImportField(32411205, '', 'DestContractCostsCls', '', 'DestContractCostsClsKey', 1, 324, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(32411206, '', 'DestContractCostsClsCode', '', 'DestContractCostsCls', 1, 324, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(32411207, '.   ()', 'StoredPaymentContentDet', '.   ()', 'StoredPaymentContentDet', 1, 324, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(32411208, ' ', 'DestTargetClsCode', ' ', 'DestTargetCls', 1, 324, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(32411209, ' ', 'DestTargetCls', '  ()', 'DestTargetClsKey', 1, 324, 1, 1, '', 0, 40643, 0, 0, '') ;

CALL ImportField(32411210, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 324, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(32411211, '', 'AUTO_AUTORIZATION', '', ' ', 1, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411212, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411213, '  ()', 'CREATEDATE', '  ()', ' ', 1, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411214, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 324, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(32411266, '()', 'DESTKESRCode', '()', 'DestKESR', 1, 324, 1, 0, ',', 0, 43607, 0, 1, '') ;

CALL ImportField(32411268, '()', 'DestSubKESRCode', '()', 'DestSUBKESR', 1, 324, 1, 0, ',', 0, 43610, 0, 1, '') ;

--    , (1)
CALL ImportField(40111056, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 1, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40113084, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 3, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40114100, '()', 'KVSR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114101, '()', 'KFSR', '', ' ', 1, 401, 4, 0, '', 0, 18148, 0, 0, '') ;

CALL ImportField(40114102, '()', 'KCSR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114103, '()', 'KVR', '', ' ', 1, 401, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(40114104, '()', 'KESR', '', ' ', 1, 401, 4, 0, '', 0, 18151, 0, 0, '') ;

CALL ImportField(40114106, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 4, 0, '', 0, 18142, 0, 0, '') ;

CALL ImportField(40114235, '()', 'KCSRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40114236, '()', 'KVRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40114237, '()', 'KVSRCode', '()', ' ', 1, 401, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40114256, '()', 'KESRCode', '()', ' ', 1, 401, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40116121, '', 'KVSR', '', ' ', 1, 401, 6, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(40116122, '()', 'KFSR', '', ' ', 1, 401, 6, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(40116123, '', 'KCSR', '', ' ', 1, 401, 6, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(40116124, '', 'KVR', '', ' ', 1, 401, 6, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(40116125, '', 'KESR', '', ' ', 1, 401, 6, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(40116139, '', 'SUBKESR', '', ' ', 1, 401, 6, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(40116143, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 6, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(40116241, '()', 'KCSRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40116242, '()', 'KVRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40116243, '()', 'KVSRCode', '()', ' ', 1, 401, 6, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40116257, '()', 'KESRCode', '()', ' ', 1, 401, 6, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40116259, '()', 'SUBKESRCode', '()', ' ', 1, 401, 6, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(40118167, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 8, 0, '', 0, 19218, 0, 0, '') ;

CALL ImportField(40110192, '', 'KVSR', '', ' ', 1, 401, 10, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(40110193, '()', 'KFSR', '', ' ', 1, 401, 10, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(40110194, '', 'KCSR', '', ' ', 1, 401, 10, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(40110195, '', 'KVR', '', ' ', 1, 401, 10, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(40110196, '', 'KESR', '', ' ', 1, 401, 10, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(40110202, '', 'SUBKESR', '', ' ', 1, 401, 10, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(40110209, ' ', 'BuhOperationCLS', ' ', ' ', 1, 401, 10, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(40110246, '()', 'KCSRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(40110247, '()', 'KVRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(40110248, '()', 'KVSRCode', '()', ' ', 1, 401, 10, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(40110258, '()', 'KESRCode', '()', ' ', 1, 401, 10, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(40110260, '()', 'SUBKESRCode', '()', ' ', 1, 401, 10, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(50111038, '', 'KVSR', '', ' ', 1, 501, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(50111039, '()', 'KFSR', '', ' ', 1, 501, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(50111040, '', 'KCSR', '', ' ', 1, 501, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(50111041, '', 'KVR', '', ' ', 1, 501, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(50111042, '', 'KESR', '', ' ', 1, 501, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(50111045, '', 'SUBKESR', '', ' ', 1, 501, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(50111062, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(50111181, '()', 'KCSRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(50111182, '()', 'KVRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(50111183, '()', 'KVSRCode', '()', ' ', 1, 501, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50111191, '()', 'KESRCODE', '()', ' ', 1, 501, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50111195, '()', 'SUBKESRCode', '()', ' ', 1, 501, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(50113074, '', 'KVSR', '', ' ', 1, 501, 3, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(50113075, '()', 'KFSR', '', ' ', 1, 501, 3, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(50113076, '', 'KCSR', '', ' ', 1, 501, 3, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(50113077, '', 'KVR', '', ' ', 1, 501, 3, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(50113078, '', 'KESR', '', ' ', 1, 501, 3, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(50113081, '', 'SUBKESR', '', ' ', 1, 501, 3, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(50113096, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 3, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(50113185, '()', 'KCSRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(50113186, '()', 'KVRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(50113187, '()', 'KVSRCode', '()', ' ', 1, 501, 3, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50113192, '()', 'KESRCODE', '()', ' ', 1, 501, 3, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50113196, '()', 'SUBKESRCode', '()', ' ', 1, 501, 3, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(50114104, '( )', 'KVSR', '', ' ', 1, 501, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(50114114, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 4, 0, '', 0, 18142, 0, 0, '') ;

CALL ImportField(50114170, '( )', 'KVSRCode', '( )', ' ', 1, 501, 4, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50114193, '( )', 'KESRCODE', '( )', ' ', 1, 501, 4, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(50116125, '( )', 'KVSR', '', ' ', 1, 501, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(50116139, ' ', 'BuhOperationCLS', ' ', ' ', 1, 501, 6, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(50116175, '( )', 'KVSRCode', '( )', ' ', 1, 501, 6, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(50116194, '( )', 'KESRCODE', '( )', ' ', 1, 501, 6, 0, '', 0, 43607, 0, 0, '') ;

--   , (1)
CALL ImportField(70111007, '', 'KVSR', '', ' ', 1, 701, 1, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(70111008, '()', 'KFSR', '', ' ', 1, 701, 1, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(70111009, '', 'KCSR', '', ' ', 1, 701, 1, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(70111010, '', 'KVR', '', ' ', 1, 701, 1, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(70111011, '', 'KESR', '', ' ', 1, 701, 1, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(70111018, '', 'SUBKESR', '', ' ', 1, 701, 1, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(70111044, ' ', 'BuhOperationCLS', ' ', ' ', 1, 701, 1, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(70111066, '()', 'KCSRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(70111067, '()', 'KVRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(70111068, '()', 'KVSRCode', '()', ' ', 1, 701, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(70111074, '()', 'KESRCode', '()', ' ', 1, 701, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(70111075, '()', 'SUBKESRCode', '()', ' ', 1, 701, 1, 0, '()', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(70310004, '', 'KVSR', '', ' ', 1, 703, 0, 1, '', 0, 17825, 0, 0, '') ;

CALL ImportField(70310005, '()', 'KFSR', '', ' ', 1, 703, 0, 0, '', 0, 17823, 0, 0, '') ;

CALL ImportField(70310006, '', 'KCSR', '', ' ', 1, 703, 0, 1, '', 0, 17824, 0, 0, '') ;

CALL ImportField(70310007, '', 'KVR', '', ' ', 1, 703, 0, 1, '', 0, 17826, 0, 0, '') ;

CALL ImportField(70310008, '', 'KESR', '', ' ', 1, 703, 0, 1, '', 0, 17827, 0, 0, '') ;

CALL ImportField(70310015, '', 'SUBKESR', '', ' ', 1, 703, 0, 1, '', 0, 17828, 0, 0, '') ;

CALL ImportField(70310039, ' ', 'BuhOperationCLS', ' ', ' ', 1, 703, 0, 0, '', 0, 17871, 0, 0, '') ;

CALL ImportField(70310049, '()', 'KCSRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(70310050, '()', 'KVRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(70310051, '()', 'KVSRCode', '()', ' ', 1, 703, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(70310055, '()', 'KESRCode', '()', ' ', 1, 703, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(70310056, '()', 'SUBKESRCode', '()', ' ', 1, 703, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(80110016, '', 'AMONTH', '', 'MONTH', 1, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80110027, '', 'AYEAR', '', 'YEAR', 1, 801, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80111022, '', 'KCSR', '', 'KCSRKey', 1, 801, 1, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80111023, '', 'KESR', '', 'KESRKey', 1, 801, 1, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80111024, '()', 'KFSR', '', 'KFSR', 1, 801, 1, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80111025, '', 'KVR', '', 'KVRKey', 1, 801, 1, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80111026, '', 'KVSR', '', 'KVSRKey', 1, 801, 1, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80111028, '', 'AMONTH', '', 'MONTH', 1, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80111040, '', 'SUBKESR', '', 'SUBKESRKey', 1, 801, 1, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80111042, '', 'AYEAR', '', 'YEAR', 1, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80111048, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 1, 801, 1, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80111058, '()', 'KCSRCode', '()', 'KCSR', 1, 801, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80111059, '()', 'KVRCode', '()', 'KVR', 1, 801, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80111060, '()', 'KVSRCode', '()', 'KVSR', 1, 801, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80111079, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80111086, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 801, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80111091, '()', 'KESRCode', '', 'KESR', 1, 801, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80111094, '()', 'SUBKESRCode', '()', 'SUBKESR', 1, 801, 1, 0, '', 0, 43610, 0, 0, '') ;

--   (), (1)
CALL ImportField(80210006, '', 'KVSR', '', ' ', 1, 802, 0, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80210007, '()', 'KFSR', '', ' ', 1, 802, 0, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80210008, '', 'KCSR', '', ' ', 1, 802, 0, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80210009, '', 'KVR', '', ' ', 1, 802, 0, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80210010, '', 'KESR', '', ' ', 1, 802, 0, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80210017, '', 'SUBKESR', '', ' ', 1, 802, 0, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80210024, ' ', 'BuhOperationCLS', ' ', ' ', 1, 802, 0, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80210036, '()', 'KCSRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80210037, '()', 'KVRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80210038, '()', 'KVSRCode', '()', ' ', 1, 802, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80210044, ' ', 'TargetClsCode', ' ', ' ', 1, 802, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(80210045, ' ', 'TargetCls', '  ()', ' ', 1, 802, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(80210046, '()', 'KESRCode', '()', ' ', 1, 802, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(80210047, '()', 'SUBKESRCode', '()', ' ', 1, 802, 0, 0, '', 0, 43610, 0, 0, '') ;

--     , (1)
CALL ImportField(80311012, '()', 'KFSR', '', ' ', 1, 803, 1, 0, '', 0, 18653, 0, 0, '') ;

CALL ImportField(80311013, '', 'KCSR', '', ' ', 1, 803, 1, 1, '', 0, 18652, 0, 0, '') ;

CALL ImportField(80311014, '', 'KVR', '', ' ', 1, 803, 1, 1, '', 0, 18629, 0, 0, '') ;

CALL ImportField(80311015, '', 'KESR', '', ' ', 1, 803, 1, 1, '', 0, 18630, 0, 0, '') ;

CALL ImportField(80311029, '', 'SUBKESR', '', ' ', 1, 803, 1, 1, '', 0, 18635, 0, 0, '') ;

CALL ImportField(80311033, ' ', 'BuhOperationCLS', ' ', ' ', 1, 803, 1, 0, '', 0, 18665, 0, 0, '') ;

CALL ImportField(80311035, '', 'KVSR', '', ' ', 1, 803, 1, 1, '', 0, 18651, 0, 0, '') ;

CALL ImportField(80311049, '()', 'KCSRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(80311050, '()', 'KVRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(80311051, '()', 'KVSRCode', '()', ' ', 1, 803, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(80311057, ' ', 'TargetClsCode', ' ', ' ', 1, 803, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(80311058, ' ', 'TargetCls', '  ()', ' ', 1, 803, 1, 1, '', 0, 40891, 0, 0, '') ;

CALL ImportField(80311059, '()', 'KESRCode', '()', ' ', 1, 803, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(80311060, '()', 'SUBKESRCode', '()', ' ', 1, 803, 1, 0, '', 0, 43610, 0, 0, '') ;

-- , (1)
CALL ImportField(90010002, '()', '{("")}', ' ', ' ', 1, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90010003, '', 'AUTO_AUTORIZATION', '', ' ', 1, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90010004, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90010005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90010006, '  ()', 'CREATEDATE', '  ()', ' ', 1, 900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011009, ' ', '{("")}', ' ', ' ', 1, 900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90011010, ' ', '{("")}', '  ()', ' ', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011011, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011012, '', 'AUTO_AUTORIZATION', '', ' ', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011013, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011014, '  ()', 'CREATEDATE', '  ()', ' ', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90011015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 900, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(90110041, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90110042, '', 'AUTO_AUTORIZATION', '', ' ', 1, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90110043, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90110044, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90110045, '  ()', 'CREATEDATE', '  ()', ' ', 1, 901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90111030, ' ', 'BuhOperationCLS', ' ', ' ', 1, 901, 1, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90111069, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90111070, '', 'AUTO_AUTORIZATION', '', ' ', 1, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90111071, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90111072, '  ()', 'CREATEDATE', '  ()', ' ', 1, 901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90111073, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 901, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(90210032, ' ', 'BuhOperationCLS', ' ', ' ', 1, 902, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90210052, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90210053, '', 'AUTO_AUTORIZATION', '', ' ', 1, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90210054, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90210055, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90210056, '  ()', 'CREATEDATE', '  ()', ' ', 1, 902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90211046, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90211047, '', 'AUTO_AUTORIZATION', '', ' ', 1, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90211048, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90211049, '  ()', 'CREATEDATE', '  ()', ' ', 1, 902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90211050, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 902, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(90310001, ' ', 'BUILDDATE', ' ', 'BuildDate', 1, 903, 0, 0, '', 0, 17645, 0, 1, '') ;

CALL ImportField(90310002, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 903, 0, 0, '', 0, 17646, 0, 1, '') ;

CALL ImportField(90310003, ' ', 'DFAccountName', ' ', 'IncAccountName', 1, 903, 0, 0, '', 0, 17112, 0, 1, '') ;

CALL ImportField(90310008, '', 'BudgetRef', '', 'BudgetRef', 1, 903, 0, 0, '', 0, 17649, 0, 1, '') ;

CALL ImportField(90310009, '  ', 'RejectCls', '  ', 'RejectCls', 1, 903, 0, 0, '', 0, 17663, 0, 1, '') ;

CALL ImportField(90310010, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 903, 0, 0, '', 0, 17664, 0, 1, '') ;

CALL ImportField(90310011, ' ', 'DocNumber', ' ', 'DocNumber', 1, 903, 0, 0, '', 0, 17648, 0, 1, '') ;

CALL ImportField(90310059, ' ', 'ID', ' ', 'ID', 1, 903, 0, 1, '', 0, 17644, 0, 1, '') ;

CALL ImportField(90310061, ' ()', 'INCACCOUNT', ' ', 'IncAccount', 1, 903, 0, 1, '', 0, 17647, 0, 1, '') ;

CALL ImportField(90310072, ' (-)', 'Summa', ' (-)', 'Summa', 1, 903, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90310073, '  ', 'SenderID', '  ', 'SenderID', 1, 903, 0, 1, '', 0, 17660, 0, 1, '') ;

CALL ImportField(90310075, ' ', 'DocStateRef', ' ', 'DocStateRef', 1, 903, 0, 1, '', 0, 25481, 0, 1, '') ;

CALL ImportField(90310076, '', 'DepartmentCls', '  ,  ', 'DepartmentCls', 1, 903, 0, 0, '', 0, 27626, 0, 1, '') ;

CALL ImportField(90310077, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90310078, '', 'AUTO_AUTORIZATION', '', ' ', 1, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90310079, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90310080, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90310081, '  ()', 'CREATEDATE', '  ()', ' ', 1, 903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311020, '', 'GOSNI', '', 'GosNI', 1, 903, 1, 0, '', 0, 17683, 0, 1, '') ;

CALL ImportField(90311021, '', 'INN20', ' ', 'Org_refKPP', 1, 903, 1, 0, '', 0, 16653, 0, 1, '') ;

CALL ImportField(90311022, '', 'INN', ' ', 'Org_refINN', 1, 903, 1, 0, '', 0, 16645, 0, 1, '') ;

CALL ImportField(90311023, '', 'DOCNUM', '', 'DocNum', 1, 903, 1, 0, '', 0, 17707, 0, 1, '') ;

CALL ImportField(90311024, '. ', 'SUBKD', '. ', 'SubKD', 1, 903, 1, 0, '', 0, 17681, 0, 1, '') ;

CALL ImportField(90311025, '', 'NDS', '', 'NDS', 1, 903, 1, 0, '', 0, 17698, 0, 1, '') ;

CALL ImportField(90311026, ' ', 'MeansType', ' ', 'MeansType', 1, 903, 1, 0, '', 0, 17699, 0, 1, '') ;

CALL ImportField(90311027, ' ', 'ACC', '  ', 'AccountRefName', 1, 903, 1, 0, '', 0, 17112, 0, 1, '') ;

CALL ImportField(90311028, ' ', 'DocDate', ' ', 'DocDate', 1, 903, 1, 0, '', 0, 17708, 0, 1, '') ;

CALL ImportField(90311029, ' ', 'facialAcc_Cls', ' ', 'FacialAcc_Cls', 1, 903, 1, 0, '', 0, 17697, 0, 1, '') ;

CALL ImportField(90311030, '', 'KESR', '', 'KESRKey', 1, 903, 1, 1, '', 0, 17712, 0, 1, '') ;

CALL ImportField(90311033, '', 'Debit', '', 'Debit', 1, 903, 1, 0, '', 0, 17673, 0, 1, '') ;

CALL ImportField(90311035, ' ', 'CLSType', ' ', 'ClsType', 1, 903, 1, 0, '', 0, 17723, 0, 1, '') ;

CALL ImportField(90311036, '', 'Credit', '', 'Credit', 1, 903, 1, 0, '', 0, 17674, 0, 1, '') ;

CALL ImportField(90311037, '', 'Name', ' -', 'Org_refName', 1, 903, 1, 0, '', 0, 16646, 0, 1, '') ;

CALL ImportField(90311038, '', 'DOCTYPE', '', 'DocType', 1, 903, 1, 0, '', 0, 17675, 0, 1, '') ;

CALL ImportField(90311039, '', 'Note', '', 'Note', 1, 903, 1, 0, '', 0, 17692, 0, 1, '') ;

CALL ImportField(90311040, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 903, 1, 0, '', 0, 17720, 0, 1, '') ;

CALL ImportField(90311041, '', 'OKATO', 'OKATO', 'OKATO', 1, 903, 1, 1, '', 0, 17728, 0, 1, '') ;

CALL ImportField(90311042, ' ', 'ADDOKATO', ' ', 'AddOKATO', 1, 903, 1, 1, '', 0, 17729, 0, 1, '') ;

CALL ImportField(90311045, ' ', 'REGIONCLS', '', 'RegionCLS', 1, 903, 1, 0, ',', 0, 17682, 0, 1, '') ;

CALL ImportField(90311047, '', 'ACCOUNTINDEX', '', 'AccountIndex', 1, 903, 1, 0, '', 0, 17678, 0, 1, '') ;

CALL ImportField(90311048, '', 'FactCode', '', 'Fact', 1, 903, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(90311049, '', 'DocBaseCode', '', 'DocBase', 1, 903, 1, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(90311052, '( )', 'IsBlocked', '', 'IsBlocked', 1, 903, 1, 0, '', 0, 17734, 0, 1, '') ;

CALL ImportField(90311053, ' ( )', 'BlockedCause', ' ', 'BlockedCause', 1, 903, 1, 0, '', 0, 17735, 0, 1, '') ;

CALL ImportField(90311054, ' ( )', 'UnBlockedDate', ' ', 'UnBlockedDate', 1, 903, 1, 0, '', 0, 17736, 0, 1, '') ;

CALL ImportField(90311055, ' ( )', 'UnBlockedCause', ' ', 'UnblockedCause', 1, 903, 1, 0, '', 0, 17737, 0, 1, '') ;

CALL ImportField(90311056, ' ', 'FundsSource', ' ', 'FundsSource', 1, 903, 1, 0, '', 0, 17732, 0, 1, '') ;

CALL ImportField(90311057, '', 'DirectionCLSCode', '', 'DirectionCls', 1, 903, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(90311058, '   ', 'taxnote', '   ', 'TaxNote', 1, 903, 1, 0, '', 0, 17705, 0, 1, '') ;

CALL ImportField(90311062, ' ', 'PROGINDEX', ' ', 'ProgIndex', 1, 903, 1, 1, '', 0, 17685, 0, 1, '') ;

CALL ImportField(90311063, '()', 'IFS', '   ', 'IFS', 1, 903, 1, 1, '', 0, 17721, 0, 1, '') ;

CALL ImportField(90311064, '()', 'KD', '   ', 'KD', 1, 903, 1, 1, '', 0, 17680, 0, 1, '') ;

CALL ImportField(90311066, ' ', 'ID', ' ', 'Id', 1, 903, 1, 1, '', 0, 17669, 0, 1, '') ;

CALL ImportField(90311067, '  ', 'ORG_REF', '', 'Org_ref', 1, 903, 1, 1, '', 0, 17677, 0, 1, '') ;

CALL ImportField(90311069, 'REcordIndex', 'RECORDINDEX', 'REcordIndex', 'RecordIndex', 1, 903, 1, 1, '', 0, 17686, 0, 1, '') ;

CALL ImportField(90311070, ' ()', 'ACC_REF', ' ()', 'AccountRef', 1, 903, 1, 1, '', 0, 17679, 0, 1, '') ;

CALL ImportField(90311074, ' . (  )', 'ELNUM', ' . ', 'EL_DocNumber', 1, 903, 1, 1, '', 0, 19317, 0, 1, '') ;

CALL ImportField(90311075, '   ()', 'TransfertCls', '   ()', 'TransfertCls', 1, 903, 1, 1, '', 0, 17739, 0, 1, '') ;

CALL ImportField(90311076, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 903, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(90311079, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 903, 1, 1, '', 0, 26627, 0, 1, '') ;

CALL ImportField(90311080, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 903, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(90311081, ' ', 'KDValue', ' ', 'KDValue', 1, 903, 1, 0, '', 0, 16836, 0, 1, '') ;

CALL ImportField(90311086, '', 'UINCode', '  ', 'UINCode', 1, 903, 1, 0, '', 0, 35368, 0, 1, '') ;

CALL ImportField(90311087, ' .  ()', 'FinType', '  ', 'FINTYPEKey', 1, 903, 1, 1, ',', 0, 36856, 0, 1, '') ;

CALL ImportField(90311088, ' . ', 'FinTypeCode', '  ', 'FINTYPE', 1, 903, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(90311089, ' ()', 'DirectionCLS', '', 'DirectionClsKey', 1, 903, 1, 1, '', 0, 17733, 0, 1, '') ;

CALL ImportField(90311090, ' ()', 'Fact', '', 'FactKey', 1, 903, 1, 1, '', 0, 17710, 0, 1, '') ;

CALL ImportField(90311091, ' ()', 'DocBase', '', 'DocBaseKey', 1, 903, 1, 1, ',', 0, 17709, 0, 1, '') ;

CALL ImportField(90311095, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 903, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90311096, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 903, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90311097, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 903, 1, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90311178, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(90311180, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(90311181, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311182, '', 'AUTO_AUTORIZATION', '', ' ', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311183, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311184, '  ()', 'CREATEDATE', '  ()', ' ', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311185, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90311186, '()', 'KESRCode', '()', 'KESR', 1, 903, 1, 0, '', 0, 43607, 0, 1, '') ;

--   , (1)
CALL ImportField(90510004, ' ', 'KDValue', ' ', ' ', 1, 905, 0, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(90510016, ' ', 'MeansType', ' ', ' ', 1, 905, 0, 0, '', 0, 17699, 0, 0, '') ;

CALL ImportField(90510021, '', 'NDS', '', ' ', 1, 905, 0, 0, '', 0, 17698, 0, 0, '') ;

CALL ImportField(90510026, ' ', 'BuhOperationCLS', ' ', ' ', 1, 905, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90510033, '  ()', 'TransfertCls', '   ()', ' ', 1, 905, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90510040, ' .  ()', 'FinType', '  ', 'FINTYPEKey', 1, 905, 0, 1, '', 0, 36856, 0, 0, '') ;

CALL ImportField(90510043, ' ()', 'DocBase', '', ' ', 1, 905, 0, 1, ',', 0, 17709, 0, 0, '') ;

CALL ImportField(90510044, '', 'InvestObject', '', ' ', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510046, '', 'KESR', '', 'KESRKey', 1, 905, 0, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90510047, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 905, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90510051, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 905, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90510053, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 905, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90510054, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510055, '', 'AUTO_AUTORIZATION', '', ' ', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510056, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510057, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510058, '  ()', 'CREATEDATE', '  ()', ' ', 1, 905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90510059, '()', 'KESRCode', '()', 'KESR', 1, 905, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90511001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90511002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90511003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90511004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 905, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90511005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 905, 1, 1, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(90610004, ' ', 'KDValue', ' ', ' ', 1, 906, 0, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(90610021, ' ', 'MeansType', ' ', ' ', 1, 906, 0, 0, '', 0, 17699, 0, 0, '') ;

CALL ImportField(90610022, ' ', 'BuhOperationCLS', ' ', ' ', 1, 906, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90610057, '', 'KD', '', ' ', 1, 906, 0, 1, '', 0, 17680, 0, 0, '') ;

CALL ImportField(90610058, ' ', 'ID', ' ', ' ', 1, 906, 0, 1, '', 0, 17669, 0, 0, '') ;

CALL ImportField(90610064, ' ', 'DocDate', ' ', ' ', 1, 906, 0, 0, '', 0, 17708, 0, 0, '') ;

CALL ImportField(90610073, '  ', 'TransfertCls', '   ()', ' ', 1, 906, 0, 1, '', 0, 17739, 0, 0, '') ;

CALL ImportField(90610079, ' ()', 'Fact', '', ' ', 1, 906, 0, 1, '', 0, 17710, 0, 0, '') ;

CALL ImportField(90610080, '', 'InvestObject', '', ' ', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610082, '', 'KESR', '', 'KESRKey', 1, 906, 0, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90610083, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610084, '', 'AUTO_AUTORIZATION', '', ' ', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610085, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610086, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610087, '  ()', 'CREATEDATE', '  ()', ' ', 1, 906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90610096, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 906, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90610098, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 906, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90610115, '()', 'KESRCode', '()', 'KESR', 1, 906, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90611026, ' ', 'KDValue', ' ', ' ', 1, 906, 1, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(90611031, '.  ', 'SubKD', '.  ', ' ', 1, 906, 1, 0, '', 0, 17681, 0, 0, '') ;

CALL ImportField(90611032, ' ', 'MeansType', ' ', ' ', 1, 906, 1, 0, '', 0, 17699, 0, 0, '') ;

CALL ImportField(90611045, ' ', 'BuhOperationCLS', ' ', ' ', 1, 906, 1, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90611049, '  ()', 'RejectCause', '  ()', ' ', 1, 906, 1, 0, '', 0, 17731, 0, 0, '') ;

CALL ImportField(90611050, '   ', 'TaxNote', '   ', ' ', 1, 906, 1, 0, '', 0, 17705, 0, 0, '') ;

CALL ImportField(90611051, '( )', 'IsBlocked', '', ' ', 1, 906, 1, 0, '', 0, 17734, 0, 0, '') ;

CALL ImportField(90611052, ' ( )', 'BlockedCause', ' ', ' ', 1, 906, 1, 0, '', 0, 17735, 0, 0, '') ;

CALL ImportField(90611053, ' ( )', 'UnBlockedDate', ' ', ' ', 1, 906, 1, 0, '', 0, 17736, 0, 0, '') ;

CALL ImportField(90611056, ' ', 'FundsSource', ' ', ' ', 1, 906, 1, 0, '', 0, 17732, 0, 0, '') ;

CALL ImportField(90611065, '', 'KD', '', ' ', 1, 906, 1, 1, '', 0, 17680, 0, 0, '') ;

CALL ImportField(90611067, ' ', 'ID', ' ', ' ', 1, 906, 1, 1, '', 0, 17669, 0, 0, '') ;

CALL ImportField(90611074, '  ', 'TransfertCls', '   ()', ' ', 1, 906, 1, 1, '', 0, 17739, 0, 0, '') ;

CALL ImportField(90611080, ' ', 'SubsidyCls', '', ' ', 1, 906, 1, 1, '', 0, 26627, 0, 0, '') ;

CALL ImportField(90611081, ' ', 'SubsidyClsCode', '', ' ', 1, 906, 1, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(90611082, ' .  ()', 'FinType', '  ', ' ', 1, 906, 1, 1, '', 0, 36856, 0, 0, '') ;

CALL ImportField(90611084, ' ()', 'DirectionCls', '', ' ', 1, 906, 1, 1, '', 0, 17733, 0, 0, '') ;

CALL ImportField(90611085, ' ()', 'Fact', '', ' ', 1, 906, 1, 1, '', 0, 17710, 0, 0, '') ;

CALL ImportField(90611086, '', 'InvestObject', '', ' ', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611088, '', 'KESR', '', 'KESRKey', 1, 906, 1, 1, '', 0, 17712, 0, 0, '') ;

CALL ImportField(90611089, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 906, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90611090, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611091, '', 'AUTO_AUTORIZATION', '', ' ', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611092, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611093, '  ()', 'CREATEDATE', '  ()', ' ', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611094, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90611100, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 906, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90611112, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 906, 1, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90611116, '()', 'KESRCode', '()', 'KESR', 1, 906, 1, 0, '', 0, 43607, 0, 0, '') ;

--   (), (1)
CALL ImportField(90710002, ' ', 'MeansType', ' ', ' ', 1, 907, 0, 0, '', 0, 17699, 0, 0, '') ;

CALL ImportField(90710003, ' ', 'KDValue', ' ', ' ', 1, 907, 0, 0, '', 0, 16836, 0, 0, '') ;

CALL ImportField(90710008, '. ', 'SubKD', '. ', ' ', 1, 907, 0, 0, '', 0, 17681, 0, 0, '') ;

CALL ImportField(90710009, '', 'Debit', '', ' ', 1, 907, 0, 0, '', 0, 17673, 0, 0, '') ;

CALL ImportField(90710010, '', 'Credit', '', ' ', 1, 907, 0, 0, '', 0, 17674, 0, 0, '') ;

CALL ImportField(90710015, '', 'BudgetRef', '', ' ', 1, 907, 0, 0, '', 0, 17687, 0, 0, '') ;

CALL ImportField(90710016, '', 'RegionCLS', '', ' ', 1, 907, 0, 0, ',,', 0, 17682, 0, 0, '') ;

CALL ImportField(90710017, '', 'GosNI', '', ' ', 1, 907, 0, 0, '', 0, 17683, 0, 0, '') ;

CALL ImportField(90710019, '', 'AccountIndex', '', ' ', 1, 907, 0, 0, '', 0, 17678, 0, 0, '') ;

CALL ImportField(90710020, '', 'DocType', '', ' ', 1, 907, 0, 0, '', 0, 17675, 0, 0, '') ;

CALL ImportField(90710023, '', 'NDS', '', ' ', 1, 907, 0, 0, '', 0, 17698, 0, 0, '') ;

CALL ImportField(90710025, ' ', 'BuhOperationCLS', ' ', ' ', 1, 907, 0, 0, '', 0, 17720, 0, 0, '') ;

CALL ImportField(90710027, '', 'OKATO', 'OKATO', ' ', 1, 907, 0, 0, '', 0, 17728, 0, 0, '') ;

CALL ImportField(90710029, ' ', 'ProgIndex', ' ', ' ', 1, 907, 0, 1, '', 0, 17685, 0, 0, '') ;

CALL ImportField(90710030, '', 'IFS', '', ' ', 1, 907, 0, 1, '', 0, 17721, 0, 0, '') ;

CALL ImportField(90710031, ' ', 'FundsSource', ' ', ' ', 1, 907, 0, 0, '', 0, 17732, 0, 0, '') ;

CALL ImportField(90710032, '', 'KD', '', ' ', 1, 907, 0, 1, '', 0, 17680, 0, 0, '') ;

CALL ImportField(90710033, ' ', 'ID', ' ', ' ', 1, 907, 0, 1, '', 0, 17669, 0, 0, '') ;

CALL ImportField(90710035, ' ', 'IncAccount', ' ', ' ', 1, 907, 0, 1, '', 0, 17684, 0, 0, '') ;

CALL ImportField(90710043, '  ', 'TransfertCls', '   ()', ' ', 1, 907, 0, 1, '', 0, 17739, 0, 0, '') ;

CALL ImportField(90710051, ' ', 'SubsidyCls', '', ' ', 1, 907, 0, 1, '', 0, 26627, 0, 0, '') ;

CALL ImportField(90710052, ' ', 'SubsidyClsCode', '', ' ', 1, 907, 0, 0, '', 0, 26641, 0, 0, '') ;

CALL ImportField(90710053, '', 'OKTMO', '', ' ', 1, 907, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(90710054, ' ()', 'DirectionCls', '', ' ', 1, 907, 0, 1, '', 0, 17733, 0, 0, '') ;

CALL ImportField(90710056, '', 'InvestObject', '', ' ', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710058, '', 'KESR', '', 'KESRKey', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710059, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 907, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(90710060, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 907, 0, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(90710061, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 907, 0, 1, '', 0, 40886, 0, 0, '') ;

CALL ImportField(90710062, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710063, '', 'AUTO_AUTORIZATION', '', ' ', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710064, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710065, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710066, '  ()', 'CREATEDATE', '  ()', ' ', 1, 907, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90710068, '()', 'KESRCode', '()', 'KESR', 1, 907, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(90711001, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90711002, '', 'AUTO_AUTORIZATION', '', ' ', 1, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90711003, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90711004, '  ()', 'CREATEDATE', '  ()', ' ', 1, 907, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(90711005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 907, 1, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(120110005, '', 'KVSR', '', ' ', 1, 1201, 0, 1, '', 0, 17341, 0, 0, '') ;

CALL ImportField(120110006, '( )', 'KFSR', '', ' ', 1, 1201, 0, 0, '', 0, 17342, 0, 0, '') ;

CALL ImportField(120110007, '', 'KCSR', '', ' ', 1, 1201, 0, 1, '', 0, 17345, 0, 0, '') ;

CALL ImportField(120110008, '', 'KVR', '', ' ', 1, 1201, 0, 1, '', 0, 17344, 0, 0, '') ;

CALL ImportField(120110009, '', 'KESR', '', ' ', 1, 1201, 0, 1, '', 0, 17343, 0, 0, '') ;

CALL ImportField(120110019, ' ', 'KVSR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17347, 0, 0, '') ;

CALL ImportField(120110020, '( )', 'KFSR_corr', '', ' ', 1, 1201, 0, 0, '', 0, 17348, 0, 0, '') ;

CALL ImportField(120110021, '', 'KCSR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17351, 0, 0, '') ;

CALL ImportField(120110022, '', 'KVR_corr', '', ' ', 1, 1201, 0, 1, '', 0, 17350, 0, 0, '') ;

CALL ImportField(120110035, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1201, 0, 0, '', 0, 17338, 0, 0, '') ;

CALL ImportField(120110045, '( )', 'KCSR_corrCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(120110046, '( )', 'KCSRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(120110049, '( )', 'KVR_corrCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(120110050, '( )', 'KVRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(120110051, ' ( )', 'KVSR_corrCode', ' ( )', ' ', 1, 1201, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(120110052, '( )', 'KVSRCode', '( )', ' ', 1, 1201, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(120110068, '', 'SubKESR', '', ' ', 1, 1201, 0, 1, '', 0, 17387, 0, 0, '') ;

CALL ImportField(120110079, '()', 'KESRCode', '()', ' ', 1, 1201, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(120110080, '()', 'SubKESRCode', '()', ' ', 1, 1201, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(150110003, '', 'KVSR', '', ' ', 1, 1501, 0, 1, '', 0, 18381, 0, 0, '') ;

CALL ImportField(150110004, '()', 'KFSR', '', ' ', 1, 1501, 0, 0, '', 0, 18379, 0, 0, '') ;

CALL ImportField(150110005, '', 'KCSR', '', ' ', 1, 1501, 0, 1, '', 0, 18380, 0, 0, '') ;

CALL ImportField(150110006, '', 'KVR', '', ' ', 1, 1501, 0, 1, '', 0, 18382, 0, 0, '') ;

CALL ImportField(150110007, '', 'KESR', '', ' ', 1, 1501, 0, 1, '', 0, 18383, 0, 0, '') ;

CALL ImportField(150110010, '', 'SUBKESR', '', ' ', 1, 1501, 0, 1, '', 0, 18384, 0, 0, '') ;

CALL ImportField(150110041, '()', 'KCSRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(150110042, '()', 'KVRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(150110043, '()', 'KVSRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(150110056, '()', 'KESRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(150110057, '()', 'SUBKESRCode', '()', ' ', 1, 1501, 0, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(160111021, '', 'KVSR', '', 'KVSRKey', 1, 1601, 1, 1, '', 0, 19021, 0, 0, '') ;

CALL ImportField(160111022, '()', 'KFSR', '', 'KFSR', 1, 1601, 1, 0, '', 0, 19020, 0, 0, '') ;

CALL ImportField(160111023, '', 'KCSR', '', 'KCSRKey', 1, 1601, 1, 1, '', 0, 19022, 0, 0, '') ;

CALL ImportField(160111024, '', 'KVR', '', 'KVRKey', 1, 1601, 1, 1, '', 0, 19023, 0, 0, '') ;

CALL ImportField(160111025, '', 'KESR', '', 'KESRKey', 1, 1601, 1, 1, '', 0, 19024, 0, 0, '') ;

CALL ImportField(160111030, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1601, 1, 0, '', 0, 19058, 0, 0, '') ;

CALL ImportField(160111044, '', 'SubKESR', '', 'SubKESRKey', 1, 1601, 1, 1, '', 0, 19031, 0, 0, '') ;

CALL ImportField(160111074, '()', 'KCSRCode', '()', 'KCSR', 1, 1601, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(160111075, '()', 'KVRCode', '()', 'KVR', 1, 1601, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(160111076, '()', 'KVSRCode', '()', 'KVSR', 1, 1601, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(160111079, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1601, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(160111083, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1601, 1, 1, '', 0, 27860, 0, 0, '') ;

CALL ImportField(160111105, '()', 'KESRCode', '()', 'KESR', 1, 1601, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(160111107, '()', 'SUBKESRCode', '()', 'SubKESR', 1, 1601, 1, 0, '', 0, 43610, 0, 0, '') ;

-- . - , (1)
CALL ImportField(160210011, '', 'KFSR', '', ' ', 1, 1602, 0, 0, '', 0, 19020, 0, 0, '') ;

CALL ImportField(160210012, '', 'KVSR', '', ' ', 1, 1602, 0, 1, '', 0, 19021, 0, 0, '') ;

CALL ImportField(160210013, '', 'KCSR', '', ' ', 1, 1602, 0, 1, '', 0, 19022, 0, 0, '') ;

CALL ImportField(160210014, '', 'KVR', '', ' ', 1, 1602, 0, 1, '', 0, 19023, 0, 0, '') ;

CALL ImportField(160210015, '', 'KESR', '', ' ', 1, 1602, 0, 1, '', 0, 19024, 0, 0, '') ;

CALL ImportField(160210018, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1602, 0, 0, '', 0, 19058, 0, 0, '') ;

CALL ImportField(160210022, '', 'SubKESR', '', ' ', 1, 1602, 0, 1, '', 0, 19031, 0, 0, '') ;

CALL ImportField(160210035, '', 'KCSRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(160210036, '', 'KVRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(160210037, '', 'KVSRCode', '', ' ', 1, 1602, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(160210039, ' ', 'BudAllocationClsCode', '', ' ', 1, 1602, 0, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(160210048, '()', 'KESRCode', '()', ' ', 1, 1602, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(160210049, '()', 'SubKESRCode', '()', ' ', 1, 1602, 0, 0, '', 0, 43610, 0, 0, '') ;

-- , (1)
CALL ImportField(170110027, '', 'KCSR', '', 'KCSRKey', 1, 1701, 0, 1, '', 0, 19129, 0, 0, '') ;

CALL ImportField(170110029, '', 'KESR', '', 'KESRKey', 1, 1701, 0, 1, '', 0, 19131, 0, 0, '') ;

CALL ImportField(170110030, '()', 'KFSR', '', 'KFSR', 1, 1701, 0, 0, '', 0, 19127, 0, 0, '') ;

CALL ImportField(170110031, '', 'KVR', '', 'KVRKey', 1, 1701, 0, 1, '', 0, 19130, 0, 0, '') ;

CALL ImportField(170110032, '', 'KVSR', '', 'KVSRKey', 1, 1701, 0, 1, '', 0, 19128, 0, 0, '') ;

CALL ImportField(170110049, '', 'SUBKESR', '', 'SUBKESRKey', 1, 1701, 0, 1, '', 0, 19132, 0, 0, '') ;

CALL ImportField(170110057, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 1, 1701, 0, 0, '', 0, 19178, 0, 0, '') ;

CALL ImportField(170110081, '()', 'KCSRCode', '()', 'KCSR', 1, 1701, 0, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(170110083, '()', 'KVRCode', '()', 'KVR', 1, 1701, 0, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(170110084, '()', 'KVSRCode', '()', 'KVSR', 1, 1701, 0, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(170110087, ' ', 'BudAllocationCLS', '', 'BudAllocationCLSKey', 1, 1701, 0, 1, '', 0, 29948, 0, 0, '') ;

CALL ImportField(170110088, ' ', 'BudAllocationCLSCode', '', 'BudAllocationCLS', 1, 1701, 0, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(170110097, '()', 'KESRCode', '()', 'KESR', 1, 1701, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(170110098, '()', 'SubKESRCode', '()', 'SUBKESR', 1, 1701, 0, 0, '', 0, 43610, 0, 0, '') ;

-- (), (1)
CALL ImportField(170210015, ' ', 'BuhOperationCLS', ' ', ' ', 1, 1702, 0, 0, '', 0, 19178, 0, 0, '') ;

CALL ImportField(170210024, '', 'KVR', '()', ' ', 1, 1702, 0, 1, '', 0, 19130, 0, 0, '') ;

CALL ImportField(170210025, '', 'KVSR', '()', ' ', 1, 1702, 0, 1, '', 0, 19128, 0, 0, '') ;

CALL ImportField(170210028, '()', 'KFSR', '()', ' ', 1, 1702, 0, 0, '', 0, 19127, 0, 0, '') ;

CALL ImportField(170210029, '', 'KCSR', '()', ' ', 1, 1702, 0, 1, '', 0, 19129, 0, 0, '') ;

CALL ImportField(170210030, '', 'KESR', '', ' ', 1, 1702, 0, 1, '', 0, 19131, 0, 0, '') ;

CALL ImportField(170210043, '', 'SubKESR', '', ' ', 1, 1702, 0, 1, '', 0, 19132, 0, 0, '') ;

CALL ImportField(170210048, '()', 'KCSRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210049, '()', 'KVRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210050, '()', 'KVSRCode', '()', ' ', 1, 1702, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(170210054, '()', 'KESRCode', '()', ' ', 1, 1702, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(170210055, '()', 'SUBKESRCode', '()', ' ', 1, 1702, 0, 0, '', 0, 43610, 0, 0, '') ;

--   , (1)
CALL ImportField(180510083, '()', 'CreaterUser', '', 'CREATERUSER_CPT', 1, 1805, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(180510084, '()', 'UpdaterUser', '', ' ', 1, 1805, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(180510090, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1805, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(180510091, ' ()', 'UPDATEDATE', '', ' ', 1, 1805, 0, 1, '', 0, 19310, 0, 0, '') ;

CALL ImportField(180510092, ' ()', 'CREATEDATE', '', ' ', 1, 1805, 0, 1, '', 0, 19308, 0, 0, '') ;

--   , (1)
CALL ImportField(180710004, ' ', 'Note', '', ' ', 1, 1807, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(180710005, '()', 'CreaterUser', '()', 'CREATERUSER_CPT', 1, 1807, 0, 1, '', 0, 17236, 0, 0, '') ;

CALL ImportField(180710006, ' ()', 'CreateDate', '', ' ', 1, 1807, 0, 1, '', 0, 17238, 0, 0, '') ;

CALL ImportField(180710007, '()', 'UPDATERUSER', '', ' ', 1, 1807, 0, 1, '', 0, 17237, 0, 0, '') ;

CALL ImportField(180710008, ' ()', 'UPDATEDATE', '', ' ', 1, 1807, 0, 1, '', 0, 17239, 0, 0, '') ;

CALL ImportField(180710009, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1807, 0, 1, '', 0, null, 0, 0, '') ;

--      , (1)
CALL ImportField(180910003, '()', 'CreaterUser', '()', 'CREATERUSER_CPT', 1, 1809, 0, 1, '', 0, 31632, 0, 0, '') ;

CALL ImportField(180910004, ' ()', 'CreateDate', '', ' ', 1, 1809, 0, 1, '', 0, 31631, 0, 0, '') ;

CALL ImportField(180910005, '()', 'UPDATERUSER', '', ' ', 1, 1809, 0, 1, '', 0, 31634, 0, 0, '') ;

CALL ImportField(180910006, ' ()', 'UPDATEDATE', '', ' ', 1, 1809, 0, 1, '', 0, 31633, 0, 0, '') ;

CALL ImportField(180910007, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1809, 0, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(181010050, '()', 'CreaterUser', '', 'CREATERUSER_CPT', 1, 1810, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181010051, '()', 'UpdaterUser', '', ' ', 1, 1810, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181010062, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1810, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181010063, '  ()', 'UPDATEDATE', ' ()', ' ', 1, 1810, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181010064, ' ()', 'CreateDate', ' ()', ' ', 1, 1810, 0, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(181210026, '()', 'CreaterUser', '', 'CREATERUSER_CPT', 1, 1812, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181210027, '()', 'UpdaterUser', '', ' ', 1, 1812, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181210030, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1812, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181210031, '  ()', 'UPDATEDATE', ' ()', ' ', 1, 1812, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181210032, ' ()', 'CreateDate', ' ()', ' ', 1, 1812, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181211033, '()', 'CreaterUser', '', 'CREATERUSER_DET', 1, 1812, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181211034, '()', 'UpdaterUser', '', ' ', 1, 1812, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181211035, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1812, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181211036, ' ()', 'UPDATEDATE', '', ' ', 1, 1812, 1, 1, '', 0, 19310, 0, 0, '') ;

CALL ImportField(181211037, ' ()', 'CREATEDATE', '', ' ', 1, 1812, 1, 1, '', 0, 19308, 0, 0, '') ;

--   , (1)
CALL ImportField(181610003, '', 'KVSR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610004, '', 'KFSR', '', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610005, '', 'KCSR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610006, '', 'KVR', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610007, '', 'KESR', '', ' ', 1, 1816, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181610026, '', 'KVRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610027, '', 'KVSRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610028, '', 'KCSRCode', ' ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610034, '', 'SubKESR', '', ' ', 1, 1816, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181610038, ' ', 'BuhOperationCls', ' ', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610047, '  ()', 'BudAllocationCls', '   ()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610048, ' ', 'BudAllocationClsCode', '  ', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610102, '()', 'KESRCode', '()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181610104, '()', 'SubKESRCode', '()', ' ', 1, 1816, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611063, '', 'KFSR', '', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611064, '', 'KVSR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611065, '', 'KVSRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611066, '', 'KCSR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611067, '', 'KCSRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611068, '', 'KVR', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611069, '', 'KVRCode', ' ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611070, '', 'KESR', '', ' ', 1, 1816, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181611073, '', 'SubKESR', '', ' ', 1, 1816, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(181611090, '  ()', 'BudAllocationCls', '   ()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611091, ' ', 'BudAllocationClsCode', '  ', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611097, ' ', 'BuhOperationCls', ' ', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611103, '()', 'KESRCode', '()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181611105, '()', 'SubKESRCode', '()', ' ', 1, 1816, 1, 0, '', 0, null, 0, 0, '') ;

--     , (1)
CALL ImportField(181810001, ' ', 'ID', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810002, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810003, ' ', 'PACKETNAME', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810004, ' ', 'REGNUM', '  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810005, ' ', 'ANUMBER', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810006, ' ', 'SIGNDATE', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810007, ' ', 'VERSIONNUMBER', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810008, '  ', 'CUSTOMER_REGNUM', '  ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810009, ' ', 'CUSTOMER_FULLNAME', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810010, ' ', 'CUSTOMER_INN', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810011, ' ', 'CUSTOMER_KPP', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810012, ' ', 'PROTOCOLDATE', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810013, '-', 'DOCUMENTBASE', '-', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810014, '', 'PRICE', '', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810015, ' ', 'SINGLECUSTOMERREASON_ID', '     ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810016, '', 'SINGLECUSTOMERREASON_NAME', '      ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810017, ' ', 'EXECUTIONDATE_MONTH', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810018, ' ', 'EXECUTIONDATE_YEAR', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810019, ' ', 'SUPPLIER_INN', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810020, ' ', 'SUPPLIER_KPP', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810021, ' ', 'SUPPLIER_ORGANIZATIONNAME', ' ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810022, '  ', 'HREF', '   ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810023, '  ', 'FCSORDER_PLACING', '  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810024, '', 'CUSTOMER_HEAD', '', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810025, '', 'SUPPLIER_HEAD', '', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810026, '  ', 'SINGLECUSTOMERREASON_HEAD', '     ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810027, ' ', 'EXECUTIONDATE_HEAD', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810028, '   ', 'FCSORDER_PLAC', '   ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810029, '  ', 'SUPPLIER_LF_SINGULARNAME', '   ()', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810030, ' ', 'PUBLISHDATE', '  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810031, ' ', 'BUDGET_CODE', ' ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810052, '  ', 'IKZ', '  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810053, '    ', 'ADVANCEPRICEVALUE', '    ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810054, '   ', 'ADVANCESUMINPERCENTS', '   ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181810055, '-  ', 'NOTIFICATIONNUMBER', '-  ', ' ', 1, 1818, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811032, ' ', 'RECORDINDEX', ' ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811033, '  ', 'ID', '  ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811034, ' ', 'ISBUDGETARY', ' ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811035, '', 'AYEAR', '', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811036, ' ', 'SUBSTAGEMONTH', ' ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811037, ' ', 'SUBSTAGEYEAR', ' ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811038, '', 'KBK', '', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811039, '', 'PRICE', '', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181811040, ' ', 'ISBUDGETAR', '  ', ' ', 1, 1818, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181812041, ' ', 'RECORDINDEX', ' ', ' ', 1, 1818, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181812042, '  ', 'ID', '  ', ' ', 1, 1818, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181812043, '', 'NAME', ' ', ' ', 1, 1818, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813044, '  ', 'ID', '  ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813045, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813046, ' ', 'PACKETNAME', ' ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813047, ' ', 'REGNUM', '  ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813048, '  ', 'VERSIONNUMBER', '  ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813049, '', 'TERMINATION_PAID', '', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813050, ' ', 'CURRENTCONTRACTSTAGE', ' ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181813051, ' ', 'PUBLISHDATE', ' ', ' ', 1, 1818, 3, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814056, ' ', 'ID', ' ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814057, '  ', 'RECORDINDEX', '  ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814058, '', 'PROGINDEX', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814059, ' ', 'DOCTYPE', ' ', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814060, '', 'url', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181814061, '', 'DESCRIPTION', '', ' ', 1, 1818, 4, 0, '', 0, null, 0, 0, '') ;

--   -  , (1)
CALL ImportField(181910001, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910002, ' ', 'PACKETNAME', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910003, ' ', 'ANUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910004, ' ', 'VERSIONNUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910005, ' ', 'CUSTOMER_REGNUM', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910006, '', 'CUSTOMER_FULLNAME', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910007, '', 'CUSTOMER_INN', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910008, '', 'CUSTOMER_KPP', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910009, '', 'EXECUTIONDATE_YEAR', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910010, ' ', 'FCSORDER_PLACING', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910011, ' ', 'PUBLISHDATE', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910012, ' ', 'ID', 'ID', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910025, '', 'CUSTOMER_HEAD', '', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181910026, ' ', 'EDITIONNUMBER', ' ', ' ', 1, 1819, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911013, ' ', 'Number', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911014, '  ', 'KBK', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911015, '', 'YEAR', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911016, '', 'PRICE', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911017, '  ', 'MAXPRICE', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911018, '  ', 'SUBJECTNAME', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911019, '  ', 'IKZ', '  ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911020, '  ', 'PLACINGWAY_NAME', '  ()', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911021, '   ', 'PLACINGWAY_CODE', '  ()', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911022, '  ', 'CHANGEREASON_NAME', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911023, '  ', 'CHANGEREASON_ID', '', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(181911024, ' ', 'PACKETSECTION', ' ', ' ', 1, 1819, 1, 0, '', 0, null, 0, 0, '') ;

--      , (1)
CALL ImportField(182010001, ' ', 'ID', 'ID', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010002, ' ', 'ARCHIVENAME', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010003, ' ', 'PACKETNAME', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010004, ' ', 'ANUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010005, ' ', 'VERSIONNUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010006, ' ', 'CUSTOMER_REGNUM', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010007, '', 'CUSTOMER_FULLNAME', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010008, '', 'CUSTOMER_INN', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010009, '', 'CUSTOMER_KPP', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010010, '', 'CUSTOMER_HEAD', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010011, '', 'EXECUTIONDATE_YEAR', '', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010012, ' ', 'FCSORDER_PLACING', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010013, ' ', 'EDITIONNUMBER', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182010027, ' ', 'PUBLISHDATE', ' ', ' ', 1, 1820, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011015, ' ', 'Number', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011016, '  ', 'KBK', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011017, '', 'YEAR', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011018, '', 'PRICE', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011019, '  ', 'MAXPRICE', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011020, '  ', 'SUBJECTNAME', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011021, '  ', 'IKZ', '  ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011022, '  ', 'PLACINGWAY_NAME', '  ()', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011023, '   ', 'PLACINGWAY_CODE', '  ()', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011024, '  ', 'CHANGEREASON_NAME', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011025, '  ', 'CHANGEREASON_ID', '', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(182011026, ' ', 'PACKETSECTION', ' ', ' ', 1, 1820, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(190010013, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190010014, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190010015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190010016, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1900, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011013, ' ', '{("")}', ' ', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011036, '', '{("")}', ' ()', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011037, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 1900, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190011038, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011039, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011040, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011041, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1900, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190011042, ' ', '{("")}', ' ', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011043, ' ', '{("")}', '  ()', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190011045, '', '{("")}', '', ' ', 1, 1900, 1, 0, '', 0, null, 0, 0, '') ;

--  (), (1)
CALL ImportField(190110001, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 1901, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190110002, '', 'Variant', '', 'Variant', 1, 1901, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(190110003, ' ', 'DateInput', ' ', 'DateInput', 1, 1901, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(190110004, ' ', 'DAT', ' ', 'Dat', 1, 1901, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(190110005, '', 'BUDGETREF', '', 'BudgetRef', 1, 1901, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(190110006, '', 'NUMBER', '', 'Number', 1, 1901, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(190110009, '()', 'NOTE', '', 'Note', 1, 1901, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(190110010, ' ', 'DOCDAT', ' ', 'DocDat', 1, 1901, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(190110011, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 1901, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(190110012, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 1901, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(190110013, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 1901, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(190110050, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 1901, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(190110051, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 1901, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(190110055, ' ', 'ID', 'ID', 'Id', 1, 1901, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(190110057, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 1901, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(190110058, '', 'DocStateRef', 'DocStateRef', 'DocStateRef', 1, 1901, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(190110069, ' ', 'AssignmentSource', '  ', 'ASSIGNMENTSOURCE', 1, 1901, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190110081, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 1901, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(190110082, '  ', 'SenderID', '  ', 'SenderId', 1, 1901, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(190110084, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 1, 1901, 0, 0, '_', 0, 17502, 0, 1, '_') ;

CALL ImportField(190110085, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 1901, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(190110087, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 1901, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190110088, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 1901, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190110089, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190110090, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190110091, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190110092, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1901, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190111015, '  ', 'IFS_FinSourceValue', '  ', 'IFS_FinSourceValue', 1, 1901, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(190111016, '(  )', 'IFS_KVSRCode', '', 'IFS_KVSRCode', 1, 1901, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(190111017, ' (  )', 'IFS_DescriptionCode', ' ', 'IFS_DescriptionCode', 1, 1901, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(190111018, '(  )', 'IFSAGCode', '', 'IFS_KESRCode', 1, 1901, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(190111019, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1901, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190111020, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 1901, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(190111022, '  ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 1901, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(190111023, '', 'FACTCODE', '', 'DestFactCls', 1, 1901, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(190111025, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 1901, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(190111032, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 1901, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(190111033, '', 'Month01', '', 'Month01', 1, 1901, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(190111034, '', 'Month02', '', 'Month02', 1, 1901, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(190111035, '', 'Month03', '', 'Month03', 1, 1901, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(190111036, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 1901, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(190111037, '', 'Month04', '', 'Month04', 1, 1901, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(190111038, '', 'Month05', '', 'Month05', 1, 1901, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(190111039, '', 'Month06', '', 'Month06', 1, 1901, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(190111040, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 1901, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(190111041, '', 'Month07', '', 'Month07', 1, 1901, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(190111042, '', 'Month08', '', 'Month08', 1, 1901, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(190111043, '', 'Month09', '', 'Month09', 1, 1901, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(190111044, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 1901, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(190111045, '', 'Month10', '', 'Month10', 1, 1901, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(190111046, '', 'Month11', '', 'Month11', 1, 1901, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(190111047, '', 'Month12', '', 'Month12', 1, 1901, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(190111048, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1901, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190111052, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190111059, ' ', 'IFS', ' ', 'IFS', 1, 1901, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(190111061, ' ', 'RECORDINDEX', 'RECORDINDEX', 'RecordIndex', 1, 1901, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(190111062, ' ', 'ID', 'ID', 'Id', 1, 1901, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(190111063, '', 'Org_ref', 'Org_ref', 'Org_Ref_Det', 1, 1901, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(190111070, ' ', 'AssignmentKind', '  ', 'ASSIGNMENTKIND', 1, 1901, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(190111075, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 1901, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(190111083, '  ', 'SenderID', '  ', 'SenderId', 1, 1901, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(190111088, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 1901, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(190111091, '  ', 'TransfertCls', '  ', 'TransfertCls', 1, 1901, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(190111092, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190111093, ' ', 'ClsType', ' ', 'ClsType', 1, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190111095, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1901, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190111096, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 1901, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(190111097, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 1901, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(190111098, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 1901, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(190111099, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1901, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190111100, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 1901, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(190111103, ' ()', 'FACT', '', 'DestFactClsKey', 1, 1901, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190111105, '', 'InvestObject', '', 'InvestObjectKey', 1, 1901, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190111106, '', 'InvestObjectCode', '', 'InvestObject', 1, 1901, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190111107, '', 'Kesr', '', 'DestKesrKey', 1, 1901, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190111108, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 1901, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190111109, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190111110, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190111111, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190111112, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1901, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190111113, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1901, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(190111114, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1901, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(190111219, '()', 'KESRCode', '()', 'DestKesr', 1, 1901, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190111221, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1901, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), (1)
CALL ImportField(190210001, '', 'NUMBER', '', 'Number', 1, 1902, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(190210013, '', 'Variant', '', 'Variant', 1, 1902, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(190210015, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 1902, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190210016, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 1902, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190210017, ' ', 'DOCDAT', ' ', 'DocDat', 1, 1902, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(190210018, ' ', 'DateInput', ' ', 'DateInput', 1, 1902, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(190210019, ' ', 'DAT', ' ', 'Dat', 1, 1902, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(190210024, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 1902, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(190210027, '', 'BUDGETREF', '', 'BudgetRef', 1, 1902, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(190210029, ' ', 'ID', ' ', 'Id', 1, 1902, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(190210038, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 1902, 0, 1, '', 0, 17494, 0, 1, '') ;

CALL ImportField(190210041, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 1902, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(190210043, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 1902, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(190210044, '()', 'NOTE', '()', 'Note', 1, 1902, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(190210048, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 1902, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(190210049, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 1902, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(190210070, '', 'DocStateRef', 'DocStateRef', 'DocStateRef', 1, 1902, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(190210073, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 1902, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(190210081, '  ', 'SenderID', '  ', 'SenderId', 1, 1902, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(190210083, '  , ', 'Ba_Lbo_Flag', '  , ', 'BA_LBO_FLAG', 1, 1902, 0, 0, '_', 0, 17502, 0, 1, '_') ;

CALL ImportField(190210084, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 1902, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(190210086, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 1902, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190210087, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 1902, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190210088, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190210089, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190210090, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190210091, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1902, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190211004, '(  )', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 1902, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(190211005, ' (  )', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 1902, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(190211006, '(  )', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 1902, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(190211007, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190211012, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1902, 1, 0, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190211014, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 1902, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(190211021, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 1902, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(190211022, ' ', 'IFS', ' ', 'IFS', 1, 1902, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(190211030, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 1902, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(190211031, ' ', 'ID', ' ', 'Id', 1, 1902, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(190211037, ' ', 'FACIALACC_CLS', '  ', 'DestFacialAccCls', 1, 1902, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(190211039, '', 'FACTCODE', '()', 'DestFactCls', 1, 1902, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(190211040, '', 'DirectionCLSCode', '()', 'DestDirectionCLS', 1, 1902, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(190211042, '', 'Org_ref', 'Org_ref', 'Org_Ref_Det', 1, 1902, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(190211051, '', 'Month08', '', 'Month08', 1, 1902, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(190211052, '', 'Month04', '', 'Month04', 1, 1902, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(190211053, '', 'Month12', '', 'Month12', 1, 1902, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(190211054, '', 'Month07', '', 'Month07', 1, 1902, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(190211055, '', 'Month06', '', 'Month06', 1, 1902, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(190211056, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 1902, 1, 1, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(190211057, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 1902, 1, 1, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(190211058, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 1902, 1, 1, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(190211059, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 1902, 1, 1, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(190211060, '', 'Month05', '', 'Month05', 1, 1902, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(190211061, '', 'Month03', '', 'Month03', 1, 1902, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(190211065, '', 'Month11', '', 'Month11', 1, 1902, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(190211066, '', 'Month10', '', 'Month10', 1, 1902, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(190211067, '', 'Month09', '', 'Month09', 1, 1902, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(190211068, '', 'Month02', '', 'Month02', 1, 1902, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(190211069, '', 'Month01', '', 'Month01', 1, 1902, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(190211071, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1902, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190211075, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 1902, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(190211079, '  ', 'IFS_FinSourceValue', '  ( )', 'IFS_FinSourceValue', 1, 1902, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(190211082, '  ', 'SenderID', '  ', 'SenderId', 1, 1902, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(190211087, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 1902, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(190211090, '  ', 'TransfertCls', '  ', 'TransfertCls', 1, 1902, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(190211091, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190211092, ' ', 'ClsType', ' ', 'ClsType', 1, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190211094, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1902, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190211095, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 1902, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(190211096, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 1902, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(190211097, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 1902, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(190211098, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1902, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190211099, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 1902, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(190211100, ' ()', 'DirectionCLS', '()', 'DestDirectionCLSKey', 1, 1902, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(190211101, ' ()', 'FACT', '()', 'DestFactClsKey', 1, 1902, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190211103, '', 'InvestObject', '', 'InvestObjectKey', 1, 1902, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190211104, '', 'InvestObjectCode', '', 'InvestObject', 1, 1902, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190211105, '', 'Kesr', '', 'DestKesrKey', 1, 1902, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190211106, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 1902, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190211107, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190211108, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190211109, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190211110, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1902, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190211219, '()', 'KESRCode', '()', 'DestKesr', 1, 1902, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190211221, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1902, 1, 0, '', 0, 43610, 0, 1, '') ;

--   (), (1)
CALL ImportField(190310001, '', 'NUMBER', '', 'Number', 1, 1903, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(190310011, '', 'Variant', '', 'Variant', 1, 1903, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(190310013, ' ', 'ASSIGNMENTSOURCE', ' ', 'ASSIGNMENTSOURCE', 1, 1903, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(190310014, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 1903, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(190310017, ' ', 'DOCDAT', ' ', 'DocDat', 1, 1903, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(190310018, ' ', 'DateInput', ' ', 'DateInput', 1, 1903, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(190310019, ' ', 'DAT', ' ', 'Dat', 1, 1903, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(190310023, '', 'NOTIFYTYPE', '', 'NotifyType', 1, 1903, 0, 0, '', 0, 17471, 0, 1, '') ;

CALL ImportField(190310026, '', 'BUDGETREF', '', 'BudgetRef', 1, 1903, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(190310028, ' ', 'ID', ' ', 'Id', 1, 1903, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(190310037, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 1903, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(190310040, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 1903, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(190310042, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 1903, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(190310043, '()', 'NOTE', '()', 'Note', 1, 1903, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(190310047, '  ', 'REJECTCLS', '  ', 'RejectCls', 1, 1903, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(190310048, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 1903, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(190310069, '', 'DocStateRef', 'DocStateRef', 'DocStateRef', 1, 1903, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(190310072, ' ', 'DocBaseCode', ' ', 'DocBase', 1, 1903, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(190310083, '  ', 'SenderID', '  ', 'SenderId', 1, 1903, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(190310084, '', 'KPPERIOD', '', 'KPPeriod', 1, 1903, 0, 1, '', 0, 24700, 0, 1, '') ;

CALL ImportField(190310085, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 1903, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(190310087, '  ()', 'DocBase', '  ()', 'DocBaseKey', 1, 1903, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(190310088, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 1903, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190310089, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190310090, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190310091, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190310092, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190311003, '/ ', 'FACIALCODE', '/ ', 'DestFacialAccClsFacialCode', 1, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190311008, '()', 'CREATERUSER', '', 'CREATERUSER_DET', 1, 1903, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(190311009, '()', 'UpdaterUser', '', 'UpdaterUser_det', 1, 1903, 1, 1, '', 0, 17430, 0, 1, '') ;

CALL ImportField(190311010, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1903, 1, 1, '', 0, 17451, 0, 1, '') ;

CALL ImportField(190311012, ' ', 'ASSIGNMENTKIND', ' ', 'ASSIGNMENTKIND', 1, 1903, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(190311015, ' ()', 'UpdateDate', ' ', 'UpdateDate_Det', 1, 1903, 1, 1, '', 0, 17429, 0, 1, '') ;

CALL ImportField(190311016, ' ()', 'CreateDate', ' ', 'CreateDate_Det', 1, 1903, 1, 1, '', 0, 17428, 0, 1, '') ;

CALL ImportField(190311021, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 1903, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(190311029, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 1903, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(190311030, ' ', 'ID', ' ', 'Id', 1, 1903, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(190311036, ' ', 'FACIALACC_CLS', ' ', 'DestFacialAccCls', 1, 1903, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(190311038, '', 'FACTCODE', '', 'DestFactCls', 1, 1903, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(190311039, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 1903, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(190311041, '', 'Org_ref', 'Org_ref', 'Org_Ref_Det', 1, 1903, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(190311050, '', 'Month08', '', 'Month08', 1, 1903, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(190311051, '', 'Month04', '', 'Month04', 1, 1903, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(190311052, '', 'Month12', '', 'Month12', 1, 1903, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(190311053, '', 'Month07', '', 'Month07', 1, 1903, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(190311054, '', 'Month06', '', 'Month06', 1, 1903, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(190311055, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 1903, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(190311056, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 1903, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(190311057, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 1903, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(190311058, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 1903, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(190311059, '', 'Month05', '', 'Month05', 1, 1903, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(190311060, '', 'Month03', '', 'Month03', 1, 1903, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(190311064, '', 'Month11', '', 'Month11', 1, 1903, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(190311065, '', 'Month10', '', 'Month10', 1, 1903, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(190311066, '', 'Month09', '', 'Month09', 1, 1903, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(190311067, '', 'Month02', '', 'Month02', 1, 1903, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(190311068, '', 'Month01', '', 'Month01', 1, 1903, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(190311070, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1903, 1, 1, '', 0, 17416, 0, 1, '') ;

CALL ImportField(190311074, ' ', 'MeansType', ' ', 'DestMeansTypeCls', 1, 1903, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(190311076, '(  )', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 1903, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(190311077, '(  )', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 1903, 1, 0, '', 0, 38919, 0, 1, '') ;

CALL ImportField(190311078, ' ', 'IFS', ' ', 'IFS', 1, 1903, 1, 1, '', 0, 17452, 0, 1, '') ;

CALL ImportField(190311079, ' (  )', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 1903, 1, 0, '', 0, 17050, 0, 1, '') ;

CALL ImportField(190311081, '  ', 'IFS_FinSourceValue', '  ( )', 'IFS_FinSourceValue', 1, 1903, 1, 0, '', 0, 17055, 0, 1, '') ;

CALL ImportField(190311084, '  ', 'SenderID', '  ', 'SenderId', 1, 1903, 1, 1, '', 0, 17434, 0, 1, '') ;

CALL ImportField(190311091, '  ', 'TransfertCls', '  ', 'TransfertCls', 1, 1903, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(190311092, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 1903, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(190311093, ' ', 'ClsType', ' ', 'ClsType', 1, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190311095, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1903, 1, 0, '', 0, 27825, 0, 1, '') ;

CALL ImportField(190311096, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 1903, 1, 0, '', 0, 27849, 0, 1, '') ;

CALL ImportField(190311097, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 1903, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(190311098, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 1903, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(190311099, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1903, 1, 1, '', 0, 27834, 0, 1, '') ;

CALL ImportField(190311100, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 1903, 1, 1, '', 0, 27835, 0, 1, '') ;

CALL ImportField(190311101, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 1, 1903, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(190311102, ' ()', 'FACT', '', 'DestFactClsKey', 1, 1903, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(190311104, '', 'InvestObject', '', 'InvestObjectKey', 1, 1903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(190311105, '', 'InvestObjectCode', '', 'InvestObject', 1, 1903, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(190311106, '', 'Kesr', '', 'DestKesrKey', 1, 1903, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(190311107, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 1903, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190311108, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190311109, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 1903, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(190311110, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 1903, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(190311197, '()', 'KESRCode', '()', 'DestKesr', 1, 1903, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(190311199, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1903, 1, 0, '', 0, 43610, 0, 1, '') ;

--    (), (1)
CALL ImportField(190610089, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 1906, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190610090, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190610091, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190610092, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190610093, '  ()', 'CREATEDATE', '  ()', ' ', 1, 1906, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190611011, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCLS', 1, 1906, 1, 1, '', 0, 17451, 0, 0, '') ;

CALL ImportField(190611071, '', 'SUBKESR', '', 'DestSubKesrKey', 1, 1906, 1, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(190611077, '(  )', 'IFS_KVSRCode', '()', 'IFS_KVSRCode', 1, 1906, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(190611078, '(  )', 'IFSAGCode', '()', 'IFS_KESRCode', 1, 1906, 1, 0, '', 0, 38919, 0, 0, '') ;

CALL ImportField(190611080, ' (  )', 'IFS_DescriptionCode', ' ()', 'IFS_DescriptionCode', 1, 1906, 1, 0, '', 0, 17050, 0, 0, '') ;

CALL ImportField(190611094, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 1906, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190611097, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 1906, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(190611101, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 1906, 1, 1, '', 0, 27834, 0, 0, '') ;

CALL ImportField(190611106, '', 'InvestObject', '', 'InvestObjectKey', 1, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190611107, '', 'InvestObjectCode', '', 'InvestObject', 1, 1906, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(190611108, '', 'Kesr', '', 'DestKesrKey', 1, 1906, 1, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(190611109, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 1906, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(190611110, '', 'AUTO_AUTORIZATION', '', ' ', 1, 1906, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(190611111, '()', 'KESRCode', '()', 'DestKesr', 1, 1906, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(190611113, '()', 'SubKESRCode', '()', 'DestSubKesr', 1, 1906, 1, 0, '', 0, 43610, 0, 0, '') ;

--   (), (1)
CALL ImportField(220010013, '', 'AUTO_AUTORIZATION', '', ' ', 1, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220010014, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220010015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220010016, '  ()', 'CREATEDATE', '  ()', ' ', 1, 2200, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011010, '', '{("")}', ' ()', ' ', 1, 2200, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(220011011, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 2200, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220011012, '', 'AUTO_AUTORIZATION', '', ' ', 1, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011013, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011014, '  ()', 'CREATEDATE', '  ()', ' ', 1, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 2200, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220011018, '', '{("")}', '', ' ', 1, 2200, 1, 0, '', 0, null, 0, 0, '') ;

--   (), (1)
CALL ImportField(220110002, '', 'VARIANT', '', 'Variant', 1, 2201, 0, 0, '', 0, 17474, 0, 1, '') ;

CALL ImportField(220110003, '', 'NUMBER', '', 'Number', 1, 2201, 0, 0, '', 0, 17499, 0, 1, '') ;

CALL ImportField(220110004, ' ', 'DateInput', ' ', 'DateInput', 1, 2201, 0, 0, '', 0, 17483, 0, 1, '') ;

CALL ImportField(220110005, ' ', 'Dat', ' ', 'Dat', 1, 2201, 0, 0, '', 0, 17465, 0, 1, '') ;

CALL ImportField(220110006, '', 'BUDGETREF', '', 'BudgetRef', 1, 2201, 0, 0, '', 0, 17472, 0, 1, '') ;

CALL ImportField(220110008, '()', 'NOTE', '', 'Note', 1, 2201, 0, 0, '', 0, 17468, 0, 1, '') ;

CALL ImportField(220110009, ' ', 'DOCBASECODE', ' ', 'DocBase', 1, 2201, 0, 0, ',', 0, 36865, 0, 1, '') ;

CALL ImportField(220110010, ' ', 'DOCNUMBER', ' ', 'DocNumber', 1, 2201, 0, 0, '', 0, 17467, 0, 1, '') ;

CALL ImportField(220110011, ' ', 'DOCDAT', ' ', 'DocDat', 1, 2201, 0, 0, '', 0, 17466, 0, 1, '') ;

CALL ImportField(220110041, '  ', 'REJECTCLS', ' ', 'RejectCls', 1, 2201, 0, 0, '', 0, 17485, 0, 1, '') ;

CALL ImportField(220110042, '  ()', 'REJECTCAUSE', ' ()', 'RejectCause', 1, 2201, 0, 0, '', 0, 17486, 0, 1, '') ;

CALL ImportField(220110043, ' ', 'PlanDocType', ' ', 'PlanDocType', 1, 2201, 0, 0, '', 0, 17487, 0, 1, '') ;

CALL ImportField(220110045, ' ', 'ID', 'ID', 'Id', 1, 2201, 0, 1, '', 0, 17464, 0, 1, '') ;

CALL ImportField(220110052, ' ', 'AssignmentSource', '  ', 'ASSIGNMENTSOURCE', 1, 2201, 0, 0, '', 0, 17501, 0, 1, '') ;

CALL ImportField(220110055, '  ', 'SENDERID', '  ', 'SenderId', 1, 2201, 0, 1, '', 0, 17475, 0, 1, '') ;

CALL ImportField(220110056, '\  ', 'FacialAccCls', '\  ', 'FacialAccCls', 1, 2201, 0, 0, '', 0, 17494, 0, 1, '') ;

CALL ImportField(220110057, ' ', 'NOTE1', ' ', 'note1', 1, 2201, 0, 0, '', 0, 17469, 0, 1, '') ;

CALL ImportField(220110058, ' ()', 'NOTE2', ' ()', 'note2', 1, 2201, 0, 0, '', 0, 17470, 0, 1, '') ;

CALL ImportField(220110061, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 2201, 0, 1, '', 0, 17493, 0, 1, '') ;

CALL ImportField(220110062, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 2201, 0, 1, '', 0, 17477, 0, 1, '') ;

CALL ImportField(220110067, 'CryptoStatus', 'CryptoStatus', 'CryptoStatus', 'CRYPTOSTATUS', 1, 2201, 0, 1, '', 0, 17490, 0, 1, '') ;

CALL ImportField(220110068, 'DocStateRef', 'DocStateRef', 'DocStateRef', 'DocStateRef', 1, 2201, 0, 1, '', 0, 17492, 0, 1, '') ;

CALL ImportField(220110069, ' ', 'ORGREF', ' ', 'DestOrgRef', 1, 2201, 0, 1, '', 0, 17484, 0, 1, '') ;

CALL ImportField(220110070, '  ()', 'DOCBASE', '  ()', 'DocBaseKey', 1, 2201, 0, 1, ',', 0, 17473, 0, 1, '') ;

CALL ImportField(220110071, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 2201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(220110072, '', 'AUTO_AUTORIZATION', '', ' ', 1, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220110073, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220110074, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220110075, '  ()', 'CREATEDATE', '  ()', ' ', 1, 2201, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220111012, ' ', 'KDValue', ' ', 'KDValue', 1, 2201, 1, 1, '', 0, 16836, 0, 1, '') ;

CALL ImportField(220111013, '()', 'KDKVSRCode', '', 'KDKVSRCode', 1, 2201, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(220111014, ' ()', 'DescriptionCode', ' ', 'DescriptionCode', 1, 2201, 1, 0, '', 0, 16831, 0, 1, '') ;

CALL ImportField(220111015, ' ()', 'ProgramCode', '', 'ProgramCode', 1, 2201, 1, 0, '', 0, 16834, 0, 1, '') ;

CALL ImportField(220111016, '()', 'KDAGCode', '', 'KDKESRCode', 1, 2201, 1, 0, '', 0, 38908, 0, 1, '') ;

CALL ImportField(220111017, '.  ', 'SUBKD', '. ', 'SubKD', 1, 2201, 1, 0, '', 0, 25271, 0, 1, '') ;

CALL ImportField(220111018, ' ', 'REGIONCLS', '', 'RegionCLS', 1, 2201, 1, 0, ',', 0, 17417, 0, 1, '') ;

CALL ImportField(220111019, ' ', 'Facialacc_Cls', ' c', 'DestFacialAccCls', 1, 2201, 1, 0, '', 0, 17419, 0, 1, '') ;

CALL ImportField(220111020, '/ ', 'facialcode', '', 'DestFacialAccClsFacialCode', 1, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220111021, ' ', 'MeansType', ' c', 'DestMeansTypeCls', 1, 2201, 1, 0, '', 0, 17426, 0, 1, '') ;

CALL ImportField(220111023, ' 1', 'QUARTER1', ' 1', 'Quarter1', 1, 2201, 1, 0, '1', 0, 17421, 0, 1, '1') ;

CALL ImportField(220111024, '', 'Month01', '', 'Month01', 1, 2201, 1, 0, '', 0, 17436, 0, 1, '') ;

CALL ImportField(220111025, '', 'Month02', '', 'Month02', 1, 2201, 1, 0, '', 0, 17437, 0, 1, '') ;

CALL ImportField(220111026, '', 'Month03', '', 'Month03', 1, 2201, 1, 0, '', 0, 17438, 0, 1, '') ;

CALL ImportField(220111027, ' 2', 'QUARTER2', ' 2', 'Quarter2', 1, 2201, 1, 0, '2', 0, 17422, 0, 1, '2') ;

CALL ImportField(220111028, '', 'Month04', '', 'Month04', 1, 2201, 1, 0, '', 0, 17439, 0, 1, '') ;

CALL ImportField(220111029, '', 'Month05', '', 'Month05', 1, 2201, 1, 0, '', 0, 17440, 0, 1, '') ;

CALL ImportField(220111030, '', 'Month06', '', 'Month06', 1, 2201, 1, 0, '', 0, 17441, 0, 1, '') ;

CALL ImportField(220111031, ' 3', 'QUARTER3', ' 3', 'Quarter3', 1, 2201, 1, 0, '3', 0, 17423, 0, 1, '3') ;

CALL ImportField(220111032, '', 'Month07', '', 'Month07', 1, 2201, 1, 0, '', 0, 17442, 0, 1, '') ;

CALL ImportField(220111033, '', 'Month08', '', 'Month08', 1, 2201, 1, 0, '', 0, 17443, 0, 1, '') ;

CALL ImportField(220111034, '', 'Month09', '', 'Month09', 1, 2201, 1, 0, '', 0, 17444, 0, 1, '') ;

CALL ImportField(220111035, ' 4', 'QUARTER4', ' 4', 'Quarter4', 1, 2201, 1, 0, '4', 0, 17424, 0, 1, '4') ;

CALL ImportField(220111036, '', 'Month10', '', 'Month10', 1, 2201, 1, 0, '', 0, 17445, 0, 1, '') ;

CALL ImportField(220111037, '', 'Month11', '', 'Month11', 1, 2201, 1, 0, '', 0, 17446, 0, 1, '') ;

CALL ImportField(220111038, '', 'Month12', '', 'Month12', 1, 2201, 1, 0, '', 0, 17447, 0, 1, '') ;

CALL ImportField(220111039, '', 'NOTE', '', 'Note', 1, 2201, 1, 0, '', 0, 17431, 0, 1, '') ;

CALL ImportField(220111040, '', 'FactCode', '', 'DestFactCls', 1, 2201, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(220111046, ' ()', 'KD', '  ()', 'KD', 1, 2201, 1, 1, '', 0, 25270, 0, 1, '') ;

CALL ImportField(220111048, ' ', 'ID', 'ID', 'Id', 1, 2201, 1, 1, '', 0, 17409, 0, 1, '') ;

CALL ImportField(220111053, ' ', 'AssignmentKind', '  ', 'ASSIGNMENTKIND', 1, 2201, 1, 0, '', 0, 17462, 0, 1, '') ;

CALL ImportField(220111054, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 2201, 1, 1, '', 0, 17432, 0, 1, '') ;

CALL ImportField(220111055, '', 'DirectionCLSCode', '', 'DestDirectionCLS', 1, 2201, 1, 0, '', 0, 21556, 0, 1, '') ;

CALL ImportField(220111061, ' ', 'ClsType', ' ', 'ClsType', 1, 2201, 1, 1, '', 0, 17453, 0, 1, '') ;

CALL ImportField(220111062, ' ', 'RECORDINDEX', ' ', 'RecordIndex', 1, 2201, 1, 1, '', 0, 17433, 0, 1, '') ;

CALL ImportField(220111063, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 2201, 1, 1, '', 0, 17427, 0, 1, '') ;

CALL ImportField(220111064, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 2201, 1, 1, '', 0, 17460, 0, 1, '') ;

CALL ImportField(220111065, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 2201, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(220111070, '', 'Org_ref', '  . .', 'Org_Ref_Det', 1, 2201, 1, 1, '', 0, 17454, 0, 1, '') ;

CALL ImportField(220111072, ' ', 'SubsidyCls', '', 'SubsidyCls', 1, 2201, 1, 1, '', 0, 26542, 0, 1, '') ;

CALL ImportField(220111073, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 1, 2201, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(220111076, ' ()', 'DirectionCLS', '', 'DestDirectionCLSKey', 1, 2201, 1, 1, '', 0, 17450, 0, 1, '') ;

CALL ImportField(220111077, ' ()', 'Fact', '', 'DestFactClsKey', 1, 2201, 1, 1, '', 0, 17418, 0, 1, '') ;

CALL ImportField(220111078, '', 'InvestObject', '', 'InvestObjectKey', 1, 2201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(220111079, '', 'InvestObjectCode', '', 'InvestObject', 1, 2201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(220111080, '', 'Kesr', '', 'DestKesrKey', 1, 2201, 1, 1, '', 0, 17415, 0, 1, '') ;

CALL ImportField(220111082, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 2201, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(220111083, ' ', 'TargetClsCode', ' ', 'TargetCls', 1, 2201, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(220111084, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 2201, 1, 1, '', 0, 40783, 0, 0, '') ;

CALL ImportField(220111085, '', 'AUTO_AUTORIZATION', '', ' ', 1, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220111086, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220111087, '  ()', 'CREATEDATE', '  ()', ' ', 1, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220111088, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 2201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(220111216, '()', 'KESRCode', '()', 'DestKesr', 1, 2201, 1, 0, '', 0, 43607, 0, 1, '') ;

--  , +(2)
CALL ImportField(250110079, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250110080, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250110081, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250110082, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250110087, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 2501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250111089, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250111090, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250111091, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250111092, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250111093, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250112003, '', 'KFSR', '', 'KFSR', 2, 2501, 2, 0, '', 0, 20225, 0, 0, '') ;

CALL ImportField(250112004, '', 'KESR', '', 'KESRKey', 2, 2501, 2, 1, '', 0, 20226, 0, 0, '') ;

CALL ImportField(250112005, '', 'KVR', '', 'KVR', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112006, '', 'KCSR', '', 'KCSR', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112007, '', 'KVSR', '', 'KVSR', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112010, '', 'KVRCode', '', 'KVR', 2, 2501, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(250112011, '', 'KCSRCode', '', 'KCSR', 2, 2501, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(250112012, '', 'KVSRCode', '', 'KVSR', 2, 2501, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(250112077, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 2501, 2, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(250112078, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2501, 2, 1, '', 0, 40887, 0, 0, '') ;

CALL ImportField(250112083, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112084, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112085, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112086, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2501, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250112088, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2501, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250112094, '()', 'KESRCode', '()', 'KESR', 2, 2501, 2, 0, '', 0, 43607, 0, 0, '') ;

-- , +(2)
CALL ImportField(250210001, '', 'BudgetRef', '', 'BudgetRef', 2, 2502, 0, 0, '', 0, 19814, 0, 1, 'BudgetRef') ;

CALL ImportField(250210002, '  ', 'Summa', '', 'Summa', 2, 2502, 0, 0, '', 0, 19797, 0, 1, 'Summa') ;

CALL ImportField(250210003, ' . ', 'StateOrderNumber', '', 'StateOrderNumber', 2, 2502, 0, 0, '', 0, 19798, 0, 1, 'StateOrderNumber') ;

CALL ImportField(250210004, ' ', 'ReviewNote', '', 'ReviewNote', 2, 2502, 0, 0, '', 0, 19845, 0, 1, 'ReviewNote') ;

CALL ImportField(250210005, ' ', 'RejectCls', '', 'RejectCls', 2, 2502, 0, 0, '', 0, 19836, 0, 1, 'RejectCls') ;

CALL ImportField(250210006, '  ()', 'RejectCause', '', 'RejectCause', 2, 2502, 0, 0, '', 0, 19837, 0, 1, 'RejectCause') ;

CALL ImportField(250210007, '', 'Region', '', 'Region', 2, 2502, 0, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250210008, ' ', 'ReestrNumber', '', 'ReestrNumber', 2, 2502, 0, 0, '', 0, 19830, 0, 1, 'ReestrNumber') ;

CALL ImportField(250210009, ' ', 'PaymentDate', '', 'PaymentDate', 2, 2502, 0, 0, '', 0, 19831, 0, 1, 'PaymentDate') ;

CALL ImportField(250210010, '', 'Note', '', 'Note', 2, 2502, 0, 0, '', 0, 19821, 0, 1, 'Note') ;

CALL ImportField(250210011, '      ', 'FinCardAdvance', '', 'FinCardAdvance', 2, 2502, 0, 0, '', 0, 19833, 0, 1, 'FinCardAdvance') ;

CALL ImportField(250210012, '', 'FactCode', '', 'Fact', 2, 2502, 0, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250210013, '/ ', 'FacialCode', '', 'FacialCode', 2, 2502, 0, 0, '', 0, null, 0, 1, 'FacialCode') ;

CALL ImportField(250210014, '/c ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2502, 0, 0, '', 0, 19803, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250210015, ' ', 'ExecuterName', '', 'Executer_Name', 2, 2502, 0, 0, '', 0, 24613, 0, 1, 'Executer_Name') ;

CALL ImportField(250210016, ' ', 'ExecuterKPP', '', 'Executer_INN20', 2, 2502, 0, 0, '', 0, 24612, 0, 1, 'Executer_INN20') ;

CALL ImportField(250210017, ' ', 'ExecuterINN', '', 'Executer_INN', 2, 2502, 0, 0, '', 0, 24611, 0, 1, 'Executer_INN') ;

CALL ImportField(250210018, ' (+)', 'Executer', '', 'Executer', 2, 2502, 0, 0, '', 0, null, 0, 1, 'Executer') ;

CALL ImportField(250210019, ' ', 'DocNumber', '', 'DocNumber', 2, 2502, 0, 0, '', 0, 19798, 0, 1, 'DocNumber') ;

CALL ImportField(250210020, ' ', 'DeliveryRules', '', 'DeliveryRules', 2, 2502, 0, 0, '', 0, 19825, 0, 1, 'DeliveryRules') ;

CALL ImportField(250210021, '  (+)', 'CloseDocTop', '', 'CloseDocTop', 2, 2502, 0, 0, '', 0, null, 0, 1, 'CloseDocTop') ;

CALL ImportField(250210022, '  ', 'CloseDocNum', '', 'CloseDocNum', 2, 2502, 0, 0, '', 0, 19739, 0, 1, 'CloseDocNum') ;

CALL ImportField(250210023, ' ', 'CloseDate', '', 'CloseDate', 2, 2502, 0, 0, '', 0, 19824, 0, 1, 'CloseDate') ;

CALL ImportField(250210024, ' ', 'ClientName', '', 'Client_Name', 2, 2502, 0, 0, '', 0, 24608, 0, 1, 'Client_Name') ;

CALL ImportField(250210025, ' ', 'ClientKPP', '', 'Client_INN20', 2, 2502, 0, 0, '', 0, 24607, 0, 1, 'Client_INN20') ;

CALL ImportField(250210026, ' ', 'ClientINN', '', 'Client_INN', 2, 2502, 0, 0, '', 0, 24606, 0, 1, 'Client_INN') ;

CALL ImportField(250210027, ' (+)', 'ClientAll', '', 'ClientAll', 2, 2502, 0, 0, '', 0, null, 0, 1, 'ClientAll') ;

CALL ImportField(250210028, ' (+)', 'Client', '', 'Client', 2, 2502, 0, 0, '', 0, null, 0, 1, 'Client') ;

CALL ImportField(250210029, ' ', 'CardAdvancePercent', '', 'CardAdvancePercent', 2, 2502, 0, 0, '', 0, 19807, 0, 1, 'CardAdvancePercent') ;

CALL ImportField(250210030, '  ', 'CardAdvance', '', 'CardAdvance', 2, 2502, 0, 0, '', 0, 19808, 0, 1, 'CardAdvance') ;

CALL ImportField(250210031, ' ', 'AgreementType', '', 'AgreementType', 2, 2502, 0, 1, '', 0, null, 0, 1, 'AgreementType') ;

CALL ImportField(250210032, '  (+)', 'AgreementSumms', '', 'AgreementSumms', 2, 2502, 0, 0, '', 0, null, 0, 1, 'AgreementSumms') ;

CALL ImportField(250210033, ' ', 'AgreementSumma', '', 'AgreementSumma', 2, 2502, 0, 0, '', 0, 19826, 0, 1, 'AgreementSumma') ;

CALL ImportField(250210034, '     ', 'AgreementFinSumma', '', 'AgreementFinSumma', 2, 2502, 0, 0, '', 0, 19827, 0, 1, 'AgreementFinSumma') ;

CALL ImportField(250210035, ' ', 'AgreementEndDate', '', 'AgreementEndDate', 2, 2502, 0, 0, '', 0, 19800, 0, 1, 'AgreementEndDate') ;

CALL ImportField(250210036, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2502, 0, 0, '', 0, 19799, 0, 1, 'AgreementDate') ;

CALL ImportField(250210037, ' ', 'AgreementCardAdvance', '', 'AgreementCardAdvance', 2, 2502, 0, 0, '', 0, 19832, 0, 1, 'AgreementCardAdvance') ;

CALL ImportField(250210038, ' ', 'AgreementBeginDate', '', 'AgreementBeginDate', 2, 2502, 0, 0, '', 0, 19841, 0, 1, 'AgreementBeginDate') ;

CALL ImportField(250210039, ' ', 'Advance', '', 'Advance', 2, 2502, 0, 0, '', 0, null, 0, 1, 'Advance') ;

CALL ImportField(250210041, ' /', 'AcceptDate', '', 'AcceptDate', 2, 2502, 0, 0, '', 0, 19806, 0, 1, 'AcceptDate') ;

CALL ImportField(250210042, ' ', 'PurportDoc', '', 'PurportDoc', 2, 2502, 0, 0, '', 0, 19849, 0, 1, 'PurportDoc') ;

CALL ImportField(250210043, '  ', 'UnknownAmount', '', 'UnknownAmount', 2, 2502, 0, 0, '', 0, 19869, 0, 1, 'UnknownAmount') ;

CALL ImportField(250210044, ' ', 'ExecuterAccName', '', 'ExecuterAccRef', 2, 2502, 0, 0, '', 0, 17112, 0, 1, 'ExecuterAccRef') ;

CALL ImportField(250210045, ' ', 'ExecuterCountry', ' ', 'Executer_Country', 2, 2502, 0, 0, '', 0, 24610, 0, 1, 'Executer_Country') ;

CALL ImportField(250210046, ' ', 'ExecuterAddress', ' ', 'Executer_Address', 2, 2502, 0, 0, '', 0, 24609, 0, 1, 'Executer_Address') ;

CALL ImportField(250210047, ' ', 'ExecuterPhone', ' ', 'Executer_Phone', 2, 2502, 0, 0, '', 0, 24614, 0, 1, 'Executer_Phone') ;

CALL ImportField(250210048, ' ', 'ExecuterStatus', ' ', 'Executer_Status', 2, 2502, 0, 0, '', 0, 24615, 0, 1, 'Executer_Status') ;

CALL ImportField(250210049, ' ', 'DocType', '', 'DocType', 2, 2502, 0, 0, '', 0, 26539, 0, 1, 'DocType') ;

CALL ImportField(250210050, 'Executer_Ref', 'Executer_Ref', '', 'Executer_Ref', 2, 2502, 0, 1, '', 0, null, 0, 1, 'Executer_Ref') ;

CALL ImportField(250210051, 'Client_Ref', 'Client_Ref', '', 'Client_Ref', 2, 2502, 0, 1, '', 0, null, 0, 1, 'Client_Ref') ;

CALL ImportField(250210052, 'EXECUTERACCREF', 'EXECUTERACCREF', '', 'EXECUTERACCREF', 2, 2502, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF') ;

CALL ImportField(250210053, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2502, 0, 0, '', 0, 29903, 0, 1, 'InfoNumber') ;

CALL ImportField(250210054, '   ', 'AdjustmentRef', '', 'AdjustmentRef', 2, 2502, 0, 1, '', 1, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250210055, 'EXECUTERACCREF_BANKBIK', 'EXECUTERACCREF_BANKBIK', '', 'EXECUTERACCREF_BANKBIK', 2, 2502, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF_BANKBIK') ;

CALL ImportField(250210056, 'EXECUTERACCREF_BANKCOR', 'EXECUTERACCREF_BANKCOR', '', 'EXECUTERACCREF_BANKCOR', 2, 2502, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF_BANKCOR') ;

CALL ImportField(250210057, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2502, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250210058, ' ()', 'Fact', '', 'FactKey', 2, 2502, 0, 1, '', 0, 19822, 0, 1, 'FactKey') ;

CALL ImportField(250210059, ' ', 'StateOrderDate', '', 'StateOrderDate', 2, 2502, 0, 0, '', 0, null, 0, 1, 'StateOrderDate') ;

CALL ImportField(250210060, '  ', 'StateOrderReestrNumber', '', 'StateOrderReestrNumber', 2, 2502, 0, 0, '', 0, null, 0, 1, 'StateOrderReestrNumber') ;

CALL ImportField(250210061, ' ', 'StateOrderInnerNumber', '', 'StateOrderInnerNumber', 2, 2502, 0, 0, '', 0, null, 0, 1, 'StateOrderInnerNumber') ;

CALL ImportField(250210062, '    ', 'OldDocNumber', '', 'OldDocNumber', 2, 2502, 0, 0, '', 0, null, 0, 1, 'OldDocNumber') ;

CALL ImportField(250210063, '', 'StateOrderCaption', '', 'StateOrderCaption', 2, 2502, 0, 0, '', 0, null, 0, 1, 'StateOrderCaption') ;

CALL ImportField(250210064, 'ID', 'ID', '', 'ID', 2, 2502, 0, 1, '', 0, null, 0, 1, 'ID') ;

CALL ImportField(250210065, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210066, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210067, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210068, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250210073, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 2502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250210074, '.  ', 'StoredContent', '', 'StoredContent', 2, 2502, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250211001, '  ', 'Summa', '', 'Summa', 2, 2502, 1, 0, '', 0, 20112, 0, 1, 'Summa') ;

CALL ImportField(250211002, ' ', 'StepSumma', '', 'StepSumma', 2, 2502, 1, 0, '', 0, 20121, 0, 1, 'StepSumma') ;

CALL ImportField(250211003, '', 'StepFinSumma', '', 'StepFinSumma', 2, 2502, 1, 0, '', 0, 20122, 0, 1, 'StepFinSumma') ;

CALL ImportField(250211004, ' ', 'ANumber', '', 'ANumber', 2, 2502, 1, 0, '', 0, 20109, 0, 1, 'ANumber') ;

CALL ImportField(250211005, '', 'Note', '', 'Note', 2, 2502, 1, 0, '', 0, 20113, 0, 1, 'Note') ;

CALL ImportField(250211006, ' ', 'EndStepDate', '', 'EndStepDate', 2, 2502, 1, 0, '', 0, 20111, 0, 1, 'EndStepDate') ;

CALL ImportField(250211007, '  (+)', 'CloseDocTop', '', 'CloseDocTop', 2, 2502, 1, 0, '', 0, null, 0, 1, 'CloseDocTop') ;

CALL ImportField(250211008, '  ', 'CloseDocNum', '', 'CloseDocNum', 2, 2502, 1, 0, '', 0, 19739, 0, 1, 'CloseDocNum') ;

CALL ImportField(250211009, ' ', 'BeginStepDate', '', 'BeginStepDate', 2, 2502, 1, 0, '', 0, 20110, 0, 1, 'BeginStepDate') ;

CALL ImportField(250211010, ' ', 'AcceptDate', '', 'AcceptDate', 2, 2502, 1, 0, '', 0, 20114, 0, 1, 'AcceptDate') ;

CALL ImportField(250211075, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250211076, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250211077, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250211078, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250211079, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250212001, '    ', 'SummaPreviousYear', '', 'SummaPreviousYear', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaPreviousYear') ;

CALL ImportField(250212002, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250212003, '', 'Summa', '', 'Summa', 2, 2502, 2, 0, '', 0, 20140, 0, 1, 'Summa') ;

CALL ImportField(250212004, '', 'SubKESR', '', 'SubKESRKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'SubKESRKey') ;

CALL ImportField(250212005, '', 'Region', '', 'Region', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250212006, ' IV', 'Quarter4', '', 'Quarter4', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Quarter4') ;

CALL ImportField(250212007, ' III', 'Quarter3', '', 'Quarter3', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Quarter3') ;

CALL ImportField(250212008, ' II', 'Quarter2', '', 'Quarter2', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Quarter2') ;

CALL ImportField(250212009, ' I', 'Quarter1', '', 'Quarter1', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Quarter1') ;

CALL ImportField(250212010, ' ', 'PromiseType', '', 'PromiseType', 2, 2502, 2, 0, '', 0, null, 0, 1, 'PromiseType') ;

CALL ImportField(250212011, '  ', 'ParentNumber', '', 'ParentNumber', 2, 2502, 2, 1, '', 0, null, 0, 1, 'ParentNumber') ;

CALL ImportField(250212012, ' ', 'ANumber', '', 'ANumber', 2, 2502, 2, 0, '', 0, null, 0, 1, 'ANumber') ;

CALL ImportField(250212013, '', 'Month12', '', 'Month12', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month12') ;

CALL ImportField(250212014, '', 'Month11', '', 'Month11', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month11') ;

CALL ImportField(250212015, '', 'Month10', '', 'Month10', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month10') ;

CALL ImportField(250212016, '', 'Month09', '', 'Month09', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month09') ;

CALL ImportField(250212017, '', 'Month08', '', 'Month08', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month08') ;

CALL ImportField(250212018, '', 'Month07', '', 'Month07', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month07') ;

CALL ImportField(250212019, '', 'Month06', '', 'Month06', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month06') ;

CALL ImportField(250212020, '', 'Month05', '', 'Month05', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month05') ;

CALL ImportField(250212021, '', 'Month04', '', 'Month04', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month04') ;

CALL ImportField(250212022, '', 'Month03', '', 'Month03', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month03') ;

CALL ImportField(250212023, '', 'Month02', '', 'Month02', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month02') ;

CALL ImportField(250212024, '', 'Month01', '', 'Month01', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Month01') ;

CALL ImportField(250212025, ' ', 'MeansType', '', 'MeansType', 2, 2502, 2, 0, '', 0, null, 0, 1, 'MeansType') ;

CALL ImportField(250212026, '', 'KVSR', '', 'KVSR', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250212027, '', 'KVR', '', 'KVR', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250212028, '', 'KFSR', '', 'KFSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250212029, '', 'KESR', '', 'KESR', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250212030, '', 'KCSR', '', 'KCSR', 2, 2502, 2, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250212031, ' . ', 'FinTypeCode', '', 'FinType', 2, 2502, 2, 0, '', 0, null, 0, 1, 'FinType') ;

CALL ImportField(250212032, ' ', 'FinSource', '', 'FinSource', 2, 2502, 2, 0, '', 0, null, 0, 1, 'FinSource') ;

CALL ImportField(250212033, '', 'FactCode', '', 'Fact', 2, 2502, 2, 0, '', 0, null, 0, 1, 'Fact') ;

CALL ImportField(250212034, '/ ', 'FacialCode', '', 'FacialCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'FacialCode') ;

CALL ImportField(250212035, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2502, 2, 0, '', 0, null, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250212036, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250212037, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 2, 2502, 2, 0, '', 0, null, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250212038, ' (+)', 'TreeOwner0', '', 'BudTree', 2, 2502, 2, 0, '', 0, null, 0, 1, 'BudTree') ;

CALL ImportField(250212040, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250212041, '', 'KVSRCode', '', 'KVSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250212042, '', 'KVRCode', '', 'KVR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250212043, '', 'KCSRCode', '', 'KCSR', 2, 2502, 2, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250212044, ' ', 'StepNumber', '', 'StepNumber', 2, 2502, 2, 0, '', 0, null, 0, 1, 'StepNumber') ;

CALL ImportField(250212045, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250212046, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2502, 2, 0, '', 0, null, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250212047, '  ', 'SummaYear2', '', 'SummaYear2', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaYear2') ;

CALL ImportField(250212048, '  ', 'SummaYear3', '', 'SummaYear3', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaYear3') ;

CALL ImportField(250212049, ' ', 'PromiseNumber', '', 'PromiseNumber', 2, 2502, 2, 0, '', 0, null, 0, 1, 'PromiseNumber') ;

CALL ImportField(250212050, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2502, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250212051, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2502, 2, 0, '', 0, null, 0, 1, 'DirectionCls') ;

CALL ImportField(250212052, ' ()', 'Fact', '', 'FactKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'FactKey') ;

CALL ImportField(250212053, ' . ', 'FinType', '', 'FinTypeKey', 2, 2502, 2, 1, '', 0, null, 0, 1, 'FinTypeKey') ;

CALL ImportField(250212056, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2502, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250212059, '  ', 'SummaOtherYears', '', 'SummaOtherYears', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaOtherYears') ;

CALL ImportField(250212060, '  ', 'SummaYear4', '', 'SummaYear4', 2, 2502, 2, 0, '', 0, null, 0, 1, 'SummaYear4') ;

CALL ImportField(250212061, ' ', 'AgreementRef', '  ', ' ', 2, 2502, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250212062, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2502, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250212063, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2502, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250212069, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212070, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212071, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212072, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250212074, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2502, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250212075, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2502, 2, 1, '', 0, 27829, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250212076, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2502, 2, 1, '', 0, null, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250212077, '   ()', 'TransfertCls', '   ()', 'TransfertCls', 2, 2502, 2, 1, '', 0, 22774, 0, 1, 'TransfertCls') ;

CALL ImportField(250212090, '()', 'KESRCode', '', '()', 2, 2502, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250212091, '()', 'SubKESRCode', '', 'SubKESR', 2, 2502, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

CALL ImportField(250213001, ' ', 'VATSumma', '', 'VATSumma', 2, 2502, 3, 0, '', 0, null, 0, 1, 'VATSumma') ;

CALL ImportField(250213002, ' ', 'VATPercent', '', 'VATPercent', 2, 2502, 3, 0, '', 0, null, 0, 1, 'VATPercent') ;

CALL ImportField(250213003, '   ', 'Summa', '', 'Summa', 2, 2502, 3, 0, '', 0, 20242, 0, 1, 'Summa') ;

CALL ImportField(250213004, ' ', 'ProductName', '', 'ProductName', 2, 2502, 3, 0, '', 0, null, 0, 1, 'ProductName') ;

CALL ImportField(250213005, '  (+)', 'Product', '', 'Product', 2, 2502, 3, 0, '', 0, null, 0, 1, 'Product') ;

CALL ImportField(250213006, '  ', 'PriceVAT', '  ', 'PriceVAT', 2, 2502, 3, 0, '', 0, null, 0, 1, 'PriceVAT') ;

CALL ImportField(250213007, '  ', 'Price', '', 'Price', 2, 2502, 3, 0, '', 0, null, 0, 1, 'Price') ;

CALL ImportField(250213008, '', 'Cost', '', 'Cost', 2, 2502, 3, 0, '', 0, null, 0, 1, 'Cost') ;

CALL ImportField(250213009, '', 'Amount', '', 'Amount', 2, 2502, 3, 1, '', 0, null, 0, 1, 'Amount') ;

CALL ImportField(250213080, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2502, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250213081, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2502, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250213082, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250213083, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250213084, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2502, 3, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250214085, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2502, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250214086, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2502, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250214087, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2502, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250214088, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2502, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250214089, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2502, 4, 1, '', 0, null, 0, 1, '') ;

--   , +(2)
CALL ImportField(250310001, '', 'BudgetRef', '', 'BudgetRef', 2, 2503, 0, 0, '', 0, 19749, 0, 1, 'BudgetRef') ;

CALL ImportField(250310002, ' ', 'SupplierName', '', 'SupplierName', 2, 2503, 0, 0, '', 0, 16646, 0, 1, 'SupplierName') ;

CALL ImportField(250310003, ' ', 'SupplierKPP', '', 'SupplierKPP', 2, 2503, 0, 0, '', 0, 16653, 0, 1, 'SupplierKPP') ;

CALL ImportField(250310004, ' ', 'SupplierINN', '', 'SupplierINN', 2, 2503, 0, 0, '', 0, 16645, 0, 1, 'SupplierINN') ;

CALL ImportField(250310005, '  ', 'SupplierAcc', '', 'SupplierAcc', 2, 2503, 0, 0, '', 0, 17112, 0, 1, 'SupplierAcc') ;

CALL ImportField(250310006, ' ', 'Summa', '', 'Summa', 2, 2503, 0, 0, '', 0, 19744, 0, 1, 'Summa') ;

CALL ImportField(250310007, '  ', 'StepNumber', '', 'StepNumber', 2, 2503, 0, 0, '', 0, 19752, 0, 1, 'StepNumber') ;

CALL ImportField(250310008, ' ', 'ReviewNote', '', 'ReviewNote', 2, 2503, 0, 0, '', 0, 19763, 0, 1, 'ReviewNote') ;

CALL ImportField(250310009, '  ', 'ReturnDoc', '', 'ReturnDoc', 2, 2503, 0, 1, '', 0, null, 0, 1, 'ReturnDoc') ;

CALL ImportField(250310010, ' ', 'Ret_RegistrationType', '', 'Ret_RegistrationType', 2, 2503, 0, 0, '', 0, null, 0, 1, 'Ret_RegistrationType') ;

CALL ImportField(250310011, '   ', 'Ret_ReestrNumber', '', 'Ret_ReestrNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'Ret_ReestrNumber') ;

CALL ImportField(250310012, '  ', 'Ret_DocumentDate', '', 'Ret_DocumentDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'Ret_DocumentDate') ;

CALL ImportField(250310013, '  ', 'Ret_DocNumber', '', 'Ret_DocNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'Ret_DocNumber') ;

CALL ImportField(250310014, ' ', 'RejectCls', '', 'RejectCls', 2, 2503, 0, 0, '', 0, 19757, 0, 1, 'RejectCls') ;

CALL ImportField(250310015, '  ()', 'RejectCause', '', 'RejectCause', 2, 2503, 0, 0, '', 0, 19758, 0, 1, 'RejectCause') ;

CALL ImportField(250310016, ' ', 'RegistrationType', '', 'RegistrationType', 2, 2503, 0, 0, '', 0, null, 0, 1, 'RegistrationType') ;

CALL ImportField(250310017, '  ', 'ReestrNumber', '', 'ReestrNumber', 2, 2503, 0, 0, '', 0, 19756, 0, 1, 'ReestrNumber') ;

CALL ImportField(250310018, ' ', 'RecipientName', '', 'RecipientName', 2, 2503, 0, 0, '', 0, 16646, 0, 1, 'RecipientName') ;

CALL ImportField(250310019, ' ', 'RecipientKPP', '', 'RecipientKPP', 2, 2503, 0, 0, '', 0, 16653, 0, 1, 'RecipientKPP') ;

CALL ImportField(250310020, ' ', 'RecipientINN', '', 'RecipientINN', 2, 2503, 0, 0, '', 0, 16645, 0, 1, 'RecipientINN') ;

CALL ImportField(250310021, '  ', 'RecipientAcc', '', 'RecipientAcc', 2, 2503, 0, 0, '', 0, null, 0, 1, 'RecipientAcc') ;

CALL ImportField(250310022, '  ', 'PrimaryAgreementNumber', '', 'PrimaryAgreementNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'PrimaryAgreementNumber') ;

CALL ImportField(250310023, '', 'OrgSupplier', '', 'OrgSupplier', 2, 2503, 0, 0, '', 0, null, 0, 1, 'OrgSupplier') ;

CALL ImportField(250310024, '', 'OrgRecipient', '', 'OrgRecipient', 2, 2503, 0, 0, '', 0, null, 0, 1, 'OrgRecipient') ;

CALL ImportField(250310025, '', 'Note', '', 'Note', 2, 2503, 0, 0, '', 0, 19762, 0, 1, 'Note') ;

CALL ImportField(250310026, '', 'FactCode', '', 'Fact', 2, 2503, 0, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250310027, '  ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2503, 0, 0, '', 0, 19754, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250310028, '    ', 'ExecDocFinSumma', '', 'ExecDocFinSumma', 2, 2503, 0, 0, '', 0, 19767, 0, 1, 'ExecDocFinSumma') ;

CALL ImportField(250310029, ' ', 'DocumentDate', '', 'DocumentDate', 2, 2503, 0, 0, '', 0, 19740, 0, 1, 'DocumentDate') ;

CALL ImportField(250310030, ' ', 'DocType', '', 'DocType', 2, 2503, 0, 0, '', 0, 19738, 0, 1, 'DocType') ;

CALL ImportField(250310031, ' ', 'DocNumber', '', 'DocNumber', 2, 2503, 0, 0, '', 0, 19739, 0, 1, 'DocNumber') ;

CALL ImportField(250310032, '  ', 'Binding', '', 'Binding', 2, 2503, 0, 0, '', 0, null, 0, 1, 'Binding') ;

CALL ImportField(250310033, '', 'AgreementNumberRest', '', 'AgreementNumberRest', 2, 2503, 0, 0, '', 0, null, 0, 1, 'AgreementNumberRest') ;

CALL ImportField(250310034, ' ', 'AgreementNumber', '', 'AgreementNumber', 2, 2503, 0, 0, '', 0, 19798, 0, 1, 'AgreementNumber') ;

CALL ImportField(250310035, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'AgreementDate') ;

CALL ImportField(250310036, '  ', 'AcceptDate', '', 'AcceptDate', 2, 2503, 0, 0, '', 0, 19741, 0, 1, 'AcceptDate') ;

CALL ImportField(250310037, '  ', 'SupplierAccExpanded', '  ', 'SupplierAccExpanded', 2, 2503, 0, 0, '', 0, null, 0, 1, 'SupplierAccExpanded') ;

CALL ImportField(250310038, '   ', 'AdjustmentRef', '', 'AdjustmentRef', 2, 2503, 0, 1, '', 1, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250310039, ' ', 'ExecSumms', '', ' ', 2, 2503, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250310041, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2503, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250310042, ' ()', 'Fact', '', 'FactKey', 2, 2503, 0, 1, '', 0, 19769, 0, 1, 'FactKey') ;

CALL ImportField(250310043, '  / ', 'SupplierAcc_Ref', '', 'Supplieracc_ref', 2, 2503, 0, 1, '', 0, 17109, 0, 1, 'Supplieracc_ref') ;

CALL ImportField(250310044, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'InfoNumber') ;

CALL ImportField(250310045, ' ', 'NotifyDate', '', 'NotifyDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'NotifyDate') ;

CALL ImportField(250310046, ' ', 'MoneyPromiseNumber', '', 'MoneyPromiseNumber', 2, 2503, 0, 0, '', 0, null, 0, 1, 'MoneyPromiseNumber') ;

CALL ImportField(250310047, ' ', 'PurportDoc', '', 'PurportDoc', 2, 2503, 0, 0, '', 0, null, 0, 1, 'PurportDoc') ;

CALL ImportField(250310048, '  ', 'SupplierStoredProps', '', 'SupplierStoredProps', 2, 2503, 0, 0, '', 0, null, 0, 1, 'SupplierStoredProps') ;

CALL ImportField(250310049, 'ID', 'ID', '', 'ID', 2, 2503, 0, 1, '', 0, null, 0, 1, 'ID') ;

CALL ImportField(250310059, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2503, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250310060, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2503, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250310061, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2503, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250310062, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2503, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250310067, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 2503, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250310068, '.  ', 'StoredContent', '', 'StoredContent', 2, 2503, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250310069, '  ', 'AgreementRef', '', 'AgreementRef', 2, 2503, 0, 1, '', 0, 29912, 0, 0, 'AgreementRef') ;

CALL ImportField(250310076, ' ', 'AutoPayType', ' ', 'AutoPayType', 2, 2503, 0, 0, '', 0, 43489, 0, 1, '') ;

CALL ImportField(250310077, ' ', 'PayDate', '', 'PayDate', 2, 2503, 0, 0, '', 0, null, 0, 1, 'PayDate') ;

CALL ImportField(250311001, ' ', 'VATSumma', '', 'VATSumma', 2, 2503, 1, 0, '', 0, 20160, 0, 1, 'VATSumma') ;

CALL ImportField(250311002, ' ', 'VATPercent', '', 'VATPercent', 2, 2503, 1, 0, '', 0, 20159, 0, 1, 'VATPercent') ;

CALL ImportField(250311004, '   ', 'Summa', '', 'Summa', 2, 2503, 1, 0, '', 0, 20166, 0, 1, 'Summa') ;

CALL ImportField(250311005, ' ', 'ProductName', '', 'ProductName', 2, 2503, 1, 0, '', 0, 20697, 0, 1, 'ProductName') ;

CALL ImportField(250311006, ' ', 'ProductCode', '', 'ProductCode', 2, 2503, 1, 0, '', 0, null, 0, 1, 'ProductCode') ;

CALL ImportField(250311007, '  ', 'PriceVAT', '  ', 'PriceVAT', 2, 2503, 1, 0, '', 0, 20172, 0, 1, 'PriceVAT') ;

CALL ImportField(250311008, '  ', 'Price', '', 'Price', 2, 2503, 1, 0, '', 0, 20157, 0, 1, 'Price') ;

CALL ImportField(250311009, '   ', 'OKDP', '', 'OKDP', 2, 2503, 1, 0, '', 0, null, 0, 1, 'OKDP') ;

CALL ImportField(250311010, ' ', 'MeasurementClsName', '', 'MeasurementClsName', 2, 2503, 1, 0, '', 0, null, 0, 1, 'MeasurementClsName') ;

CALL ImportField(250311012, '  ', 'Cost', '', 'Cost', 2, 2503, 1, 0, '', 0, 20158, 0, 1, 'Cost') ;

CALL ImportField(250311013, ' ', 'Amount', '', 'Amount', 2, 2503, 1, 0, '', 0, 20156, 0, 1, 'Amount') ;

CALL ImportField(250311069, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250311070, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250311071, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2503, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250311072, ' ()', 'CreateDate', '', 'CreateDate', 2, 2503, 1, 1, '', 0, null, 0, 1, 'CreateDate') ;

CALL ImportField(250311073, ' ()', 'UpdateDate', '', 'UpdateDate', 2, 2503, 1, 1, '', 0, null, 0, 1, 'UpdateDate') ;

CALL ImportField(250312002, ' ', 'ANumber', '', 'ANumber', 2, 2503, 2, 0, '', 0, 20223, 0, 1, 'ANumber') ;

CALL ImportField(250312003, ' ', 'BuhOperationCls', '', 'BuhOperationCls', 2, 2503, 2, 0, '', 0, 20279, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250312004, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2503, 2, 0, '', 0, 36861, 0, 1, 'DirectionCls') ;

CALL ImportField(250312005, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2503, 2, 0, '', 0, 20249, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250312006, '/ ', 'FacialCode', '', 'FacialCode', 2, 2503, 2, 0, '', 0, null, 0, 1, 'FacialCode') ;

CALL ImportField(250312007, '', 'FactCode', '', 'Fact', 2, 2503, 2, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250312008, ' ', 'FinSource', '', 'FinSource', 2, 2503, 2, 0, '', 0, 20246, 0, 1, 'FinSource') ;

CALL ImportField(250312009, ' . ', 'FinTypeCode', '', 'FinType', 2, 2503, 2, 0, '', 0, 36853, 0, 1, 'FinType') ;

CALL ImportField(250312010, '', 'KCSRCode', '', 'KCSRCode', 2, 2503, 2, 0, '', 0, 25462, 0, 1, 'KCSRCode') ;

CALL ImportField(250312011, '', 'KESR', '', 'KESRKey', 2, 2503, 2, 1, '', 0, 20226, 0, 1, 'KESRKey') ;

CALL ImportField(250312012, '', 'KFSR', '', 'KFSR', 2, 2503, 2, 0, '', 0, 20225, 0, 1, 'KFSR') ;

CALL ImportField(250312013, '', 'KVRCode', '', 'KVRCode', 2, 2503, 2, 0, '', 0, 25467, 0, 1, 'KVRCode') ;

CALL ImportField(250312014, '', 'KVSRCode', '', 'KVSRCode', 2, 2503, 2, 0, '', 0, 25472, 0, 1, 'KVSRCode') ;

CALL ImportField(250312015, ' ', 'MeansType', '', 'MeansType', 2, 2503, 2, 0, '', 0, 20245, 0, 1, 'MeansType') ;

CALL ImportField(250312016, '', 'Month01', '', 'Month01', 2, 2503, 2, 0, '', 0, 20230, 0, 1, 'Month01') ;

CALL ImportField(250312017, '', 'Month02', '', 'Month02', 2, 2503, 2, 0, '', 0, 20231, 0, 1, 'Month02') ;

CALL ImportField(250312018, '', 'Month03', '', 'Month03', 2, 2503, 2, 0, '', 0, 20232, 0, 1, 'Month03') ;

CALL ImportField(250312019, '', 'Month04', '', 'Month04', 2, 2503, 2, 0, '', 0, 20233, 0, 1, 'Month04') ;

CALL ImportField(250312020, '', 'Month05', '', 'Month05', 2, 2503, 2, 0, '', 0, 20234, 0, 1, 'Month05') ;

CALL ImportField(250312021, '', 'Month06', '', 'Month06', 2, 2503, 2, 0, '', 0, 20235, 0, 1, 'Month06') ;

CALL ImportField(250312022, '', 'Month07', '', 'Month07', 2, 2503, 2, 0, '', 0, 20236, 0, 1, 'Month07') ;

CALL ImportField(250312023, '', 'Month08', '', 'Month08', 2, 2503, 2, 0, '', 0, 20237, 0, 1, 'Month08') ;

CALL ImportField(250312024, '', 'Month09', '', 'Month09', 2, 2503, 2, 0, '', 0, 20238, 0, 1, 'Month09') ;

CALL ImportField(250312025, '', 'Month10', '', 'Month10', 2, 2503, 2, 0, '', 0, 20239, 0, 1, 'Month10') ;

CALL ImportField(250312026, '', 'Month11', '', 'Month11', 2, 2503, 2, 0, '', 0, 20240, 0, 1, 'Month11') ;

CALL ImportField(250312027, '', 'Month12', '', 'Month12', 2, 2503, 2, 0, '', 0, 20241, 0, 1, 'Month12') ;

CALL ImportField(250312028, '  ', 'ParentNumber', '', 'ParentNumber', 2, 2503, 2, 0, '', 0, null, 0, 1, 'ParentNumber') ;

CALL ImportField(250312029, ' ', 'PromiseType', '', 'PromiseType', 2, 2503, 2, 0, '', 0, 20261, 0, 1, 'PromiseType') ;

CALL ImportField(250312030, ' I', 'Quarter1', '', 'Quarter1', 2, 2503, 2, 0, '', 0, 20266, 0, 1, 'Quarter1') ;

CALL ImportField(250312031, ' II', 'Quarter2', '', 'Quarter2', 2, 2503, 2, 0, '', 0, 20267, 0, 1, 'Quarter2') ;

CALL ImportField(250312032, ' III', 'Quarter3', '', 'Quarter3', 2, 2503, 2, 0, '', 0, 20268, 0, 1, 'Quarter3') ;

CALL ImportField(250312033, ' IV', 'Quarter4', '', 'Quarter4', 2, 2503, 2, 0, '', 0, 20269, 0, 1, 'Quarter4') ;

CALL ImportField(250312034, '', 'Region', '', 'Region', 2, 2503, 2, 0, '', 0, 20243, 0, 1, 'Region') ;

CALL ImportField(250312035, '', 'SubKESR', '', 'SubKESRKey', 2, 2503, 2, 1, '', 0, 20244, 0, 1, 'SubKESRKey') ;

CALL ImportField(250312036, '', 'Summa', '', 'Summa', 2, 2503, 2, 0, '', 0, null, 0, 1, 'Summa') ;

CALL ImportField(250312037, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2503, 2, 0, '', 0, 20265, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250312038, '    ', 'SummaPreviousYear', '', 'SummaPreviousYear', 2, 2503, 2, 0, '', 0, 20264, 0, 1, 'SummaPreviousYear') ;

CALL ImportField(250312039, '  ', 'TransfertClsCode', '', 'TransfertClsCode', 2, 2503, 2, 0, '', 0, 25326, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250312040, ' (+)', 'TreeOwner0', '', 'TreeOwner0', 2, 2503, 2, 0, '', 0, null, 0, 1, 'TreeOwner0') ;

CALL ImportField(250312041, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2503, 2, 0, '', 0, 27825, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250312042, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2503, 2, 0, '', 0, 27849, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250312043, '  ', 'SummaYear3', '', 'SummaYear3', 2, 2503, 2, 0, '', 0, 20301, 0, 1, 'SummaYear3') ;

CALL ImportField(250312044, '  ', 'SummaYear2', '', 'SummaYear2', 2, 2503, 2, 0, '', 0, 20300, 0, 1, 'SummaYear2') ;

CALL ImportField(250312045, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2503, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250312046, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2503, 2, 1, '', 0, 20277, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250312047, ' ()', 'Fact', '', 'FactKey', 2, 2503, 2, 1, '', 0, 20248, 0, 1, 'FactKey') ;

CALL ImportField(250312048, ' . ', 'FinType', '', 'FinTypeKey', 2, 2503, 2, 1, '', 0, 20247, 0, 1, 'FinTypeKey') ;

CALL ImportField(250312051, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2503, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250312054, '    ', 'OldNumber', '', 'OldNumber', 2, 2503, 2, 0, '', 0, 20263, 0, 1, 'OldNumber') ;

CALL ImportField(250312055, ' ', 'PromiseNumber', '', 'PromiseNumber', 2, 2503, 2, 0, '', 0, 27624, 0, 1, 'PromiseNumber') ;

CALL ImportField(250312056, ' ', 'ExecutionRef', '  ', ' ', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312057, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2503, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250312058, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2503, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250312063, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312064, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312065, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312066, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250312068, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2503, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250312069, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2503, 2, 1, '', 0, 27829, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250312070, ' ()', 'KCSR', '', 'KCSR', 2, 2503, 2, 1, '', 0, 16858, 0, 1, 'KCSR') ;

CALL ImportField(250312071, ' ()', 'KVR', '', 'KVR', 2, 2503, 2, 1, '', 0, 16865, 0, 1, 'KVR') ;

CALL ImportField(250312072, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2503, 2, 1, '', 0, 27853, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250312073, ' ()', 'KVSR', '', 'KVSR', 2, 2503, 2, 1, '', 0, 16852, 0, 1, 'KVSR') ;

CALL ImportField(250312074, '   ()', 'TransfertCls', '', 'TransfertCls', 2, 2503, 2, 1, '', 0, 22774, 0, 1, 'TransfertCls') ;

CALL ImportField(250312075, '    ', 'OldYearData', '    ', 'OldYearData', 2, 2503, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250312078, '()', 'KESRCode', '', 'KESR', 2, 2503, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250312079, '()', 'SubKESRCode', '', 'SubKESR', 2, 2503, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

--  , +(2)
CALL ImportField(250410001, ' ', 'ExecuterCountry', ' ', 'Executer_Country', 2, 2504, 0, 0, '', 0, 24610, 0, 1, 'Executer_Country') ;

CALL ImportField(250410002, ' ', 'ExecuterAddress', ' ', 'Executer_Address', 2, 2504, 0, 0, '', 0, 24609, 0, 1, 'Executer_Address') ;

CALL ImportField(250410003, ' ', 'ExecuterPhone', ' ', 'Executer_Phone', 2, 2504, 0, 0, '', 0, 24614, 0, 1, 'Executer_Phone') ;

CALL ImportField(250410004, ' ', 'ExecuterStatus', ' ', 'Executer_Status', 2, 2504, 0, 0, '', 0, 24615, 0, 1, 'Executer_Status') ;

CALL ImportField(250410005, '', 'BudgetRef', '', 'BudgetRef', 2, 2504, 0, 0, '', 0, 19814, 0, 1, 'BudgetRef') ;

CALL ImportField(250410006, '  ', 'UnknownAmount', '  ', 'UnknownAmount', 2, 2504, 0, 0, '', 0, 19869, 0, 1, 'UnknownAmount') ;

CALL ImportField(250410007, '  ', 'Summa', '', 'Summa', 2, 2504, 0, 0, '', 0, 19797, 0, 1, 'Summa') ;

CALL ImportField(250410009, '', 'rnYear', '', 'rnYear', 2, 2504, 0, 0, '', 0, 19854, 0, 1, 'rnYear') ;

CALL ImportField(250410010, '', 'rnNumber', '', 'rnNumber', 2, 2504, 0, 0, '', 0, 19855, 0, 1, 'rnNumber') ;

CALL ImportField(250410011, '   ', 'rnDate', '   ', 'rnDate', 2, 2504, 0, 0, '', 0, 19856, 0, 1, 'rnDate') ;

CALL ImportField(250410012, ' ', 'rnClientID', ' ', 'rnClientID', 2, 2504, 0, 0, '', 0, 19853, 0, 1, 'rnClientID') ;

CALL ImportField(250410013, ' ', 'ReviewNote', '', 'ReviewNote', 2, 2504, 0, 0, '', 0, 19845, 0, 1, 'ReviewNote') ;

CALL ImportField(250410014, ' ', 'RejectCls', '', 'RejectCls', 2, 2504, 0, 0, '', 0, 19836, 0, 1, 'RejectCls') ;

CALL ImportField(250410015, '  ()', 'RejectCause', '', 'RejectCause', 2, 2504, 0, 0, '', 0, 19837, 0, 1, 'RejectCause') ;

CALL ImportField(250410016, '', 'Region', '', 'Region', 2, 2504, 0, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250410017, ' ', 'ReestrNumber', '', 'ReestrNumber', 2, 2504, 0, 0, '', 0, 19830, 0, 1, 'ReestrNumber') ;

CALL ImportField(250410018, ' .', 'PurportDoc', ' .', 'PurportDoc', 2, 2504, 0, 0, '', 0, 19849, 0, 1, 'PurportDoc') ;

CALL ImportField(250410019, '   ', 'protocolSaleTypeName', '   ', 'protocolSaleTypeName', 2, 2504, 0, 1, '', 0, null, 0, 1, 'protocolSaleTypeName') ;

CALL ImportField(250410020, '  ', 'protocolSaleType', '  ', 'protocolSaleType', 2, 2504, 0, 0, '', 0, 19860, 0, 1, 'protocolSaleType') ;

CALL ImportField(250410021, '  ', 'protocolResultDate', '  ', 'protocolResultDate', 2, 2504, 0, 0, '', 0, 19858, 0, 1, 'protocolResultDate') ;

CALL ImportField(250410022, '  ', 'ProtocolReasonText', '  ', 'ProtocolReason', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolReason') ;

CALL ImportField(250410024, ' - ', 'ProtocolNumberTop', '', 'ProtocolNumberTop', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolNumberTop') ;

CALL ImportField(250410025, ' ', 'ProtocolNumber', ' ', 'ProtocolNumber', 2, 2504, 0, 0, '', 0, 19843, 0, 1, 'ProtocolNumber') ;

CALL ImportField(250410026, '    ', 'protocolNotice', '    ', 'protocolNotice', 2, 2504, 0, 0, '', 0, 19857, 0, 1, 'protocolNotice') ;

CALL ImportField(250410027, ' ', 'protocolDocTypeText', ' ', 'ProtocolDocType', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ProtocolDocType') ;

CALL ImportField(250410029, ' ', 'protocolDocType', ' ', 'protocolDocType', 2, 2504, 0, 1, '', 0, null, 0, 1, 'protocolDocType') ;

CALL ImportField(250410030, ' ', 'ProtocolDate', '', 'ProtocolDate', 2, 2504, 0, 0, '', 0, 19844, 0, 1, 'ProtocolDate') ;

CALL ImportField(250410031, ' ', 'PaymentDate', '', 'PaymentDate', 2, 2504, 0, 0, '', 0, 19831, 0, 1, 'PaymentDate') ;

CALL ImportField(250410032, '    ', 'NotifyDate', '    ', 'NotifyDate', 2, 2504, 0, 0, '', 0, 19861, 0, 1, 'NotifyDate') ;

CALL ImportField(250410033, '', 'Note', '', 'Note', 2, 2504, 0, 0, '', 0, 19821, 0, 1, 'Note') ;

CALL ImportField(250410034, ' ', 'fsOrganName', ' ', 'fsOrganName', 2, 2504, 0, 0, '', 0, null, 0, 1, 'fsOrganName') ;

CALL ImportField(250410035, '  ', 'fsOrganCode', '  ', 'fsOrganCode', 2, 2504, 0, 0, '', 0, null, 0, 1, 'fsOrganCode') ;

CALL ImportField(250410036, ' - ', 'fsOrgan', ' - ', 'fsOrgan', 2, 2504, 0, 0, '', 0, 19850, 0, 1, 'fsOrgan') ;

CALL ImportField(250410039, '  ', 'fsOffBudget', '  ', 'fsOffBudget', 2, 2504, 0, 0, '', 0, 19852, 0, 1, 'fsOffBudget') ;

CALL ImportField(250410042, ' ', 'fsBudgetName', ' ', 'fsBudgetName', 2, 2504, 0, 0, '', 0, 19851, 0, 1, 'fsBudgetName') ;

CALL ImportField(250410043, '      ', 'FinCardAdvance', '', 'FinCardAdvance', 2, 2504, 0, 0, '', 0, 19833, 0, 1, 'FinCardAdvance') ;

CALL ImportField(250410044, '', 'FactCode', '', 'Fact', 2, 2504, 0, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250410045, '/ ', 'FacialCode', '', 'FacialCode', 2, 2504, 0, 0, '', 0, null, 0, 1, 'FacialCode') ;

CALL ImportField(250410046, '/c ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2504, 0, 0, '', 0, 19803, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250410047, ' ', 'ExecuterName', '', 'Executer_Name', 2, 2504, 0, 0, '', 0, 24613, 0, 1, 'Executer_Name') ;

CALL ImportField(250410048, ' ', 'ExecuterKPP', '', 'Executer_INN20', 2, 2504, 0, 0, '', 0, 24612, 0, 1, 'Executer_INN20') ;

CALL ImportField(250410049, ' ', 'ExecuterINN', '', 'Executer_INN', 2, 2504, 0, 0, '', 0, 24611, 0, 1, 'Executer_INN') ;

CALL ImportField(250410053, ' ', 'ExecuterAccName', '', 'ExecuterAccName', 2, 2504, 0, 0, '', 0, 17112, 0, 1, 'ExecuterAccName') ;

CALL ImportField(250410056, ' (+)', 'Executer', '', 'Executer', 2, 2504, 0, 0, '', 0, null, 0, 1, 'Executer') ;

CALL ImportField(250410057, ' ', 'DocNumber', '', 'DocNumber', 2, 2504, 0, 0, '', 0, 19798, 0, 1, 'DocNumber') ;

CALL ImportField(250410058, ' ', 'DocBaseType', ' ', 'DocBaseType', 2, 2504, 0, 0, '', 0, 19867, 0, 1, 'DocBaseType') ;

CALL ImportField(250410059, '  ', 'DocBaseText', '  ', 'DocBaseText', 2, 2504, 0, 0, '', 0, 19866, 0, 1, 'DocBaseText') ;

CALL ImportField(250410060, ' ', 'DocBaseSumma', ' ', 'DocBaseSumma', 2, 2504, 0, 0, '', 0, 19868, 0, 1, 'DocBaseSumma') ;

CALL ImportField(250410061, '     / ', 'DocBaseNotifyDate', '     / ', 'DocBaseNotifyDate', 2, 2504, 0, 0, '', 0, 19865, 0, 1, 'DocBaseNotifyDate') ;

CALL ImportField(250410062, '  /  ', 'DocBaseDate', '  /  ', 'DocBaseDate', 2, 2504, 0, 0, '', 0, 19864, 0, 1, 'DocBaseDate') ;

CALL ImportField(250410063, ' ', 'DeliveryRules', '', 'DeliveryRules', 2, 2504, 0, 0, '', 0, 19825, 0, 1, 'DeliveryRules') ;

CALL ImportField(250410064, ' ', 'CloseDocTop', '', 'CloseDocTop', 2, 2504, 0, 0, '', 0, null, 0, 1, 'CloseDocTop') ;

CALL ImportField(250410065, '  ', 'CloseDocNum', '', 'CloseDocNum', 2, 2504, 0, 0, '', 0, 19739, 0, 1, 'CloseDocNum') ;

CALL ImportField(250410066, ' ', 'CloseDate', '', 'CloseDate', 2, 2504, 0, 0, '', 0, 19824, 0, 1, 'CloseDate') ;

CALL ImportField(250410067, ' ', 'ClientName', '', 'Client_Name', 2, 2504, 0, 0, '', 0, 24608, 0, 1, 'Client_Name') ;

CALL ImportField(250410068, ' ', 'ClientKPP', '', 'Client_INN20', 2, 2504, 0, 0, '', 0, 24607, 0, 1, 'Client_INN20') ;

CALL ImportField(250410069, ' ', 'ClientINN', '', 'Client_INN', 2, 2504, 0, 0, '', 0, 24606, 0, 1, 'Client_INN') ;

CALL ImportField(250410070, ' (+)', 'ClientAll', '', 'ClientAll', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ClientAll') ;

CALL ImportField(250410078, ' (+)', 'Client', '', 'Client', 2, 2504, 0, 0, '', 0, null, 0, 1, 'Client') ;

CALL ImportField(250410079, ' ', 'CardAdvancePercent', '', 'CardAdvancePercent', 2, 2504, 0, 0, '', 0, 19807, 0, 1, 'CardAdvancePercent') ;

CALL ImportField(250410080, '  ', 'CardAdvance', '', 'CardAdvance', 2, 2504, 0, 0, '', 0, 19808, 0, 1, 'CardAdvance') ;

CALL ImportField(250410081, ' ', 'AgreementSumma', '', 'AgreementSumma', 2, 2504, 0, 0, '', 0, 19826, 0, 1, 'AgreementSumma') ;

CALL ImportField(250410082, '     ', 'AgreementFinSumma', '', 'AgreementFinSumma', 2, 2504, 0, 0, '', 0, 19827, 0, 1, 'AgreementFinSumma') ;

CALL ImportField(250410083, ' ', 'AgreementEndDate', '', 'AgreementEndDate', 2, 2504, 0, 0, '', 0, 19800, 0, 1, 'AgreementEndDate') ;

CALL ImportField(250410084, ' ', 'AgreementDate', '', 'AgreementDate', 2, 2504, 0, 0, '', 0, 19799, 0, 1, 'AgreementDate') ;

CALL ImportField(250410085, ' ', 'AgreementCardAdvance', '', 'AgreementCardAdvance', 2, 2504, 0, 0, '', 0, 19832, 0, 1, 'AgreementCardAdvance') ;

CALL ImportField(250410086, ' ', 'AgreementBeginDate', '', 'AgreementBeginDate', 2, 2504, 0, 0, '', 0, 19841, 0, 1, 'AgreementBeginDate') ;

CALL ImportField(250410087, ' ', 'Advance', '', 'Advance', 2, 2504, 0, 0, '', 0, null, 0, 1, 'Advance') ;

CALL ImportField(250410088, ' /', 'AcceptDate', '', 'AcceptDate', 2, 2504, 0, 0, '', 0, 19806, 0, 1, 'AcceptDate') ;

CALL ImportField(250410089, 'Executer_Ref', 'Executer_Ref', '', 'Executer_Ref', 2, 2504, 0, 1, '', 0, null, 0, 1, 'Executer_Ref') ;

CALL ImportField(250410090, 'Client_Ref', 'Client_Ref', '', 'Client_Ref', 2, 2504, 0, 1, '', 0, null, 0, 1, 'Client_Ref') ;

CALL ImportField(250410091, 'EXECUTERACCREF', 'EXECUTERACCREF', '', 'EXECUTERACCREF', 2, 2504, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF') ;

CALL ImportField(250410092, ' ', 'InfoNumber', '', 'InfoNumber', 2, 2504, 0, 0, '', 0, 29903, 0, 1, 'InfoNumber') ;

CALL ImportField(250410093, '   ', 'AdjustmentRef', '', 'AdjustmentRef', 2, 2504, 0, 1, '', 1, null, 0, 1, 'AdjustmentRef') ;

CALL ImportField(250410094, ' ', 'DocType', '', 'DocType', 2, 2504, 0, 0, '', 0, 26539, 0, 1, 'DocType') ;

CALL ImportField(250410095, 'EXECUTERACCREF_BANKCOR', 'EXECUTERACCREF_BANKCOR', '', 'EXECUTERACCREF_BANKCOR', 2, 2504, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF_BANKCOR') ;

CALL ImportField(250410096, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 2504, 0, 1, '', 0, null, 0, 1, 'LastAdjustment') ;

CALL ImportField(250410055, 'EXECUTERACCREF_BANKBIK', 'EXECUTERACCREF_BANKBIK', '', 'EXECUTERACCREF_BANKBIK', 2, 2504, 0, 1, '', 0, null, 0, 1, 'EXECUTERACCREF_BANKBIK') ;

CALL ImportField(250410097, ' ', 'ReestrVersion', '  .  ', 'ReestrVersion', 2, 2504, 0, 0, '', 0, null, 0, 1, 'ReestrVersion') ;

CALL ImportField(250410098, ' ()', 'Fact', '', 'FactKey', 2, 2504, 0, 1, '', 0, 19822, 0, 1, 'FactKey') ;

CALL ImportField(250410099, '  ', 'ExecuterStoredProps', '', 'ExecuterStoredProps', 2, 2504, 0, 0, '', 0, 43484, 0, 1, 'ExecuterStoredProps') ;

CALL ImportField(250410100, '   ()', 'AutoSanction', '', 'AutoSanction', 2, 2504, 0, 0, '', 0, null, 0, 1, 'AutoSanction') ;

CALL ImportField(250410101, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 2504, 0, 0, '', 0, null, 0, 1, 'PurchaseCode') ;

CALL ImportField(250410103, ' ', 'DocumentNumber', '', 'DocumentNumber', 2, 2504, 0, 0, '', 0, null, 0, 1, 'DocumentNumber') ;

CALL ImportField(250410104, ' ', 'DocStateRef', '', 'DocStateRef', 2, 2504, 0, 0, '', 0, null, 0, 1, 'DocStateRef') ;

CALL ImportField(250410105, 'ID', 'ID', '', 'ID', 2, 2504, 0, 1, '', 0, null, 0, 1, 'ID') ;

CALL ImportField(250410106, 'RealID', 'RealID', '', 'RealID', 2, 2504, 0, 1, '', 0, null, 0, 1, 'RealID') ;

CALL ImportField(250410111, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410112, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410113, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410114, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250410115, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 2504, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250410116, '.  ', 'StoredContent', '', 'StoredContent', 2, 2504, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(250410141, ' ', 'AUTOPAYTYPE', ' ', 'AUTOPAYTYPE', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410142, '    ', 'AUTOPAYMONTH', '    ', 'AUTOPAYMONTH', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410143, '   / ', 'AUTOPAYDAY', '   / ', 'AUTOPAYDAY', 2, 2504, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(250410144, '  /', 'ReestrRecordNumber', '', 'ReestrRecordNumber', 2, 2504, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250411001, '  ', 'Summa', '', 'Summa', 2, 2504, 1, 0, '', 0, 20112, 0, 1, 'Summa') ;

CALL ImportField(250411002, ' ', 'StepSumma', '', 'StepSumma', 2, 2504, 1, 0, '', 0, 20121, 0, 1, 'StepSumma') ;

CALL ImportField(250411003, '', 'StepFinSumma', '', 'StepFinSumma', 2, 2504, 1, 0, '', 0, 20122, 0, 1, 'StepFinSumma') ;

CALL ImportField(250411004, '', 'Note', '', 'Note', 2, 2504, 1, 0, '', 0, 20113, 0, 1, 'Note') ;

CALL ImportField(250411005, ' ', 'EndStepDate', '', 'EndStepDate', 2, 2504, 1, 0, '', 0, 20111, 0, 1, 'EndStepDate') ;

CALL ImportField(250411006, '  (+)', 'CloseDocTop', '', 'CloseDocTop', 2, 2504, 1, 0, '', 0, null, 0, 1, 'CloseDocTop') ;

CALL ImportField(250411007, '  ', 'CloseDocNum', '', 'CloseDocNum', 2, 2504, 1, 0, '', 0, 19739, 0, 1, 'CloseDocNum') ;

CALL ImportField(250411008, ' ', 'BeginStepDate', '', 'BeginStepDate', 2, 2504, 1, 0, '', 0, 20110, 0, 1, 'BeginStepDate') ;

CALL ImportField(250411009, ' ', 'ANumber', '', 'ANumber', 2, 2504, 1, 0, '', 0, 20109, 0, 1, 'ANumber') ;

CALL ImportField(250411010, ' ', 'AcceptDate', '', 'AcceptDate', 2, 2504, 1, 0, '', 0, 20114, 0, 1, 'AcceptDate') ;

CALL ImportField(250411126, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250411127, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250411128, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250411129, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250411130, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2504, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250412001, ' ', 'StepNumber', ' ', 'StepNumber', 2, 2504, 2, 0, '', 0, null, 0, 1, 'StepNumber') ;

CALL ImportField(250412002, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'TransfertClsCode') ;

CALL ImportField(250412003, ' (+)', 'TreeOwner0', '', 'BudTree', 2, 2504, 2, 0, '', 0, null, 0, 1, 'BudTree') ;

CALL ImportField(250412004, '  ', 'summayear3', '', 'summayear3', 2, 2504, 2, 0, '', 0, null, 0, 1, 'summayear3') ;

CALL ImportField(250412005, '  ', 'summayear2', '', 'summayear2', 2, 2504, 2, 0, '', 0, null, 0, 1, 'summayear2') ;

CALL ImportField(250412006, '    ', 'SummaPreviousYear', '', 'SummaPreviousYear', 2, 2504, 2, 0, '', 0, null, 0, 1, 'SummaPreviousYear') ;

CALL ImportField(250412007, '     ', 'SummaFinPreviousYear', '', 'SummaFinPreviousYear', 2, 2504, 2, 0, '', 0, null, 0, 1, 'SummaFinPreviousYear') ;

CALL ImportField(250412008, '', 'Summa', '', 'Summa', 2, 2504, 2, 0, '', 0, 20140, 0, 1, 'Summa') ;

CALL ImportField(250412009, ' ', 'SubsidyClsCode', '', 'SubsidyClsCode', 2, 2504, 2, 0, '', 0, 26641, 0, 1, 'SubsidyClsCode') ;

CALL ImportField(250412010, '', 'SubKESR', '', 'SubKESRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'SubKESRKey') ;

CALL ImportField(250412011, '', 'Region', '', 'Region', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Region') ;

CALL ImportField(250412012, ' IV', 'Quarter4', '', 'Quarter4', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Quarter4') ;

CALL ImportField(250412013, ' III', 'Quarter3', '', 'Quarter3', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Quarter3') ;

CALL ImportField(250412014, ' II', 'Quarter2', '', 'Quarter2', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Quarter2') ;

CALL ImportField(250412015, ' I', 'Quarter1', '', 'Quarter1', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Quarter1') ;

CALL ImportField(250412016, ' ', 'PromiseType', '', 'PromiseType', 2, 2504, 2, 0, '', 0, null, 0, 1, 'PromiseType') ;

CALL ImportField(250412017, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'PayPromiseClsCode') ;

CALL ImportField(250412018, '', 'Month12', '', 'Month12', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month12') ;

CALL ImportField(250412019, '', 'Month11', '', 'Month11', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month11') ;

CALL ImportField(250412020, '', 'Month10', '', 'Month10', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month10') ;

CALL ImportField(250412021, '', 'Month09', '', 'Month09', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month09') ;

CALL ImportField(250412022, '', 'Month08', '', 'Month08', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month08') ;

CALL ImportField(250412023, '', 'Month07', '', 'Month07', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month07') ;

CALL ImportField(250412024, '', 'Month06', '', 'Month06', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month06') ;

CALL ImportField(250412025, '', 'Month05', '', 'Month05', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month05') ;

CALL ImportField(250412026, '', 'Month04', '', 'Month04', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month04') ;

CALL ImportField(250412027, '', 'Month03', '', 'Month03', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month03') ;

CALL ImportField(250412028, '', 'Month02', '', 'Month02', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month02') ;

CALL ImportField(250412029, '', 'Month01', '', 'Month01', 2, 2504, 2, 0, '', 0, null, 0, 1, 'Month01') ;

CALL ImportField(250412030, ' ', 'MeansType', '', 'MeansType', 2, 2504, 2, 0, '', 0, null, 0, 1, 'MeansType') ;

CALL ImportField(250412031, '', 'KVSRCode', '', 'KVSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250412032, '', 'KVSR', '', 'KVSR', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250412033, '', 'KVRCode', '', 'KVR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250412034, '', 'KVR', '', 'KVR', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250412035, '', 'KFSR', '', 'KFSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250412036, '', 'KESR', '', 'KESRKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250412037, '', 'KCSRCode', '', 'KCSR', 2, 2504, 2, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250412038, '', 'KCSR', '', 'KCSR', 2, 2504, 2, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250412039, ' . ', 'FinTypeCode', '', 'FinType', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FinType') ;

CALL ImportField(250412040, ' ', 'FinSource', '', 'FinSource', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FinSource') ;

CALL ImportField(250412041, '', 'FactCode', '', 'Fact', 2, 2504, 2, 0, '', 0, 36863, 0, 1, 'Fact') ;

CALL ImportField(250412042, '/ ', 'FacialCode', '', 'FacialCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FacialCode') ;

CALL ImportField(250412043, ' ', 'FacialAcc_Cls', '', 'FacialAcc_Cls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250412044, '', 'DirectionClsCode', '', 'DirectionCls', 2, 2504, 2, 0, '', 0, 36861, 0, 1, 'DirectionCls') ;

CALL ImportField(250412045, ' ', 'BuhOperationCls', ' ', 'BuhOperationCls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'BuhOperationCls') ;

CALL ImportField(250412046, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'BudAllocationClsCode') ;

CALL ImportField(250412047, ' ', 'ANumber', '', 'ANumber', 2, 2504, 2, 0, '', 0, null, 0, 1, 'ANumber') ;

CALL ImportField(250412049, ' ', 'PromiseNumber', '', 'PromiseNumber', 2, 2504, 2, 0, '', 0, null, 0, 1, 'PromiseNumber') ;

CALL ImportField(250412050, ' ()', 'DirectionCls', '', 'DirectionClsKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'DirectionClsKey') ;

CALL ImportField(250412051, ' ()', 'Fact', '', 'FactKey', 2, 2504, 2, 1, '', 0, 20248, 0, 1, 'FactKey') ;

CALL ImportField(250412052, ' .  ()', 'FinType', '', 'FinTypeKey', 2, 2504, 2, 1, '', 0, null, 0, 1, 'FinTypeKey') ;

CALL ImportField(250412055, '  ()', 'SubsidyCls', '', 'SubsidyCls', 2, 2504, 2, 1, '', 0, 27625, 0, 1, 'SubsidyCls') ;

CALL ImportField(250412056, '', 'Note', '', 'Note', 2, 2504, 2, 0, '', 0, 20297, 0, 1, 'Note') ;

CALL ImportField(250412057, '', 'ContractCostsCls', '', 'ContractCostsCls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'ContractCostsCls') ;

CALL ImportField(250412058, '', 'ContractCostsClsCode', '', 'ContractCostsClsCode', 2, 2504, 2, 0, '', 0, null, 0, 1, 'ContractCostsClsCode') ;

CALL ImportField(250412059, '  ', 'SummaYear4', '', 'SummaYear4', 2, 2504, 2, 0, '', 0, null, 0, 1, 'SummaYear4') ;

CALL ImportField(250412060, '  ', 'SummaOtherYears', '', 'SummaOtherYears', 2, 2504, 2, 0, '', 0, null, 0, 1, 'SummaOtherYears') ;

CALL ImportField(250412061, ' ', 'AgreementRef', '  ', ' ', 2, 2504, 2, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250412107, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 2504, 2, 1, '', 0, null, 0, 1, 'BudAllocationCls') ;

CALL ImportField(250412108, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 2504, 2, 0, '', 0, null, 0, 1, 'TransfertCls') ;

CALL ImportField(250412109, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2504, 2, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250412110, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2504, 2, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250412116, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412117, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412118, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412119, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250412120, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2504, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250412121, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 2504, 2, 1, '', 0, null, 0, 1, 'PayPromiseCLS') ;

CALL ImportField(250412158, '()', 'KESRCode', '()', '()', 2, 2504, 2, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250412159, '()', 'SubKESRCode', '()', 'SubKESR', 2, 2504, 2, 0, '', 0, 43610, 0, 1, 'SubKESR') ;

CALL ImportField(250413001, ' ', 'VATSumma', '', 'VATSumma', 2, 2504, 3, 0, '', 0, null, 0, 1, 'VATSumma') ;

CALL ImportField(250413002, ' ', 'VATPercent', '', 'VATPercent', 2, 2504, 3, 0, '', 0, null, 0, 1, 'VATPercent') ;

CALL ImportField(250413003, '   ', 'Summa', '', 'Summa', 2, 2504, 3, 0, '', 0, 20242, 0, 1, 'Summa') ;

CALL ImportField(250413004, ' ', 'ProductName', '', 'ProductName', 2, 2504, 3, 0, '', 0, null, 0, 1, 'ProductName') ;

CALL ImportField(250413005, ' ', 'Product', '', 'Product', 2, 2504, 3, 0, '', 0, null, 0, 1, 'Product') ;

CALL ImportField(250413006, '  ', 'PriceVAT', '  ', 'PriceVAT', 2, 2504, 3, 0, '', 0, null, 0, 1, 'PriceVAT') ;

CALL ImportField(250413007, '  ', 'Price', '', 'Price', 2, 2504, 3, 0, '', 0, null, 0, 1, 'Price') ;

CALL ImportField(250413008, '  ', 'FacialAcc_Cls', '  ', 'FacialAcc_Cls', 2, 2504, 3, 0, '', 0, 20249, 0, 1, 'FacialAcc_Cls') ;

CALL ImportField(250413009, '', 'Cost', '', 'Cost', 2, 2504, 3, 0, '', 0, null, 0, 1, 'Cost') ;

CALL ImportField(250413010, ' ', 'ClientName', ' ', 'ClientName', 2, 2504, 3, 0, '', 0, null, 0, 1, 'ClientName') ;

CALL ImportField(250413011, ' ', 'ClientKPP', ' ', 'ClientKPP', 2, 2504, 3, 0, '', 0, null, 0, 1, 'ClientKPP') ;

CALL ImportField(250413012, ' ', 'ClientINN', ' ', 'ClientINN', 2, 2504, 3, 0, '', 0, null, 0, 1, 'ClientINN') ;

CALL ImportField(250413013, ' (+)', 'ClientAll', '', 'ClientAll', 2, 2504, 3, 0, '', 0, null, 0, 1, 'ClientAll') ;

CALL ImportField(250413014, '', 'Amount', '', 'Amount', 2, 2504, 3, 0, '', 0, null, 0, 1, 'Amount') ;

CALL ImportField(250413131, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250413132, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250413133, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250413134, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250413135, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2504, 3, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250414121, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250414122, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250414123, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250414124, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250414125, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2504, 4, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250414126, ' (+)', 'TreeOwner0', '', 'TreeOwner0', 2, 2504, 4, 0, '', 0, null, 0, 1, 'TreeOwner0') ;

CALL ImportField(250414127, '', 'SUMMA', '', 'SUMMA', 2, 2504, 4, 0, '', 0, null, 0, 1, 'SUMMA') ;

CALL ImportField(250414128, '', 'Note', '', 'Note', 2, 2504, 4, 0, '', 0, null, 0, 1, 'Note') ;

CALL ImportField(250414129, ' ', 'MEANSTYPE', ' ', 'MEANSTYPE', 2, 2504, 4, 0, '', 0, null, 0, 1, 'MEANSTYPE') ;

CALL ImportField(250414130, '', 'KVSRCode', '', 'KVSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250414131, '', 'KVSR', '', 'KVSR', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KVSR') ;

CALL ImportField(250414132, '', 'KVRCode', '', 'KVR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250414133, '', 'KVR', '', 'KVR', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KVR') ;

CALL ImportField(250414134, '', 'KFSR', '', 'KFSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KFSR') ;

CALL ImportField(250414135, '', 'KESR', '', 'KESRKey', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250414136, '', 'KCSRCode', '', 'KCSR', 2, 2504, 4, 0, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250414137, '', 'KCSR', '', 'KCSR', 2, 2504, 4, 1, '', 0, null, 0, 1, 'KCSR') ;

CALL ImportField(250414138, '', 'FinYear', '', 'FinYear', 2, 2504, 4, 0, '', 0, null, 0, 1, 'FinYear') ;

CALL ImportField(250414139, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 2, 2504, 4, 0, '', 0, 22390, 0, 1, 'TargetClsCode') ;

CALL ImportField(250414140, ' ', 'TargetCls', '  ()', 'TargetCls', 2, 2504, 4, 1, '', 0, 40887, 0, 1, 'TargetCls') ;

CALL ImportField(250414141, '()', 'KESRCode', '()', '()', 2, 2504, 4, 0, '', 0, 43607, 0, 1, 'KESR') ;

CALL ImportField(250415010, '', 'KESR', '', 'KESRKey', 2, 2504, 5, 1, '', 0, null, 0, 1, 'KESRKey') ;

CALL ImportField(250415136, '', 'AUTO_AUTORIZATION', '', ' ', 2, 2504, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250415137, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 2504, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250415138, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 2504, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250415139, '  ()', 'CREATEDATE', '  ()', ' ', 2, 2504, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250415140, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 2504, 5, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(250416145, 'ORGREF', 'ORGREF', '   ', 'ORGREF', 2, 2504, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250416146, 'ACCREF', 'ACCREF', '    ', 'ACCREF', 2, 2504, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(250416147, '  ', 'STOREDPROPS', '  ', 'STOREDPROPS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416148, ' ', 'INN', ' ', 'INN', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416149, ' ', 'INN20', ' ', 'INN20', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416150, ' ', 'NAME', ' ', 'NAME', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416151, ' ', 'STATUS', ' ', 'STATUS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416152, ' ', 'COUNTRY', ' ', 'COUNTRY', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416153, ' ', 'ADDRESS', ' ', 'ADDRESS', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416154, ' ', 'PHONE', ' ', 'PHONE', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416155, ' ', 'ACCNAME', ' ', 'ACCNAME', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(250416156, ' (+)', 'Executer', ' (+)', 'Executer', 2, 2504, 6, 0, '', 0, null, 0, 0, '') ;

--       , (1)
CALL ImportField(280111016, ' ', 'BuhOperationCLS', ' ', ' ', 1, 2801, 1, 0, '', 0, 17200, 0, 0, '') ;

--   , (1)
CALL ImportField(280210008, ' ', 'BuhOperationCLS', ' ', ' ', 1, 2802, 0, 0, '', 0, 17297, 0, 0, '') ;

--    , +(2)
CALL ImportField(300110106, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110107, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110108, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110109, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300110110, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3001, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300111008, '', 'SubKESR', '', 'SubKESRKey', 2, 3001, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(300111038, '', 'KVSR', '', 'KVSR', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111039, '', 'KVR', '', 'KVR', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111040, '', 'KFSR', '', 'KFSR', 2, 3001, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(300111041, '', 'KESR', '', 'KESRKey', 2, 3001, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(300111042, '', 'KCSR', '', 'KCSR', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111088, '', 'KVSRCode', '', 'KVSR', 2, 3001, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(300111089, '', 'KVRCode', '', 'KVR', 2, 3001, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(300111090, '', 'KCSRCode', '', 'KCSR', 2, 3001, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(300111093, ' ', 'BudAllocationClsCode', '  ', 'BudAllocationClsCode', 2, 3001, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(300111102, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111103, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111104, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3001, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(300111105, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3001, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(300111111, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111112, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111113, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111114, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111115, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300111116, '  ()', 'BudAllocationCls', '', 'BudAllocationCls', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111117, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3001, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300111118, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3001, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(300111119, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 3001, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300111151, '()', 'KESRCode', '()', 'KESR', 2, 3001, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(300111152, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3001, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(300112116, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300112117, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300112118, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300112119, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300112120, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300113121, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 3, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300113122, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300113123, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300113124, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300113125, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300114126, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300114127, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300114128, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300114129, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300114130, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 4, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300115131, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300115132, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300115133, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300115134, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300115135, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 5, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300116136, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300116137, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300116138, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300116139, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300116140, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 6, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300117141, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300117142, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300117143, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300117144, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300117145, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 7, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300118146, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3001, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300118147, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3001, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300118148, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3001, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300118149, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3001, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300118150, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3001, 8, 1, '', 0, null, 0, 1, '') ;

--  , +(2)
CALL ImportField(300310050, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3003, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300310051, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3003, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300310052, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3003, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300310053, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3003, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300310054, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3003, 0, 1, '', 0, null, 0, 0, '') ;

-- -, +(2)
CALL ImportField(300510020, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3005, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300510021, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3005, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300510022, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3005, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300510023, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3005, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300510024, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3005, 0, 1, '', 0, null, 0, 0, '') ;

--  -, +(2)
CALL ImportField(300610066, ' ', 'AdjustmentNumber', '', 'AdjustmentNumber', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610069, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610070, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610071, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3006, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300610072, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300610073, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3006, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611008, '', 'KESR', '', 'KESRKey', 2, 3006, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(300611009, '', 'KCSR', '', 'KCSRKey', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611036, '', 'KVSR', '', 'KVSR', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611037, '', 'KFSR', '', 'KFSR', 2, 3006, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(300611038, '', 'KVR', '', 'KVR', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611041, '', 'KCSRCode', '', 'KCSR', 2, 3006, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(300611042, '', 'KVSRCode', '', 'KVSR', 2, 3006, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(300611043, '', 'KVRCode', '', 'KVR', 2, 3006, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(300611051, '', 'subkesr', '', 'SubKESRKey', 2, 3006, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(300611060, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 3006, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(300611065, '  ()', 'BudAllocationCls', '', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611066, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3006, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(300611067, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3006, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(300611068, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3006, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(300611074, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611075, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611076, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611077, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 3006, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300611078, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611079, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611080, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3006, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300611084, '()', 'KESRCode', '()', 'KESR', 2, 3006, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(300611085, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3006, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(300612079, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3006, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300612080, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3006, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300612081, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3006, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(300612082, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3006, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(300612083, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3006, 2, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(301010032, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3010, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301010033, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3010, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301010034, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3010, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(301010035, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3010, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301010036, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3010, 0, 1, '', 0, null, 0, 0, '') ;

--   , +(2)
CALL ImportField(301110052, ' ', 'AdjustmentNumber', '', 'AdjustmentNumber', 2, 3011, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301110053, ' ', 'SaleType', '', ' ', 2, 3011, 0, 0, '', 0, 21287, 0, 0, '') ;

CALL ImportField(301110054, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3011, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301110055, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3011, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301110056, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 3011, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(301110057, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3011, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301110058, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3011, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111002, '', 'KESR', '', 'KESRKey', 2, 3011, 1, 1, '', 0, 21038, 0, 0, '') ;

CALL ImportField(301111003, '', 'KCSR', '', 'KCSRKey', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111025, '', 'KVSR', '', 'KVSR', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111026, '', 'KFSR', '', 'KFSR', 2, 3011, 1, 0, '', 0, 21034, 0, 0, '') ;

CALL ImportField(301111027, '', 'KVR', '', 'KVR', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111029, '', 'KCSRCode', '', 'KCSR', 2, 3011, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(301111030, '', 'KVSRCode', '', 'KVSR', 2, 3011, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(301111031, '', 'KVRCode', '', 'KVR', 2, 3011, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(301111038, '', 'subkesr', '', 'SubKESRKey', 2, 3011, 1, 1, '', 0, 21039, 0, 0, '') ;

CALL ImportField(301111047, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(301111052, ' ', 'TargetClsCode', ' ', 'TargetCls', 2, 3011, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(301111053, ' ', 'TargetCls', '  ()', 'TargetClsKey', 2, 3011, 1, 1, '', 0, 40892, 0, 0, '') ;

CALL ImportField(301111059, '', 'AUTO_AUTORIZATION', '', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111060, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111061, '()', 'CREATERUSER', '()', 'CREATERUSER_Det', 2, 3011, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(301111062, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111063, '  ()', 'CREATEDATE', '  ()', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111064, '  ()', 'BudAllocationCls', '', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111065, '   ()', 'PayPromiseCLS', '', 'PayPromiseCLS', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111066, '  ()', 'SubsidyCls', ' ()', 'SubsidyCls', 2, 3011, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(301111067, '   ()', 'TransfertCls', '    ', 'TransfertCls', 2, 3011, 1, 1, '', 0, 29965, 0, 0, '') ;

CALL ImportField(301111068, '()', 'KESRCode', '()', 'KESR', 2, 3011, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(301111069, '()', 'SubKESRCode', '()', 'SubKESR', 2, 3011, 1, 0, '', 0, 43610, 0, 0, '') ;

--  , (1)
CALL ImportField(440110001, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 4401, 0, 0, '', 0, 21688, 0, 1, '') ;

CALL ImportField(440110003, ' ', 'BUDGETREF', ' ', 'BudgetRef', 1, 4401, 0, 1, '', 0, 21683, 0, 1, '') ;

CALL ImportField(440110004, ' ', 'CRYPTOSTATUS', ' ', 'CryptoStatus', 1, 4401, 0, 1, '', 0, 21700, 0, 1, '') ;

CALL ImportField(440110005, '  \ ', 'DFACCOUNT', '  \ ', 'DFAccount', 1, 4401, 0, 1, '', 0, 21687, 0, 1, '') ;

CALL ImportField(440110006, ' ', 'DocNumber', ' ', 'DocNumber', 1, 4401, 0, 0, '', 0, 21684, 0, 1, '') ;

CALL ImportField(440110007, ' ', 'DOCSTATEREF', ' ', 'DocStateRef', 1, 4401, 0, 1, '', 0, 21701, 0, 1, '') ;

CALL ImportField(440110008, ' ', 'DOCUMENTFORMAT', ' ', 'DocumentFormat', 1, 4401, 0, 1, '', 0, 21692, 0, 1, '') ;

CALL ImportField(440110009, ' ', 'FACIALACCCLS', ' ', 'FacialAccCLS', 1, 4401, 0, 1, '', 0, 21691, 0, 1, '') ;

CALL ImportField(440110010, ' ', 'ID', ' ', 'ID', 1, 4401, 0, 1, '', 0, 21682, 0, 1, '') ;

CALL ImportField(440110012, ' ', 'InputDate', ' ', 'InputDate', 1, 4401, 0, 0, '', 0, 21686, 0, 1, '') ;

CALL ImportField(440110016, '', 'Note', '', 'Note', 1, 4401, 0, 0, '', 0, 21695, 0, 1, '') ;

CALL ImportField(440110017, '    ', 'NotifyNumber', '    ', 'NotifyNumber', 1, 4401, 0, 0, '', 0, 21685, 0, 1, '') ;

CALL ImportField(440110018, '', 'NotifyType', ' ', 'NotifyType', 1, 4401, 0, 1, '', 0, 21694, 0, 1, '') ;

CALL ImportField(440110019, ' ', 'PROGINDEX', ' ', 'ProgIndex', 1, 4401, 0, 1, '', 0, 21690, 0, 1, '') ;

CALL ImportField(440110020, '  ', 'SENDERID', '  ', 'SenderID', 1, 4401, 0, 1, '', 0, 21698, 0, 1, '') ;

CALL ImportField(440110021, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 4401, 0, 1, '', 0, 21699, 0, 1, '') ;

CALL ImportField(440110022, ' ', 'SpecialNote', ' ', 'SpecialNote', 1, 4401, 0, 1, '', 0, 21697, 0, 1, '') ;

CALL ImportField(440110039, ' ', 'RejectCLS', ' ', 'REJECTCLS', 1, 4401, 0, 0, '', 0, 21707, 0, 1, '') ;

CALL ImportField(440110040, '  ()', 'RejectCause', '  ()', 'REJECTCAUSE', 1, 4401, 0, 0, '', 0, 21708, 0, 1, '') ;

CALL ImportField(440110041, '()', 'CREATERUSER', '()', 'CreaterUser', 1, 4401, 0, 1, '', 0, 21703, 0, 1, '') ;

CALL ImportField(440110042, '()', 'UPDATERUSER', '()', 'UpdaterUser', 1, 4401, 0, 1, '', 0, 21705, 0, 1, '') ;

CALL ImportField(440110043, ' ()', 'UPDATEDATE', ' ()', 'UpdateDate', 1, 4401, 0, 1, '', 0, 21706, 0, 1, '') ;

CALL ImportField(440110044, ' ()', 'CREATEDATE', ' ()', 'CreateDate', 1, 4401, 0, 1, '', 0, 21704, 0, 1, '') ;

CALL ImportField(440110045, '', 'Org_Ref', 'Org_Ref', '', 1, 4401, 0, 1, '', 0, 21693, 0, 1, '') ;

CALL ImportField(440110046, '    ', 'DATE_PP', '    ', 'DATE_PP', 1, 4401, 0, 1, '', 0, 25050, 0, 1, '') ;

CALL ImportField(440110047, '(   )', 'DATE_UTV_BA', '(   )', 'DATE_UTV_BA', 1, 4401, 0, 0, '', 0, 25051, 0, 1, '') ;

CALL ImportField(440110048, '(   )', 'DATE_UTV_LBO', '(   )', 'DATE_UTV_LBO', 1, 4401, 0, 0, '', 0, 25052, 0, 1, '') ;

CALL ImportField(440110049, '(   )', 'DATE_UTV_POF', '(   )', 'DATE_UTV_POF', 1, 4401, 0, 0, '', 0, 25053, 0, 1, '') ;

CALL ImportField(440110050, ' (   )', 'DATE_UTV_PP', ' (   )', 'DATE_UTV_PP', 1, 4401, 0, 0, '', 0, 25054, 0, 1, '') ;

CALL ImportField(440110051, '    ()', 'Date_UTV_Reestr', '    ()', 'DATE_UTV_Reestr', 1, 4401, 0, 1, '', 0, 25055, 0, 1, '') ;

CALL ImportField(440110052, '    ', 'NOM_PP', '    ', 'NOM_PP', 1, 4401, 0, 1, '', 0, 25057, 0, 1, '') ;

CALL ImportField(440110053, ' ()', 'ReestrDate', ' ()', 'REESTRDATE', 1, 4401, 0, 1, '', 0, 25058, 0, 1, '') ;

CALL ImportField(440110054, ' ()', 'ReestrNumber', ' ()', 'REESTRNUMBER', 1, 4401, 0, 1, '', 0, 25059, 0, 1, '') ;

CALL ImportField(440110055, '  ', 'SpecialNoteCode', '  ', 'SpecialNoteCode', 1, 4401, 0, 0, '', 0, 25060, 0, 1, '') ;

CALL ImportField(440110056, '  ', 'TIP_RR', '  ', 'TIP_RR', 1, 4401, 0, 0, '', 0, 25062, 0, 1, '') ;

CALL ImportField(440110061, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 4401, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440111023, ' ', 'ActivityKind', ' ', 'ACTIVITYKIND', 1, 4401, 1, 1, '', 0, 21718, 0, 1, '') ;

CALL ImportField(440111024, ' ', 'ID', ' ', 'ID', 1, 4401, 1, 1, '', 0, 21710, 0, 1, '') ;

CALL ImportField(440111025, '', 'KCSR', '', 'KCSR', 1, 4401, 1, 1, '', 0, 21713, 0, 1, '') ;

CALL ImportField(440111026, '', 'KESR', '', 'KESRKey', 1, 4401, 1, 1, '', 0, 21716, 0, 1, '') ;

CALL ImportField(440111027, '()', 'KFSR', '', 'KFSR', 1, 4401, 1, 1, '', 0, 21714, 0, 1, '') ;

CALL ImportField(440111028, '', 'KVR', '', 'KVR', 1, 4401, 1, 1, '', 0, 21715, 0, 1, '') ;

CALL ImportField(440111029, '', 'KVSR', '', 'KVSR', 1, 4401, 1, 1, '', 0, 21712, 0, 1, '') ;

CALL ImportField(440111030, '', 'NOTE', '', 'Note', 1, 4401, 1, 0, '', 0, 21721, 0, 1, '') ;

CALL ImportField(440111031, '  ', 'SENDERID', '  ', 'SenderID', 1, 4401, 1, 1, '', 0, 21729, 0, 1, '') ;

CALL ImportField(440111032, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 4401, 1, 1, '', 0, 21730, 0, 1, '') ;

CALL ImportField(440111035, '  ', 'SUMMAFIN', ' ', 'SUMMAFIN', 1, 4401, 1, 1, '', 0, 21724, 0, 1, '') ;

CALL ImportField(440111038, ' ', 'TargetClsCode', ' ', 'TargetCLS', 1, 4401, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(440111046, '()', 'CREATERUSER', '()', 'CreaterUser', 1, 4401, 1, 1, '', 0, 21732, 0, 1, '') ;

CALL ImportField(440111047, '()', 'UPDATERUSER', '()', 'UpdaterUser', 1, 4401, 1, 1, '', 0, 21734, 0, 1, '') ;

CALL ImportField(440111048, ' ()', 'UPDATEDATE', ' ()', 'UpdateDate', 1, 4401, 1, 1, '', 0, 21735, 0, 1, '') ;

CALL ImportField(440111049, ' ()', 'CREATEDATE', ' ()', 'CreateDate', 1, 4401, 1, 1, '', 0, 21733, 0, 1, '') ;

CALL ImportField(440111050, '  ()', 'IFS', 'IFS', 'IFS', 1, 4401, 1, 1, '', 0, 21717, 0, 1, '') ;

CALL ImportField(440111051, ' ', 'RECORDINDEX', 'RECORDINDEX', 'RecordIndex', 1, 4401, 1, 1, '', 0, 21711, 0, 1, '') ;

CALL ImportField(440111053, '  , ', 'BA_LBO_FLAG', '  , ', 'BA_LBO_FLAG', 1, 4401, 1, 1, '_', 0, 25357, 0, 1, '_') ;

CALL ImportField(440111054, ' ', 'BUHOPERATIONCLS', ' ', ' ', 1, 4401, 1, 0, '', 0, 25358, 0, 0, '') ;

CALL ImportField(440111055, '    ', 'SummaYear1', '    ', 'SummaYear1', 1, 4401, 1, 1, '', 0, 25365, 0, 1, '') ;

CALL ImportField(440111056, '    ', 'SummaYear2', '    ', 'SummaYear2', 1, 4401, 1, 1, '', 0, 25366, 0, 1, '') ;

CALL ImportField(440111057, '    ', 'SummaYear3', '    ', 'SummaYear3', 1, 4401, 1, 1, '', 0, 25367, 0, 1, '') ;

CALL ImportField(440111062, '', 'SubKESR', '', 'SubKESRKey', 1, 4401, 1, 1, '', 0, 25364, 0, 1, '') ;

CALL ImportField(440111065, ' ', 'BudAllocationCLS', '', ' ', 1, 4401, 1, 1, '', 0, 27930, 0, 0, '') ;

CALL ImportField(440111072, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 4401, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440111073, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 4401, 1, 1, '', 0, 21719, 0, 1, '') ;

CALL ImportField(440111077, '()', 'KESRCode', '()', 'KESR', 1, 4401, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(440111080, '()', 'SubKESRCode', '()', 'SubKESR', 1, 4401, 1, 0, '', 0, 43610, 0, 1, '') ;

--  ,, (1)
CALL ImportField(440310001, ' ', 'ACCEPTDATE', ' ', 'AcceptDate', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310003, ' ', 'BUDGETREF', ' ', 'BudgetRef', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310004, ' ', 'CRYPTOSTATUS', ' ', 'CRYPTOSTATUS', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310005, '  \ ', 'DFACCOUNT', '  \ ', 'DFAccount', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310006, ' ', 'DocNumber', ' ', 'DocNumber', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310007, ' ', 'DOCSTATEREF', ' ', 'DocStateRef', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310008, ' ', 'DOCUMENTFORMAT', ' ', 'DocumentFormat', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310009, ' ', 'FACIALACCCLS', ' ', 'FacialAccCls', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310010, ' ', 'ID', ' ', 'ID', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310012, ' ', 'InputDate', ' ', 'InputDate', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310016, '', 'Note', '', 'Note', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310017, '    ', 'NotifyNumber', '    ', 'NotifyNumber', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310018, '', 'NotifyType', ' ', 'NotifyType', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310019, ' ', 'PROGINDEX', ' ', 'ProgIndex', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310020, '  ', 'SENDERID', '  ', 'SenderID', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310021, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310022, ' ', 'SpecialNote', ' ', 'SpecialNote', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310043, '', 'Org_Ref', 'Org_Ref', 'OrgCity', 1, 4403, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440310044, ' ', 'RejectCLS', ' ', 'RejectCls', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310045, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 4403, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440310057, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 4403, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440311023, ' ', 'ActivityKind', ' ', 'ACTIVITYKIND', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311024, ' ', 'ID', ' ', 'ID', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311025, '', 'KCSR', '', 'KCSRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311026, '', 'KESR', '', 'KESRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311027, '()', 'KFSR', '', 'KFSR', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311028, '', 'KVR', '', 'KVRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311029, '', 'KVSR', '', 'KVSRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311030, '', 'NOTE', '', 'Note', 1, 4403, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(440311031, '  ', 'SENDERID', '  ', 'SenderID', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311032, '  ', 'SENDERRECORDID', '  ', 'SenderRecordID', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311038, ' ', 'TargetClsCode', ' ', 'TargetCLS', 1, 4403, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(440311050, '  ()', 'IFS', 'IFS', 'IFS', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311052, ' ', 'CLSTYPE', ' ', 'ClsType', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311054, ' ', 'BUHOPERATIONCLS', ' ', ' ', 1, 4403, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(440311062, '', 'SubKESR', '', 'SubKESRKey', 1, 4403, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(440311069, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 4403, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(440311070, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 4403, 1, 1, '', 0, 21719, 0, 1, '') ;

CALL ImportField(440311071, '()', 'KESRCode', '()', 'KESR', 1, 4403, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(440311072, '()', 'SubKESRCode', '()', 'SubKESR', 1, 4403, 1, 0, '', 0, 43610, 0, 1, '') ;

--   , (1)
CALL ImportField(510110001, ' ', 'ID', '  ', 'ID', 1, 5101, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(510111001, ' ', 'ID', '  ', 'ID', 1, 5101, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(510111002, '  ', 'RecordIndex', '  ', 'RecordIndex', 1, 5101, 1, 0, '', 0, null, 0, 0, '') ;

--  / , (1)
CALL ImportField(520110001, ' ', 'id', ' ', 'id', 1, 5201, 0, 1, '', 0, 25404, 0, 1, '') ;

CALL ImportField(520110002, '   ', 'ISSUEDATE', '   ', 'ISSUEDATE', 1, 5201, 0, 0, '', 0, 25405, 0, 1, '') ;

CALL ImportField(520110004, ' ( )', 'LAWDEPARTMENTDATE', ' ( )', 'LAWDEPARTMENTDATE', 1, 5201, 0, 0, '', 0, 25407, 0, 1, '') ;

CALL ImportField(520110005, ' ( )', 'LAWDEPARTMENTNUMBER', ' ( )', 'LAWDEPARTMENTNUMBER', 1, 5201, 0, 0, '', 0, 25408, 0, 1, '') ;

CALL ImportField(520110008, '  ', 'NAMEJUDICIALAGENCY', '  ', 'NAMEJUDICIALAGENCY', 1, 5201, 0, 0, '', 0, 25411, 0, 1, '') ;

CALL ImportField(520110009, '  ', 'NAMEJUDICIALDECISION', '  ', 'NAMEJUDICIALDECISION', 1, 5201, 0, 0, '', 0, 25412, 0, 1, '') ;

CALL ImportField(520110010, '', 'NOTE', '', 'NOTE', 1, 5201, 0, 0, '', 0, 25413, 0, 1, '') ;

CALL ImportField(520110011, '  ', 'UNIQUENUMBER', '    ', 'UNIQUENUMBER', 1, 5201, 0, 0, '', 0, 31836, 0, 1, '') ;

CALL ImportField(520110012, '  ( )', 'PRESENTDATE', '(  )', 'PRESENTDATE', 1, 5201, 0, 0, '', 0, 31834, 0, 1, '') ;

CALL ImportField(520110013, ' ', 'NUMBERDOSSIER', ' ', 'NUMBERDOSSIER', 1, 5201, 0, 0, '', 0, 25416, 0, 1, '') ;

CALL ImportField(520110015, ' ', 'REJECTCAUSE', '  ()', 'REJECTCAUSE', 1, 5201, 0, 0, '', 0, 25419, 0, 1, '') ;

CALL ImportField(520110016, ' ', 'REJECT_CLS', ' ', 'RejectCls', 1, 5201, 0, 1, '', 0, 25418, 0, 1, '') ;

CALL ImportField(520110017, '  ', 'SHEETSCOUNT', '  ', 'SHEETSCOUNT', 1, 5201, 0, 0, '', 0, 31835, 0, 1, '') ;

CALL ImportField(520110018, '   ', 'DELIVERYDATE', '   ', 'DELIVERYDATE', 1, 5201, 0, 0, '', 0, 31832, 0, 1, '') ;

CALL ImportField(520110019, '-    ', 'COURTSHEETSCOUNT', '    ', 'COURTSHEETSCOUNT', 1, 5201, 0, 0, '', 0, 31830, 0, 1, '') ;

CALL ImportField(520110021, '      ', 'STARTDATE', '      ', 'STARTDATE', 1, 5201, 0, 1, '', 0, 25427, 0, 1, '') ;

CALL ImportField(520110026, '', 'BUDGETREF', '', 'BudgetRef', 1, 5201, 0, 0, '', 0, 25391, 0, 1, '') ;

CALL ImportField(520110029, '  ', 'DOCNUMBER', '  ', 'DOCNUMBER', 1, 5201, 0, 0, '', 0, 25398, 0, 1, '') ;

CALL ImportField(520110030, '', 'DOCSTATEREF', '', 'DOCSTATEREF', 1, 5201, 0, 1, '', 0, 25399, 0, 1, '') ;

CALL ImportField(520110032, '', 'ISINVALID', '   ,          ', 'ISINVALID', 1, 5201, 0, 0, '', 0, 31833, 0, 1, '') ;

CALL ImportField(520110033, '/  ', 'FACIALACC_CLS', '/  ', 'FACIALACC_CLS', 1, 5201, 0, 0, '', 0, 25403, 0, 1, '') ;

CALL ImportField(520110034, '', 'WRITEXECUTIONTOTALSUMMA', '', 'WRITEXECUTIONTOTALSUMMA', 1, 5201, 0, 0, '', 0, 25432, 0, 1, '') ;

CALL ImportField(520110043, '  ', 'DebtorName', '', 'DebtorName', 1, 5201, 0, 0, '', 0, 31831, 0, 0, '') ;

CALL ImportField(520110048, '  ', 'SENDERID', '', 'SenderID', 1, 5201, 0, 0, '', 0, 25425, 0, 1, '') ;

CALL ImportField(520110049, '    ', 'ENDDATE', '     ', 'ENDDATE', 1, 5201, 0, 0, '', 0, 25402, 0, 1, '') ;

CALL ImportField(520110051, '  ', 'CASECATEGORY', '  ', 'CASECATEGORY', 1, 5201, 0, 0, '', 0, 31829, 0, 1, '') ;

CALL ImportField(520110052, ' . ', 'WritType', '  : 0 - ; 1 - /; 2 -   ', 'WritType', 1, 5201, 0, 0, '', 0, 31838, 0, 1, '') ;

CALL ImportField(520110053, '', 'WritPeriod', '   : 0 - ; 1 - ; 2 - ', 'WritPeriod', 1, 5201, 0, 0, '', 0, 31837, 0, 1, '') ;

CALL ImportField(520110054, ' ', 'InnerNumber', '', 'InnerNumber', 1, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110055, '  -', 'NameJudicialAgencyRef', '', 'NameJudicialAgencyRef', 1, 5201, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520110056, '  ', 'JudicialDecisionDate', '', 'JudicialDecisionDate', 1, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110057, '  ', 'NumberPostNotice', '', 'NumberPostNotice', 1, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110058, '  ', 'DatePostNotice', '', 'DatePostNotice', 1, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110059, ' ', 'NumberDepartmentCB', '', 'NumberDepartmentCB', 1, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110061, ' ', 'CompletionDate', '   ', 'CompletionDate', 1, 5201, 0, 0, '', 0, 38743, 0, 1, '') ;

CALL ImportField(520111001, '.  ', 'BudgetPromise', '.  ', 'BudgetPromise', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111003, '', 'DIRECTIONCLSCode', '', 'DIRECTIONCLS', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111004, ' ', 'DOCTYPE', ' ', 'DOCTYPE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111005, '  ', 'FACIALACC_CLS', '  ', 'FACIALACC_CLS', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111006, '', 'FACTCode', '', 'FACT', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111007, ' ', 'FINSOURCE', ' ', 'FINSOURCE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111008, ' . ', 'FINTYPECode', ' . ', 'FINTYPE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111009, '', 'KCSR', '', 'KCSR', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111010, '()', 'KCSRCode', '()', 'KCSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111011, '', 'KESR', '', 'KESRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111012, '()', 'KFSR', '()', 'KFSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111013, '', 'KVR', '', 'KVR', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111014, '()', 'KVRCode', '()', 'KVR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111015, '', 'KVSR', '', 'KVSR', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111016, '()', 'KVSRCode', '()', 'KVSR', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111017, ' ', 'MEANSTYPE', ' ', 'MEANSTYPE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111018, ' ', 'PROGINDEX', ' ', 'PROGINDEX', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111019, ' ', 'PROMISE', ' ', 'PROMISE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111020, ' ', 'RECORDINDEX', ' ', 'RECORDINDEX', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111021, ' ', 'REGIONCLS', '', 'REGIONCLS', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111022, '', 'SUBKESR', '', 'SUBKESRKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111023, '   ', 'WRITEXECUTIONSUMMA', '   ', 'WRITEXECUTIONSUMMA', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111030, '( )', 'MONTH01', '     ', 'MONTH01', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111031, '( )', 'MONTH02', '     ', 'MONTH02', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111032, '( )', 'MONTH03', '     ', 'MONTH03', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111033, '( )', 'MONTH04', '     ', 'MONTH04', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111034, '( )', 'MONTH05', '     ', 'MONTH05', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111035, '( )', 'MONTH06', '     ', 'MONTH06', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111036, '( )', 'MONTH07', '     ', 'MONTH07', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111037, '( )', 'MONTH08', '     ', 'MONTH08', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111038, '( )', 'MONTH09', '     ', 'MONTH09', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111039, '( )', 'MONTH10', '     ', 'MONTH10', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111040, '( )', 'MONTH11', '     ', 'MONTH11', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111041, '( )', 'MONTH12', '     ', 'MONTH12', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111042, ' 1( )', 'QUARTER1', '      ', 'QUARTER1', 1, 5201, 1, 0, '1', 0, null, 0, 1, '1') ;

CALL ImportField(520111043, ' 2( )', 'QUARTER2', '      ', 'QUARTER2', 1, 5201, 1, 0, '2', 0, null, 0, 1, '2') ;

CALL ImportField(520111044, ' 3( )', 'QUARTER3', '      ', 'QUARTER3', 1, 5201, 1, 0, '3', 0, null, 0, 1, '3') ;

CALL ImportField(520111045, ' 4( )', 'QUARTER4', '      ', 'QUARTER4', 1, 5201, 1, 0, '4', 0, null, 0, 1, '4') ;

CALL ImportField(520111046, '    ( )', 'MONTHLYDATE', '    ', 'MONTHLYDATE', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111047, '    ( )', 'QUARTERLYMONTHDAY', '     ', 'QUARTERLYMONTHDAY', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111048, '    ( )', 'QUARTERLYMONTHNUMBER', '      ', 'QUARTERLYMONTHNUMBER', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111050, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111051, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111052, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111053, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111054, ' ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111055, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111056, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111057, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111058, ' ', 'id', ' ', 'id', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111059, ' ()', 'DIRECTIONCLS', '', 'DIRECTIONCLSKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111060, ' ()', 'FACT', '', 'FACTKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111061, ' . ()', 'FINTYPE', ' . ()', 'FINTYPEKey', 1, 5201, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111064, ' ', 'kd', ' ', 'KD', 1, 5201, 1, 1, '', 0, 38500, 0, 1, '') ;

CALL ImportField(520111070, ' ', 'KDValue', '', 'KDValue', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111071, ' ', 'ClsType', ' ', 'ClsType', 1, 5201, 1, 0, '', 0, 38499, 0, 1, '') ;

CALL ImportField(520111072, ' ', 'Note', '  ', 'Note', 1, 5201, 1, 0, '', 0, 38765, 0, 1, '') ;

CALL ImportField(520111073, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111074, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 5201, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(520111075, ' ', 'IFS', ' ', 'IFS', 1, 5201, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520111076, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111077, '()', 'IFS_KVSRCode', '()', ' ', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111078, '()', 'IFSAGCode', '()', ' ', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111080, ' ', 'TargetClsCode', ' ', 'TargetCLS', 1, 5201, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(520111081, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 5201, 1, 1, '', 0, 40888, 0, 1, '') ;

CALL ImportField(520111082, '   (.)', 'CaseCategory', '   (.)', 'CaseCategoryDet', 1, 5201, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(520111084, '()', 'KESRCode', '()', 'KESR', 1, 5201, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(520111086, '()', 'SubKESRCode', '()', 'SUBKESR', 1, 5201, 1, 0, '', 0, 43610, 0, 1, '') ;

CALL ImportField(520112001, ' ', 'id', ' ', 'id', 1, 5201, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520112002, '  ()', 'NOTIFYCLS', ' ', 'NOTIFYCLS', 1, 5201, 2, 0, '', 0, 31865, 0, 1, '') ;

CALL ImportField(520112003, '', 'DESCRIPTION', '', 'DESCRIPTION', 1, 5201, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520112004, '', 'NOTE', '', 'NOTE', 1, 5201, 2, 0, '', 0, 31864, 0, 1, '') ;

CALL ImportField(520112005, ' ', 'RECORDINDEX', '  ', 'RECORDINDEX', 1, 5201, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520112006, '', 'NOTIFYNUMBER', ' ', 'NOTIFYNUMBER', 1, 5201, 2, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520112007, '', 'NOTIFYDATE', ' ', 'NOTIFYDATE', 1, 5201, 2, 0, '', 0, null, 0, 1, '') ;

--  / , +(2)
CALL ImportField(520110006, '    ', 'LEVIERACC_REF', '   ', 'LEVIERACC_REF', 2, 5201, 0, 1, '', 0, 25409, 0, 0, '') ;

CALL ImportField(520110007, '   ', 'LEVIERORG_REF', '   ', 'LEVIERORG_REF', 2, 5201, 0, 1, '', 0, 25410, 0, 0, '') ;

CALL ImportField(520110039, '()', 'LevierInn20', '()', 'LevierOrgKPP', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110044, '()', 'LevierAcc', '()', 'LevierAccountName', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110045, '()', 'LevierInn', '()', 'LevierOrgINN', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110046, '()', 'LevierName', '', 'LevierName', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110047, '', 'LevierParent', ' ', ' ', 2, 5201, 0, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(520110062, '.  ', 'StoredContent', '.  ', 'StoredContent', 2, 5201, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(520110064, '  ', '', '  ', 'LevierBankBIK', 2, 5201, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(520110065, '.  ', ' ', '.  ', 'LevierBankCor', 2, 5201, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(520110066, '  ', ' ', '  ', 'LevierBankName', 2, 5201, 0, 1, '', 1, null, 30210153, 1, '') ;

CALL ImportField(520110067, ' ', '', ' ', 'LevierFCAccount', 2, 5201, 0, 1, '', 1, null, 0, 1, '') ;

CALL ImportField(520110068, ' -', '', ' -', 'LevierOrgCity', 2, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520110069, ' ', '', ' ', 'LevierFKFacialCode', 2, 5201, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(520111079, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 2, 5201, 1, 0, '', 0, null, 0, 2, '') ;

--    , (1)
CALL ImportField(540210001, ' ', 'ID', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540210002, ' ', 'FormDate', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540210003, ' ', 'ExportDate', '', ' ', 1, 5402, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211001, '  ', 'RecordIndex', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211002, ' ', 'ID', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211003, ' ', 'PacketNumber', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211004, ' ', 'PageTab', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211005, ' ', 'PageID', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211006, ' ', 'WasError', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(540211007, '  ', 'NoData', '', ' ', 1, 5402, 1, 0, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(550110003, '', 'BudgetRef', '', 'BudgetRef', 1, 5501, 0, 0, '', 0, 22846, 0, 1, '') ;

CALL ImportField(550110004, ' ', 'InputDate', ' ', 'InputDate', 1, 5501, 0, 0, '', 0, 22848, 0, 1, '') ;

CALL ImportField(550110005, ' ', 'AcceptDate', ' ', 'AcceptDate', 1, 5501, 0, 0, '', 0, 22849, 0, 1, '') ;

CALL ImportField(550110006, ' ', 'Summa', ' ', 'summa', 1, 5501, 0, 0, '', 0, 22850, 0, 1, '') ;

CALL ImportField(550110007, '  ', 'OriginalProgindex', '  ', 'OriginalProgIndex', 1, 5501, 0, 1, '', 0, 22861, 0, 1, '') ;

CALL ImportField(550110008, ' ', 'OriginalAttr', ' ', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110009, '( )', 'OriginalNumber', '( )', 'OriginalNumber', 1, 5501, 0, 0, '', 0, 22857, 0, 1, '') ;

CALL ImportField(550110010, '( )', 'OriginalSumma', '( )', 'OriginalSumma', 1, 5501, 0, 0, '', 0, 22859, 0, 1, '') ;

CALL ImportField(550110011, '( )', 'OriginalDate', '( )', 'OriginalDate', 1, 5501, 0, 0, '', 0, 22858, 0, 1, '') ;

CALL ImportField(550110012, ' ( )', 'OriginalNote', ' ( )', 'OriginalNote', 1, 5501, 0, 0, '', 0, 22860, 0, 1, '') ;

CALL ImportField(550110013, '( )', 'OriginalPayerParent', '( )', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110014, ' ( \)', 'OriginalPayerhandBook', ' ()', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110015, '( \)', 'OriginalPayerAcc', '()', 'OriginalPayerAcc', 1, 5501, 0, 0, '', 0, 22864, 0, 1, '') ;

CALL ImportField(550110016, '( \)', 'OriginalPayerOrgName', '()', 'OriginalPayerOrgName', 1, 5501, 0, 0, '', 0, 22865, 0, 1, '') ;

CALL ImportField(550110017, '( \)', 'OriginalPayerOrgInn', '()', 'OriginalPayerOrgINN', 1, 5501, 0, 0, '', 0, 22902, 0, 1, '') ;

CALL ImportField(550110018, '( \)', 'OriginalPayerOrgInn20', '()', 'OriginalPayerOrgINN20', 1, 5501, 0, 0, '', 0, 22866, 0, 1, '') ;

CALL ImportField(550110019, '', 'OriginalPayerBankName', '()', 'OriginalPayerBankName', 1, 5501, 0, 1, '', 0, 22867, 0, 1, '') ;

CALL ImportField(550110020, '', 'OriginalPayerBankMfo', '()', 'OriginalPayerBankMFO', 1, 5501, 0, 1, '', 0, 22868, 0, 1, '') ;

CALL ImportField(550110021, '. ', 'OriginalPayerBankCor', '. ()', 'OriginalPayerBankCor', 1, 5501, 0, 1, '', 0, 22869, 0, 1, '') ;

CALL ImportField(550110022, '_( \)', 'OriginalPayerFKOrgINN', '_()', 'OriginalPayerFKOrgINN', 1, 5501, 0, 0, '', 0, 22870, 0, 1, '') ;

CALL ImportField(550110023, '_( \)', 'OriginalPayerFKOrgName', '_()', 'OriginalPayerFKOrgName', 1, 5501, 0, 0, '', 0, 22871, 0, 1, '') ;

CALL ImportField(550110024, '_( \)', 'OriginalPayerFKLS', '_()', 'OriginalPayerFKLS', 1, 5501, 0, 0, '', 0, 22872, 0, 1, '') ;

CALL ImportField(550110025, '_( \)', 'OriginalPayerFKCode', '_()', 'OriginalPayerFKCode', 1, 5501, 0, 1, '', 0, 22894, 0, 1, '') ;

CALL ImportField(550110026, '( )', 'OriginalAcceptorParent', '( )', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110027, ' ( \)', 'OriginalAcceptorHandBook', ' ()', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110028, '( \)', 'OriginalAcceptorAcc', '()', 'OriginalAcceptorAcc', 1, 5501, 0, 0, '', 0, 22874, 0, 1, '') ;

CALL ImportField(550110029, '( \)', 'OriginalAcceptorOrgName', '()', 'OriginalAcceptorOrgName', 1, 5501, 0, 0, '', 0, 22875, 0, 1, '') ;

CALL ImportField(550110030, '( \)', 'OriginalAcceptorOrgInn', '()', 'OriginalAcceptorOrgINN', 1, 5501, 0, 0, '', 0, 22903, 0, 1, '') ;

CALL ImportField(550110031, '( \)', 'OriginalAcceptorOrgInn20', '()', 'OriginalAcceptorOrgINN20', 1, 5501, 0, 0, '', 0, 22876, 0, 1, '') ;

CALL ImportField(550110032, '', 'OriginalAcceptorBankName', '()', 'OriginalAcceptorBankName', 1, 5501, 0, 1, '', 0, 22877, 0, 1, '') ;

CALL ImportField(550110033, '', 'OriginalAcceptorBankMfo', '()', 'OriginalAcceptorBankMFO', 1, 5501, 0, 1, '', 0, 22878, 0, 1, '') ;

CALL ImportField(550110034, '. ', 'OriginalAcceptorBankCor', '. ()', 'OriginalAcceptorBankCor', 1, 5501, 0, 1, '', 0, 22879, 0, 1, '') ;

CALL ImportField(550110035, '_( \)', 'OriginalAcceptorFKOrgINN', '_()', 'OriginalAcceptorFKOrgINN', 1, 5501, 0, 0, '', 0, 22880, 0, 1, '') ;

CALL ImportField(550110036, '_( \)', 'OriginalAcceptorFKOrgName', '_()', 'OriginalAcceptorFKOrgName', 1, 5501, 0, 0, '', 0, 22881, 0, 1, '') ;

CALL ImportField(550110037, '_( \)', 'OriginalAcceptorFKLS', '_()', 'OriginalAcceptorFKLS', 1, 5501, 0, 0, '', 0, 22882, 0, 1, '') ;

CALL ImportField(550110038, '_( \)', 'OriginalAcceptorFKCode', '_()', 'OriginalAcceptorFKCode', 1, 5501, 0, 0, '', 0, 22893, 0, 1, '') ;

CALL ImportField(550110040, '', 'Note', '', 'Note', 1, 5501, 0, 0, '', 0, 22851, 0, 1, '') ;

CALL ImportField(550110042, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 5501, 0, 0, '', 0, 22884, 0, 1, '') ;

CALL ImportField(550110043, ' ', 'id', ' ', 'ID', 1, 5501, 0, 1, '', 0, 22844, 0, 1, '') ;

CALL ImportField(550110044, ' ', 'DocType', ' ', 'DocType', 1, 5501, 0, 0, '', 0, 22852, 0, 1, '') ;

CALL ImportField(550110045, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 5501, 0, 1, '', 0, 22853, 0, 1, '') ;

CALL ImportField(550110046, '', 'OriginalRecordindex', '', 'OriginalRecordindex', 1, 5501, 0, 1, '', 0, 22862, 0, 0, '') ;

CALL ImportField(550110047, '', 'OriginalPayerAcc_Ref', '', 'OriginalPayerAcc_RefFUID', 1, 5501, 0, 1, '', 0, 22863, 0, 1, '') ;

CALL ImportField(550110048, '', 'OriginalAcceptorAcc_Ref', '', 'OriginalAcceptorAcc_refFUID', 1, 5501, 0, 1, '', 0, 22873, 0, 1, '') ;

CALL ImportField(550110082, '   ', 'PayDocRef', '   ', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110094, '  ', 'ElDocRef', '  ', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110095, ' ', 'OperationDirection', ' ', ' ', 1, 5501, 0, 1, '', 0, 22854, 0, 0, '') ;

CALL ImportField(550110096, ' ', 'RecordDate', ' ', 'RecordDate', 1, 5501, 0, 0, '', 0, 22906, 0, 1, '') ;

CALL ImportField(550110097, '', 'OriginalPayerBankFilName', '()', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110098, '', 'OriginalAcceptorBankFilName', '()', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110099, '( )', 'AdminAcceptorInn', '( )', ' ', 1, 5501, 0, 0, '', 0, 22895, 0, 0, '') ;

CALL ImportField(550110100, '( )', 'AdminAcceptorInn20', '( )', ' ', 1, 5501, 0, 0, '', 0, 22896, 0, 0, '') ;

CALL ImportField(550110101, ' ( )', 'TerritorialFKParent', ' ( )', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110102, '( \ )', 'TerritorialFKInn', '( )', ' ', 1, 5501, 0, 0, '', 0, 22900, 0, 0, '') ;

CALL ImportField(550110103, '( \ )', 'TerritorialFKInn20', '( )', ' ', 1, 5501, 0, 0, '', 0, 22901, 0, 0, '') ;

CALL ImportField(550110104, '  ', 'FKParent', '  ', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110105, '(  )', 'FKInn', '(  )', ' ', 1, 5501, 0, 0, '', 0, 22897, 0, 0, '') ;

CALL ImportField(550110106, '(  )', 'FKInn20', '(  )', ' ', 1, 5501, 0, 0, '', 0, 22898, 0, 0, '') ;

CALL ImportField(550110107, '(  )', 'FKName', '(  )', ' ', 1, 5501, 0, 0, '', 0, 22899, 0, 0, '') ;

CALL ImportField(550110108, ' ', 'DocNumber', ' ', 'DocNumber', 1, 5501, 0, 0, '', 0, 22847, 0, 1, '') ;

CALL ImportField(550110109, '', 'BasicNote', '', 'BasicNote', 1, 5501, 0, 0, '', 0, 22907, 0, 1, '') ;

CALL ImportField(550110124, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 1, 5501, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550110125, ' . ( )', 'ELNUM', ' . ( )', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110126, 'OKATO( )', 'OKATO', 'OKATO( )', 'OKATO', 1, 5501, 0, 1, '', 0, 25279, 0, 1, '') ;

CALL ImportField(550110127, ' ( )', 'ADDOKATO', ' ( )', 'ADDOKATO', 1, 5501, 0, 1, '', 0, 25273, 0, 1, '') ;

CALL ImportField(550110143, ' ( \)', 'PersonalInfo', ' ( \)', ' ', 1, 5501, 0, 0, '', 0, 25280, 0, 0, '') ;

CALL ImportField(550110152, '    ( )', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 1, 5501, 0, 0, '', 0, 25277, 0, 1, '') ;

CALL ImportField(550110153, '  ', 'ParentElBank', '  ', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110161, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 5501, 0, 1, '', 0, 25274, 0, 1, '') ;

CALL ImportField(550110164, ' ', 'FoAcc', ' ', ' ', 1, 5501, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550110166, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 5501, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550110167, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110168, '', 'AUTO_AUTORIZATION', '', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110169, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110170, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550110171, '  ()', 'CREATEDATE', '  ()', ' ', 1, 5501, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111049, '', 'ParentId', '', 'ParentId', 1, 5501, 1, 1, '', 0, 22910, 0, 1, '') ;

CALL ImportField(550111050, ' ', 'OriginalClassification', ' ', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111051, '', 'Summa', '', 'summa', 1, 5501, 1, 0, '', 0, 22912, 0, 1, '') ;

CALL ImportField(550111052, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 1, 5501, 1, 0, '', 0, 22914, 0, 1, '') ;

CALL ImportField(550111053, '', 'TreeOwner0', '', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111054, '', 'KVSR', '()', 'KVSRKey', 1, 5501, 1, 1, '', 0, 22915, 0, 1, '') ;

CALL ImportField(550111055, '()', 'KFSR', '()', 'KFSR', 1, 5501, 1, 0, '', 0, 22916, 0, 1, '') ;

CALL ImportField(550111056, '', 'KCSR', '()', 'KCSRKey', 1, 5501, 1, 1, '', 0, 22917, 0, 1, '') ;

CALL ImportField(550111057, '', 'KVR', '()', 'KVRKey', 1, 5501, 1, 1, '', 0, 22918, 0, 1, '') ;

CALL ImportField(550111058, '', 'KESR', '', 'KESRKey', 1, 5501, 1, 1, '', 0, 22919, 0, 1, '') ;

CALL ImportField(550111059, '()', 'IFS_KVSRCode', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111060, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111061, '()', 'IFSAGCode', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111062, '()', 'KDKVSR', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111063, ' ()', 'KDDescriptionCode', ' ()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111064, '()', 'KDProgramCode', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111065, '()', 'KDAGCode', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111066, ' ', 'clstype', ' ', 'ClsType', 1, 5501, 1, 0, '', 0, 22913, 0, 1, '') ;

CALL ImportField(550111067, '()', 'DirectionClsCode', '', 'DirectionCls', 1, 5501, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(550111068, '', 'FACTCode', '', 'Fact', 1, 5501, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(550111069, ' ', 'MeansType', ' ', 'MeansType', 1, 5501, 1, 0, '', 0, 22921, 0, 1, '') ;

CALL ImportField(550111070, ' ', 'FinSource', ' ', 'FinSource', 1, 5501, 1, 0, '', 0, 22924, 0, 1, '') ;

CALL ImportField(550111071, ' . ', 'FinTypeCode', '  ', 'FinType', 1, 5501, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(550111072, ' ', 'DOCTYPE', ' ', 'DocType', 1, 5501, 1, 0, '', 0, 22926, 0, 1, '') ;

CALL ImportField(550111073, ' ', 'REGIONCLS', ' ', 'RegionCls', 1, 5501, 1, 0, '', 0, 22923, 0, 1, '') ;

CALL ImportField(550111074, '', 'SubKesr', '', 'SubKESRKey', 1, 5501, 1, 1, '', 0, 22927, 0, 1, '') ;

CALL ImportField(550111075, ' ', 'FundsSource', ' ', 'FundsSource', 1, 5501, 1, 0, '', 0, 22928, 0, 1, '') ;

CALL ImportField(550111076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCls', 1, 5501, 1, 0, '', 0, 22931, 0, 1, '') ;

CALL ImportField(550111078, ' ', 'ChangeParent', ' ', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111079, ' ( )', 'ChangeHandBook', ' ( )', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111080, '( )', 'ChangeAcc', '( )', 'ChangeAcc', 1, 5501, 1, 0, '', 0, 22933, 0, 1, '') ;

CALL ImportField(550111081, '( )', 'ChangeOrgName', '( )', 'ChangeOrgName', 1, 5501, 1, 0, '', 0, 22934, 0, 1, '') ;

CALL ImportField(550111082, '( )', 'ChangeOrgINN', '( )', 'ChangeOrgINN', 1, 5501, 1, 0, '', 0, 22935, 0, 1, '') ;

CALL ImportField(550111083, '( )', 'ChangeOrgINN20', '( )', 'ChangeOrgINN20', 1, 5501, 1, 0, '', 0, 22936, 0, 1, '') ;

CALL ImportField(550111084, '( )', 'IsBlocked', '( )', 'IsBlocked', 1, 5501, 1, 0, '', 0, 22941, 0, 1, '') ;

CALL ImportField(550111085, ' ( )', 'BlockedCause', ' ( )', 'BlockedCause', 1, 5501, 1, 0, '', 0, 22942, 0, 1, '') ;

CALL ImportField(550111086, ' ( )', 'UnBlockedDate', ' ( )', 'UnBlockedDate', 1, 5501, 1, 0, '', 0, 22943, 0, 1, '') ;

CALL ImportField(550111087, ' ( )', 'UnBlockedCause', ' ( )', 'UnBlockedCause', 1, 5501, 1, 0, '', 0, 22944, 0, 1, '') ;

CALL ImportField(550111088, ' ', 'IFS', ' ', 'IFS', 1, 5501, 1, 1, '', 0, 22930, 0, 1, '') ;

CALL ImportField(550111089, ' ', 'id', ' ', 'ID', 1, 5501, 1, 1, '', 0, 22909, 0, 1, '') ;

CALL ImportField(550111090, ' ', 'kd', ' ', 'KD', 1, 5501, 1, 1, '', 0, 22929, 0, 1, '') ;

CALL ImportField(550111091, '  ', 'ChangeAcc_Ref', '  ', 'ChangeAcc_RefFUID', 1, 5501, 1, 1, '', 0, 22932, 0, 1, '') ;

CALL ImportField(550111092, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 5501, 1, 1, '', 0, 22937, 0, 1, '') ;

CALL ImportField(550111108, '/ ', 'Note', '', 'Note', 1, 5501, 1, 0, '', 0, 22952, 0, 1, '') ;

CALL ImportField(550111110, '  ', 'RecordIndex', ' ', 'RecordIndex', 1, 5501, 1, 1, '', 0, 22938, 0, 1, '') ;

CALL ImportField(550111111, '.  ', 'BudgetPromise', '.  ', 'BUDGETPROMISE', 1, 5501, 1, 1, ',', 0, 25283, 0, 1, '') ;

CALL ImportField(550111112, ' . -', 'BudgetPromiseCollaps', '  ', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111114, ' .. ', 'ExecDoc', ' .. ', 'ExecDoc', 1, 5501, 1, 1, '', 0, 25284, 0, 1, '') ;

CALL ImportField(550111115, '. ', 'ExecDocCollaps', '. ', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111116, '(. )', 'ExecDocNum', '(. )', 'ExecDocNum', 1, 5501, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(550111117, '', 'IsClsChanged', '', 'IsClsChanged', 1, 5501, 1, 1, '', 0, 22953, 0, 1, '') ;

CALL ImportField(550111118, ' ', 'PROMISE', ' ', 'PROMISE', 1, 5501, 1, 0, '', 0, 25289, 0, 1, '') ;

CALL ImportField(550111119, ' ', 'BudgetPromiseAgrDate', ' ', 'BudgetPromiseAgrDate', 1, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550111122, ' ', 'BudgetPromiseAgrNum', ' ', 'BudgetPromiseAgrNum', 1, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550111123, '  .', 'BudgetPromiseAgrRNum', '  .', 'BudgetPromiseAgrReestrNum', 1, 5501, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550111125, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseAgrDate', 1, 5501, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(550111126, '. . ', 'BudgetPromiseSONote', '. . ', 'BudgetPromiseAgrNote', 1, 5501, 1, 1, '', 0, 19821, 0, 1, '') ;

CALL ImportField(550111127, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseAgrNum', 1, 5501, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(550111129, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseAgrReestrNum', 1, 5501, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(550111131, ' ( . -)', 'BudgetPromiseSumma', ' ', 'BudgetPromiseSumma', 1, 5501, 1, 1, '', 0, 20242, 0, 1, '') ;

CALL ImportField(550111132, '(.  )', 'ExecDocDate', '  ', 'ExecDocDate', 1, 5501, 1, 1, '', 0, 19740, 0, 1, '') ;

CALL ImportField(550111134, '(.  )', 'ExecDocNote', '  ', 'ExecDocNote', 1, 5501, 1, 1, '', 0, 19762, 0, 1, '') ;

CALL ImportField(550111135, ' (.  )', 'ExecDocReestr', '   ', 'ExecDocReestr', 1, 5501, 1, 1, '', 0, 19756, 0, 1, '') ;

CALL ImportField(550111136, '(.  )', 'ExecDocSumma', '   ', 'ExecDocSumma', 1, 5501, 1, 1, '', 0, 19744, 0, 1, '') ;

CALL ImportField(550111137, '(.  )', 'ExecDocType', '  ', 'ExecDocType', 1, 5501, 1, 1, '', 0, 19738, 0, 1, '') ;

CALL ImportField(550111138, ' ', 'ADDOKATO', ' ', 'ADDOKATO', 1, 5501, 1, 1, '', 0, 25282, 0, 1, '') ;

CALL ImportField(550111139, '', 'OKATO', '', 'OKATO', 1, 5501, 1, 1, '', 0, 25286, 0, 1, '') ;

CALL ImportField(550111144, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 5501, 1, 1, '', 0, 25291, 0, 1, '') ;

CALL ImportField(550111145, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 5501, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(550111146, '()', 'KCSRCode', '()', 'KCSR', 1, 5501, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(550111147, '()', 'KVRCode', '()', 'KVR', 1, 5501, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(550111148, '()', 'KVSRCode', '()', 'KVSR', 1, 5501, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(550111149, '   ', 'ORIGINALCLSSUMMA', '   ', 'ORIGINALCLSSUMMA', 1, 5501, 1, 1, '', 0, 25288, 0, 1, '') ;

CALL ImportField(550111150, '     ', 'NoteCls', '     ', 'NOTECLS', 1, 5501, 1, 0, '', 0, 25285, 0, 1, '') ;

CALL ImportField(550111151, ' ', 'OperationType', ' ', 'OperationType', 1, 5501, 1, 1, '', 0, 25287, 0, 1, '') ;

CALL ImportField(550111153, '()', 'KDKVSRCode', '()', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111154, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 5501, 1, 1, '', 0, 27700, 0, 1, '') ;

CALL ImportField(550111155, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 5501, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(550111156, ' ', 'KDValue', '', 'KDValue', 1, 5501, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550111157, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5501, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550111158, ' ', 'BudAllocationClsCode', '', ' ', 1, 5501, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550111159, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 5501, 1, 1, '', 0, 27839, 0, 1, '') ;

CALL ImportField(550111160, '  ', 'PayPromiseClsCode', '', ' ', 1, 5501, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550111161, '', 'OKTMOCode', '', ' ', 1, 5501, 1, 0, '', 0, 32822, 0, 0, '') ;

CALL ImportField(550111162, '', 'OKTMO', '', ' ', 1, 5501, 1, 1, '', 0, 32898, 0, 0, '') ;

CALL ImportField(550111163, '()', 'DirectionCls', '', 'DirectionClsKey', 1, 5501, 1, 1, '', 0, 22920, 0, 1, '') ;

CALL ImportField(550111164, ' .  ()', 'FinType', '  ', 'FinTypeKey', 1, 5501, 1, 1, ',', 0, 22925, 0, 1, '') ;

CALL ImportField(550111165, ' ()', 'FACT', '', 'FactKey', 1, 5501, 1, 1, '', 0, 22922, 0, 1, '') ;

CALL ImportField(550111166, '', 'InvestObject', '', ' ', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111167, '', 'InvestObjectCode', '', ' ', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111168, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111169, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111170, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 5501, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550111171, ' ', 'TargetClsCode', ' ', 'TargetCLS', 1, 5501, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(550111172, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 5501, 1, 1, '', 0, 40890, 0, 1, '') ;

CALL ImportField(550111173, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111174, '', 'AUTO_AUTORIZATION', '', ' ', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111175, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111176, '  ()', 'CREATEDATE', '  ()', ' ', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111177, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 5501, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550111187, '()', 'KESRCode', '()', 'KESR', 1, 5501, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550111189, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5501, 1, 0, '', 0, 43610, 0, 1, '') ;

--    , +(2)
CALL ImportField(550111001, ' ', 'ExecDocMPNum', ' ', 'ExecDocMPNum', 2, 5501, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550111002, ' ', 'ExecDocDate', '  ', 'ExecDocDate', 2, 5501, 1, 0, '', 0, null, 0, 1, '') ;

--    , (1)
CALL ImportField(550210001, '', 'DocStateRef', '', 'DocStateREf', 1, 5502, 0, 1, '', 0, 22887, 0, 1, '') ;

CALL ImportField(550210002, ' ', 'DocNumber', ' ', 'DocNumber', 1, 5502, 0, 0, '', 0, 22847, 0, 1, '') ;

CALL ImportField(550210003, '', 'BudgetRef', '', 'BudgetRef', 1, 5502, 0, 0, '', 0, 22846, 0, 1, '') ;

CALL ImportField(550210004, ' ', 'InputDate', ' ', 'InputDate', 1, 5502, 0, 0, '', 0, 22848, 0, 1, '') ;

CALL ImportField(550210005, ' ', 'AcceptDate', ' ', 'AcceptDate', 1, 5502, 0, 0, '', 0, 22849, 0, 1, '') ;

CALL ImportField(550210006, ' ', 'Summa', ' ', 'summa', 1, 5502, 0, 0, '', 0, 22850, 0, 1, '') ;

CALL ImportField(550210007, '  ', 'OriginalProgindex', '  ', 'OriginalProgIndex', 1, 5502, 0, 1, '', 0, 22861, 0, 1, '') ;

CALL ImportField(550210008, ' ', 'OriginalAttr', ' ', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210009, '( )', 'OriginalNumber', '( )', 'OriginalNumber', 1, 5502, 0, 0, '', 0, 22857, 0, 1, '') ;

CALL ImportField(550210010, '( )', 'OriginalSumma', '( )', 'OriginalSumma', 1, 5502, 0, 0, '', 0, 22859, 0, 1, '') ;

CALL ImportField(550210011, '( )', 'OriginalDate', '( )', 'OriginalDate', 1, 5502, 0, 0, '', 0, 22858, 0, 1, '') ;

CALL ImportField(550210012, ' ( )', 'OriginalNote', ' ( )', 'OriginalNote', 1, 5502, 0, 0, '', 0, 22860, 0, 1, '') ;

CALL ImportField(550210013, '( )', 'OriginalPayerParent', '( )', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210014, ' ( \)', 'OriginalPayerhandBook', ' ()', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210015, '( \)', 'OriginalPayerAcc', '()', 'OriginalPayerAcc', 1, 5502, 0, 0, '', 0, 22864, 0, 1, '') ;

CALL ImportField(550210016, '( \)', 'OriginalPayerOrgName', '()', 'OriginalPayerOrgName', 1, 5502, 0, 0, '', 0, 22865, 0, 1, '') ;

CALL ImportField(550210017, '( \)', 'OriginalPayerOrgInn', '()', 'OriginalPayerOrgINN', 1, 5502, 0, 0, '', 0, 22902, 0, 1, '') ;

CALL ImportField(550210018, '( \)', 'OriginalPayerOrgInn20', '()', 'OriginalPayerOrgINN20', 1, 5502, 0, 0, '', 0, 22866, 0, 1, '') ;

CALL ImportField(550210019, '', 'OriginalPayerBankName', '()', 'OriginalPayerBankName', 1, 5502, 0, 1, '', 0, 22867, 0, 1, '') ;

CALL ImportField(550210020, '', 'OriginalPayerBankMfo', '()', 'OriginalPayerBankMFO', 1, 5502, 0, 1, '', 0, 22868, 0, 1, '') ;

CALL ImportField(550210021, '. ', 'OriginalPayerBankCor', '. ()', 'OriginalPayerBankCor', 1, 5502, 0, 1, '', 0, 22869, 0, 1, '') ;

CALL ImportField(550210022, '_( \)', 'OriginalPayerFKOrgINN', '_()', 'OriginalPayerFKOrgINN', 1, 5502, 0, 0, '', 0, 22870, 0, 1, '') ;

CALL ImportField(550210023, '_( \)', 'OriginalPayerFKOrgName', '_()', 'OriginalPayerFKOrgName', 1, 5502, 0, 0, '', 0, 22871, 0, 1, '') ;

CALL ImportField(550210024, '_( \)', 'OriginalPayerFKLS', '_()', 'OriginalPayerFKLS', 1, 5502, 0, 0, '', 0, 22872, 0, 1, '') ;

CALL ImportField(550210025, '_( \)', 'OriginalPayerFKCode', '_()', 'OriginalPayerFKCode', 1, 5502, 0, 1, '', 0, 22894, 0, 1, '') ;

CALL ImportField(550210026, '( )', 'OriginalAcceptorParent', '( )', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210027, ' ( \)', 'OriginalAcceptorHandBook', ' ()', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210028, '( \)', 'OriginalAcceptorAcc', '()', 'OriginalAcceptorAcc', 1, 5502, 0, 0, '', 0, 22874, 0, 1, '') ;

CALL ImportField(550210029, '( \)', 'OriginalAcceptorOrgName', '()', 'OriginalAcceptorOrgName', 1, 5502, 0, 0, '', 0, 22875, 0, 1, '') ;

CALL ImportField(550210030, '( \)', 'OriginalAcceptorOrgInn', '()', 'OriginalAcceptorOrgINN', 1, 5502, 0, 0, '', 0, 22903, 0, 1, '') ;

CALL ImportField(550210031, '( \)', 'OriginalAcceptorOrgInn20', '()', 'OriginalAcceptorOrgINN20', 1, 5502, 0, 0, '', 0, 22876, 0, 1, '') ;

CALL ImportField(550210032, '', 'OriginalAcceptorBankName', '()', 'OriginalAcceptorBankName', 1, 5502, 0, 1, '', 0, 22877, 0, 1, '') ;

CALL ImportField(550210033, '', 'OriginalAcceptorBankMfo', '()', 'OriginalAcceptorBankMFO', 1, 5502, 0, 1, '', 0, 22878, 0, 1, '') ;

CALL ImportField(550210034, '. ', 'OriginalAcceptorBankCor', '. ()', 'OriginalAcceptorBankCor', 1, 5502, 0, 1, '', 0, 22879, 0, 1, '') ;

CALL ImportField(550210035, '_( \)', 'OriginalAcceptorFKOrgINN', '_()', 'OriginalAcceptorFKOrgINN', 1, 5502, 0, 0, '', 0, 22880, 0, 1, '') ;

CALL ImportField(550210036, '_( \)', 'OriginalAcceptorFKOrgName', '_()', 'OriginalAcceptorFKOrgName', 1, 5502, 0, 0, '', 0, 22881, 0, 1, '') ;

CALL ImportField(550210037, '_( \)', 'OriginalAcceptorFKLS', '_()', 'OriginalAcceptorFKLS', 1, 5502, 0, 0, '', 0, 22882, 0, 1, '') ;

CALL ImportField(550210038, '_( \)', 'OriginalAcceptorFKCode', '_()', 'OriginalAcceptorFKCode', 1, 5502, 0, 1, '', 0, 22893, 0, 1, '') ;

CALL ImportField(550210040, '', 'Note', '', 'Note', 1, 5502, 0, 0, '', 0, 22851, 0, 1, '') ;

CALL ImportField(550210042, '  ()', 'RejectCause', '  ()', 'RejectCause', 1, 5502, 0, 0, '', 0, 22884, 0, 1, '') ;

CALL ImportField(550210043, ' ', 'id', ' ', 'ID', 1, 5502, 0, 1, '', 0, 22844, 0, 1, '') ;

CALL ImportField(550210044, ' ', 'DocType', ' ', 'DocType', 1, 5502, 0, 0, '', 0, 22852, 0, 1, '') ;

CALL ImportField(550210045, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 5502, 0, 1, '', 0, 22853, 0, 1, '') ;

CALL ImportField(550210047, '', 'OriginalPayerAcc_Ref', '', 'OriginalPayerAcc_RefFUID', 1, 5502, 0, 1, '', 0, 22863, 0, 1, '') ;

CALL ImportField(550210048, '', 'OriginalAcceptorAcc_Ref', '', 'OriginalAcceptorAcc_refFUID', 1, 5502, 0, 1, '', 0, 22873, 0, 1, '') ;

CALL ImportField(550210082, '   ', 'PayDocRef', '   ', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210094, '  ', 'ElDocRef', '  ', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210095, ' ', 'OperationDirection', ' ', ' ', 1, 5502, 0, 1, '', 0, 22854, 0, 0, '') ;

CALL ImportField(550210096, ' ', 'RecordDate', ' ', 'RecordDate', 1, 5502, 0, 0, '', 0, 22906, 0, 1, '') ;

CALL ImportField(550210097, '', 'OriginalPayerBankFilName', '()', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210098, '', 'OriginalAcceptorBankFilName', '()', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210099, '( )', 'AdminAcceptorInn', '( )', ' ', 1, 5502, 0, 0, '', 0, 22895, 0, 0, '') ;

CALL ImportField(550210100, '( )', 'AdminAcceptorInn20', '( )', ' ', 1, 5502, 0, 0, '', 0, 22896, 0, 0, '') ;

CALL ImportField(550210101, ' ( )', 'TerritorialFKParent', ' ( )', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210102, '( \ )', 'TerritorialFKInn', '( )', ' ', 1, 5502, 0, 0, '', 0, 22900, 0, 0, '') ;

CALL ImportField(550210103, '( \ )', 'TerritorialFKInn20', '( )', ' ', 1, 5502, 0, 0, '', 0, 22901, 0, 0, '') ;

CALL ImportField(550210104, '  ', 'FKParent', '  ', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210105, '(  )', 'FKInn', '(  )', ' ', 1, 5502, 0, 0, '', 0, 22897, 0, 0, '') ;

CALL ImportField(550210106, '(  )', 'FKInn20', '(  )', ' ', 1, 5502, 0, 0, '', 0, 22898, 0, 0, '') ;

CALL ImportField(550210107, '(  )', 'FKName', '(  )', ' ', 1, 5502, 0, 0, '', 0, 22899, 0, 0, '') ;

CALL ImportField(550210108, '', 'BasicNote', '', 'BasicNote', 1, 5502, 0, 0, '', 0, 22907, 0, 1, '') ;

CALL ImportField(550210109, ' . ( )', 'ELNUM', ' . ( )', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210110, 'OKATO( )', 'OKATO', 'OKATO( )', 'OKATO', 1, 5502, 0, 1, '', 0, 25279, 0, 1, '') ;

CALL ImportField(550210111, ' ( )', 'ADDOKATO', ' ( )', 'ADDOKATO', 1, 5502, 0, 1, '', 0, 25273, 0, 1, '') ;

CALL ImportField(550210124, ' ( \)', 'PersonalInfo', ' ( \)', ' ', 1, 5502, 0, 0, '', 0, 25280, 0, 0, '') ;

CALL ImportField(550210136, '    ( )', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 1, 5502, 0, 0, '', 0, 25277, 0, 1, '') ;

CALL ImportField(550210137, '  ', 'ParentElBank', '  ', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210146, ' ', 'CryptoStatus', ' ', 'CRYPTOSTATUS', 1, 5502, 0, 1, '', 0, 25274, 0, 1, '') ;

CALL ImportField(550210148, ' ', 'FoAcc', ' ', ' ', 1, 5502, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550210150, ' ', 'BudgetPromiseAgrSumma', ' ', 'BudgetPromiseAgrSumma', 1, 5502, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550210151, '.  ', 'StoredContent', '.  ', 'StoredContent', 1, 5502, 0, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550210152, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210153, '', 'AUTO_AUTORIZATION', '', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210154, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210155, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550210156, '  ()', 'CREATEDATE', '  ()', ' ', 1, 5502, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211049, '', 'ParentId', '', 'ParentId', 1, 5502, 1, 1, '', 0, 22910, 0, 1, '') ;

CALL ImportField(550211050, ' ', 'OriginalClassification', ' ', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211051, '', 'Summa', '', 'summa', 1, 5502, 1, 0, '', 0, 22912, 0, 1, '') ;

CALL ImportField(550211052, '/', 'FacialAcc_Cls', '/', 'FacialAcc_Cls', 1, 5502, 1, 0, '', 0, 22914, 0, 1, '') ;

CALL ImportField(550211053, '', 'TreeOwner0', '', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211054, '', 'KVSR', '()', 'KVSRKey', 1, 5502, 1, 1, '', 0, 22915, 0, 1, '') ;

CALL ImportField(550211055, '()', 'KFSR', '()', 'KFSR', 1, 5502, 1, 0, '', 0, 22916, 0, 1, '') ;

CALL ImportField(550211056, '', 'KCSR', '()', 'KCSRKey', 1, 5502, 1, 1, '', 0, 22917, 0, 1, '') ;

CALL ImportField(550211057, '', 'KVR', '()', 'KVRKey', 1, 5502, 1, 1, '', 0, 22918, 0, 1, '') ;

CALL ImportField(550211058, '', 'KESR', '', 'KESRKey', 1, 5502, 1, 1, '', 0, 22919, 0, 1, '') ;

CALL ImportField(550211059, '()', 'IFS_KVSRCode', '()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211060, ' ()', 'IFS_DescriptionCode', ' ()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211061, '()', 'IFSAGCode', '()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211062, '()', 'KDKVSRCode', '()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211063, ' ()', 'KDDescriptionCode', ' ()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211064, '()', 'KDProgramCode', '()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211065, '()', 'KDAGCode', '()', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211066, ' ', 'clstype', ' ', 'ClsType', 1, 5502, 1, 0, '', 0, 22913, 0, 1, '') ;

CALL ImportField(550211067, '', 'DirectionClsCode', '', 'DirectionCls', 1, 5502, 1, 0, '', 0, 36861, 0, 1, '') ;

CALL ImportField(550211068, '', 'FACTCode', '', 'Fact', 1, 5502, 1, 0, '', 0, 36863, 0, 1, '') ;

CALL ImportField(550211069, ' ', 'MeansType', ' ', 'MeansType', 1, 5502, 1, 0, '', 0, 22921, 0, 1, '') ;

CALL ImportField(550211070, ' ', 'FinSource', ' ', 'FinSource', 1, 5502, 1, 0, '', 0, 22924, 0, 1, '') ;

CALL ImportField(550211071, ' . ', 'FinTypeCode', '  ', 'FinType', 1, 5502, 1, 0, ',', 0, 36853, 0, 1, '') ;

CALL ImportField(550211072, ' ', 'DOCTYPE', ' ', 'DocType', 1, 5502, 1, 0, '', 0, 22926, 0, 1, '') ;

CALL ImportField(550211073, ' ', 'REGIONCLS', ' ', 'RegionCls', 1, 5502, 1, 0, '', 0, 22923, 0, 1, '') ;

CALL ImportField(550211074, '', 'SubKesr', '', 'SubKESRKey', 1, 5502, 1, 1, '', 0, 22927, 0, 1, '') ;

CALL ImportField(550211075, ' ', 'FundsSource', ' ', 'FundsSource', 1, 5502, 1, 0, '', 0, 22928, 0, 1, '') ;

CALL ImportField(550211076, ' ', 'BuhOperationCLS', ' ', 'BuhOperationCls', 1, 5502, 1, 0, '', 0, 22931, 0, 1, '') ;

CALL ImportField(550211078, ' ', 'ChangeParent', ' ', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211079, ' ( )', 'ChangeHandBook', ' ( )', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211080, '( )', 'ChangeAcc', '( )', 'ChangeAcc', 1, 5502, 1, 0, '', 0, 22933, 0, 1, '') ;

CALL ImportField(550211081, '( )', 'ChangeOrgName', '( )', 'ChangeOrgName', 1, 5502, 1, 0, '', 0, 22934, 0, 1, '') ;

CALL ImportField(550211082, '( )', 'ChangeOrgINN', '( )', 'ChangeOrgINN', 1, 5502, 1, 0, '', 0, 22935, 0, 1, '') ;

CALL ImportField(550211083, '( )', 'ChangeOrgINN20', '( )', 'ChangeOrgINN20', 1, 5502, 1, 0, '', 0, 22936, 0, 1, '') ;

CALL ImportField(550211084, '( )', 'IsBlocked', '( )', 'IsBlocked', 1, 5502, 1, 0, '', 0, 22941, 0, 1, '') ;

CALL ImportField(550211085, ' ( )', 'BlockedCause', ' ( )', 'BlockedCause', 1, 5502, 1, 0, '', 0, 22942, 0, 1, '') ;

CALL ImportField(550211086, ' ( )', 'UnBlockedDate', ' ( )', 'UnBlockedDate', 1, 5502, 1, 0, '', 0, 22943, 0, 1, '') ;

CALL ImportField(550211087, ' ( )', 'UnBlockedCause', ' ( )', 'UnBlockedCause', 1, 5502, 1, 0, '', 0, 22944, 0, 1, '') ;

CALL ImportField(550211088, ' ', 'IFS', ' ', 'IFSValue', 1, 5502, 1, 1, '', 0, 22930, 0, 1, '') ;

CALL ImportField(550211089, ' ', 'id', ' ', 'ID', 1, 5502, 1, 1, '', 0, 22909, 0, 1, '') ;

CALL ImportField(550211090, ' ', 'kd', ' ', 'KD', 1, 5502, 1, 1, '', 0, 22929, 0, 1, '') ;

CALL ImportField(550211091, '  ', 'ChangeAcc_Ref', '  ', 'ChangeAcc_RefFUID', 1, 5502, 1, 1, '', 0, 22932, 0, 1, '') ;

CALL ImportField(550211092, ' ', 'ProgIndex', ' ', 'ProgIndex', 1, 5502, 1, 1, '', 0, 22937, 0, 1, '') ;

CALL ImportField(550211108, '/ ', 'Note', '', 'Note', 1, 5502, 1, 0, '', 0, 22952, 0, 1, '') ;

CALL ImportField(550211109, '  ', 'RecordIndex', ' ', 'RecordIndex', 1, 5502, 1, 1, '', 0, 22938, 0, 1, '') ;

CALL ImportField(550211110, '.  ', 'BudgetPromise', '.  ', 'BUDGETPROMISE', 1, 5502, 1, 1, ',', 0, 25283, 0, 1, '') ;

CALL ImportField(550211111, ' . -', 'BudgetPromiseCollaps', ' . -', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211113, ' .. ', 'ExecDoc', ' .. ', 'ExecDoc', 1, 5502, 1, 1, '', 0, 25284, 0, 1, '') ;

CALL ImportField(550211114, '. ', 'ExecDocCollaps', '. ', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211115, '(. )', 'ExecDocNum', '(. )', 'ExecDocNum', 1, 5502, 1, 0, '', 0, 19739, 0, 1, '') ;

CALL ImportField(550211116, '', 'IsClsChanged', '', 'IsClsChanged', 1, 5502, 1, 1, '', 0, 22953, 0, 1, '') ;

CALL ImportField(550211117, ' ', 'PROMISE', ' ', 'PROMISE', 1, 5502, 1, 0, '', 0, 25289, 0, 1, '') ;

CALL ImportField(550211118, ' ', 'ADDOKATO', ' ', 'ADDOKATO', 1, 5502, 1, 1, '', 0, 25282, 0, 1, '') ;

CALL ImportField(550211119, '', 'OKATO', '', 'OKATO', 1, 5502, 1, 1, '', 0, 25286, 0, 1, '') ;

CALL ImportField(550211125, '  ', 'TransfertCls', '   ()', 'TransfertCls', 1, 5502, 1, 1, '', 0, 25291, 0, 1, '') ;

CALL ImportField(550211126, '  ', 'TransfertClsCode', '  ', 'TransfertClsValue', 1, 5502, 1, 0, '', 0, 25326, 0, 1, '') ;

CALL ImportField(550211127, '()', 'KCSRCode', '()', 'KCSR', 1, 5502, 1, 0, '', 0, 25462, 0, 1, '') ;

CALL ImportField(550211128, '()', 'KVRCode', '()', 'KVR', 1, 5502, 1, 0, '', 0, 25467, 0, 1, '') ;

CALL ImportField(550211129, '()', 'KVSRCode', '()', 'KVSR', 1, 5502, 1, 0, '', 0, 25472, 0, 1, '') ;

CALL ImportField(550211130, '   ', 'ORIGINALCLSSUMMA', '   ', 'ORIGINALCLSSUMMA', 1, 5502, 1, 1, '', 0, 25288, 0, 1, '') ;

CALL ImportField(550211131, '     ', 'NoteCls', '     ', 'NOTECLS', 1, 5502, 1, 0, '', 0, 25285, 0, 1, '') ;

CALL ImportField(550211132, ' ', 'OperationType', ' ', 'OperationType', 1, 5502, 1, 1, '', 0, 25287, 0, 1, '') ;

CALL ImportField(550211133, ' ', 'SubsidyClsCode', ' ', 'SubsidyClsCode', 1, 5502, 1, 0, '', 0, 26641, 0, 1, '') ;

CALL ImportField(550211134, ' ', 'SubsidyCls', '  ()', 'SubsidyCls', 1, 5502, 1, 1, '', 0, 27700, 0, 1, '') ;

CALL ImportField(550211135, ' ', 'KDValue', '', 'KDValue', 1, 5502, 1, 0, '', 0, null, 0, 1, '') ;

CALL ImportField(550211136, ' ', 'BudAllocationCls', '', 'BudAllocationCls', 1, 5502, 1, 1, '', 0, 27838, 0, 1, '') ;

CALL ImportField(550211137, ' ', 'BudAllocationClsCode', '', ' ', 1, 5502, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550211138, '  ', 'PayPromiseCls', '', 'PayPromiseCls', 1, 5502, 1, 1, '', 0, 27839, 0, 1, '') ;

CALL ImportField(550211139, '  ', 'PayPromiseClsCode', '', ' ', 1, 5502, 1, 0, '', 0, 27849, 0, 0, '') ;

CALL ImportField(550211140, '', 'OKTMOCode', '', ' ', 1, 5502, 1, 0, '', 0, 32822, 0, 0, '') ;

CALL ImportField(550211141, '', 'OKTMO', '', ' ', 1, 5502, 1, 1, '', 0, 32898, 0, 0, '') ;

CALL ImportField(550211142, ' ()', 'DirectionCls', '', 'DirectionClsKey', 1, 5502, 1, 1, '', 0, 22920, 0, 1, '') ;

CALL ImportField(550211143, ' ()', 'FACT', '', 'FactKey', 1, 5502, 1, 1, '', 0, 22922, 0, 1, '') ;

CALL ImportField(550211144, ' .  ()', 'FinType', '  ', 'FinTypeKey', 1, 5502, 1, 1, ',', 0, 22925, 0, 1, '') ;

CALL ImportField(550211145, '', 'InvestObject', '', ' ', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211146, '', 'InvestObjectCode', '', ' ', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211147, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211148, '', 'ContractCostsClsCode', '', 'ContractCostsCls', 1, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211149, ' ', 'BudgetPromiseAgrDate', ' ', 'BudgetPromiseAgrDate', 1, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550211150, ' ', 'BudgetPromiseAgrNum', ' ', 'BudgetPromiseAgrNum', 1, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550211151, '  .', 'BudgetPromiseAgrRNum', '  .', 'BudgetPromiseAgrReestrNum', 1, 5502, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(550211152, ' . ', 'BudgetPromiseSODate', ' . ', 'BudgetPromiseAgrDate', 1, 5502, 1, 1, '', 0, 19799, 0, 1, '') ;

CALL ImportField(550211153, '. . ', 'BudgetPromiseSONote', '. . ', 'BudgetPromiseAgrNote', 1, 5502, 1, 1, '', 0, 19821, 0, 1, '') ;

CALL ImportField(550211154, ' . ', 'BudgetPromiseSONum', ' . ', 'BudgetPromiseAgrNum', 1, 5502, 1, 1, '', 0, 19798, 0, 1, '') ;

CALL ImportField(550211155, '  . ', 'BudgetPromiseSORNum', '  . ', 'BudgetPromiseAgrReestrNum', 1, 5502, 1, 1, '', 0, 19830, 0, 1, '') ;

CALL ImportField(550211157, ' ( . -)', 'BudgetPromiseSumma', ' ', 'BudgetPromiseSumma', 1, 5502, 1, 1, '', 0, 20242, 0, 1, '') ;

CALL ImportField(550211158, '.   ()', 'StoredContentDet', '.   ()', 'StoredContentDet', 1, 5502, 1, 0, '', 0, null, 0, 2, '') ;

CALL ImportField(550211159, ' ', 'TargetClsCode', ' ', 'TargetCLS', 1, 5502, 1, 0, '', 0, 22390, 0, 1, '') ;

CALL ImportField(550211160, ' ', 'TargetCls', '  ()', 'TargetClsKey', 1, 5502, 1, 1, '', 0, 40890, 0, 1, '') ;

CALL ImportField(550211161, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211162, '', 'AUTO_AUTORIZATION', '', ' ', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211163, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211164, '  ()', 'CREATEDATE', '  ()', ' ', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211165, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 5502, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550211200, '()', 'KESRCode', '()', 'KESR', 1, 5502, 1, 0, '', 0, 43607, 0, 1, '') ;

CALL ImportField(550211202, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5502, 1, 0, '', 0, 43610, 0, 1, '') ;

--    , +(2)
CALL ImportField(550211001, ' ', 'ExecDocMPNum', ' ', 'ExecDocMPNum', 2, 5502, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(550211002, ' ', 'ExecDocDate', '  ', 'ExecDocDate', 2, 5502, 1, 0, '', 0, null, 0, 1, '') ;

--    , (1)
CALL ImportField(550311005, ' ', 'BudAllocationCls', '   ()', 'BudAllocationCls', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311011, '', 'KVSR', '', 'KVSR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311012, '()', 'Kfsr', '', 'Kfsr', 1, 5503, 1, 0, '', 0, 31729, 0, 0, '') ;

CALL ImportField(550311013, '', 'KCSR', '', 'KCSR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311014, '', 'KVR', '', 'KVR', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311015, '', 'Kesr', '', 'KesrKey', 1, 5503, 1, 1, '', 0, 31728, 0, 0, '') ;

CALL ImportField(550311016, '', 'SubKESR', '', 'SubKESRKey', 1, 5503, 1, 1, '', 0, 31738, 0, 0, '') ;

CALL ImportField(550311030, ' ', 'BudAllocationClsCode', '  ', 'BudAllocationClsCode', 1, 5503, 1, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550311036, '()', 'KcsrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(550311041, '()', 'KvrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(550311042, '()', 'KvsrCode', '', ' ', 1, 5503, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(550311064, '', 'ContractCostsCls', '', 'ContractCostsClsKey', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311066, ' ', 'TargetClsCode', ' ', 'TargetClsCode', 1, 5503, 1, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(550311067, ' ', 'TargetCls', '  ()', 'TargetCls', 1, 5503, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550311068, '()', 'KESRCode', '()', 'Kesr', 1, 5503, 1, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(550311070, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5503, 1, 0, '', 0, 43610, 0, 0, '') ;

CALL ImportField(550312006, ' ', 'BudAllocationClsCode', '', ' ', 1, 5503, 2, 0, '', 0, 27825, 0, 0, '') ;

CALL ImportField(550312017, '()', 'KcsrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(550312022, '', 'Kesr', '', 'KesrKey', 1, 5503, 2, 1, '', 0, 17415, 0, 0, '') ;

CALL ImportField(550312023, '()', 'Kfsr', '', ' ', 1, 5503, 2, 0, '', 0, 17411, 0, 0, '') ;

CALL ImportField(550312024, '()', 'KvrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(550312025, '()', 'KvsrCode', '', ' ', 1, 5503, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(550312030, '', 'SubKesr', '', 'SubKESRKey', 1, 5503, 2, 1, '', 0, 17416, 0, 0, '') ;

CALL ImportField(550312041, '', 'Kvsr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312042, '', 'Kvr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312043, '', 'Kcsr', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312047, ' ', 'BudAllocationCls', '', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312060, ' ', 'TargetClsCode', ' ', ' ', 1, 5503, 2, 0, '', 0, 22390, 0, 0, '') ;

CALL ImportField(550312061, ' ', 'TargetCls', '  ()', ' ', 1, 5503, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(550312069, '()', 'KESRCode', '()', 'Kesr', 1, 5503, 2, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(550312071, '()', 'SubKESRCode', '()', 'SubKESR', 1, 5503, 2, 0, '', 0, 43610, 0, 0, '') ;

-- , (1)
CALL ImportField(960110003, ' ', 'BUDGETNAME', '', ' ', 1, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110005, ' ', 'BUGNAME', '', ' ', 1, 9601, 0, 0, '', 0, 16657, 0, 0, '') ;

CALL ImportField(960110006, ' ', 'BUGPHONE', '', ' ', 1, 9601, 0, 0, '', 0, 16659, 0, 0, '') ;

CALL ImportField(960110007, '    ', 'CHANGEDATE', '', ' ', 1, 9601, 0, 0, '', 0, 16679, 0, 0, '') ;

CALL ImportField(960110013, ' ', 'DIRNAME', '', ' ', 1, 9601, 0, 0, '', 0, 16656, 0, 0, '') ;

CALL ImportField(960110014, ' ', 'DIRPHONE', '', ' ', 1, 9601, 0, 0, '', 0, 16658, 0, 0, '') ;

CALL ImportField(960110015, 'E-mail ', 'EMAIL', '', ' ', 1, 9601, 0, 0, '', 0, 16665, 0, 0, '') ;

CALL ImportField(960110017, '  ', 'FEDERALREGIONCODE', '', ' ', 1, 9601, 0, 0, '', 0, 16681, 0, 0, '') ;

CALL ImportField(960110022, '', 'GOSNI', '', ' ', 1, 9601, 0, 0, '', 0, 16647, 0, 0, '') ;

CALL ImportField(960110027, '', 'OKFS', '', ' ', 1, 9601, 0, 0, '', 0, 16675, 0, 0, '') ;

CALL ImportField(960110028, '', 'OKOPF', '', ' ', 1, 9601, 0, 0, '', 0, 16676, 0, 0, '') ;

CALL ImportField(960110029, '   ', 'OPENDATE', '', ' ', 1, 9601, 0, 0, '', 0, 16677, 0, 0, '') ;

CALL ImportField(960110034, ' ', 'ORG_SHORTNAME', '', ' ', 1, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110038, ' ', 'RCORG', '', ' ', 1, 9601, 0, 0, '', 0, 16660, 0, 0, '') ;

CALL ImportField(960110040, '  ', 'SENDERID', '', ' ', 1, 9601, 0, 0, '', 0, 16673, 0, 0, '') ;

CALL ImportField(960110043, '( / )', 'UFKCODE', '', ' ', 1, 9601, 0, 0, '', 0, 16668, 0, 0, '') ;

CALL ImportField(960110044, ' Web-', 'WEBSITE', '', ' ', 1, 9601, 0, 0, '', 0, 16666, 0, 0, '') ;

CALL ImportField(960110045, '', 'ORG_USECOUNT', '', ' ', 1, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110050, '', 'ORG_REF', '', ' ', 1, 9601, 0, 0, '', 0, 16643, 0, 0, '') ;

CALL ImportField(960110051, ' ', 'DATEOPEN', '', ' ', 1, 9601, 0, 0, '', 0, 31711, 0, 0, '') ;

CALL ImportField(960110052, '', 'OKTMO', '', ' ', 1, 9601, 0, 0, '', 0, 32858, 0, 0, '') ;

CALL ImportField(960110053, '', 'OKTMOCODE', '', ' ', 1, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110055, '', 'OGRN', '', ' ', 1, 9601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(960111001, ' ()', 'ACC_REF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111002, ' ()', 'ORG_REF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111003, '', 'ACC', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111004, ' ', 'ACC_CLS', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111005, ' ', 'COMMENT', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111006, '  ', 'ACCCLSNAME', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111007, '', 'BANK_REF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111008, 'Bank_MFO', 'BANK_MFO', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111009, 'Bank_Cor', 'BANK_COR', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111010, '  ', 'BANKREF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111011, '  ', 'BANKDEPNUMBER', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111012, '  ', 'BANK_DATECLOSE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111013, '  ', 'BANK_CLOSED', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111014, 'SrcFKAcc', 'SRCFKACC', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111015, 'SrcServiceBank', 'SRCSERVICEBANK', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111016, 'SrcServiceBank_Cor', 'SRCSERVICEBANK_COR', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111017, 'SrcServiceMank_MFO', 'SRCSERVICEBANK_MFO', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111018, 'SrcServiceFacialCode', 'SRCSERVICEFACIALCODE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111019, 'SrcServiceSubFacialCode', 'SRCSERVICESUBFACIALCODE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111020, '  ( \ )', 'FACIALCODE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111021, ' . ', 'FINTYPE', ' . ', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111022, '  ', 'ISDEFAULT', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111023, '  ', 'ORGACC_CLOSED', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111024, '  ', 'ORGREF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111025, 'Service_Acc_Ref', 'SERVICE_ACC_REF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111026, '   ', 'SERVICE_ORG_REF', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111027, '  ', 'SERVICETYPE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111028, 'OrgAcc_CloseCode', 'ORGACC_CLOSECODE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111029, 'OrgAcc_FacialAcc', 'ORGACC_FACIALACC', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111030, 'ServiceOrg_AccType', 'SERVICEORG_ACCTYPE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111031, ' ', 'ACC_DATECLOSE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111032, ' ', 'ACC_DATEOPEN', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111033, 'ExtID', 'EXTID', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111034, 'ExtOwner', 'EXTOWNER', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960111035, 'ExtSyncDate', 'EXTSYNCDATE', '', ' ', 1, 9601, 1, 0, '', 0, null, 0, 0, '') ;

-- , +(2)
CALL ImportField(960110001, ' ', 'ADDOKATO', '', ' ', 2, 9601, 0, 0, '', 0, 16669, 0, 0, '') ;

CALL ImportField(960110002, '', 'ADDRESS', '', ' ', 2, 9601, 0, 0, '', 0, 16651, 0, 0, '') ;

CALL ImportField(960110008, ' ', 'CLIENTID', '', ' ', 2, 9601, 0, 0, '', 0, 16684, 0, 0, '') ;

CALL ImportField(960110009, '   ', 'CLOSEDATE', '', ' ', 2, 9601, 0, 0, '', 0, 16678, 0, 0, '') ;

CALL ImportField(960110010, '', 'COUNTRY', '', ' ', 2, 9601, 0, 0, '', 0, 16649, 0, 0, '') ;

CALL ImportField(960110011, ' ', 'COUNTRYCODE', '', ' ', 2, 9601, 0, 0, '', 0, 16686, 0, 0, '') ;

CALL ImportField(960110012, ' ', 'DATECLOSE', '', ' ', 2, 9601, 0, 0, '', 0, 16672, 0, 0, '') ;

CALL ImportField(960110016, '', 'FACIALACC', '', ' ', 2, 9601, 0, 0, '', 0, 16655, 0, 0, '') ;

CALL ImportField(960110021, '-()', 'GENERALORG_REF', '', ' ', 2, 9601, 0, 0, '', 0, 16680, 0, 0, '') ;

CALL ImportField(960110023, '', 'INN', '', ' ', 2, 9601, 0, 0, '', 0, 16645, 0, 0, '') ;

CALL ImportField(960110024, '', 'KPP', '', ' ', 2, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110025, '', 'KVSR', '', ' ', 2, 9601, 0, 0, '', 0, 16674, 0, 0, '') ;

CALL ImportField(960110026, '', 'OKATO', '', ' ', 2, 9601, 0, 0, '', 0, 16667, 0, 0, '') ;

CALL ImportField(960110030, '', 'ORG_CITY', '', ' ', 2, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110031, '  ()', 'ORG_CLS', '', ' ', 2, 9601, 0, 0, '', 0, 16652, 0, 0, '') ;

CALL ImportField(960110032, ' ()', 'ORG_NAME', '', ' ', 2, 9601, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(960110035, ' ', 'ORG_TYPE', '', ' ', 2, 9601, 0, 0, '', 0, 16682, 0, 0, '') ;

CALL ImportField(960110036, '( / )', 'ORGCODE', '', ' ', 2, 9601, 0, 0, '', 0, 16687, 0, 0, '') ;

CALL ImportField(960110037, '', 'PHONE', '', ' ', 2, 9601, 0, 0, '', 0, 16650, 0, 0, '') ;

CALL ImportField(960110039, '', 'REGIONCLS', '', ' ', 2, 9601, 0, 0, '', 0, 16644, 0, 0, '') ;

CALL ImportField(960110041, ' ', 'SUBINN', '', ' ', 2, 9601, 0, 0, '', 0, 16654, 0, 0, '') ;

CALL ImportField(960110042, ' ', 'SUPPLIERSTATUS', '', ' ', 2, 9601, 0, 0, '', 0, 16685, 0, 0, '') ;

CALL ImportField(960110056, '', 'RemotePBSCode', '', ' ', 2, 9601, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(960110057, '', 'RemoteNotPBSCode', '', ' ', 2, 9601, 0, 1, '', 0, null, 0, 0, '') ;

-- , (1)
CALL ImportField(980810008, '', 'CODE', '', ' ', 1, 9808, 0, 1, '', 0, 43610, 0, 0, '') ;

-- , +(2)
CALL ImportField(980810007, '', '_FAVORITE', '', ' ', 2, 9808, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(980810009, ' ', 'BUDGETREF', '', ' ', 2, 9808, 0, 1, '', 0, 43611, 0, 0, '') ;

-- , +(2)
CALL ImportField(980910008, '', 'KESR', '', ' ', 2, 9809, 0, 1, '', 0, 16835, 0, 0, '') ;

CALL ImportField(980910009, ' ()', 'KVSR', '', ' ', 2, 9809, 0, 0, '', 0, 16830, 0, 0, '') ;

CALL ImportField(980910017, '', 'KVSRCODE', '', ' ', 2, 9809, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(980910027, '()', 'KESRCode', '', ' ', 2, 9809, 0, 0, '', 0, 43607, 0, 0, '') ;

-- , +(2)
CALL ImportField(981210015, '  ', 'TransfertKVSR', '', ' ', 2, 9812, 0, 0, '', 0, null, 0, 0, '') ;

-- - , +(2)
CALL ImportField(982910011, '  ', 'ReestrNumber', '', ' ', 2, 9829, 0, 0, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(984110022, '', 'KCSR', '', ' ', 2, 9841, 0, 0, '', 0, 17137, 0, 0, '') ;

CALL ImportField(984110023, '', 'KESR', '', ' ', 2, 9841, 0, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(984110024, '', 'KFSR', '', ' ', 2, 9841, 0, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(984110025, '', 'KVR', '', ' ', 2, 9841, 0, 0, '', 0, 17139, 0, 0, '') ;

CALL ImportField(984110026, '', 'KVSR', '', ' ', 2, 9841, 0, 0, '', 0, 17136, 0, 0, '') ;

CALL ImportField(984110052, '()', 'KESRCode', '', ' ', 2, 9841, 0, 0, '', 0, 43607, 0, 0, '') ;

--    , (1)
CALL ImportField(985210018, '', 'KVSRCODE', '', ' ', 1, 9852, 0, 0, '', 0, null, 0, 0, '') ;

--    , +(2)
CALL ImportField(985210010, '', 'KESR', '', ' ', 2, 9852, 0, 1, '', 0, 17054, 0, 0, '') ;

CALL ImportField(985210011, ' ()', 'KVSR', '', ' ', 2, 9852, 0, 0, '', 0, 17049, 0, 0, '') ;

CALL ImportField(985210027, '()', 'KESRCode', '', ' ', 2, 9852, 0, 0, '', 0, 43607, 0, 0, '') ;

-- , +(2)
CALL ImportField(985410017, '', 'KVSR', '', ' ', 2, 9854, 0, 1, '', 0, 38217, 0, 0, '') ;

CALL ImportField(985410018, '', 'KCSR', '', ' ', 2, 9854, 0, 0, '', 0, 38218, 0, 0, '') ;

CALL ImportField(985410029, '', 'KVSRCODE', '', ' ', 2, 9854, 0, 0, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(986110012, '', 'KESR', '', ' ', 1, 9861, 0, 1, '', 0, 20702, 0, 0, '') ;

CALL ImportField(986110039, '()', 'KESRCode', '', ' ', 1, 9861, 0, 0, '', 0, 43607, 0, 0, '') ;

--     , +(2)
CALL ImportField(986810018, '', 'CODE', '', ' ', 2, 9868, 0, 1, '', 0, 43607, 0, 0, '') ;

CALL ImportField(986810019, ' ', 'BUDGETREF', '', ' ', 2, 9868, 0, 1, '', 0, 43608, 0, 0, '') ;

--   , +(2)
CALL ImportField(988410018, '', 'TRANSFERKCSR', '', ' ', 2, 9884, 0, 0, '', 0, 25337, 0, 0, '') ;

CALL ImportField(988410019, '', 'TRANSFERKCSRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410022, '', 'TRANSFERKFSR', '', ' ', 2, 9884, 0, 0, '', 0, 25340, 0, 0, '') ;

CALL ImportField(988410023, '', 'TRANSFERKVR', '', ' ', 2, 9884, 0, 0, '', 0, 25341, 0, 0, '') ;

CALL ImportField(988410024, '', 'TRANSFERKVRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410025, '', 'TRANSFERKVSR', '', ' ', 2, 9884, 0, 0, '', 0, 25342, 0, 0, '') ;

CALL ImportField(988410026, '', 'TRANSFERKVSRCODE', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410042, '', 'FactCode', '', ' ', 2, 9884, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(988410043, ' ()', 'FACT', '', ' ', 2, 9884, 0, 0, '', 0, 43561, 0, 0, '') ;

--  , +(2)
CALL ImportField(989010012, ' ', 'ASSIGNMENTKIND', '', ' ', 2, 9890, 0, 1, '', 0, 43451, 0, 0, '') ;

--  , (1)
CALL ImportField(989810004, '', 'CREATERUSER', '', ' ', 1, 9898, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(989810006, '', 'UPDATERUSER', '', ' ', 1, 9898, 0, 1, '', 0, null, 0, 0, '') ;

--  , +(2)
CALL ImportField(989810001, '', 'ID', '', ' ', 2, 9898, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(989810002, '', 'NAME', '', ' ', 2, 9898, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(989810003, ' ', 'CREATEDATE', '', ' ', 2, 9898, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(989810005, ' ', 'UPDATEDATE', '', ' ', 2, 9898, 0, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(990312042, '', 'KVSR', '', ' ', 1, 9903, 2, 1, '', 0, 17136, 0, 0, '') ;

CALL ImportField(990312043, '', 'KCSR', '', ' ', 1, 9903, 2, 1, '', 0, 17137, 0, 0, '') ;

CALL ImportField(990312044, '', 'KFSR', '', ' ', 1, 9903, 2, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(990312045, '', 'KVR', '', ' ', 1, 9903, 2, 1, '', 0, 17139, 0, 0, '') ;

CALL ImportField(990312046, '', 'KESR', '', ' ', 1, 9903, 2, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(990312083, '', 'KCSRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(990312084, '', 'KVRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(990312085, '', 'KVSRCode', '', ' ', 1, 9903, 2, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(990312121, '()', 'KESRCode', '()', ' ', 1, 9903, 2, 0, '', 0, 43607, 0, 0, '') ;

--  , +(2)
CALL ImportField(990310096, ' ', 'REJECT_CLS', ' ', 'REJECTCLS', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990310097, '  ()', 'RejectCause', '  ()', 'RejectCause', 2, 9903, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(990310106, '', 'AUTO_AUTORIZATION', '', ' ', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990310107, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990310108, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 2, 9903, 0, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(990310109, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990310110, '  ()', 'CREATEDATE', '  ()', ' ', 2, 9903, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990311111, '', 'AUTO_AUTORIZATION', '', ' ', 2, 9903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990311112, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 9903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990311113, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 9903, 1, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(990311114, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 9903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990311115, '  ()', 'CREATEDATE', '  ()', ' ', 2, 9903, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990312116, '', 'AUTO_AUTORIZATION', '', ' ', 2, 9903, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990312117, '  ()', 'UPDATEDATE', '  ()', ' ', 2, 9903, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990312118, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 2, 9903, 2, 1, '', 0, null, 0, 1, '') ;

CALL ImportField(990312119, ' ()', 'UPDATERUSER', ' ()', ' ', 2, 9903, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990312120, '  ()', 'CREATEDATE', '  ()', ' ', 2, 9903, 2, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(990510026, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990510027, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990510028, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990510029, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9905, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990510030, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9905, 0, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(990810014, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9908, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990810015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9908, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990810016, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9908, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990810017, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9908, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990810018, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9908, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990811019, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9908, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990811020, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9908, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990811021, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9908, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990811022, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9908, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(990811023, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9908, 1, 1, '', 0, null, 0, 0, '') ;

--  , (1)
CALL ImportField(991210020, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9912, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991210021, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9912, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991210022, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9912, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991210023, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9912, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991210024, '  ()	', 'CREATEDATE', '  ()', ' ', 1, 9912, 0, 1, '', 0, null, 0, 0, '') ;

-- , (1)
CALL ImportField(991312035, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9913, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991312036, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9913, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991312037, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9913, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991312038, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9913, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991312039, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9913, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991314040, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9913, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991314041, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9913, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991314042, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9913, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991314043, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9913, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991314044, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9913, 4, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(991410010, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9914, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991410011, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9914, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991410012, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9914, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991410013, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9914, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991410014, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9914, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991411015, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9914, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991411016, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9914, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991411017, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9914, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991411018, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9914, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991411019, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9914, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(991510006, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9915, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991510007, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9915, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991510008, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9915, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991510009, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9915, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991510010, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9915, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991511011, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9915, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991511012, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9915, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991511014, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9915, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991511015, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9915, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(991511016, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9915, 1, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(992010012, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9920, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992010013, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9920, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992010014, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9920, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992010015, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9920, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992010016, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9920, 0, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(992110038, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9921, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992110039, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9921, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992110040, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9921, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992110041, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9921, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992110042, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9921, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992111019, '', 'KCSR', '', ' ', 1, 9921, 1, 1, '', 0, 17137, 0, 0, '') ;

CALL ImportField(992111020, '', 'KCSRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25462, 0, 0, '') ;

CALL ImportField(992111021, '', 'KESR', '', ' ', 1, 9921, 1, 1, '', 0, 17140, 0, 0, '') ;

CALL ImportField(992111022, '', 'KFSR', '', ' ', 1, 9921, 1, 0, '', 0, 17138, 0, 0, '') ;

CALL ImportField(992111024, '', 'KVR', '', ' ', 1, 9921, 1, 1, '', 0, 17139, 0, 0, '') ;

CALL ImportField(992111025, '', 'KVRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25467, 0, 0, '') ;

CALL ImportField(992111026, '', 'KVSR', '', ' ', 1, 9921, 1, 1, '', 0, 17136, 0, 0, '') ;

CALL ImportField(992111027, '', 'KVSRCode', '', ' ', 1, 9921, 1, 0, '', 0, 25472, 0, 0, '') ;

CALL ImportField(992111043, '()', 'KESRCode', '', ' ', 1, 9921, 1, 0, '', 0, 43607, 0, 0, '') ;

--   , (1)
CALL ImportField(992210021, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9922, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992210022, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9922, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992210023, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9922, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992210024, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9922, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992210025, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9922, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992211026, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9922, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992211027, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9922, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992211028, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9922, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992211029, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9922, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992211030, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9922, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(992310006, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9923, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992310007, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9923, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992310008, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9923, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992310009, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9923, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992310010, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9923, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992311011, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9923, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992311012, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9923, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992311013, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9923, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992311014, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9923, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992311015, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9923, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(992410005, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9924, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992410006, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9924, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992410007, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9924, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992410008, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9924, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992410009, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9924, 0, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(992510016, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9925, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992510017, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9925, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992510018, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9925, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992510019, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9925, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992510020, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9925, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992511021, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9925, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992511022, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9925, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992511023, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9925, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992511024, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9925, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992511025, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9925, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512001, '', 'KESR', '', ' ', 1, 9925, 2, 1, '', 0, 22627, 0, 0, '') ;

CALL ImportField(992512026, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9925, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512027, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9925, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512028, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9925, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512029, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9925, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512030, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9925, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992512031, '()', 'KESRCode', '', ' ', 1, 9925, 2, 0, '', 0, 43607, 0, 0, '') ;

--    , (1)
CALL ImportField(992610008, ' ', 'NumberingType', '', ' ', 1, 9926, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992610009, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9926, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992610010, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9926, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992610011, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9926, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992610012, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9926, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992610013, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9926, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992611014, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9926, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992611015, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9926, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992611016, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9926, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992611017, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9926, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992611018, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9926, 1, 1, '', 0, null, 0, 0, '') ;

--   , (1)
CALL ImportField(992710018, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992710019, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992710020, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9927, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992710021, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992710022, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992711023, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992711024, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992711025, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992711026, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992711027, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 1, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992712028, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992712029, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992712030, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992712031, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992712032, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 2, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992713033, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992713034, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992713035, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992713036, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992713037, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 3, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992714038, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992714039, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 4, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992715040, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992715041, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992715042, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992715043, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992715044, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 5, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992716045, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992716046, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992716047, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992716048, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992716049, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 6, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992717050, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992717051, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992717052, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992717053, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992717054, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 7, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992718055, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9927, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992718056, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9927, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992718057, '()', 'CREATERUSER', '()', 'CREATERUSER_DET', 1, 9927, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992718058, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9927, 8, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992718059, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9927, 8, 1, '', 0, null, 0, 0, '') ;

--    , (1)
CALL ImportField(992810002, '', 'KVR', '', ' ', 1, 9928, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992810003, '', 'KESR', '', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810005, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810006, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810007, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810008, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810009, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9928, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992810010, '()', 'KESRCode', '', ' ', 1, 9928, 0, 0, '', 0, 43607, 0, 0, '') ;

--     , (1)
CALL ImportField(992910002, '', 'KVSRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910003, '', 'KFSR', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910004, '', 'KCSRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910005, '', 'KVRCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910006, '', 'KESR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910008, '', 'SubKESR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910014, ' ', 'BudAllocationClsCode', '', ' ', 1, 9929, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(992910021, ' ()', 'KVSR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910022, ' ()', 'KCSR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910023, ' ()', 'KVR', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910028, '  ()', 'BudAllocationCls', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910031, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910032, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910033, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910034, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910035, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9929, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(992910036, '()', 'KESRCode', '', ' ', 1, 9929, 0, 0, '', 0, 43607, 0, 0, '') ;

CALL ImportField(992910037, '()', 'SubKESRCode', '', ' ', 1, 9929, 0, 0, '', 0, 43610, 0, 0, '') ;

--    , +(2)
CALL ImportField(993010009, '', 'KFSR', '', ' ', 2, 9930, 0, 0, '', 0, 39181, 0, 0, '') ;

CALL ImportField(993010010, '', 'KCSR', '', ' ', 2, 9930, 0, 0, '', 0, 39182, 0, 0, '') ;

CALL ImportField(993010011, '', 'KVSR', '', ' ', 2, 9930, 0, 0, '', 0, 39183, 0, 0, '') ;

CALL ImportField(993010012, '', 'KVR', '', ' ', 2, 9930, 0, 0, '', 0, 39184, 0, 0, '') ;

CALL ImportField(993010013, '', 'KESR', '', ' ', 2, 9930, 0, 1, '', 0, 39185, 0, 0, '') ;

CALL ImportField(993010026, '()', 'KESRCode', '', ' ', 2, 9930, 0, 0, '', 0, 43607, 0, 0, '') ;

--    , (1)
CALL ImportField(993110002, '', 'KFSR', '', ' ', 1, 9931, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993110003, '', 'KVR', '', ' ', 1, 9931, 0, 0, '', 0, null, 0, 0, '') ;

CALL ImportField(993110004, '', 'AUTO_AUTORIZATION', '', ' ', 1, 9931, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993110005, '  ()', 'UPDATEDATE', '  ()', ' ', 1, 9931, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993110006, '()', 'CREATERUSER', '()', 'CREATERUSER_CPT', 1, 9931, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993110007, ' ()', 'UPDATERUSER', ' ()', ' ', 1, 9931, 0, 1, '', 0, null, 0, 0, '') ;

CALL ImportField(993110008, '  ()', 'CREATEDATE', '  ()', ' ', 1, 9931, 0, 1, '', 0, null, 0, 0, '') ;

--       
ALTER TRIGGER TR_INTCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_VARCHARCONST_BU_500 ENABLE
/

ALTER TRIGGER TR_REALCONST_BU_500 ENABLE
/

DROP PROCEDURE ImportField
/

/*      */
ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 DISABLE
/

Update TB_DocumentFields df
set documentcls=doctyperef*100+detailnumber
where (detailnumber<100)and(documentcls is null)
 and(exists(select dc.id from documentcls dc where id=df.doctyperef*100+df.detailnumber))
/

ALTER TRIGGER TR_DOCUMENTFIELDS_BU_500 ENABLE
/

DROP PROCEDURE DeleteFields
/

DROP PROCEDURE InsertConst
/

DROP PROCEDURE DELETECONST
/




CREATE OR REPLACE PROCEDURE DOCLOCK_IMPORT(
  NAME_              VARCHAR2,
  LOCKMASK_          NUMBER,
  DOCREF_            NUMBER,
  DETAILNUM_         NUMBER,
  RUNPOS_            NUMBER,
  LOCKACTION_        NUMBER,
  USERIGHTS_        NUMBER,
  FORMULA_           VARCHAR2,
  FORDELETE_         NUMBER,
  ISSYSTEM_          NUMBER,
  NOTE_              VARCHAR2,
  FORINSERT_         NUMBER,
  VALIDATEMESSAGE_ VARCHAR2,
  VALIDATELEVEL_   NUMBER,
  VALIDATEFILTER_  VARCHAR2,
  ISBUDGET_ NUMBER)
IS
  DOCLOCKID$ Number(10);
BEGIN
   BEGIN
     SELECT ID
     INTO DOCLOCKID$
     FROM DOCLOCK
     WHERE (DOCREF = DOCREF_) AND(DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       DOCLOCKID$ := NULL;  
   END;
   
   IF (DOCLOCKID$ is not null) THEN
     IF (ISSYSTEM_ = 3) THEN
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_,
         USERIGHTS = USERIGHTS_
       WHERE ID = DOCLOCKID$;  
     ELSE
       UPDATE DOCLOCK SET
         NAME = NAME_,
         LOCKMASK = LOCKMASK_,
         DOCREF = DOCREF_,
         DETAILNUM = DETAILNUM_,
         RUNPOS = RUNPOS_,
         LOCKACTION = LOCKACTION_,
         FORMULA = FORMULA_,
         FORDELETE = FORDELETE_,
         ISSYSTEM = ISSYSTEM_,
         NOTE = NOTE_,
         FORINSERT = FORINSERT_,
         VALIDATEMESSAGE = VALIDATEMESSAGE_,
         VALIDATELEVEL = VALIDATELEVEL_,
         VALIDATEFILTER = VALIDATEFILTER_,
         ISBUDGET = ISBUDGET_
       WHERE ID = DOCLOCKID$;    
     END IF;  
   ELSE
     INSERT INTO DOCLOCK
       (ISBUDGET,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORMULA,FORDELETE,ISSYSTEM,NOTE,FORINSERT,VALIDATEMESSAGE,VALIDATELEVEL,VALIDATEFILTER)
     VALUES
       (ISBUDGET_,NAME_,LOCKMASK_,DOCREF_,DETAILNUM_,RUNPOS_,LOCKACTION_,USERIGHTS_,FORMULA_,FORDELETE_,ISSYSTEM_,NOTE_,FORINSERT_,VALIDATEMESSAGE_,VALIDATELEVEL_,VALIDATEFILTER_);
   END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(
  NAME_      VARCHAR2,
  DOCREF_    NUMBER,
  DETAILNUM_ NUMBER,
  FIELDREF_  NUMBER,
  ISBUDGET_ NUMBER)
IS
  NID$ NUMBER(10);
  cnt$ number(10);
BEGIN
  BEGIN
    SELECT ID
    INTO NID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      NID$ := NULL;  
  END;

  IF (NID$ is not null) THEN
    CNT$ := 0;
    SELECT count(ID)
    into cnt$
    FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    
    IF (cnt$ = 0) THEN
      INSERT INTO DOCLOCKFIELDS
        (DOCLOCKREF,FIELDREF,ISSYSTEM)
      VALUES
        (NID$,FIELDREF_,1);
    ELSE
      UPDATE DOCLOCKFIELDS SET
        ISSYSTEM = 1
      WHERE (DOCLOCKREF = NID$) AND (FIELDREF = FIELDREF_) ;
    END IF;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCK_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCK
    WHERE ID = DOCLOCKID$;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE DOCLOCKFIELDS_DELETE(NAME_ VARCHAR2, DOCREF_ NUMBER, DETAILNUM_ NUMBER, CANCHANGEFIELDS_ NUMBER, ISBUDGET_ NUMBER) IS
   DOCLOCKID$ NUMBER(10);
BEGIN
  BEGIN
    SELECT ID
    INTO DOCLOCKID$
    FROM DOCLOCK
    WHERE (DOCREF = DOCREF_) AND (DETAILNUM = DETAILNUM_) AND (NAME = NAME_) AND (ISBUDGET = ISBUDGET_);
  EXCEPTION  
    WHEN NO_DATA_FOUND THEN
      DOCLOCKID$ := NULL;
  END;  

  IF (DOCLOCKID$ is not null) THEN
    DELETE FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = DOCLOCKID$) AND ((ISSYSTEM = 1) OR ((ISSYSTEM = 0) AND (CANCHANGEFIELDS_ = 0) ));
  END IF;
END;
/

-- 
CALL DOCLOCK_DELETE('  ',213, -1, 1) ;

CALL DOCLOCK_DELETE('  ',213, -1, 1) ;

CALL DOCLOCK_DELETE('  ',302, -1, 1) ;

CALL DOCLOCK_DELETE('  ',302, -1, 1) ;

CALL DOCLOCK_DELETE('   ',2501, 2, 2) ;

CALL DOCLOCK_DELETE('   ',2502, 2, 2) ;

CALL DOCLOCK_DELETE('   ',2503, 2, 2) ;

CALL DOCLOCK_DELETE('   ',2504, 2, 2) ;

CALL DOCLOCK_DELETE('    ',2504, 4, 1) ;

CALL DOCLOCK_DELETE('    ',2504, 5, 2) ;

CALL DOCLOCK_DELETE('   ',3001, 1, 2) ;

CALL DOCLOCK_DELETE('   ',3006, 1, 2) ;

CALL DOCLOCK_DELETE('   ',3011, 1, 2) ;

CALL DOCLOCK_DELETE('  ',9903, 1, 1) ;

CALL DOCLOCK_IMPORT('   ',0,200,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[20011008])))',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011028,1) ;

CALL DOCLOCK_IMPORT('     ,',0,200,1,0,11,0,' ( in (213, 214, 215))',0,1,'          "",   -   ""',0,'       ""          ""  ',null,'((.[20011012]=2)  ([988410016] = 0)) 

((.[20011012]=0)  ([988410016] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('     ,', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ,',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('      ',0,200,1,0,11,0,'([20011012] = 0)   ( in (213, 214, 215))',0,1,'         , , , .    ,         ,      ',0,'       ',null,'(([988410025] = 0)  (.[20011018] = 0)  (.[20011024] = [988410026]))

(([988410022] = 0)  (.[20011020] = 0)  (.[20011020] = [988410022]))

(([988410023] = 0)  (.[20011019] = 0)  (.[20011023] = [988410024]))

(([988410018] = 0)  (.[20011022] = 0)  (.[20011025] = [988410019]))',1) ;

CALL DOCLOCKFIELDS_DELETE('      ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,' in (214, 215)',0,1,'',0,'      ""',null,'([988410016] = 0)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('     ',0,200,1,0,11,0,'([20011012] = 2)   ( in (213, 214, 215))',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[20011017] = 0)  ([988410008] = .[20011026]) 
   ((("..",[988410006])=0)
    (((".",.[20011017]), (".",[988410006]), "9.99.99.999.99"))
   (((".",[988410006])=(".",.[20011017]))
     ((".",[988410006])=0))
   (("..",[988410006])=("..",.[20011017]))) 
(((".", .[20011017]) div 100000) between 218 and 219)  
(((".", .[20011017]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 200, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',200,1,20011011,1) ;

CALL DOCLOCK_IMPORT('  ',32768,200,1,0,3,0,' ( in (205, 213))',0,1,'  ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011033,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011031,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',200,1,20011030,1) ;

CALL DOCLOCK_IMPORT('   ',32768,200,1,0,3,0,'((("..",[20010014]) between 10800  11199)    (("_...",[20011008]) between 10800  11199)     ((("_...",[20011008]) between 10000  10499)         (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011014,1) ;

CALL DOCLOCK_IMPORT('   ',32768,200,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011042,1) ;

CALL DOCLOCK_IMPORT('  ',0,201,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 201, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',201,-1,20111198,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',201,-1,20110083,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,201,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 201, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111207,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111050,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111049,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111055,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20111011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110018,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110017,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110016,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110010,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110023,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110003,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110012,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110005,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110006,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110007,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',201,-1,20110014,1) ;

CALL DOCLOCK_IMPORT('  ',0,201,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 201, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',201,-1,20110083,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',201,-1,20111198,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,202,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 202, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211046,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210013,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210010,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20211152,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',202,-1,20210015,1) ;

CALL DOCLOCK_IMPORT('  ',0,202,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 202, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',202,-1,20211115,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',202,-1,20210091,1) ;

CALL DOCLOCK_IMPORT('  ',0,202,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 202, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',202,-1,20210091,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',202,-1,20211115,1) ;

CALL DOCLOCK_IMPORT('    ',0,202,1,0,11,0,'([20211096]=0) ((32,45,3) between 0 and 2)',0,3,'         ,    "() "',0,'    .      ,    "() "',null,'(((32,45,3) = 0)   ([980410006] like "?00") 
   (([980410006] like "??0")  (".KVR[CODE].{COUNTNOTNULL(CODE)}",
  (''CODE like "''+ [980410006] div 1 +''_"''))>1))
 (((32,45,3) = 1)  ([980410006] like "??0")  ([980410006] <> "000")) 
 (((32,45,3) = 2)  ([980410006] like "?00")  ([980410006] <> "000"))',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 202, 1, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',202,1,20211021,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,203,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 203, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311161,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311046,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20311035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310013,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',203,-1,20310010,1) ;

CALL DOCLOCK_IMPORT('  ',0,203,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 203, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',203,-1,20310082,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',203,-1,20311103,1) ;

CALL DOCLOCK_IMPORT('  ',0,203,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 203, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',203,-1,20311103,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',203,-1,20310082,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,204,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 204, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411152,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411070,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411046,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411036,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20411035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410069,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410043,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410040,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410020,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410013,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',204,-1,20410010,1) ;

CALL DOCLOCK_IMPORT('  ',0,204,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 204, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',204,-1,20410087,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',204,-1,20411124,1) ;

CALL DOCLOCK_IMPORT('  ',0,204,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 204, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',204,-1,20411124,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',204,-1,20410087,1) ;

CALL DOCLOCK_IMPORT('   ',0,204,0,0,11,0,'',0,1,'    .    () ,         01.08.00  01.11.99',0,'  .     () , (),   ,   ',null,'([960110035] between 10800 and 11199)',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 204, 0, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',204,0,20410039,1) ;

CALL DOCLOCK_IMPORT('   / ()',0,204,0,0,11,0,'',0,1,'  - \ (). -          01.08.00  01.11.99',0,'-      () , (),   ,   ',null,'(("..",[984110031]) between 10800 and 11199)',1) ;

CALL DOCLOCKFIELDS_DELETE('   / ()', 204, 0, 0, 1) ;

--  "\  "
CALL DOCLOCKFIELDS_INSERTFIELD('   / ()',204,0,20410034,1) ;

CALL DOCLOCK_IMPORT('   /',0,204,1,0,11,0,'',0,1,'  - \. -          01.08.00  01.11.99',0,'-      () , (),   ,   ',null,'(("..",[984110031]) between 10800 and 11199)',1) ;

CALL DOCLOCKFIELDS_DELETE('   /', 204, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   /',204,1,20411033,1) ;

CALL DOCLOCK_IMPORT('    / ,  ()',0,204,1,0,10,0,' (([20411033] <> 0)  (("_._",[20411033]))  (("_...",[20411033]) = 11000)  ([20411087] = 0))',0,3,'       /, -   ()',0,'         "/"    ()',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    / ,  ()', 204, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,  ()',204,1,20411087,1) ;

CALL DOCLOCK_IMPORT('  ',0,205,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 205, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',205,-1,20510090,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',205,-1,20511111,1) ;

CALL DOCLOCK_IMPORT('  ',0,205,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 205, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',205,-1,20511111,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',205,-1,20510090,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,206,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 206, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611201,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20611036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',206,-1,20610011,1) ;

CALL DOCLOCK_IMPORT('  ',0,206,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 206, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',206,-1,20610090,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',206,-1,20611190,1) ;

CALL DOCLOCK_IMPORT('  ',0,206,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 206, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',206,-1,20611190,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',206,-1,20610090,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,207,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 207, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711222,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20711036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',207,-1,20710011,1) ;

CALL DOCLOCK_IMPORT('  ',0,207,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 207, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',207,-1,20710161,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',207,-1,20711190,1) ;

CALL DOCLOCK_IMPORT('  ',0,207,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 207, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',207,-1,20711190,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',207,-1,20710161,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,208,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 208, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811224,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811071,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811047,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20811036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810070,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810046,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810044,1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810042,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810038,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810021,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810014,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',208,-1,20810011,1) ;

CALL DOCLOCK_IMPORT('  ',0,208,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 208, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',208,-1,20810161,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',208,-1,20811191,1) ;

CALL DOCLOCK_IMPORT('  ',0,208,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 208, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',208,-1,20811191,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',208,-1,20810161,1) ;

CALL DOCLOCK_IMPORT('  ',0,209,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 209, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,-1,20910028,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,-1,20911145,1) ;

CALL DOCLOCK_IMPORT('  ',0,209,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 209, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,-1,20911145,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',209,-1,20910028,1) ;

CALL DOCLOCK_IMPORT('   ',32768,209,2,0,3,0,'((("..",[20910021]) between 10800  11199)    (("_...",[20912007]) between 10800  11199)     ((("_...",[20912007]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 209, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',209,2,20912040,1) ;

CALL DOCLOCK_IMPORT('   ',32768,209,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 209, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',209,2,20912048,1) ;

CALL DOCLOCK_IMPORT('  ',0,210,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 210, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21012061,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21010028,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21011049,1) ;

CALL DOCLOCK_IMPORT('  ',0,210,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 210, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21012061,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21011049,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',210,-1,21010028,1) ;

CALL DOCLOCK_IMPORT('   ',32768,210,2,0,3,0,'((("..",[21010021]) between 10800  11199)   (("_...",[21010014]) between 10000  10499))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,1',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 210, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',210,2,21012052,1) ;

CALL DOCLOCK_IMPORT('   ',32768,210,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 210, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',210,2,21012067,1) ;

CALL DOCLOCK_IMPORT('  ',0,211,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 211, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21112050,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21110028,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21111050,1) ;

CALL DOCLOCK_IMPORT('  ',0,211,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 211, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21112050,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21111050,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',211,-1,21110028,1) ;

CALL DOCLOCK_IMPORT('   ',32768,211,2,0,3,0,'((("..",[21110019]) between 10800  11199)    (("_...",[21112006]) between 10800  11199)     ((("_...",[21112006]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 211, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',211,2,21112033,1) ;

CALL DOCLOCK_IMPORT('   ',32768,211,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 211, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',211,2,21112051,1) ;

CALL DOCLOCK_IMPORT('  ',0,212,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 212, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21212051,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21210028,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21211051,1) ;

CALL DOCLOCK_IMPORT('  ',0,212,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 212, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21212051,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21211051,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',212,-1,21210028,1) ;

CALL DOCLOCK_IMPORT('   /',0,212,2,0,11,0,'',0,1,'  - \. -          01.08.00  01.10.99',0,'-      ()   ()',null,'(("..",[984110031]) between 10800 and 11099)',1) ;

CALL DOCLOCKFIELDS_DELETE('   /', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   /',212,2,21212006,1) ;

CALL DOCLOCK_IMPORT('   ',32768,212,2,0,3,0,'((("..",[21210019]) between 10800  11199)    (("_...",[21212006]) between 10800  11199)     ((("_...",[21212006]) between 10000  10499)      (=204) ))',0,1,'  " "  \   -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  .(.) ).           ,',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',212,2,21212033,1) ;

CALL DOCLOCK_IMPORT('    / ,  ()',0,212,2,0,10,0,' (([21212006] <> 0)  (("_._",[21212006]))  (("_...",[21212006]) = 11000)  ([21212003] = 0))',0,3,'       /, -   ()',0,'         "/"    ()',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    / ,  ()', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    / ,  ()',212,2,21212003,1) ;

CALL DOCLOCK_IMPORT('   ',32768,212,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 212, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',212,2,21212052,1) ;

CALL DOCLOCK_IMPORT('  ',0,213,-1,0,15,1,'',0,1,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 213, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21311008,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21310031,2) ;

CALL DOCLOCK_IMPORT('  ',0,213,-1,0,12,0,'',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 213, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21311008,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',213,-1,21310031,2) ;

CALL DOCLOCK_IMPORT('   ',0,213,1,0,11,0,'',0,3,'    01.01. - 01.03.',0,'    (01.01.)   (01.02. - 01.03.)',null,'([960110035] between 10100 and 10399)',2) ;

CALL DOCLOCKFIELDS_DELETE('   ', 213, 1, 0, 2) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',213,1,21311051,2) ;

CALL DOCLOCK_IMPORT('      ()',0,213,1,0,11,0,'(-1,5,3) <> 2',0,1,' ,    = ,    ,          "    ().  = ""',0,'      ""        ',null,'([988410016] = 0)  ([988410008] = (".",.[21311041]))',1) ;

CALL DOCLOCKFIELDS_DELETE('      ()', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      ()',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('      (,)',0,213,1,0,11,0,'((-1,5,3) = 2)  (("",[21310031] , 277, 213) <> 2)',0,1,' ,    = ,          "    ().  = ""',0,'      ""        ',null,'([988410016] = 0)  ([988410008] = (".",.[21311041]))',1) ;

CALL DOCLOCKFIELDS_DELETE('      (,)', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      (,)',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('      (, )',0,213,1,0,11,0,'((-1,5,3) = 2)  (("",[21310031] , 277, 213) = 2)',0,1,' ,    = ,              "    ()".  = ""',0,'      ""           ',null,'([988410016] = 1)  ([988410026] = ("..",.[21311044])) 
([988410022] = ("..",.[21311044]))  
([988410019] = ("..",.[21311044]))  
([988410024] = ("..",.[21311044]))',1) ;

CALL DOCLOCKFIELDS_DELETE('      (, )', 213, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('      (, )',213,1,21311011,1) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21411008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21410031,1) ;

CALL DOCLOCK_IMPORT('  ',0,214,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 214, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21411008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',214,-1,21410031,1) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21511008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21510031,1) ;

CALL DOCLOCK_IMPORT('  ',0,215,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 215, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21511008,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',215,-1,21510031,1) ;

CALL DOCLOCK_IMPORT('     (3)',0,300,0,0,11,0,'(("/._",[30010021]) = 1)   (("/.",[30010021]) = 0)   (("/._",[30010021]) = 0)  (("/.",[30010021]) = 0)  (("/.",[30010021])=0)',0,1,'         /,   /c,      (),    ,   ',0,'         (),     ',null,'((".",[984110031]) between 011000 and 011199) 
((".",[984110031]) between 010100 and 010199)',1) ;

CALL DOCLOCKFIELDS_DELETE('     (3)', 300, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('     (3)',300,0,30010008,1) ;

CALL DOCLOCK_IMPORT('     , ',0,300,1,0,11,0,'(("_._",[30010008])    ("_._",[30010008])    ("_.",[30010008]))  ( in(0323,0324))',0,1,',     ,   =- \,  =.    \ \,     <>.   \ \      .',0,'         ',null,'([988910008] = ("_.",.[30010008])
 ((".",[988910008]) between 10100  10199))
   
(( ("_._",.[30010008])
 ([988910010] = 0))

(("_._",.[30010008])
 ([988910010] <> 0)))',1) ;

CALL DOCLOCKFIELDS_DELETE('     , ', 300, 1, 0, 1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     , ',300,1,30011023,1) ;

CALL DOCLOCK_IMPORT('     ',0,300,1,0,11,0,'([30011019] = 2)   ((( <> 305)  ( <> 302))    (("_..",[30010008]) between 010800 and 011099))',0,3,'          ,    / , ()         /.      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[30011025] = 0)  (.[30011034] = [988410008])
 ((("..",[988410006])=0)
  (((".",.[30011025]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[30011025]))
     ((".",[988410006])=0))
 (("..",[988410006])=("..",.[30011025])))
 (((".", .[30011025]) div 100000) between 218 and 219) 
 (((".", .[30011025]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 300, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',300,1,30011018,1) ;

CALL DOCLOCK_IMPORT('  ',32768,300,1,0,3,0,'([30011019] = 1) (("_.",[30011041])=0)',0,1,'  "  "   ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 300, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',300,1,30011020,1) ;

CALL DOCLOCK_IMPORT('   ',32768,300,1,0,3,0,'((("_...",[30010008]) between 10800  11199)    (("_...",[30010008]) between 10000  10499)   ( in(0323,0324)))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',300,1,30011022,1) ;

CALL DOCLOCK_IMPORT('   ',32768,300,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 300, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',300,1,30011046,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,301,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111100,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111002,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111048,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111012,1) ;

--  " - ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111010,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111028,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111101,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111032,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111030,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111001,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111022,1) ;

--  " - -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111025,1) ;

--  " .  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111031,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111029,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111219,1) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,-1,30111215,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,301,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 301, -1, 1, 1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111219,1) ;

--  " -( -)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111215,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111027,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111100,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111002,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111011,1) ;

--  "  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111048,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111012,1) ;

--  " - ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111050,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111028,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111023,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111101,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111032,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111030,1) ;

--  " ( -)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111052,1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111001,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111022,1) ;

--  " - -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111025,1) ;

--  " .  -"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111031,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30111029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',301,-1,30110098,1) ;

CALL DOCLOCK_IMPORT('     ',0,301,1,0,11,0,'',0,3,'     ',0,'      ',null,'((.[30011019] = 0)  ([986810009] = 1)) 
((.[30011019] = 1)  ([986810008] = 1)) 
((.[30011019] = 2)  ([986810007] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 301, 1, 0, 1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD('     ',301,1,30111005,1) ;

CALL DOCLOCK_IMPORT('    .  ',0,301,1,0,11,0,'[30110110] = 2',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[30111122] = 0)  (.[30111130] = [988410008])
 ((("..",[988410006])=0)
    (((".",.[30111122]), (".",[988410006]), "9.99.99.999.99"))
   (((".",[988410006])=(".",.[30111122]))
     ((".",[988410006])=0))
   (("..",[988410006])=("..",.[30111122])))
 (((".", .[30111122]) div 100000) between 218 and 219)
 (((".", .[30111122]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('    .  ', 301, 1, 0, 1) ;

--  "   ."
CALL DOCLOCKFIELDS_INSERTFIELD('    .  ',301,1,30111136,1) ;

CALL DOCLOCK_IMPORT('  ',32768,301,1,0,3,0,'([30110110] = 1) (("_.",[30111119])=0)',0,1,'  "   .", "   ."   ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 301, 1, 0, 1) ;

--  "   -"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',301,1,30111138,1) ;

--  "   ."
CALL DOCLOCKFIELDS_INSERTFIELD('  ',301,1,30111137,1) ;

CALL DOCLOCK_IMPORT('    ',32768,301,1,0,3,0,'((("_...",[30111014]) between 10800  11199)    (("_...",[30111014]) between 10000  10499) )',0,1,'  "  "  \    -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,  ()).',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30111150,1) ;

CALL DOCLOCK_IMPORT('    ',0,301,1,0,11,0,'',0,3,'     ',0,'      ',null,'((.[30011019] = 0)  ([986810009] = 1)) 
((.[30001019] = 1)  ([986810008] = 1)) 
((.[30001019] = 2)  ([986810007] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30111017,1) ;

CALL DOCLOCK_IMPORT('    ',32768,301,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 301, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',301,1,30111192,1) ;

CALL DOCLOCK_IMPORT('  ',0,302,-1,0,15,1,'',0,1,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 302, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30211158,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30210163,2) ;

CALL DOCLOCK_IMPORT('  ',0,302,-1,0,12,0,'',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 302, -1, 0, 2) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30211158,2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',302,-1,30210163,2) ;

CALL DOCLOCK_IMPORT('    ',1074855941,302,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 302, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211015,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211008,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211012,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211016,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211041,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',302,-1,30211222,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,302,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 302, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211222,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211041,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211012,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211043,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211015,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211011,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30211008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210104,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210025,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210005,1) ;

--  " /"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',302,-1,30210034,1) ;

CALL DOCLOCK_IMPORT('    ',1075904517,303,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 303, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311026,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311037,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311039,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311018,1) ;

--  " . -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311030,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311040,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',303,-1,30311119,1) ;

CALL DOCLOCK_IMPORT('    ',1075904517,304,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 304, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411007,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411001,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411018,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411010,1) ;

--  " O "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411009,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411008,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',304,-1,30411178,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1075838980,304,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 304, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411178,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411007,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411001,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411018,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411045,1) ;

--  " O "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411004,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411009,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30411008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410022,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410096,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',304,-1,30410011,1) ;

CALL DOCLOCK_IMPORT('  ',0,304,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 304, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410150,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30411149,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410147,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410148,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410151,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410149,1) ;

CALL DOCLOCK_IMPORT('  ',0,304,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 304, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410150,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30411149,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410151,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410149,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410148,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',304,-1,30410147,1) ;

CALL DOCLOCK_IMPORT('  - \',32768,304,1,0,3,0,'(("_..",[30410017]) < 10800)  (("_..",[30410017]) > 11199)',0,3,'  " "      -   01.08.00-01.11.99.',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  - \', 304, 1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ,   ',2097156,305,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 305, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511190,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511023,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511022,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511020,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511103,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511104,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30511035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',305,-1,30510099,1) ;

CALL DOCLOCK_IMPORT('    ',2228229,305,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 305, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511190,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511023,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511022,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511103,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511019,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',305,-1,30511104,1) ;

CALL DOCLOCK_IMPORT('  ',0,305,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 305, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30510173,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30511150,1) ;

CALL DOCLOCK_IMPORT('  ',0,305,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 305, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30511150,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',305,-1,30510173,1) ;

CALL DOCLOCK_IMPORT(' ,   ',4194308,306,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 306, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611208,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611023,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611049,1) ;

--  " ( . - )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611036,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611033,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611024,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611040,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30611035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',306,-1,30610011,1) ;

CALL DOCLOCK_IMPORT('    ',4325381,306,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 306, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611208,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611032,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611023,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611049,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611033,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611024,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',306,-1,30611035,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,308,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811050,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811043,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811041,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811036,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811035,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811025,1) ;

--  " .  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811018,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811017,1) ;

--  " ( .)"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811261,1) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811256,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,-1,30811008,1) ;

CALL DOCLOCK_IMPORT(' ,   ',1074790404,308,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 308, -1, 1, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811050,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811049,1) ;

--  " .  ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811043,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811041,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811037,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811036,1) ;

--  " .( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811035,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810015,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810013,1) ;

--  " ."
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30810006,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811025,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811024,1) ;

--  "  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811020,1) ;

--  " .  ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811018,1) ;

--  " - "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811016,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811009,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811008,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811002,1) ;

--  " ( .)"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811261,1) ;

--  " ( )"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',308,-1,30811256,1) ;

CALL DOCLOCK_IMPORT('  ',0,308,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 308, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810075,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30811119,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810071,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810072,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810073,1) ;

CALL DOCLOCK_IMPORT('  ',0,308,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 308, -1, 0, 1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810073,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30811119,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810075,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810072,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',308,-1,30810071,1) ;

CALL DOCLOCK_IMPORT('    .  ',0,308,1,0,11,0,'[30811003] = 2',0,1,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[30811019] = 0)  (.[30811093] = [988410008]) 
 ((("..",[988410006])=0)
  (((".",.[30811019]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[30811019]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[30811019])))
 (((".", .[30811019]) div 100000) between 218 and 219)
 (((".", .[30811019]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('    .  ', 308, 1, 0, 1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('    .  ',308,1,30811063,1) ;

CALL DOCLOCK_IMPORT('   ',32768,308,1,0,3,0,'((("_...", [30810064]) between 10800  11199)     (("_...",[30810064]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).    3.23,3.24()',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 308, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',308,1,30811082,1) ;

CALL DOCLOCK_IMPORT('    ',0,308,1,0,11,0,'',0,3,'     ',0,'      ',null,'((.[30810063] = 0)  ([986810009] = 1)) 
((.[30810063] = 1)  ([986810008] = 1)) 
((.[30810063] = 2)  ([986810007] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 1) ;

--  " .()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30811045,1) ;

CALL DOCLOCK_IMPORT('    ',32768,308,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 308, 1, 0, 1) ;

--  "  -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',308,1,30811121,1) ;

CALL DOCLOCK_IMPORT('    ',1048577,322,-1,0,4,2,'',0,2,'      ,  ,     .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 322, -1, 1, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211040,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211045,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211033,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211042,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211041,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211028,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211043,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211044,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32210020,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',322,-1,32211103,1) ;

CALL DOCLOCK_IMPORT('  ',0,322,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 322, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210082,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32211094,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210078,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210079,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210080,1) ;

CALL DOCLOCK_IMPORT('  ',0,322,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 322, -1, 0, 1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210078,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210079,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210080,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32211094,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',322,-1,32210082,1) ;

CALL DOCLOCK_IMPORT('  ',0,323,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 323, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310143,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310144,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32311167,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310140,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310141,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310142,1) ;

CALL DOCLOCK_IMPORT('  ',0,323,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 323, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310143,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310140,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310141,1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310142,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32311167,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',323,-1,32310144,1) ;

CALL DOCLOCK_IMPORT('   ',32768,323,1,0,3,0,'((("_...", [32311012]) between 10800  11199)   (("_...",[32311012]) between 10000  10499))',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32311150,1) ;

CALL DOCLOCK_IMPORT('   ',0,323,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32311012])))',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32311163,1) ;

CALL DOCLOCK_IMPORT('   ',32768,324,-1,0,3,0,'((("_...",[32411026]) between 10800  11199)    (("_...",[32411026]) between 10000  10499) )',0,1,'  " "      -   01.08.00-01.11.99  01.01.00-01.04.99 ( ,  ,  () ,   ()).',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, -1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,-1,32411191,1) ;

CALL DOCLOCK_IMPORT('    ',1074855941,324,-1,0,4,2,'',0,2,'      ,  ,    .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 324, -1, 1, 1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411074,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411080,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411083,1) ;

--  " ( . - )"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411030,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411084,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411072,1) ;

--  " -"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411073,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411082,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411040,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',324,-1,32411268,1) ;

CALL DOCLOCK_IMPORT('  ',0,324,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 324, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410181,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32411207,1) ;

CALL DOCLOCK_IMPORT('  ',0,324,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 324, -1, 0, 1) ;

--  " (  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410179,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32411207,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410181,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410178,1) ;

--  "(  )"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410177,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',324,-1,32410180,1) ;

CALL DOCLOCK_IMPORT('   ',0,324,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011199)
([960110021]=("_.",.[32411026])))',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 324, 1, 0, 1) ;

--  " ()"
CALL DOCLOCKFIELDS_INSERTFIELD('   ',324,1,32411204,1) ;

CALL DOCLOCK_IMPORT('    ',1,703,-1,0,4,2,'',0,2,'      .         .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 703, -1, 1, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310021,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310010,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310009,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310019,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('    ',703,-1,70310056,1) ;

CALL DOCLOCK_IMPORT(' ,   ',65540,801,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 801, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111094,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111048,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111005,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111009,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111014,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111016,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111035,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80111027,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110002,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110012,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110007,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110044,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',801,-1,80110017,1) ;

CALL DOCLOCK_IMPORT('   ',32768,801,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 801, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',801,1,80111079,1) ;

CALL DOCLOCK_IMPORT('   ',32768,802,0,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 802, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',802,0,80210044,1) ;

CALL DOCLOCK_IMPORT('   ',32768,803,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 803, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',803,1,80311057,1) ;

CALL DOCLOCK_IMPORT('     ',0,900,1,0,11,0,'([90011001] = 2)  (( <> 903)    (("_..",[90011008]) between 010800 and 011099))',0,3,'          ,  / , ()   (09.03)   .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[90011004] = 0)  (.[90011005] = [988410008]) 
 ((("..",[988410006])=0)
  (((".",.[90011004]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[90011004]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[90011004])))
 (((".", .[90011004]) div 100000) between 218 and 219) 
 (((".", .[90011004]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 900, 1, 0, 1) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',900,1,90011002,1) ;

CALL DOCLOCK_IMPORT('  ',32768,900,1,0,3,0,'([90011001] = 1) (("_.",[90011006])=0)',0,1,'  "  "   ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 900, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',900,1,90011003,1) ;

CALL DOCLOCK_IMPORT('  ',0,903,1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 903, 1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',903,1,90311095,1) ;

CALL DOCLOCK_IMPORT('   ',32768,903,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 903, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',903,1,90311096,1) ;

CALL DOCLOCK_IMPORT('  ',0,903,1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 903, 1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',903,1,90311095,1) ;

CALL DOCLOCK_IMPORT('  ',0,905,0,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 905, 0, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',905,0,90510047,1) ;

CALL DOCLOCK_IMPORT('   ',32768,905,0,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 905, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',905,0,90510051,1) ;

CALL DOCLOCK_IMPORT('  ',0,905,0,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 905, 0, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',905,0,90510047,1) ;

CALL DOCLOCK_IMPORT('   ',32768,906,0,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 906, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',906,0,90610096,1) ;

CALL DOCLOCK_IMPORT('  ',0,906,1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 906, 1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',906,1,90611089,1) ;

CALL DOCLOCK_IMPORT('   ',32768,906,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 906, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',906,1,90611100,1) ;

CALL DOCLOCK_IMPORT('  ',0,906,1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 906, 1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',906,1,90611089,1) ;

CALL DOCLOCK_IMPORT('  ',0,907,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 907, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',907,-1,90710059,1) ;

CALL DOCLOCK_IMPORT('  ',0,907,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 907, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',907,-1,90710059,1) ;

CALL DOCLOCK_IMPORT('   ',32768,907,0,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 907, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',907,0,90710060,1) ;

CALL DOCLOCK_IMPORT(' ,   ',131076,1601,-1,0,4,2,'',0,2,'     ,   .       . ,     .',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ,   ', 1601, -1, 1, 1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111107,1) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111052,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111053,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111026,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111029,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111018,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111045,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111017,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111030,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111027,1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160111028,1) ;

--  "/"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110003,1) ;

--  " /"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110002,1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110001,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110051,1) ;

--  "  ()"
CALL DOCLOCKFIELDS_INSERTFIELD(' ,   ',1601,-1,160110050,1) ;

CALL DOCLOCK_IMPORT('  ',0,1816,0,0,9,0,'(([181610099] is null)  ((30,35,3) = 0)  ((30,15,3) = 1)) ? (1) : (((".",[181610099]) = 1)    ((".",[181610099]) = 0)    ((".",[181610099]) <> 0)    ((".",[181610099])=[181610024]) )',0,3,'  ',0,'          ',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,0,181610099,1) ;

CALL DOCLOCK_IMPORT('  ',0,1816,1,0,9,0,'(([181611100] is null)  ((30,35,3) = 0)  ((30,15,3) = 1)) ? (1) : (((".",[181611100]) = 1)    ((".",[181611100]) = 0)    ((".",[181611100]) <> 0)    ((".",[181611100])=[181611095]) )',0,3,'  ',0,'          ',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1816, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1816,1,181611100,1) ;

CALL DOCLOCK_IMPORT('   ',32768,1900,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 1900, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',1900,1,190011042,1) ;

CALL DOCLOCK_IMPORT('  ',0,1901,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1901, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,-1,190110088,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,-1,190111108,1) ;

CALL DOCLOCK_IMPORT('  ',0,1901,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1901, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,-1,190111108,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1901,-1,190110088,1) ;

CALL DOCLOCK_IMPORT('  ',0,1902,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1902, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,-1,190210087,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,-1,190211106,1) ;

CALL DOCLOCK_IMPORT('  ',0,1902,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1902, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,-1,190211106,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1902,-1,190210087,1) ;

CALL DOCLOCK_IMPORT('  ',0,1903,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1903, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,-1,190310088,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,-1,190311107,1) ;

CALL DOCLOCK_IMPORT('  ',0,1903,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1903, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,-1,190311107,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1903,-1,190310088,1) ;

CALL DOCLOCK_IMPORT('  ',0,1906,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1906, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,-1,190610089,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,-1,190611109,1) ;

CALL DOCLOCK_IMPORT('  ',0,1906,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 1906, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,-1,190610089,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',1906,-1,190611109,1) ;

CALL DOCLOCK_IMPORT('  ',0,2201,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2201, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,-1,220110071,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,-1,220111082,1) ;

CALL DOCLOCK_IMPORT('  ',0,2201,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2201, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,-1,220111082,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2201,-1,220110071,1) ;

CALL DOCLOCK_IMPORT('     ',0,2201,1,0,11,0,'',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[220111046] = 0)  (.[220111012] = [988410008])
 ((("..",[988410006])=0)                          
  (((".",.[220111046]), (".",[988410006]), "9.99.99.999.99")) 
  (((".",[988410006])=(".",.[220111046]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[220111046])))
 (((".", .[220111046]) div 100000) between 218 and 219) 
 (((".", .[220111046]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 2201, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',2201,1,220111064,1) ;

CALL DOCLOCK_IMPORT('   ',32768,2201,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  " ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 2201, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',2201,1,220111083,1) ;

CALL DOCLOCK_IMPORT('  ',0,2502,0,0,15,1,'',0,1,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2502, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2502,0,250210074,2) ;

CALL DOCLOCK_IMPORT('  ',0,2502,0,0,12,0,'',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2502, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2502,0,250210074,2) ;

CALL DOCLOCK_IMPORT('      ',0,2502,2,0,11,0,'',0,3,'         , , , .',0,'       ',null,'(([988410025] = 0)  (.[250212026] = 0)  (.[250212041] = [988410026]))

(([988410022] = 0)  (.[250212028] = 0)  (.[250212028] = [988410022]))

(([988410023] = 0)  (.[250212027] = 0)  (.[250212042] = [988410024]))

(([988410018] = 0)  (.[250212030] = 0)  (.[250212043] = [988410019]))',2) ;

CALL DOCLOCKFIELDS_DELETE('      ', 2502, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2502,2,250212077,2) ;

CALL DOCLOCK_IMPORT('  ',0,2503,0,0,15,1,'',0,1,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,0,250310068,2) ;

CALL DOCLOCK_IMPORT('  ',0,2503,0,0,12,0,'',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,0,250310068,2) ;

CALL DOCLOCK_IMPORT('  ',0,2503,2,0,12,0,'(50,52,3) = 1',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2503, 2, 0, 2) ;

--  "    "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312054,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312055,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312029,2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312002,2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312028,2) ;

--  "    "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2503,2,250312075,2) ;

CALL DOCLOCK_IMPORT('      ',0,2503,2,0,11,0,'',0,3,'         , , , .',0,'       ',null,'(([988410025] = 0)  (.[250312073] = 0)  (.[250312014] = [988410026]))

(([988410022] = 0)  (.[250312012] = 0)  (.[250312012] = [988410022]))

(([988410023] = 0)  (.[250312071] = 0)  (.[250312013] = [988410024]))

(([988410018] = 0)  (.[250312070] = 0)  (.[250312010] = [988410019]))',2) ;

CALL DOCLOCKFIELDS_DELETE('      ', 2503, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2503,2,250312074,2) ;

CALL DOCLOCK_IMPORT('  ',65536,2504,-1,0,7,0,'[250410104] is null',1,3,'   .   ,   .           .',2,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, -1, 0, 2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,10,0,'[250410086] <= [250410083]',0,1,'        ',0,'              ',0,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410083,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,10,0,'([250410086] <= [250410083])  ([250410083] is null)',0,1,'',0,'              ',0,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410086,2) ;

CALL DOCLOCK_IMPORT('   36  ',0,2504,0,0,10,0,'[250410101] like "____________________________________"  [250410101] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2) ;

CALL DOCLOCKFIELDS_DELETE('   36  ', 2504, 0, 0, 2) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('   36  ',2504,0,250410101,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,15,1,'',0,1,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410116,2) ;

CALL DOCLOCK_IMPORT('  ',0,2504,0,0,12,0,'',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 2504, 0, 0, 2) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',2504,0,250410116,2) ;

CALL DOCLOCK_IMPORT('    ',0,2504,2,0,11,0,'',0,3,'     ',0,'      ',null,'[986810009]',2) ;

CALL DOCLOCKFIELDS_DELETE('    ', 2504, 2, 0, 2) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',2504,2,250412036,2) ;

CALL DOCLOCK_IMPORT('      ',0,2504,2,0,11,1,'',0,1,'         , , , .',0,'       ',null,'(([988410025] = 0)  (.[250412032] = 0)  (.[250412031] = [988410026]))

(([988410022] = 0)  (.[250412035] = 0)  (.[250412035] = [988410022]))

(([988410023] = 0)  (.[250412034] = 0)  (.[250412033] = [988410024]))

(([988410018] = 0)  (.[250412038] = 0)  (.[250412037] = [988410019]))',2) ;

CALL DOCLOCKFIELDS_DELETE('      ', 2504, 2, 0, 2) ;

--  "   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2504,2,250412108,2) ;

CALL DOCLOCK_IMPORT('      ',0,2504,4,0,11,0,'',0,3,'',0,'      ',null,'[986810009]',2) ;

CALL DOCLOCKFIELDS_DELETE('      ', 2504, 4, 0, 2) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('      ',2504,4,250414135,2) ;

CALL DOCLOCK_IMPORT(' ',65540,3005,-1,0,4,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ', 3005, -1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510011,1) ;

CALL DOCLOCK_IMPORT('    -',0,3006,0,0,10,0,'([300610051] is not null)  ([300610017] < 2017)',0,1,'',0,'    -',0,'',2) ;

CALL DOCLOCKFIELDS_DELETE('    -', 3006, 0, 0, 2) ;

--  "  /"
CALL DOCLOCKFIELDS_INSERTFIELD('    -',3006,0,300610051,2) ;

CALL DOCLOCK_IMPORT(' ',65540,3010,0,0,4,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ', 3010, 0, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010019,1) ;

CALL DOCLOCK_IMPORT('     ',0,3011,0,0,10,0,'[301110029] is not null',0,1,'',0,'     ',0,'',2) ;

CALL DOCLOCKFIELDS_DELETE('     ', 3011, 0, 0, 2) ;

--  "  /"
CALL DOCLOCKFIELDS_INSERTFIELD('     ',3011,0,301110029,2) ;

CALL DOCLOCK_IMPORT('  ',0,4401,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 4401, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,-1,440110061,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,-1,440111072,1) ;

CALL DOCLOCK_IMPORT('  ',0,4401,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 4401, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,-1,440111072,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4401,-1,440110061,1) ;

CALL DOCLOCK_IMPORT('  ',0,4403,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 4403, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4403,-1,440311069,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4403,-1,440310057,1) ;

CALL DOCLOCK_IMPORT('  ',0,4403,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 4403, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4403,-1,440311069,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',4403,-1,440310057,1) ;

CALL DOCLOCK_IMPORT('  ',0,5201,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,-1,520111079,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,-1,520110062,1) ;

CALL DOCLOCK_IMPORT('  ',0,5201,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,-1,520111079,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,-1,520110062,1) ;

CALL DOCLOCK_IMPORT('      . . ',0,5201,0,0,11,0,'[520110052] in (1,4,6)',0,3,'',0,'   .   , ,          ',null,' (([984110042] = 1)  ([984110044] = 1)  ([984110043] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('      . . ', 5201, 0, 0, 1) ;

--  "/  "
CALL DOCLOCKFIELDS_INSERTFIELD('      . . ',5201,0,520110033,1) ;

CALL DOCLOCK_IMPORT('      . ',0,5201,0,0,11,0,'[520110052] in (0,3,5)',0,3,'',0,'   .       ", "  " , " ',null,' (([984110041] = 1)  ([984110045] = 1)  ([984110046] = 1))',1) ;

CALL DOCLOCKFIELDS_DELETE('      . ', 5201, 0, 0, 1) ;

--  "/  "
CALL DOCLOCKFIELDS_INSERTFIELD('      . ',5201,0,520110033,1) ;

CALL DOCLOCK_IMPORT('  ',0,5201,0,0,12,0,'(5201, "") <> 0',0,3,'',0,'',null,'',2) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 0, 0, 2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110046,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110045,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110044,2) ;

--  "()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110039,2) ;

CALL DOCLOCK_IMPORT('  ',0,5201,0,0,10,0,'([520110033] = 0)  ([520110052] in (2))  (([520110052] in (1,4,6))  (("_._",[520110033])  ("_._",[520110033])  ("_.",[520110033])))  (([520110052] in (0,3,5))  (("_.",[520110033])  ("_.",[520110033])  ("_.",[520110033])))',0,3,'',0,'       ',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5201, 0, 0, 1) ;

--  " . "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5201,0,520110052,1) ;

CALL DOCLOCK_IMPORT('  /   / ',0,5201,1,0,11,0,'[520110033] <> 0',0,1,'',0,'',null,'[984110031] = ("_.",.[520110033])',1) ;

CALL DOCLOCKFIELDS_DELETE('  /   / ', 5201, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('  /   / ',5201,1,520111005,1) ;

CALL DOCLOCK_IMPORT('     ',0,5201,1,0,11,0,'[520111071] = 2',0,3,'          .      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[520111064] = 0)  ([988410008] = .[520111070]) 
   ((("..",[988410006])=0)
   (((".",.[520111064]), (".",[988410006]), "9.99.99.999.99"))
   (((".",[988410006])=(".",.[520111064]))
    ((".",[988410006])=0))
   (("..",[988410006])=("..",.[520111064]))) 
(((".", .[520111064]) div 100000) between 218 and 219) 
(((".", .[520111064]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 5201, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5201,1,520111052,1) ;

CALL DOCLOCK_IMPORT('   ',32768,5201,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 5201, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',5201,1,520111080,1) ;

CALL DOCLOCK_IMPORT('  ',0,5501,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5501, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,-1,550110166,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,-1,550111170,1) ;

CALL DOCLOCK_IMPORT('  ',0,5501,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5501, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,-1,550111170,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5501,-1,550110166,1) ;

CALL DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'([550111066] = 2)  ((("_..",[550111052]) between 010800 and 011099))',0,3,'          ,    / , ().      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       . ',0,'      ',null,'([988410006] = 0)  (.[550111090] = 0)  (.[550111156] = [988410008]) 
 ((("..",[988410006])=0)
  (((".",.[550111090]), (".",[988410006]), "9.99.99.999.99"))  
  (((".",[988410006])=(".",.[550111090]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[550111090])))
 (((".", .[550111090]) div 100000) between 218 and 219) 
  (((".", .[550111090]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550111144,1) ;

CALL DOCLOCK_IMPORT('   ',32768,5501,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 5501, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',5501,1,550111171,1) ;

CALL DOCLOCK_IMPORT('  ',0,5502,-1,0,12,0,'',0,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5502, -1, 0, 1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,-1,550210151,1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,-1,550211158,1) ;

CALL DOCLOCK_IMPORT('  ',0,5502,-1,0,15,1,'',0,1,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 5502, -1, 0, 1) ;

--  ".   ()"
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,-1,550211158,1) ;

--  ".  "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',5502,-1,550210151,1) ;

CALL DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'([550211066] = 2)  ((("_..",[550211052]) between 010800 and 011099))',0,3,'          ,    / , ().      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       . ',0,'      ',null,'([988410006] = 0)  (.[550211090] = 0)  (.[550211135] = [988410008]) 
 ((("..",[988410006])=0)
  (((".",.[550211090]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[550211090]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[550211090])))
 (((".", .[550211090]) div 100000) between 218 and 219) 
  (((".", .[550211090]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550211125,1) ;

CALL DOCLOCK_IMPORT('   ',32768,5502,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 5502, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',5502,1,550211159,1) ;

CALL DOCLOCK_IMPORT('     ',0,5503,1,0,11,0,'[550311008] = 2',0,1,'          ,    /          /.      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       .',0,'      ',null,'([988410006] = 0)  (.[550311022] = 0)  (.[550311022] = [988410006])
 ((("..",[988410006])=0)
  (((".",.[550311022]), (".",[988410006]), "9.99.99.999.99"))
  (((".",[988410006])=(".",.[550311022]))
   ((".",[988410006])=0))
  (("..",[988410006])=("..",.[550311022])))
 (((".", .[550311022]) div 100000) between 218 and 219) 
 (((".", .[550311022]) div 1000) = 11302)',1) ;

CALL DOCLOCKFIELDS_DELETE('     ', 5503, 1, 0, 1) ;

--  "  "
CALL DOCLOCKFIELDS_INSERTFIELD('     ',5503,1,550311025,1) ;

CALL DOCLOCK_IMPORT('   ',32768,5503,1,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 5503, 1, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',5503,1,550311066,1) ;

CALL DOCLOCK_IMPORT('   ',32768,5503,2,0,3,0,'(32,41,3) in (0,1)',0,1,'  "  ",      (32, 41)     ',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ', 5503, 2, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ',5503,2,550312060,1) ;

CALL DOCLOCK_IMPORT('   ()',0,9903,0,0,9,0,'(([990310057] >= 10800)  ([990310057] <= 11099)    (([990312091]) = 0)    (([990312089]) <= ([990312090])))  (([990310057] >= 11100)  ([990310057] <= 11199)    (([990312091]) = 0)  (([990312088]) = 0)    (([990312089])= 0)  (([990312090]) = 0)   (([990312093]) = 0))   (([990310057] >= 10000)  ([990310057] <= 10499)    (([990312088]) = 0)  (([990312092])= 0)    (([990312090]) = 0)  (([990312093]) = 0))  (([990310057] >= 10500)  ([990310057] <= 10799)    (([990312091]) = 0)  (([990312088]) = 0)    (([990312092])= 0)  (([990312090]) = 0)   (([990312093]) = 0))  (([990310057] >= 20000)  ([990310057] <= 999999))  ([990310057] = 0)',0,3,'   /       01.00.00 - 01.11.99(, , ,  . )',0,'          ',0,'',1) ;

CALL DOCLOCKFIELDS_DELETE('   ()', 9903, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('   ()',9903,0,990310057,1) ;

CALL DOCLOCK_IMPORT('    ',32768,9903,0,0,3,0,'((53,1,3)=1)  ("200", (53,3,8))  (("\\\\","  ") = 1)',1,3,'        ',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('    ', 9903, 0, 0, 1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310085,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310076,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310020,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310010,1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310004,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310003,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310002,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310001,1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310062,1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('    ',9903,0,990310061,1) ;

CALL DOCLOCK_IMPORT('  ',262144,9926,0,0,5,0,'([992610001]<100) and (([992610001]))',1,3,'',0,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9926, 0, 0, 1) ;

--  " "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9926,0,992610008,1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9926,0,992610007,1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9926,0,992610006,1) ;

--  ""
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9926,0,992610002,1) ;

--  "   "
CALL DOCLOCKFIELDS_INSERTFIELD('  ',9926,0,992610005,1) ;

CALL DOCLOCK_IMPORT(' ',65536,9928,-1,0,8,0,'',1,1,'  .       .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ', 9928, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',65536,9928,-1,0,7,0,'',1,3,'   .           .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9928, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',2,9928,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9928, -1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ',65536,9931,-1,0,8,0,'',1,1,'  .       .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ', 9931, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',65536,9931,-1,0,7,0,'',1,3,'   .           .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9931, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',2,9931,-1,0,8,2,'',1,1,'     ,   .       .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9931, -1, 0, 1) ;

CALL DOCLOCK_IMPORT(' ',65536,9932,-1,0,8,0,'',1,1,'  .       .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE(' ', 9932, -1, 0, 1) ;

CALL DOCLOCK_IMPORT('  ',65536,9932,-1,0,7,0,'',1,3,'   .           .',2,'',null,'',1) ;

CALL DOCLOCKFIELDS_DELETE('  ', 9932, -1, 0, 1) ;

DROP PROCEDURE DOCLOCK_IMPORT      
/

DROP PROCEDURE DocLockFields_InsertField
/

DROP PROCEDURE DOCLOCK_DELETE
/

DROP PROCEDURE DOCLOCKFIELDS_DELETE
/

CREATE OR REPLACE PROCEDURE LINKTYPE_DELETE(
  NAME_         VARCHAR2,
  TEMPLATECLS_  NUMBER,
  PARENTDOCCLS_ NUMBER,
  CHILDDOCCLS_  NUMBER) IS
BEGIN
  FOR tab_rec in (SELECT id FROM LINKTYPE LT
  WHERE (((NAME_ <> '') or (NAME_ is not null)) and (LT.NAME = NAME_)) or 
    (((NAME_ = '') or (NAME_ is null)) and (LT.TEMPLATECLS = TEMPLATECLS_ AND LT.PARENTDOCCLS = PARENTDOCCLS_ AND LT.CHILDDOCCLS = CHILDDOCCLS_)))    
  LOOP
    UPDATE STATE_JUMPCONTROL SET
      REFERENCEREF = NULL
    WHERE REFERENCEREF = tab_rec.id;
    DELETE FROM REPLACEMENTCLSDETAIL WHERE LINKID IN (SELECT ID FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id);
    DELETE FROM LINKRECORDS
      WHERE LINKTYPEREF = tab_rec.id;
    DELETE FROM LINKTYPE LT
      WHERE LT.ID = tab_rec.id;
  END LOOP;     
END;
/

CREATE OR REPLACE PROCEDURE LINKTYPE_IMPORT(
   ID_                    NUMBER,
   NAME_                  VARCHAR2,
   TEMPLATECLS_           NUMBER,
   PARENTDOCCLS_          NUMBER,
   CHILDDOCCLS_           NUMBER,
   LINKCOMMENT_           VARCHAR2,
   BLOCKPARENT_           NUMBER,
   BLOCKCHILD_            NUMBER,
   CANDELBLOCKPARENT_     NUMBER,
   CANDELBLOCKCHILD_      NUMBER,
   PARENTPICTURETYPE_     NUMBER,
   PARENTPICTURENAME_     VARCHAR2,
   CHILDPICTURETYPE_      NUMBER,
   CHILDPICTURENAME_      VARCHAR2,
   PICTURECOLLECTIONNAME_ VARCHAR2,
   URMUSE_                NUMBER,
   DELMACROSNAME_         VARCHAR2,
   NEEDDELCHILD_          NUMBER,
   LINKKIND_              NUMBER
) IS
   CNT$ NUMBER(10);
BEGIN
   /*          ,     */
   /*  ,   , ,  ,     */
   IF (
   ((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0))or(Name_ is not null))   
   THEN
     FOR tab_rec in(SELECT id FROM LINKTYPE LT WHERE 
		 (id<>ID_)	
         and(((TEMPLATECLS_ is not null)and(TEMPLATECLS_<>0)and(LT.TEMPLATECLS = TEMPLATECLS_)
         and (LT.PARENTDOCCLS = PARENTDOCCLS_) and (LT.CHILDDOCCLS = CHILDDOCCLS_))
         or((Name_ is not null)and(lt.Name=Name_))))
     LOOP
        /*             */    
        DELETE FROM LINKRECORDS WHERE LINKTYPEREF = -10;  
        DELETE FROM TB_LINKTYPE WHERE ID = -10;
        DELETE FROM DOCUMENTCLS WHERE ID = -10;
        DELETE FROM DOCUMENTTYPES WHERE ID = -10;
        INSERT INTO DOCUMENTTYPES(ID, PROGINDEX) VALUES(-10, -10);
        INSERT INTO DOCUMENTCLS(ID, DOCTYPE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM)
           VALUES(-10, -10, ' ', ' ', ' ', ' ');
        INSERT INTO LINKTYPE(ID, PARENTDOCCLS, CHILDDOCCLS, NAME) VALUES(-10, -10, -10, ' ');
        UPDATE STATE_JUMPCONTROL SET
           REFERENCEREF = -10
        WHERE
           REFERENCEREF = tab_rec.id;
        UPDATE LINKRECORDS SET
           LINKTYPEREF = -10
        WHERE
           LINKTYPEREF = tab_rec.id;
        DELETE FROM TB_LINKTYPE WHERE ID = tab_rec.Id;
     END LOOP;
   end if;
   /*      */ 
   SELECT count(*) into CNT$
      FROM LINKTYPE LT WHERE LT.ID = ID_;
   IF (CNT$ = 0)    
   THEN
      INSERT INTO LINKTYPE
       (ID,NAME,TEMPLATECLS,PARENTDOCCLS, CHILDDOCCLS, LINKCOMMENT, BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,
        CANDELBLOCKCHILD, PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,
        PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND)
      VALUES
       (ID_,NAME_,TEMPLATECLS_, PARENTDOCCLS_, CHILDDOCCLS_, LINKCOMMENT_, BLOCKPARENT_,BLOCKCHILD_,CANDELBLOCKPARENT_,
        CANDELBLOCKCHILD_, PARENTPICTURETYPE_,PARENTPICTURENAME_,CHILDPICTURETYPE_,CHILDPICTURENAME_,
        PICTURECOLLECTIONNAME_,URMUSE_,DELMACROSNAME_,NEEDDELCHILD_,LINKKIND_);
   ELSE
      UPDATE LINKTYPE SET
         NAME = NAME_,
         TEMPLATECLS = TEMPLATECLS_,
         PARENTDOCCLS = PARENTDOCCLS_,
         CHILDDOCCLS = CHILDDOCCLS_,
         LINKCOMMENT = LINKCOMMENT_,
         BLOCKPARENT = BLOCKPARENT_,
         BLOCKCHILD = BLOCKCHILD_,
         CANDELBLOCKPARENT = CANDELBLOCKPARENT_,
         CANDELBLOCKCHILD = CANDELBLOCKCHILD_,
         PARENTPICTURETYPE = PARENTPICTURETYPE_,
         PARENTPICTURENAME = PARENTPICTURENAME_,
         CHILDPICTURETYPE = CHILDPICTURETYPE_,
         CHILDPICTURENAME = CHILDPICTURENAME_,
         PICTURECOLLECTIONNAME = PICTURECOLLECTIONNAME_,
         URMUSE = URMUSE_,
         DELMACROSNAME = DELMACROSNAME_,
         NEEDDELCHILD = NEEDDELCHILD_,
         LINKKIND = LINKKIND_
      WHERE ID = ID_;
   END IF;      
   
   /*      ,      */
   UPDATE STATE_JUMPCONTROL SET
     REFERENCEREF = ID_
   WHERE
     REFERENCEREF = -10;
   UPDATE LINKRECORDS SET
      LINKTYPEREF = ID_
   WHERE
      LINKTYPEREF = -10;
   /*   */  
   DELETE FROM TB_LINKTYPE WHERE ID = -10;
   DELETE FROM DOCUMENTCLS WHERE ID = -10;
   DELETE FROM DOCUMENTTYPES WHERE ID = -10;
END;
/

--  
CALL LINKTYPE_IMPORT(20204900,'->_',null,20301,20601,' ()    ()',1,0,0,1,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(22200100,'->()',null,20500,220100,'       ()',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(22200200,'->()',null,20501,220101,'       ()',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(30200100,'->',null,32400,20100,'      ',1,0,0,0,1,'',1,'','1616',1,'',1,0) ;

CALL LINKTYPE_IMPORT(515100100,'',null,510100,510100,'        ()',1,0,0,0,1,'',1,'','',1,'',1,0) ;

CALL LINKTYPE_IMPORT(515100200,'',null,510101,510101,'        ()',1,0,0,0,1,'',1,'','',1,'',1,0) ;

CALL LINKTYPE_IMPORT(184900100,'->',null,181800,490200,'      ',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(20300300,'',null,21100,32300,'      ',1,0,0,0,1,'',1,'','1616',0,'',0,0) ;

CALL LINKTYPE_IMPORT(220200100,'()->',null,220100,20500,'         ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(220200200,'()->',null,220101,20501,'         ',1,0,0,0,1,'',1,'','1616',0,'',1,0) ;

CALL LINKTYPE_IMPORT(20205000,' 14 () ->  14 ()',null,21501,21501,'   (14 /)    (14 /)',1,0,0,1,1,'',1,'','',0,'',1,0) ;

CALL LINKTYPE_IMPORT(34903200,'2',null,30300,490200,'',0,0,0,0,2,'',1,'','1616',1,'',0,1) ;

CALL LINKTYPE_IMPORT(20205100,' 14 () ->  14 ()',null,21500,21500,'   (14 /)    (14 /)',1,0,0,1,1,'',1,'','',0,'',1,0) ;

DROP PROCEDURE LINKTYPE_DELETE
/

DROP PROCEDURE LINKTYPE_IMPORT
/

CREATE OR REPLACE PROCEDURE STATICLINK_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATICLINKS SL
  WHERE SL.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE STATICLINK_IMPORT(
  ID_             NUMBER,
  NAME_           VARCHAR2,
  PARENTFIELDREF_ NUMBER,
  CHILDFIELDREF_  NUMBER,
  LINKKIND_      NUMBER,
  ParentDelAction_ NUMBER
) IS
  FINDID$ NUMBER;
  FINDNEWID$ NUMBER;
  IDExists$ NUMBER;
BEGIN
  /*     ID,    CHILDFIELDREF,PARENTFIELDREF. 
   ,     ,    ID.       ID  , 
   (  )     id ,      */
  BEGIN
    SELECT
      SL.ID
    INTO FINDID$
    FROM 
      STATICLINKS SL
    WHERE (SL.CHILDFIELDREF = CHILDFIELDREF_) AND (SL.PARENTFIELDREF = PARENTFIELDREF_) AND (SL.ID <> ID_);
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      FINDID$ := NULL;
  END;
  
  IF (FINDID$ IS NOT NULL) THEN
  /*   ID         */

    SELECT COUNT (ID)
      INTO IDExists$
      FROM STATE_JUMPCONTROL
    WHERE (STATICLINKREF = FINDID$);

    IF (IDExists$ > 0) THEN

      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM 
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
 
      IF (FINDNEWID$ IS NULL) THEN
        INSERT INTO STATICLINKS
         (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
        VALUES
          (ID_,NAME_,CHILDFIELDREF_,PARENTFIELDREF_,1,ParentDelAction_);
      END IF;        
      UPDATE STATE_JUMPCONTROL
        SET STATICLINKREF = ID_
      WHERE (STATICLINKREF = FINDID$);

      DELETE FROM STATICLINKS  
      WHERE ID=FINDID$;
    ELSE   
      BEGIN
        SELECT
          SL.ID
        INTO FINDNEWID$
        FROM
          STATICLINKS SL
        WHERE (SL.ID = ID_);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          FINDNEWID$ := NULL;
      END;
      IF (FINDNEWID$ IS NULL) THEN
        UPDATE STATICLINKS
        SET ID=ID_
        WHERE ID=FINDID$;
      ELSE
        DELETE FROM STATICLINKS
        WHERE ID=FINDID$;
      END IF;
    END IF;
      
  END IF; /*  id  */
  
  /*       ( ), 
   ,            CHILDFIELDREF.
   ,        1( )*/
  IF (LINKKIND_=0) THEN
    UPDATE STATICLINKS
    SET LINKKIND=1  
    WHERE (CHILDFIELDREF = CHILDFIELDREF_) AND (ID <> ID_) AND (LINKKIND=0);
  END IF;    
  
  /*        id.  ,   .  ,   */
  BEGIN
    SELECT SL.ID
      INTO FINDID$
      FROM
        STATICLINKS SL
      WHERE
        (SL.ID = ID_);
  EXCEPTION
      WHEN NO_DATA_FOUND THEN
        FINDID$ := NULL;
  END;
  IF (FINDID$ IS NOT NULL) THEN
    UPDATE STATICLINKS SET
      NAME           = NAME_,
      PARENTFIELDREF = PARENTFIELDREF_,
      CHILDFIELDREF  = CHILDFIELDREF_,
      LINKKIND       = LINKKIND_,
      ParentDelAction = ParentDelAction_
      WHERE ID = ID_;
  ELSE
    INSERT INTO STATICLINKS
     (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
    VALUES
      (ID_,NAME_,PARENTFIELDREF_,CHILDFIELDREF_,LINKKIND_,ParentDelAction_);
  END IF;      

END;
/

--  
CALL STATICLINK_DELETE(994400300) ;

CALL STATICLINK_DELETE(994401500) ;

CALL STATICLINK_DELETE(993700100) ;

CALL STATICLINK_DELETE(982505400) ;

CALL STATICLINK_DELETE(982505100) ;

CALL STATICLINK_DELETE(982505000) ;

CALL STATICLINK_DELETE(982505200) ;

CALL STATICLINK_DELETE(992501800) ;

CALL STATICLINK_DELETE(982505300) ;

CALL STATICLINK_DELETE(992503700) ;

CALL STATICLINK_DELETE(992502600) ;

CALL STATICLINK_DELETE(990235900) ;

CALL STATICLINK_IMPORT(990338400,'.1.SOURCETARGETCLS()->.ID',987910002,30211184,0,0) ;

CALL STATICLINK_IMPORT(990231000,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20211112,0,0) ;

CALL STATICLINK_IMPORT(990231100,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20311102,0,0) ;

CALL STATICLINK_IMPORT(990231200,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20411120,0,0) ;

CALL STATICLINK_IMPORT(990231300,'.1.CONTRACTCOSTSCLS()->.ID',989710001,20511107,0,0) ;

CALL STATICLINK_IMPORT(990231400,'__.1.CONTRACTCOSTSCLS()->.ID',989710001,20611188,0,0) ;

CALL STATICLINK_IMPORT(990231500,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,20711188,0,0) ;

CALL STATICLINK_IMPORT(990231600,'__.1.CONTRACTCOSTSCLS()->.ID',989710001,20811189,0,0) ;

CALL STATICLINK_IMPORT(990231700,'_.2.CONTRACTCOSTSCLS()->.ID',989710001,21112048,0,0) ;

CALL STATICLINK_IMPORT(990231800,'_.2.CONTRACTCOSTSCLS()->.ID',989710001,21212049,0,0) ;

CALL STATICLINK_IMPORT(990336500,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,30211195,0,0) ;

CALL STATICLINK_IMPORT(990336600,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,30411148,0,0) ;

CALL STATICLINK_IMPORT(990336700,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30511149,0,0) ;

CALL STATICLINK_IMPORT(990336800,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30611151,0,0) ;

CALL STATICLINK_IMPORT(990337000,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,30811116,0,0) ;

CALL STATICLINK_IMPORT(990336900,'.1.SOURCECONTRACTCOSTSCLS(,)->.ID',989710001,30811117,0,0) ;

CALL STATICLINK_IMPORT(990337100,'_.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,31111109,0,0) ;

CALL STATICLINK_IMPORT(990337200,'_.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,31211144,0,0) ;

CALL STATICLINK_IMPORT(990337300,'_.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,31411145,0,0) ;

CALL STATICLINK_IMPORT(990337400,'_.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,31511101,0,0) ;

CALL STATICLINK_IMPORT(990337500,'.1.SOURCECONTRACTCOSTSCLS()->.ID',989710001,32211092,0,0) ;

CALL STATICLINK_IMPORT(990337700,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,32411205,0,0) ;

CALL STATICLINK_IMPORT(995504200,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,550111168,0,0) ;

CALL STATICLINK_IMPORT(995504300,'_.1.CONTRACTCOSTSCLS()->.ID',989710001,550211147,0,0) ;

CALL STATICLINK_IMPORT(995504400,'.1.CONTRACTCOSTSCLS()->.ID',989710001,550311064,0,0) ;

CALL STATICLINK_IMPORT(992502500,'.2.CONTRACTCOSTSCLS()->.ID',989710001,250212058,0,0) ;

CALL STATICLINK_IMPORT(992502800,'.2.CONTRACTCOSTSCLS()->.ID',989710001,250312052,0,0) ;

CALL STATICLINK_IMPORT(992502700,'.2.CONTRACTCOSTSCLS()->.ID',989710001,250412057,0,0) ;

CALL STATICLINK_IMPORT(993002500,'.1.CONTRACTCOSTSCLS()->.ID',989710001,300111100,0,0) ;

CALL STATICLINK_IMPORT(993002600,'.1.CONTRACTCOSTSCLS()->.ID',989710001,300611062,0,0) ;

CALL STATICLINK_IMPORT(995200900,'.1.CONTRACTCOSTSCLS()->.ID',989710001,520111074,0,0) ;

CALL STATICLINK_IMPORT(999903800,'.PURCHASETYPE ->.ID',989810001,989710010,0,0) ;

CALL STATICLINK_IMPORT(990337600,'.1.DESTCONTRACTCOSTSCLS()->.ID',989710001,32311166,0,0) ;

CALL STATICLINK_IMPORT(993002700,'.1.CONTRACTCOSTSCLS()->.ID',989710001,301111049,0,0) ;

CALL STATICLINK_IMPORT(992504100,'.2.BUDALLOCATIONCLS->.ID',989010006,250412107,0,1) ;

CALL STATICLINK_IMPORT(993003600,'.1.BUDALLOCATIONCLS->.ID',989010006,300611065,0,1) ;

CALL STATICLINK_IMPORT(992502900,'.2.TRANSFERTCLS->.ID',988410002,250412108,0,0) ;

CALL STATICLINK_IMPORT(252500200,'.2.AGREEMENTREF->.ID',250410105,250412061,0,2) ;

CALL STATICLINK_IMPORT(252500000,'.2.AGREEMENTREF->.ID',250210064,250212061,0,2) ;

CALL STATICLINK_IMPORT(252500100,'.2.EXECUTIONREF->.ID',250310049,250312056,0,2) ;

CALL STATICLINK_IMPORT(993003400,'.1.SUBSIDYCLS->.ID',988910006,300111102,0,1) ;

CALL STATICLINK_IMPORT(993002800,'.1.TRANSFERTCLS->.ID',988410002,300611066,0,0) ;

CALL STATICLINK_IMPORT(990338000,'.1.SOURCETARGETCLS()->.ID',987910002,30111191,0,0) ;

CALL STATICLINK_IMPORT(990338100,'.1.DESTTARGETCLS()->.ID',987910002,30111193,0,0) ;

CALL STATICLINK_IMPORT(990338600,'.1.DESTTARGETCLS()->.ID',987910002,30311111,0,0) ;

CALL STATICLINK_IMPORT(990338700,'.1.SOURCETARGETCLS()->.ID',987910002,30411150,0,0) ;

CALL STATICLINK_IMPORT(990338900,'.1.DESTTARGETCLS()->.ID',987910002,30511151,0,0) ;

CALL STATICLINK_IMPORT(990339200,'.1.DESTTARGETCLS()->.ID',987910002,30811120,0,0) ;

CALL STATICLINK_IMPORT(990339100,'.1.SOURCETARGETCLS(,)->.ID',987910002,30811122,0,0) ;

CALL STATICLINK_IMPORT(990339500,'.1.SOURCETARGETCLS()->.ID',987910002,32211096,0,0) ;

CALL STATICLINK_IMPORT(990339700,'.1.DESTTARGETCLS()->.ID',987910002,32311169,0,0) ;

CALL STATICLINK_IMPORT(990339900,'.1.DESTTARGETCLS()->.ID',987910002,32411209,0,0) ;

CALL STATICLINK_IMPORT(990232100,'_.1.TARGETCLS()->.ID',987910002,20111200,0,0) ;

CALL STATICLINK_IMPORT(990232300,'_.1.TARGETCLS()->.ID',987910002,20211116,0,0) ;

CALL STATICLINK_IMPORT(990232500,'_.1.TARGETCLS()->.ID',987910002,20311104,0,0) ;

CALL STATICLINK_IMPORT(990232700,'_.1.TARGETCLS()->.ID',987910002,20411125,0,0) ;

CALL STATICLINK_IMPORT(990232900,'.1.TARGETCLS()->.ID',987910002,20511112,0,0) ;

CALL STATICLINK_IMPORT(990233000,'__.1.TARGETCLS()->.ID',987910002,20611191,0,0) ;

CALL STATICLINK_IMPORT(990233200,'__.1.TARGETCLS()->.ID',987910002,20811192,0,0) ;

CALL STATICLINK_IMPORT(990233400,'_.2.TARGETCLS()->.ID',987910002,20912047,0,0) ;

CALL STATICLINK_IMPORT(990233600,'.1.TARGETCLS()->.ID',987910002,21011054,0,0) ;

CALL STATICLINK_IMPORT(990233700,'.2.TARGETCLS()->.ID',987910002,21012066,0,0) ;

CALL STATICLINK_IMPORT(990234000,'_.2.TARGETCLS()->.ID',987910002,21112052,0,1) ;

CALL STATICLINK_IMPORT(990234200,'_.2.TARGETCLS()->.ID',987910002,21212053,0,1) ;

CALL STATICLINK_IMPORT(992203500,'_.1.TARGETCLS()->.ID',987910002,220111084,0,0) ;

CALL STATICLINK_IMPORT(990337800,'.1.->.ID',987910002,30011047,0,1) ;

CALL STATICLINK_IMPORT(990232000,'.1.->.ID',987910002,20011043,0,1) ;

CALL STATICLINK_IMPORT(990803300,'_.1.TARGETCLS()->.ID',987910002,80111086,0,0) ;

CALL STATICLINK_IMPORT(990803500,'_.TARGETCLS()->.ID',987910002,80210045,0,0) ;

CALL STATICLINK_IMPORT(990803600,'_.1.TARGETCLS()->.ID',987910002,80311058,0,0) ;

CALL STATICLINK_IMPORT(990908300,'.1.{("")}()->.ID',987910002,90011010,0,0) ;

CALL STATICLINK_IMPORT(990908500,'_.1.TARGETCLS()->.ID',987910002,90311097,0,0) ;

CALL STATICLINK_IMPORT(990908700,'_.TARGETCLS()->.ID',987910002,90510053,0,0) ;

CALL STATICLINK_IMPORT(990908800,'_.TARGETCLS()->.ID',987910002,90710061,0,0) ;

CALL STATICLINK_IMPORT(992503000,'.2.TARGETCLS->.ID',987910002,250112078,0,1) ;

CALL STATICLINK_IMPORT(992503100,'.2.TARGETCLS->.ID',987910002,250212063,0,1) ;

CALL STATICLINK_IMPORT(992503200,'.2.TARGETCLS->.ID',987910002,250312058,0,1) ;

CALL STATICLINK_IMPORT(992503300,'.2.TARGETCLS->.ID',987910002,250412110,0,1) ;

CALL STATICLINK_IMPORT(993002900,'.1.TARGETCLS->.ID',987910002,300111105,0,1) ;

CALL STATICLINK_IMPORT(993003000,'.1.TARGETCLS->.ID',987910002,300611068,0,1) ;

CALL STATICLINK_IMPORT(993003100,'.1.TARGETCLS->.ID',987910002,301111053,0,1) ;

CALL STATICLINK_IMPORT(994402400,'.1.TARGETCLS()->.ID',987910002,440111073,0,0) ;

CALL STATICLINK_IMPORT(994402600,'.1.TARGETCLS()->.ID',987910002,440311070,0,0) ;

CALL STATICLINK_IMPORT(995201000,'.1.TARGETCLS()->.ID',987910002,520111081,0,0) ;

CALL STATICLINK_IMPORT(995504500,'_.1.TARGETCLS()->.ID',987910002,550111172,0,0) ;

CALL STATICLINK_IMPORT(995504700,'_.1.TARGETCLS()->.ID',987910002,550211160,0,0) ;

CALL STATICLINK_IMPORT(995505000,'.1.TARGETCLS()->.ID',987910002,550311067,0,0) ;

CALL STATICLINK_IMPORT(960204900,'.ORGREF()->.ID',960110033,21310019,0,0) ;

CALL STATICLINK_IMPORT(980229500,'.FACIALACCCLS()->.ID',984110021,21310027,0,0) ;

CALL STATICLINK_IMPORT(980228900,'.DOCBASE(,)->.ID',982910007,21310030,0,0) ;

CALL STATICLINK_IMPORT(980229900,'__.FACIALACCCLS()->.ID',984110021,21410027,0,0) ;

CALL STATICLINK_IMPORT(980230700,'__.DOCBASE(,)->.ID',982910007,21410030,0,0) ;

CALL STATICLINK_IMPORT(980231100,'__.FACIALACCCLS()->.ID',984110021,21510027,0,0) ;

CALL STATICLINK_IMPORT(980231500,'__.DOCBASE(,)->.ID',982910007,21510030,0,0) ;

CALL STATICLINK_IMPORT(990235400,'.1.TARGETCLS()->.ID',987910002,21311006,0,0) ;

CALL STATICLINK_IMPORT(990236100,'.1.TRANSFERTCLS()->.ID',988410002,21311011,0,0) ;

CALL STATICLINK_IMPORT(980229300,'.1.MEANSTYPE()->.ID',984910002,21311013,0,0) ;

CALL STATICLINK_IMPORT(20202600,'.1.RECORDINDEX()->.ID()',21310007,21311034,0,2) ;

CALL STATICLINK_IMPORT(980229700,'.1.FACIALACC_CLS()->.ID',984110021,21311035,0,0) ;

CALL STATICLINK_IMPORT(980229100,'.1.REGIONCLS(,,)->.ID',981210005,21311036,0,0) ;

CALL STATICLINK_IMPORT(980228700,'.1.KD()->.ID',980910006,21311041,0,0) ;

CALL STATICLINK_IMPORT(990235600,'__.1.TARGETCLS()->.ID',987910002,21411006,0,0) ;

CALL STATICLINK_IMPORT(980230300,'__.1.MEANSTYPE()->.ID',984910002,21411013,0,0) ;

CALL STATICLINK_IMPORT(20202800,'__.1.RECORDINDEX()->__.ID()',21410007,21411034,0,2) ;

CALL STATICLINK_IMPORT(980230100,'__.1.FACIALACC_CLS()->.ID',984110021,21411035,0,0) ;

CALL STATICLINK_IMPORT(980230500,'__.1.REGIONCLS(,,)->.ID',981210005,21411036,0,0) ;

CALL STATICLINK_IMPORT(980230900,'__.1.KD()->.ID',980910006,21411041,0,0) ;

CALL STATICLINK_IMPORT(990235800,'__.1.TARGETCLS()->.ID',987910002,21511006,0,0) ;

CALL STATICLINK_IMPORT(980232100,'__.1.MEANSTYPE()->.ID',984910002,21511013,0,0) ;

CALL STATICLINK_IMPORT(20203000,'__.1.RECORDINDEX()->__.ID()',21510007,21511034,0,2) ;

CALL STATICLINK_IMPORT(980231300,'__.1.FACIALACC_CLS()->.ID',984110021,21511035,0,0) ;

CALL STATICLINK_IMPORT(980231700,'__.1.REGIONCLS(,,)->.ID',981210005,21511036,0,0) ;

CALL STATICLINK_IMPORT(980231900,'__.1.KD()->.ID',980910006,21511041,0,0) ;

CALL STATICLINK_IMPORT(992503400,'.2.BUDALLOCATIONCLS->.ID',989010006,250212075,0,1) ;

CALL STATICLINK_IMPORT(992503500,'.2.PAYPROMISECLS->.ID',989110006,250212076,0,1) ;

CALL STATICLINK_IMPORT(992503600,'.2.TRANSFERTCLS->.ID',988410002,250212077,0,1) ;

CALL STATICLINK_IMPORT(992503800,'.2.BUDALLOCATIONCLS->.ID',989010006,250312069,0,1) ;

CALL STATICLINK_IMPORT(982506600,'.2.KCSR->.ID',980510002,250312070,0,0) ;

CALL STATICLINK_IMPORT(982506700,'.2.KVR->.ID',980410002,250312071,0,1) ;

CALL STATICLINK_IMPORT(992503900,'.2.PAYPROMISECLS->.ID',989110006,250312072,0,1) ;

CALL STATICLINK_IMPORT(982506800,'.2.KVSR->.ID',980310002,250312073,0,1) ;

CALL STATICLINK_IMPORT(992504000,'.2.TRANSFERTCLS->.ID',988410002,250312074,0,1) ;

CALL STATICLINK_IMPORT(992504200,'.2.PAYPROMISECLS->.ID',989110006,250412121,0,1) ;

CALL STATICLINK_IMPORT(993003200,'.1.BUDALLOCATIONCLS->.ID',989010006,300111116,0,1) ;

CALL STATICLINK_IMPORT(993003300,'.1.PAYPROMISECLS->.ID',989110006,300111117,0,1) ;

CALL STATICLINK_IMPORT(993003500,'.1.TRANSFERTCLS->.ID',988410002,300111118,0,1) ;

CALL STATICLINK_IMPORT(993003700,'.1.PAYPROMISECLS->.ID',989110006,300611079,0,1) ;

CALL STATICLINK_IMPORT(993003800,'.1.SUBSIDYCLS->.ID',988910006,300611080,0,1) ;

CALL STATICLINK_IMPORT(993003900,'.1.BUDALLOCATIONCLS->.ID',989010006,301111064,0,1) ;

CALL STATICLINK_IMPORT(993004000,'.1.PAYPROMISECLS->.ID',989110006,301111065,0,1) ;

CALL STATICLINK_IMPORT(993004100,'.1.SUBSIDYCLS->.ID',988910006,301111066,0,1) ;

CALL STATICLINK_IMPORT(993004200,'.1.TRANSFERTCLS->.ID',988410002,301111067,0,1) ;

CALL STATICLINK_IMPORT(515100000,'.1.RECORDINDEX()->.ID()',510110001,510111002,0,2) ;

CALL STATICLINK_IMPORT(982507300,'.4.MEANSTYPE->.ID',984910002,250414129,0,0) ;

CALL STATICLINK_IMPORT(982507000,'.4.KVSR->.ID',980310002,250414131,0,1) ;

CALL STATICLINK_IMPORT(982506900,'.4.KVR->.ID',980410002,250414133,0,1) ;

CALL STATICLINK_IMPORT(982507100,'.4.KFSR->.ID',980210004,250414134,0,0) ;

CALL STATICLINK_IMPORT(992504400,'.4.KESR->.ID',986810006,250414135,0,0) ;

CALL STATICLINK_IMPORT(982507200,'.4.KCSR->.ID',980510002,250414137,0,0) ;

CALL STATICLINK_IMPORT(992504300,'.4.TARGETCLS->.ID',987910002,250414140,0,0) ;

CALL STATICLINK_IMPORT(960204700,'.1.ORG_REF()->.ID',960110033,21311051,0,0) ;

CALL STATICLINK_IMPORT(545400000,'.1.RECORDINDEX->.ID',540210001,540211001,0,0) ;

DROP PROCEDURE STATICLINK_DELETE
/

DROP PROCEDURE STATICLINK_IMPORT
/

CREATE OR REPLACE PROCEDURE FILTERS_DELETE(ID_ NUMBER) IS
BEGIN
  DELETE FROM STATE_JUMPCONTROL
  WHERE STATE_JUMPCONTROL.FILTERCODE = ID_;
  UPDATE STATE_ACTIONJUMPS SAJ
  SET SAJ.FILTERCODE = NULL, SAJ.OPTIONS = NULL
  WHERE SAJ.FILTERCODE = ID_;
  DELETE FROM State_Filter SF
  WHERE SF.ID = ID_;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORT(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValue_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValue,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValue_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValue = FilterValue_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE FILTERS_IMPORTURM(
  ID_ NUMBER,
  Name_ VARCHAR2,
  Note_ VARCHAR2,
  FilterValueURM_ VARCHAR2,
  FilterFormat_ NUMBER,
  FilterActive_ NUMBER,
  IsBudget_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM State_Filter
  WHERE (ID = ID_);
  IF (IDExists$ = 0) THEN
  INSERT INTO State_Filter
    (ID,NAME,Note,FilterValueURM,FilterFormat,FilterActive,IsBudget)
  VALUES
    (ID_,NAME_,Note_,FilterValueURM_,FilterFormat_,FilterActive_,IsBudget_);
  ELSE
    UPDATE State_Filter SET
      NAME = NAME_,
      Note = Note_,
      FilterValueURM = FilterValueURM_,
      FilterFormat = FilterFormat_,
      FilterActive = FilterActive_,
      IsBudget = IsBudget_
    WHERE ID = ID_;
  END IF;
END;
/

-- 
DROP PROCEDURE FILTERS_DELETE
/

DROP PROCEDURE FILTERS_IMPORT
/

DROP PROCEDURE FILTERS_IMPORTURM
/

CREATE OR REPLACE PROCEDURE STATUSICONS_IMPORT(
  ID_ NUMBER,
  NOTE_ VARCHAR2,
  DOCREF_ NUMBER,
  DETAILNUM_ NUMBER,
  ICONNAME_ VARCHAR2,
  ISSYSTEM_ NUMBER,
  ICONPOS_ NUMBER,
  RUNPOS_ NUMBER,
  RESERVEPOS_ NUMBER,
  ICONHINT_ VARCHAR2,
  ICONKIND_ NUMBER,
  LOCKMASK_ NUMBER,
  FORMULA_ VARCHAR2,
  ISBUDGET_ NUMBER
) IS
  IDExists$ NUMBER (10);
BEGIN
  SELECT COUNT(ID)
  INTO IDExists$
  FROM STATUSICONS
  WHERE (ID = ID_);
  IF (IDExists$ <> 0) THEN
    UPDATE STATUSICONS SET
      NOTE = NOTE_,
      DOCREF = DOCREF_,
      DETAILNUM = DETAILNUM_,
      ICONNAME = ICONNAME_,
      ISSYSTEM = ISSYSTEM_,
      ICONPOS = ICONPOS_,
      RUNPOS = RUNPOS_,
      RESERVEPOS = RESERVEPOS_,
      ICONHINT = ICONHINT_,
      ICONKIND = ICONKIND_,
      LOCKMASK = LOCKMASK_,
      ISBUDGET = ISBUDGET_,
      FORMULA = FORMULA_
    WHERE ID = ID_;
  ELSE
    INSERT INTO STATUSICONS
      (ISBUDGET, ID, NOTE, DOCREF, DETAILNUM, ICONNAME, ISSYSTEM, ICONPOS, RUNPOS, RESERVEPOS, ICONHINT, ICONKIND, LOCKMASK, FORMULA)
    VALUES
      (ISBUDGET_, ID_, NOTE_, DOCREF_, DETAILNUM_, ICONNAME_, ISSYSTEM_, ICONPOS_, RUNPOS_, RESERVEPOS_, ICONHINT_, ICONKIND_, LOCKMASK_, FORMULA_);
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE STATUSICONS_DELETE(
  ID_ NUMBER
) IS
BEGIN
  DELETE FROM STATUSICONS SI
  WHERE SI.ID = ID_;
END;
/

--  
CALL STATUSICONS_IMPORT(39873,'',302,0,'',1,2,3,1,'     ',0,0,'([30210135])',1) ;

CALL STATUSICONS_IMPORT(39874,'',304,0,'',1,2,3,1,'     ',0,0,'([30410040])',1) ;

CALL STATUSICONS_IMPORT(40393,' ,   ',1807,0,'',1,1,1,0,'[180710004]',0,0,'([180710004] is not null) and ([180710004] <> '''')',1) ;

DROP PROCEDURE STATUSICONS_IMPORT
/

DROP PROCEDURE STATUSICONS_DELETE
/


CREATE OR REPLACE PROCEDURE ENUMS_IMPORT(NAME_ VARCHAR2,FACIALACCCLS_ NUMBER) IS
  IDEXISTS$ NUMBER;
BEGIN
  SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMS WHERE NAME = NAME_;
  IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMS E1
      WHERE (E1.NAME = NAME_) AND (E1.ID > (SELECT MIN(E2.ID) FROM ENUMS E2 WHERE E2.NAME = NAME_));
  END IF;
  IF (IDEXISTS$ > 0) THEN
    UPDATE ENUMS SET
      FACIALACCCLS = FACIALACCCLS_,
      ISSYSTEM = 1
    WHERE NAME = NAME_;
  ELSE
    INSERT INTO ENUMS
      (NAME,FACIALACCCLS,ISSYSTEM)    
    VALUES
      (NAME_,FACIALACCCLS_,1);
  END IF;    
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_IMPORT(ENUMNAME_ VARCHAR2,NAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
  IDEXISTS$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      IDENUM$ := NULL;
  END;  
  IF (IDENUM$ IS NOT NULL) THEN
    SELECT COUNT(ID) INTO IDEXISTS$ FROM ENUMVALUES WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    IF (IDEXISTS$ > 1) THEN
      DELETE FROM ENUMVALUES EV1
      WHERE (EV1.ENUMREF = IDENUM$) AND (EV1.VAL = VAL_) AND
        (EV1.ID > (SELECT MIN(EV2.ID) FROM ENUMVALUES EV2 WHERE EV2.ENUMREF = IDENUM$ AND EV2.VAL = VAL_));
    END IF;
    IF (IDEXISTS$ > 0) THEN
      UPDATE ENUMVALUES SET
        NAME = NAME_
      WHERE ENUMREF = IDENUM$ AND VAL = VAL_;
    ELSE
      INSERT INTO ENUMVALUES
        (VAL,NAME,ENUMREF)  
      VALUES
        (VAL_,NAME_,IDENUM$);
    END IF;    
  END IF;
END;
/

CREATE OR REPLACE PROCEDURE ENUMS_DELETE(NAME_ VARCHAR2) IS
BEGIN
  DELETE FROM ENUMS WHERE NAME = NAME_;
END;
/

CREATE OR REPLACE PROCEDURE ENUMVALUES_DELETE(ENUMNAME_ VARCHAR2,VAL_ NUMBER) IS
  IDENUM$ NUMBER;
BEGIN
  BEGIN
    SELECT ID INTO IDENUM$ FROM ENUMS WHERE NAME = ENUMNAME_;
  EXCEPTION
     WHEN NO_DATA_FOUND THEN
       IDENUM$ := NULL;  
  END;
  IF (IDENUM$ IS NOT NULL) THEN
    DELETE FROM ENUMVALUES WHERE (VAL = VAL_) AND (ENUMREF = IDENUM$);
  END IF;  
END;
/

-- 
CALL ENUMVALUES_DELETE('',14) ;

CALL ENUMVALUES_IMPORT('','03=   ,           ,     ',3) ;

CALL ENUMVALUES_IMPORT('','05=       ',5) ;

CALL ENUMVALUES_IMPORT('','06=     ,      ',6) ;

CALL ENUMVALUES_IMPORT('','15= ,  ,    ',15) ;

CALL ENUMVALUES_IMPORT('','23=    ',23) ;

CALL ENUMVALUES_IMPORT('','27= ,      ',27) ;

CALL ENUMVALUES_IMPORT('','28=       ',28) ;

CALL ENUMVALUES_IMPORT('','=  ',27) ;

CALL ENUMVALUES_IMPORT('','=    ',28) ;

CALL ENUMS_IMPORT('',null) ;

CALL ENUMVALUES_IMPORT('',' ',0) ;

CALL ENUMVALUES_IMPORT('','  ',1) ;

CALL ENUMVALUES_IMPORT('','   - ',2) ;

CALL ENUMVALUES_IMPORT('',' ',3) ;

CALL ENUMVALUES_IMPORT('',' (, ),           ,      ',4) ;

CALL ENUMVALUES_IMPORT('','-  ',5) ;

CALL ENUMVALUES_IMPORT('',' (, ),           ,       ',6) ;

DROP PROCEDURE ENUMS_IMPORT
/

DROP PROCEDURE ENUMVALUES_IMPORT
/

DROP PROCEDURE ENUMS_DELETE
/

DROP PROCEDURE ENUMVALUES_DELETE
/

--      
INSERT INTO DFUCHANGELOG (VersionID, BEGINUPDATECODE, ENDUPDATECODE, LASTUPDATEDFU, ISBUDGET, INCLUDEDEL, INCLUDEBLOCKS, INCLUDEDOCS, SCRIPTCREATOR, SCRIPTCREATEDATE, NOTE) VALUES (2341, 121000, 130000, TO_DATE('02.07.2018 15:10:46', 'DD.MM.YYYY HH24:MI:SS'), 1, 1, ',    ,  , ,  , ,  , , ', '00.00, 01.01, 02.00, 02.01, 02.02, 02.03, 02.04, 02.05, 02.06, 02.07, 02.08, 02.09, 02.10, 02.11, 02.12, 02.13, 02.14, 02.15, 03.00, 03.01, 03.02, 03.03, 03.04, 03.05, 03.06, 03.07, 03.08, 03.11, 03.12, 03.14, 03.15, 03.16, 03.22, 03.23, 03.24, 04.01, 05.01, 07.01, 07.02, 07.03, 08.01, 08.02, 08.03, 08.04, 09.00, 09.01, 09.02, 09.03, 09.05, 09.06, 09.07, 12.01, 15.01, 16.01, 16.02, 17.01, 17.02, 18.05, 18.07, 18.09, 18.10, 18.12, 18.13, 18.14, 18.15, 18.16, 18.18, 18.19, 18.20, 19.00, 19.01, 19.02, 19.03, 19.06, 22.00, 22.01, 25.01, 25.02, 25.03, 25.04, 28.01, 28.02, 30.01, 30.02, 30.03, 30.04, 30.05, 30.06, 30.10, 30.11, 36.10, 37.01, 39.01, 44.01, 44.03, 48.01, 49.01, 49.02, 49.03, 51.01, 52.01, 53.01, 53.02, 54.01, 54.02, 55.01, 55.02, 55.03, 96.01, 96.02, 96.03, 96.04, 97.01, 97.02, 98.02, 98.03, 98.04, 98.05, 98.06, 98.08, 98.09, 98.10, 98.11, 98.12, 98.13, 98.14, 98.15, 98.16, 98.17, 98.18, 98.20, 98.21, 98.22, 98.23, 98.26, 98.27, 98.28, 98.29, 98.34, 98.35, 98.41, 98.42, 98.43, 98.44, 98.45, 98.46, 98.47, 98.48, 98.49, 98.50, 98.51, 98.52, 98.53, 98.54, 98.57, 98.58, 98.59, 98.60, 98.61, 98.62, 98.63, 98.64, 98.65, 98.67, 98.68, 98.69, 98.70, 98.71, 98.72, 98.78, 98.79, 98.80, 98.81, 98.82, 98.83, 98.84, 98.85, 98.86, 98.87, 98.88, 98.89, 98.90, 98.91, 98.92, 98.94, 98.95, 98.97, 98.98, 98.99, 99.03, 99.04, 99.05, 99.08, 99.12, 99.13, 99.14, 99.15, 99.16, 99.17, 99.18, 99.19, 99.20, 99.21, 99.22, 99.23, 99.24, 99.25, 99.26, 99.27, 99.28, 99.29, 99.30, 99.31, 99.32', 'AGMIRONOV7/agmironov', TO_DATE('02.07.2018 16:17:14', 'DD.MM.YYYY HH24:MI:SS'), '') ;

COMMIT WORK
/

--              (   13.00)
delete from DocLockFields  where (id in
(select
  dlf.Id
from DOCLOCK dl
left join DocLockFields dlf on (dlf.DocLockRef = dl.Id)
left join DocumentFields df on (df.Id = dlf.FieldRef)
where  ((UPPER(df.Name) Like ('%%')) and (UPPER(df.Name) Like ('%%')))
and (dl.isSystem = 2) and (dl.LockAction <> 11)))
/

CREATE OR REPLACE procedure ChangeKESR
AS
  ID_new$ NUMBER(10);
BEGIN
  FOR REC$1 IN (select dlf.id AS DocLockRef, df.itffieldname AS FIELDNAME, df.doctyperef AS DOCType, df.detailnumber AS DetailNumbers, df.isbudget  AS IsBudget from DOCLOCK dl
  left join DocLockFields dlf on (dlf.DocLockRef = dl.Id)
  left join DocumentFields df on (df.Id = dlf.FieldRef)
  where  ((UPPER(df.Name) Like ('%%')) and (UPPER(df.Name) Like ('%%')))
  and (dl.isSystem = 0) and (dl.LockAction <> 11)
  )
  LOOP
    REC$1.FIELDNAME := UPPER('%'||REC$1.FIELDNAME||'CODE%');
    if (UPPER(REC$1.FIELDNAME) like ('%SUB%')) then
      BEGIN
        select df.id into ID_new$ from  DocumentFields df where (UPPER(df.itffieldname) like (REC$1.FIELDNAME))
        and (UPPER(df.Name) like ('%%'))
        and (df.doctyperef = REC$1.DOCType) and (df.detailnumber = REC$1.DetailNumbers) and (df.IsBudget = REC$1.IsBudget) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    else
      BEGIN
        select df.id into ID_new$ from  DocumentFields df where (UPPER(df.itffieldname) like (REC$1.FIELDNAME))
        and (UPPER(df.Name) not like ('%%'))
        and (UPPER(df.Name) like ('%%'))
        and (df.doctyperef = REC$1.DOCType) and (df.detailnumber = REC$1.DetailNumbers) and (df.IsBudget = REC$1.IsBudget) ;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    END IF;
    IF (ID_new$  is not null) THEN
      update DocLockFields dlf set
      dlf.FIELDREF = ID_new$
      where
      dlf.Id = REC$1.DocLockRef;
    END IF;
  END LOOP;
END;
/

CALL ChangeKESR()
/

drop procedure ChangeKESR
/

commit work
/



-- #########################################################
-- #########################################################
-- DBVersion.sql
-- #########################################################
-- #########################################################

INSERT INTO DataBaseVersion(VERSION, Major, Minor, AComment)
  VALUES ('13.00.00', 1300, 00, ' 13.0')
/

COMMIT WORK
/

-- #########################################################
-- #########################################################
-- Index_Fix.sql
-- #########################################################
-- #########################################################

--      INDX
DECLARE
  CURSOR C$ IS
    select INDEX_NAME from DBA_INDEXES
    where OWNER = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      and TABLESPACE_NAME <> 'INDX'
      and INDEX_TYPE LIKE '%NORMAL%';
  CNT$ NUMBER(10);    
BEGIN
  BEGIN
    select count(*) into CNT$ from V$TABLESPACE
    where name = 'INDX';
  EXCEPTION
    WHEN OTHERS THEN
      CNT$ := 1;
  END;
  IF CNT$ = 1 THEN
    FOR R$ IN C$ LOOP
      EXECUTE IMMEDIATE 'ALTER INDEX ' || R$.INDEX_NAME || ' REBUILD TABLESPACE INDX';
    END LOOP;
  END IF;
END;
/

-- #########################################################
-- #########################################################
-- compile_scr.sql
-- #########################################################
-- #########################################################

--      , 
--  -  
--  DBMS_UTILITY.COMPILE_SCHEMA(user, TRUE);

DECLARE
  CURSOR C$ IS
    SELECT 'ALTER ' || object_type || ' ' || owner || '.' || object_name || ' COMPILE' AS str,
      object_type, object_name
    FROM SYS.ALL_OBJECTS
    WHERE owner = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
      AND object_type IN ('VIEW', 'PROCEDURE', 'TRIGGER')
      AND status = 'INVALID'
      AND object_name not like 'BIN$%'
    ORDER BY DECODE(object_type, 'VIEW', 1, 'PROCEDURE', 2, 'TRIGGER', 3), object_name;
  S VARCHAR2(100);
BEGIN
  FOR R$ IN C$ LOOP
    BEGIN
      S := R$.object_type || ' ' || R$.object_name;
      EXECUTE IMMEDIATE R$.str;
    EXCEPTION
      WHEN OTHERS THEN 
        --DBMS_OUTPUT.PUT_LINE(S);
        RAISE_APPLICATION_ERROR(-20000, '    ' || S);
    END;
  END LOOP;
END;
/

-- #########################################################
-- #########################################################
-- dbms_stats_scr.sql
-- #########################################################
-- #########################################################

ALTER SESSION SET NLS_NUMERIC_CHARACTERS='.,'
/

BEGIN
  DBMS_STATS.GATHER_SCHEMA_STATS(
    SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA'),
    DBMS_STATS.AUTO_SAMPLE_SIZE,
    false,
    'FOR ALL COLUMNS SIZE AUTO',
    cascade=>TRUE
  );
END;
/

exit
